Package: PSCBS
Version: 0.68.0
Depends: R (>= 3.2.0)
Imports: R.methodsS3 (>= 1.8.2), R.oo (>= 1.25.0), R.utils (>= 2.12.0),
        R.cache (>= 0.16.0), matrixStats (>= 0.62.0), aroma.light (>=
        2.4.0), DNAcopy (>= 1.42.0), future (>= 1.28.0), parallel,
        graphics, grDevices, stats, utils
Suggests: R.rsp (>= 0.45.0), R.devices (>= 2.17.1), ggplot2 (>= 3.2.1)
SuggestsNote: BioC (>= 3.1)
VignetteBuilder: R.rsp
Title: Analysis of Parent-Specific DNA Copy Numbers
Authors@R: c(
  person("Henrik", "Bengtsson", role=c("aut", "cre", "cph"),
                                 email="henrikb@braju.com"),
  person("Pierre", "Neuvial", role="aut"),
  person("Venkatraman E.", "Seshan", role="aut"),
  person("Adam B.", "Olshen", role="aut"),
  person("Paul T.", "Spellman", role="aut"),
  person("Richard A.", "Olshen", role="aut"),
  person("Frank E", "Harrell Jr", role="ctb",
         comment = "Weighted quantile estimator adopted from Hmisc::wtd.quantile()"))
Description: Segmentation of allele-specific DNA copy number data and detection of regions with abnormal copy number within each parental chromosome.  Both tumor-normal paired and tumor-only analyses are supported.
License: GPL (>= 2)
LazyLoad: TRUE
ByteCompile: TRUE
biocViews: aCGH, CopyNumberVariants, SNP, Microarray, OneChannel,
        TwoChannel, Genetics
URL: https://github.com/HenrikBengtsson/PSCBS
BugReports: https://github.com/HenrikBengtsson/PSCBS/issues
NeedsCompilation: no
Packaged: 2025-04-18 18:47:19 UTC; henrik
Author: Henrik Bengtsson [aut, cre, cph],
  Pierre Neuvial [aut],
  Venkatraman E. Seshan [aut],
  Adam B. Olshen [aut],
  Paul T. Spellman [aut],
  Richard A. Olshen [aut],
  Frank E Harrell Jr [ctb] (Weighted quantile estimator adopted from
    Hmisc::wtd.quantile())
Maintainer: Henrik Bengtsson <henrikb@braju.com>
Repository: CRAN
Date/Publication: 2025-04-18 19:40:02 UTC
Built: R 4.6.0; ; 2026-04-26 05:21:57 UTC; unix

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# IMPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
importFrom("R.methodsS3", "setMethodS3")
importFrom("R.methodsS3", "getMethodS3")
importFrom("R.oo", "setConstructorS3")
importFrom("R.utils", "use")

## Importing Object classes
importFrom("R.oo", "Package")
importFrom("R.utils", "Arguments")
importFrom("R.utils", "GenericSummary")

## Importing functions
importFrom("R.oo",
           "extend", "attachLocally", "startupMessage")

importFrom("R.cache",
           "getCachePath", "loadCache", "saveCache")

importFrom("R.utils",
           "cat", "capitalize", "copyDirectory", "createLink",
           "enter", "enterf", "exit", "filePath", "getAbsolutePath",
           "getRelativePath", "hpaste", "insert", "isDirectory",
           "isFile", "isPackageInstalled", "isZero", "less",
           "loadObject", "more", "popState", "popTemporaryFile",
           "printf", "pushState", "pushTemporaryFile", "resample",
           "saveObject", "stext", "subplots", "toCamelCase", "wrap")

importFrom("matrixStats",
           "binMeans", "colCumsums", "colDiffs", "colMins", "colMaxs",
           "rowAlls", "rowAnys", "rowMins", "weightedMedian")

importFrom("graphics",
           "abline", "arrows", "axis", "box", "lines",
           "mtext", "par", "plot", "points", "rect", "text")

importFrom("grDevices",
           "col2rgb", "rgb")

importFrom("stats",
           "approx", "cor", "cutree", "density", "end", "mad", "median",
           "na.omit", "quantile", "sd", "start", "weighted.mean")

importFrom("utils",
           "capture.output", "file_test", "getFromNamespace",
           "head", "packageVersion", "str", "tail", "write.table",
           "packageDescription", "install.packages")

importFrom("aroma.light",
           "callNaiveGenotypes", "findPeaksAndValleys", "normalizeTumorBoost")
	   
importFrom("DNAcopy",
           "segments.summary", "smooth.CNA", "CNA", "segment", "getbdry")

importFrom("future", "future", "value")
importFrom("parallel", "nextRNGStream")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# EXPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Export all public methods, that is, those without a preceeding dot
# in their names.
exportPattern("^[^\\.]")


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# S3 methods
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# AbstractCBS
S3method("adjustPloidyScale", "AbstractCBS")
S3method("all.equal", "AbstractCBS")
S3method("as.data.frame", "AbstractCBS")
S3method("clearCalls", "AbstractCBS")
S3method("drawChangePoints", "AbstractCBS")
S3method("drawKnownSegments", "AbstractCBS")
S3method("dropChangePoint", "AbstractCBS")
S3method("dropChangePoints", "AbstractCBS")
S3method("dropRegion", "AbstractCBS")
S3method("dropRegions", "AbstractCBS")
S3method("extractChromosome", "AbstractCBS")
S3method("extractChromosomes", "AbstractCBS")
S3method("extractCNs", "AbstractCBS")
S3method("extractRegion", "AbstractCBS")
S3method("extractRegions", "AbstractCBS")
S3method("extractSegment", "AbstractCBS")
S3method("extractSegments", "AbstractCBS")
S3method("getChangePoints", "AbstractCBS")
S3method("getChromosomeOffsets", "AbstractCBS")
S3method("getChromosomeRanges", "AbstractCBS")
S3method("getChromosomes", "AbstractCBS")
S3method("getLocusData", "AbstractCBS")
S3method("getLocusSignalNames", "AbstractCBS")
S3method("getMeanEstimators", "AbstractCBS")
S3method("getSampleName", "AbstractCBS")
S3method("getSegments", "AbstractCBS")
S3method("getSegmentSizes", "AbstractCBS")
S3method("getSegmentTrackPrefixes", "AbstractCBS")
S3method("hclustCNs", "AbstractCBS")
S3method("mergeThreeSegments", "AbstractCBS")
S3method("mergeTwoSegments", "AbstractCBS")
S3method("nbrOfChangePoints", "AbstractCBS")
S3method("nbrOfChromosomes", "AbstractCBS")
S3method("nbrOfLoci", "AbstractCBS")
S3method("nbrOfSegments", "AbstractCBS")
S3method("normalizeTotalCNs", "AbstractCBS")
S3method("normalizeTotalCNs", "PSCBS")
S3method("ploidy", "AbstractCBS")
S3method("ploidy<-", "AbstractCBS")
S3method("plotTracks", "AbstractCBS")
S3method("print", "AbstractCBS")
S3method("pruneByDP", "AbstractCBS")
S3method("pruneByHClust", "AbstractCBS")
S3method("renameChromosomes", "AbstractCBS")
S3method("report", "AbstractCBS")
S3method("resegment", "AbstractCBS")
S3method("resetSegments", "AbstractCBS")
S3method("sampleCNs", "AbstractCBS")
S3method("sampleName", "AbstractCBS")
S3method("sampleName<-", "AbstractCBS")
S3method("seqOfSegmentsByDP", "AbstractCBS")
S3method("setLocusData", "AbstractCBS")
S3method("setMeanEstimators", "AbstractCBS")
S3method("setPloidy", "AbstractCBS")
S3method("setSampleName", "AbstractCBS")
S3method("setSegments", "AbstractCBS")
S3method("shiftTCN", "AbstractCBS")
S3method("tileChromosomes", "AbstractCBS")
S3method("updateMeans", "AbstractCBS")
S3method("updateMeansTogether", "AbstractCBS")
S3method("writeWIG", "AbstractCBS")


# CBS
S3method("all.equal", "CBS")
S3method("as.character", "CBS")
S3method("as.data.frame", "CBS")
S3method("as.DNAcopy", "CBS")
S3method("c", "CBS")
S3method("callAmplifications", "CBS")
S3method("callArms", "CBS")
S3method("callGainsAndLosses", "CBS")
S3method("callGLAO", "CBS")
S3method("callOutliers", "CBS")
S3method("drawCentromeres", "CBS")
S3method("drawChromosomes", "CBS")
S3method("drawLevels", "CBS")
S3method("estimateDeltaCN", "CBS")
S3method("estimateStandardDeviation", "CBS")
S3method("extractCallsByLocus", "CBS")
S3method("extractChromosomes", "CBS")
S3method("extractCNs", "CBS")
S3method("extractSegmentMeansByLocus", "CBS")
S3method("extractSegments", "CBS")
S3method("extractTotalCNs", "CBS")
S3method("extractWIG", "CBS")
S3method("extractWIG", "AbstractCBS")
S3method("extractWIG", "PSCBS")
S3method("getCallStatistics", "CBS")
S3method("getCallStatisticsByArms", "CBS")
S3method("getChangePoints", "CBS")
S3method("getChromosomeRanges", "CBS")
S3method("getFGA", "CBS")
S3method("getFGG", "CBS")
S3method("getFGL", "CBS")
S3method("getFractionOfGenomeAltered", "CBS")
S3method("getFractionOfGenomeGained", "CBS")
S3method("getFractionOfGenomeLost", "CBS")
S3method("getLocusData", "CBS")
S3method("getLocusSignalNames", "CBS")
S3method("getSegments", "CBS")
S3method("getSegmentTrackPrefixes", "CBS")
S3method("getSignalType", "CBS")
S3method("getSmoothLocusData", "CBS")
S3method("highlightArmCalls", "CBS")
S3method("highlightCalls", "CBS")
S3method("highlightLocusCalls", "CBS")
S3method("isSegmentSplitter", "CBS")
S3method("isWholeChromosomeGained", "CBS")
S3method("isWholeChromosomeLost", "CBS")
S3method("joinSegments", "CBS")
S3method("mergeNonCalledSegments", "CBS")
S3method("mergeTwoSegments", "CBS")
S3method("nbrOfAmplifications", "CBS")
S3method("nbrOfGains", "CBS")
S3method("nbrOfLosses", "CBS")
S3method("plot", "CBS")
S3method("plotTracks", "CBS")
S3method("plotTracksManyChromosomes", "CBS")
S3method("pruneBySdUndo", "CBS")
S3method("resegment", "CBS")
S3method("segmentByCBS", "CBS")
S3method("seqOfSegmentsByDP", "CBS")
S3method("shiftTCN", "CBS")
S3method("signalType", "CBS")
S3method("signalType<-", "CBS")
S3method("subset", "CBS")
S3method("tileChromosomes", "CBS")
S3method("updateBoundaries", "CBS")
S3method("updateMeans", "CBS")
S3method("updateMeansTogether", "CBS")
S3method("writeLocusData", "CBS")
S3method("writeSegments", "CBS")

# CNA
S3method("segmentByCBS", "CNA")

# data.frame
S3method("callSegmentationOutliers", "data.frame")
S3method("encodeCalls", "data.frame")
S3method("dropSegmentationOutliers", "data.frame")
S3method("findLargeGaps", "data.frame")
S3method("gapsToSegments", "data.frame")
S3method("segmentByCBS", "data.frame")
S3method("segmentByNonPairedPSCBS", "data.frame")
S3method("segmentByPairedPSCBS", "data.frame")

# default
S3method("callAllelicBalance", "default")
S3method("callSegmentationOutliers", "default")
S3method("dropSegmentationOutliers", "default")
S3method("exampleData", "default")
S3method("findLargeGaps", "default")
S3method("findNeutralCopyNumberState", "default")
S3method("installDNAcopy", "default")
S3method("segmentByCBS", "default")
S3method("segmentByNonPairedPSCBS", "default")
S3method("segmentByPairedPSCBS", "default")
S3method("weightedQuantile", "default")

# DNAcopy
S3method("as.CBS", "DNAcopy")
S3method("drawLevels", "DNAcopy")
S3method("estimateStandardDeviation", "DNAcopy")
S3method("extractSegmentMeansByLocus", "DNAcopy")
S3method("getChromosomes", "DNAcopy")
S3method("getSampleNames", "DNAcopy")
S3method("nbrOfLoci", "DNAcopy")
S3method("nbrOfSamples", "DNAcopy")
S3method("nbrOfSegments", "DNAcopy")
S3method("writeSegments", "DNAcopy")

# matrix
S3method("seqOfSegmentsByDP", "matrix")

# NonPairedPSCBS
S3method("callROH", "NonPairedPSCBS")
S3method("getLocusData", "NonPairedPSCBS")
S3method("resegment", "NonPairedPSCBS")
S3method("updateMeans", "NonPairedPSCBS")

# numeric
S3method("testROH", "numeric")

# PairedPSCBS
S3method("adjustPloidyScale", "PairedPSCBS")
S3method("applyByRegion", "PairedPSCBS")
S3method("arrowsC1C2", "PairedPSCBS")
S3method("arrowsDeltaC1C2", "PairedPSCBS")
S3method("bootstrapCIs", "PairedPSCBS")
S3method("bootstrapSegmentsAndChangepoints", "PairedPSCBS")
S3method("bootstrapTCNandDHByRegion", "PairedPSCBS")
S3method("calcStatsForCopyNeutralABs", "PairedPSCBS")
S3method("callAB", "PairedPSCBS")
S3method("callABandHighAI", "PairedPSCBS")
S3method("callABandLowC1", "PairedPSCBS")
S3method("callAllelicBalanceByDH", "PairedPSCBS")
S3method("callCopyNeutral", "PairedPSCBS")
S3method("callCopyNeutralByTCNofAB", "PairedPSCBS")
S3method("callExtremeAllelicImbalanceByDH", "PairedPSCBS")
S3method("callGainNeutralLoss", "PairedPSCBS")
S3method("callGNL", "PairedPSCBS")
S3method("callGNLByTCNofAB", "PairedPSCBS")
S3method("callGNLByTCNofABv1", "PairedPSCBS")
S3method("callLOH", "PairedPSCBS")
S3method("callLowC1ByC1", "PairedPSCBS")
S3method("callNTCN", "PairedPSCBS")
S3method("callROH", "PairedPSCBS")
S3method("callROHOneSegment", "PairedPSCBS")
S3method("clearBootstrapSummaries", "PairedPSCBS")
S3method("drawChangePointsC1C2", "PairedPSCBS")
S3method("drawConfidenceBands", "PairedPSCBS")
S3method("drawLevels", "PairedPSCBS")
S3method("estimateDeltaAB", "PairedPSCBS")
S3method("estimateDeltaABBySmallDH", "PairedPSCBS")
S3method("estimateDeltaCN", "PairedPSCBS")
S3method("estimateDeltaLOH", "PairedPSCBS")
S3method("estimateDeltaLOHByMinC1ForNonAB", "PairedPSCBS")
S3method("estimateHighDHQuantileAtAB", "PairedPSCBS")
S3method("estimateKappa", "PairedPSCBS")
S3method("estimateKappaByC1Density", "PairedPSCBS")
S3method("estimateMeanForDH", "PairedPSCBS")
S3method("estimateStdDevForHeterozygousBAF", "PairedPSCBS")
S3method("extractC1C2", "PairedPSCBS")
S3method("extractCallsByLocus", "PairedPSCBS")
S3method("extractCNs", "PairedPSCBS")
S3method("extractDeltaC1C2", "PairedPSCBS")
S3method("extractDhSegment", "PairedPSCBS")
S3method("extractLocusLevelC1C2", "PairedPSCBS")
S3method("extractLocusLevelTCN", "PairedPSCBS")
S3method("extractMinorMajorCNs", "PairedPSCBS")
S3method("extractSegmentDataByLocus", "PairedPSCBS")
S3method("extractSegments", "PairedPSCBS")
S3method("extractTCNAndDHs", "PairedPSCBS")
S3method("findBootstrapSummaries", "PairedPSCBS")
S3method("getBootstrapLocusSets", "PairedPSCBS")
S3method("getChromosomeOffsets", "PairedPSCBS")
S3method("getChromosomeRanges", "PairedPSCBS")
S3method("getLocusData", "PairedPSCBS")
S3method("hasBootstrapSummaries", "PairedPSCBS")
S3method("linesC1C2", "PairedPSCBS")
S3method("linesDeltaC1C2", "PairedPSCBS")
S3method("mergeTwoSegments", "PairedPSCBS")
S3method("plot", "PairedPSCBS")
S3method("plotC1C2", "PairedPSCBS")
S3method("plotDeltaC1C2", "PairedPSCBS")
S3method("plotTracks", "PairedPSCBS")
S3method("plotTracks1", "PairedPSCBS")
S3method("plotTracks2", "PairedPSCBS")
S3method("plotTracksManyChromosomes", "PairedPSCBS")
S3method("pointsC1C2", "PairedPSCBS")
S3method("pointsDeltaC1C2", "PairedPSCBS")
S3method("postsegmentTCN", "PairedPSCBS")
S3method("resegment", "PairedPSCBS")
S3method("segmentByNonPairedPSCBS", "PairedPSCBS")
S3method("segmentByPairedPSCBS", "PairedPSCBS")
S3method("seqOfSegmentsByDP", "PairedPSCBS")
S3method("shiftTCN", "PairedPSCBS")
S3method("tileChromosomes", "PairedPSCBS")
S3method("unTumorBoost", "PairedPSCBS")
S3method("updateMeans", "PairedPSCBS")
S3method("updateMeansC1C2", "PairedPSCBS")
S3method("updateMeansTogether", "PairedPSCBS")

# PSCBS
S3method("as.data.frame", "PSCBS")
S3method("c", "PSCBS")
S3method("drawChangePoints", "PSCBS")
S3method("extractChromosomes", "PSCBS")
S3method("getChangePoints", "PSCBS")
S3method("getLocusData", "PSCBS")
S3method("getLocusSignalNames", "PSCBS")
S3method("getSegments", "PSCBS")
S3method("getSegmentTrackPrefixes", "PSCBS")
S3method("isLocallyPhased", "PSCBS")
S3method("isSegmentSplitter", "PSCBS")
S3method("writeSegments", "PSCBS")

<div id="badges"><!-- pkgdown markup -->
<a href="https://CRAN.R-project.org/web/checks/check_results_PSCBS.html"><img border="0" src="https://www.r-pkg.org/badges/version/PSCBS" alt="CRAN check status"/></a> <a href="https://github.com/HenrikBengtsson/PSCBS/actions?query=workflow%3AR-CMD-check"><img border="0" src="https://github.com/HenrikBengtsson/PSCBS/actions/workflows/R-CMD-check.yaml/badge.svg?branch=develop" alt="R CMD check status"/></a> <a href="https://github.com/HenrikBengtsson/PSCBS/actions?query=workflow%3Arevdepcheck-top"><img border="0" src="https://github.com/HenrikBengtsson/PSCBS/actions/workflows/revdepcheck-top.yaml/badge.svg?branch=develop" alt="Top reverse-dependency checks status"/></a>     
</div>

# PSCBS: Analysis of Parent-Specific DNA Copy Numbers 

The PSCBS package implements the parent-specific copy-number segmentation presented in Olshen et al. (2011).  Package vignette ['Parent-specific copy-number segmentation using Paired PSCBS'](https://CRAN.R-project.org/package=PSCBS/vignettes/PairedPSCBS.pdf) provides a detailed introduction for running PSCBS segmentation.  It's available as:

```r
vignette("PairedPSCBS", package = "PSCBS")
```

Below is an excerpt of the example found in that vignette:

```r
library(PSCBS)

## Get single-chromosome example data
data <- exampleData("paired.chr01")
str(data)
# ’data.frame’: 73346 obs. of 6 variables:
# $ chromosome: int 1 1 1 1 1 1 1 1 1 1 ...
# $ x : int 1145994 2224111 2319424 2543484 2926730 2941694 3084986 3155127..
# $ CT : num 1.625 1.071 1.406 1.18 0.856 ...
# $ betaT : num 0.757 0.771 0.834 0.778 0.229 ...
# $ CN : num 2.36 2.13 2.59 1.93 1.71 ...
# $ betaN : num 0.827 0.875 0.887 0.884 0.103 ...

## Drop total copy-number outliers
data <- dropSegmentationOutliers(data)

## Identify chromosome arms from data
gaps <- findLargeGaps(data, minLength = 1e+06)
knownSegments <- gapsToSegments(gaps)

## Parent-specific copy-number segmentation
fit <- segmentByPairedPSCBS(data, knownSegments = knownSegments)

## Get segments as a data.frame
segments <- getSegments(fit, simplify = TRUE)
segments
#    chromosome tcnId dhId     start       end tcnNbrOfLoci  tcnMean
# 1           1     1    1    554484  33414619         9413 1.381375
# 2           1     1    2  33414619  86993745        17433 1.378570
# 3           1     2    1  86993745  87005243            2 3.185100
# 4           1     3    1  87005243 119796080        10404 1.389763
# 5           1     3    2 119796080 119932126           72 1.470789
# 6           1     3    3 119932126 120992603          171 1.439620
# 7           1     4    1 120992604 141510002            0       NA
# 8           1     5    1 141510003 185527989        13434 2.065400
# 9           1     6    1 185527989 199122066         4018 2.707400
# 10          1     7    1 199122066 206512702         2755 2.586100
# 11          1     8    1 206512702 206521352           14 3.871900
# 12          1     9    1 206521352 247165315        15581 2.637500
#    tcnNbrOfSNPs tcnNbrOfHets dhNbrOfLoci dhMean    c1Mean    c2Mean
# 1          2765         2765        2765 0.4868 0.3544608 1.0269140
# 2          4544         4544        4544 0.5185 0.3318907 1.0466792
# 3             0            0           0     NA        NA        NA
# 4          2777         2777        2777 0.5203 0.3333347 1.0564285
# 5             8            8           8 0.0767 0.6789900 0.7917995
# 6            52           52          52 0.5123 0.3510514 1.0885688
# 7             0            0          NA     NA        NA        NA
# 8          3770         3770        3770 0.0943 0.9353164 1.1300836
# 9          1271         1271        1271 0.2563 1.0067467 1.7006533
# 10          784          784         784 0.2197 1.0089669 1.5771331
# 11            9            9           9 0.2769 1.3998854 2.4720146
# 12         4492         4492        4492 0.2290 1.0167563 1.6207438

## Plot copy-number tracks
plotTracks(fit)
```

![](man/figures/ex-PSCBS-paired.chr01.png)


## Parallel processing

The package supports segmentation of the chromosomes in parallel
(asynchronously) via [futures](https://cran.r-project.org/package=future)
by adding the following

```r
future::plan("multisession")
```

to the beginning of the PSCBS script.  Everything else will work the
same.  To reset to non-parallel processing, use `future::plan("sequential")`.

To configure this automatically whenever the package is loaded, see
future vignette '[A Future for R: Controlling Default Future Strategy](https://CRAN.R-project.org/package=future/vignettes/future-5-startup.html)'.



## References

* Bengtsson H, Neuvial P, Speed TP. TumorBoost: Normalization of allele-specific tumor copy numbers from a single pair of tumor-normal genotyping microarrays, BMC Bioinformatics, 2010. DOI: [10.1186/1471-2105-11-245](https://doi.org/10.1186%2F1471-2105-11-245). PMID: [20462408](https://europepmc.org/article/MED/20462408), PMCID: PMC2894037

* Olshen AB, Bengtsson H, Neuvial P, Spellman PT, Olshen RA, Seshan VA. Parent-specific copy number in paired tumor-normal studies using circular binary segmentation, Bioinformatics, 2011. DOI: [10.1093/bioinformatics/btr329](https://doi.org/10.1093%2Fbioinformatics%2Fbtr329). PMID: [21666266](https://europepmc.org/article/MED/21666266). PMCID: PMC3137217


## Installation

R package PSCBS is available on [CRAN](https://cran.r-project.org/package=PSCBS) and can be installed in R as:

```r
# install.packages("BiocManager")
BiocManager::install(c("aroma.light", "DNAcopy"))

install.packages("PSCBS")
```

### Pre-release version
 
To install the pre-release version that is available in Git branch `develop` on GitHub, use:

```r
remotes::install_github("HenrikBengtsson/PSCBS", ref="develop")
```

This will install the package from source.  


<!-- pkgdown-drop-below -->

###########################################################################
### This 'tangle' R script was created from an RSP document.
### RSP source document: 'CBS.tex.rsp'
### Metadata 'title': 'Total copy-number segmentation using CBS'
### Metadata 'author': 'Henrik Bengtsson'
### Metadata 'engine': 'R.rsp::rsp'
### Metadata 'keywords': 'copy numbers, genomic aberrations'
###########################################################################

t0 <- Sys.time()
R.utils::use("R.utils")

# RSP specific
R.rsp <- R.oo::Package("R.rsp")
withCapture <- R.utils::withCapture
options("withCapture/newline"=FALSE)
options(str=strOptions(strict.width="cut"))
options(width=85)
options(digits=3)

# Graphics
use("R.devices")
options("devEval/args/field"="fullname") # Preferred for LaTeX
devOptions("png", width=840)

# Analysis
use("PSCBS")
PSCBS <- R.oo::Package("PSCBS")
fixLocations <- function(fit, ...) {
  for (key in grep("(end|start)$", colnames(fit$output))) {
    fit$output[[key]] <- as.integer(fit$output[[key]])
  }
  fit
} # fixLocations()

signalType <- "TCN"
R.rsp$version
R.rsp$author
format(as.Date(PSCBS$date), format="%B %d, %Y")
fullname <- "PairedPSCBS,exData,chr01"
withCapture({
data <- PSCBS::exampleData("paired.chr01")
data <- data[,c("chromosome", "x", "CT")]
colnames(data)[3] <- "y"
str(data)
})
signalType
signalType
withCapture({
data <- dropSegmentationOutliers(data)
})
signalType
withCapture({
gaps <- findLargeGaps(data, minLength=1e6)
gaps
})
withCapture({
knownSegments <- gapsToSegments(gaps)
knownSegments
})
signalType
signalType
withCapture({
fit <- segmentByCBS(data, knownSegments=knownSegments, seed=0xBEEF, verbose=-10)
})
signalType
nbrOfSegments(fit)
signalType
fit <- fixLocations(fit)
withCapture({
getSegments(fit, simplify=TRUE)
})
segs <- getSegments(fit, simplify=TRUE)
which(segs$nbrOfLoci == 0)
signalType
signalType
signalType
toPNG(fullname, tags=c(class(fit)[1L], "tracks"), aspectRatio=0.35, {
    plotTracks(fit)
  })
signalType
signalType
signalType
signalType
withCapture({
fitP <- pruneByHClust(fit, h=0.25, verbose=-10)
})
toPNG(fullname, tags=c(class(fitP)[1L], "pruned", "tracks"), aspectRatio=0.35, {
    plotTracks(fitP)
  })
signalType
toLatex(sessionInfo())
dt <- round(Sys.time()-t0, digits=2)
attr(dt, "units")

setMethodS3("c", "PSCBS", function(..., addSplit = TRUE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  args <- list(...)

  ## Nothing todo?
  nargs <- length(args)
  if (nargs == 1) return(args[[1]])

  isNA <- function(x) is.logical(x) && length(x) == 1L && is.na(x)

  res <- args[[1]]
  fields <- c("output", "tcnSegRows", "dhSegRows")
  
  for (ii in 2:nargs) {
    arg <- args[[ii]]

    if (isNA(arg)) {
      if (addSplit) {
        warning(sprintf("Detected explicit NA in call to c(<%s>, ..., addSplit = TRUE). Ignoring", class(args[[1]])[1]))
        next
      }
      ## Add "splitter"
      for (field in fields) {
        res[[field]] <- rbind(res[[field]], NA)
      }
    } else {
      ## Locus-level data
      data <- getLocusData(res)
      data_arg <- getLocusData(arg)
      if (!all(colnames(data_arg) == colnames(data))) {
        stop(sprintf("Cannot concatenate %s and %s objects, because they have different sets of columns in field %s: {%s} [n=%d] != {%s} [n=%d]", sQuote(class(res)[1]), sQuote(class(arg)[1]), sQuote(field), paste(sQuote(colnames(data)), collapse=", "), ncol(data), paste(sQuote(colnames(data_arg)), collapse=", "), ncol(data_arg)))
      }

      indexOffset <- nrow(data)
      
      data <- rbind(data, getLocusData(arg))
      res[["data"]] <- data
      
      # Segmentation data
      for (field in fields[-1]) {
        arg[[field]] <- arg[[field]] + indexOffset
      }
      splitter <- if (addSplit) NA else NULL
      for (field in fields) {
        res[[field]] <- rbind(res[[field]], splitter, arg[[field]])
      }

      # Known segments
      ksT <- res$params$knownSegments
      ksT$length <- NULL  # In case it's been added
      ksO <- arg$params$knownSegments
      ksO$length <- NULL  # In case it's been added
      res$params$knownSegments <- rbind(ksT, ksO)
    }
  } ## for (ii ...)

  ## Drop row names, iff they've been added
  for (field in fields) rownames(res[[field]]) <- NULL
  
  # Sanity check
  ns <- sapply(res[fields], FUN = nrow)
  .stop_if_not(all(ns == ns[1]))

  res
}) # c()


setMethodS3("extractChromosomes", "PSCBS", function(x, chromosomes, ...) {
  # To please R CMD check
  this <- x

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'chromosomes':
  disallow <- c("NaN", "Inf")
  chromosomes <- Arguments$getIntegers(chromosomes, range=c(0,Inf), disallow=disallow)
  .stop_if_not(all(is.element(chromosomes, getChromosomes(this))))

  # Always extract in order
  chromosomes <- unique(chromosomes)
  chromosomes <- sort(chromosomes)

  # Allocate results
  res <- this

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Locus data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  chromosome <- NULL; rm(list="chromosome") # To please R CMD check
  res$data <- subset(res$data, chromosome %in% chromosomes)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Segmentation data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Identify rows to subset
  rows <- which(is.element(res$output$chromosome, chromosomes))
  for (field in c("output", "tcnSegRows", "dhSegRows")) {
    res[[field]] <- res[[field]][rows,,drop=FALSE]
  }

  # Identify chromosome offsets
  chrStarts <- match(getChromosomes(this), this$data$chromosome)
  chrEnds <- c(chrStarts[-1]-1L, nrow(this$data))
  chrLengths <- chrEnds - chrStarts + 1L

  chrLengthsExcl <- chrLengths

  keep <- match(chromosomes, getChromosomes(this))
  chrLengthsExcl[keep] <- 0L
  cumChrLengthsExcl <- cumsum(chrLengthsExcl)

  shifts <- cumChrLengthsExcl[keep]
  .stop_if_not(all(is.finite(shifts)))

  # Adjust indices
  for (cc in seq_along(chromosomes)) {
    chromosome <- chromosomes[cc]
    shift <- shifts[cc]
    # Nothing to do?
    if (shift == 0) next
    for (field in c("tcnSegRows", "dhSegRows")) {
      segRows <- res[[field]]
      rows <- which(res$output$chromosome == chromosome)
      segRows[rows,] <- segRows[rows,] - shift
      res[[field]] <- segRows
    }
  }

  res
}, protected=TRUE)

###########################################################################/**
# @RdocClass CBS
#
# @title "The CBS class"
#
# \description{
#   A CBS object holds results from the
#   Circular Binary Segmentation (CBS) method
#   for \emph{one} sample for one or more chromosomes.
#
#  @classhierarchy
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Arguments passed to the constructor of @see "AbstractCBS".}
# }
#
# \section{Fields and Methods}{
#  @allmethods "public"
# }
#
# \section{Difference to DNAcopy object}{
#   A CBS object is similar to DNAcopy objects with the major
#   difference that a CBS object holds only one sample, whereas
#   a DNAcopy object can hold more than one sample.
# }
#
# \section{See also}{
#  The @see "segmentByCBS" method returns an object of this class.
# }
#
# @author "HB"
#*/###########################################################################
setConstructorS3("CBS", function(...) {
  extend(AbstractCBS(list(data=NULL, output=NULL), ...), "CBS")
})


setMethodS3("all.equal", "CBS", function(target, current, check.attributes=FALSE, ...) {
  # Compare class attributes
  res <- all.equal(class(target), class(current))
  if (!isTRUE(res)) {
    return(res)
  }

  # WORKAROUND: segmentByCBS() return getSegments(fit)$id without NA:s for
  # splitters, unless append() is used.
  # TO DO: Fix segmentByCBS() /HB 2011-10-08
  segs <- getSegments(target)
  if (nrow(segs) > 0) {
    isSplitter <- isSegmentSplitter(target)
    segs[isSplitter, "sampleName"] <- NA
    target$output <- segs
  }

  segs <- getSegments(current)
  if (nrow(segs) > 0) {
    isSplitter <- isSegmentSplitter(current)
    segs[isSplitter, "sampleName"] <- NA
    current$output <- segs
  }

  # NOTE: Here arguments 'target' and 'current' are lists and does not
  # have to be passed explicitly (although they have been modified).
  # If passed explicity, note that they must be named *and* that the
  # first/dispatch argument have to be passed as 'object=target'
  # (and never as 'target=target').  /HB 2014-02-03
  NextMethod("all.equal", object=target, current=current, check.attributes=check.attributes)
}, protected=TRUE)



###########################################################################/**
# @RdocMethod as.data.frame
#
# @title "Gets the table of segments"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns a @data.frame, where each row corresponds to
#   a unique segment.
# }
#
# @author
#
# \seealso{
#   Utilizes @seemethod "getSegments".
#   @seeclass.
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("as.character", "CBS", function(x, ...) {
  # To please R CMD check
  fit <- x

  s <- sprintf("%s:", class(fit)[1])

  s <- c(s, sprintf("Sample name: %s", getSampleName(fit)))

  s <- c(s, sprintf("Signal type: %s", getSignalType(fit)))

  s <- c(s, sprintf("Number of segments: %d", nbrOfSegments(fit)))

  s <- c(s, sprintf("Number of loci: %d", nbrOfLoci(fit)))

  n <- getSegments(fit)$nbrOfLoci
  q <- quantile(n, probs=c(0.00, 0.05, 0.25, 0.50, 0.75, 0.95, 1.00), na.rm=TRUE)
  qs <- sprintf("%g [%s]", q, names(q))
  s <- c(s, sprintf("Number of loci per segment: %s", paste(qs, collapse=", ")))

  chrs <- getChromosomes(fit)
  s <- c(s, sprintf("Chromosomes: [%d] %s", length(chrs), hpaste(chrs)))

  s <- c(s, sprintf("Standard deviation: %g", estimateStandardDeviation(fit)))

  tt <- grep("Call$", colnames(getLocusData(fit)), value=TRUE)
  s <- c(s, sprintf("Locus calls: [%d] %s", length(tt), hpaste(tt)))

  segs <- getSegments(fit)
  callCols <- grep("Call$", colnames(segs), value=TRUE)
  callTypes <- gsub("Call$", "", callCols)
  s <- c(s, sprintf("Types of segment calls: [%d] %s", length(callTypes), hpaste(callTypes)))
  for (kk in seq_along(callCols)) {
    key <- callCols[kk]
    type <- callTypes[kk]
    n <- sum(segs[,key], na.rm=TRUE)
    if (type == "loss") {
      nC <- sum(isWholeChromosomeLost(fit))
    } else if (type == "gain") {
      nC <- sum(isWholeChromosomeGained(fit))
    } else {
      nC <- NA
    }
    s <- c(s, sprintf("Number of chromosomes (segments) called '%s': %d (%d)", type, nC, n))
  }

  GenericSummary(s)
}, protected=TRUE)


setMethodS3("as.data.frame", "CBS", function(x, ...) {
  getSegments(x, splitters=FALSE, ...)
}, protected=TRUE)


setMethodS3("getSignalType", "CBS", function(fit, ...) {
  type <- fit$signalType
  if (is.null(type)) type <- NA_character_
  type
}, protected=TRUE)


setMethodS3("signalType", "CBS", function(fit, ...) {
  getSignalType(fit)
}, protected=TRUE)


"signalType<-" <- function(x, value) {
  UseMethod("signalType<-")
}

setMethodS3("signalType<-", "CBS", function(x, value) {
  fit <- x

  # Argument 'value':
  value <- Arguments$getCharacter(value)

  fit$signalType <- value
  fit
}, private=TRUE, addVarArgs=FALSE)



setMethodS3("getLocusSignalNames", "CBS", function(fit, ...) {
  data <- fit$data
  names <- colnames(data)
  if (is.element("y", names)) {
    return("y")
  } else if (is.element("CT", names)) {
    return("CT")
  }

  stop("INTERNAL ERROR: Unknown locus signal names: ", paste(names, collapse=", "))
}, protected=TRUE)

setMethodS3("getSegmentTrackPrefixes", "CBS", function(fit, ...) {
  c("")
}, protected=TRUE)


setMethodS3("getLocusData", "CBS", function(fit, indices=NULL, addCalls=NULL, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'indices':
  if (!is.null(indices)) {
    indices <- Arguments$getIndices(indices)
  }

  # Argument 'addCalls':
  if (is.logical(addCalls)) {
    addCalls <- Arguments$getLogical(addCalls)
    if (!addCalls) {
      addCalls <- NULL
    }
  } else {
    addCalls <- Arguments$getCharacters(addCalls)
  }

  data <- fit$data

  # Append segment calls?
  if (length(addCalls) > 0) {
    callsL <- extractCallsByLocus(fit)
    if (is.character(addCalls)) {
      callsL <- callsL[,addCalls]
    }

    # Sanity check
    .stop_if_not(nrow(callsL) == nrow(data))

    data <- cbind(data, callsL)
  }

  # Return requested indices
  if (!is.null(indices)) {
    # Map of final indices to current indices
    map <- match(indices, data$index)

    # Extract/expand...
    data <- data[map,]
    rownames(data) <- NULL

    # Sanity check
    .stop_if_not(nrow(data) == length(indices))
  }

  data
}, private=TRUE) # getLocusData()


setMethodS3("isSegmentSplitter", "CBS", function(fit, ...) {
  segs <- fit$output

  isSplitter <- lapply(segs[-1], FUN=is.na)
  isSplitter <- Reduce("&", isSplitter)

  isSplitter
}, protected=TRUE)


setMethodS3("getSegments", "CBS", function(fit, simplify=FALSE, splitters=TRUE, addGaps=FALSE, ...) {
  # Argument 'splitters':
  splitters <- Arguments$getLogical(splitters)

  segs <- fit$output

  isSplitter <- isSegmentSplitter(fit)

  # Add 'sampleName' column?
  if (nrow(segs) > 0) {
    sampleName <- rep(getSampleName(fit), times=nrow(segs))
    sampleName[isSplitter] <- NA_character_
    if (!is.element("sampleName", colnames(segs))) {
      segs <- cbind(sampleName=I(sampleName), segs)
    } else {
      segs[,"sampleName"] <- sampleName
    }
  }

  # Drop chromosome splitters?
  if (!splitters) {
    segs <- segs[!isSplitter,]
  }

  # Add splitters for "gaps"...
  if (splitters && addGaps) {
    # Chromosome gaps
    n <- nrow(segs)
    chrs <- segs$chromosome
    gapsAfter <- which(diff(chrs) != 0L)
    gapsAfter <- gapsAfter[!is.na(chrs[gapsAfter])]
    nGaps <- length(gapsAfter)
    if (nGaps > 0L) {
      idxs <- seq_len(n)
      values <- rep(NA_integer_, times=nGaps)
      idxs <- insert(idxs, ats=gapsAfter+1L, values=values)
      segs <- segs[idxs,]
    }

    # Other gaps
    n <- nrow(segs)
    chrs <- segs$chromosome
    starts <- segs$tcnStart[-1L]
    ends <- segs$tcnEnd[-n]
    gapsAfter <- which(starts != ends)
    onSameChr <- (chrs[gapsAfter+1L] == chrs[gapsAfter] )
    gapsAfter <- gapsAfter[onSameChr]
    nGaps <- length(gapsAfter)
    if (nGaps > 0L) {
      idxs <- seq_len(n)
      values <- rep(NA_integer_, times=nGaps)
      idxs <- insert(idxs, ats=gapsAfter+1L, values=values)
      segs <- segs[idxs,]
    }
  }

  segs
}, private=TRUE)



setMethodS3("getChangePoints", "CBS", function(fit, ...) {
  # Already available?
  cps <- fit$changepoints
  if (!is.null(cps)) return(cps)

  segs <- getSegments(fit, splitters=TRUE)
  tcn <- segs[["mean"]]
  n <- length(tcn)

  # Calculate observed (d) data
  D <- tcn[-n] - tcn[-1L]
  cps <- data.frame(
    d = D
  )

  cps
}, private=TRUE) # getChangePoints()



setMethodS3("updateBoundaries", "CBS", function(fit, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Updating boundaries")
  verbose && cat(verbose, "Number of segments: ",
                                  nbrOfSegments(fit, splitters=FALSE))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the data and segmentation results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  segs <- getSegments(fit, splitters=TRUE)
  segRows <- fit$segRows

  nbrOfSegments <- nrow(segs)
  chromosome <- data$chromosome
  x <- data$x
  y <- data$y
  w <- data$w
  hasWeights <- !is.null(w)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  for (ss in seq_len(nbrOfSegments)) {
    verbose && enter(verbose, sprintf("Segment %d of %d", ss, nbrOfSegments))
    segRow <- segRows[ss,]
    seg <- segs[ss,]

    # A splitter - nothing todo?
    if (is.na(segRow[[1]]) && is.na(segRow[[2]])) {
      next
    }

    # (a) Identify units (loci)
    units <- segRow[[1]]:segRow[[2]]
    verbose && cat(verbose, "Loci:")
    verbose && str(verbose, units)

    # (b) Extract signals
    ySS <- y[units]
    xSS <- x[units]
    cSS <- chromosome[units]
    if (hasWeights) {
      wSS <- w[units]
    }

    # (c) Drop missing values
    keep <- (!is.na(ySS) & !is.na(xSS) & !is.na(cSS))
    if (hasWeights) {
      keep <- keep & (!is.na(wSS) & wSS > 0)
    }
    keep <- which(keep)
    ySS <- ySS[keep]
    xSS <- xSS[keep]
    cSS <- cSS[keep]
    if (hasWeights) {
      wSS <- wSS[keep]
    }
    units <- units[keep]
    verbose && cat(verbose, "Loci (non-missing):")
    verbose && str(verbose, units)

    # (d) Identify (chromosome, start, stop)
    .stop_if_not(all(cSS == cSS[1]))
    cSS <- cSS[1]
    xRange <- range(xSS, na.rm=TRUE)
    verbose && cat(verbose, "Range:")
    verbose && print(verbose, xRange)

    # (e) Update segment information
    seg$chromosome <- cSS
    seg$start <- xRange[1]
    seg$end <- xRange[2]

    segs[ss,] <- seg

    verbose && exit(verbose)
  } # for (ss ...)

  # Update results
  res <- fit
  res$output <- segs

  # Rejoin segments?
  if (isTRUE(res$params$joinSegments)) {
    res <- joinSegments(res, verbose=less(verbose,10))
  }

  verbose && exit(verbose)

  res
}, protected=TRUE) # updateBoundaries()



setMethodS3("updateMeans", "CBS", function(fit, ..., avg=c("asis", "mean", "median"), verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'avg':
  avg <- match.arg(avg)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Updating mean level estimates")
  verbose && cat(verbose, "Number of segments: ",
                                  nbrOfSegments(fit, splitters=FALSE))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the data and segmentation results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  segs <- getSegments(fit, splitters=TRUE)
  segRows <- fit$segRows

  nbrOfSegments <- nrow(segs)
  chromosome <- data$chromosome
  x <- data$x
  y <- data$y
  w <- data$w
  hasWeights <- !is.null(w)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setting up averaging functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (avg == "asis") {
    est <- fit$params$meanEstimators
    avg <- est$y
    if (is.null(avg)) avg <- "mean"
    avg <- match.arg(avg)
  }

  if (hasWeights) {
    if(avg == "mean") {
      avgFUN <- weighted.mean
    } else if(avg == "median") {
      avgFUN <- weightedMedian
    } else {
      stop("Value of argument 'avg' is not supported with weights: ", avg)
    }
  } else {
    avgFUN <- get(avg, mode="function")
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  for (ss in seq_len(nbrOfSegments)) {
    verbose && enter(verbose, sprintf("Segment %d of %d", ss, nbrOfSegments))
    segRow <- segRows[ss,]
    seg <- segs[ss,]

    # A splitter - nothing todo?
    if (!is.finite(segRow[[1]]) || !is.finite(segRow[[2]])) {
      next
    }

    # (a) Identify units (loci)
    units <- segRow[[1]]:segRow[[2]]

    # (b) Extract signals
    ySS <- y[units]
    if (hasWeights) {
      wSS <- w[units]
    }

    # (c) Drop missing values
    keep <- (!is.na(ySS))
    if (hasWeights) {
      keep <- keep & (!is.na(wSS) & wSS > 0)
    }
    keep <- which(keep)
    ySS <- ySS[keep]
    if (hasWeights) {
      wSS <- wSS[keep]
    }
    units <- units[keep]
    nbrOfLoci <- length(units)

    # (d) Update mean
    if (hasWeights) {
      wSS <- wSS / sum(wSS)
      gamma <- avgFUN(ySS, w=wSS)
    } else {
      gamma <- avgFUN(ySS)
    }

    # Sanity check
    .stop_if_not(nbrOfLoci == 0 || !is.na(gamma))

    # (d) Update the segment statistics
    seg$mean <- gamma
    seg$nbrOfLoci <- nbrOfLoci

    segs[ss,] <- seg

    verbose && exit(verbose)
  } # for (ss ...)

  # Return results
  res <- fit
  res$output <- segs
  res <- setMeanEstimators(res, y=avg)

  verbose && exit(verbose)

  res
}, protected=TRUE) # updateMeans()


setMethodS3("resegment", "CBS", function(fit, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Resegmenting a ", class(fit)[1], " object")
  segFcnName <- "segmentByCBS"
  segFcn <- getMethodS3(segFcnName, "default")

  # Use the locus-level data of the segmentation object
  data <- getLocusData(fit)
  class(data) <- "data.frame"
  drop <- c("index")
  keep <- !is.element(colnames(data), drop)
  data <- data[,keep]
  verbose && str(verbose, data)

  verbose && cat(verbose, "Number of loci: ", nrow(data))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup arguments to be passed
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Overriding default arguments")

  # (a) The default arguments
  formals <- formals(segFcn)

  formals <- formals[!sapply(formals, FUN=is.language)]
  formals <- formals[!sapply(formals, FUN=is.name)]
  drop <- c("chromosome", "x", "y", "w", "...")
  keep <- !is.element(names(formals), drop)
  formals <- formals[keep]

  # (b) The arguments used in previous fit
  params <- fit$params
  keep <- is.element(names(params), names(formals))
  params <- params[keep]

  # (c) The arguments in '...'
  userArgs <- list(..., verbose=verbose)

  # (d) Merge
  args <- formals
  args2 <- c(params, userArgs)
  for (kk in seq_along(args2)) {
    value <- args2[[kk]]
    if (!is.null(value)) {
      key <- names(args2)[kk]
      if (!is.null(key)) {
        args[[key]] <- value
      } else {
        args <- c(args, list(value))
      }
    }
  } # for (key ...)
  verbose && str(verbose, args[names(args) != "verbose"])

  args <- c(list(data), args)
  verbose && cat(verbose, "Arguments with data:")
  verbose && str(verbose, args[names(args) != "verbose"])
  verbose && exit(verbose)

  verbose && enter(verbose, sprintf("Calling %s()", segFcnName))
  fit <- do.call(segFcnName, args)
  verbose && exit(verbose)

  verbose && exit(verbose)

  fit
}, protected=TRUE) # resegment()

##########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod callROH
# @alias callROH.NonPairedPSCBS
#
# @title "Calls segments that are in ROH"
#
# \description{
#  @get "title", i.e. that have no (true) heterozygous genotypes.
#  Run of homozygosity (ROH) is a property of the normal (germline) sample.
# }
#
# @synopsis
#
# \arguments{
#   \item{...}{Additional arguments passed to @see "testROH".}
#   \item{updateMeans}{If @TRUE, DH and (C1,C2) mean levels are set
#    to @NA for segments called ROH, otherwise not.}
#   \item{force}{If @FALSE, and ROH calls already exits,
#    then nothing is done, otherwise the calls are done.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns a @see "PairedPSCBS" object with ROH calls.
# }
#
# @author "PN, HB"
#
# \seealso{
#   Internally, @see "testROH" is used.
#   To call allelic balance (AB) see @seemethod "callAB".
#   To call loss of heterozygosity (LOH) see @seemethod "callLOH".
# }
#*/###########################################################################
setMethodS3("callROH", "PairedPSCBS", function(fit, ..., updateMeans=TRUE, force=FALSE, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Calling ROH")

  # Already done?
  segs <- getSegments(fit)
  calls <- segs$rohCall
  if (!force && !is.null(calls)) {
    return(invisible(fit))
  }

  nbrOfSegments <- nrow(segs)
  calls <- rep(NA, times=nbrOfSegments)
  if (is.null(calls)) {
    segs <- cbind(segs, rohCall=calls)
  }
  delta <- NA_real_

  # For each segment...
  for (ss in seq_len(nbrOfSegments)) {
    verbose && enter(verbose, sprintf("Segment #%d of %d", ss, nbrOfSegments))

    fitT <- extractSegment(fit, ss)

    # Call only "non-splitter" segments
    if (nbrOfSegments(fitT) > 0L) {
      callSS <- callROHOneSegment(fitT, ..., verbose=less(verbose, 1))
      calls[ss] <- callSS
      if (is.na(delta) && !is.na(callSS)) {
        delta <- attr(callSS, "delta")
      }
    }

    verbose && exit(verbose)
  } # for (ss ...)

  verbose && cat(verbose, "ROH calls:")
  verbose && str(verbose, calls)
  verbose && print(verbose, summary(calls))

  segs$rohCall <- calls

  fit$output <- segs

  # Append parameters
  params <- fit$params
  params$deltaROH <- delta
  fit$params <- params

  # Set DH and (C1,C2) mean levels to NA?
  if (updateMeans) {
    fit <- updateMeans(fit, from="segments", adjustFor="roh",
                                             verbose=less(verbose, 20))
  }

  verbose && exit(verbose)

  invisible(fit)
}) # callROH()


# This method calls ROH for a single-segment PairedPSCBS object
setMethodS3("callROHOneSegment", "PairedPSCBS", function(fit, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Calling ROH for a single segment")

  # Make sure that there is only a single segment in this object
  .stop_if_not(nbrOfSegments(fit, splitters=TRUE) == 1L)


  # Extract the locus-level data for the segment tested
  data <- getLocusData(fit)


  # Keep only SNPs:
  # SNPs are identifies as those loci that have non-missing
  # 'betaTN' & 'muN', cf. segmentByPairedPSCBS().
  isSnp <- (!is.na(data$betaTN) & !is.na(data$muN))
  nbrOfSnps <- sum(isSnp)
  verbose && cat(verbose, "Number of SNPs: ", nbrOfSnps)
  data <- data[isSnp,]

  # Extract that SNP signals used for calling ROH
  betaN <- data$betaN
  muN <- data$muN
  csN <- data$csN # Genotyping confidence scores, if available

  # Test for ROH
  fit <- testROH(muN=muN, csN=csN, betaN=betaN, ..., verbose=less(verbose, 10))

  # Get the ROH call (TRUE, FALSE, or NA)
  call <- fit

  verbose && exit(verbose)

  call
}, private=TRUE)


##############################################################################
# HISTORY
# 2014-03-29 [HB]
# o BUG FIX: In rare cases, callROH() could throw "Error in if (is.na(delta))
#   { : argument is of length zero".
# 2012-05-30 [HB]
# o Now callROH() records paramter 'deltaROH' in the results.
# 2011-11-26 [HB]
# o Added argument 'updateMeans=TRUE' to callROH() for PairedPSCBS.
# 2011-11-12 [HB]
# o BUG FIX: ROH calls should be stored in column 'rohCall' (not 'rohCalls').
# 2011-11-04 [HB]
# o Added callROH() for PairedPSCBS.
# o Created.
##############################################################################

###########################################################################/**
# @set "class=AbstractCBS"
# @RdocMethod plotTracks
#
# @title "Plots the segmentation result along the genome"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{...}
# }
#
# \value{
#   Returns nothing.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#*/###########################################################################
setMethodS3("plotTracks", "AbstractCBS", abstract=TRUE)


setMethodS3("tileChromosomes", "AbstractCBS", abstract=TRUE, protected=TRUE)


setMethodS3("drawChangePoints", "AbstractCBS", abstract=TRUE, protected=TRUE)


setMethodS3("drawKnownSegments", "AbstractCBS", function(fit, col="#aaaaaa", ..., xScale=1e-6) {
  segs <- fit$params$knownSegments

  # Nothing todo?
  if (is.null(segs)) {
    return()
  }

  # Workaround from the fact that extractChromosomes() does not drop
  # known segments. /HB 2013-03-21
  chromosome <- NULL; rm(list="chromosome") # To please R CMD check.
  segs <- subset(segs, chromosome %in% getChromosomes(fit))
  xStarts <- segs[,"start"]
  xEnds <- segs[,"end"]
  xs <- sort(unique(c(xStarts, xEnds)))
  abline(v=xScale*xs, col=col, ...)
}, protected=TRUE)

############################################################################/**
# @RdocDefault installDNAcopy
#
# @title "Install the DNAcopy package"
#
# @synopsis
#
# \description{
#   @get "title", if missing.
# }
#
# \arguments{
#   \item{...}{Arguments passed to the install function.}
#   \item{force}{If @FALSE and the \pkg{DNAcopy} package is already
#     installed, then it will not be re-install.
#     If @TRUE, it will be installed.}
# }
#
# \value{
#   Returns nothing.
# }
#
# \details{
#   This function is will download and call the \code{biocLite()}
#   installation function from the Bioconductor Project website.
#   This function will also make sure that \pkg{DNAcopy} is loaded so
#   that it is reported by @see "utils::sessionInfo".
# }
#
# @author "HB"
#
# @keyword internal
#*/############################################################################
setMethodS3("installDNAcopy", "default", function(..., force=FALSE) {
  # Argument 'force':
  force <- Arguments$getLogical(force)

  # Package to be installed
  pkgName <- "DNAcopy"

  # Is DNAcopy already available?
  if (!force && isPackageInstalled(pkgName)) {
    library(pkgName, character.only=TRUE)
    return(invisible())
  }

  # If not, install it...
  if (getRversion() >= "3.5.0") {
    if (!isPackageInstalled("BiocManager")) install.packages("BiocManager")
    ns <- getNamespace("BiocManager")
    BiocManager_install <- get("install", envir = ns)
    BiocManager_install(pkgName, ...)
  } else {
    # To please R CMD check
    biocLite <- NULL; rm(list="biocLite")
    source("https://www.bioconductor.org/biocLite.R")
    biocLite(pkgName, ...)
  }
  
  # ...and load it
  library(pkgName, character.only=TRUE)

  return(invisible())
}) # installDNAcopy()

###########################################################################/**
# @RdocClass PSCBS
#
# @title "The PSCBS class"
#
# \description{
#  @classhierarchy
#
#  A PSCBS is an object containing results from parent-specific copy-number
#  (PSCN) segmentation.
# }
#
# \usage{PSCBS(fit=list(), ...)}
#
# \arguments{
#   \item{fit}{A @list structure containing the PSCN segmentation results.}
#   \item{...}{Not used.}
# }
#
# \section{Fields and Methods}{
#  @allmethods "public"
# }
#
# @author "HB"
#
# \seealso{
#   @see "PairedPSCBS".
# }
#*/###########################################################################
setConstructorS3("PSCBS", function(fit=list(), ...) {
  # Argument 'fit':
  if (!is.list(fit)) {
    stop("Argument 'fit' is not a list: ", class(fit)[1])
  }

  extend(AbstractCBS(fit, ...), "PSCBS")
})


setMethodS3("as.data.frame", "PSCBS", function(x, ...) {
  getSegments(x, splitters=TRUE, ...)
}, protected=TRUE)


setMethodS3("getLocusSignalNames", "PSCBS", function(fit, ...) {
  c("CT", "rho")
}, protected=TRUE)

setMethodS3("getSegmentTrackPrefixes", "PSCBS", function(fit, ...) {
  c("tcn", "dh")
}, protected=TRUE)


setMethodS3("getLocusData", "PSCBS", function(fit, indices=NULL, fields=c("asis"), ...) {
  # Argument 'indices':
  if (!is.null(indices)) {
    indices <- Arguments$getIndices(indices)
  }

  # Argument 'fields':
  fields <- match.arg(fields)

  data <- fit$data

  # Return requested indices
  if (!is.null(indices)) {
    # Map of final indices to current indices
    map <- match(indices, data$index)

    # Extract/expand...
    data <- data[map,]

    # Sanity check
    .stop_if_not(nrow(data) == length(indices))
  }

  data
}, protected=TRUE) # getLocusData()



setMethodS3("isSegmentSplitter", "PSCBS", function(fit, ...) {
  segs <- fit$output

  isSplitter <- lapply(segs[-1], FUN=is.na)
  isSplitter <- Reduce("&", isSplitter)

  isSplitter
}, protected=TRUE)


###########################################################################/**
# @RdocMethod getSegments
#
# @title "Gets the segments"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{simplify}{If @TRUE, redundant and intermediate information is dropped.}#  \item{splitters}{If @TRUE, "splitters" between chromosomes are
#     preserved, otherwise dropped.}
#  \item{...}{Not used.}
# }
#
# \value{
#   Returns a SxK @data.frame, where S in the number of segments,
#   and K is the number of segment-specific fields.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#*/###########################################################################
setMethodS3("getSegments", "PSCBS", function(fit, simplify=FALSE, splitters=TRUE, addGaps=FALSE, ...) {
  # Argument 'splitters':
  splitters <- Arguments$getLogical(splitters)

  segs <- fit$output

  # Drop chromosome splitters?
  if (!splitters) {
    isSplitter <- isSegmentSplitter(fit)
    segs <- segs[!isSplitter,]
  }

  # Add splitters for "gaps"...
  if (splitters && addGaps) {
    # Chromosome gaps
    n <- nrow(segs)
    chrs <- segs$chromosome
    gapsAfter <- which(diff(chrs) != 0L)
    gapsAfter <- gapsAfter[!is.na(chrs[gapsAfter])]
    nGaps <- length(gapsAfter)
    if (nGaps > 0L) {
      idxs <- seq_len(n)
      values <- rep(NA_integer_, times=nGaps)
      idxs <- insert(idxs, ats=gapsAfter+1L, values=values)
      segs <- segs[idxs,]
    }

    # Other gaps
    n <- nrow(segs)
    chrs <- segs$chromosome
    starts <- segs$tcnStart[-1L]
    ends <- segs$tcnEnd[-n]
    gapsAfter <- which(starts != ends)
    onSameChr <- (chrs[gapsAfter+1L] == chrs[gapsAfter] )
    gapsAfter <- gapsAfter[onSameChr]
    nGaps <- length(gapsAfter)
    if (nGaps > 0L) {
      idxs <- seq_len(n)
      values <- rep(NA_integer_, times=nGaps)
      idxs <- insert(idxs, ats=gapsAfter+1L, values=values)
      segs <- segs[idxs,]
    }
  }

##  if (nrow(segs) > 0) {
##    segs$id <- getSampleName(fit)
##  }

  if (simplify) {
    # If joinSegments was used (i.e. (start,end) are equal for TCN and DH)...
    if (fit$params$joinSegments) {
      # Sanity check
      .stop_if_not(all(segs$tcnStart == segs$dhStart, na.rm=TRUE))
      .stop_if_not(all(segs$tcnEnd == segs$dhEnd, na.rm=TRUE))

      names <- colnames(segs)
      keep <- !is.element(names, c("dhStart", "dhEnd"))
      segs <- segs[,keep]
      names <- colnames(segs)
      names[names == "tcnStart"] <- "start"
      names[names == "tcnEnd"] <- "end"
      colnames(segs) <- names
    }

    # Drop bootstrap columns, if any
    names <- colnames(segs)
    keep <- (regexpr("_[0-9]+(|[.][0-9]+)%$", names) == -1)
    segs <- segs[,keep]
  }

  segs
}, private=TRUE)



setMethodS3("getChangePoints", "PSCBS", function(fit, ...) {
  # Already available?
  cps <- fit$changepoints
  if (!is.null(cps)) return(cps)

  segs <- getSegments(fit, splitters=TRUE)
  tcn <- segs[["tcnMean"]]
  dh <- segs[["dhMean"]]
  C1 <- (1-dh) * tcn / 2
  C2 <- tcn - C1
  n <- length(tcn)

  # Calculate observed (alpha, radius, manhattan, dc1, dc2) data
  D1 <- C1[-n] - C1[-1L]
  D2 <- C2[-n] - C2[-1L]
  cps <- data.frame(
    alpha = atan2(D2, D1), # Changepoint angles in (0,2*pi)
    radius = sqrt(D2^2 + D1^2),
    manhattan = abs(D2) + abs(D1),
    d1 = D1,
    d2 = D2
  )

  cps
}, private=TRUE) # getChangePoints()


setMethodS3("normalizeTotalCNs", "PSCBS", function(fit, targetTCN=2, ...) {
  ## Fit using locus-level data
  data <- getLocusData(fit, ...)
  C <- data$CT
  .stop_if_not(!is.null(C))
  mu <- median(C, na.rm=TRUE)
  scale <- targetTCN / mu

  ## (a) Rescale locus-level data
  C <- scale * C
  data$CT <- C
  rm(list="C")
  fitN <- setLocusData(fit, data)

  ## (b) Rescale segment-level data
  segs <- getSegments(fit)
  fields <- colnames(segs)
  cnFields <- grep("^(tcn|c1|c2)", fields, value=TRUE)
  cnFields <- grep("(Id|Start|End|NbrOf)", cnFields, value=TRUE, invert=TRUE)
  for (field in cnFields) {
    segs[[field]] <- scale * segs[[field]]
  }
  fitN <- setSegments(fitN, segs)

  invisible(fitN)
})

# Removes all segment calls and corresponding parameter estimates.
setMethodS3("clearCalls", "AbstractCBS", function(fit, ...) {
  segs <- fit$output
  params <- fit$params

  # Drop all calls
  excl <- grep("Call$", colnames(segs))
  if (length(excl) > 0L) {
    segs <- segs[,-excl]
  }

  # Drop all call parameters (AD HOC!)
  for (ff in c("deltaROH", "deltaAB", "deltaLOH")) {
    params[[ff]] <- NULL
  }

  fit$output <- segs
  fit$params <- params

  invisible(fit)
}, protected=TRUE)



##############################################################################
# HISTORY
# 2013-10-24
# o Added clearCalls() for AbstractCBS.
# o Created.
##############################################################################

###########################################################################/**
# @set class=CBS
# @RdocMethod getSmoothLocusData
#
# @title "Gets smoothed locus-level data"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{fit}{An @see "CBS" object.}
#   \item{by}{A @numeric scalar specifying the bin size.}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns a @data.frame where the
#   first three columns are 'chromosome', 'x' (position),
#   and 'count' (number of loci average over for the given bin),
#   and the remaining ones are the smoothed locus-level data.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("getSmoothLocusData", "CBS", function(fit, by, ...) {
  # Argument 'by':
  by <- Arguments$getNumeric(by, range=c(0,Inf))

  chromosomes <- getChromosomes(fit)
  data <- getLocusData(fit)

  chromosome <- NULL; rm(list="chromosome") # To please R CMD check

  dataS <- NULL
  for (kk in seq_along(chromosomes)) {
    chr <- chromosomes[kk]
    dataT <- subset(data, chromosome == chr)
    x <- dataT$x
    y <- dataT$y
    rx <- range(x, na.rm=TRUE)
    bx <- seq(from=rx[1], to=rx[2], by=by)
    xS <- bx[-1] - by/2
    yS <- binMeans(y=y, x=x, bx=bx)
    count <- attr(yS, "count")
    yS[count == 0L] <- NA_real_
    attr(yS, "count") <- NULL
    dataTS <- data.frame(chromosome=chr, x=xS, count=count, y=yS)
    dataS <- rbind(dataS, dataTS)
  } # for (kk ...)

  dataS
}, protected=TRUE) # getSmoothLocusData()

###########################################################################/**
# @RdocDefault segmentByPairedPSCBS
# @alias segmentByPairedPSCBS.data.frame
# @alias segmentByPairedPSCBS.PairedPSCBS
# @alias segmentByPairedPSCBS
#
# @title "Segment total copy numbers and allele B fractions using the Paired PSCBS method"
#
# \description{
#  @get "title" [1].
#  This method requires matched normals.
#  This is a low-level segmentation method.
#  It is intended to be applied to one tumor-normal sample at the time.
# }
#
# @synopsis
#
# \arguments{
#   \item{CT}{A @numeric @vector of J tumor total copy number (TCN)
#        ratios in [0,+@Inf) (due to noise, small negative values are
#        also allowed).  The TCN ratios are typically scaled such that
#        copy-neutral diploid loci have a mean of two.}
#   \item{thetaT, thetaN}{(alternative) As an alternative to specifying
#        tumor TCN \emph{ratios} relative to the match normal by
#        argument \code{CT}, on may specify total tumor and normal
#        signals seperately, in which case the TCN ratios \code{CT} are
#        calculated as \eqn{CT = 2*thetaT/thetaN}.}
#   \item{betaT}{A @numeric @vector of J tumor allele B fractions (BAFs)
#        in [0,1] (due to noise, values may be slightly outside as well)
#        or @NA for non-polymorphic loci.}
#   \item{betaN}{A @numeric @vector of J matched normal BAFs in [0,1]
#        (due to noise, values may be slightly outside as well) or @NA
#        for non-polymorphic loci.}
#   \item{muN}{An optional @numeric @vector of J genotype calls in
#        \{0,1/2,1\} for AA, AB, and BB, respectively,
#        and @NA for non-polymorphic loci.
#        If not given, they are estimated from the normal BAFs using
#        @see "aroma.light::callNaiveGenotypes" as described in [2].}
#   \item{rho}{(alternative to \code{betaT} and \code{betaN}/\code{muN})
#        A @numeric @vector of J decrease-of-heterozygosity signals (DHs)
#        in [0,1] (due to noise, values may be slightly larger than one
#        as well).  By definition, DH should be @NA for homozygous loci
#        and for non-polymorphic loci.}
#   \item{chromosome}{(Optional) An @integer scalar (or a @vector of length J),
#        which can be used to specify which chromosome each locus belongs to
#        in case multiple chromosomes are segments.
#        This argument is also used for annotation purposes.}
#   \item{x}{Optional @numeric @vector of J genomic locations.
#            If @NULL, index locations \code{1:J} are used.}
#   \item{alphaTCN, alphaDH}{The significance levels for segmenting total
#        copy numbers (TCNs) and decrease-in-heterozygosity signals (DHs),
#        respectively.}
#   \item{undoTCN, undoDH}{Non-negative @numerics.  If greater than 0,
#        then a cleanup of segmentions post segmentation is done.
#        See argument \code{undo} of @see "segmentByCBS" for more
#        details.}
#   \item{avgTCN, avgDH}{A @character string specifying how to calculating
#         segment mean levels \emph{after} change points have been
#         identified.}
#   \item{...}{Additional arguments passed to @see "segmentByCBS".}
#   \item{flavor}{A @character specifying what type of segmentation and
#     calling algorithm to be used.}
#   \item{tbn}{If @TRUE, \code{betaT} is normalized before segmentation
#     using the TumorBoost method [2], otherwise not.}
#   \item{joinSegments}{If @TRUE, there are no gaps between neighboring
#     segments.
#     If @FALSE, the boundaries of a segment are defined by the support
#     that the loci in the segments provides, i.e. there exist a locus
#     at each end point of each segment.  This also means that there
#     is a gap between any neighboring segments, unless the change point
#     is in the middle of multiple loci with the same position.
#     The latter is what \code{DNAcopy::segment()} returns.
#   }
#   \item{knownSegments}{Optional @data.frame specifying
#     \emph{non-overlapping} known segments.  These segments must
#     not share loci.  See @see "findLargeGaps" and @see "gapsToSegments".}
#   \item{dropMissingCT}{If @TRUE, loci for which 'CT' is missing
#     are dropped, otherwise not.}
#   \item{seed}{An (optional) @integer specifying the random seed to be
#     set before calling the segmentation method.  The random seed is
#     set to its original state when exiting.  If @NULL, it is not set.}
#   \item{verbose}{See @see "R.utils::Verbose".}
#   \item{preserveScale}{\emph{Defunct - gives an error is specified.}}
# }
#
# \value{
#   Returns the segmentation results as a @see "PairedPSCBS" object.
# }
#
# \details{
#   Internally @see "segmentByCBS" is used for segmentation.
#   The Paired PSCBS segmentation method does \emph{not} support weights.
# }
#
# \section{Reproducibility}{
#   The "DNAcopy::segment" implementation of CBS uses approximation
#   through random sampling for some estimates.  Because of this,
#   repeated calls using the same signals may result in slightly
#   different results, unless the random seed is set/fixed.
# }
#
# \section{Whole-genome segmentation is preferred}{
#   Although it is possible to segment each chromosome independently
#   using Paired PSCBS, we strongly recommend to segment whole-genome
#   (TCN,BAF) data at once.  The reason for this is that downstream
#   CN-state calling methods, such as the AB and the LOH callers,
#   performs much better on whole-genome data.  In fact, they may
#   fail to provide valid calls if done chromosome by chromosome.
# }
#
# \section{Missing and non-finite values}{
#   The total copy number signals as well as any optional positions
#   must not contain missing values, i.e. @NAs or @NaNs.
#   If there are any, an informative error is thrown.
#   Allele B fractions may contain missing values, because such are
#   interpreted as representing non-polymorphic loci.
#
#   None of the input signals may have infinite values, i.e. -@Inf or +@Inf.
#   If so, an informative error is thrown.
# }
#
# \section{Paired PSCBS with only genotypes}{
#   If allele B fractions for the matched normal (\code{betaN}) are
#   not available, but genotypes (\code{muN}) are, then it is possible
#   to run a version of Paired PSCBS where TumorBoost normalization
#   of the tumor allele B fractions is skipped.  In order for this
#   to work, argument \code{tbn} must be set to @FALSE.
# }
#
# @examples "../incl/segmentByPairedPSCBS.Rex"
#
# @author "HB"
#
# \references{
#  [1] @include "../incl/OlshenA_etal_2011.Rd" \cr
#  [2] @include "../incl/BengtssonH_etal_2010.Rd" \cr
# }
#
# \seealso{
#   Internally, @see "aroma.light::callNaiveGenotypes" is used to
#   call naive genotypes, @see "aroma.light::normalizeTumorBoost" is
#   used for TumorBoost normalization, and @see "segmentByCBS" is used
#   to segment TCN and DH separately.
#
#   To segment tumor total copy numbers and allele B fractions
#   \emph{without} a matched normal, see @see "segmentByNonPairedPSCBS".
#
#   To segment total copy-numbers, or any other unimodal signals,
#   see @see "segmentByCBS".
# }
#
# @keyword IO
#*/###########################################################################
setMethodS3("segmentByPairedPSCBS", "default", function(CT, thetaT=NULL, thetaN=NULL, betaT=NULL, betaN=NULL, muN=NULL, rho=NULL, chromosome=0, x=NULL, alphaTCN=0.009, alphaDH=0.001, undoTCN=0, undoDH=0, ..., avgTCN=c("mean", "median"), avgDH=c("mean", "median"), flavor=c("tcn&dh", "tcn,dh", "sqrt(tcn),dh", "sqrt(tcn)&dh", "tcn"), tbn=is.null(rho), joinSegments=TRUE, knownSegments=NULL, dropMissingCT=TRUE, seed=NULL, verbose=FALSE, preserveScale=FALSE) {
  # WORKAROUND: If Hmisc is loaded after R.utils, it provides a buggy
  # capitalize() that overrides the one we want to use. Until PSCBS
  # gets a namespace, we do the following workaround. /HB 2011-07-14
  capitalize <- R.utils::capitalize

  # To please R CMD check
  index <- NULL; rm(list="index")

  # Settings for sanity checks
  tol <- getOption("PSCBS/sanityChecks/tolerance", 0.0005)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'thetaT' & 'thetaN':
  if (!is.null(thetaT) && !is.null(thetaN)) {
    thetaT <- Arguments$getDoubles(thetaT, disallow=disallow)
    nbrOfLoci <- length(thetaT)
    length2 <- rep(nbrOfLoci, times=2L)
    thetaN <- Arguments$getDoubles(thetaN, length=length2, disallow=disallow)
    CT <- 2 * thetaT / thetaN
  } else if (!is.null(thetaT) || !is.null(thetaN)) {
    stop("Either argument 'CT' needs to be specified or *both* of arguments 'thetaT' and 'thetaN'")
  }

  # Argument 'CT':
  disallow <- c("Inf")
  CT <- Arguments$getDoubles(CT, disallow=disallow)
  nbrOfLoci <- length(CT)
  length2 <- rep(nbrOfLoci, times=2L)


  # Argument 'betaT':
  if (!is.null(betaT)) {
    betaT <- Arguments$getDoubles(betaT, length=length2, disallow="Inf")
  }

  # Argument 'betaN':
  if (!is.null(betaN)) {
    betaN <- Arguments$getDoubles(betaN, length=length2, disallow="Inf")
  }

  # Argument 'muN':
  if (!is.null(muN)) {
    muN <- Arguments$getDoubles(muN, length=length2, range=c(0,1), disallow="Inf")
    if (all(is.na(muN)) == nbrOfLoci) {
      stop(sprintf("All genotypes ('muN') are NAs: %d (100%%) out of %d", nbrOfLoci, nbrOfLoci))
    }
  }

  # Argument 'rho':
  if (!is.null(rho)) {
    rho <- Arguments$getDoubles(rho, range=c(0,Inf), length=length2, disallow="Inf")
  }

  if (is.null(muN)) {
    if (is.null(betaN) && is.null(rho)) {
      stop("If argument 'muN' is not given, then either 'betaN' or 'rho' must be.")
    }
  }

  # Argument 'tbn':
  tbn <- Arguments$getLogical(tbn)
  if (!is.null(tbn)) {
    if (tbn) {
      if (is.null(betaT)) {
        stop("Cannot do TumorBoost normalization (tbn=TRUE) without tumor BAFs ('betaT').")
      }
      if (is.null(betaN)) {
        stop("Cannot do TumorBoost normalization (tbn=TRUE) with normal BAFs ('betaN').")
      }
    }
  }

  # Argument 'chromosome':
  if (is.null(chromosome)) {
    chromosome <- 0L
  } else {
    disallow <- c("Inf")
    chromosome <- Arguments$getIntegers(chromosome, range=c(0,Inf), disallow=disallow)
    if (length(chromosome) > 1) {
      chromosome <- Arguments$getIntegers(chromosome, length=length2, disallow=disallow)
    }
  }

  # Argument 'x':
  if (is.null(x)) {
    x <- seq_len(nbrOfLoci)
  } else {
    disallow <- c("Inf")
    x <- Arguments$getDoubles(x, length=length2, disallow=disallow)
  }

  # Argument 'alphaTCN':
  alphaTCN <- Arguments$getDouble(alphaTCN, range=c(0,1))

  # Argument 'alphaDH':
  alphaDH <- Arguments$getDouble(alphaDH, range=c(0,1))

  # Argument 'undoTCN':
  undoTCN <- Arguments$getDouble(undoTCN, range=c(0,Inf))

  # Argument 'undoDH':
  undoDH <- Arguments$getDouble(undoDH, range=c(0,Inf))

  # Argument 'avgTCN' & 'avgDH':
  avgTCN <- match.arg(avgTCN)
  avgDH <- match.arg(avgDH)

  # Argument 'flavor':
  flavor <- match.arg(flavor)
  knownFlavors <- eval(formals(segmentByPairedPSCBS.default)$flavor, enclos = baseenv())
  if (!is.element(flavor, knownFlavors)) {
    stop("Segmentation flavor is not among the supported ones (", paste(sprintf("\"%s\"", knownFlavors), collapse=", "), "): ", flavor)
  }

  # Argument 'joinSegments':
  joinSegments <- Arguments$getLogical(joinSegments)

  # Argument 'knownSegments':
  if (is.null(knownSegments)) {
    knownSegments <- data.frame(chromosome=integer(0), start=integer(0), end=integer(0))
  } else {
    if (!joinSegments) {
##      warning("Argument 'knownSegments' should only be specified if argument 'joinSegments' is TRUE.")
    }
  }

  if (!is.data.frame(knownSegments)) {
    stop("Argument 'knownSegments' is not a data.frame: ", class(knownSegments)[1])
  }

  if (!all(is.element(c("chromosome", "start", "end"), colnames(knownSegments)))) {
    stop("Argument 'knownSegments' does not have the required column names: ", hpaste(colnames(knownSegments)))
  }

  # Argument 'dropMissingCT':
  dropMissingCT <- Arguments$getLogical(dropMissingCT)
  if (!dropMissingCT) {
    if (is.element(flavor, c("tcn&dh", "sqrt(tcn)&dh"))) {
      stop("Missing values in 'CT' are (currently) not supported by the chosen 'flavor': ", flavor)
    }
  }


  # Argument 'seed':
  if (!is.null(seed)) {
    seed <- Arguments$getIntegers(seed)
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  # Argument 'preserveScale' is deprecated
  if (!missing(preserveScale)) {
    .Defunct(msg = "Argument 'preserveScale' for segmentByPairedPSCBS() is defunct; as of PSCBS 0.64.0 (Mar 2018) it is effectively fixed to FALSE, which has been the default since PSCBS 0.50.0 (Oct 2015). To avoid this error, do not specify 'preserveScale' when calling segmentByPairedPSCBS().")
  }
  
  verbose && enter(verbose, "Segmenting paired tumor-normal signals using Paired PSCBS")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Call genotypes?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Are genotype calls muN missing and can they be called?
  if (is.null(muN) && !is.null(betaN)) {
    verbose && enter(verbose, "Calling genotypes from normal allele B fractions")
    verbose && str(verbose, betaN)
    muN <- callNaiveGenotypes(betaN, censorAt=c(0,1))
    verbose && cat(verbose, "Called genotypes:")
    verbose && str(verbose, muN)
    verbose && print(verbose, table(muN))
    # Assert proper calls
    muN <- Arguments$getDoubles(muN, length=length2, range=c(0,1), disallow="Inf")
    # Sanity check
    if (all(is.na(muN))) {
      stop(sprintf("All genotypes ('muN') called from the normal allele B fractions ('betaN') are NAs: %d (100%%) out of %d", nbrOfLoci, nbrOfLoci))
    }
    verbose && exit(verbose)
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Normalize betaT using betaN (TumorBoost normalization)
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (tbn) {
    verbose && enter(verbose, "Normalizing betaT using betaN (TumorBoost)")
    betaTN <- normalizeTumorBoost(betaT=betaT, betaN=betaN, muN=muN, preserveScale=FALSE)
    verbose && cat(verbose, "Normalized BAFs:")
    verbose && str(verbose, betaTN)

    # Assert that no missing values where introduced
    keep <- (is.finite(betaT) & is.finite(betaN) & is.finite(muN))
    if (anyNA(betaTN[keep])) {
      stop("Internal error: normalizeTumorBoost() introduced missing values.")
    }
    # Not needed anymore
    keep <- NULL
    verbose && exit(verbose)
  } else {
    betaTN <- betaT
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Setup up data")
  data <- data.frame(chromosome=chromosome, x=x, CT=CT)
  if (!is.null(thetaT)) {
    data$thetaT <- thetaT
    data$thetaN <- thetaN
  }
  if (!is.null(betaT)) data$betaT <- betaT
  if (!is.null(betaTN)) data$betaTN <- betaTN
  if (!is.null(betaN)) data$betaN <- betaN
  if (!is.null(muN)) data$muN <- muN
  if (!is.null(rho)) data$rho <- rho
  verbose && str(verbose, data)
  # Not needed anymore
  chromosome <- x <- CT <- thetaT <- thetaN <- betaT <- betaTN <- betaN <- muN <- rho <- NULL

  # Sanity check
  .stop_if_not(nrow(data) == nbrOfLoci)
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Drop data points without known genomic positions, because that
  # is what DNAcopy::CNA() will do otherwise.  At the end, we will
  # undo this such that the returned 'data' object is complete.
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ok <- (!is.na(data$chromosome) & !is.na(data$x))
  if (any(!ok)) {
    verbose && enter(verbose, "Dropping loci with unknown locations")
    verbose && cat(verbose, "Number of loci dropped: ", sum(!ok))
    data <- data[ok,,drop=FALSE]
    nbrOfLoci <- nrow(data)
    verbose && exit(verbose)
  }
  ok <- NULL # Not needed anymore

  # Sanity check
  .stop_if_not(nrow(data) == nbrOfLoci)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Drop loci for which CT is missing (regardless of betaT)
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (dropMissingCT) {
    ok <- (!is.na(data$CT))
    if (any(!ok)) {
      verbose && enter(verbose, "Dropping loci for which TCNs are missing")
      verbose && cat(verbose, "Number of loci dropped: ", sum(!ok))
      data <- data[ok,,drop=FALSE]
      nbrOfLoci <- nrow(data)
      verbose && exit(verbose)
    }
    ok <- NULL # Not needed anymore

    # Sanity check
    .stop_if_not(nrow(data) == nbrOfLoci)
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Reorder data points along the genome, because that is what
  # DNAcopy::segment() will return.  At the end, we will undo
  # the sort such that the returned 'data' object is always in
  # the same order and number of loci as the input data.
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Ordering data along genome")
  o <- order(data$chromosome, data$x, decreasing=FALSE, na.last=TRUE)
  # Any change?
  if (any(o != seq_along(o))) {
    data <- data[o,,drop=FALSE]
  }
  o <- NULL # Not needed anymore
  verbose && str(verbose, data)
  verbose && exit(verbose)

  # Attach 'index' (guaranteed to be ordered)
  data$index <- seq_len(nrow(data))

  # Sanity check
  .stop_if_not(nrow(data) == nbrOfLoci)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Assert no missing values in (chromosome, x, CT)
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Sanity check
  ok <- (!is.na(data$chromosome) & !is.na(data$x))
  if (!all(ok)) {
    stop("INTERNAL ERROR: Detected (chromosome, x) with missing values also after filtering.")
  }

  # Sanity check
  if (dropMissingCT) {
    ok <- (!is.na(data$CT))
    if (!all(ok)) {
      stop("INTERNAL ERROR: Detected TCN with missing values also after filtering.")
    }
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Multiple chromosomes?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Identify all chromosomes, excluding missing values
  chromosomes <- sort(unique(data$chromosome), na.last=NA)
  nbrOfChromosomes <- length(chromosomes)
  if (nbrOfChromosomes > 1) {
    verbose && enter(verbose, "Segmenting multiple chromosomes")
    verbose && cat(verbose, "Number of chromosomes: ", nbrOfChromosomes)

    # Generate random seeds?
    seeds <- NULL
    if (!is.null(seed)) {
      randomSeed("set", seed=seed, kind="L'Ecuyer-CMRG")
      on.exit(randomSeed("reset"), add=TRUE)
      verbose && printf(verbose, "Random seed temporarily set (seed=c(%s), kind=\"L'Ecuyer-CMRG\")\n", paste(seed, collapse=", "))
      seeds <- randomSeed("advance", n=nbrOfChromosomes)
      verbose && printf(verbose, "Produced %d seeds from this stream for future usage\n", length(seeds))
    }

    fitList <- list()
    for (kk in seq_len(nbrOfChromosomes)) {
      chromosomeKK <- chromosomes[kk]
      chrTag <- sprintf("Chr%02d", chromosomeKK)
      verbose && enter(verbose, sprintf("Chromosome #%d ('%s') of %d", kk, chrTag, nbrOfChromosomes))

      seedKK <- seeds[[kk]]

      # Extract subset of data and parameters for this chromosome
      dataKK <- subset(data, chromosome == chromosomeKK)
      verbose && str(verbose, dataKK)
      fields <- attachLocally(dataKK, fields=c("CT", "thetaT", "thetaN", "betaT", "betaTN", "betaN", "muN", "rho", "chromosome", "x"))
      dataKK <- NULL # Not needed anymore

      knownSegmentsKK <- NULL
      if (!is.null(knownSegments)) {
        knownSegmentsKK <- subset(knownSegments, chromosome == chromosomeKK)
        verbose && cat(verbose, "Known segments:")
        verbose && print(verbose, knownSegmentsKK)
      }

      fitList[[chrTag]] <- future({
        fit <- segmentByPairedPSCBS(CT=CT, thetaT=thetaT, thetaN=thetaN,
                  betaT=betaTN, betaN=betaN, muN=muN, rho=rho,
                  chromosome=chromosome, x=x,
                  tbn=FALSE, joinSegments=joinSegments,
                  knownSegments=knownSegmentsKK,
                  alphaTCN=alphaTCN, alphaDH=alphaDH,
                  undoTCN=undoTCN, undoDH=undoDH,
                  avgTCN=avgTCN, avgDH=avgDH,
                  flavor=flavor,
                  ...,
                  seed=seedKK,
                  verbose=verbose)

        # Sanity checks
        if (nrow(knownSegmentsKK) == 0) {
          .stop_if_not(nrow(fit$data) == length(CT))
          .stop_if_not(all.equal(fit$data$CT, CT))
          .stop_if_not(all.equal(fit$data$muN, muN))
        }

        # Update betaT (which is otherwise equals betaTN)
        fit$data$betaT <- betaT

        verbose && print(verbose, head(as.data.frame(fit)))
        verbose && print(verbose, tail(as.data.frame(fit)))

        fit
      }, seed = TRUE, label = sprintf("segmentByPairedPSCBS-%s", chrTag))

      rm(list=fields) # Not needed anymore
      verbose && exit(verbose)
    } # for (kk ...)

    verbose && enter(verbose, "Merging (independently) segmented chromosome")
    fitList <- value(fitList)
    ## former Reduce() w/ append(..., addSplit = TRUE)
    fit <- do.call(c, args = c(fitList, addSplit = TRUE))
    fitList <- NULL # Not needed anymore
    verbose && str(verbose, fit)
    verbose && exit(verbose)

    # Update parameters that otherwise may be incorrect
    fit$params$tbn <- tbn
    fit$params$seed <- seed

    segs <- as.data.frame(fit)
    if (nrow(segs) < 6) {
      verbose && print(verbose, segs)
    } else {
      verbose && print(verbose, head(segs))
      verbose && print(verbose, tail(segs))
    }

    verbose && exit(verbose)

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Return results
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    return(fit)
  } # if (nbrOfChromosomes > 1)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Subset 'knownSegments'
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Keeping only current chromosome for 'knownSegments'")

  currChromosome <- data$chromosome[1]
  verbose && cat(verbose, "Chromosome: ", currChromosome)

  knownSegments <- subset(knownSegments, chromosome == currChromosome)
  nbrOfSegments <- nrow(knownSegments)

  verbose && cat(verbose, "Known segments for this chromosome:")
  verbose && print(verbose, knownSegments)

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Sanity checks
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Here 'knownSegments' should specify at most a single chromosome
  uChromosomes <- sort(unique(knownSegments$chromosome))
  if (length(uChromosomes) > 1) {
    stop("INTERNAL ERROR: Argument 'knownSegments' specifies more than one chromosome: ", hpaste(uChromosomes))
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Assert no missing values in (chromosome, x, CT)
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Sanity check
  ok <- (!is.na(data$chromosome) & !is.na(data$x))
  if (!all(ok)) {
    stop("INTERNAL ERROR: Detected (chromosome, x) with missing values also after filtering.")
  }

  # Sanity check
  if (dropMissingCT) {
    ok <- (!is.na(data$CT))
    if (!all(ok)) {
      stop("INTERNAL ERROR: Detected TCN with missing values also after filtering.")
    }
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup input data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && cat(verbose, "alphaTCN: ", alphaTCN)
  verbose && cat(verbose, "alphaDH: ", alphaDH)
  verbose && cat(verbose, "Number of loci: ", nbrOfLoci)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Calculate decrease-of-heterozygosity signals (DHs)?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.null(data$rho)) {
    verbose && enter(verbose, "Calculating DHs")
    # SNPs are identifies as those loci that have non-missing 'betaTN' & 'muN'
    isSnp <- (!is.na(data$betaTN) & !is.na(data$muN))
    nbrOfSnps <- sum(isSnp)
    verbose && cat(verbose, "Number of SNPs: ", nbrOfSnps)

    # DH is by definition only defined for heterozygous SNPs.
    # For simplicity, we set it to be NA for non-heterozygous loci.
    isHet <- isSnp & (data$muN == 1/2)
    verbose && printf(verbose, "Number of heterozygous SNPs: %d (%.2f%%)\n",
                                       sum(isHet), 100*sum(isHet)/nbrOfSnps)
    rho <- rep(NA_real_, times=nbrOfLoci)
    rho[isHet] <- 2*abs(data$betaTN[isHet]-1/2)
    verbose && cat(verbose, "Normalized DHs:")
    verbose && str(verbose, rho)
    data$rho <- rho
    isSnp <- isHet <- rho <- NULL # Not needed anymore
    verbose && exit(verbose)
  }
  ## Sanity check
  .stop_if_not(!is.null(data$rho))



  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Generate random seeds?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  seeds <- NULL
  if (!is.null(seed)) {
    randomSeed("set", seed=seed, kind="L'Ecuyer-CMRG")
    on.exit(randomSeed("reset"), add=TRUE)
    verbose && printf(verbose, "Random seed temporarily set (seed=c(%s), kind=\"L'Ecuyer-CMRG\")\n", paste(seed, collapse=", "))
    seeds <- randomSeed("advance", n=2L) ## For TCN and DH
    names(seeds) <- c("TCN", "DH")
    verbose && printf(verbose, "Produced %d seeds from this stream for future usage\n", length(seeds))
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # 1a. Identification of change points in total copy numbers
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Identification of change points by total copy numbers")

  fields <- attachLocally(data, fields=c("CT", "thetaT", "thetaN", "chromosome", "x", "index"))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Assert no missing values in (chromosome, x, CT)
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Sanity check
  ok <- (!is.na(data$chromosome) & !is.na(data$x))
  if (!all(ok)) {
    stop("INTERNAL ERROR: Detected (chromosome, x) with missing values also after filtering.")
  }

  # Sanity check
  if (dropMissingCT) {
    ok <- (!is.na(data$CT))
    if (!all(ok)) {
      stop("INTERNAL ERROR: Detected CT with missing values also after filtering.")
    }
  }


  # Segment TCN ratios
  # Calculate tumor-normal TCN ratios?
  fit <- segmentByCBS(CT,
                      chromosome=chromosome, x=x, index=index,
                      joinSegments=joinSegments,
                      knownSegments=knownSegments,
                      alpha=alphaTCN, undo=undoTCN, ...,
                      seed=seeds[["TCN"]],
                      verbose=verbose)
  verbose && str(verbose, fit)

  rm(list=fields) # Not needed anymore

  # Sanity check
  if (nrow(knownSegments) == 0) {
    .stop_if_not(nrow(fit$data) == nrow(data))
    .stop_if_not(all(fit$data$chromosome == data$chromosome))
    .stop_if_not(all(fit$data$x == data$x))
    .stop_if_not(all(fit$data$index == data$index))
    .stop_if_not(all.equal(fit$data$y, data$CT))
  }

  tcnSegments <- fit$output
  tcnSegRows <- fit$segRows
  fit <- NULL # Not needed anymore

  # Sanity checks
  .stop_if_not(all(tcnSegRows[,1] <= tcnSegRows[,2], na.rm=TRUE))
  .stop_if_not(all(tcnSegRows[-nrow(tcnSegRows),2] < tcnSegRows[-1,1], na.rm=TRUE))

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # 1b. Restructure TCN segmentation results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Restructure TCN segmentation results")
  # Drop dummy columns
  keep <- setdiff(colnames(tcnSegments), c("sampleName"))
  tcnSegments <- tcnSegments[,keep,drop=FALSE]

  # Tag fields by TCN
  names <- names(tcnSegments)
  # Adding 'tcn' prefix to column names
  names <- sprintf("tcn%s", capitalize(names))
  names <- gsub("tcnChromosome", "chromosome", names, fixed=TRUE)
  names(tcnSegments) <- names
  verbose && print(verbose, tcnSegments)

  nbrOfSegs <- nrow(tcnSegments)
  verbose && cat(verbose, "Number of TCN segments: ", nbrOfSegs)

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # 2a. Identification of additional change points using DH
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # For each segment independently, segment decrease of heterozygousity (DH)
  # using CBS. By definition, only heterozygous SNPs are used.

  if (flavor == "tcn") {
    verbose && enter(verbose, "TCN-only segmentation")

    tcnSegsExpanded <- tcnSegRows
    dhSegRows <- tcnSegRows

    # Segments
    segs <- tcnSegments
    segs[,"tcnId"] <- seq_len(nbrOfSegs)
    segs[,"dhId"] <- rep(1L, times=nbrOfSegs)
    segs[,c("tcnNbrOfSNPs", "tcnNbrOfHets", "dhNbrOfLoci")] <- 0L
    segs[,"dhStart"] <- segs[,"tcnStart"]
    segs[,"dhEnd"] <- segs[,"tcnEnd"]

    # For each TCN segment...
    for (kk in seq_len(nbrOfSegs)) {
      tcnId <- kk

      xStart <- tcnSegments[kk,"tcnStart"]
      xEnd <- tcnSegments[kk,"tcnEnd"]
      regionTag <- sprintf("[%10g,%10g]", xStart, xEnd)
      verbose && enter(verbose, sprintf("Total CN segment #%d (%s) of %d", kk, regionTag, nbrOfSegs))

      # Empty segment?
      rowStart <- tcnSegRows[kk,1]
      rowEnd <- tcnSegRows[kk,2]

      # Empty segment or a segment separator?
      isEmptySegment <- (is.na(rowStart) && is.na(rowEnd))

      # Nothing to do?
      if (isEmptySegment) {
        verbose && exit(verbose)
        next
      }

      nbrOfTCNLociKK <- tcnSegments[kk,"tcnNbrOfLoci"]
      verbose && cat(verbose, "Number of TCN loci in segment: ", nbrOfTCNLociKK)
      rows <- seq(from=rowStart, length.out=nbrOfTCNLociKK)
      dataKK <- data[rows,,drop=FALSE]
      nbrOfLociKK <- nrow(dataKK)

      verbose && cat(verbose, "Locus data for TCN segment:")
      verbose && str(verbose, dataKK)

      verbose && cat(verbose, "Number of loci: ", nbrOfLociKK)
      hasDH <- !is.null(dataKK$rho)
      if (hasDH) {
        isSnpKK <- !is.na(dataKK$rho)
        isHetsKK <- (isSnpKK & (dataKK$rho > 0))
      } else {
        isSnpKK <- !is.na(dataKK$muN)
        isHetsKK <- (isSnpKK & (dataKK$muN == 1/2))
      }
      nbrOfSnpsKK <- sum(isSnpKK)
      nbrOfHetsKK <- sum(isHetsKK)
      verbose && printf(verbose, "Number of SNPs: %d (%.2f%%)\n",
                                    nbrOfSnpsKK, 100*nbrOfSnpsKK/nbrOfLociKK)

      verbose && printf(verbose, "Number of heterozygous SNPs: %d (%.2f%%)\n",
                                    nbrOfHetsKK, 100*nbrOfHetsKK/nbrOfSnpsKK)

      segs[kk,"tcnNbrOfSNPs"] <- nbrOfSnpsKK
      segs[kk,"tcnNbrOfHets"] <- nbrOfHetsKK
      segs[kk,"dhNbrOfLoci"] <- nbrOfHetsKK

      # Adjust 'dhRows[kk,]'
      rows <- rows[isHetsKK]
      rows <- range(rows, na.rm=TRUE)
      dhSegRows[kk,] <- rows

      # Sanity check
      if (nbrOfHetsKK > 0) {
        .stop_if_not(all(dhSegRows[kk,1] <= dhSegRows[kk,2], na.rm=TRUE))
      }

      # Calculate dhMean
      rhoKK <- dataKK[["rho"]][isHetsKK]
      segs[kk,"dhMean"] <- mean(rhoKK, na.rm=TRUE)

      verbose && exit(verbose)
    } # for (kk ...)

    # Reorder segmentation columns
    keys <- c("tcnId", "dhId", colnames(tcnSegments))
    keys <- c(keys, setdiff(colnames(segs), keys))
    segs <- segs[,keys]

    verbose && exit(verbose)
  } else {
    dhSegRows <- NULL
    tcnSegsExpanded <- NULL

    # For each TCN segment...
    segs <- vector("list", length=nbrOfSegs)
    for (kk in seq_len(nbrOfSegs)) {
      tcnId <- kk

      xStart <- tcnSegments[kk,"tcnStart"]
      xEnd <- tcnSegments[kk,"tcnEnd"]
      regionTag <- sprintf("[%10g,%10g]", xStart, xEnd)
      verbose && enter(verbose, sprintf("Total CN segment #%d (%s) of %d", kk, regionTag, nbrOfSegs))

      # Empty segment?
      rowStart <- tcnSegRows[kk,1]
      rowEnd <- tcnSegRows[kk,2]

      # Empty segment or a segment separator?
      isEmptySegment <- (is.na(rowStart) && is.na(rowEnd))
      isSplitter <- (isEmptySegment && is.na(xStart) && is.na(xEnd))
      isEmptySegment <- (isEmptySegment & !isSplitter)

      if (isSplitter) {
        verbose && cat(verbose, "No signals to segment. Just a \"splitter\" segment. Skipping.")

        # Sanity check
        .stop_if_not(kk >= 1)

        # Add a splitter segment
        segT <- segs[[kk-1]]
        segT <- segT[NA_integer_,]
        keys <- colnames(tcnSegments)
        segT[,keys] <- tcnSegments[kk,keys]
        segT[,"tcnId"] <- tcnId
        segT[,"dhId"] <- 1L
        segT[,c("tcnNbrOfSNPs", "tcnNbrOfHets", "dhNbrOfLoci")] <- 0L
        segT[,"dhStart"] <- xStart
        segT[,"dhEnd"] <- xEnd
        segs[[kk]] <- segT
        verbose && print(verbose, segT)

        # Add a splitter to TCN and DH segment row matrix
        segRowsT <- dhSegRows[NA_integer_,]
        dhSegRows <- rbind(dhSegRows, segRowsT)

        segRowsT <- tcnSegsExpanded[NA_integer_,]
        tcnSegsExpanded <- rbind(tcnSegsExpanded, segRowsT)

        verbose && exit(verbose)
        next
      } # if (isSplitter)


      nbrOfTCNLociKK <- tcnSegments[kk,"tcnNbrOfLoci"]
      verbose && cat(verbose, "Number of TCN loci in segment: ", nbrOfTCNLociKK)

      # Sanity check
      .stop_if_not(!isEmptySegment || (isEmptySegment && (nbrOfTCNLociKK == 0)))

      if (nbrOfTCNLociKK > 0) {
        # Extract locus data for TCN segment
        rows <- rowStart:rowEnd
    ##    if (nrow(knownSegments) == 0) {
    ##      gammaT <- tcnSegments[kk,"tcnMean"]
    ##      verbose && print(verbose, all.equal(mean(dataKK$CT, na.rm=TRUE), gammaT, tolerance=tol))
    ##      .stop_if_not(all.equal(mean(dataKK$CT, na.rm=TRUE), gammaT, tolerance=tol))
    ##    }
      } else {
        rows <- integer(0)
      } # if (nbrOfTCNLociKK > 0)

      dataKK <- data[rows,,drop=FALSE]
      nbrOfLociKK <- nrow(dataKK)

      # Sanity check
      .stop_if_not(length(dataKK$CT) == nbrOfTCNLociKK)
    ##  .stop_if_not(sum(!is.na(dataKK$CT)) == nbrOfTCNLociKK)

      verbose && cat(verbose, "Locus data for TCN segment:")
      verbose && str(verbose, dataKK)

      verbose && cat(verbose, "Number of loci: ", nbrOfLociKK)

      hasDH <- !is.null(dataKK$rho)
      if (hasDH) {
        isSnpKK <- !is.na(dataKK$rho)
        isHetsKK <- (isSnpKK & (dataKK$rho > 0))
      } else {
        isSnpKK <- !is.na(dataKK$muN)
        isHetsKK <- (isSnpKK & (dataKK$muN == 1/2))
      }
      nbrOfSnpsKK <- sum(isSnpKK)
      nbrOfHetsKK <- sum(isHetsKK)
      verbose && printf(verbose, "Number of SNPs: %d (%.2f%%)\n",
                                    nbrOfSnpsKK, 100*nbrOfSnpsKK/nbrOfLociKK)
      verbose && printf(verbose, "Number of heterozygous SNPs: %d (%.2f%%)\n",
                                    nbrOfHetsKK, 100*nbrOfHetsKK/nbrOfSnpsKK)

      # Since segments in 'knownSegments' has already been used in the TCN
      # segmentation, they are not needed in the DH segmentation.
      currChromosome <- data$chromosome[1]
      verbose && cat(verbose, "Chromosome: ", currChromosome)
      knownSegmentsT <- data.frame(chromosome=currChromosome, start=xStart, end=xEnd)

      verbose && enter(verbose, "Segmenting DH signals")
      fields <- attachLocally(dataKK, fields=c("chromosome", "x", "rho", "index"))

      fit <- segmentByCBS(rho,
                          chromosome=chromosome, x=x,
                          joinSegments=joinSegments,
                          knownSegments=knownSegmentsT,
                          alpha=alphaDH, undo=undoDH, ...,
                          seed=seeds[["DH"]],
                          verbose=verbose)
      verbose && str(verbose, fit)
      dhSegments <- fit$output
      dhSegRowsKK <- fit$segRows

      verbose && cat(verbose, "DH segmentation (locally-indexed) rows:")
      verbose && print(verbose, dhSegRowsKK)
      verbose && str(verbose, index)

      # Remap to genome-wide indices
      for (cc in 1:2) {
        dhSegRowsKK[,cc] <- index[dhSegRowsKK[,cc]]
      }

      verbose && cat(verbose, "DH segmentation rows:")
      verbose && print(verbose, dhSegRowsKK)

      # Not needed anymore
      rm(list=fields)
      fit <- NULL
      verbose && exit(verbose)

      # Drop dummy columns
      keep <- setdiff(colnames(dhSegments), c("sampleName", "chromosome"))
      dhSegments <- dhSegments[,keep,drop=FALSE]

      # Tag fields by DH
      names <- names(dhSegments)
      # Adding 'dh' prefix to column names
      names <- sprintf("dh%s", capitalize(names))
      names(dhSegments) <- names

      # Special case: If there where not enough data to segment DH...
      if (nrow(dhSegments) == 0) {
        dhSegments <- dhSegments[NA_integer_,,drop=FALSE]
        dhSegRowsKK <- dhSegRowsKK[NA_integer_,,drop=FALSE]
      }

      verbose && cat(verbose, "DH segmentation table:")
      verbose && print(verbose, dhSegments)
      verbose && print(verbose, dhSegRowsKK)

      # Expand the TCN segmentation result data frame
      rows <- rep(kk, times=nrow(dhSegments))
      verbose && cat(verbose, "Rows:")
      verbose && print(verbose, rows)
      tcnSegmentsKK <- tcnSegments[rows,,drop=FALSE]
      tcnSegRowsKK <- tcnSegRows[rows,,drop=FALSE]
      # Sanity check
      .stop_if_not(nrow(tcnSegmentsKK) == nrow(dhSegments))
      .stop_if_not(nrow(tcnSegRowsKK) == nrow(dhSegments))
      .stop_if_not(all(is.na(tcnSegRowsKK[,1]) | is.na(dhSegRowsKK[,1]) | (tcnSegRowsKK[,1] <= dhSegRowsKK[,1])))
      .stop_if_not(all(is.na(tcnSegRowsKK[,2]) | is.na(dhSegRowsKK[,2]) | (dhSegRowsKK[,2] <= tcnSegRowsKK[,2])))
      verbose && cat(verbose, "TCN segmentation rows:")
      verbose && print(verbose, tcnSegRowsKK)
      .stop_if_not(all(tcnSegRowsKK[,1] == tcnSegRowsKK[1,1], na.rm=TRUE))
      .stop_if_not(all(tcnSegRowsKK[,2] == tcnSegRowsKK[1,2], na.rm=TRUE))

      verbose && cat(verbose, "TCN and DH segmentation rows:")
      verbose && print(verbose, tcnSegRowsKK)
      verbose && print(verbose, dhSegRowsKK)
      verbose && print(verbose, tcnSegsExpanded)

      # Append
      tcnSegsExpanded <- rbind(tcnSegsExpanded, tcnSegRowsKK)
      verbose && cat(verbose, "TCN segmentation (expanded) rows:")
      verbose && print(verbose, tcnSegsExpanded)
      rownames(tcnSegsExpanded) <- NULL

      dhSegRows <- rbind(dhSegRows, dhSegRowsKK)
      rownames(dhSegRows) <- NULL

      verbose && cat(verbose, "TCN and DH segmentation rows:")
      verbose && print(verbose, tcnSegRows)
      verbose && print(verbose, dhSegRows)
      verbose && print(verbose, tcnSegsExpanded)

      # Sanity checks
      .stop_if_not(all(tcnSegRows[,1] <= tcnSegRows[,2], na.rm=TRUE))
      .stop_if_not(all(tcnSegRows[-nrow(tcnSegRows),2] < tcnSegRows[-1,1], na.rm=TRUE))
      .stop_if_not(all(dhSegRows[,1] <= dhSegRows[,2], na.rm=TRUE))
      .stop_if_not(all(dhSegRows[-nrow(dhSegRows),2] < dhSegRows[-1,1], na.rm=TRUE))
      .stop_if_not(all(tcnSegsExpanded[,1] <= tcnSegsExpanded[,2], na.rm=TRUE))
      .stop_if_not(all(tcnSegsExpanded[,1] <= dhSegRows[,1], na.rm=TRUE))
      .stop_if_not(all(tcnSegsExpanded[,2] >= dhSegRows[,2], na.rm=TRUE))
  ##    if (!all(tcnSegsExpanded[-nrow(tcnSegsExpanded),2] < tcnSegsExpanded[-1,1], na.rm=TRUE)) {
  ##      .stop_if_not(all(tcnSegsExpanded[-nrow(tcnSegsExpanded),2] < tcnSegsExpanded[-1,1], na.rm=TRUE))
  ##    }


      # Sanity check
      .stop_if_not(nrow(dhSegRows) == nrow(tcnSegsExpanded))

      # Append information on number of SNPs and hets in CN region
      tcnSegmentsKK <- cbind(
        tcnSegmentsKK,
        tcnNbrOfSNPs=nbrOfSnpsKK,
        tcnNbrOfHets=nbrOfHetsKK
      )
      verbose && cat(verbose, "Total CN segmentation table (expanded):")
      verbose && print(verbose, tcnSegmentsKK)

      # Sanity check
      .stop_if_not(nrow(tcnSegmentsKK) == nrow(dhSegments))

      # Combine TCN and DH segmentation results
      tcndhSegments <- cbind(
        tcnId=rep(kk, times=nrow(dhSegments)),
        dhId=seq_len(nrow(dhSegments)),
        tcnSegmentsKK,
        dhSegments
      )

      segs[[kk]] <- tcndhSegments

      verbose && cat(verbose, "(TCN,DH) segmentation for one total CN segment:")
      verbose && print(verbose, segs[[kk]])

      verbose && exit(verbose)
    } # for (kk ...)

    segs <- Reduce(rbind, segs)
    rownames(segs) <- NULL
  } # if (flavor == "tcn")

  # Sanity check
  .stop_if_not(nrow(dhSegRows) == nrow(tcnSegsExpanded))
  rownames(tcnSegRows) <- rownames(dhSegRows) <- NULL

  .stop_if_not(all(tcnSegRows[,1] <= tcnSegRows[,2], na.rm=TRUE))
  .stop_if_not(all(tcnSegRows[-nrow(tcnSegRows),2] < tcnSegRows[-1,1], na.rm=TRUE))
  if (flavor != "tcn") {
    .stop_if_not(all(dhSegRows[,1] <= dhSegRows[,2], na.rm=TRUE))
  }
  .stop_if_not(all(dhSegRows[-nrow(dhSegRows),2] < dhSegRows[-1,1], na.rm=TRUE))
  .stop_if_not(all(tcnSegsExpanded[,1] <= tcnSegsExpanded[,2], na.rm=TRUE))
##  .stop_if_not(all(tcnSegsExpanded[-nrow(tcnSegsExpanded),2] < tcnSegsExpanded[-1,1], na.rm=TRUE))

  # Move 'chromosome' column to the first column
  idx <- match("chromosome", names(segs))
  idxs <- c(idx, seq_len(ncol(segs))[-idx])
  segs <- segs[,idxs,drop=FALSE]
  verbose && print(verbose, segs)

  verbose && enter(verbose, "Calculating (C1,C2) per segment")
  # Append (C1,C2) estimates
  tcn <- segs$tcnMean
  dh <- segs$dhMean
  C1 <- 1/2*(1-dh)*tcn
  C2 <- tcn - C1
  segs <- cbind(segs, c1Mean=C1, c2Mean=C2)
  verbose && exit(verbose)

  nbrOfSegs <- nrow(segs)
  verbose && cat(verbose, "Number of segments: ", nbrOfSegs)

  verbose && exit(verbose)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Create result object
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  params <- list(
    alphaTCN = alphaTCN,
    alphaDH = alphaDH,
    flavor = flavor,
    tbn = tbn,
    joinSegments = joinSegments,
    knownSegments = knownSegments,
    seed = seed
  )

  # Should we drop attributes? /HB 2010-09-24
  .stop_if_not(all(data$index == seq_len(nrow(data))))
  data$index <- NULL # Drop, because it is guaranteed to be ordered
  class(data) <- c("PairedPSCNData", class(data))

  class(segs) <- c("PairedPSCNSegments", class(segs))

  fit <- list(
    data = data,
    output = segs,
    tcnSegRows = tcnSegsExpanded,
    dhSegRows = dhSegRows,
    params = params
  )

  class(fit) <- c("PairedPSCBS", "PSCBS", "AbstractCBS")


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (avgTCN != "mean" || avgDH != "mean") {
    verbose && enter(verbose, "Updating mean level using different estimator")
    verbose && cat(verbose, "TCN estimator: ", avgTCN)
    verbose && cat(verbose, "DH estimator: ", avgDH)
    fit <- updateMeans(fit, avgTCN=avgTCN, avgDH=avgDH, verbose=less(verbose, 20))
    verbose && exit(verbose)
  }

  if (is.element(flavor, c("tcn&dh", "sqrt(tcn)&dh"))) {
    fit$params$flavor <- gsub("&", ",", flavor, fixed=TRUE) # AD HOC.
    fit <- postsegmentTCN(fit, verbose=verbose)

    # Sanity check
    CT <- fit$data$CT
    tcnSegRows <- fit$tcnSegRows
    dhSegRows <- fit$dhSegRows
    for (jj in 1:nrow(tcnSegRows)) {
      tcnSegRowJJ <- unlist(tcnSegRows[jj,,drop=TRUE], use.names=FALSE)
      dhSegRowJJ <- unlist(dhSegRows[jj,,drop=TRUE], use.names=FALSE)
      .stop_if_not(
        is.na(tcnSegRowJJ[1]) || is.na(dhSegRowJJ[1]) ||
        # A TCN segment must start at or before a DH segment...
        (tcnSegRowJJ[1] <= dhSegRowJJ[1]) ||
        # ...unless there was an outlier at the left edge.
        (is.na(CT[dhSegRowJJ[1]]) && (tcnSegRowJJ[1] - 1L <= dhSegRowJJ[1]))
      )
      .stop_if_not(
        is.na(tcnSegRowJJ[2]) || is.na(dhSegRowJJ[2]) ||
        # A TCN segment must end at or after a DH segment...
        (dhSegRowJJ[2] <= tcnSegRowJJ[2]) ||
        # ...unless there was an outlier at the right edge.
        (is.na(CT[dhSegRowJJ[2]]) && (dhSegRowJJ[2] <= tcnSegRowJJ[2] + 1L))
      )
    } # for (jj ...)
    # Not needed anymore
    CT <- tcnSegRows <- dhSegRows <- NULL
  }

  verbose && print(verbose, head(as.data.frame(fit)))
  verbose && print(verbose, tail(as.data.frame(fit)))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Return results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fit
}) # segmentByPairedPSCBS()



setMethodS3("segmentByPairedPSCBS", "data.frame", function(CT, ...) {
  # To please R CMD check
  data <- CT

  segmentByPairedPSCBS(CT=data$CT, thetaT=data$thetaT, thetaN=data$thetaN,
                       betaT=data$betaT, betaN=data$betaN,
                       muN=data$muN, rho=data$rho,
                       chromosome=data$chromosome, x=data$x, ...)
})



setMethodS3("segmentByPairedPSCBS", "PairedPSCBS", function(...) {
  resegment(...)
}) # segmentByPairedPSCBS()

setMethodS3("updateMeans", "PairedPSCBS", function(fit, from=c("loci", "segments"), adjustFor=NULL, ..., avgTCN=c("asis", "mean", "median"), avgDH=c("asis", "mean", "median"), clear=FALSE, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'from':
  from <- match.arg(from)

  # Argument 'adjustFor':
  if (!is.null(adjustFor)) {
    adjustFor <- Arguments$getCharacters(adjustFor)
    adjustFor <- tolower(adjustFor)
    knownValues <- c("ab", "loh", "roh")
    adjustFor <- match.arg(adjustFor, choices=knownValues, several.ok=TRUE)
  }

  # Argument 'avgTCN' & 'avgDH':
  avgTCN <- match.arg(avgTCN)
  avgDH <- match.arg(avgDH)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Updating mean level estimates")
  verbose && cat(verbose, "Adjusting for:")
  verbose && print(verbose, adjustFor)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setting up averaging functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (avgTCN == "asis" || avgDH == "asis") {
    est <- fit$params$meanEstimators
    if (avgTCN == "asis") {
      avgTCN <- est$tcn
      if (is.null(avgTCN)) avgTCN <- "mean"
      avgTCN <- match.arg(avgTCN)
    }
    if (avgDH == "asis") {
      avgDH <- est$dh
      if (is.null(avgDH)) avgDH <- "mean"
      avgDH <- match.arg(avgDH)
    }
  }

  avgList <- list(
    tcn = get(avgTCN, mode="function"),
    dh = get(avgDH, mode="function")
  )


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the segmentation results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  segs <- getSegments(fit, splitters=TRUE)
  segRows <- list(tcn=fit$tcnSegRows, dh=fit$dhSegRows)
  nbrOfSegments <- nrow(segs)
  verbose && cat(verbose, "Number of segments: ", nbrOfSegments)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Assert that adjustments can be made
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.element("ab", adjustFor)) {
    if (!is.element("abCall", names(segs))) {
      adjustFor <- setdiff(adjustFor, "ab")
      stop("Cannot adjust for AB, because they haven't been called.")
    }
  }

  if (is.element("loh", adjustFor)) {
    if (!is.element("lohCall", names(segs))) {
      adjustFor <- setdiff(adjustFor, "loh")
      stop("Cannot adjust for LOH, because they haven't been called.")
    }
  }

  if (is.element("roh", adjustFor)) {
    if (!is.element("rohCall", names(segs))) {
      adjustFor <- setdiff(adjustFor, "roh")
      stop("Cannot adjust for ROH, because they haven't been called.")
    }
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update the (TCN,DH) mean levels from locus-level data?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (from == "loci") {
    data <- getLocusData(fit)
    chromosome <- data$chromosome
    x <- data$x
    CT <- data$CT
    rho <- data$rho

    isSplitter <- isSegmentSplitter(fit)
    for (ss in seq_len(nbrOfSegments)[!isSplitter]) {
      verbose && enter(verbose, sprintf("Segment %d of %d", ss, nbrOfSegments))
      seg <- segs[ss,]
      verbose && print(verbose, seg)

      chr <- seg[["chromosome"]]
      chrTag <- sprintf("chr%02d", chr)

      for (what in c("tcn", "dh")) {
        segRow <- segRows[[what]][ss,]

        # (a) A splitter - nothing todo?
        if (!is.finite(segRow[[1]]) || !is.finite(segRow[[2]])) {
          next
        }

        # (b) Identify units (loci)
        units <- segRow[[1]]:segRow[[2]]

        # (c) Adjust for missing values
        if (what == "tcn") {
          value <- CT
        } else if (what == "dh") {
          value <- rho
        }
        keep <- which(!is.na(value[units]))
        units <- units[keep]

        # (d) Update mean
        avgFUN <- avgList[[what]]
        gamma <- avgFUN(value[units])

        # Sanity check
        .stop_if_not(length(units) == 0 || !is.na(gamma))

        # Update the segment boundaries, estimates and counts
        key <- paste(what, "Mean", sep="")
        seg[[key]] <- gamma
      }

      verbose && print(verbose, seg)

      segs[ss,] <- seg

      verbose && exit(verbose)
    } # for (ss ...)
  } # if (from ...)



  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Adjust segment means from various types of calls
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (length(adjustFor) > 0) {
    verbose && enter(verbose, "Adjusting segment means")
    verbose && cat(verbose, "Adjusting for:")
    verbose && print(verbose, adjustFor)

    if (is.element("ab", adjustFor)) {
      verbose && enter(verbose, "Adjusting for AB")
      calls <- segs$abCall
      segs$dhMean[calls] <- 0
      verbose && exit(verbose)
    }

    if (is.element("loh", adjustFor)) {
      verbose && enter(verbose, "Adjusting for LOH")
      calls <- segs$lohCall
      segs$dhMean[calls] <- 1
      verbose && exit(verbose)
    }

    if (is.element("roh", adjustFor)) {
      verbose && enter(verbose, "Adjusting for ROH")
      calls <- segs$rohCall
      segs$dhMean[calls] <- NA_real_
      verbose && exit(verbose)
    }

    verbose && exit(verbose)
  } # if (length(adjustFor) > 0)


  # Update
  fit$output <- segs
  fit <- setMeanEstimators(fit, tcn=avgTCN, dh=avgDH)
  if (clear) {
    fit <- clearBootstrapSummaries(fit)
  }

  # Update (C1,C2) mean levels
  fit <- updateMeansC1C2(fit, verbose=verbose)

  verbose && exit(verbose)

  fit
}, private=TRUE) # updateMeans()


setMethodS3("updateMeansC1C2", "PairedPSCBS", function(fit, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Updating (C1,C2) segment mean levels")
  segs <- getSegments(fit)

  if (nrow(segs) > 0L) {
    tcn <- segs$tcnMean
    dh <- segs$dhMean

    C1 <- 1/2*(1-dh)*tcn
    C2 <- tcn - C1

    segs$c1Mean <- C1
    segs$c2Mean <- C2

    # Preserve (C1,C2) swaps / change-point flips?
    swap <- segs$c1c2Swap
    if (!is.null(swap)) {
      swap <- which(swap)
      if (length(swap) > 0L) {
        segs[swap, c("c1Mean","c2Mean")] <- segs[swap, c("c2Mean","c1Mean")]
      }
    }

    fit$output <- segs
  }

  verbose && exit(verbose)

  fit
}, protected=TRUE) # updateMeansC1C2()



##############################################################################
# HISTORY
# 2014-03-26
# o BUG FIX: updateMeansC1C2() for PairedPSCBS did not handle missing
#   values (=splitters) in the 'c1c2Swap' field.
# 2014-03-25
# o BUG FIX: updateMeans() for PairedPSCBS and NonPairedPSCBS returned the
#   incorrect DH segment levels for region in AB if adjustFor="ab" and
#   likewise for segments in LOH if adjustFor="loh".
# 2013-11-23
# o Now updateMeans(..., clear=TRUE) clears bootstrap summaries, otherwise
#   not.
# 2013-10-26
# o Now updateMeans() for PairedPSCBS always clears the bootstrap summaries.
# o Added updateMeansC1C2().
# o updateMeans() for PairedPSCBS did not preserve the (C1,C2) swaps.
# 2012-04-21
# o CLEANUP: Removed unused objects in updateMeans().
# 2011-11-12
# o Added arguments 'from' and 'adjustFor' to updateMeans().
# 2011-01-16
# o BUG FIX: updateMeans() save to the incorrect column names.
# 2011-01-12
# o Added updateMeans() for PairedPSCBS.
##############################################################################

###########################################################################/**
# @set "class=CBS"
# @RdocMethod callGainsAndLosses
#
# @title "Calls gains and losses"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{adjust}{A positive scale factor adjusting the sensitivity of the
#    caller, where a value less (greater) than 1.0 makes the caller
#    less (more) sensitive.}
#  \item{method}{A @character string specifying the calling algorithm to use.}
#  \item{...}{Additional/optional arguments used to override the default
#    parameters used by the caller.}
# }
#
# \value{
#  Returns a @see "PSCBS::CBS" object where @logical columns
#  'lossCall' and 'gainCall' have been appended to the segmentation table.
# }
#
# \section{The UCSF caller}{
#   If \code{method == "ucsf-mad"}, then segments are called using [1], i.e.
#   a segment is called gained or lost if its segment level is
#   at least two standard deviations away from the median segment level
#   on Chr1-22, where standard deviation is estimated using MAD.
#   Then same is done for \code{method == "ucsf-dmad"} with the difference
#   that the standard deviation is estimated using a robust first order
#   variance estimator.
# }
#
# \examples{
#   @include "../incl/segmentByCBS.Rex"
#   @include "../incl/segmentByCBS,calls.Rex"
# }
#
# @author "HB"
#
# \references{
#   [1] Fridlyand et al. \emph{Breast tumor copy number aberration
#       phenotypes and genomic instability}, BMC Cancer, 2006. \cr
# }
#
# \seealso{
#   @seemethod "callAmplifications".
#   @seemethod "callOutliers".
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("callGainsAndLosses", "CBS", function(fit, adjust=1.0, method=c("ucsf-mad", "ucsf-dmad"), ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'adjust':
  adjust <- Arguments$getDouble(adjust, range=c(0, Inf))

  # Argument 'method':
  method <- match.arg(method)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Calling segments that are gained or lost")

  userArgs <- list(...)

  params <- list()

  # Allocate calls
  naValue <- NA
  nbrOfSegments <- nbrOfSegments(fit, splitters=TRUE)
  segs <- getSegments(fit, splitters=TRUE)
  nbrOfRows <- nrow(segs)
  gainCalls <- lossCalls <- rep(naValue, times=nbrOfRows)

  verbose && cat(verbose, "Number of segments to be called: ", nbrOfSegments)
  verbose && cat(verbose, "Call method: ", method)

  if (is.element(method, c("ucsf-mad", "ucsf-dmad"))) {
    # Default arguments
    args <- list(
      chromosomes = intersect(getChromosomes(fit), c(0L, 1:22)),
      scale = 2.0
    )

    # Override by (optional) user-specified arguments
    for (key in names(userArgs)) {
      args[[key]] <- userArgs[[key]]
    }

    # Extract arguments
    chromosomes <- args$chromosomes
    scale <- args$scale

    # Argument check
    chromosomes <- Arguments$getVector(chromosomes, lengths=c(1,Inf))
    scale <- Arguments$getDouble(scale, range=c(0,Inf))

    # Estimate the whole-genome standard deviation of the TCNs
    if (method == "ucsf-mad") {
      sigma <- estimateStandardDeviation(fit, chromosomes=chromosomes,
                                         method="res", estimator="mad")
      sigmaKey <- "sigmaMAD"
    } else if (method == "ucsf-dmad") {
      sigma <- estimateStandardDeviation(fit, chromosomes=chromosomes,
                                         method="diff", estimator="mad")
      sigmaKey <- "sigmaDelta"
    } else {
      stop("INTERNAL ERROR: Unknown method: ", method)
    }

    # Sanity check
    sigma <- Arguments$getDouble(sigma, range=c(0,Inf))

    # Calculate the threshold
    tau <- scale * sigma

    # Make more or less sensitive
    tau <- adjust * tau

    verbose && cat(verbose, "Call parameters:")
    verbose && str(verbose, list(sigma=sigma, scale=scale, adjust=adjust))

    # Calculate segment levels using the median estimator
    fitT <- updateMeans(fit, avg="median")
    segsT <- getSegments(fitT, splitters=TRUE)
    mu <- segsT$mean
    fitT <- segsT <- NULL # Not needed anymore

    # The median segmented level
    muR <- median(mu, na.rm=TRUE)

    # The threshold for losses
    tauLoss <- muR - tau

    # The threshold for gains
    tauGain <- muR + tau

    # Call
    lossCalls <- (mu <= tauLoss) # Losses
    gainCalls <- (mu >= tauGain) # Gains

    # Call parameters used
    params$method <- method
    params$adjust <- adjust
    params[[sigmaKey]] <- sigma
    params$scale <- scale
    params$muR <- muR
    params$tau <- tau
    params$tauLoss <- tauLoss
    params$tauGain <- tauGain
  }

  verbose && cat(verbose, "Number of called segments: ", length(lossCalls))


  # Sanity check
  .stop_if_not(length(lossCalls) == nbrOfRows)
  .stop_if_not(length(gainCalls) == nbrOfRows)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update 'DNAcopy' object
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # (a) segmentation table
  segs <- getSegments(fit, splitters=TRUE)
  segs$lossCall <- lossCalls
  segs$gainCall <- gainCalls
  fit$output <- segs

  # (b) parameters
  allParams <- fit$params
  if (is.null(allParams)) {
    allParams <- list()
  }
  allParams$callGainsAndLosses <- params
  fit$params <- allParams

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Return the updated 'CBS' object.
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fit
}, private=TRUE) # callGainsAndLosses()





###########################################################################/**
# @RdocMethod callAmplifications
#
# @title "Calls (focal) amplifications"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{adjust}{A positive scale factor adjusting the sensitivity of the
#    caller, where a value less (greater) than 1.0 makes the caller
#    less (more) sensitive.}
#  \item{maxLength}{A @double scalar specifying the maximum length of a segment
#    in order for it to be considered a focal amplification.}
#  \item{method}{A @character string specifying the calling algorithm to use.}
#  \item{...}{Additional/optional arguments used to override the default
#    parameters used by the caller.}
#  \item{verbose}{@see "R.utils::Verbose".}
# }
#
# \value{
#  Returns a @see "PSCBS::CBS" object where @logical column
#  'amplificationCall' has been appended to the segmentation table.
# }
#
# \section{The UCSF caller}{
#   If \code{method == "ucsf-exp"}, then segments are called using [1], i.e.
#   a segment is called an amplification if ...
# }
#
# @author
#
# \references{
#   [1] Fridlyand et al. \emph{Breast tumor copy number aberration
#       phenotypes and genomic instability}, BMC Cancer, 2006. \cr
# }
#
# \seealso{
#   @seemethod "callGainsAndLosses".
#   @seemethod "callOutliers".
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("callAmplifications", "CBS", function(fit, adjust=1.0, maxLength=20e6, method=c("ucsf-exp"), ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'adjust':
  adjust <- Arguments$getDouble(adjust, range=c(0, Inf))

  # Argument 'maxLength':
  maxLength <- Arguments$getDouble(maxLength, range=c(0, Inf))

  # Argument 'method':
  method <- match.arg(method)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Calling segments that are amplified")

  userArgs <- list(...)

  params <- list()

  # Allocate calls
  naValue <- NA
  nbrOfSegments <- nbrOfSegments(fit, splitters=TRUE)
  calls <- rep(naValue, times=nbrOfSegments)

  verbose && cat(verbose, "Number of segments to be called: ", nbrOfSegments)
  verbose && cat(verbose, "Call method: ", method)

  if (method == "ucsf-exp") {
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Call arguments
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Default arguments
    args <- list(
      minLevel = 0.0,
      lambda   = 1.0,
      degree   = 3
    )

    # Override by (optional) user-specified arguments
    for (key in names(userArgs)) {
      args[[key]] <- userArgs[[key]]
    }

    # Extract arguments
    minLevel <- args$minLevel
    lambda <- args$lambda
    degree <- args$degree

    # Validate arguments
    minLevel <- Arguments$getDouble(minLevel, range=c(-Inf, Inf))
    lambda <- Arguments$getDouble(lambda, range=c(0, Inf))
    degree <- Arguments$getDouble(degree, range=c(1, Inf))

    verbose && cat(verbose, "Call parameters:")
    verbose && str(verbose, list(minLevel=minLevel, lambda=lambda,
                                                  degree=degree))

    segs <- getSegments(fit, splitters=TRUE)

    verbose && cat(verbose, "Segments:")
    verbose && str(verbose, segs)


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Rule #1: Only consider segments that are short enough
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # The lengths (in bp) of the segments
    start <- segs$start
    end <- segs$end
    length <- end - start ## + 1L
    keep1 <- (length <= maxLength)

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Rule #2: Only consider segments that have a mean level
    #          that is large enough.
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # The mean levels of the segments
    mu <- segs$mean
    keep2 <- (mu >= minLevel)

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Rule #3: Only consider segments that have a mean level
    #          that is much larger than either of the
    #          flanking segments.
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # The mean levels of the flanking segments
    muL <- c(NA_real_, mu[-nbrOfSegments])
    muR <- c(mu[-1], NA_real_)

    # The difference in mean levels to the flanking segments
    deltaL <- mu - muL
    deltaR <- mu - muR

    # The maximum difference to either of the flanking segments
    delta <- pmax(deltaL, deltaR, na.rm=TRUE)

    # The threshold for calling segments amplified
    tau <- exp(-lambda * mu^degree)

    # Make more or less sensitive
    tau <- adjust * tau

    keep3 <- (delta >= tau)

    # Amplification calls
    calls <- (keep1 & keep2 & keep3)

    # Call parameters used
    params$method <- method
    params$adjust <- adjust
    params$maxLength <- maxLength
    params$minLevel <- minLevel
    params$lambda <- lambda
    params$degree <- degree
    params$tau <- tau
  }

  verbose && cat(verbose, "Number of called segments: ", length(calls))

  # Sanity check
  .stop_if_not(length(calls) == nbrOfSegments)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update 'DNAcopy' object
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # (a) segmentation table
  segs <- getSegments(fit, splitters=TRUE)
  segs$amplificationCall <- calls
  fit$output <- segs

  # (b) parameters
  allParams <- fit$params
  if (is.null(allParams)) {
    allParams <- list()
  }
  allParams$callAmplifications <- params
  fit$params <- allParams


  verbose && exit(verbose)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Return the updated 'CBS' object.
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fit
}, private=TRUE) # callAmplifications()



###########################################################################/**
# @RdocMethod callOutliers
#
# @title "Calls outliers"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{adjust}{A positive scale factor adjusting the sensitivity of the
#    caller, where a value less (greater) than 1.0 makes the caller
#    less (more) sensitive.}
#  \item{method}{A @character string specifying the calling algorithm to use.}
#  \item{...}{Additional/optional arguments used to override the default
#    parameters used by the caller.}
# }
#
# \value{
#  Returns a @see "PSCBS::CBS" object where @logical columns
#  'negOutlierCall' and 'posOutlierCall' have been appended
#  to the segmentation table.
# }
#
# \section{The UCSF caller}{
#   If \code{method == "ucsf-mad"}, then loci are called using [1]
#  "Finally, to identify single technical or biological outliers such
#   as high level amplifications, the presence of the outliers within
#   a segment was allowed by assigning the original observed log2ratio
#   to the clones for which the observed values were more than four
#   tumor-specific MAD away from the smoothed values." [1; Suppl. Mat.]
# }
#
# @author "HB"
#
# \references{
#   [1] Fridlyand et al. \emph{Breast tumor copy number aberration
#       phenotypes and genomic instability}, BMC Cancer, 2006. \cr
# }
#
# \seealso{
#   @seemethod "callGainsAndLosses".
#   @seemethod "callAmplifications".
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("callOutliers", "CBS", function(fit, adjust=1.0, method=c("ucsf-mad"), ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'adjust':
  adjust <- Arguments$getDouble(adjust, range=c(0, Inf))

  # Argument 'method':
  method <- match.arg(method)


  userArgs <- list(...)

  params <- list()

  # Allocate calls
  nbrOfLoci <- nbrOfLoci(fit)
  naValue <- NA
  negOutlierCall <- posOutlierCall <- rep(naValue, times=nbrOfLoci)

  if (method == "ucsf-mad") {
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Call arguments
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Default arguments
    args <- list(
      scale = 4.0
    )

    # Override by (optional) user-specified arguments
    for (key in names(userArgs)) {
      args[[key]] <- userArgs[[key]]
    }

    # Extract arguments
    scale <- args$scale

    # Validate arguments
    scale <- Arguments$getDouble(scale, range=c(0, Inf))


    # Genomic annotations
    data <- getLocusData(fit)
    chromosome <- data$chromosome
    x <- data$x

    # CN signals
    y <- data[,3]

    # Segmented CN signals
    yS <- extractSegmentMeansByLocus(fit)

    # CN residuals (relative to segment means)
    dy <- y - yS

    segs <- getSegments(fit, splitters=TRUE)

    # Allocate per-segment SD estimates
    nbrOfSegments <- nbrOfSegments(fit)
    naValue <- NA_real_
    sds <- rep(naValue, times=nbrOfSegments)

    naValue <- NA_real_
    for (ss in seq_len(nbrOfSegments)) {
      seg <- segs[ss,]

      # Identify loci in current segment
      idxs <- which(seg$chromosome == chromosome &
                    seg$start <= x & x <= seg$end)

      # Sanity check
      idxs <- Arguments$getIndices(idxs, max=nbrOfLoci)

      # Extract CN residuals
      dySS <- dy[idxs]

      # Calculate MAD for segment
      sdSS <- mad(dySS, na.rm=TRUE)

      # Threshold for outliers
      tau <- scale * sdSS

      # Make more or less sensitive
      tau <- adjust * tau

      # Call outliers
      naValue <- NA
      callsSS <- rep(naValue, times=length(dySS))
      callsSS[-tau <= dySS & dySS <= +tau] <- 0L
      callsSS[dySS > +tau] <- +1L
      callsSS[dySS < -tau] <- -1L

      # Record
      negOutlierCall[idxs] <- (callsSS < 0L)
      posOutlierCall[idxs] <- (callsSS > 0L)

      sds[ss] <- sdSS
    } # for (ss ...)

    params$method <- method
    params$adjust <- adjust
    params$scale <- scale
    params$sds <- sds
  }


  # Sanity check
  .stop_if_not(length(negOutlierCall) == nbrOfLoci)
  .stop_if_not(length(posOutlierCall) == nbrOfLoci)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update 'DNAcopy' object
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # (a) segmentation table
  data <- getLocusData(fit)
  data$negOutlierCall <- negOutlierCall
  data$posOutlierCall <- posOutlierCall
  fit$data <- data

  # (b) parameters
  allParams <- fit$params
  if (is.null(allParams)) {
    allParams <- list()
  }
  allParams$callOutliers <- params
  fit$params <- allParams


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Return the updated 'CBS' object.
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fit
}, private=TRUE) # callOutliers()



setMethodS3("extractCallsByLocus", "CBS", function(fit, ...) {
  # Extract locus data
  data <- getLocusData(fit, ...)

  nbrOfLoci <- nrow(data)

  # Extract segment data
  segs <- getSegments(fit, splitters=TRUE)

  # Identify segment calls
  callCols <- grep("Call$", colnames(segs))
  nbrOfCalls <- length(callCols)


  chromosome <- data$chromosome
  x <- data$x
  y <- data[,3]

  # Allocate locus calls
  naValue <- NA
  callsL <- matrix(naValue, nrow=nbrOfLoci, ncol=nbrOfCalls)
  colnames(callsL) <- colnames(segs)[callCols]
  callsL <- as.data.frame(callsL)

  # For each segment...
  for (ss in seq_len(nrow(segs))) {
    seg <- segs[ss,]
    idxs <- which(chromosome == seg$chromosome &
                  seg$start <= x & x <= seg$end)
    idxs <- Arguments$getIndices(idxs, max=nbrOfLoci)
    # Sanity check
##    .stop_if_not(length(idxs) == seg$nbrOfLoci)

    callsSS <- seg[callCols]
    for (cc in seq_len(nbrOfCalls)) {
      callsL[idxs,cc] <- callsSS[,cc]
    }
  } # for (ss ...)

  # The calls for loci that have missing annotations or observations,
  # should also be missing, i.e. NA.
  nok <- (is.na(chromosome) | is.na(x) | is.na(y))
  callsL[nok,] <- NA

  # Sanity check
  .stop_if_not(nrow(callsL) == nbrOfLoci)
  .stop_if_not(ncol(callsL) == nbrOfCalls)

  callsL
}, private=TRUE) # extractCallsByLocus()



###########################################################################/**
# @RdocMethod getCallStatistics
#
# @title "Calculates various call statistics per chromosome"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{regions}{An optional @data.frame with columns "chromosome",
#     "start", and "end" specifying the regions of interest to calculate
#     statistics for.  If @NULL, all of the genome is used.}
#  \item{shrinkRegions}{If @TRUE, regions are shrunk to the support of
#     the data.}
#  \item{...}{Not used.}
#  \item{verbose}{@see "R.utils::Verbose".}
# }
#
# \value{
#  Returns a CxK @data.frame, where C is the number of regions that
#  meet the criteria setup by argument \code{regions}
#  and (K-4)/2 is the number of call types.
#  The first column is the chromosome index, the second and the third
#  are the first and last position, and the fourth the length
#  (=last-first+1) of the chromosome.
#  The following columns contains call summaries per chromosome.
#  For each chromosome and call type, the total length of such calls
#  on that chromosome is reported together how large of a fraction
#  of the chromosome such calls occupy.
# }
#
# \details{
#   The estimators implemented here are based solely on the
#   segmentation results, which is very fast.
#   In the original proposal by Fridlyand et al. [1], the authors
#   estimates the parameters by converting segment-level calls back
#   to locus-level calls and there do the calculations.
#   The difference between the two approaches should be minor,
#   particularly for large density arrays.
# }
#
# @author "HB"
#
# \references{
#   [1] Fridlyand et al. \emph{Breast tumor copy number aberration
#       phenotypes and genomic instability}, BMC Cancer, 2006. \cr
# }
#
# \seealso{
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("getCallStatistics", "CBS", function(fit, regions=NULL, shrinkRegions=TRUE, ..., verbose=FALSE) {
  # To please R CMD check, cf. subset()
  chromosome <- NULL; rm(list="chromosome")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'regions':
  if (is.null(regions)) {
    # Get chromosome lengths
    regions <- getChromosomeRanges(fit)[,c("chromosome", "start", "end")]
  }
  regions <- as.data.frame(regions)
  .stop_if_not(all(is.element(c("chromosome", "start", "end"), colnames(regions))))
  .stop_if_not(!any(duplicated(regions$chromosome)))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Calculating call statistics")
  segs <- getSegments(fit, splitters=FALSE)
  callTypes <- grep("Call$", colnames(segs), value=TRUE)
  verbose && cat(verbose, "Call types: ", hpaste(callTypes))
  if (length(callTypes) == 0) {
    stop("Cannot calculate call statistics. No calls have been made.")
  }

  verbose && cat(verbose, "Regions of interest:")
  verbose && str(verbose, regions)


  verbose && enter(verbose, "Filtering out segments within the requested regions")

  # Filter out segments within the requested regions
  segsT <- NULL
  verbose && cat(verbose, "Number of segments (before): ", nrow(segs))

  for (rr in seq_len(nrow(regions))) {
    regionRR <- regions[rr,]
    chrRR <- regionRR[,"chromosome"]
    startRR <- regionRR[,"start"]
    endRR <- regionRR[,"end"]
    if (is.na(chrRR) || is.na(startRR) || is.na(endRR)) {
      next
    }

    verbose && enter(verbose, sprintf("Region #%d of %d", rr, nrow(regions)))

    # Select regions that (at least) overlapping with the region
    segsRR <- subset(segs, chromosome == chrRR & start <= endRR & end >= startRR)

    verbose && cat(verbose, "Number of segments within region: ", nrow(segsRR))

    # Special case
    if (nrow(segsRR) == 0) {
      segsRR <- segs[1,][NA,]
      segsRR$chromosome <- chrRR
      segsRR$start <- startRR
      segsRR$end <- endRR
      segsRR$nbrOfLoci <- 0L
    }

    if (shrinkRegions) {
      range <- range(c(segsRR$start, segsRR$end), na.rm=TRUE)
      startRR <- max(startRR, range[1], na.rm=TRUE)
      endRR <- min(endRR, range[2], na.rm=TRUE)
      regions[rr,"end"] <- endRR
      regions[rr,"start"] <- startRR
    }

    # Adjust ranges
    segsRR$start[segsRR$start < startRR] <- startRR
    segsRR$end[segsRR$end > endRR] <- endRR

    segsRR$fullLength <- endRR - startRR ## + 1L

    segsT <- rbind(segsT, segsRR)

    verbose && exit(verbose)
  } # for (rr ...)

  segs <- segsT

  # Order by chromosome
  o <- order(segs$chromosome)
  segs <- segs[o,]

  verbose && cat(verbose, "Number of segments (after): ", nrow(segs))
  verbose && str(verbose, segs)

  verbose && exit(verbose)


  verbose && enter(verbose, "Calculating total length per call and chromosome")
  # Sum length of calls per type and chromosome
  segs$length <- segs[,"end"] - segs[,"start"] ## + 1L
  res <- lapply(callTypes, FUN=function(type) {
    coeffs <- as.integer(segs[,type])
    lens <- coeffs * segs$length
    lens <- by(lens, INDICES=segs$chromosome, FUN=sum, na.rm=TRUE)
    as.vector(lens)
  })
  names(res) <- gsub("Call$", "Length", callTypes)
  res1 <- as.data.frame(res)
  verbose && str(verbose, res)
  verbose && exit(verbose)

  # Extract selected regions
  idxs <- match(unique(segs$chromosome), regions$chromosome)
  regionsT <- regions[idxs,]

  # Sanity check
  .stop_if_not(nrow(regionsT) == nrow(res1))


  verbose && enter(verbose, "Calculating fractions per region")
  # Calculate lengths
  regionsT$length <- regionsT[,"end"] - regionsT[,"start"] ## + 1L
  .stop_if_not(all(regionsT$length >= 0))

  res2 <- res1 / regionsT[,"length"]
  names(res2) <- gsub("Call$", "Fraction", callTypes)
  verbose && exit(verbose)

  res3 <- cbind(res1, res2)

  res <- regionsT
  if (nrow(res3) > 0) {
    res <- cbind(res, res3)
  }
  rownames(res) <- NULL

  res <- cbind(label=I(sprintf("chr%d", res[,"chromosome"])), res)

  # Sanity checks
  resT <- res[,grep("Fraction", colnames(res))]
  for (key in colnames(resT)) {
    rho <- resT[,key]
    .stop_if_not(all(rho >= 0, na.rm=TRUE))
    .stop_if_not(all(rho <= 1, na.rm=TRUE))
  }

  .stop_if_not(nrow(res) == nrow(regions))

  verbose && str(verbose, res)
  verbose && exit(verbose)

  res
}, protected=TRUE) # getCallStatistics()



###########################################################################/**
# @RdocMethod getFractionOfGenomeLost
# @aliasmethod getFractionOfGenomeGained
# @aliasmethod getFractionOfGenomeAltered
# @aliasmethod getFGL
# @aliasmethod getFGG
# @aliasmethod getFGA
#
# @title "Calculates the fraction of the genome lost, gained, or aberrant either way"
#
# \description{
#  @get "title" (in sense of total copy numbers),
#  using definitions closely related to those presented in [1].
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Not used.}
# }
#
# \value{
#  Returns a @double in [0,1].
# }
#
# @author "HB"
#
# \references{
#   [1] Fridlyand et al. \emph{Breast tumor copy number aberration
#       phenotypes and genomic instability}, BMC Cancer, 2006. \cr
# }
#
# \seealso{
#   Internally, @seemethod "getCallStatistics" is used.
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("getFractionOfGenomeLost", "CBS", function(fit, ...) {
  stats <- getCallStatistics(fit, ...)
  mean(stats$lossFraction, na.rm=TRUE)
}, protected=TRUE)

setMethodS3("getFractionOfGenomeGained", "CBS", function(fit, ...) {
  stats <- getCallStatistics(fit, ...)
  mean(stats$gainFraction, na.rm=TRUE)
}, protected=TRUE)

setMethodS3("getFractionOfGenomeAltered", "CBS", function(fit, ...) {
  getFractionOfGenomeLost(fit, ...) + getFractionOfGenomeGained(fit, ...)
}, protected=TRUE)

# Shortcuts
setMethodS3("getFGL", "CBS", function(fit, ...) {
  getFractionOfGenomeLost(fit, ...)
}, protected=TRUE)

setMethodS3("getFGG", "CBS", function(fit, ...) {
  getFractionOfGenomeGained(fit, ...)
}, protected=TRUE)

setMethodS3("getFGA", "CBS", function(fit, ...) {
  getFractionOfGenomeAltered(fit, ...)
}, protected=TRUE)




setMethodS3("isWholeChromosomeGained", "CBS", function(fit, minFraction=0.99, ...) {
  # Argument 'minFraction':
  minFraction <- Arguments$getDouble(minFraction, range=c(0,1))

  stats <- getCallStatistics(fit, ...)
  calls <- stats$gainFraction
  if (is.null(calls)) {
    return(rep(NA, times=nbrOfChromosomes(fit)))
  }

  res <- (calls >= minFraction)
  names(res) <- stats$chromosome
  attr(res, "minFraction") <- minFraction

  res
}, protected=TRUE) # isWholeChromosomeGained()


setMethodS3("isWholeChromosomeLost", "CBS", function(fit, minFraction=0.99, ...) {
  # Argument 'minFraction':
  minFraction <- Arguments$getDouble(minFraction, range=c(0,1))

  stats <- getCallStatistics(fit, ...)
  calls <- stats$lossFraction
  if (is.null(calls)) {
    return(rep(NA, times=nbrOfChromosomes(fit)))
  }

  res <- (calls >= minFraction)
  names(res) <- stats$chromosome
  attr(res, "minFraction") <- minFraction

  res
}, protected=TRUE) # isWholeChromosomeLost()


setMethodS3("nbrOfLosses", "CBS", function(fit, ...) {
  stats <- getSegments(fit, ...)
  calls <- stats$lossCall
  if (is.null(calls)) {
    return(NA_integer_)
  }
  sum(calls, na.rm=TRUE)
}, protected=TRUE)


setMethodS3("nbrOfGains", "CBS", function(fit, ...) {
  stats <- getSegments(fit, ...)
  calls <- stats$gainCall
  if (is.null(calls)) {
    return(NA_integer_)
  }
  sum(calls, na.rm=TRUE)
}, protected=TRUE)


setMethodS3("nbrOfAmplifications", "CBS", function(fit, ...) {
  stats <- getSegments(fit, ...)
  calls <- stats$amplificationCall
  if (is.null(calls)) {
    return(NA_integer_)
  }
  sum(calls, na.rm=TRUE)
}, protected=TRUE)


setMethodS3("getCallStatisticsByArms", "CBS", function(fit, genomeData, ...) {
  # To please/trick R CMD check
  chromosome <- x <- NULL; rm(list=c("chromosome", "x"))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'genomeData':
  genomeData <- as.data.frame(genomeData)



  # Subset 'regions' by chromosomes segmented
  keep <- is.element(genomeData$chromosome, getChromosomes(fit))
  genomeData <- genomeData[keep,]


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # p-arm
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  regions <- getChromosomeRanges(fit)
  regions$end <- genomeData$centroStart
  regions$start <- pmin(regions$start, regions$end)

  # Shrink regions
  for (rr in seq_len(nrow(regions))) {
    chr <- regions[rr,"chromosome"]
    x0 <- regions[rr,"start"]
    x1 <- regions[rr,"end"]
    xs <- subset(fit$data, chromosome == chr & x0 <= x & x <= x1)$x
    if (length(xs) > 0) {
      range <- range(xs, na.rm=TRUE)
      x0 <- max(c(x0, range[1]), na.rm=TRUE)
      x1 <- min(c(x1, range[2]), na.rm=TRUE)
      regions[rr,"start"] <- x0
      regions[rr,"end"] <- x1
    }
  } # for (rr ...)
  regions[,"length"] <- regions[,"end"] - regions[,"start"] ## + 1L
  callStats <- getCallStatistics(fit, regions=regions)
  callStats$label <- sprintf("%sp", callStats$label)
  callStatsP <- callStats


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # q-arm
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  regions <- getChromosomeRanges(fit)
  regions$start <- genomeData$centroEnd
  regions$end <- pmax(regions$end, regions$start)

  # Shrink regions
  for (rr in seq_len(nrow(regions))) {
    chr <- regions[rr,"chromosome"]
    x0 <- regions[rr,"start"]
    x1 <- regions[rr,"end"]
    xs <- subset(fit$data, chromosome == chr & x0 <= x & x <= x1)$x
    if (length(xs) > 0) {
      range <- range(xs, na.rm=TRUE)
      x0 <- max(c(x0, range[1]), na.rm=TRUE)
      x1 <- min(c(x1, range[2]), na.rm=TRUE)
      regions[rr,"start"] <- x0
      regions[rr,"end"] <- x1
    }
  } # for (rr ...)
  regions[,"length"] <- regions[,"end"] - regions[,"start"] ## + 1L

  callStats <- getCallStatistics(fit, regions=regions)
  callStats$label <- sprintf("%sq", callStats$label)
  callStatsQ <- callStats



  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Merge
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  callStats <- rbind(callStatsP, callStatsQ)

  # Not needed anymore
  regions <- callStatsP <- callStatsQ <- NULL

  # Reorder
  o <- order(callStats$chromosome, callStats$start)
  callStats <- callStats[o,]

  callStats
}, protected=TRUE) # getCallStatisticsByArms()


setMethodS3("callArms", "CBS", function(fit, genomeData, minFraction=0.95, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'minFraction':
  minFraction <- Arguments$getDouble(minFraction, range=c(0,1))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # p-arm
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  callStats <- getCallStatisticsByArms(fit, genomeData=genomeData)

  callTypes <- grep("Fraction", colnames(callStats), value=TRUE)
  callTypes <- gsub("Fraction", "", callTypes)

  keys <- sprintf("%sFraction", callTypes)
  rhos <- callStats[,keys]
  calls <- (rhos >= minFraction)
  colnames(calls) <- sprintf("%sCall", callTypes)

  callStats <- cbind(callStats, calls)

  callStats
}, protected=TRUE) # callArms()




###########################################################################/**
# @RdocMethod mergeNonCalledSegments
#
# @title "Merge neighboring segments that are not called"
#
# \description{
#   @get "title"
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Not used.}
#  \item{verbose}{@see "R.utils::Verbose".}
# }
#
# \value{
#   Returns an object of the same class
#   with the same of fewer number of segments.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("mergeNonCalledSegments", "CBS", function(fit, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Merging neighboring segments that are not called")

  # Identify call columns
  segs <- getSegments(fit, splitters=TRUE)
  keep <- grep("Call$", colnames(segs))
  nbrOfCalls <- length(keep)

  # Sanity check
  .stop_if_not(nbrOfCalls > 0)

  chromosomes <- getChromosomes(fit)
  fitList <- list()
  for (cc in seq_along(chromosomes)) {
    chromosome <- chromosomes[cc]
    verbose && enter(verbose, sprintf("Chromosome #%d ('%s') of %d", cc, chromosome, length(chromosomes)))


    fitCC <- extractChromosome(fit, chromosome=chromosome)
    n0 <- nbrOfSegments(fitCC)

    # Until no more neighboring non-called segments exists
    while (TRUE) {
      segs <- getSegments(fitCC, splitters=TRUE)
      calls <- as.matrix(segs[,keep])

      # Find two neighboring segments that are not called
      isCalled <- rowAnys(calls, na.rm=TRUE, useNames=FALSE)
      verbose && printf(verbose, "Number of segments not called: %d of %d\n", sum(!isCalled, na.rm=TRUE), length(isCalled))

      notCalled <- which(!isCalled)
      delta <- diff(notCalled)
      left <- notCalled[which(delta == 1)[1]]

      # No more segments to merge?
      if (is.na(left)) {
        break
      }

      fitCC <- mergeTwoSegments(fitCC, left=left)
    } # while (...)

    n1 <- nbrOfSegments(fitCC)
    verbose && printf(verbose, "Number of segments merged: %d of %d\n", n0-n1, n0)

    fitList[[cc]] <- fitCC
    verbose && exit(verbose)
  } # for (cc ...)

  verbose && enter(verbose, "Building result")
  res <- Reduce(append, fitList)
  verbose && exit(verbose)

  verbose && exit(verbose)

  res
}, protected=TRUE) # mergeNonCalledSegments()


setMethodS3("estimateDeltaCN", "CBS", function(fit, flavor=c("density(TCN)", "density(dTCN)", "dTCN"), adjust=0.3, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'flavor':
  flavor <- match.arg(flavor)

  # Argument 'adjust':
  adjust <- Arguments$getDouble(adjust, range=c(0,10))


  if (flavor == "density(TCN)") {
    # Get segment mean levels
    segs <- getSegments(fit, splitters=FALSE)
    x <- segs$mean
    w <- segs$nbrOfLoci

    # Drop missing values
    keep <- is.finite(x) & is.finite(w)
    x <- x[keep]
    w <- w[keep]
    keep <- NULL # Not needed anymore

    # Normalize weights
    w <- w / sum(w, na.rm=TRUE)

    # Estimate density
    d <- density(x, weights=w, adjust=adjust)

    w <- NULL # Not needed anymore

    # Find peaks
    pv <- findPeaksAndValleys(d, ...)
    type <- NULL; rm(list="type") # To please R CMD check
    p <- subset(pv, type == "peak")
    px <- p$x
    pw <- p$density

    # Distance between peaks
    dx <- diff(px)
    # Weights "between" peaks (AD HOC: sum up peak weights)
    dw <- pw[-length(pw)] + pw[-1L]

    deltaCN <- weighted.mean(dx, w=dw)
  } else if (flavor == "density(dTCN)") {
    # Get change-point magnitudes
    x <- getChangePoints(fit)[[1L]]
    x <- abs(x)

    # Drop missing values
    keep <- is.finite(x)
    x <- x[keep]
    keep <- NULL # Not needed anymore


    # Estimate density
    d <- density(x, adjust=adjust)

    # Find peaks
    pv <- findPeaksAndValleys(d, ...)
    type <- NULL; rm(list="type") # To please R CMD check
    p <- subset(pv, type == "peak")
    px <- p$x
    pw <- p$density

    # Distance between peaks
    dx <- diff(px)
    # Weights "between" peaks (AD HOC: sum up peak weights)
    dw <- pw[-length(pw)] + pw[-1L]

    stop("Still not implemented.")
  } else if (flavor == "dTCN") {
    # Get change-point magnitudes
    x <- getChangePoints(fit)[[1L]]
    x <- abs(x)

    # Drop missing values
    keep <- is.finite(x)
    x <- x[keep]
    keep <- NULL # Not needed anymore

    deltaCN <- median(x)
  }

  # Sanity check
  deltaCN <- Arguments$getDouble(deltaCN, range=c(0, Inf))

  deltaCN
}, protected=TRUE)



setMethodS3("encodeCalls", "data.frame", function(calls, flavor="UCSF", ...) {
  # Argument 'calls':
  .stop_if_not(all(is.element(c("chromosome", "x"), colnames(calls))))
  .stop_if_not(all(is.element(c("lossCall", "gainCall"), colnames(calls))))

  # Argument 'flavor':
  flavor <- match.arg(flavor)

  calls0 <- calls

  # Allocate
  calls <- rep(NA_real_, times=nrow(calls0))

  # Encode loss, neutral and gain (required)
  calls[!calls0$gainCall & !calls0$lossCall] <- 0
  calls[calls0$gainCall] <- +1
  calls[calls0$lossCall] <- -1

  # Encode amplifications, if any/called.
  idxs <- which(calls0$amplificationCall)
  calls[idxs] <- +9

  # Encode negative and positive outliers, if any/called.
  idxs <- which(calls0$negOutlierCall)
  calls[idxs] <- calls[idxs] - 0.1

  idxs <- which(calls0$posOutlierCall)
  calls[idxs] <- calls[idxs] + 0.1

  calls
}, protected=TRUE) # encodeCalls()


setMethodS3("callGLAO", "CBS", function(fit, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Call gains, losses, amplifications and (negative and positive) outliers")
  verbose && cat(verbose, "Number of segments: ", nbrOfSegments(fit))

  # Call segments
  fitC <- callGainsAndLosses(fit, ..., verbose=verbose)
  fitC <- callAmplifications(fitC, ..., verbose=verbose)

  # Call loci, i.e. locus-level negative and positive outliers
  fitC <- callOutliers(fitC, ..., verbose=verbose)
  verbose && print(verbose, fitC)

  verbose && exit(verbose)

  fitC
}, protected=TRUE) # callGLAO()

.use <- function(name, package, ..., mode = "function") {
  get(name, mode = mode, envir = getNamespace(package))
}


.onLoad <- function(libname, pkgname) {
  ## covr: skip=5
  ns <- getNamespace(pkgname)
  pkg <- Package(pkgname)
  # Assign '.PSCBS' object [since 'PSCBS' is a constructor/Class].
  name <- sprintf(".%s", pkgname)
  assign(name, pkg, envir = ns, inherits = FALSE)
}


.onAttach <- function(libname, pkgname) {
  # Copy some pre-memoized CBS-parameter calculations to the 'R.cache'
  # cache.  This speeds up the calculation for common CBS use cases.
  .prememoize()

  # Get '.PSCBS' object [since 'PSCBS' is a constructor/Class].
  name <- sprintf(".%s", pkgname)
  pkg <- get(name, envir = getNamespace(pkgname), inherits = FALSE)
  startupMessage(pkg)
}

setMethodS3("extractWIG", "AbstractCBS", function(fit, signal, transform=NULL, nbrOfDecimals=4L, label=toupper(signal), graphType=c("bar", "points", "line"), viewLimits=NULL, colors=c(negative="231,41,138", positive="117,112,179"), ...) {
  # Argument 'graphType':
  graphType <- match.arg(graphType)

  # Argument 'nbrOfDecimals':
  nbrOfDecimals <- Arguments$getInteger(nbrOfDecimals)

  data <- getSegments(fit, splitters=FALSE)
  fields <- c("chromosome", "start", "end", "mean")
  if (!is.null(signal)) {
    fields[-1] <- sprintf("%s%s", signal, capitalize(fields[-1]))
  }
  data <- data[,fields]
  colnames(data) <- c("chromosome", "start", "end", "mean")
  data$chromosome <- sprintf("chr%d", data$chromosome)

  ## Round / truncate
  for (ff in c("start", "end")) {
    data[[ff]] <- as.integer(round(data[[ff]], digits=0L))
  }

  # Transform mean levels?
  if (!is.null(transform)) {
    data[["mean"]] <- transform(data[["mean"]])
  }
  
  # Round mean levels
  if (!is.null(nbrOfDecimals)) {
    data[["mean"]] <- round(data[["mean"]], digits=nbrOfDecimals)
  }

  # Drop segments with missing values
  data <- na.omit(data)

  ## Track information
  track <- list(
    type="wiggle_0",
    name=sampleName(fit),
    description=sprintf("Data type: %s", class(fit)),
    graphType=graphType,
    visibility="full",
    maxHeightPixels="128:96:64",
    yLineOnOff="on",
    autoScale="true"
  )
  if (is.na(track$name)) track$name <- "Unknown sample"
  if (!is.null(signal)) track$name <- sprintf("%s [%s]", track$name, label)

  if (!is.null(viewLimits)) {
    track$viewLimits <- sprintf("%g:%g", viewLimits[1], viewLimits[2])
  }

  if (!is.null(colors)) {
    if (!is.null(names(colors))) colors <- colors[c("negative", "positive")]
    track$color <- colors[["negative"]]
    track$altColor <- colors[["positive"]]
  }

  attr(data, "track") <- track

  data
}, protected=TRUE)



setMethodS3("extractWIG", "CBS", function(fit, ..., colors=c(negative="231,41,138", positive="117,112,179")) {
  NextMethod("extractWIG", signal=NULL, colors=colors)
}, protected=TRUE)


setMethodS3("extractWIG", "PSCBS", function(fit, signal=c("tcn", "dh"), ..., colors=c(negative="231,41,138", positive="117,112,179")) {
  signal <- match.arg(signal)
  NextMethod("extractWIG", signal=signal, colors=colors)
}, protected=TRUE)


# \references{
#  [1] Wiggle Track Format (WIG), UCSC Genome Browser
#      \url{https://genome.ucsc.edu/goldenPath/help/wiggle.html}
# }
setMethodS3("writeWIG", "AbstractCBS", function(fit, name=getSampleName(fit), tags=NULL, ext="wig", path=NULL, overwrite=FALSE, skip=FALSE, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'name' and 'tags':
  name <- Arguments$getCharacter(name)
  tags <- Arguments$getCharacters(tags)

  # Argument 'ext':
  ext <- Arguments$getCharacter(ext)

  # Arguments 'path':
  path <- Arguments$getWritablePath(path)


  fullname <- paste(c(name, tags), collapse=",")
  filename <- sprintf("%s.%s", fullname, ext)
  pathname <- Arguments$getWritablePathname(filename, path=path, mustNotExist=(!overwrite && !skip))

  # File already exists?
  if (isFile(pathname)) {
    # Skip?
    if (skip) {
      return(pathname)
    }

    # Overwrite!
    file.remove(pathname)
  }

  ## Write file (atomically)
  pathnameT <- pushTemporaryFile(pathname)

  bed <- extractWIG(fit, ...)

  ## Generate 'track' definition line
  track <- attr(bed, "track")
  track <- lapply(track, FUN=function(value) {
    if (is.character(value)) value <- dQuote(value)
    value
  })
  track <- unlist(track, use.names=TRUE)
  track <- sprintf("%s=%s", names(track), track)
  track <- paste(track, collapse=" ")
  track <- sprintf("track %s", track)


  cat(track, "\n", sep="", file=pathnameT)
  write.table(bed, file=pathnameT,
              col.names=FALSE, row.names=FALSE, sep="\t", quote=FALSE,
              append=TRUE)

  pathname <- popTemporaryFile(pathnameT)

  pathname
})

library("PSCBS")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Simulating copy-number data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
set.seed(0xBEEF)

# Number of loci
J <- 1000

mu <- double(J)
mu[200:300] <- mu[200:300] + 1
mu[350:400] <- NA # centromere
mu[650:800] <- mu[650:800] - 1
eps <- rnorm(J, sd=1/2)
y <- mu + eps
x <- sort(runif(length(y), max=length(y))) * 1e5
w <- runif(J)
w[650:800] <- 0.001

## Create multiple chromosomes
data <- knownSegments <- list()
for (cc in 1:3) {
  data[[cc]] <- data.frame(chromosome=cc, y=y, x=x)
  knownSegments[[cc]] <- data.frame(
    chromosome=c(   cc,  cc,  cc),
    start     =x[c(  1, 350, 401)],
    end       =x[c(349, 400,   J)]
  )
}
data <- Reduce(rbind, data)
str(data)
knownSegments <- Reduce(rbind, knownSegments)
str(knownSegments)

message("*** segmentByCBS() via futures ...")


message("*** segmentByCBS() via futures with 'future' attached ...")
library("future")
oplan <- plan()

strategies <- c("sequential", "multiprocess")

## Test 'future.BatchJobs' futures?
pkg <- "future.BatchJobs"
if (require(pkg, character.only=TRUE)) {
  strategies <- c(strategies, "batchjobs_local")
}

message("Future strategies to test: ", paste(sQuote(strategies), collapse=", "))

fits <- list()
for (strategy in strategies) {
  message(sprintf("- segmentByCBS() using '%s' futures ...", strategy))
  plan(strategy)
  fit <- segmentByCBS(data, seed=0xBEEF, verbose=TRUE)
  fits[[strategy]] <- fit
  stopifnot(all.equal(fit, fits[[1]]))
}


message("*** segmentByCBS() via futures with known segments ...")
fits <- list()
dataT <- subset(data, chromosome == 1)
for (strategy in strategies) {
  message(sprintf("- segmentByCBS() w/ known segments using '%s' futures ...", strategy))
  plan(strategy)
  fit <- segmentByCBS(dataT, knownSegments=knownSegments, seed=0xBEEF, verbose=TRUE)
  fits[[strategy]] <- fit
  stopifnot(all.equal(fit, fits[[1]]))
}

message("*** segmentByCBS() via futures ... DONE")


## Cleanup
plan(oplan)
rm(list=c("fits", "dataT", "data", "fit"))

setMethodS3("shiftTCN", "PairedPSCBS", function(fit, shift, update=TRUE, ...) {
  # Argument 'shift':
  shift <- Arguments$getDouble(shift, disallow=c("NA", "NaN", "Inf"))

  data <- getLocusData(fit)
  data$CT <- data$CT + shift
  fit$data <- data
  # Not needed anymore
  data <- NULL

  if (update) {
    fit <- updateMeans(fit, ...)
  }

  fit
}, protected=TRUE)


setMethodS3("bootstrapCIs", "PairedPSCBS", function(fit, ...) {
  # ...
}, private=TRUE)


###########################################################################/**
# @set "class=PairedPSCBS"
# @RdocMethod extractTCNAndDHs
#
# @title "Extract TCN and DH mean levels per segment"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Arguments passed to \code{getSegments()}.}
# }
#
# \value{
#   Returns a @data.frame.
# }
#
# @author "HB"
#
# \seealso{
#   @seemethod "extractMinorMajorCNs".
#   @seeclass
# }
#*/###########################################################################
setMethodS3("extractTCNAndDHs", "PairedPSCBS", function(fit, ...) {
  segs <- getSegments(fit, ...)
  .stop_if_not(!is.null(segs))

  data <- segs[,c("tcnMean", "dhMean", "tcnNbrOfLoci", "dhNbrOfLoci"), drop=FALSE]
  data
}, protected=TRUE)



###########################################################################/**
# @set "class=PairedPSCBS"
# @RdocMethod extractMinorMajorCNs
# @aliasmethod extractC1C2
#
# @title "Extract minor and major copy-number mean levels per segment"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Not used.}
# }
#
# \value{
#   Returns a @data.frame.
# }
#
# @author "HB"
#
# \seealso{
#   @seemethod "extractTCNAndDHs"
#   @seeclass
# }
#*/###########################################################################
setMethodS3("extractMinorMajorCNs", "PairedPSCBS", function(fit, ...) {
  data <- extractTCNAndDHs(fit, ...)

  gamma <- data[,1L]
  rho <- data[,2L]
  C1 <- 1/2*(1-rho)*gamma
  C2 <- gamma - C1

  data[,1L] <- C1
  data[,2L] <- C2
  colnames(data)[1:2] <- c("C1", "C2")

  # Swap (C1,C2)?
  segs <- getSegments(fit, ...)
  flipped <- segs$c1c2Swap
  if (!is.null(flipped)) {
    idxs <- which(flipped)
    if (length(idxs) > 0L) {
      data[idxs,1:2] <- data[idxs,2:1]
    }
  }

  data
}, protected=TRUE)


setMethodS3("extractC1C2", "PairedPSCBS", function(...) {
  extractMinorMajorCNs(...)
}, protected=TRUE)


setMethodS3("extractCNs", "PairedPSCBS", function(fit, splitters=TRUE, ...) {
  data <- extractC1C2(fit, splitters=splitters, ...)
  data[,c("C1", "C2"), drop=FALSE]
})


setMethodS3("extractDeltaC1C2", "PairedPSCBS", function(...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  X <- extractC1C2(..., splitters=TRUE, addGaps=TRUE)

  # (C1,C2)
  C1C2 <- X[,1:2,drop=FALSE]

  # Number of TCN and DH data points
  counts <- X[,3:4, drop=FALSE]

  # Not needed anymore
  X <- NULL

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Calculate (dC1,dC2)
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # (dC1, dC2)
  dC1C2 <- colDiffs(C1C2, useNames = FALSE)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Change-point weights
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Region weights from DH counts
  w <- counts[,2,drop=TRUE]
  w <- sqrt(w)
  w <- w / sum(w, na.rm=TRUE)

  # (a) Smallest of the two flanking (DH) counts
  cpw <- cbind(w[1:(length(w)-1)], w[2:length(w)])
  cpw <- rowMins(cpw, na.rm=TRUE, useNames=FALSE)
  cpw[is.infinite(cpw)] <- NA
  cpw <- sqrt(cpw)
  cpwMin <- cpw / sum(cpw, na.rm=TRUE)

  # (b) Sum of region weights
  cpw <- w[1:(length(w)-1)] + w[2:length(w)]
  cpwAvg <- cpw / sum(cpw, na.rm=TRUE)

  cbind(dC1=dC1C2[,1], dC2=dC1C2[,2], wMin=cpwMin, wAvg=cpwAvg)
}, protected=TRUE)



setMethodS3("postsegmentTCN", "PairedPSCBS", function(fit, ..., force=FALSE, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Post-segmenting TCNs")

  flavor <- fit$params$flavor
  if (!force && regexpr("&", flavor, fixed=TRUE) != -1) {
    verbose && cat(verbose, "Nothing to do. Already postsegmentTCN:ed: ", flavor)
    verbose && exit(verbose)
    return(fit)
  }

  joinSegments <- fit$params$joinSegments
  if (!joinSegments) {
    stop("Postsegmentation of TCNs is only implemented for the case when joinSegments=TRUE: ", joinSegments)
  }


  # Get mean estimators
  estList <- getMeanEstimators(fit, "tcn")
  avgTCN <- estList$tcn


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the data and segmentation results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)

  segs <- getSegments(fit)
  keep <- is.finite(segs$chromosome)
  segs <- segs[keep,,drop=FALSE]
  tcnSegRows <- fit$tcnSegRows[keep,,drop=FALSE]
  dhSegRows <- fit$dhSegRows[keep,,drop=FALSE]

  # Sanity check
  .stop_if_not(nrow(dhSegRows) == nrow(tcnSegRows))
  .stop_if_not(all(tcnSegRows[,1] <= tcnSegRows[,2], na.rm=TRUE))
#  .stop_if_not(all(tcnSegRows[-nrow(tcnSegRows),2] < tcnSegRows[-1,1], na.rm=TRUE))
  .stop_if_not(all(dhSegRows[,1] <= dhSegRows[,2], na.rm=TRUE))
  .stop_if_not(all(dhSegRows[-nrow(dhSegRows),2] < dhSegRows[-1,1], na.rm=TRUE))


  nbrOfSegments <- nrow(segs)
  verbose && cat(verbose, "Number of segments: ", nbrOfSegments)

  chromosome <- data$chromosome
  x <- data$x
  CT <- data$CT
  muN <- data$muN
  rho <- data$rho
  hasDH <- !is.null(rho)
  if (hasDH) {
    isHet <- !is.na(rho)
    isSnp <- isHet
  } else {
    isSnp <- !is.na(muN)
    isHet <- (isSnp & (muN == 1/2))
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update the TCN segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  chromosomes <- getChromosomes(fit)
  nbrOfChromosomes <- length(chromosomes)
  verbose && cat(verbose, "Number of chromosomes: ", nbrOfChromosomes)
  verbose && print(verbose, chromosomes)

  for (cc in seq_len(nbrOfChromosomes)) {
    chr <- chromosomes[cc]
    chrTag <- sprintf("chr%02d", chr)
    verbose && enter(verbose, sprintf("Chromosome %d ('%s') of %d", cc, chrTag, nbrOfChromosomes))
    rows <- which(is.element(segs[["chromosome"]], chr))
    verbose && cat(verbose, "Rows:")
    verbose && print(verbose, rows)

    segsCC <- segs[rows,,drop=FALSE]
    tcnSegRowsCC <- tcnSegRows[rows,,drop=FALSE]
    dhSegRowsCC <- dhSegRows[rows,,drop=FALSE]
    nbrOfSegmentsCC <- nrow(segsCC)
    verbose && cat(verbose, "Number of segments: ", nbrOfSegmentsCC)

    tcnIds <- sort(unique(segsCC[["tcnId"]]))
    I <- length(tcnIds)
    for (ii in seq_len(I)) {
      tcnId <- tcnIds[ii]
      verbose && enter(verbose, sprintf("TCN segment #%d ('%s') of %d", ii, tcnId, I))

      rowsII <- which(segsCC[["tcnId"]] == tcnId)
      J <- length(rowsII)
      # Nothing todo?
      if (!force && J == 1) {
        verbose && cat(verbose, "Nothing todo. Only one DH segmentation. Skipping.")
        verbose && exit(verbose)
        next
      }

      verbose && cat(verbose, "Rows:")
      verbose && print(verbose, rowsII)
      segsII <- segsCC[rowsII,,drop=FALSE]

      tcnSegRowsII <- tcnSegRowsCC[rowsII,,drop=FALSE]
      dhSegRowsII <- dhSegRowsCC[rowsII,,drop=FALSE]

      verbose && cat(verbose, "TCN & DH segRows before:")
      verbose && print(verbose, cbind(tcn=tcnSegRowsII, dh=dhSegRowsII))

      segRowsRange <- range(c(tcnSegRowsII, dhSegRowsII), na.rm=TRUE)
      verbose && printf(verbose, "Range [%d,%d]\n",
                                    segRowsRange[1], segRowsRange[2])

      tcnSegRowsIIBefore <- tcnSegRowsII
      nbrOfTCNsBefore <- segsII[1,"tcnNbrOfLoci"]
      # Sanity check
      .stop_if_not(diff(segRowsRange)+1L == nbrOfTCNsBefore)

      for (jj in seq_len(J)) {
        verbose && enter(verbose, sprintf("DH segment #%d of %d", jj, J))
        seg <- segsII[jj,,drop=FALSE]
        tcnSegRow <- unlist(tcnSegRowsII[jj,,drop=FALSE], use.names=FALSE)
        dhSegRow <- unlist(dhSegRowsII[jj,,drop=FALSE], use.names=FALSE)
        # Sanity check
        .stop_if_not(all(is.na(tcnSegRow)) || (tcnSegRow[1] <= tcnSegRow[2]))
        .stop_if_not(all(is.na(dhSegRow)) || (dhSegRow[1] <= dhSegRow[2]))

        # Sanity check
        idxsTCN <- tcnSegRow[1]:tcnSegRow[2]
        nbrOfTCNs <- sum(!is.na(CT[idxsTCN]))
        .stop_if_not(nbrOfTCNs == nbrOfTCNsBefore)

        if (joinSegments) {
          # (a) The TCN segment should have identical (start,end) boundaries as the DH region
          xStart <- seg[["dhStart"]]
          xEnd <- seg[["dhEnd"]]
          verbose && printf(verbose, "[xStart,xEnd] = [%.0f,%.0f]\n", xStart, xEnd)
          .stop_if_not(xStart <= xEnd)

          # (b) Identify units
          units <- which(chromosome == chr & xStart <= x & x <= xEnd)

          # (c) Drop units that are outside both the TCN and DH segments
          keep <- (segRowsRange[1] <= units & units <= segRowsRange[2])
          units <- units[keep]

          tcnSegRow <- range(units)
          verbose && printf(verbose, "[idxStart,idxEnd] = [%d,%d]\n", tcnSegRow[1], tcnSegRow[2])
          verbose && cat(verbose, "Number of TCN loci: ", length(units))

          # (c) Adjust for missing values
          keep <- which(!is.na(CT[units]))
          units <- units[keep]

          # (d) Adjust for DH boundaries
          if (jj > 1L) {
            minIdx <- tcnSegRowsII[jj-1L,2L, drop=TRUE]
            units <- units[units > minIdx]
          }
          if (jj < J) {
            maxIdx <- dhSegRowsII[jj+1L,1L, drop=TRUE]
            units <- units[units < maxIdx]
          }

          if (jj == J) {
#           maxIdx <- dhSegRowsII[jj+1L,1L, drop=TRUE]
#           units <- units[units < maxIdx]
          }

          tcnSegRow <- range(units)
          verbose && printf(verbose, "[idxStart,idxEnd] = [%d,%d]\n", tcnSegRow[1], tcnSegRow[2])
          verbose && cat(verbose, "Number of non-missing TCN loci: ", length(units))
        } else {
          stop("Not implemented yet.")  # /HB 2010-12-02
        } # if (joinSegments)

        gamma <- avgTCN(CT[units])
        # Sanity check
        .stop_if_not(length(units) == 0 || !is.na(gamma))

        # Update the segment boundaries, estimates and counts
        seg[["tcnStart"]] <- xStart
        seg[["tcnEnd"]] <- xEnd
        seg[["tcnMean"]] <- gamma
        seg[["tcnNbrOfLoci"]] <- length(units)
        seg[["tcnNbrOfSNPs"]] <- sum(isSnp[units])
        seg[["tcnNbrOfHets"]] <- sum(isHet[units])

        # Sanity check
        .stop_if_not(nrow(seg) == length(jj))

        segsII[jj,] <- seg
        tcnSegRowsII[jj,] <- tcnSegRow

        verbose && exit(verbose)
      } # for (jj ...)

      # Sanity check
      .stop_if_not(nrow(segsII) == length(rowsII))

      verbose && cat(verbose, "TCN & DH segRows afterward:")
      verbose && print(verbose, cbind(tcn=tcnSegRowsII, dh=dhSegRowsII))

##print(segsII)

      # Sanity check
      nbrOfTCNsAfter <- sum(segsII[,"tcnNbrOfLoci"], na.rm=TRUE)
      verbose && cat(verbose, "Number of TCNs before: ", nbrOfTCNsBefore)
      verbose && cat(verbose, "Number of TCNs after: ", nbrOfTCNsAfter)
      .stop_if_not(nbrOfTCNsAfter >= nbrOfTCNsBefore)

      # Sanity check
      .stop_if_not(nrow(dhSegRowsII) == nrow(tcnSegRowsII))
      .stop_if_not(all(tcnSegRowsII[,1] <= tcnSegRowsII[,2], na.rm=TRUE))
      .stop_if_not(all(tcnSegRowsII[-nrow(tcnSegRowsII),2] < tcnSegRowsII[-1,1], na.rm=TRUE))
      .stop_if_not(all(dhSegRowsII[,1] <= dhSegRowsII[,2], na.rm=TRUE))
      .stop_if_not(all(dhSegRowsII[-nrow(dhSegRowsII),2] < dhSegRowsII[-1,1], na.rm=TRUE))

      segsCC[rowsII,] <- segsII
      tcnSegRowsCC[rowsII,] <- tcnSegRowsII

      # Not needed anymore
      rowsII <- segsII <- NULL
      verbose && exit(verbose)
    } # for (ii ...)

    # Sanity check
    .stop_if_not(nrow(segsCC) == length(rows))

    # Sanity check
    .stop_if_not(nrow(dhSegRowsCC) == nrow(tcnSegRowsCC))
    .stop_if_not(all(tcnSegRowsCC[,1] <= tcnSegRowsCC[,2], na.rm=TRUE))
####################
if (!all(tcnSegRowsCC[-nrow(tcnSegRowsCC),2] < tcnSegRowsCC[-1,1], na.rm=TRUE)) {

  aa <- tcnSegRowsCC[-nrow(tcnSegRowsCC),2]
  bb <- tcnSegRowsCC[-1,1]
  delta <- bb - aa
  dd <- cbind(aa, bb, delta=delta)
  print(dd)
  dd <- subset(dd, delta == 0)
  print(dd)
  row <- dd[,1L,drop=TRUE]
  print(row)
  rr <- row + -10:10
  dd <- data[rr,]
  rownames(dd) <- rr
  print(dd)
print(tcnSegRowsII)
}
####################

    .stop_if_not(all(tcnSegRowsCC[-nrow(tcnSegRowsCC),2] < tcnSegRowsCC[-1,1], na.rm=TRUE))
    .stop_if_not(all(dhSegRowsCC[,1] <= dhSegRowsCC[,2], na.rm=TRUE))
    .stop_if_not(all(dhSegRowsCC[-nrow(dhSegRowsCC),2] < dhSegRowsCC[-1,1], na.rm=TRUE))

    segs[rows,] <- segsCC
    tcnSegRows[rows,] <- tcnSegRowsCC

    # Not needed anymore
    rows <- segsCC <- NULL
    verbose && exit(verbose)
  } # for (cc ...)

  # Sanity check
  .stop_if_not(nrow(dhSegRows) == nrow(tcnSegRows))
  .stop_if_not(all(tcnSegRows[,1] <= tcnSegRows[,2], na.rm=TRUE))
  .stop_if_not(all(tcnSegRows[-nrow(tcnSegRows),2] < tcnSegRows[-1,1], na.rm=TRUE))
  .stop_if_not(all(dhSegRows[,1] <= dhSegRows[,2], na.rm=TRUE))
  .stop_if_not(all(dhSegRows[-nrow(dhSegRows),2] < dhSegRows[-1,1], na.rm=TRUE))

  verbose && enter(verbose, "Update (C1,C2) per segment")
  # Append (C1,C2) estimates
  tcn <- segs$tcnMean
  dh <- segs$dhMean
  C1 <- 1/2*(1-dh)*tcn
  C2 <- tcn - C1
  segs$c1Mean <- C1
  segs$c2Mean <- C2
  verbose && exit(verbose)

  # Return results
  keep <- which(is.finite(fit$output$chromosome))
  fitS <- fit
  fitS$data <- data
  fitS$output[keep,] <- segs
  fitS$tcnSegRows[keep,] <- tcnSegRows

  # Sanity check
  tcnSegRows <- fitS$tcnSegRows
  dhSegRows <- fitS$dhSegRows
  .stop_if_not(nrow(dhSegRows) == nrow(tcnSegRows))
  .stop_if_not(all(tcnSegRows[,1] <= tcnSegRows[,2], na.rm=TRUE))
  .stop_if_not(all(tcnSegRows[-nrow(tcnSegRows),2] < tcnSegRows[-1,1], na.rm=TRUE))
  .stop_if_not(all(dhSegRows[,1] <= dhSegRows[,2], na.rm=TRUE))
  .stop_if_not(all(dhSegRows[-nrow(dhSegRows),2] < dhSegRows[-1,1], na.rm=TRUE))

  # Update 'flavor'
  fitS$params$flavor <- gsub(",", "&", flavor, fixed=TRUE)

  verbose && exit(verbose)

  fitS
}, protected=TRUE) # postsegmentTCN()

setMethodS3("segmentByCBS", "CNA", function(y, ...) {
  # To please R CMD check
  cnData <- y

  # Extract signals of interest
  chromosome <- cnData$chrom
  x <- cnData$maploc
  y <- cnData[,3]
  signalType <- attr(cnData, "data.type")
  sampleName <- colnames(cnData)[3]

# str(list(y=y, chromosome=chromosome, x=x))

  fit <- segmentByCBS(y=y, chromosome=chromosome, x=x, ...)
  sampleName(fit) <- sampleName

  fit
}) # segmentByCBS()

###########################################################################/**
# @set "class=data.frame"
# @RdocMethod gapsToSegments
# @alias gapsToSegments
#
# @title "Gets the genomic segments that are complementary to the gaps"
#
# \description{
#  @get "title", with default chromosome boundaries being \code{-Inf}
#  and \code{+Inf}.
# }
#
# @synopsis
#
# \arguments{
#   \item{gaps}{A @data.frame with columns \code{chromosome}, \code{start},
#     and \code{stop}. Any overlapping gaps will throw an error.}
#   \item{resolution}{A non-negative @numeric specifying the minimum
#     length unit, which by default equals one nucleotide/base pair.}
#   \item{minLength}{Minimum length of segments to be kept.}
#   \item{dropGaps}{If @TRUE, the gaps themselves are not part of the output.}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns @data.frame of least one row with columns \code{chromosome}
#   if that argument is given), \code{start}, \code{stop} and \code{length}.
#   The segments are ordered along the genome.
# }
#
# @author "HB"
#
# \seealso{
#   @see "findLargeGaps".
# }
#
# @keyword IO
#*/###########################################################################
setMethodS3("gapsToSegments", "data.frame", function(gaps, resolution=1L, minLength=0L, dropGaps=FALSE, ...) {
  # To please R CMD check
  chromosome <- NULL; rm(list="chromosome")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'gaps':
  keys <- colnames(gaps)
  .stop_if_not(all(is.element(c("start", "end"), keys)))
  .stop_if_not(all(gaps$start <= gaps$end, na.rm=TRUE))
  hasChr <- is.element("chromosome", keys)

  ## Nothing more to do?
  if (nrow(gaps) == 0L) {
    knownSegments <- data.frame(chromosome=integer(1L), start=-Inf, end=+Inf)
    if (!hasChr) knownSegments$hromosome <- NULL
    return(knownSegments)
  }

  # Order gaps by the genome
  o <- order(gaps$chromosome, gaps$start, gaps$end)
  gaps <- gaps[o,]

  # For each chromosome...
  knownSegments <- NULL
  chromosomes <- sort(unique(gaps$chromosome))
  for (chr in chromosomes) {
    gapsCC <- subset(gaps, chromosome == chr)
    nCC <- nrow(gapsCC)

    starts <- gapsCC$start
    ends <- gapsCC$end

    # Assert that no overlapping gaps where specified
    if (!all(starts[-1] >= ends[-nCC], na.rm=TRUE)) {
      print(knownSegments)
      stop("INTERNAL ERROR: Detected overlapping gaps on chromosome ", chr, " in argument 'gaps'.")
    }

    # All boundaries in order
    # (this is possible because gaps are non-overlapping)
    naValue <- NA_real_
    if (dropGaps) {
      bps <- rep(naValue, times=2*nCC)
      bps[seq(from=1, to=2*nCC, by=2)] <- starts - resolution
      bps[seq(from=2, to=2*nCC, by=2)] <- ends + resolution
      bps <- c(-Inf, bps, +Inf)
      dim(bps) <- c(2L, nCC+1L)
    } else {
      bps <- rep(naValue, times=4*nCC)
      bps[seq(from=1, to=4*nCC, by=4)] <- starts - resolution
      bps[seq(from=2, to=4*nCC, by=4)] <- starts
      bps[seq(from=3, to=4*nCC, by=4)] <- ends
      bps[seq(from=4, to=4*nCC, by=4)] <- ends + resolution
      bps <- c(-Inf, bps, +Inf)
      dim(bps) <- c(2L, 2*nCC+1L)
    }

    knownSegmentsCC <- data.frame(chromosome=chr, start=bps[1L,], end=bps[2L,])

    knownSegments <- rbind(knownSegments, knownSegmentsCC)
  } # for (chr ...)

#  o <- with(knownSegments, order(chromosome, start, end))
#  knownSegments <- knownSegments[o,]
#  rownames(knownSegments) <- NULL

  # Append segment lengths
  knownSegments$length <- knownSegments$end - knownSegments$start

  # Drop too short segments
  keep <- (knownSegments$length >= minLength)
  knownSegments <- knownSegments[keep,]


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate generated 'knownSegments'
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  .stop_if_not(is.data.frame(knownSegments))
  .stop_if_not(nrow(knownSegments) >= 1L)
  for (chr in sort(unique(knownSegments$chromosome))) {
    dd <- subset(knownSegments, chromosome == chr)

    # Known segments must not overlap
    if (!all(dd$start[-1] >= dd$end[-nrow(dd)], na.rm=TRUE)) {
      stop("INTERNAL ERROR: Detected overlapping segments on chromosome ", chr, " in generated 'knownSegments'.")
    }
  }

  knownSegments
}) # gapsToSegments()

##########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod callLOH
#
# @title "Calls segments that are in LOH"
#
# \description{
#  @get "title", i.e. that have "zero" minor copy number.
# }
#
# @synopsis
#
# \arguments{
#   \item{flavor}{A @character string specifying which type of
#    call to use.}
#   \item{...}{Additional arguments passed to the caller.}
#   \item{minSize}{An optional @integer specifying the minimum number
#    of data points in order to call a segments.  If fewer data points,
#    then the call is set to @NA regardless.}
#   \item{xorCalls}{If @TRUE, a region already called AB, will
#    for consistency never be called LOH, resulting in either an LOH
#    call set to @FALSE or @NA (as explained below).}
#   \item{force}{If @FALSE, and allelic-balance calls already exits,
#    then nothing is done, otherwise the calls are done.}
# }
#
# \value{
#   Returns a @see "PairedPSCBS" object with LOH calls.
# }
#
# \section{AB and LOH consistency}{
#   Biologically, a segment can not be both in allelic balance (AB) and
#   in loss-of-heterozygosity (LOH) at the same time.
#   To avoid reporting such inconsistencies, the LOH caller will,
#   if argument \code{xorCalls=TRUE}, never report a segment to be in
#   LOH if it is already called to be in AB.
#   However, regardless of of the AB call, a segment is still always
#   tested for LOH, to check weather the LOH caller is consistent with the
#   AB caller or not.  Thus, in order to distinguish the case where
#   the AB caller and LOH caller agree from when they disagree,
#   we report either (AB,LOH)=(TRUE,FALSE) or (TRUE,NA).  The former is
#   reported when they are consistent, and the latter when they are not,
#   or when the LOH caller could not call it.
# }
#
# @author "HB"
#
# \seealso{
#   Internally, one of the following methods are used:
#   @seemethod "callLowC1ByC1",
#   @seemethod "callExtremeAllelicImbalanceByDH".
# }
#
#*/###########################################################################
setMethodS3("callLOH", "PairedPSCBS", function(fit, flavor=c("SmallC1", "LargeDH"), ..., minSize=1, xorCalls=TRUE, force=FALSE) {
  # Argument 'flavor':
  flavor <- match.arg(flavor)

  # Argument 'minSize':
  minSize <- Arguments$getDouble(minSize, range=c(1,Inf))

  # Argument 'xorCalls':
  xorCalls <- Arguments$getLogical(xorCalls)


  # Already done?
  segs <- as.data.frame(fit)
  calls <- segs$lohCall
  if (!force && !is.null(calls)) {
    return(invisible(fit))
  }


  if (flavor == "SmallC1") {
    fit <- callLowC1ByC1(fit, ..., callName="loh")
  } else if (flavor == "LargeDH") {
    fit <- callExtremeAllelicImbalanceByDH(fit, ..., callName="loh")
  } else {
    stop("Cannot call LOH. Unsupported flavor: ", flavor)
  }

  # Don't call segments with too few data points?
  if (minSize > 1) {
    segs <- as.data.frame(fit)
    ns <- segs$dhNbrOfLoci
    calls <- segs$lohCall
    calls[ns < minSize] <- NA
    segs$lohCall <- calls
    fit$output <- segs
    # Not needed anymore
    segs <- calls <- NULL
  }

  # Don't call a segment LOH if it already called AB?
  if (xorCalls) {
    segs <- as.data.frame(fit)
    if (is.element("abCall", names(segs))) {
      calls <- segs$lohCall
      otherCalls <- segs$abCall
      # If called (TRUE) and already called (TRUE)
      # by the other caller, call it as NA.
      calls[calls & otherCalls] <- NA
      segs$lohCall <- calls
      fit$output <- segs
    }
  }


  return(invisible(fit))
})



setMethodS3("callLowC1ByC1", "PairedPSCBS", function(fit, delta=estimateDeltaLOH(fit, flavor="minC1|nonAB"), alpha=0.05, ..., callName="lowc1", verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'delta':
  if (delta != -Inf) {
    delta <- Arguments$getDouble(delta, range=c(0,Inf))
  }

  # Argument 'alpha':
  alpha <- Arguments$getDouble(alpha, range=c(0,1))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Calling segments of allelic balance from one-sided DH bootstrap confidence intervals")

  verbose && cat(verbose, "delta (offset adjusting for bias in C1): ", delta)
  verbose && cat(verbose, "alpha (CI quantile; significance level): ", alpha)

  # Calculate C1 confidence intervals, if not already done
  probs <- c(alpha, 1-alpha)
  fit <- bootstrapTCNandDHByRegion(fit, probs=probs, ..., verbose=less(verbose, 50))

  segs <- as.data.frame(fit)

  # Extract confidence interval
  alphaTag <- sprintf("%g%%", 100*alpha)
  column <- sprintf("c1_%s", alphaTag)
  # Sanity checks
  .stop_if_not(is.element(column, colnames(segs)))

  # One-sided test
  verbose && enter(verbose, "Calling segments")
  value <- segs[,column, drop=TRUE]
  call <- (value < delta)
  nbrOfCalls <- sum(call, na.rm=TRUE)
  verbose && printf(verbose, "Number of segments called low C1 (LowC1, \"LOH_C1\"): %d (%.2f%%) of %d\n", nbrOfCalls, 100*nbrOfCalls/nrow(segs), nrow(segs))
  verbose && exit(verbose)

  key <- sprintf("%sCall", callName)
#  calls <- data.frame(lowc1Call=call)
#  colnames(calls) <- key
#  segs <- cbind(segs, calls)
  segs[[key]] <- call
  fit$output <- segs

  # Append 'delta' and 'alpha' to parameters
  params <- fit$params
  params$deltaLowC1 <- delta
  params$alphaLowC1 <- alpha
  fit$params <- params

  verbose && exit(verbose)

  fit
}, private=TRUE) # callLowC1ByC1()




setMethodS3("callExtremeAllelicImbalanceByDH", "PairedPSCBS", function(fit, delta=0.60, alpha=0.05, ..., callName="aiHigh", verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'delta':
  delta <- Arguments$getDouble(delta, range=c(0,Inf))

  # Argument 'alpha':
  alpha <- Arguments$getDouble(alpha, range=c(0,1))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Calling segments of extreme allelic imbalance (AI) from one-sided DH bootstrap confidence intervals")

  verbose && cat(verbose, "delta (offset adjusting for normal contamination and other biases): ", delta)
  verbose && cat(verbose, "alpha (CI quantile; significance level): ", alpha)


  # Calculate DH confidence intervalls, if not already done
  probs <- c(alpha, 1-alpha)
  fit <- bootstrapTCNandDHByRegion(fit, probs=probs, ..., verbose=less(verbose, 50))

  segs <- as.data.frame(fit)

  # Extract confidence interval
  alphaTag <- sprintf("%g%%", 100*alpha)
  column <- sprintf("dh_%s", alphaTag)
  # Sanity checks
  .stop_if_not(is.element(column, colnames(segs)))

  # One-sided test
  verbose && enter(verbose, "Calling segments")
  value <- segs[,column, drop=TRUE]
  call <- (value >= delta)
  nbrOfCalls <- sum(call, na.rm=TRUE)
  verbose && printf(verbose, "Number of segments called high allelic imbalance (AI/\"LOH_AI\"): %d (%.2f%%) of %d\n", nbrOfCalls, 100*nbrOfCalls/nrow(segs), nrow(segs))
  verbose && exit(verbose)

  key <- sprintf("%sCall", callName)
#  calls <- data.frame(aiHighCall=call)
#  colnames(calls) <- key
#  segs <- cbind(segs, calls)
  segs[[key]] <- call
  fit$output <- segs

  # Append 'delta' and 'alpha' to parameters
  params <- fit$params
  params$deltaExtremeDH <- delta
  params$alphaExtremeDH <- alpha
  fit$params <- params

  verbose && exit(verbose)

  fit
}, private=TRUE) # callExtremeAllelicImbalanceByDH()



##############################################################################
# HISTORY
# 2012-05-30
# o BUG FIX: callLOH(..., force=TRUE) would append multiple 'lohCall'
#   columns, if called multiple times.
# o BUG FIX: callLowC1ByC1() and callExtremeAllelicImbalanceByDH() would
#   append multiple call columns with the same name if called multiple times.
# 2012-01-15
# o DOCUMENTATION: Added details to the help of callLOH() and callAB() on
#   the difference between (AB,LOH)=(TRUE,FALSE) and (AB,LOH)=(TRUE,NA).
# 2011-06-14
# o Updated code to recognize new column names.
# 2011-05-29
# o Renamed all arguments, variables, function named 'tau' to 'delta'.
# 2011-04-14
# o BUG FIX: Argument 'minSize' of callAB() and callLOH() had no effect.
# 2011-04-12
# o Added argument 'minSize' to callLOH() for PairedPSCBS.
# o Added argument 'xorCalls' to callLOH() for PairedPSCBS.
# 2011-04-11
# o Added argument 'callName' to callExtremeAllelicImbalanceByDH() and
#   callLowC1ByC1().
# 2011-04-10
# o Added callLOH().
# 2010-12-07
# o Added callLowC1ByC1() and callABandLowC1().
# 2010-11-27
# o Corrected verbose output to call results.
# 2010-11-26 [HB]
# o Now all call functions estimate symmetric bootstrap quantiles for
#   convenince of plotting confidence intervals.
# o BUG FIX: callABandHighAI() for PairedPSCBS used the old DH-only
#   bootstrap method.
# o BUG FIX: The call functions, for instance callABandHighAI(), would throw
#   'Error in quantile.default(x, probs = alpha) : missing values and NaN's
#   not allowed if 'na.rm' is FALSE' unless bootstrapTCNandDHByRegion() was
#   run before.
# 2010-11-22 [HB]
# o Added more verbose output to callABandHighAI().
# o Updated callAllelicBalanceByDH() and callExtremeAllelicImbalanceByDH()
#   to utilize bootstrapTCNandDHByRegion().
# 2010-10-25 [HB]
# o Relaced argument 'ciRange' with 'alpha' for callAllelicBalanceByDH() and
#   callExtremeAllelicImbalanceByDH().
# o Renamed callAllelicBalance() to callAllelicBalanceByDH() and
#   callExtremeAllelicImbalanceByDH() to callExtremeAllelicImbalance().
# o Added arguments 'alphaAB' and 'alphaHighAI' to callABandHighAI().
# o Added sanity checks to the call methods.
# o Now arguments '...' to callABandHighAI() are passed down.
# o Now also arguments '...' to callAllelicBalance() and
#   callExtremeAllelicImbalance() are passed to bootstrapDHByRegion().
# o Added argument 'ciRange' to callAllelicBalance() and
#   callExtremeAllelicImbalance().
# 2010-09-16 [HB]
# o Added callABandHighAI().
# o Added callAllelicBalance() and callExtremeAllelicImbalance().
# o Created.
##############################################################################

###########################################################################/**
# @RdocDefault findLargeGaps
# @alias findLargeGaps.data.frame
#
# @title "Identifies gaps of a genome where there exist no observations"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{chromosome}{(Optional) An @integer @vector of length J of
#     chromosome indices.}
#   \item{x}{A @numeric @vector of J of genomic locations.}
#   \item{minLength}{A positive @numeric scalar specifying the minimum
#     length of a gap.}
#   \item{resolution}{A non-negative @numeric specifying the minimum
#     length unit, which by default equals one nucleotide/base pair.}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns @data.frame zero or more rows and with columns
#   \code{chromosome} (if given), \code{start}, \code{stop},
#   and \code{length}.
# }
#
# @author "HB"
#
# \seealso{
#   Use @see "gapsToSegments" to turn the set of identified gaps into
#   the complementary set of segments such that they can be passed
#   to @see "segmentByCBS", @see "segmentByPairedPSCBS" and
#   @see "segmentByNonPairedPSCBS" via argument \code{knownSegments}.
# }
#
# @keyword IO
#*/###########################################################################
setMethodS3("findLargeGaps", "default", function(chromosome=NULL, x, minLength, resolution=1L, ...) {
  # Argument 'x':
  x <- Arguments$getNumerics(x)
  nbrOfLoci <- length(x)

  # Argument 'chromosome':
  if (!is.null(chromosome)) {
    disallow <- c("Inf")
    chromosome <- Arguments$getIntegers(chromosome, range=c(0,Inf), disallow=disallow, length=c(nbrOfLoci, nbrOfLoci))
  }

  # Argument 'minLength':
  minLength <- Arguments$getNumeric(minLength, range=c(0,Inf))

  # Argument 'resolution':
  resolution <- Arguments$getNumeric(resolution, range=c(0,Inf))
  if (resolution >= minLength) {
    stop(sprintf("Cannot identify large gaps. Argument 'resolution' (=%g) is not strictly smaller than 'minLength' (=%g).", resolution, minLength))
  }

  if (!is.null(chromosome)) {
    allChromosomes <- sort(unique(chromosome))
    nbrOfChromosomes <-  length(allChromosomes)

    xEmpty <- vector(mode(x), length=0L)
    gaps <- data.frame(chromosome=integer(0L), start=xEmpty, end=xEmpty)
    for (cc in seq_along(allChromosomes)) {
      chr <- allChromosomes[cc]
      idxs <- which(chromosome == chr)
      chromosomeCC <- chromosome[idxs]
      xCC <- x[idxs]
      gapsCC <- findLargeGaps(chromosome=NULL, x=xCC, minLength=minLength, ...)
      if (nrow(gapsCC) > 0) {
        gapsCC <- cbind(chromosome=chr, gapsCC)
        gaps <- rbind(gaps, gapsCC)
      }
    } # for (cc ...)
  } else {
    x <- x[is.finite(x)]
    x <- sort(x)
    dx <- diff(x)

    isGap <- (dx >= minLength)
    idxsL <- which(isGap)
##str(list(x=x, dx=dx, isGap=isGap, idxsL=idxsL))
    xL <- x[idxsL]
    xR <- x[idxsL+1L]
##str(list(x=x, dx=dx, isGap=isGap, idxsL=idxsL, xL=xL, xR=xR))
    gaps <- data.frame(start=xL+resolution, end=xR-resolution)
    gaps$length <- gaps$end - gaps$start
  }

  ## Sanity checks
  .stop_if_not(is.data.frame(gaps))
  .stop_if_not(all(gaps$start <= gaps$end))
  .stop_if_not(all(gaps$length >= 0))

  gaps
}) # findLargeGaps()


setMethodS3("findLargeGaps", "data.frame", function(chromosome, ...) {
  data <- chromosome
  findLargeGaps(chromosome=data$chromosome, x=data$x, ...)
}) # findLargeGaps()

###########################################################################/**
# @RdocFunction randomSeed
#
# @title "Sets and resets the .Random.seed in the global environment"
#
# \description{
#  @get "title".
# }
#
# \usage{
#  @usage randomSeed
# }
#
# \arguments{
#   \item{action}{A @character string specifying the action.}
#   \item{seed}{Random seed to be set; only for \code{action="set"}.
#     If \code{length(seed) == 1}, then \code{set.seed(seed)} is
#     used, otherwise \code{.Random.seed} is assigned the value.}
#   \item{kind}{(optional) A @character string specifying type of
#     random number generator to use, cf. @see "base::RNGkind".}
#   \item{n}{Number of random seeds to generate by \code{action}.}
#   \item{backup}{If @TRUE, the previous (seed, kind) state is recorded
#     such that it can be reset later.}
# }
#
# \value{
#   Returns a \code{.Random.seed}.
#   If more than one is returned, the they are returned as a @list.
# }
#
# @author "HB"
#
# @keyword internal
#*/###########################################################################
randomSeed <- local({
  oldSeed <- NULL
  oldKind <- NULL
  lecuyerSeed <- NULL

  genv <- globalenv()

  getSeed <- function() {
    if (exists(".Random.seed", envir=genv, inherits=FALSE)) {
      get(".Random.seed", envir=genv, inherits=FALSE)
    } else {
      NULL
    }
  }

  setSeed <- function(seed, kind=NULL, backup=TRUE) {
    force(seed)  ## FIX: Why is this needed?

    ## Set new RNG kind?
    newKind <- (!is.null(kind) && !identical(kind, RNGkind()[1L]))
    if (newKind) {
       if (backup) {
         oldSeed <<- getSeed()
         oldKind <<- RNGkind()[1L]
       }
       RNGkind(kind)  ## Sets .Random.seed
    }

    ## Reset or set seed?
    if (is.null(seed)) {
      if (exists(".Random.seed", envir=genv, inherits=FALSE)) {
        rm(list=".Random.seed", envir=genv, inherits=FALSE)
        lecuyerSeed <<- NULL
      }
    } else {
      if (backup && !newKind) oldSeed <<- getSeed()

      if (length(seed) == 1L) {
        set.seed(seed)
        lecuyerSeed <<- getSeed()
      } else {
        assign(".Random.seed", seed, envir=genv, inherits=FALSE)
        lecuyerSeed <<- seed
      }
    }
  }

  advanceSeed <- function() {
    ## Nothing to do?
    if (RNGkind()[1L] != "L'Ecuyer-CMRG") return()

    if (is.null(lecuyerSeed)) {
      stats::runif(1)
      lecuyerSeed <<- getSeed()
    }

    lecuyerSeed <<- nextRNGStream(lecuyerSeed)
    assign(".Random.seed", lecuyerSeed, envir=genv, inherits=FALSE)
  }


  function(action=c("set", "advance", "reset", "get"), seed=NULL, kind=NULL, n=1L, backup=TRUE) {
    action <- match.arg(action)
    n <- as.integer(n)
    .stop_if_not(n >= 1)

    ## Record existing RNG kind (only once)
    if (is.null(oldKind)) oldKind <<- RNGkind()[1L]

    if (action == "set") {
      setSeed(seed=seed, kind=kind, backup=backup)
    } else if (action == "advance") {
      seeds <- list()
      for (kk in seq_len(n)) {
        advanceSeed()
        seeds[[kk]] <- getSeed()
      }
      if (n == 1) seeds <- seeds[[1]]
      return(seeds)
    } else if (action == "reset") {
      setSeed(seed=oldSeed, kind=oldKind, backup=FALSE)
    } else if (action == "get") {
      return(getSeed())
    }

    invisible(getSeed())
  }
}) # randomSeed()

setMethodS3("plotTracks2", "PairedPSCBS", function(x, panels=NULL, calls=".*", pch=".", col=NULL, cex=1, lwd=2, changepoints=FALSE, grid=FALSE, quantiles=c(0.05,0.95), xlim=NULL, Clim=c(0,3*ploidy(x)), Blim=c(0,1), xScale=1e-6, ..., add=FALSE, subplots=!add && (length(panels) > 1), verbose=FALSE) {

  # To please R CMD check
  fit <- x

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'fit':
  if (nbrOfChromosomes(fit) > 1) {
    stop("Multiple chromosomes detected. Not yet implemented.")
  }

  # Argument 'panels':
  panels <- unique(panels)
  panelsOrg <- panels
  panels <- gsub("[-*]", "", panelsOrg)
  knownPanels <- c("tcn", "tcn,c1,c2", "tcn,c1", "tcn,c2", "c1,c2", "c1", "c2", "dh", "betaN", "betaT", "betaTN")
  panels <- match.arg(panels, choices=knownPanels, several.ok=TRUE)
  panels <- panelsOrg

  # Argument 'calls':
  if (!is.null(calls)) {
    calls <- sapply(calls, FUN=Arguments$getRegularExpression)
  }

  # Argument 'changepoints':
  changepoints <- Arguments$getLogical(changepoints)

  # Argument 'grid':
  grid <- Arguments$getLogical(grid)

  # Argument 'xlim':
  if (!is.null(xlim)) {
    xlim <- Arguments$getNumerics(xlim, length=c(2,2))
  }

  # Argument 'xScale':
  xScale <- Arguments$getNumeric(xScale, range=c(0,Inf))

  # Argument 'add':
  add <- Arguments$getLogical(add)

  # Argument 'Clim':
  if (!add) {
    Clim <- Arguments$getNumerics(Clim, length=c(2L,2L),
                                        disallow=c("Inf", "NA", "NaN"))
  }

  # Argument 'subplots':
  subplots <- Arguments$getLogical(subplots)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Plotting PSCN panels")

  # Extract the input data
  data <- getLocusData(fit)
  if (is.null(data)) {
    stop("Cannot plot segmentation results. No input data available.")
  }

  chromosomes <- getChromosomes(fit)
  chromosome <- chromosomes[1]
  x <- data$x
  CT <- data$CT
  rho <- data$rho
  betaT <- data$betaT
  betaN <- data$betaN
  betaTN <- data$betaTN
  muN <- data$muN
  rho <- data$rho
  hasDH <- !is.null(rho)
  if (hasDH) {
    isHet <- !is.na(rho)
    isSnp <- isHet
  } else {
    isSnp <- (!is.na(betaTN) & !is.na(muN))
    isHet <- isSnp & (muN == 1/2)
  }
  nbrOfLoci <- length(x)

  # BACKWARD COMPATIBILITY:
  # If 'rho' is not available, recalculate it from tumor BAFs.
  # NOTE: This should throw an error in the future. /HB 2013-10-25
  if (!hasDH) {
    rho <- rep(NA_real_, times=nbrOfLoci)
    rho[isHet] <- 2*abs(betaTN[isHet]-1/2)
    warning(sprintf("Locus-level DH signals ('rho') were not available in the %s object and therefore recalculated from the TumorBoost-normalized tumor BAFs ('betaTN').", class(fit)[1L]))
  }

  # Extract the segmentation
  segs <- as.data.frame(fit)

  # Identify available calls
  if (!is.null(calls)) {
    verbose && enter(verbose, "Identifying calls")

    pattern <- "Call$"
    callColumns <- grep(pattern, colnames(segs), value=TRUE)
    if (length(callColumns) > 0) {
      keep <- sapply(calls, FUN=function(pattern) {
        (regexpr(pattern, callColumns) != -1)
      })
      if (is.matrix(keep)) {
        keep <- rowAnys(keep, useNames=FALSE)
      }
      callColumns <- callColumns[keep]
      callLabels <- gsub(pattern, "", callColumns)
      callLabels <- toupper(callLabels)
    }
    verbose && cat(verbose, "Call columns:")
    verbose && print(verbose, callColumns)

    verbose && exit(verbose)
  } else {
    callColumns <- NULL
  }

  if (chromosome != 0) {
    chrTag <- sprintf("Chr%02d", chromosome)
  } else {
    chrTag <- ""
  }

  if (xScale != 1) {
    x <- xScale * x
    if (is.null(xlim)) {
      xlim <- range(x, na.rm=TRUE)
    } else {
      xlim <- xScale * xlim
    }
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Number of panels?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfPanels <- length(panels)
  if (subplots) {
    subplots(nbrOfPanels, ncol=1)
    par(mar=c(1,4,1,2)+1)
  }

  # Color loci by genotype
  if (hasDH) {
    colMu <- c("gray", "black")[!is.na(rho) + 1]
  } else {
    colMu <- c("gray", "black")[(muN == 1/2) + 1]
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # For each panel...
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  for (pp in seq_len(nbrOfPanels)) {
    panel <- panels[pp]
    verbose && enter(verbose, sprintf("Panel #%d ('%s') of %d",
                                             pp, panel, length(panels)))


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Setup empty plot
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    if (!add) {
      verbose && enter(verbose, "Creating empty plot")

      tracks <- strsplit(panel, split=",", fixed=TRUE)[[1]]
      tracks <- gsub("[-*]", "", tracks)

      # Defaults
      ylim <- Clim
      ylab <- paste(toupper(tracks), collapse=", ")

      if (any(is.element(c("betaN", "betaT", "betaTN", "dh"), tracks))) {
        ylim <- Blim
      }

      verbose && cat(verbose, "ylim:")
      verbose && print(verbose, ylim)

      plot(NA, xlim=xlim, ylim=ylim, ylab=ylab)

      # Geometrical annotations
      stext(side=3, pos=1, chrTag)
      if (grid) {
        abline(h=seq(from=0, to=ylim[2], by=2), lty=3, col="gray")
        abline(h=0, lty=1, col="black")
      }

      verbose && exit(verbose)
    }


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Scatter tracks
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    tracks <- strsplit(panel, split=",", fixed=TRUE)[[1]]
    keep <- grep("-", tracks, fixed=TRUE, invert=TRUE)
    tracks <- tracks[keep]

    verbose && cat(verbose, "Number tracks with scatter: ", length(tracks))
    verbose && cat(verbose, "Tracks with scatter:")
    verbose && print(verbose, tracks)
    nbrOfTracks <- length(tracks)

    for (tt in seq_len(nbrOfTracks)) {
      track <- tracks[tt]
      verbose && enter(verbose, sprintf("Scatter track #%d ('%s') of %d",
                                                tt, track, nbrOfTracks))
      track <- gsub("[-*]", "", track)

      # Defaults
      colT <- if (is.null(col)) "black" else col

      if (track == "tcn") {
        y <- CT
      } else if (track == "c1") {
        y <- 1/2*(1-rho)*CT
      } else if (track == "c2") {
        y <- 1/2*(1+rho)*CT
      } else if (track == "betaN") {
        y <- betaN
        colT <- if (is.null(col)) colMu else col
        ylab <- expression(BAF[N])
        ylim <- Blim
      } else if (track == "betaT") {
        y <- betaT
        colT <- if (is.null(col)) colMu else col
        ylab <- expression(BAF[T])
        ylim <- Blim
      } else if (track == "betaTN") {
        y <- betaTN
        colT <- if (is.null(col)) colMu else col
        ylab <- expression(BAF[T]^"*")
        ylim <- Blim
      } else if (track == "dh") {
        y <- rho
        colT <- if (is.null(col)) colMu[isHet] else col
        ylab <- "DH"
        ylim <- Blim
      } else {
        y <- NULL
      }

      # Nothing to do?
      if (!is.null(y)) {
        points(x, y, pch=pch, cex=cex, col=colT)
      }

      verbose && exit(verbose)
    } # for (tt ...)


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Segment tracks
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    tracks <- strsplit(panel, split=",", fixed=TRUE)[[1]]
    keep <- grep("*", tracks, fixed=TRUE)
    tracks <- gsub("[-*]", "", tracks[keep])

    # Keep only supported tracks
    tracksWithLevels <- c("tcn", "betaTN", "c1", "c2", "dh")
    .stop_if_not(all(is.element(tracks, tracksWithLevels)))
    tracks <- intersect(tracks, tracksWithLevels)

    verbose && cat(verbose, "Number tracks with levels: ", length(tracks))
    verbose && cat(verbose, "Tracks with levels:")
    verbose && print(verbose, tracks)
    nbrOfTracks <- length(tracks)

    for (tt in seq_len(nbrOfTracks)) {
      track <- tracks[tt]
      verbose && enter(verbose, sprintf("Level track #%d ('%s') of %d",
                                                 tt, track, nbrOfTracks))

      if (track == "tcn") {
        colT <- "purple"
      } else if (track == "c1") {
        colT <- "blue"
      } else if (track == "c2") {
        colT <- "red"
      } else if (track == "betaTN") {
        colT <- "orange"
      } else if (track == "dh") {
        colT <- "orange"
      } else {
        colT <- if (is.null(col)) "black" else col
      }

      # Nothing to do?
      if (track != "betaTN") {
        drawConfidenceBands(fit, what=track, quantiles=quantiles,

                        col=colT, xScale=xScale)
      }
      drawLevels(fit, what=track, col=colT, lwd=lwd, xScale=xScale)

      verbose && exit(verbose)
    } # for (tt ...)


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Draw change points?
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    if (changepoints) {
      segs <- as.data.frame(fit)
      xStarts <- segs[,"tcnStart"]
      xEnds <- segs[,"tcnEnd"]
      xs <- sort(unique(c(xStarts, xEnds)))
      abline(v=xScale*xs, lty=1, col="gray")
    }


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # For each panel of tracks, annotate with calls?
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    if (length(callColumns) > 0) {
      for (cc in seq_along(callColumns)) {
        callColumn <- callColumns[cc]
        callLabel <- callLabels[cc]
        verbose && enter(verbose, sprintf("Call #%d ('%s') of %d",
                                      cc, callLabel, length(callColumns)))

        verbose && cat(verbose, "Column: ", callColumn)

        segsT <- segs[,c("dhStart", "dhEnd", callColumn)]
        isCalled <- which(segsT[[callColumn]])
        segsT <- segsT[isCalled,1:2,drop=FALSE]
        verbose && printf(verbose, "Number of segments called %s: %d\n",
                                                  callLabel, nrow(segsT))
        segsT <- xScale * segsT

        verbose && str(verbose, segsT)

        side <- 2*((cc+1) %% 2) + 1
        # For each segment called...
        for (ss in seq_len(nrow(segsT))) {
          x0 <- segsT[ss,1,drop=TRUE]
          x1 <- segsT[ss,2,drop=TRUE]
          abline(v=c(x0,x1), lty=3, col="gray")
          xMid <- (x0+x1)/2
          mtext(side=side, at=xMid, line=-1, cex=0.7, col="#666666", callLabel)
        } # for (ss in ...)
        verbose && exit(verbose)
      } # for (cc in ...)
    } # if (length(callColumns) > 0)

    verbose && exit(verbose)
  } # for (pp ...)

  verbose && exit(verbose)

  invisible()
}, protected=TRUE) # plotTracks2()

###########################################################################/**
# @set class=AbstractCBS
# @RdocMethod report
#
# @title "Generates a report of the segmentation results"
#
# \description{
#  @get "title".
#  Currently reports can be generated for segmentation results of class
#  @see "CBS" and @see "PairedPSCBS".
# }
#
# @synopsis
#
# \arguments{
#   \item{fit}{An @see "AbstractCBS" object.}
#   \item{sampleName}{A @character string specifying the name of the
#      sample segmented.}
#   \item{studyName}{A @character string specifying the name of study/project.}
#   \item{...}{Optional arguments passed to the RSP template.}
#   \item{rspTags}{Optional @character @vector of tags for further specifying
#      which RSP report to generate.}
#   \item{rootPath}{The root directory where to write the report.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns the pathname of the generated PDF.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("report", "AbstractCBS", function(fit, sampleName=getSampleName(fit), studyName, ..., rspTags=NULL, rootPath="reports/", .filename="*", skip=TRUE, envir=new.env(), verbose=FALSE) {
  use("R.rsp (>= 0.20.0)")


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'sampleName':
  sampleName <- Arguments$getCharacter(sampleName)
  if (is.na(sampleName)) {
    stop("Cannot generate report. Argument 'sampleName' is non-valid or missing.")
  }

  # Argument 'studyName':
  if (missing(studyName)) {
    stop("Cannot generate report. Argument 'studyName' is missing.")
  }
  studyName <- Arguments$getCharacter(studyName)
  if (is.na(studyName)) {
    stop("Cannot generate report. Argument 'studyName' is non-valid.")
  }

  # Argument 'rspTags':
  if (!is.null(rspTags)) {
    rspTags <- Arguments$getCharacters(rspTags)
    rspTags <- unlist(strsplit(rspTags, split=",", fixed=TRUE))
    rspTags <- rspTags[nchar(rspTags) > 0L]
  }

  # Argument 'rootPath':
  rootPath <- Arguments$getWritablePath(rootPath)

  # Argument '.filename':
  if (!is.null(.filename)) {
    .filename <- Arguments$getCharacter(.filename, useNames=TRUE)
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Generating CBS report")

  verbose && cat(verbose, "Sample name: ", sampleName)
  verbose && cat(verbose, "Number of chromosomes: ", nbrOfChromosomes(fit))
  verbose && cat(verbose, "Number of segments: ", nbrOfSegments(fit))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Report template arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Default arguments
  rspArgs <- list(
    fit = fit,
    sampleName = sampleName,
    studyName = studyName,
    dataSet = NULL,
    Clim = c(0,2*ploidy(fit)),
    Blim = c(0,1),
    figForce = FALSE
  )

  # Override with user arguments
  userArgs <- list(...)
  for (key in names(userArgs)) {
    rspArgs[[key]] <- userArgs[[key]]
  }

  if (is.null(rspArgs$reportPath)) {
    rspArgs$reportPath <- file.path(rootPath, rspArgs$studyName)
  }
  rspArgs$reportPath <- Arguments$getWritablePath(rspArgs$reportPath)
  verbose && cat(verbose, "Report root path: ", rspArgs$reportPath)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Linking to report files
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Linking to report files")

  # Directory where all report templates lives
  srcPath <- "templates"

  # If missing, default to one that comes with PSCBS/templates/
  if (!isDirectory(srcPath)) {
    srcPath <- system.file("templates", package="PSCBS")
  }
  srcPath <- file.path(srcPath, "rsp")
  srcPath <- Arguments$getReadablePath(srcPath)
  verbose && cat(verbose, "Source path: ", srcPath)

  filename <- .filename


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Create file links to the main RSP report template
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Main RSP template")

  # Construct the filename of the main RSP file to compile, iff missing.
  if (filename == "*") {
    className <- class(fit)[1]
    fullname <- paste(c(className, rspTags), collapse=",")
    filename <- sprintf("%s,report.tex.rsp", fullname)
  }

  rspPathname <- file.path(srcPath, filename)
  verbose && cat(verbose, "RSP report template: ", rspPathname)
  rspPathname <- Arguments$getReadablePathname(rspPathname)

  destFilename <- sprintf("%s,%s", sampleName, filename)
  destPathname <- filePath(rspArgs$reportPath, destFilename)
  target <- rspPathname
  link <- destPathname
  if (!isFile(link)) {
    verbose && cat(verbose, "Adding link: ", link, " -> ", target)
    createLink(link=link, target=target)
  }
  # Sanity check
  .stop_if_not(isFile(link))

  verbose && exit(verbose)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Skip?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (skip) {
    ## Try to guess report filename
    filename <- basename(destPathname)
    filename <- gsub("[.]rsp$", "", filename)
    ext <- gsub(".*[.]", "", filename)
    fullname <- gsub(sprintf("[.]%s$", ext), "", filename)
    ext <- switch(ext, tex="pdf", md="html", ext)
    filename <- sprintf("%s.%s", fullname, ext)
    pathname <- file.path(rspArgs$reportPath, filename)
    pathname <- getAbsolutePath(pathname)
    verbose && cat(verbose, "Expected output pathname: ", pathname)
    if (isFile(pathname)) {
      verbose && cat(verbose, "Already exists: Skipping.")
      report <- R.rsp::RspFileProduct(pathname)
      return(report)
    }
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Create file links to all LaTeX include files
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "All LaTeX files")

  files <- list.files(path=srcPath, pattern="[.](bib|bst|cls|sty|tex)$", full.names=TRUE, recursive=FALSE)
  files <- files[file_test("-f", files)]
  if (length(files) > 0L) {
    verbose && cat(verbose, "Number of such files found: ", length(files))
    verbose && print(verbose, files)

    for (kk in seq_along(files)) {
      target <- files[kk]
      link <- filePath(rspArgs$reportPath, basename(files[kk]))
      if (!isFile(link)) {
        verbose && cat(verbose, "Adding link: ", link, " -> ", target)
        createLink(link=link, target=target)
      }
      # Sanity check
      .stop_if_not(isFile(link))
    }
  } else {
    verbose && cat(verbose, "No such files found.")
  }

  verbose && exit(verbose)



  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Create file links to all 'incl.*' subdirectories
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "All 'incl.*' subdirectories")

  dirs <- list.files(srcPath, pattern="^incl", full.names=TRUE, recursive=FALSE)
  dirs <- dirs[file_test("-d", dirs)]

  if (length(dirs) > 0L) {
    verbose && cat(verbose, "Number of such directories found: ", length(dirs))
    verbose && print(verbose, dirs)

    for (kk in seq_along(dirs)) {
      target <- dirs[kk]
      link <- filePath(rspArgs$reportPath, basename(dirs[kk]))
      if (!isDirectory(link)) {
        verbose && cat(verbose, "Adding link: ", link, " -> ", target)
        createLink(link=link, target=target)
      }
      # Sanity check
      .stop_if_not(isDirectory(link))
    }
  } else {
    verbose && cat(verbose, "No such directories found.")
  }

  verbose && exit(verbose)


  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Build reports
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Processing RSP template")
  rspArgs$figPath <- "figures/"
  args <- c(list(rspArgs=rspArgs), rspArgs)
  report <- R.rsp::rfile(destPathname, workdir=rspArgs$reportPath, args=args, envir=envir, verbose=verbose)
  verbose && exit(verbose)

  verbose && cat(verbose, "Final report: ", getRelativePath(report))

  verbose && exit(verbose)

  report
}, protected=TRUE)

############################################################################/**
# @RdocDefault weightedQuantile
#
# @title "Weighted Quantile Value"
#
# @synopsis
#
# \description{
#   Computes a weighted quantile of a numeric vector.
# }
#
# \arguments{
#   \item{x}{a @numeric @vector containing the values whose weighted
#            quantile is to be computed.}
#   \item{w}{a numeric @vector of weights the same length as
#            \code{x} giving the weights to use for each element of \code{x}.
#            Negative weights are treated as zero weights.
#            Default value is equal weight to all values.}
#   \item{probs}{a @numeric @vector of quantiles in [0,1] to be retrieved.}
#   \item{na.rm}{a @logical value indicating whether @NA values in
#            \code{x} should be stripped before the computation proceeds,
#            or not.}
#   \item{method}{If \code{"wtd.quantile"}, then an internal copy of
#            \code{Hmisc::wtd.quantile()} is used.
#            No other methods are currently supported.}
#   \item{...}{Additional arguments passed to the estimator.}
# }
#
# \value{
#   Returns the weighted quantile.
# }
#
# @author "HB"
#
# \seealso{
#   Internally the following functions may be used:
#   @see "stats::quantile" (if no weights are specified), or an internal
#   copy of \code{Hmisc::wtd.quantile()}.
#   For a weighted median estimator, @see "matrixStats::weightedMedian"
#   of the \pkg{matrixStats} package.
# }
#
# @keyword univar
# @keyword robust
# @keyword internal
#*/############################################################################
setMethodS3("weightedQuantile", "default", function(x, w, probs=c(0, 0.25, 0.5, 0.75, 1), na.rm=TRUE, method=c("wtd.quantile"), ...) {
  # Argument 'x':
  x <- Arguments$getNumerics(x)

  # Argument 'w':
  if (missing(w)) {
    # By default use weights that are one.
    w <- rep(1, times=length(x))
  } else {
    w <- Arguments$getNumerics(w, range=c(0,Inf), length=rep(length(x), times=2L))
  }

  naValue <- NA
  storage.mode(naValue) <- storage.mode(x)

  # Argument 'na.rm':
  if (is.na(na.rm)) {
    # There are no NAs
  } else if (isTRUE(na.rm)) {
    # Remove values that are NA's
    tmp <- !(is.na(x) | is.na(w))
    x <- .subset(x, tmp)
    w <- .subset(w, tmp)
  } else if (anyNA(x)) {
    return(naValue)
  }

  # Argument 'method':
  method <- match.arg(method)

  # Remove values with zero (and negative) weight. This will:
  # (1) take care of the case when all weights are zero,
  # (2) it will most likely speed up the sorting.
  n <- length(w)
  tmp <- (w > 0)
  if (!all(tmp)) {
    x <- .subset(x, tmp)
    w <- .subset(w, tmp)
    n <- sum(tmp)
  }

  # Are there any values left to calculate the weighted median of?
  if (n == 0) {
    return(naValue)
  } else if (n == 1) {
    return(x)
  }

  # Are any weights Inf? Then treat them with equal weight and all others
  # with weight zero. If they have equal weight, regular quantile
  # can be used instead, which is assumed to be faster.
  tmp <- is.infinite(w)
  if (any(tmp)) {
    x <- .subset(x, tmp)
    # Here we know there are no NAs.
    return(quantile(x, probs=probs, na.rm=FALSE, ...))
  }

  # Here we know that there are no missing values in the data
  .wtd.quantile(x, weights=w, probs=probs)
}) # weightedQuantile()



## The wtd.quantile() function originates from Hmisc 4.6-0 (2021-10-07), which
## was released under GPL (>= 2).  The reasons for copying (and pruning) it
## instead of adding 'Hmisc' as a dependency are several: (i) Hmisc has a large
## number of dependencies, (ii) Hmisc requires R (>= 3.6.0) whereas we try to
## stay backward compatible with R (>= 3.2.0), and, most importantly, (iii) due
## to it's many dependencies Hmisc does not install out of the box on all
## systems, e.g. as of 2021-10-22 it is not available for macOS running on the
## M1 chip.
##
## CHANGES MADE:
## * wtd.quantile(): Dropped argument 'type' - always type="quantile"
## * wtd.quantile(): Dropped argument 'normwt' - always normwt=TRUE
## * wtd.quantile(): Dropped argument 'na.rm' - always na.rm=FALSE
.wtd.quantile <- function(x, weights, probs=c(0, .25, .5, .75, 1)) {
  if(any(probs < 0 | probs > 1))
    stop("Probabilities must be between 0 and 1 inclusive")

  ## NOTE: Data points with zero or NA weights have already been dropped
  ## by weightedQuantile() before calling this function

  ## Normalize weights
  weights <- weights/sum(weights)

  ## Order (x,weights) by x
  i <- order(x)
  x <- x[i]
  weights <- weights[i]

  nx <- length(x)

  ## Merge replicated 'x':s into single ones by combining their weights
  if (anyDuplicated(x)) {
    weights <- tapply(weights, INDEX = x, FUN = sum)
    ## The names of 'weights' holds the unique 'x' values
    xs <- names(weights)
    names(weights) <- NULL
    if (length(xs) == 0) stop("program logic error")
    x <- as.numeric(xs)
  }
  
  weights <- nx * weights
  cweights <- cumsum(weights)
  
  n     <- cweights[length(weights)]
  order <- 1 + (n - 1) * probs
  low   <- pmax(floor(order), 1)
  high  <- pmin(low + 1, n)
  order <- order %% 1
  ## Find low and high order statistics
  ## These are minimum values of x such that the cum. freqs >= c(low,high)
  allq <- approx(cweights, x, xout=c(low,high), 
                 method="constant", f=1, rule=2L)$y
  k <- length(probs)
  quantiles <- (1 - order)*allq[1:k] + order*allq[-(1:k)]

  ## Add 'probs' names
  digits <- if (k > 1) 2 - log10(diff(range(probs))) else 2
  names <- paste(format(round(100 * probs, digits = digits)), "%", sep = "")
  names(quantiles) <- names
  
  quantiles
}

###########################################################################/**
# @RdocDefault findNeutralCopyNumberState
#
# @title "Call segments to be copy neutral based on allelic imbalance calls and total copy number estimates"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{C}{A @numeric @vector of region-level total copy number estimates.}
#   \item{isAI}{A @logical @vector of "allelic imbalance" calls.}
#   \item{weights}{An optional @numeric @vector of non-negative weights.}
#   \item{...}{Further arguments to be passed to the density estimation
#     function.}
#   \item{minDensity}{A @numeric value, below which density peaks are
#     discarded.}
#   \item{flavor}{A @character string specifying how to identify the
#     mode of the AB segments.}
#   \item{verbose}{If @TRUE, extra information is output.}
# }
#
# \value{
#   A @logical @vector of "neutral copy number state" calls.
# }
#
# @author "PN, HB"
#
# @keyword internal
#*/###########################################################################
setMethodS3("findNeutralCopyNumberState", "default", function(C, isAI, weights=NULL, ..., minDensity=1e-10, flavor=c("firstPeak", "maxPeak"), verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'C':
  C <- Arguments$getNumerics(C)
  nbrOfLoci <- length(C)

  # Argument 'isAI':
  length2 <- rep(nbrOfLoci, times=2)
  isAI <- Arguments$getLogicals(isAI, length=length2, disallow=NULL)

  # Argument 'weights':
  if (!is.null(weights)) {
    weights <- Arguments$getNumerics(weights, range=c(0, Inf), length=length2)
  }

  # Argument 'minDensity':
  minDensity <- Arguments$getDouble(minDensity)

  # Argument 'flavor':
  flavor <- match.arg(flavor)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }



  verbose && enter(verbose, "Identifying segments that are copy neutral states")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Identify segments in allelic balance
  isAB <- !isAI

  # Identify segments that cannot be called
  isNA <- (is.na(isAB) | is.na(C))

  # Only segments in allelic balance can be considered to be neutral
  isNeutral <- isAB

  # Extracting segments in allelic balance
  idxs <- which(isAB)
  n <- length(idxs)
  verbose && cat(verbose, "Number of segments in allelic balance: ", n)

  # Special cases?
  if (n == 0) {
    # No segments are in allelic balance
    verbose && exit(verbose)
    return(isNeutral)
  } else if (n == 1) {
    # Only one segment is in allelic balance.  The best we can do
    # is to call that segment neutral.
    verbose && exit(verbose)
    return(isNeutral)
  } else if (n < 5) {
    # What to do when the number of segments is really low? /HB 2010-09-09
    warning("The calling of regions in a copy-neutral state is uncertain, because there are less than five (5) regions in allelic balance: ", n)
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Look only segments in allelic balance
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Subset and standardize weights
  if (!is.null(weights)) {
    weights <- weights[idxs]
    weights <- weights / sum(weights)
  }
  y <- C[idxs]
  idxs <- NULL # Not needed anymore

  if (verbose) {
    cat(verbose, "Data points:")
    df <- data.frame(C=y, weights=weights)
    print(verbose, head(df))
    str(verbose, df)
    df <- NULL # Not needed anymore
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Estimate the empirical density
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fit <- findPeaksAndValleys(y, weights=weights, ...)
  verbose && cat(verbose, "Fit:")

  verbose && cat(verbose, "Fit filtered by 'minDensity':")
  ok <- (fit[,"density"] > minDensity)
  verbose && print(verbose, fit[ok,])

  # Look for peaks with enough density
  isPeak <- (fit[,"type"] == "peak") & ok
  idxs <- which(isPeak)

  # Sanity check
  .stop_if_not(length(idxs) >= 1)

  # Extract the first peak
  if (flavor == "firstPeak") {
    idx <- idxs[1]
  } else if (flavor == "maxPeak") {
    idx <- idxs[which.max(fit[idxs,"density"])]
  }

  neutralC <- fit[idx,"x"]

  verbose && cat(verbose, "Neutral copy number:")
  verbose && cat(verbose, "Mode at: ", neutralC)
  verbose && cat(verbose, "Mode ampliture: ", fit[idx,"density"])

  # If there is more than one peak, we should only call segments that
  # are not part of that other peak.
  if (idx+1 <= nrow(fit)) {
    nextValleyC <- fit[idx+1, "x"]
  } else {
    nextValleyC <- Inf
  }
  verbose && cat(verbose, "Upper range at: ", nextValleyC)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Call copy-neutral regions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  isNeutral <- isNeutral & (C < nextValleyC)

  # Segments with missing values cannot be called
  isNeutral[isNA] <- NA

  verbose && cat(verbose, "Neutral region calls:")
  verbose && summary(verbose, isNeutral)

  verbose && exit(verbose)

  isNeutral
}) # findNeutralCopyNumberState()


##############################################################################
# HISTORY
# 2013-09-26 [HB]
# o CLEANUP: Now findNeutralCopyNumberState() no longer attached
#   'aroma.light', but only loads its namespace.
# 2013-03-19 [HB]
# o Added argument 'flavor' to findNeutralCopyNumberState() specifying how
#   to identify the main mode of the AB segments.
# 2012-02-24 [HB]
# o Moved findNeutralCopyNumberState() from aroma.light.
# 2012-02-23 [HB]
# o Renamed argument 'densityThreshold' to 'minDensity'.
# 2011-07-10 [HB]
# o Made findNeutralCopyNumberState() a default method.
# o Made the Rd help "internal".
# 2010-09-09 [HB]
# o Now segments with missing values are not called.
# o Added support for the case when there is no peak/no segments in AB.
# o Added support for the case when there is only one weak.
# o Added sanity checks.
# 2010-09-08 [PN]
# o Created.
##############################################################################

setMethodS3("updateMeansTogether", "PairedPSCBS", function(fit, idxList, ..., avgTCN=c("mean", "median"), avgDH=c("mean", "median"), verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegments <- nbrOfSegments(fit, splitters=TRUE)

  # Argument 'idxList':
  if (!is.list(idxList)) {
    idxList <- list(idxList)
  }
  idxList <- lapply(idxList, FUN=function(idxs) {
    idxs <- Arguments$getIndices(idxs, max=nbrOfSegments)
    sort(unique(idxs))
  })

  # Argument 'avgTCN' & 'avgDH':
  avgTCN <- match.arg(avgTCN)
  avgDH <- match.arg(avgDH)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Updating mean level estimates of multiple segments")

  verbose && cat(verbose, "Segments:")
  verbose && str(verbose, idxList)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setting up averaging functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  avgList <- list(
    tcn = get(avgTCN, mode="function"),
    dh = get(avgDH, mode="function")
  )


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the data and segmentation results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)

  segs <- getSegments(fit, splitters=TRUE)

  nbrOfSegments <- nrow(segs)
  verbose && cat(verbose, "Total number of segments: ", nbrOfSegments)

  for (ss in seq_along(idxList)) {
    idxs <- idxList[[ss]]

    fitT <- extractSegments(fit, idxs)
    verbose && cat(verbose, "Number of segments: ", nbrOfSegments(fitT))

    dataT <- getLocusData(fitT)
    segsT <- getSegments(fitT)

    CT <- dataT$CT
    rho <- dataT$rho

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Update the TCN segments
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    verbose && enter(verbose, "Recalculate (TCN,DH,C1,C2) means")
    naValue <- NA_real_
    mus <- c(tcn=naValue, dh=naValue, c1=naValue, c2=naValue)
    for (key in c("tcn", "dh")) {
      avgFUN <- avgList[[key]]

      # (c) Adjust for missing values
      if (key == "tcn") {
        value <- CT
      } else if (key == "dh") {
        value <- rho
      }
      keep <- which(!is.na(value))

      # (d) Update mean
      gamma <- avgFUN(value[keep])

      # Sanity check
      .stop_if_not(length(gamma) == 0 || !is.na(gamma))

      mus[key] <- gamma
    } # for (what ...)

    mus["c1"] <- 1/2*(1-mus["dh"])*mus["tcn"]
    mus["c2"] <- mus["tcn"] - mus["c1"]
    names(mus) <- sprintf("%sMean", names(mus))
    verbose && print(verbose, mus)
    verbose && exit(verbose)

    for (key in names(mus)) {
      segs[idxs,key] <- mus[key]
    }
  } # for (ss ...)

  # Return results
  res <- fit
  res$output <- segs
  res <- setMeanEstimators(res, tcn=avgTCN, dh=avgDH)

  verbose && exit(verbose)

  res
}, private=TRUE) # updateMeansTogether()

setMethodS3("tileChromosomes", "CBS", function(fit, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  # Nothing to do, i.e. already tiled?
  if (isTRUE(attr(fit, "tiledChromosomes"))) {
    return(fit)
  }

  verbose && enter(verbose, "Tiling chromosomes")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  segs <- getSegments(fit)
  knownSegments <- fit$params$knownSegments

  # Identify all chromosome
  chromosomes <- getChromosomes(fit)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Additional chromosome annotations
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  chrStats <- getChromosomeRanges(fit)

  # Build an "empty" row with start == 1.
  chrStatsKK <- chrStats[1,,drop=FALSE][NA,,drop=FALSE]
  chrStatsKK[,"start"] <- 1L

  # Append empty row
  chrStats <- rbind(chrStats, chrStatsKK)

  # Offset (start,stop)
  chrOffsets <- getChromosomeOffsets(fit, ...)
  chrStats[,"start"] <- chrStats[,"start"] + chrOffsets
  chrStats[,"end"] <- chrStats[,"end"] + chrOffsets


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Offset...
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  segFields <- grep("(start|end)$", colnames(segs), value=TRUE)
  for (kk in seq_along(chromosomes)) {
    chromosome <- chromosomes[kk]
    chrTag <- sprintf("Chr%02d", chromosome)
    verbose && enter(verbose, sprintf("Chromosome #%d ('%s') of %d",
                                         kk, chrTag, length(chromosomes)))

    # Get offset for this chromosome
    offset <- chrOffsets[kk]
    verbose && cat(verbose, "Offset: ", offset)

    # Offset data
    idxs <- which(data$chromosome == chromosome)
    if (length(idxs) > 0L) {
      data$x[idxs] <- offset + data$x[idxs]
    }

    # Offset segmentation
    idxs <- which(segs$chromosome == chromosome)
    if (length(idxs) > 0L) {
      segs[idxs,segFields] <- offset + segs[idxs,segFields]
    }

    # Offset known segments
    idxs <- which(knownSegments$chromosome == chromosome)
    if (length(idxs) > 0L) {
      knownSegments[idxs,c("start", "end")] <- offset + knownSegments[idxs,c("start", "end")]
    }

    verbose && exit(verbose)
  } # for (kk ...)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- fit
  fitT$data <- data
  fitT$output <- segs
  fitT$chromosomeStats <- chrStats
  fitT$params$knownSegments <- knownSegments
  fitT$params$chrOffsets <- chrOffsets


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Sanity checks
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  segs <- getSegments(fit)
  segsT <- getSegments(fitT)
  segs <- segs[,!is.element(colnames(segs), c("start", "end"))]
  segsT <- segsT[,!is.element(colnames(segsT), c("start", "end"))]
  .stop_if_not(all.equal(segsT, segs))

  data <- getLocusData(fit)
  dataT <- getLocusData(fitT)
  data <- data[,!is.element(colnames(data), c("x"))]
  dataT <- dataT[,!is.element(colnames(dataT), c("x"))]
  .stop_if_not(all.equal(dataT, data))

  .stop_if_not(nbrOfLoci(fitT) == nbrOfLoci(fit))
  .stop_if_not(nbrOfSegments(fitT) == nbrOfSegments(fit))

  # Flag object
  attr(fitT, "tiledChromosomes") <- TRUE

  verbose && exit(verbose)

  fitT
}, protected=TRUE) # tileChromosomes()



setMethodS3("plotTracksManyChromosomes", "CBS", function(x, scatter=TRUE, pch=20, col="gray", meanCol="purple", Clim=c(0,3*ploidy(x)), xScale=1e-6, xlab="Genomic position", Clab="TCN", ..., boundaries=TRUE, levels=TRUE, subset=NULL, byIndex=FALSE, add=FALSE, onBegin=NULL, onEnd=NULL, mar=NULL, verbose=FALSE) {
  # To please R CMD check
  fit <- x

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'fit':

  # Argument 'add':
  add <- Arguments$getLogical(add)

  # Argument 'Clim':
  if (!add) {
    Clim <- Arguments$getNumerics(Clim, length=c(2L,2L),
                                        disallow=c("Inf", "NA", "NaN"))
  }

  # Argument 'xScale':
  xScale <- Arguments$getNumeric(xScale, range=c(0,Inf))

  # Argument 'subset':
  if (!is.null(subset)) {
    subset <- Arguments$getDouble(subset, range=c(0,1))
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- tileChromosomes(fit)
  verbose && str(verbose, fitT)
  # Sanity check
  .stop_if_not(!is.null(fitT$chromosomeStats))

  # Extract the input data
  data <- getLocusData(fitT)
  if (is.null(data)) {
    stop("Cannot plot segmentation results. No input data available.")
  }

  # Subset of the loci?
  if (!is.null(subset) && subset < 1) {
    n <- nrow(data)
    keep <- sample(n, size=subset*n)
    data <- data[keep,]
  }

  # To please R CMD check
  CT <- y <- muN <- betaT <- betaN <- betaTN <- NULL
  rm(list=c("CT", "muN", "betaT", "betaN", "betaTN"))
  attachLocally(data)
  x <- xScale * x
  chrStats <- fitT$chromosomeStats
  chrStats <- chrStats[-nrow(chrStats),,drop=FALSE]
  chrRanges <- as.matrix(chrStats[,c("start","end")])
  vs <- xScale * chrRanges
  mids <- (vs[,1]+vs[,2])/2
  CT <- y

  nbrOfLoci <- length(x)
  chromosomes <- getChromosomes(fitT)
  chrLabels <- sprintf("%02d", chromosomes)

  if (byIndex) {
    xs <- seq_along(x)
  } else {
    xs <- x
  }

  if (!add && !is.null(mar)) {
    par(mar=mar)
  }

  gh <- fitT
  gh$xScale <- xScale

  xlim <- xScale*range(chrRanges, na.rm=TRUE)

  pchT <- if (scatter) { pch } else { NA }

  plot(NA, xlim=xlim, ylim=Clim, xlab=xlab, ylab=Clab, axes=FALSE)
  if (!is.null(onBegin)) onBegin(gh=gh)
  points(xs, CT, pch=pchT, col=col, ...)
  side <- rep(c(1,3), length.out=length(chrLabels))
  mtext(text=chrLabels, side=side, at=mids, line=0.1, cex=0.7*par("cex"))
  if (boundaries) {
    abline(v=vs, lty=3)
  }
  axis(side=2)
  box()
  if (levels) {
    drawLevels(fitT, col=meanCol, xScale=xScale, byIndex=byIndex)
  }
  if (!is.null(onEnd)) onEnd(gh=gh)

  invisible(gh)
}, private=TRUE) # plotTracksManyChromosomes()

setMethodS3("callABandHighAI", "PairedPSCBS", function(fit, deltaAB=estimateDeltaAB(fit), alphaAB=0.05, deltaHighAI=0.60, alphaHighAI=0.05, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Calling segments to be in allelic balance (AB) or extreme allelic imbalance (AI)")

  # Calculate DH confidence intervals, if not already done
  probs <- sort(unique(c(alphaAB, alphaHighAI)))
  probs <- sort(unique(c(probs, 1-probs)))
  fit <- bootstrapTCNandDHByRegion(fit, probs=probs, ..., verbose=less(verbose, 50))

  # Call allelic balance
  fit <- callAllelicBalanceByDH(fit, delta=deltaAB, alpha=alphaAB, ..., verbose=less(verbose, 1))

  # Call high allelic imbalance
  fit <- callExtremeAllelicImbalanceByDH(fit, delta=deltaHighAI, alpha=alphaHighAI, ..., verbose=less(verbose, 1))

  verbose && exit(verbose)

  fit
}, private=TRUE) # callABandHighAI()


setMethodS3("callABandLowC1", "PairedPSCBS", function(fit, deltaAB=estimateDeltaAB(fit), alphaAB=0.05, deltaLowC1=0.50, alphaLowC1=0.05, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Calling segments to be in allelic balance (AB) or low minor copy number (low C1)")

  # Calculate DH confidence intervals, if not already done
  probs <- sort(unique(c(alphaAB, alphaLowC1)))
  probs <- sort(unique(c(probs, 1-probs)))
  fit <- bootstrapTCNandDHByRegion(fit, probs=probs, ..., verbose=less(verbose, 50))

  # Call allelic balance
  fit <- callAllelicBalanceByDH(fit, delta=deltaAB, alpha=alphaAB, ..., verbose=less(verbose, 1))

  # Call high allelic imbalance
  fit <- callLowC1ByC1(fit, delta=deltaLowC1, alpha=alphaLowC1, ..., verbose=less(verbose, 1))

  verbose && exit(verbose)

  fit
}, private=TRUE) # callABandLowC1()



setMethodS3("extractCallsByLocus", "PairedPSCBS", function(fit, ...) {
  # Extract locus data
  data <- getLocusData(fit, ...)

  nbrOfLoci <- nrow(data)

  # Extract segment data
  segs <- getSegments(fit, splitters=TRUE)

  # Identify segment calls
  callCols <- grep("Call$", colnames(segs))
  nbrOfCalls <- length(callCols)


  chromosome <- data$chromosome
  x <- data$x
  y <- data[,3]

  # Allocate locus calls
  naValue <- NA
  callsL <- matrix(naValue, nrow=nbrOfLoci, ncol=nbrOfCalls)
  colnames(callsL) <- colnames(segs)[callCols]
  callsL <- as.data.frame(callsL)

  # For each segment...
  for (ss in seq_len(nrow(segs))) {
    seg <- segs[ss,]
    idxs <- which(chromosome == seg$chromosome &
                  seg$tcnStart <= x & x <= seg$tcnEnd)
    idxs <- Arguments$getIndices(idxs, max=nbrOfLoci)
    # Sanity check
##    .stop_if_not(length(idxs) == seg$tcnNbrOfLoci)

    callsSS <- seg[callCols]
    for (cc in seq_len(nbrOfCalls)) {
      callsL[idxs,cc] <- callsSS[,cc]
    }
  } # for (ss ...)

  # The calls for loci that have missing annotations or observations,
  # should also be missing, i.e. NA.
  nok <- (is.na(chromosome) | is.na(x) | is.na(y))
  callsL[nok,] <- NA

  # Sanity check
  .stop_if_not(nrow(callsL) == nbrOfLoci)
  .stop_if_not(ncol(callsL) == nbrOfCalls)

  callsL
}, private=TRUE) # extractCallsByLocus()



##############################################################################
# HISTORY
# 2013-03-22
# o Added extractCallsByLocus() for PairedPSCBS.
# 2011-06-14
# o Updated code to recognize new column names.
# 2011-05-29
# o Renamed all arguments, variables, function named 'tau' to 'delta'.
# 2011-02-03
# o Updated default for 'tauAB' of callABandHighAI() and callABandLowC1()
#   to be estimated from data using estimateTauAB().
# 2010-12-07
# o Added callLowC1ByC1() and callABandLowC1().
# 2010-11-27
# o Corrected verbose output to call results.
# 2010-11-26 [HB]
# o Now all call functions estimate symmetric bootstrap quantiles for
#   convenince of plotting confidence intervals.
# o BUG FIX: callABandHighAI() for PairedPSCBS used the old DH-only
#   bootstrap method.
# o BUG FIX: The call functions, for instance callABandHighAI(), would throw
#   'Error in quantile.default(x, probs = alpha) : missing values and NaN's
#   not allowed if 'na.rm' is FALSE' unless bootstrapTCNandDHByRegion() was
#   run before.
# 2010-11-22 [HB]
# o Added more verbose output to callABandHighAI().
# o Updated callAllelicBalanceByDH() and callExtremeAllelicImbalanceByDH()
#   to utilize bootstrapTCNandDHByRegion().
# 2010-10-25 [HB]
# o Relaced argument 'ciRange' with 'alpha' for callAllelicBalanceByDH() and
#   callExtremeAllelicImbalanceByDH().
# o Renamed callAllelicBalance() to callAllelicBalanceByDH() and
#   callExtremeAllelicImbalanceByDH() to callExtremeAllelicImbalance().
# o Added arguments 'alphaAB' and 'alphaHighAI' to callABandHighAI().
# o Added sanity checks to the call methods.
# o Now arguments '...' to callABandHighAI() are passed down.
# o Now also arguments '...' to callAllelicBalance() and
#   callExtremeAllelicImbalance() are passed to bootstrapDHByRegion().
# o Added argument 'ciRange' to callAllelicBalance() and
#   callExtremeAllelicImbalance().
# 2010-09-16 [HB]
# o Added callABandHighAI().
# o Added callAllelicBalance() and callExtremeAllelicImbalance().
# o Created.
##############################################################################

###########################################################################/**
# @RdocDefault exampleData
#
# @title "Gets an example data set"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{name}{A @character string specifying the name of the data set.}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns @data.frame.
# }
#
# @author "HB"
#
# @keyword IO
# @keyword data
# @keyword internal
#*/###########################################################################
setMethodS3("exampleData", "default", function(name=c("paired.chr01"), ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'name':
  name <- match.arg(name)

  path <- system.file("data-ex", package="PSCBS", mustWork=TRUE)

  if (name == "paired.chr01") {
    filename <- "PairedPSCBS,exData,chr01.Rbin"
  }

  pathname <- Arguments$getReadablePathname(filename, path=path)
  data <- loadObject(pathname)

  data
}, protected=TRUE)

###########################################################################/**
# @set "class=CBS"
# @RdocMethod joinSegments
#
# @title "Joins neighboring segments such that there is no gap in between them"
#
# \description{
#  @get "title".
#  For instance, consider two neighboring segments [x1,x2] and [x3,x4]
#  with x1 < x2 < x3 < x4.  After join the segments, they are
#  [x1,x23] and [x23,x4] where x23 = (x2 + x3)/2.
# }
#
# @synopsis
#
# \arguments{
#   \item{range}{(optional) A @numeric @vector of length two.}
#   \item{verbose}{See @see "R.utils::Verbose".}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns an updated @see "CBS" object.
# }
#
# \details{
#   This function assumes only chromosome exists.
#   If more, an error will be thrown.
# }
#
# @author "HB"
#
# @keyword IO
# @keyword internal
#*/###########################################################################
setMethodS3("joinSegments", "CBS", function(fit, range=NULL, verbose=FALSE, ...) {
  R_SANITY_CHECK <- TRUE

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  chromosomes <- getChromosomes(fit)
  nbrOfChrs <- length(chromosomes)

  # Argument 'range':
  if (!is.null(range)) {
    if (nbrOfChrs > 1L) {
      stop("Argument 'range' cannot be given when 'fit' contains multiple chromosomes.")
    }
    range <- Arguments$getDoubles(range, length=c(2,2))
    .stop_if_not(range[2] >= range[1])
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Joining segments")
  segs <- getSegments(fit, splitters=TRUE)
  verbose && cat(verbose, "Segments:")
  verbose && print(verbose, segs)
  verbose && cat(verbose, "Chromosomes:")
  verbose && print(verbose, chromosomes)
  verbose && cat(verbose, "Range:")
  verbose && print(verbose, range)

  nbrOfSegs <- nrow(segs)
  if (nbrOfSegs > 1) {
    verbose && enter(verbose, "Centering change points")
    prevSeg <- segs[1L,]
    for (ss in 2:nbrOfSegs) {
      currSeg <- segs[ss,]

      ## New chromosome?
      if (!identical(currSeg$chromosome, prevSeg$chromosome)) {
        ## Skip splitters
        if (is.na(currSeg$chromosome)) next
        prevSeg <- currSeg
        next
      }

      currStart <- currSeg[,"start"]
      prevEnd <- prevSeg[,"end"]

      # Sanity check (will give an error if more than one chromosome)
      if (R_SANITY_CHECK) {
        .stop_if_not(all(currStart >= prevEnd, na.rm=TRUE))
      }

      # Center CP
      xMid <- (prevEnd + currStart) / 2

      # Move previous end and current start to this centered CP
      segs[ss,"start"] <- xMid
      segs[ss-1L,"end"] <- xMid

      prevSeg <- currSeg
    } # for (ss ...)
    verbose && exit(verbose)

    # Sanity checks
    if (R_SANITY_CHECK) {
      .stop_if_not(all(segs$start[-1] >= segs$end[-nbrOfSegs], na.rm=TRUE))
      .stop_if_not(all(diff(segs$start) >= 0, na.rm=TRUE)) ## FIXME: > 0
      .stop_if_not(all(diff(segs$end) >= 0, na.rm=TRUE)) ## FIXME: > 0
    } # if (R_SANITY_CHECK)

    if (nbrOfSegs > 6) {
      verbose && print(verbose, head(segs))
      verbose && print(verbose, tail(segs))
    } else {
      verbose && print(verbose, segs)
    }
  } # if (nbrOfSegs > 1)


  if (!is.null(range)) {
    verbose && enter(verbose, "Adjust for 'range'")
    verbose && cat(verbose, "Range:")
    verbose && print(verbose, range)
    xMin <- min(range, na.rm=TRUE)
    xMax <- max(range, na.rm=TRUE)
    if (nbrOfSegs > 0) {
      # Sanity checks
      if (R_SANITY_CHECK) {
        .stop_if_not(xMin <= segs[1L,"start"])
        .stop_if_not(segs[1L,"end"] <= xMax)
      }
      segs[1L,"start"] <- xMin
      segs[nbrOfSegs,"end"] <- xMax

      # Sanity checks
      if (R_SANITY_CHECK) {
        .stop_if_not(all(segs$start[-1] >= segs$end[-nbrOfSegs], na.rm=TRUE))
        .stop_if_not(all(diff(segs$start) >= 0, na.rm=TRUE)) ## FIXME: > 0
        .stop_if_not(all(diff(segs$end) >= 0, na.rm=TRUE)) ## FIXME: > 0
      }

      if (nbrOfSegs > 6) {
        verbose && print(verbose, head(segs))
        verbose && print(verbose, tail(segs))
      } else {
        verbose && print(verbose, segs)
      }
    } # if (nbrOfSegs > 0)
    verbose && exit(verbose)
  } # if (!is.null(range))

  fit <- setSegments(fit, segs, splitters=TRUE)

  segs <- getSegments(fit, splitters=FALSE)
  if (nbrOfSegs > 6) {
    verbose && print(verbose, head(segs))
    verbose && print(verbose, tail(segs))
  } else {
    verbose && print(verbose, segs)
  }
  verbose && exit(verbose)

  fit
}, private=TRUE) # joinSegments()

###########################################################################/**
# @set "class=PSCBS"
# @RdocMethod writeSegments
#
# @title "Writes the table of segments to file"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{name, tags}{Name and optional tags part of the filename}.
#   \item{path}{The directory where the file will be written.}
#   \item{addHeader}{If @TRUE, header comments are written.}
#   \item{createdBy}{A header comment of whom created the file.}
#   \item{splitters}{If @TRUE, each chromosome is separated by a row
#     of missing values.}
#   \item{overwrite, skip}{If an output file already exists, these
#     arguments specifies what should happen.}
#   \item{...}{Additional arguments pass to \code{getSegments()}.}
# }
#
# \value{
#   Returns the pathname of the the file written.
# }
# 
# @author "HB"
#
# \seealso{
#   Utilizes @seemethod "getSegments".
#   @seeclass.
# }
#
# @keyword internal
#*/###########################################################################  
setMethodS3("writeSegments", "PSCBS", function(fit, name=getSampleName(fit), tags=NULL, ext="tsv", path=NULL, addHeader=TRUE, createdBy=NULL, sep="\t", nbrOfDecimals=4L, splitters=FALSE, overwrite=FALSE, skip=FALSE, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'name' and 'tags':
  name <- Arguments$getCharacter(name)
  tags <- Arguments$getCharacters(tags)

  # Argument 'ext':
  ext <- Arguments$getCharacter(ext)

  # Arguments 'path':
  path <- Arguments$getWritablePath(path)

  # Argument 'nbrOfDecimals':
  nbrOfDecimals <- Arguments$getInteger(nbrOfDecimals)


  fullname <- paste(c(name, tags), collapse=",")
  filename <- sprintf("%s.%s", fullname, ext)
  pathname <- Arguments$getWritablePathname(filename, path=path, mustNotExist=(!overwrite && !skip))

  # File already exists?
  if (isFile(pathname)) {
    # Skip?
    if (skip) {
      return(pathname)
    }

    # Overwrite!
    file.remove(pathname)
  }

  # Write to temporary file
  pathnameT <- pushTemporaryFile(pathname)


  sampleName <- getSampleName(fit)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getSegments(fit, ..., splitters=splitters)

  # Round of floating points
  if (!is.null(nbrOfDecimals)) {
    cols <- tolower(colnames(data))
    isInt <- (regexpr("chromosome|start|end|nbrofloci", cols) != -1)
    cols <- which(isInt)
    for (cc in cols) {
      values <- data[[cc]]
      if (is.double(values)) {
        values <- round(values, digits=0)
        data[[cc]] <- values
      }
    } # for (key ...)

    cols <- tolower(colnames(data))
    isInt <- (regexpr("chromosome|start|end|nbrofloci", cols) != -1)
    isLog <- (regexpr("call", cols) != -1)
    isDbl <- (!isInt & !isLog)
    cols <- which(isDbl)
    for (kk in cols) {
      values <- data[[kk]]
      if (is.double(values)) {
        values <- round(values, digits=nbrOfDecimals)
        data[[kk]] <- values
      }
    } # for (key ...) 
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Build header
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (addHeader) {
#    sigmaDelta <- estimateStandardDeviation(fit, method="diff")
   sigmaDelta <- NA
#    sigmaResiduals <- estimateStandardDeviation(fit, method="res")

    createdOn <- format(Sys.time(), format="%Y-%m-%d %H:%M:%S %Z")
    hdr <- c(
      name=name,
      tags=tags,
      fullname=fullname,
      segmentationMethod=sprintf("segment() of %s", attr(fit, "pkgDetails")),
      nbrOfLoci=nbrOfLoci(fit),
      nbrOfSegments=nbrOfSegments(fit),
      joinSegments=fit$params$joinSegments,
#      signalType=getSignalType(fit),
      sigmaDelta=sprintf("%.4f", sigmaDelta),
#      sigmaResiduals=sprintf("%.4f", sigmaResiduals),
      createdBy=createdBy,
      createdOn=createdOn,
      nbrOfDecimals=nbrOfDecimals,
      nbrOfColumns=ncol(data),
      columnNames=paste(colnames(data), collapse=", "),
      columnClasses=paste(sapply(data, FUN=function(x) class(x)[1]), collapse=", ")
    )
    bfr <- paste("# ", names(hdr), ": ", hdr, sep="")

    cat(file=pathnameT, bfr, sep="\n")
  } # if (addHeader)

  write.table(file=pathnameT, data, append=TRUE, quote=FALSE, sep=sep, 
                                          row.names=FALSE, col.names=TRUE)

  pathname <- popTemporaryFile(pathnameT)

  pathname
}) # writeSegments()

###########################################################################/**
# @RdocDefault segmentByNonPairedPSCBS
# @alias segmentByNonPairedPSCBS.data.frame
# @alias segmentByNonPairedPSCBS.PairedPSCBS
# @alias segmentByNonPairedPSCBS
#
# @title "Segment total copy numbers and allele B fractions using the Non-paired PSCBS method"
#
# \description{
#  @get "title" [1].
#  This method does not requires matched normals.
#  This is a low-level segmentation method.
#  It is intended to be applied to one tumor sample at the time.
# }
#
# @synopsis
#
# \arguments{
#   \item{CT}{A @numeric @vector of J tumor total copy number (TCN)
#        ratios in [0,+@Inf) (due to noise, small negative values are
#        also allowed).  The TCN ratios are typically scaled such that
#        copy-neutral diploid loci have a mean of two.}
#   \item{betaT}{A @numeric @vector of J tumor allele B fractions (BAFs)
#        in [0,1] (due to noise, values may be slightly outside as well)
#        or @NA for non-polymorphic loci.}
#   \item{...}{Additional arguments passed to @see "segmentByPairedPSCBS".}
#   \item{flavor}{A @character specifying what type of segmentation and
#     calling algorithm to be used.}
#   \item{tauA, tauB}{Lower and upper thresholds (\code{tauA < tauB} for
#     calling SNPs  heterozygous based on the tumor allele B fractions
#     (\code{betaT}).  If @NA, then they are estimates from data.
#   }
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns the segmentation results as a @see "NonPairedPSCBS" object.
# }
#
# \details{
#   Internally @see "segmentByPairedPSCBS" is used for segmentation.
#   This segmentation method does \emph{not} support weights.
# }
#
# \section{Reproducibility}{
#   The "DNAcopy::segment" implementation of CBS uses approximation
#   through random sampling for some estimates.  Because of this,
#   repeated calls using the same signals may result in slightly
#   different results, unless the random seed is set/fixed.
# }
#
# \section{Whole-genome segmentation is preferred}{
#   Although it is possible to segment each chromosome independently
#   using Paired PSCBS, we strongly recommend to segment whole-genome
#   (TCN,BAF) data at once.  The reason for this is that downstream
#   CN-state calling methods, such as the AB and the LOH callers,
#   performs much better on whole-genome data.  In fact, they may
#   fail to provide valid calls if done chromosome by chromosome.
# }
#
# \section{Missing and non-finite values}{
#   The total copy number signals as well as any optional positions
#   must not contain missing values, i.e. @NAs or @NaNs.
#   If there are any, an informative error is thrown.
#   Allele B fractions may contain missing values, because such are
#   interpreted as representing non-polymorphic loci.
#
#   None of the input signals may have infinite values, i.e. -@Inf or +@Inf.
#   If so, an informative error is thrown.
# }
#
# \section{Non-Paired PSCBS with known genotypes}{
#   If allele B fractions for the matched normal (\code{betaN}) are
#   not available, but genotypes (\code{muN}) are, then it is possible
#   to run Paired PSCBS.   See @see "segmentByPairedPSCBS" for details.
# }
#
# @examples "../incl/segmentByNonPairedPSCBS.Rex"
#
# @author "HB"
#
# \references{
#  [1] @include "../incl/OlshenA_etal_2011.Rd" \cr
#  [2] @include "../incl/BengtssonH_etal_2010.Rd" \cr
# }
#
# \seealso{
#   To segment paired tumor-normal total copy numbers and allele B fractions,
#   see @see "segmentByPairedPSCBS".
#
#   To segment total copy numbers, or any other unimodal signals,
#   see @see "segmentByCBS".
# }
#
# @keyword IO
#*/###########################################################################
setMethodS3("segmentByNonPairedPSCBS", "default", function(CT, betaT, ..., flavor=c("tcn", "tcn&dh", "tcn,dh", "sqrt(tcn),dh", "sqrt(tcn)&dh"), tauA=NA, tauB=1-tauA, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'CT':
  disallow <- c("Inf")
  CT <- Arguments$getDoubles(CT, disallow=disallow)
  nbrOfLoci <- length(CT)
  length2 <- rep(nbrOfLoci, times=2)

  # Argument 'betaT':
  betaT <- Arguments$getDoubles(betaT, length=length2, disallow="Inf")

  # Argument 'flavor':
  flavor <- match.arg(flavor)
  knownFlavors <- eval(formals(segmentByPairedPSCBS.default)$flavor, enclos = baseenv())
  if (!is.element(flavor, knownFlavors)) {
    stop("Segmentation flavor is not among the supported ones (", paste(sprintf("\"%s\"", knownFlavors), collapse=", "), "): ", flavor)
  }

  # Argument 'tauA' & 'tauB':
  if (!is.na(tauA) && !is.na(tauB)) {
    tauA <- Arguments$getDouble(tauA)
    tauB <- Arguments$getDouble(tauB)
    if (tauB < tauA) {
      stop("Argument 'tauA' must be smaller than 'tauB': ", tauA, " > ", tauB)
    }
    tauA <- Arguments$getDouble(tauA, range=c(-0.5, +0.5))
    tauB <- Arguments$getDouble(tauB, range=c(+0.5, +1.5))
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Segmenting non-paired tumor signals using Non-paired PSCBS")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup input data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && cat(verbose, "Number of loci: ", nbrOfLoci)

  # SNPs are identifies as those loci that have non-missing 'betaT'
  isSnp <- !is.na(betaT)
  nbrOfSnps <- sum(isSnp)
  verbose && cat(verbose, "Number of SNPs: ", nbrOfSnps)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Call tumor "genotypes"
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Calling \"genotypes\" from tumor allele B fractions")
  verbose && str(verbose, betaT)

  if (is.na(tauA) && is.na(tauB)) {
    mBAF <- abs(betaT - 1/2)
    fitT <- findPeaksAndValleys(mBAF)
    type <- NULL; rm(list="type") # To please 'R CMD check'.
    fitT <- subset(fitT, type == "peak")
    o <- order(fitT$density, decreasing=TRUE)
    fitT <- fitT[o,]
    fitT <- fitT[1,]
    z <- mBAF[mBAF >= fitT$x] - fitT$x
    q <- quantile(z, probs=0.95, na.rm=TRUE, names=FALSE)
    qU <- fitT$x+q
    verbose && cat(verbose, "Upper quantile: ", qU)
    qL <- fitT$x - q
    verbose && cat(verbose, "Symmetric lower quantile: ", qL)
    tauA <- 1/2-qL
    tauB <- 1/2+qL
    verbose && cat(verbose, "(tauA, tauB) estimates: (%g,%g)", tauA, tauB)

    # Sanity check on (tauA, tauB) estimates
    if (tauB < tauA) {
      stop("Failed to estimate (tauA, tauB). The estimate 'tauA' is greater than 'tauB', which it should not: ", tauA, " > ", tauB)
    }
    tauA <- Arguments$getDouble(tauA, range=c(-0.5, +0.5))
    tauB <- Arguments$getDouble(tauB, range=c(+0.5, +1.5))
  }

  verbose && cat(verbose, "Homozygous treshholds:")
  verbose && print(verbose, c(tauA, tauB))

  isHomA <- isSnp & (betaT <= tauA)
  isHomB <- isSnp & (betaT >= tauB)
  isHom <- (isHomA | isHomB)
  isHet <- isSnp & !isHom

  # Tumor proxy for germline genotypes
  naValue <- NA_real_
  muNx <- rep(naValue, times=length(betaT))
  muNx[isHomA] <-   0
  muNx[isHet]  <- 1/2
  muNx[isHomB] <-   1
  # Not needed anymore
  isHomA <- isHomB <- isHom <- isHet <- NULL

  verbose && cat(verbose, "Inferred germline genotypes (via tumor):")
  verbose && str(verbose, muNx)
  verbose && print(verbose, table(muNx))
  verbose && exit(verbose)

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Segment using Paired PSCBS segmentation
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Segment using Paired PSCBS")
  fit <- segmentByPairedPSCBS(CT=CT, betaT=betaT, muN=muNx, tbn=FALSE, flavor=flavor, ..., verbose=verbose)
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Coerce fit object to Non-Paired PSCBS results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Coercing to Non-Paired PSCBS results")

  data <- fit$data
  class(data) <- gsub("PairedPSCNData", "NonPairedPSCNData", class(data), fixed=TRUE)
#  class(data) <- c("NonPairedPSCNData", class(data))
  fit$data <- data
  # Not needed anymore
  data <- NULL

  segs <- fit$output
  class(segs) <- gsub("PairedPSCNSegments", "NonPairedPSCNSegments", class(segs), fixed=TRUE)
#  class(segs) <- c("NonPairedPSCNSegments", class(segs))
  fit$output <- segs
  # Not needed anymore
  segs <- NULL

  params <- fit$params
  params$tauA <- tauA
  params$tauB <- tauB
  fit$params <- params
  # Not needed anymore
  params <- NULL

#  class(fit) <- gsub("PairedPSCBS", "NonPairedPSCBS", class(fit), fixed=TRUE)
  class(fit) <- c("NonPairedPSCBS", class(fit))

  verbose && exit(verbose)


  verbose && print(verbose, head(as.data.frame(fit)))
  verbose && print(verbose, tail(as.data.frame(fit)))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Return results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fit
}) # segmentByNonPairedPSCBS()



setMethodS3("segmentByNonPairedPSCBS", "data.frame", function(CT, ...) {
  # To please R CMD check
  data <- CT


  segmentByNonPairedPSCBS(CT=data$CT, betaT=data$betaT,
                          chromosome=data$chromosome, x=data$x, ...)
})



setMethodS3("segmentByNonPairedPSCBS", "PairedPSCBS", function(...) {
  resegment(...)
})

###########################################################################/**
# @set class=CBS
# @RdocMethod as.DNAcopy
#
# @title "Coerces a CBS object to a DNAcopy object"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{fit}{A @see "CBS" object."}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns a \code{\link[DNAcopy:DNAcopy]{DNAcopy}} object
#   (of the \pkg{DNAcopy} package).
# }
#
# \examples{
#   @include "../incl/segmentByCBS.Rex"
#   @include "../incl/as.DNAcopy.Rex"
# }
#
# @author "HB"
#
# \seealso{
#   \code{\link[PSCBS:as.CBS.DNAcopy]{as.CBS()}}.
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("as.DNAcopy", "CBS", function(fit, ...) {
  sampleName <- getSampleName(fit)
  if (is.na(sampleName)) sampleName <- "<NA>"

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup the 'data' field
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)

  # Keep only certain columns
  keep <- match(c("chromosome", "x"), colnames(data))
  keep <- c(keep, 3L)
  data <- data[,keep,drop=FALSE]

  # Sanity check
  .stop_if_not(ncol(data) == 3)

  # Rename column names
  colnames(data) <- c("chrom", "maploc", sampleName)

  class(data) <- c("CNA", "data.frame")
  attr(data, "data.type") <- "logratio"


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup the 'output' field
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  output <- getSegments(fit, splitters=FALSE)
  rownames <- rownames(output)

  output <- data.frame(
    ID        = sampleName,
    chrom     = output$chromosome,
    loc.start = output$start,
    loc.end   = output$end,
    num.mark  = output$nbrOfLoci,
    seg.mean  = output$mean,
    stringsAsFactors=FALSE
  )
  rownames(output) <- rownames


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup up 'DNAcopy' object
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  res <- list()
  res$data <- data
  res$output <- output
  res$call <- NA
  class(res) <- "DNAcopy"

  res
}, protected=TRUE) # as.DNAcopy()



setMethodS3("nbrOfSegments", "DNAcopy", function(fit, ...) {
  segs <- fit$output
  nrow(segs)
})

setMethodS3("nbrOfLoci", "DNAcopy", function(fit, ...) {
  nrow(fit$data)
})

setMethodS3("nbrOfSamples", "DNAcopy", function(fit, ...) {
  length(getSampleNames(fit, ...))
})

setMethodS3("getSampleNames", "DNAcopy", function(fit, ...) {
  names <- colnames(fit$data)
  names <- setdiff(names, c("chrom", "maploc"))
  names
})

setMethodS3("getChromosomes", "DNAcopy", function(fit, ...) {
  chromosomes <- fit$data$chrom
  sort(unique(chromosomes))
})


setMethodS3("estimateStandardDeviation", "DNAcopy", function(fit, sample=1L, method=c("diff", "abs", "res"), estimator=c("mad", "sd"), na.rm=TRUE, weights=NULL, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'sample':
  sample <- Arguments$getIndex(sample, max=nbrOfSamples(fit))

  # Argument 'method':
  method <- match.arg(method)

  # Argument 'estimator':
  estimator <- match.arg(estimator)



  nbrOfLoci <- nbrOfLoci(fit)

  # Argument 'weights':
  if (!is.null(weights)) {
    weights <- Arguments$getNumerics(weights, range=c(0,Inf), length=rep(nbrOfLoci, times=2))
  }


  # Nothing to do?
  if (nbrOfLoci <= 1) {
    return(NA_real_)
  }

  # Get the estimator function
  if (!is.null(weights)) {
    estimator <- sprintf("weighted %s", estimator)
    estimator <- R.utils::toCamelCase(estimator)
  }
  estimatorFcn <- get(estimator, mode="function")


  # Extract sample of interest
  fit <- subset(fit, samplelist=sample)

  y <- fit$data[,3L]

  if (method == "diff") {
    y <- diff(y)

    # Weighted estimator?
    if (!is.null(weights)) {
      # Calculate weights per pair
      weights <- (weights[1:(nbrOfLoci-1)]+weights[2:nbrOfLoci])/2
      sigma <- estimatorFcn(y, w=weights, na.rm=na.rm)/sqrt(2)
    } else {
      sigma <- estimatorFcn(y, na.rm=na.rm)/sqrt(2)
    }
  } else if (method == "abs") {
    if (!is.null(weights)) {
      sigma <- estimatorFcn(y, w=weights, na.rm=na.rm)
    } else {
      sigma <- estimatorFcn(y, na.rm=na.rm)
    }
  } else if (method == "res") {
     yS <- extractSegmentMeansByLocus(fit)
     dy <- y - yS
      if (!is.null(weights)) {
        sigma <- estimatorFcn(dy, w=weights, na.rm=na.rm)
      } else {
        sigma <- estimatorFcn(dy, na.rm=na.rm)
      }
  } else {
    stop("Method no implemented: ", method)
  }

  sigma
}) # estimateStandardDeviation()


setMethodS3("extractSegmentMeansByLocus", "DNAcopy", function(fit, sample=1L, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'sample':
  sample <- Arguments$getIndex(sample, max=nbrOfSamples(fit))

  # Extract sample of interest
  fit <- subset(fit, samplelist=sample)

  data <- fit$data
  chr <- data$chrom
  x <- data$maploc
  y <- data[,sample,drop=TRUE]

  segs <- fit$output
  nbrOfSegments <- nrow(segs)
  nbrOfLoci <- nbrOfLoci(fit)

  # Get mean estimators
  estList <- getMeanEstimators(fit, "y")
  avgY <- estList$y

  yS <- y
  for (ss in seq_len(nbrOfSegments)) {
    seg <- segs[ss,]
    idxs <- which(seg$chrom == chr & seg$loc.start <= x & x <= seg$loc.end)
    idxs <- Arguments$getIndices(idxs, max=nbrOfLoci)

    ySS <- y[idxs]
    ok <- is.finite(ySS)
    # Sanity check
    ## .stop_if_not(sum(ok) == seg$num.mark) # Not dealing with ties
    mu <- avgY(ySS[ok])
    yS[idxs] <- mu
  } # for (ss ...)

  yS
}, private=TRUE) # extractSegmentMeansByLocus()



setMethodS3("writeSegments", "DNAcopy", function(fit, samples=seq_len(nbrOfSamples(fit)), ...) {
  # Argument 'samples':
  samples <- Arguments$getIndices(samples, max=nbrOfSamples(fit))

  pathnames <- c()
  for (ii in samples) {
    fitII <- as.CBS(fit, sample=ii)
    pathnameII <- writeSegments(fitII, ...)
    pathnames <- c(pathnames, pathnameII)
  } # for (ii ...)

  pathnames
}) # writeSegments()

set.seed(0xBEEF)

# Number of loci
J <- 1000

mu <- double(J)
mu[200:300] <- mu[200:300] + 1
mu[350:400] <- NA_real_ # centromere
mu[650:800] <- mu[650:800] - 1
eps <- rnorm(J, sd=1/2)
y <- mu + eps
x <- sort(runif(length(y), max=length(y))) * 1e5

knownSegments <- data.frame(
  chromosome=c(    0,   0),
  start     =x[c(  1, 401)],
  end       =x[c(349,   J)]
)

fit2 <- PSCBS::segmentByCBS(y, x=x, knownSegments=knownSegments)

###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod getBootstrapLocusSets
# @alias getBootstrapLocusSets
#
# @title "Generates original and bootstrapped segment-specific index sets"
#
# \description{
#  @get "title", which can be used to calculate various bootstrap summaries,
#  e.g. segment mean levels.
# }
#
# @synopsis
#
# \arguments{
#   \item{B}{A non-negative @integer specifying the number of bootstrap samples.}
#   \item{by}{Should \code{betaTN} or \code{betaT} be used?}
#   \item{seed}{An (optional) @integer specifying the random seed to be
#     set before sampling indices.  The random seed is set to its original
#     state when exiting.  If @NULL, it is not set.}
#   \item{verbose}{See @see "R.utils::Verbose".}
#   \item{.validate}{If @TRUE, additional sanity checks are performed
#     to validate the correctness.  This is only needed for troubleshooting
#     if it is suspected there is a bug.}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns a @list.
# }
#
# @author "HB"
#
# \seealso{
#   This is used internally by various bootstrap methods.
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("getBootstrapLocusSets", "PairedPSCBS", function(fit, B=1000L, by=c("betaTN", "betaT"), seed=NULL, verbose=FALSE, .validate=FALSE, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'B':
  B <- Arguments$getInteger(B, range=c(0,Inf))

  # Argument 'by':
  by <- match.arg(by)

  # Argument 'seed':
  if (!is.null(seed)) {
    seed <- Arguments$getInteger(seed)
  }

  # Argument '.validate':
  .validate <- Arguments$getLogical(.validate)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }



  verbose && enter(verbose, "Bootstrapping (TCN,DH,C1,C2) segment mean levels")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Set the random seed
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (!is.null(seed)) {
    randomSeed("set", seed=seed, kind="L'Ecuyer-CMRG")
    on.exit(randomSeed("reset"), add=TRUE)
    verbose && printf(verbose, "Random seed temporarily set (seed=%d)\n", seed)
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  tcnSegRows <- fit$tcnSegRows
  dhSegRows <- fit$dhSegRows
  segs <- getSegments(fit)
  params <- fit$params

  # Sanity checks
  if (!params$joinSegments) {
    stop("Cannot bootstrap TCN and DH by segments unless PSCNs are segmented using joinSegments=TRUE.")
  }
  if (regexpr(",", params$flavor, fixed=TRUE) != -1L) {
    stop(sprintf("Cannot bootstrap TCN and DH by segments if PSCNs are segmented using flavor=\"%s\".", params$flavor))
  }
  # Sanity check (same as above, but just in case)
  .stop_if_not(all(segs$tcnStart == segs$dhStart, na.rm=TRUE))
  .stop_if_not(all(segs$tcnEnd == segs$dhEnd, na.rm=TRUE))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Get signals
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Get (x,TCN,BAF) data
  chromosome <- data$chromosome
  x <- data$x
  CT <- data$CT
  betaT <- data[[by]]
  muN <- data$muN
  rho <- data$rho
  hasDH <- !is.null(rho)

  # Not needed anymore
  data <- NULL

  # Sanity checks
  .stop_if_not(all(!is.na(chromosome) & !is.na(x)))



  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Classify each locus as (i) heterozygous SNP, (ii) homozygous SNP,
  # or (iii) non-polymorphic loci
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Identifying heterozygous & homozygous SNPs and non-polymorphic loci")
  nbrOfLoci <- length(x)
  verbose && cat(verbose, "Number of loci: ", nbrOfLoci)

  # SNPs are identifies as those loci that have non-missing 'muN' (& betaTN')
  if (hasDH) {
    isHet <- !is.na(rho)
    isSnp <- isHet
  } else {
    isSnp <- (!is.na(muN) & !is.na(betaT))
    isHet <- isSnp & (muN == 1/2)
  }
  snps <- which(isSnp)
  nonSNPs <- which(!isSnp)
  nbrOfSNPs <- sum(isSnp)
  nbrOfNonSNPs <- sum(!isSnp)
  verbose && cat(verbose, "Number of SNPs: ", nbrOfSNPs)
  verbose && cat(verbose, "Number of non-SNPs: ", nbrOfNonSNPs)

  # Sanity checks
  .stop_if_not(length(intersect(snps, nonSNPs)) == 0L)

  # Heterozygous SNPs
  hets <- which(isSnp &  isHet)
  homs <- which(isSnp & !isHet)
  nbrOfHets <- length(hets)
  nbrOfHoms <- length(homs)
  if (!hasDH) {
    verbose && printf(verbose, "Number of heterozygous SNPs: %d (%.2f%%)\n",
                                        nbrOfHets, 100*nbrOfHets/nbrOfSNPs)
    verbose && printf(verbose, "Number of homozygous SNPs: %d (%.2f%%)\n",
                                        nbrOfHoms, 100*nbrOfHoms/nbrOfSNPs)
  }

  # Sanity checks
  .stop_if_not(length(intersect(hets, homs)) == 0L)
  .stop_if_not(nbrOfHets + nbrOfHoms == nbrOfSNPs)

  # Sanity checks
  .stop_if_not(length(isSnp) == nbrOfLoci)
  .stop_if_not(length(isHet) == nbrOfLoci)

  # Not needed anymore
  muN <- isSnp <- NULL
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Precalculate DH signals
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (!hasDH) {
    # Calculate DHs for heterozygous SNPs
    rho <- 2*abs(betaT - 1/2)

    # DH is by definition only defined for heterozygous SNPs.
    # For simplicity, we set it to be NA for non-heterozygous loci.
    rho[!isHet] <- NA
  }

  # Not needed anymore
  betaT <- isHet <- NULL


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Resample (TCN,DH) within each segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegments <- nrow(segs)

  # Allocate JxBx4 matrix M of bootstrap means
  dim <- c(nbrOfSegments, B, 4L)
  dimnames <- list(NULL, NULL, c("tcn", "dh", "c1", "c2"))

  # Identify all loci with non-missing signals
  idxsCT <- which(!is.na(CT))
  idxsRho <- which(!is.na(rho))

  # Not needed anymore
  CT <- rho <- NULL


  # Vectorized pre-adjustments
  for (key in c("tcnNbrOfLoci", "dhNbrOfLoci")) {
    counts <- segs[[key]]
    counts[is.na(counts)] <- 0L
    segs[[key]] <- counts
    counts <- NULL # Not needed anymore
  }

  hasTcnLoci <- (is.finite(tcnSegRows[,1L]) & is.finite(tcnSegRows[,2L]))
  hasDhLoci <- (is.finite(dhSegRows[,1L]) & is.finite(dhSegRows[,2L]))

  # Identify "splitter" segments which have no data
  chrs <- segs[["chromosome"]]
  tcnIds <- segs[["tcnId"]]
  dhIds <- segs[["dhId"]]
  dhMeans <- segs[["dhMean"]]
  isSplitter <- (is.na(chrs) & is.na(tcnIds) & is.na(dhIds))

  # Get all segment indices except for "splitters"
  jjs <- seq_len(nbrOfSegments)
  jjs <- jjs[!isSplitter]


  # Allocate list to hold the results
  res <- list(
    nbrOfSegments = nbrOfSegments,
    segments = jjs,
    nbrOfLoci = nbrOfLoci,
    loci = list(
      all = seq_len(nbrOfLoci),
      tcn = idxsCT,
      dh  = idxsRho
    ),
    by = by,
    seed = seed
  )
  locusSet <- vector("list", length=nbrOfSegments)


  # For each segment jj = 1, 2, ..., S
  for (jj in jjs) {
    chr <- chrs[jj]
    tcnId <- tcnIds[jj]
    dhId <- dhIds[jj]

    verbose && enter(verbose, sprintf("Segment #%d (chr %d, tcnId=%d, dhId=%d) of %d", jj, chr, tcnId, dhId, nbrOfSegments))

    # Sanity check
    if (.validate) {
      .stop_if_not(!is.na(chr) && !is.na(tcnId) && !is.na(dhId))
    }

    # Get the segment data
    segJJ <- segs[jj,,drop=FALSE]
    nbrOfTCNs <- segJJ[,"tcnNbrOfLoci"]
    nbrOfDHs <- segJJ[,"dhNbrOfLoci"]

    if (verbose) {
      print(verbose, segJJ)
      cat(verbose, "Number of TCNs: ", nbrOfTCNs)
      cat(verbose, "Number of DHs: ", nbrOfDHs)
    }
    if (.validate) {
      .stop_if_not(!is.na(nbrOfTCNs))
      .stop_if_not(!is.na(nbrOfDHs))
    }

    tcnSegRowJJ <- unlist(tcnSegRows[jj,], use.names=FALSE)
    dhSegRowJJ <- unlist(dhSegRows[jj,], use.names=FALSE)

    # Indices of all loci
    if (hasTcnLoci[jj]) {
      idxsAll <- tcnSegRowJJ[1L]:tcnSegRowJJ[2L]
    } else {
      idxsAll <- integer(0L)
    }

    if (verbose) {
      str(verbose, idxsAll)
      print(verbose, hpaste(idxsAll), level=-120)
      str(verbose, idxsCT)
      print(verbose, hpaste(idxsCT), level=-120)
    }

    # Keep only loci with finite TCNs
    idxsAll <- intersect(idxsAll, idxsCT)
    if (verbose) {
      str(verbose, idxsAll)
      print(verbose, hpaste(idxsAll), level=-120)
    }

    # Sanity check
    if (length(idxsAll) != nbrOfTCNs) {
      verbose && str(verbose, setdiff(idxsCT, idxsAll))
      stop("INTERNAL ERROR: length(idxsAll) != nbrOfTCNs: ", length(idxsAll), " != ", nbrOfTCNs)
    }


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Identify loci used to calculate DH means
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    verbose && enter(verbose, "Identify loci used to bootstrap DH means")

    if (hasDhLoci[jj]) {
      idxsDH <- dhSegRowJJ[1L]:dhSegRowJJ[2L]
      idxsDH <- intersect(idxsDH, hets)
      # Drop missing values
      idxsDH <- intersect(idxsDH, idxsRho)
    } else {
      idxsDH <- integer(0L)
    }

    verbose && cat(verbose, "Heterozygous SNPs to resample for DH:")
    verbose && str(verbose, idxsDH)

    # Sanity check
    if (.validate) .stop_if_not(length(idxsDH) == nbrOfDHs)

    verbose && exit(verbose)



    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Identify loci used to calculate TCN means
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    verbose && enter(verbose, "Identify loci used to bootstrap TCN means")

    # Identify SNPs and non-SNPs
    idxsSNP <- intersect(snps, idxsAll)
    idxsNonSNP <- setdiff(idxsAll, idxsSNP)
    if (verbose) {
      cat(verbose, "SNPs:")
      str(verbose, idxsSNP)
      cat(verbose, "Non-polymorphic loci:")
      str(verbose, idxsNonSNP)
    }
    # Sanity check
    if (.validate) .stop_if_not(length(idxsSNP) + length(idxsNonSNP) == length(idxsAll))

    # Identify heterozygous and homozygous SNPs
    idxsHet <- intersect(idxsSNP, hets)
    if (nbrOfHoms > 0) {
      idxsHom <- intersect(idxsSNP, homs)
    } else {
      idxsHom <- integer(0L)
    }

    # Drop missing values
    idxsNonSNP <- intersect(idxsNonSNP, idxsCT)
    idxsHet <- intersect(idxsHet, idxsCT)
    if (nbrOfHoms > 0) {
      idxsHom <- intersect(idxsHom, idxsCT)
    }
    idxsHetNonDH <- setdiff(idxsHet, idxsDH)

    if (verbose) {
      cat(verbose, "Heterozygous SNPs to resample for TCN:")
      str(verbose, idxsHet)
      cat(verbose, "Homozygous SNPs to resample for TCN:")
      str(verbose, idxsHom)
      cat(verbose, "Non-polymorphic loci to resample for TCN:")
      str(verbose, idxsNonSNP)
      cat(verbose, "Heterozygous SNPs with non-DH to resample for TCN:")
      str(verbose, idxsHetNonDH)
    }
    # Note that length(idxsHetNonDH) may differ from zero in case CT is non-missing
    # but rho is missing, e.g. CT = sum(c(thetaA,thetaB), na.rm=TRUE) and
    # thetaB is missing. /HB 2010-12-01

    idxsTCN <- sort(unique(c(idxsHet, idxsHom, idxsNonSNP)))
    if (verbose) {
      cat(verbose, "Loci to resample for TCN:")
      str(verbose, idxsTCN)
    }

    # Sanity check
    if (.validate) {
      .stop_if_not(length(idxsHet) + length(idxsHom) + length(idxsNonSNP) == nbrOfTCNs)
      .stop_if_not(length(intersect(idxsDH, idxsHetNonDH)) == 0L)
      .stop_if_not(length(idxsTCN) == nbrOfTCNs)
    }

    verbose && exit(verbose)


    # These numbers should be preserved when the resampling
    verbose && printf(verbose, "Number of (#hets, #homs, #nonSNPs): (%d,%d,%d)\n",
                      length(idxsHet), length(idxsHom), length(idxsNonSNP))

    # Workaround: ... Why? /HB 2013-10-22
    shouldHaveDHs <- (nbrOfDHs > 0L && !is.na(dhMeans[jj]))
    if (!shouldHaveDHs) {
      idxsHetNonDH <- idxsDH
      .stop_if_not(all(idxsHetNonDH > 0L))
    }
    shouldHaveDHs <- NULL # Not needed anymore

    nHoms <- length(idxsHom)
    nNonSNPs <- length(idxsNonSNP)
    nHetNonDHs <- length(idxsHetNonDH)

    locusSetJJ <- list(
      segment = segJJ,
      loci = list(
        all = idxsAll,
        snp = idxsSNP,
        tcn = idxsTCN,
        dh = idxsDH,
        nonSnp = idxsNonSNP,
        het = idxsHet,
        hom = idxsHom,
        hetNonDh = idxsHetNonDH
      )
    )

    # Sanity checks
    if (.validate) {
      loci <- locusSetJJ$loci
      for (key in names(loci)) {
        idxs <- loci[[key]]
        # Assert positive indices
        .stop_if_not(all(idxs > 0L))
        # Assert a unique set of indices
        .stop_if_not(!any(duplicated(idxs)))
      }
      # Assert non-overlapping sets
      with(loci, {
        .stop_if_not(length(intersect(dh,  hetNonDh)) == 0L)
        .stop_if_not(length(intersect(het, hom)) == 0L)
        .stop_if_not(length(intersect(het, nonSnp)) == 0L)
        .stop_if_not(length(intersect(hom, nonSnp)) == 0L)
      })
      loci <- NULL # Not needed anymore
    }


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Identify bootstrap locus sets preserving (#hets, #homs, #nonSNPs)
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    verbose && enter(verbose, "Identifying bootstrap locus sets that preservs (#hets, #homs, #nonSNPs)")
    verbose && cat(verbose, "Number of bootstrap samples: ", B)

    nbrOfTCNs <- nbrOfDHs+nHoms+nNonSNPs
    nbrOfHets <- nbrOfDHs+nHetNonDHs

    # Allocate index matrices
    tcn      <- matrix(NA_integer_, nrow=nbrOfTCNs, ncol=B)
    dh       <- matrix(NA_integer_, nrow=nbrOfDHs, ncol=B)
    nonSnp   <- matrix(NA_integer_, nrow=nNonSNPs, ncol=B)
    het      <- matrix(NA_integer_, nrow=nbrOfHets, ncol=B)
    hom      <- matrix(NA_integer_, nrow=nHoms, ncol=B)
    hetNonDh <- matrix(NA_integer_, nrow=nHetNonDHs, ncol=B)

##    resample <- function(x, size, ...) {
##      .stop_if_not(size == length(x))
##      x
##    } # resample()

    # (1) Bootstrap DH loci
    if (nbrOfDHs > 0L) {
      # (a) Resample heterozygous SNPs (=> resampled DH units)
      for (bb in seq_len(B)) {
        dh[,bb] <- resample(idxsDH, size=nbrOfDHs, replace=TRUE)
      }
    }

    # (2) Bootstrap other loci
    # (a) Resample non-DH hets SNPs
    if (nHetNonDHs > 0L) {
      for (bb in seq_len(B)) {
        idxsHetNonDHBB <- resample(idxsHetNonDH, size=nHetNonDHs, replace=TRUE)
        hetNonDh[,bb] <- idxsHetNonDHBB
      }
    }

    # (b) Resample homozygous SNPs
    if (nHoms > 0L) {
      for (bb in seq_len(B)) {
        idxsHomBB <- resample(idxsHom, size=nHoms, replace=TRUE)
        hom[,bb] <- idxsHomBB
      }
    }

    # (c) Resample non-SNPs
    if (nNonSNPs > 0L) {
      for (bb in seq_len(B)) {
        idxsNonSNPBB <- resample(idxsNonSNP, size=nNonSNPs, replace=TRUE)
        nonSnp[,bb] <- idxsNonSNPBB
      }
    }

    # (d) Resampled hets
    if (nbrOfHets > 0L) {
      for (bb in seq_len(B)) {
        idxsDHBB <- dh[,bb]
        idxsHetNonDHBB <- hetNonDh[,bb]
        idxsHetBB <- c(idxsDHBB, idxsHetNonDHBB)
#        idxsHetBB <- sort(idxsHetBB)
        het[,bb] <- idxsHetBB
      }
    }

    # (e) Update TCN loci
    if (nbrOfTCNs > 0L) {
      for (bb in seq_len(B)) {
        idxsHetBB <- het[,bb]
        idxsHomBB <- hom[,bb]
        idxsNonSNPBB <- nonSnp[,bb]
        idxsTCNBB <- c(idxsHetBB, idxsHomBB, idxsNonSNPBB)
#        idxsTCNBB <- sort(idxsTCNBB)
        tcn[,bb] <- idxsTCNBB
      }
    }

    # Record
    locusSetJJ$bootstrap <- list(
      B    = B,
      loci = list(
        tcn      = tcn,
        dh       = dh,
        nonSnp   = nonSnp,
        het      = het,
        hom      = hom,
        hetNonDh = hetNonDh
      )
    )

    # Sanity check
    if (.validate) {
      loci <- locusSetJJ$loci
      lociB <- locusSetJJ$bootstrap$loci
      for (key in names(lociB)) {
        idxs <- loci[[key]]
        idxsB <- lociB[[key]]
        idxsB <- unique(sort(idxsB))
        .stop_if_not(all(is.element(idxsB, idxs)))
      }
      loci <- lociB <- NULL # Not needed anymore
    }

    verbose && exit(verbose)

    # Record
    locusSet[[jj]] <- locusSetJJ

    # Not needed anymore
    locusSetJJ <- NULL
    verbose && exit(verbose)
  } # for (jj ...)

  # Sanity checks
  .stop_if_not(is.list(locusSet))
  .stop_if_not(length(locusSet) == nbrOfSegments)

  verbose && exit(verbose)

  res$locusSet <- locusSet

  res
}, protected=TRUE) # getBootstrapLocusSets()


##############################################################################
# HISTORY
# 2013-10-22
# o Added Rdoc comments.
# o Added getBootstrapLocusSets() for PairedPSCBS.
##############################################################################

###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod bootstrapTCNandDHByRegion
#
# @title "Estimate confidence intervals of TCN and DH segment levels"
#
# \description{
#  @get "title" using bootstrap.
# }
#
# @synopsis
#
# \arguments{
#   \item{B}{A positive @integer specifying the number of bootstrap samples.}
#   \item{boot}{Alternatively, to generating \code{B} bootstrap samples,
#      this specifies a pre-generated set of bootstrap samples as
#      returned by \code{bootstrapSegmentsAndChangepoints()}.}
#   \item{...}{Additional arguments passed to \code{bootstrapSegmentsAndChangepoints()}.}
#   \item{probs}{The default quantiles to be estimated.}
#   \item{statsFcn}{A (optional) @function that estimates confidence
#      intervals given locus-level data.
#      If @NULL, the @see "stats::quantile" function is used.}
#   \item{what}{A @character @vector specifying what to bootstrap.}
#   \item{force}{If @TRUE, already existing estimates are ignored,
#      otherwise not.}
#   \item{verbose}{See @see "R.utils::Verbose".}
#   \item{.debug}{(internal) If @TRUE, additional sanity checks are
#      performed internally.}
# }
#
# \value{
#   Returns a @see "PairedPSCBS" object.
# }
#
# @author "HB"
#*/###########################################################################
setMethodS3("bootstrapTCNandDHByRegion", "PairedPSCBS", function(fit, B=1000L, boot=NULL, ..., probs=c(0.025, 0.050, 0.95, 0.975), statsFcn=NULL, what=c("segment", "changepoint"), force=FALSE, verbose=FALSE, .debug=FALSE) {
  # Settings for sanity checks
  tol <- getOption("PSCBS/sanityChecks/tolerance", 0.0005)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Local functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  summarizeSamples <- function(X, statsFcn, stats=NULL, what=c("segment", "changepoint"), ..., verbose=FALSE) {
    # Argument 'X':
    .stop_if_not(is.array(X))
    dim <- dim(X)
    .stop_if_not(length(dim) == 3L)

    # Argument 'statsFcn':
    .stop_if_not(is.function(statsFcn))
    statsT <- statsFcn(1)
    .stop_if_not(!is.null(names(statsT)))
    nbrOfStats <- length(statsT)
    statsNames <- names(statsT)
    statsT <- NULL # Not needed anymore

    # Argument 'stats':
    if (!is.null(stats)) {
      .stop_if_not(is.data.frame(stats))
    }

    # Argument 'what':
    what <- match.arg(what)
    whatC <- capitalize(what)

    # Argument 'verbose':
    verbose <- Arguments$getVerbose(verbose)
    if (verbose) {
      pushState(verbose)
      on.exit(popState(verbose))
    }


    dimnames <- dimnames(X)
    fields <- dimnames[[3L]]

    verbose && enter(verbose, sprintf("Summarizing bootstrapped %s (%s) data", what, paste(sQuote(fields), collapse=", ")))

    # Allocate JxQxF matrix S
    dim[2L] <- nbrOfStats
    dimnames[[2L]] <- statsNames
    S <- array(NA_real_, dim=dim, dimnames=dimnames)
    verbose && str(verbose, S)

    for (kk in seq_along(fields)) {
      field <- fields[kk]
      verbose && enter(verbose, sprintf("Field #%d ('%s') of %d", kk, field, length(fields)))

      Xkk <- X[,,kk,drop=FALSE] # An JxB matrix
      dim(Xkk) <- dim(Xkk)[-3L]
      # Sanity check
      .stop_if_not(is.matrix(Xkk))
      .stop_if_not(nrow(Xkk) == dim(X)[1L])
      .stop_if_not(ncol(Xkk) == B)

      for (jj in seq_len(dim(X)[1L])) {
        verbose && enter(verbose, sprintf("%s #%d of %d", whatC, jj, dim(X)[1L]))
        Xkkjj <- Xkk[jj,,drop=TRUE] # A vector of length B
        S[jj,,kk] <- statsFcn(Xkkjj)
        verbose && exit(verbose)
      } # for (jj ...)

      Xkk <- NULL # Not needed anymore

      verbose && exit(verbose)
    } # for (jj ...)

    # Not needed anymore
    X <- NULL

    verbose && cat(verbose, "Bootstrap statistics")
    verbose && str(verbose, S)

    # Reshape JxQx4 array to Jx(4*Q) matrix
    T <- wrap(S, map=list(1,NA), sep="_")
    colnames(T) <- gsub("(.*)_(.*)", "\\2_\\1", colnames(T))

    # Append as new columns to the summary table
    stats <- cbind(stats, T)

    # Drop previously estimated values
    dups <- duplicated(colnames(stats), fromLast=TRUE)
    if (any(dups)) {
      stats <- stats[,!dups, drop=FALSE]
    }

    # Not needed anymore
    T <- dups <- NULL


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Statistical sanity checks
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    if (what == "segment" && B >= 100L) {
      verbose && enter(verbose, "Statistical sanity checks (iff B >= 100)")

      .stop_if_not(is.array(S))

      # Find extreme quantiles
      probs <- dimnames(S)[[2L]]
      verbose && printf(verbose, "Available summaries: %s\n", paste(probs, collapse=", "))
      probs <- grep("%", probs, fixed=TRUE, value=TRUE)
      S <- S[,probs,,drop=FALSE]
      probs <- gsub("%", "", probs, fixed=TRUE)
      probs <- as.double(probs) / 100
      verbose && printf(verbose, "Available quantiles: %s\n", paste(probs, collapse=", "))
      verbose && str(verbose, S)
      # Sanity check
      .stop_if_not(all(is.finite(probs)))

      # Is it possible to check?
      if (any(probs < 0.10) && any(probs > 0.90)) {
        tryCatch({
          fields <- dimnames(S)[[3L]]
          for (kk in seq_along(fields)) {
            field <- fields[kk]
            verbose && enter(verbose, sprintf("Field #%d ('%s') of %d", kk, field, length(fields)))

            # Bootstrap statistics
            Skk <- S[,,kk, drop=FALSE]
            dim(Skk) <- dim(Skk)[-3L]

            # Sanity checks
            .stop_if_not(is.matrix(Skk))

            range <- Skk[,c(1L,ncol(Skk)),drop=FALSE]

            # Segmentation means
            key <- sprintf("%sMean", field)
            segMean <- segs[[key]]

            # Segmentation counts
            cfield <- sprintf("%sNbrOfLoci", ifelse(field == "tcn", "tcn", "dh"))
            counts <- segs[,cfield,drop=TRUE]

            if (verbose) {
              for (rr in seq_len(length(segMean))) {
                printf(verbose, "Seg %3d. mean=%g, range=[%g,%g], n=%d\n", rr, segMean[rr], range[rr,1L], range[rr,2L], counts[rr])
              } # for (rr ...)
            }

            # Compare only segments with enough data points
            keep <- (counts > 1L)
            range <- range[keep,,drop=FALSE]
            segMean <- segMean[keep]

            # Sanity checks
            .stop_if_not(all(range[,2L] + tol >= range[,1L], na.rm=TRUE))
            .stop_if_not(all(segMean + tol >= range[,1L], na.rm=TRUE))
            .stop_if_not(all(segMean - tol <= range[,2L], na.rm=TRUE))

            verbose && exit(verbose)
          } # for (kk ...)
        }, error = function(ex) {
          # If an error, display the data, then throw the exception
          verbose && cat(verbose, "Tolerance (option 'PSCBS/sanityChecks/tolerance'): ", tol)
          verbose && print(verbose, segs)
          stop(ex)
        })
      } else {
        verbose && cat(verbose, "Skipping. Not enough quantiles: ",
                                 paste(dimnames(S)[[2L]], collapse=", "))
      }

      verbose && exit(verbose)
    } # if (B >= 100L)


    verbose && exit(verbose)

    stats
  } # summarizeSamples()


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'B':
  B <- Arguments$getInteger(B, range=c(1,Inf))

  # Argument 'probs':
  probs <- Arguments$getNumerics(probs, range=c(0,1))
  # Always estimate the default quantiles
  probs0 <- eval(formals(bootstrapTCNandDHByRegion.PairedPSCBS)$probs, enclos = baseenv())
  probs <- unique(sort(c(probs, probs0)))

  # Argument 'statsFcn':
  if (is.null(statsFcn)) {
    statsFcn <- function(x) quantile(x, probs=probs, na.rm=TRUE)
  }

  # Argument 'what':
  what <- unique(match.arg(what, several.ok=TRUE))

  # Argument 'force':
  force <- Arguments$getLogical(force)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  # Argument '.debug':
  .debug <- Arguments$getLogical(.debug)



  verbose && enter(verbose, "Resample (TCN,DH) signals and re-estimate summaries for ", paste(what, collapse=" & "))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract existing estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.element("segment", what)) {
    segs <- getSegments(fit)
  }
  if (is.element("changepoint", what)) {
    cps <- getChangePoints(fit)
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Already done?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  stats <- statsFcn(1)
  .stop_if_not(!is.null(names(stats)))
  nbrOfStats <- length(stats)
  statsNames <- names(stats)

  if (is.element("segment", what)) {
    tcnStatsNames <- sprintf("tcn_%s", names(stats))
    dhStatsNames <- sprintf("dh_%s", names(stats))
    c1StatsNames <- sprintf("c1_%s", names(stats))
    c2StatsNames <- sprintf("c2_%s", names(stats))
    allStatsNames <- c(tcnStatsNames, dhStatsNames, c1StatsNames, c2StatsNames)
    isDone <- is.element(allStatsNames, names(segs))
    names(isDone) <- allStatsNames
    verbose && cat(verbose, "Already done?")
    verbose && print(verbose, isDone)

    # Not needed anymore
    allStatsNames <- tcnStatsNames <- dhStatsNames <-
                     c1StatsNames <- c2StatsNames <- NULL

    if (!force && all(isDone)) {
      verbose && cat(verbose, "Already done. Skipping.")
      verbose && exit(verbose)
      return(fit)
    }
  }


  # The object to be returned
  fitB <- fit

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Bootstrap (TCN,DH,C1,C2) segment mean levels
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.null(boot)) {
    boot <- bootstrapSegmentsAndChangepoints(fit, B=B, ...,
                         force=force, .debug=.debug, verbose=verbose)
  } else {
    B <- dim(boot$segments)[2L]
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Summarizing segment (TCN,DH,C1,C2) mean levels
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.element("segment", what)) {
    segs <- summarizeSamples(boot$segments, statsFcn=statsFcn, stats=segs, what="segment", verbose=verbose)
    # Record statistics
    fitB$output <- segs
    segs <- NULL # Not needed anymore
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Summarizing change point (alpha, radius, manhattan, d1, d2) data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.element("changepoint", what)) {
    cps <- summarizeSamples(boot$changepoints, statsFcn=statsFcn, stats=cps, what="changepoint", verbose=verbose)
    # Record statistics
    fitB$changepoints <- cps
    cps <- NULL # Not needed anymore
  }

  # Not needed anymore
  fit <- boot <- NULL

  verbose && exit(verbose)

  fitB
}, private=TRUE) # bootstrapTCNandDHByRegion()





#   \item{by}{A @character specifying whether DH should be calculated from
#      normalized ('betaTN') or non-normalized ('betaT') tumor BAFs.}
#   \item{seed}{(optional) A random seed.}
#
#
# \value{
#   Returns a named @list containing two @arrays of bootstrap samples.
#   These arrays also contains the original observation as the first
#   element before the actual bootstrap samples.
# }
setMethodS3("bootstrapSegmentsAndChangepoints", "PairedPSCBS", function(fit, B=1000L, by=c("betaTN", "betaT"), seed=NULL, force=FALSE, cache=FALSE, verbose=FALSE, .debug=FALSE, ...) {
  # Settings for sanity checks
  tol <- getOption("PSCBS/sanityChecks/tolerance", 0.0005)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'B':
  B <- Arguments$getInteger(B, range=c(1,Inf))

  # Argument 'by':
  by <- match.arg(by)

  # Argument 'seed':
  if (!is.null(seed)) {
    seed <- Arguments$getInteger(seed)
  }

  # Argument '.cache':
  cache <- Arguments$getLogical(cache)

  # Argument 'force':
  force <- Arguments$getLogical(force)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  # Argument '.debug':
  .debug <- Arguments$getLogical(.debug)



  verbose && enter(verbose, "Bootstrapping (TCN,DH,C1,C2) segment mean levels")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Check for cached results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  key <- list(method="bootstrapSegmentsAndChangepoints", class=class(fit)[1L],
              fit=fit, B=B, by=by, seed=seed)
  dirs <- c("PSCBS", "bootstrap")
  boot <- loadCache(key=key, dirs=dirs)
  if (!force && !is.null(boot)) {
    verbose && cat(verbose, "Found cached results. Skipping.")
    verbose && exit(verbose)
    return(boot)
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Set the random seed
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (!is.null(seed)) {
    randomSeed("set", seed=seed, kind="L'Ecuyer-CMRG")
    on.exit(randomSeed("reset"), add=TRUE)
    verbose && printf(verbose, "Random seed temporarily set (seed=%d)\n", seed)
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  tcnSegRows <- fit$tcnSegRows
  dhSegRows <- fit$dhSegRows
  segs <- getSegments(fit)
  params <- fit$params

  # Sanity checks
  .stop_if_not(all(!is.na(data$chromosome) & !is.na(data$x)))

  # Sanity checks
  if (!params$joinSegments) {
    stop("Cannot bootstrap TCN and DH by segments unless PSCNs are segmented using joinSegments=TRUE.")
  }
  if (regexpr(",", params$flavor, fixed=TRUE) != -1L) {
    stop(sprintf("Cannot bootstrap TCN and DH by segments if PSCNs are segmented using flavor=\"%s\".", params$flavor))
  }
  # Sanity check (same as above, but just in case)
  .stop_if_not(all(segs$tcnStart == segs$dhStart, na.rm=TRUE))
  .stop_if_not(all(segs$tcnEnd == segs$dhEnd, na.rm=TRUE))



  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Find estimators
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Get mean estimators used
  estList <- getMeanEstimators(fit, c("tcn", "dh"))
  avgTCN <- estList$tcn
  avgDH <- estList$dh
  estList <- NULL # Not needed anymore


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Get signals
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Get (x,TCN,BAF) data
  chromosome <- data$chromosome
  x <- data$x
  CT <- data$CT
  betaT <- data[[by]]
  muN <- data$muN
  rho <- data$rho


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Classify each locus as (i) heterozygous SNP, (ii) homozygous SNP,
  # or (iii) non-polymorphic loci
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Identifying heterozygous & homozygous SNPs and non-polymorphic loci")
  nbrOfLoci <- length(CT)
  verbose && cat(verbose, "Number of loci: ", nbrOfLoci)

  # Identify SNPs
  hasDH <- !is.null(rho)
  if (hasDH) {
    isHet <- !is.na(rho)
    isSnp <- isHet
  } else {
    isSnp <- (!is.na(muN) & !is.na(betaT))
    isHet <- (isSnp & (muN == 1/2))
  }

  snps <- which(isSnp)
  nonSNPs <- which(!isSnp)
  nbrOfSNPs <- sum(isSnp)
  nbrOfNonSNPs <- sum(!isSnp)
  verbose && cat(verbose, "Number of SNPs: ", nbrOfSNPs)
  verbose && cat(verbose, "Number of non-SNPs: ", nbrOfNonSNPs)

  # Sanity checks
  .stop_if_not(length(intersect(snps, nonSNPs)) == 0L)

  # Heterozygous SNPs
  hets <- which(isSnp &  isHet)
  homs <- which(isSnp & !isHet)
  nbrOfHets <- length(hets)
  nbrOfHoms <- length(homs)

  if (!hasDH) {
    verbose && printf(verbose, "Number of heterozygous SNPs: %d (%.2f%%)\n",
                                        nbrOfHets, 100*nbrOfHets/nbrOfSNPs)
    verbose && printf(verbose, "Number of homozygous SNPs: %d (%.2f%%)\n",
                                        nbrOfHoms, 100*nbrOfHoms/nbrOfSNPs)
  }

  # Sanity checks
  .stop_if_not(length(intersect(hets, homs)) == 0L)
  .stop_if_not(nbrOfHets + nbrOfHoms == nbrOfSNPs)

  # Sanity checks
  .stop_if_not(length(isSnp) == nbrOfLoci)
  .stop_if_not(length(isHet) == nbrOfLoci)

  # Not needed anymore
  muN <- isSnp <- NULL
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Precalculate DH signals
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.null(rho)) {
    # Calculate DHs for heterozygous SNPs
    rho <- 2*abs(betaT - 1/2)

    # DH is by definition only defined for heterozygous SNPs.
    # For simplicity, we set it to be NA for non-heterozygous loci.
    rho[!isHet] <- NA_real_

    data$rho <- rho
  }

  # Not needed anymore
  betaT <- isHet <- NULL


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Resample (TCN,DH) within each segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegments <- nrow(segs)

  # Allocate JxBx4 matrix M of bootstrap means
  dim <- c(nbrOfSegments, B, 4L)
  dimnames <- list(NULL, NULL, c("tcn", "dh", "c1", "c2"))
  M <- array(NA_real_, dim=dim, dimnames=dimnames)
  verbose && str(verbose, M)

  # Identify all loci with non-missing signals
  idxsCT <- which(!is.na(CT))
  idxsRho <- which(!is.na(rho))

  # Vectorized pre-adjustments
  for (field in c("tcnNbrOfLoci", "dhNbrOfLoci")) {
    counts <- segs[[field]]
    counts[is.na(counts)] <- 0L
    segs[[field]] <- counts
  }

  hasTcnLoci <- (is.finite(tcnSegRows[,1L]) & is.finite(tcnSegRows[,2L]))
  hasDhLoci <- (is.finite(dhSegRows[,1L]) & is.finite(dhSegRows[,2L]))

  # Identify "splitter" segments which have no data
  chrs <- segs[["chromosome"]]
  tcnIds <- segs[["tcnId"]]
  dhIds <- segs[["dhId"]]
  tcnMeans <- segs[["tcnMean"]]
  dhMeans <- segs[["dhMean"]]
  isSplitter <- (is.na(chrs) & is.na(tcnIds) & is.na(dhIds))

  # Get all segment indices except for "splitters"
  jjs <- seq_len(nbrOfSegments)
  jjs <- jjs[!isSplitter]

  for (jj in jjs) {
    chr <- chrs[jj]
    tcnId <- tcnIds[jj]
    dhId <- dhIds[jj]

    verbose && enter(verbose, sprintf("Segment #%d (chr %d, tcnId=%d, dhId=%d) of %d", jj, chr, tcnId, dhId, nbrOfSegments))

    # Sanity check
    if (.debug) .stop_if_not(!is.na(chr) && !is.na(tcnId) && !is.na(dhId))

    # Get the segment data
    segJJ <- segs[jj,,drop=FALSE]
    verbose && print(verbose, segJJ)

    nbrOfTCNs <- segJJ[,"tcnNbrOfLoci"]
    nbrOfDHs <- segJJ[,"dhNbrOfLoci"]
    verbose && cat(verbose, "Number of TCNs: ", nbrOfTCNs)
    verbose && cat(verbose, "Number of DHs: ", nbrOfDHs)
    if (.debug) {
      .stop_if_not(!is.na(nbrOfTCNs))
      .stop_if_not(!is.na(nbrOfDHs))
    }

    tcnSegRowJJ <- unlist(tcnSegRows[jj,], use.names=FALSE)
    dhSegRowJJ <- unlist(dhSegRows[jj,], use.names=FALSE)

    # Indices of all loci
    if (hasTcnLoci[jj]) {
      idxsAll <- tcnSegRowJJ[1L]:tcnSegRowJJ[2L]
    } else {
      idxsAll <- 0L
    }

    verbose && str(verbose, idxsAll)
    verbose && print(verbose, hpaste(idxsAll), level=-120)
    verbose && str(verbose, idxsCT)
    verbose && print(verbose, hpaste(idxsCT), level=-120)

    # Keep only loci with finite TCNs
    idxsAll <- intersect(idxsAll, idxsCT)
    verbose && str(verbose, idxsAll)
    verbose && print(verbose, hpaste(idxsAll), level=-120)

    # Sanity check
    if (length(idxsAll) != nbrOfTCNs) {
      verbose && str(verbose, setdiff(idxsCT, idxsAll))
      stop("INTERNAL ERROR: length(idxsAll) != nbrOfTCNs: ", length(idxsAll), " != ", nbrOfTCNs)
    }


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Identify loci used to calculate DH means
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    verbose && enter(verbose, "Identify loci used to bootstrap DH means")

    if (hasDhLoci[jj]) {
      idxsDH <- dhSegRowJJ[1L]:dhSegRowJJ[2L]
      idxsDH <- intersect(idxsDH, hets)
      # Drop missing values
      idxsDH <- intersect(idxsDH, idxsRho)
    } else {
      idxsDH <- 0L
    }

    verbose && cat(verbose, "Heterozygous SNPs to resample for DH:")
    verbose && str(verbose, idxsDH)

    # Sanity check
    if (.debug) .stop_if_not(length(idxsDH) == nbrOfDHs)

    verbose && exit(verbose)



    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Identify loci used to calculate TCN means
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    verbose && enter(verbose, "Identify loci used to bootstrap TCN means")

    # Identify SNPs and non-SNPs
    idxsSNP <- intersect(snps, idxsAll)
    idxsNonSNP <- setdiff(idxsAll, idxsSNP)
    verbose && cat(verbose, "SNPs:")
    verbose && str(verbose, idxsSNP)
    verbose && cat(verbose, "Non-polymorphic loci:")
    verbose && str(verbose, idxsNonSNP)
    # Sanity check
    if (.debug) .stop_if_not(length(idxsSNP) + length(idxsNonSNP) == length(idxsAll))

    # Identify heterozygous and homozygous SNPs
    idxsHet <- intersect(idxsSNP, hets)
    if (nbrOfHoms > 0) {
      idxsHom <- intersect(idxsSNP, homs)
    } else {
      ## Happens when only DH is available
      idxsHom <- integer(0L)
    }

    # Drop missing values
    idxsNonSNP <- intersect(idxsNonSNP, idxsCT)
    idxsHet <- intersect(idxsHet, idxsCT)
    idxsHom <- intersect(idxsHom, idxsCT)
    idxsHetNonDH <- setdiff(idxsHet, idxsDH)

    verbose && cat(verbose, "Heterozygous SNPs to resample for TCN:")
    verbose && str(verbose, idxsHet)
    verbose && cat(verbose, "Homozygous SNPs to resample for TCN:")
    verbose && str(verbose, idxsHom)
        verbose && cat(verbose, "Non-polymorphic loci to resample for TCN:")
    verbose && str(verbose, idxsNonSNP)
    verbose && cat(verbose, "Heterozygous SNPs with non-DH to resample for TCN:")
    verbose && str(verbose, idxsHetNonDH)
    # Note that length(idxsHetNonDH) may differ from zero in case CT is non-missing
    # but rho is missing, e.g. CT = sum(c(thetaA,thetaB), na.rm=TRUE) and
    # thetaB is missing. /HB 2010-12-01

    idxsTCN <- sort(unique(c(idxsHet, idxsHom, idxsNonSNP)))
    verbose && cat(verbose, "Loci to resample for TCN:")
    verbose && str(verbose, idxsTCN)

    # Sanity check
    if (.debug) {
      .stop_if_not(length(idxsHet) + length(idxsHom) + length(idxsNonSNP) == nbrOfTCNs)
      .stop_if_not(length(intersect(idxsDH, idxsHetNonDH)) == 0L)
      .stop_if_not(length(idxsTCN) == nbrOfTCNs)
    }

    verbose && exit(verbose)


    # These numbers should be preserved when the resampling
    verbose && printf(verbose, "Number of (#hets, #homs, #nonSNPs): (%d,%d,%d)\n",
                      length(idxsHet), length(idxsHom), length(idxsNonSNP))


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Sanity checks
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    if (nbrOfTCNs > 0L) {
      # Sanity check
      ys <- CT[idxsTCN]
      mu <- avgTCN(ys, na.rm=TRUE)
      dMu <- (mu - tcnMeans[jj])
      if (abs(dMu) > tol) {
        str(list(nbrOfTCNs=nbrOfTCNs, tcnNbrOfLoci=segJJ$tcnNbrOfLoci, mu=mu, tcnMean=tcnMeans[jj], dMu=dMu, "abs(dMu)"=abs(dMu), "range(x[units])"=range(x[idxsTCN])))
        stop(sprintf("INTERNAL ERROR: Incorrectly recalculated TCN mean for Segment #%d (chr %d, tcnId=%d, dhId=%d): %g != %g", jj, chr, tcnId, dhId, mu, tcnMeans[jj]))
      }
    }

    shouldHaveDHs <- (nbrOfDHs > 0L && !is.na(dhMeans[jj]))
    if (shouldHaveDHs) {
      # Sanity check
      ys <- rho[idxsDH]
      mu <- avgDH(ys, na.rm=TRUE)
      dMu <- (mu - dhMeans[jj])
      if (abs(dMu) > tol) {
        str(list(nbrOfDHs=nbrOfDHs, dhNbrOfLoci=segJJ$dhNbrOfLoci, mu=mu, dhMean=dhMeans[jj], dMu=dMu, "abs(dMu)"=abs(dMu), "range(x[units])"=range(x[idxsDH])))
        stop(sprintf("INTERNAL ERROR: Incorrectly recalculated DH mean for Segment #%d (chr %d, tcnId=%d, dhId=%d): %g != %g", jj, chr, tcnId, dhId, mu, dhMeans[jj]))
      }
    }


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Bootstrap while preserving (#hets, #homs, #nonSNPs)
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    verbose && enter(verbose, "Bootstrapping while preserving (#hets, #homs, #nonSNPs)")
    verbose && cat(verbose, "Number of bootstrap samples: ", B)

    if (!shouldHaveDHs) {
      idxsHetNonDH <- idxsDH
    }

    nHoms <- length(idxsHom)
    nNonSNPs <- length(idxsNonSNP)
    nHetNonDHs <- length(idxsHetNonDH)

    # Defaults
    idxsDHBB <- NULL

    # Bootstrap B times
    for (bb in seq_len(B)) {
      # (1) Bootstrap DHs
      if (shouldHaveDHs) {
        # (a) Resample heterozygous SNPs (=> resampled DH units)
        idxsDHBB <- resample(idxsDH, size=nbrOfDHs, replace=TRUE)

        # Extract signals
        rhoBB <- rho[idxsDHBB]

        # Calculate bootstrap mean
        M[jj,bb,"dh"] <- avgDH(rhoBB, na.rm=TRUE)
      } # if (shouldHaveDHs)

      # (2) Bootstrap TCNs
      if (nbrOfTCNs > 0L) {
        # (a) Resample non-DH hets SNPs
        idxsHetNonDHBB <- resample(idxsHetNonDH, size=nHetNonDHs, replace=TRUE)
        idxsHetBB <- c(idxsDHBB, idxsHetNonDHBB)

        # (a) Resample homozygous SNPs
        if (nbrOfHoms > 0) {
          idxsHomBB <- resample(idxsHom, size=nHoms, replace=TRUE)
        } else {
          idxsHomBB <- integer(0L)
        }

        # (b) Resample non-SNPs
        idxsNonSNPBB <- resample(idxsNonSNP, size=nNonSNPs, replace=TRUE)

        # (c) Resampled TCN units
        idxsTCNBB <- c(idxsHetBB, idxsHomBB, idxsNonSNPBB)

        # Sanity check
        if (.debug) {
          .stop_if_not(length(intersect(idxsDHBB, idxsHetNonDHBB)) == 0L)
          .stop_if_not(length(intersect(idxsHetBB, idxsHomBB)) == 0L)
          .stop_if_not(length(intersect(idxsHetBB, idxsNonSNPBB)) == 0L)
          .stop_if_not(length(intersect(idxsHomBB, idxsNonSNPBB)) == 0L)
        }

        # Extract signals
        CTBB <- CT[idxsTCNBB]

        # Calculate bootstrap mean
        M[jj,bb,"tcn"] <- avgTCN(CTBB, na.rm=TRUE)
      } # if (nbrOfTCNs > 0L)
    } # (for bb ...)
    verbose && exit(verbose)

    verbose && exit(verbose)
  } # for (jj ...)

  verbose && cat(verbose, "Bootstrapped segment mean levels")
  verbose && str(verbose, M)

  # Sanity check
  .stop_if_not(all(!is.nan(M)))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Add (C1,C2) bootstrap mean levels
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Calculating (C1,C2) mean levels from (TCN,DH) mean levels")
  C1 <- (1-M[,,"dh", drop=FALSE]) * M[,,"tcn", drop=FALSE] / 2
  C2 <- M[,,"tcn", drop=FALSE] - C1
  M[,,"c1"] <- C1
  M[,,"c2"] <- C2
  verbose && str(verbose, M)
  # Sanity check
  .stop_if_not(dim(M)[1L] == nbrOfSegments)
  .stop_if_not(all(!is.nan(M)))
  # Not needed anymore
  C1 <- C2 <- NULL
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Bootstrap polar (alpha,radius,manhattan) for change points
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Calculating polar (alpha,radius,manhattan) for change points")
  C <- M[,,c("c1","c2"), drop=FALSE]

  # Calculate difference
  # (will be empty if nbrOfSegments == 1, but that's ok/intended)
  D <- C[-nbrOfSegments,,, drop=FALSE] - C[-1L,,, drop=FALSE]
  # Sanity check
  .stop_if_not(dim(D)[1L] == nbrOfSegments-1L)
  .stop_if_not(all(!is.nan(D)))
  C <- NULL # Not needed anymore

  # Allocate array
  dimnames <- dimnames(D)
  dimnames[[3L]] <- c("alpha", "radius", "manhattan", "d1", "d2")
  dim <- dim(D)
  dim[3L] <- length(dimnames[[3L]])
  P <- array(NA_real_, dim=dim, dimnames=dimnames)
  .stop_if_not(dim(P)[1L] == nbrOfSegments-1L)

  if (nbrOfSegments >= 2L) {
    verbose && str(verbose, D)
    P[,,"alpha"] <- atan2(D[,,2], D[,,1]) # Changepoint angles in (0,2*pi)
    P[,,"radius"] <- sqrt(D[,,2]^2 + D[,,1]^2)
    P[,,"manhattan"] <- abs(D[,,2]) + abs(D[,,1])
    P[,,"d1"] <- D[,,1]
    P[,,"d2"] <- D[,,2]
  }
  alpha <- D <- NULL # Not needed anymore
  verbose && cat(verbose, "Bootstrapped change points")
  verbose && str(verbose, P)

  # Sanity check
  .stop_if_not(dim(P)[1L] == nbrOfSegments-1L)
  .stop_if_not(all(!is.nan(P)))
  verbose && exit(verbose)

  boot <- list(segments=M, changepoints=P)

  # Cache?
  if (cache) {
    saveCache(boot, key=key, dirs=dirs)
    verbose && cat(verbose, "Saved results to cache.")
  }

  verbose && exit(verbose)

  boot
}, private=TRUE) # bootstrapSegmentsAndChangepoints()



setMethodS3("findBootstrapSummaries", "PairedPSCBS", function(fit, what=c("segment", "changepoint"), ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'what':
  what <- match.arg(what)

  if (what == "segment") {
    data <- getSegments(fit)
  } else if (what == "changepoint") {
    data <- getChangePoints(fit)
  }

  grep("^[^_]+_[^_]+$", colnames(data), value=TRUE)
}, protected=TRUE) # findBootstrapSummaries()


setMethodS3("hasBootstrapSummaries", "PairedPSCBS", function(fit, ...) {
  fields <- findBootstrapSummaries(fit, ...)
  (length(fields) > 0L)
})

setMethodS3("clearBootstrapSummaries", "PairedPSCBS", function(fit, what=c("segment", "changepoint"), ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'what':
  what <- unique(match.arg(what, several.ok=TRUE))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Clearing bootstrap summaries")

  whats <- what
  for (what in whats) {
    verbose && enter(verbose, sprintf("Clearing %ss", what))

    fields <- findBootstrapSummaries(fit, what=what, ...)
    if (what == "segment") {
      data <- getSegments(fit)
      data <- data[,!is.element(colnames(data), fields)]
      fit$output <- data
    } else if (what == "changepoint") {
      data <- getChangePoints(fit)
      data <- data[,!is.element(colnames(data), fields)]
      fit$changepoints <- data
    }
    # Sanity check
    fields <- findBootstrapSummaries(fit, what=what, ...)
    .stop_if_not(length(fields) == 0L)

    data <- fields <- NULL # Not needed anymoew

    verbose && exit(verbose)
  } # for (what ...)

  verbose && exit(verbose)

  fit
}, protected=TRUE) # clearBootstrapSummaries()


##############################################################################
# HISTORY
# 2013-10-22
# o SPEEDUP: Added argument 'cache' to bootstrapSegmentsAndChangepoints(),
#   which caches the results to file if cache=TRUE.
# 2013-10-21
# o Added find-, has- and clearBootstrapSummaries().
# o Added argument 'what' to bootstrapTCNandDHByRegion().
# o BUG FIX: The new bootstrapSegmentsAndChangepoints() would give
#   "Error in D[, , 2] : incorrect number of dimensions" if bootstrapping
#   was done on a single change point (==two segments).
# 2013-10-20
# o Now utilizing new getChangePoints().
# o Now calculating change-point angles in (0,2*pi) using atan2().
# o Added bootstrapSegmentsAndChangepoints(), which was extract from
#   internal code of bootstrapTCNandDHByRegion().  The latter now
#   utilizes the former.
# o BUG FIX: bootstrapTCNandDHByRegion() did not identify segment
#   "splitters" as intended.  This has had no impact on the results.
# 2013-04-23
# o SPEEDUP: Made bootstrapTCNandDHByRegion() much faster by adding
#   use.names=FALSE to two internal unlist() statements.
# 2013-04-22
# o Added argument 'probs' to bootstrapTCNandDHByRegion().
# 2013-04-09
# o Added Rdoc comments.
# 2013-02-09
# o BUG FIX: bootstrapTCNandDHByRegion() for PairedPSCBS did not bootstrap
#   for all available loci when calculating total CNs statistics, iff
#   the segment had been called run-of-homozygosity (ROH).
#   Thanks to Oscar Rueda at the Cancer Research UK Cambridge Institute
#   for reporting on this.
# 2013-02-07
# o Improved some verbose outputs of bootstrapTCNandDHByRegion().
# 2013-01-15
# o Now bootstrapTCNandDHByRegion() uses the params$avgTCN and params$avgDH
#   estimators, iff given.
# 2012-11-05
# o GENERALIZATION: Now bootstrapTCNandDHByRegion() works for more "flavors",
#   including the default ('tcn') used by segmentByNonPairedPSCBS().
# 2012-09-20
# o SPEEDUP: By default bootstrapTCNandDHByRegion() for PairedPSCBS no
#   longer do sanity checks within the bootstrap loop.  This significantly
#   speed up the method.  To run checks, use argument .debug=TRUE.
# 2012-02-26
# o BUG FIX: bootstrapTCNandDHByRegion() for PairedPSCBS would resample
#   from a subset of the intended TCNs, iff the DH mean was non-finite
#   while there were still heterozygous SNPs.  This introduced a bias in
#   the estimates, which was neglectable for large segments, but for very
#   small segments (a few loci) it could be relatively large.
# 2012-02-24
# o BUG FIX: bootstrapTCNandDHByRegion(..., force=TRUE) for PairedPSCBS
#   would give an error iff previous bootstrap estimates already existed.
# o Added argument 'force' to bootstrapTCNandDHByRegion().
# 2011-11-26
# o Now bootstrapTCNandDHByRegion() for PairedPSCBS preserves NAs for DH
#   and (C1,C2) quantiles, if the DH mean level is NA, which can happen
#   when a segment is called ROH.
# o An internal sanity check of bootstrapTCNandDHByRegion() for PairedPSCBS
#   would give an error if DH mean levels had been set to NA for segments
#   called ROH.
# 2011-11-24
# o BUG FIX: bootstrapTCNandDHByRegion() for PairedPSCBS would give
#   an error, if a segment did not have any TCN signals, which can
#   occur when known segments are specified for Paired PSCBS.
# 2011-08-08
# o Moved the sanity checks that tests the TCN and DH "segRows" from the
#   bootstrapTCNandDHByRegion() to segmentByPairedPSCBS().  This is the
#   first step to fix a failure in the sanity checks that could happend
#   iff one first run dropSegmentationOutliers().
# 2011-06-14
# o Updated code to recognize new column names.
# 2011-05-29
# o Renamed options to reflect new package name.
# 2010-12-03
# o BUG FIX: In rare cases the bootstrap sanity checks can indeed produce
#   an invalid 'range', more precisely where (range[,2] >= range[,1]) is
#   not true.  This can happen if there is no variation in the bootstrap
#   estimates.  Beause of this we allow for some tolerance.
# 2010-12-02
# o Now bootstrapTCNandDHByRegion() uses option
#   "psCBS/sanityChecks/tolerance".
# 2010-12-01
# o BUG FIX: bootstrapTCNandDHByRegion() did not always exclude the correct
#   loci.
# 2010-11-27
# o BUG FIX: bootstrapTCNandDHByRegion() would incorrectly include
#   non-polymorphic loci in the set of homozygous SNPs during resampling.
# 2010-11-26
# o BUG FIX: The statistical sanity checks of the bootstrap estimates would
#   give an error when only single-sided bootstrap confidence interval was
#   calculated.
# 2010-11-23
# o ROBUSTNESS: Added more sanity checks to bootstrapTCNandDHByRegion().
# o WORKAROUND: The precision of the mean levels of DNAcopy::segment()
#   is not great enough to always compare it to that of R's estimates.
# o BUG FIX: bootstrapTCNandDHByRegion() would give an error if there was
#   only one segment.
# 2010-11-22
# o BUG FIX: The DH segmentation and bootstrap incorrectly included
#   missing values, when subseting.
# o BUG FIX: Some sanity checks were incorrect.
# o BUG FIX: bootstrapTCNandDHByRegion() for PairedPSCBS would not correctly
#   detect if bootstrap results are already available.
# 2010-11-21
# o Added argument 'seed'.
# o Added bootstrapTCNandDHByRegion() for PairedPSCBS.
# o Created from PairedPSCBS.BOOT.R.
##############################################################################

setMethodS3("extractLocusLevelC1C2", "PairedPSCBS", function(fit, ...) {
  # Extract locus-level data
  data <- getLocusData(fit)
  C <- data$CT
  rho <- data$rho

  # Swapped (C1,C2) <-> (C2,C1) for some segments?
  fields <- colnames(getSegments(fit))
  if (is.element("c1c2Swap", fields)) {
    # FIXME: When PSCBS is updated.
    # WORKAROUND: extractSegmentDataByLocus() in PSCBS v0.40.4 requires:
    # that fields "chromosome", "tcnStart", "tcnEnd" are always requested
    # /2014-03-21
    c1c2Swap <- extractSegmentDataByLocus(fit, fields=c("c1c2Swap",
                                     "chromosome", "tcnStart", "tcnEnd"))
    c1c2Swap <- c1c2Swap[["c1c2Swap"]]
    if (any(c1c2Swap)) {
      rho[c1c2Swap] <- -rho[c1c2Swap]
    }
  }

  C1 <- 1/2*(1-rho)*C
  C2 <- C - C1

  data.frame(C1=C1, C2=C2)
}, private=TRUE) # extractLocusLevelC1C2()


setMethodS3("extractLocusLevelTCN", "PairedPSCBS", function(fit, ...) {
  data <- getLocusData(fit)
  C <- data$CT
}, private=TRUE) # extractLocusLevelTCN()



setMethodS3("extractDhSegment", "PairedPSCBS", function(fit, idx, what=c("hets", "SNPs", "all"), ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'what':
  what <- match.arg(what)


  segs <- getSegments(fit, splitters=TRUE)
  .stop_if_not(!is.null(segs))
  nbrOfSegments <- nrow(segs)

  # Argument 'idx':
  idx <- Arguments$getIndex(idx, max=nbrOfSegments)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }



  verbose && enter(verbose, "Extracting a specific DH segment")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the data and segmentation results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  .stop_if_not(!is.null(data))

  segs <- getSegments(fit, splitters=TRUE)
  .stop_if_not(!is.null(segs))

  verbose && enter(verbose, "Subsetting segment")
  # Subset the region-level data
  seg <- segs[idx,,drop=FALSE]

  isDivider <- all(is.na(seg))
  if (isDivider) {
    verbose && cat("Cannot extract DH segment. Not a valid segment: ", idx)
    verbose && exit(verbose)
    return(NULL)
  }

  verbose && print(verbose, seg)
  verbose && cat(verbose, "Number of TCN markers: ", sum(seg[["tcnNbrOfLoci"]], na.rm=TRUE))
  verbose && exit(verbose)

  verbose && enter(verbose, "Subsetting data")
  units <- seq_len(nrow(data))

  # Keep only chromosome of interest
  chr <- as.numeric(seg[,"chromosome"])
  if (!is.na(chr)) {
    keep <- which(data$chromosome == chr)
    units <- units[keep]
    data <- data[keep,]
  }

  # Keep only loci within the segment
  xRange <- as.numeric(seg[,c("dhStart", "dhEnd")])
  keep <- which(xRange[1] <= data$x & data$x <= xRange[2])
  units <- units[keep]
  data <- data[keep,]

  muN <- data$muN
  isSnp <- is.finite(muN)

  # Keep only SNPs?
  if (is.element(what, c("SNPs", "hets"))) {
    keep <- which(isSnp)
    units <- units[keep]
    data <- data[keep,]
  }

  # Keep only heterozygous SNPs?
  if (what == "hets") {
    isHet <- (muN == 1/2)
    keep <- which(isHet)
    units <- units[keep]
    data <- data[keep,]
  }
  verbose && exit(verbose)

  n <- nrow(data)
  verbose && cat(verbose, "Number of loci in DH segment: ", n)

  # Special case?
  listOfDhLociNotPartOfSegment <- fit$listOfDhLociNotPartOfSegment
  if (!is.null(listOfDhLociNotPartOfSegment)) {
    tcnId <- seg[,"tcnId"]
    dhId <- seg[,"dhId"]
    dhLociNotPartOfSegment <- listOfDhLociNotPartOfSegment[[tcnId]]
    if (!is.null(dhLociNotPartOfSegment)) {
      lociToExclude <- dhLociNotPartOfSegment[[dhId]]
      verbose && cat(verbose, "Excluding loci that belongs to a flanking segment: ", length(lociToExclude))
      drop <- match(lociToExclude, units)
      units <- units[-drop]
      data <- data[-drop,]
      n <- nrow(data)
    }
  }

  verbose && cat(verbose, "Number of units: ", n)
  verbose && cat(verbose, "Number of TCN markers: ", seg[,"tcnNbrOfLoci"])

  # Sanity check
  if (what == "hets" && n > 0) .stop_if_not(n == seg[,"dhNbrOfLoci"])

  fitS <- fit
  fitS$data <- data
  fitS$output <- seg

  verbose && exit(verbose)

  fitS
}, protected=TRUE) # extractDhSegment()

###########################################################################/**
# @set "class=AbstractCBS"
# @RdocDocumentation "Restructuring AbstractCBS objects"
# @alias RestructPSCBS
#
# \description{
#   This page describes available methods for restructuring an
#   @see "AbstractCBS" object.
#
#   \itemize{
#     \item @seemethod "extractChromosomes" /
#           @seemethod "extractChromosome"
#           - Extracts an @see "AbstractCBS" with the specified chromosomes.
#
#     \item @seemethod "extractSegments" /
#           @seemethod "extractSegment"
#           - Extracts an @see "AbstractCBS" with the specified segments.
#
#     \item @seemethod "extractRegions" /
#           @seemethod "extractRegion"
#           - Extracts an @see "AbstractCBS" with the specified regions
#             each of a certain size, where a region is defined as a
#             connected set of segments.
#
#     \item @seemethod "dropRegions" /
#           @seemethod "dropRegion"
#           - Drops specified regions and returns an @see "AbstractCBS"
#             without them.
#
#     \item @seemethod "dropChangePoint" /
#           @seemethod "mergeTwoSegments"
#           - Drops a change point by merging two neighboring segments
#             and recalculates the statistics for the merged segment
#             before returning an @see "AbstractCBS".
#
#     \item @seemethod "dropChangePoints"
#           - Drops zero or more change points
#             and recalculates the segment statistics
#             before returning an @see "AbstractCBS".
#
#     \item @seemethod "mergeThreeSegments"
#           - Merges a segment with its two flanking segments
#             and recalculates the statistics for the merged segment
#             before returning an @see "AbstractCBS".
#   }
#
#   All of the above methods are implemented for @see "CBS" and
#   @see "PairedPSCBS" objects.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################


setMethodS3("renameChromosomes", "AbstractCBS", function(fit, from, to, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'from' & 'to':
  from <- Arguments$getIntegers(from, disallow=c("NaN", "Inf"))
  n <- length(from)
  to <- Arguments$getIntegers(to, disallow=c("NaN", "Inf"), length=c(n,n))


  # Nothing to do?
  if (n == 0) {
    return(fit)
  }

  data <- getLocusData(fit)
  segs <- getSegments(fit, splitters=TRUE, simplify=FALSE)
  knownSegments <- fit$params$knownSegments

  for (cc in seq_len(n)) {
    chr <- from[cc]
    chrN <- to[cc]
    data$chromosome[data$chromosome == chr] <- chrN
    segs$chromosome[segs$chromosome == chr] <- chrN
    knownSegments$chromosome[knownSegments$chromosome == chr] <- chrN
  } # for (cc ...)

  fit <- setLocusData(fit, data)
  fit <- setSegments(fit, segs)
  fit$params$knownSegments <- knownSegments

  fit
}, protected=TRUE) # renameChromosomes()


setMethodS3("extractChromosomes", "AbstractCBS", abstract=TRUE, protected=TRUE)


setMethodS3("extractChromosome", "AbstractCBS", function(x, chromosome, ...) {
  # To please R CMD check
  this <- x

  # Argument 'chromosome':
  chromosome <- Arguments$getInteger(chromosome, disallow=c("NaN", "Inf"))

  extractChromosomes(this, chromosomes=chromosome, ...)
}, protected=TRUE)



setMethodS3("extractSegments", "AbstractCBS", abstract=TRUE, protected=TRUE)

setMethodS3("extractSegment", "AbstractCBS", function(this, idx, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'region':
  idx <- Arguments$getIndex(idx, max=nbrOfSegments(this, splitters=TRUE))

  extractSegments(this, idxs=idx, ...)
}, private=TRUE) # extractSegment()


setMethodS3("extractRegions", "AbstractCBS", function(this, regions, H=1, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegments <- nbrOfSegments(this, splitters=TRUE)

  # Argument 'regions':
  regions <- Arguments$getIndices(regions, max=nbrOfSegments)

  # Argument 'H':
  H <- Arguments$getInteger(H, range=c(0,Inf))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Extract regions of a certain length")

  verbose && cat(verbose, "Left-most segments of regions to be extracted:")
  verbose && str(verbose, regions)
  verbose && cat(verbose, "Number of segments in each region: ", H)


  # Identify segments to keep
  Hs <- seq_len(H)
  regions <- regions - 1L
  regions <- as.list(regions)
  segments <- lapply(regions, FUN=function(region) region + Hs)
  segments <- unlist(segments, use.names=FALSE)
  segments <- sort(unique(segments))
  verbose && cat(verbose, "Final set of segments to be extracted:")
  verbose && str(verbose, segments)

  res <- extractSegments(this, idxs=segments, ...)

  verbose && exit(verbose)

  res
}, protected=TRUE) # extractRegions()



setMethodS3("extractRegion", "AbstractCBS", function(this, region, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'region':
  region <- Arguments$getIndex(region, max=nbrOfSegments(this, splitters=TRUE))

  extractRegions(this, regions=region, ...)
}, private=TRUE) # extractRegion()



###########################################################################/**
# @RdocMethod mergeTwoSegments
# @aliasmethod dropChangePoint
#
# @title "Merge two neighboring segments"
#
# \description{
#   @get "title" into one segment, which is done by dropping their
#   common change point and recalculating the segment statistics.
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Not used.}
# }
#
# \value{
#   Returns an @see "AbstractCBS" of the same class with one less segment.
# }
#
# @author "HB"
#
# \seealso{
#   To merge a segment and its two flanking segments, see
#   @seemethod "mergeThreeSegments".
#   To drop regions (a connected set of segments)
#   see @seemethod "dropRegions".
#   @seeclass
# }
#*/###########################################################################
setMethodS3("mergeTwoSegments", "AbstractCBS", abstract=TRUE, protected=TRUE)


setMethodS3("dropChangePoint", "AbstractCBS", function(fit, idx, ...) {
  # Argument 'idx':
##  max <- nbrOfChangePoints(fit, splitters=TRUE, ...)
  max <- nbrOfSegments(fit, splitters=TRUE, ...) - 1L
  idx <- Arguments$getIndex(idx, max=max)

  mergeTwoSegments(fit, left=idx, ...)
}, protected=TRUE)




###########################################################################/**
# @RdocMethod dropChangePoints
#
# @title "Drops zero or more change points"
#
# \description{
#   @get "title", which is done by dropping one change point at the
#   time using @seemethod "dropChangePoint"
#   and recalculating the segment statistics at the end.
#
#   \emph{NOTE: This method only works if there is only one chromosome.}
# }
#
# @synopsis
#
# \arguments{
#  \item{idxs}{An @integer @vector specifying the change points to be dropped.}
#  \item{update}{If @TRUE, segment statistics are updated.}
#  \item{...}{Other arguments passed to @seemethod "dropChangePoint"
#             and @seemethod "updateMeans".}
# }
#
# \value{
#   Returns an @see "AbstractCBS" of the same class with
#   \code{length(idxs)} segments.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#*/###########################################################################
setMethodS3("dropChangePoints", "AbstractCBS", function(fit, idxs, update=TRUE, ...) {
  # Assert that there is only one chromosome
  chrs <- getChromosomes(fit)
  if (length(chrs) > 1) {
    stop("dropChangePoints() only support single-chromosome data: ", hpaste(chrs))
  }

  # Argument 'idxs':
##  max <- nbrOfChangePoints(fit, splitters=TRUE, ...)
  max <- nbrOfSegments(fit, splitters=TRUE, ...) - 1L
  idxs <- Arguments$getIndices(idxs, max=max)


  # Drop change points one by one
  idxs <- unique(idxs)
  idxs <- sort(idxs, decreasing=TRUE)
  for (ii in seq_along(idxs)) {
    idx <- idxs[ii]
    updateI <- update && (ii == length(idxs))
    fit <- dropChangePoint(fit, idx=idx, update=updateI, ...)
  }

  # Update segment statistics?
  if (update) {
    fit <- updateMeans(fit, ...)
  }

  fit
}, protected=TRUE)



###########################################################################/**
# @RdocMethod mergeThreeSegments
#
# @title "Merge a segment and its two flanking segments"
#
# \description{
#   @get "title" into one segment, and recalculating the segment statistics.
# }
#
# @synopsis
#
# \arguments{
#  \item{middle}{An @integer specifying the three segments
#    (middle-1, middle, middle+1) to be merged.}
#  \item{...}{Additional arguments passed to @seemethod "mergeTwoSegments".}
# }
#
# \value{
#   Returns an @see "AbstractCBS" of the same class with two less segment.
# }
#
# @author "HB"
#
# \seealso{
#   Internally @seemethod "mergeTwoSegments" is used.
#   @seeclass
# }
#*/###########################################################################
setMethodS3("mergeThreeSegments", "AbstractCBS", function(fit, middle, ...) {
  # Argument 'middle':
  S <- nbrOfSegments(fit, splitters=TRUE)
  middle <- Arguments$getIndex(middle, range=c(2L, S))

  # Assert that the three segments are on the same chromosome
  idxs <- middle + c(-1L, 0L, +1L)
  fitT <- extractSegments(fit, idxs)
  chrs <- getChromosomes(fitT)
  if (length(chrs) != 1L) {
    stop("Argument 'middle' specifies a segment that is at the very end of a chromosome: ", middle)
  }
  fitT <- NULL # Not needed anymore

  fit <- mergeTwoSegments(fit, left=middle, ...)
  fit <- mergeTwoSegments(fit, left=middle-1L, ...)
  fit
}) # mergeThreeSegments()



###########################################################################/**
# @RdocMethod dropRegions
# @aliasmethod dropRegion
#
# @title "Drops chromosomal regions (a connected set of segments)"
#
# \description{
#   @get "title" each of a certain size (number of segments).
#   \emph{None of the statistics are recalculated}.
# }
#
# @synopsis
#
# \arguments{
#  \item{regions}{An @integer @vector of length R specifying the indices
#    of the left most segment in each of the R regions to be dropped.}
#  \item{H}{A non-negative @integer specifying the size of each region,
#    i.e. the number of segments per region.}
#  \item{...}{Additional arguments passed to @seemethod "extractRegions".}
#  \item{asMissing}{If @TRUE, dropped segments are replaced by missing values,
#    otherwise they are truly dropped.}
#  \item{verbose}{A @logical or a @see "R.utils::Verbose" object.}
# }
#
# \value{
#   Returns an @see "AbstractCBS" object of the same class with (at most)
#   R*H segments dropped.
#   If some regions overlap (share segments), then fewer than R*H segments
#   are dropped.
# }
#
# @author "HB"
#
# \seealso{
#   Internally @seemethod "extractRegions" is used.
#   See also @seemethod "dropChangePoint" and @seemethod "mergeTwoSegments".
#   @seeclass
# }
#*/###########################################################################
setMethodS3("dropRegions", "AbstractCBS", function(this, regions, H=1, ..., asMissing=FALSE, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegments <- nbrOfSegments(this, splitters=TRUE)
  # Argument 'regions':
  regions <- Arguments$getIndices(regions, max=nbrOfSegments)

  # Argument 'H':
  H <- Arguments$getInteger(H, range=c(0,Inf))

  # Argument 'asMissing':
  asMissing <- Arguments$getLogical(asMissing)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Dropping regions of a certain length")

  verbose && cat(verbose, "Left-most segments of regions to be dropped:")
  verbose && str(verbose, regions)
  verbose && cat(verbose, "Number of segments in each region: ", H)

  # Nothing to do?
  if (H == 0) {
    verbose && cat(verbose, "Nothing to do. No segments will be dropped.")
    verbose && exit(verbose)
    return(this)
  }

  # Identify segments to drop
  Hs <- seq_len(H)
  regions <- regions - 1L
  regions <- as.list(regions)
  regions <- lapply(regions, FUN=function(region) region + Hs)
  regions <- unlist(regions, use.names=FALSE)
  regions <- sort(unique(regions))
  verbose && cat(verbose, "Final set of segments to be dropped:")
  verbose && str(verbose, regions)

  # Identify segments to keep
  allRegions <- seq_len(nbrOfSegments)
  keepSegments <- setdiff(allRegions, regions)
  verbose && cat(verbose, "Final set of segments to be kept:")
  verbose && str(verbose, keepSegments)

  dropped <- extractRegions(this, regions=regions, ...)
  res <- this
  if (length(regions) > 0) {
    if (asMissing) {
      segs <- getSegments(res, splitters=TRUE)
      pattern <- "(chromosome|id|start|end)$"

      # TODO/AD HOC: Should be class specific /HB 2011-10-17
      pattern <- "(chromosome|id)$"
      excl <- grep(pattern, colnames(segs), ignore.case=TRUE, invert=TRUE)
      segs[regions,excl] <- NA
      res$output <- segs

      # TODO/AD HOC: Should be class specific /HB 2011-10-17
      for (ff in grep("segRows", names(res), ignore.case=TRUE, value=TRUE)) {
        res[[ff]][regions,] <- NA
      }
    } else {
      res <- extractRegions(res, regions=keepSegments, ...)
    }
  }
  res$dropped <- dropped

  # Sanity check
  if (asMissing) {
    .stop_if_not(nbrOfSegments(res, splitters=TRUE) == nbrOfSegments(this, splitters=TRUE))
  } else {
    .stop_if_not(nbrOfSegments(res, splitters=TRUE) + length(regions) == nbrOfSegments(this, splitters=TRUE))
  }

  verbose && exit(verbose)

  res
}, protected=TRUE)


setMethodS3("dropRegion", "AbstractCBS", function(fit, region, ...) {
  # Argument 'region':
  region <- Arguments$getIndex(region)

  dropRegions(fit, regions=region, ...)
}, protected=TRUE)


setMethodS3("shiftTCN", "AbstractCBS", abstract=TRUE, protected=TRUE)

###########################################################################/**
# @RdocClass PairedPSCBS
#
# @title "The PairedPSCBS class"
#
# \description{
#  @classhierarchy
#
#  A PairedPSCBS is an object containing the results from the
#  Paired PSCBS method.
# }
#
# \usage{PairedPSCBS(fit=list(), ...)}
#
# \arguments{
#   \item{fit}{A @list structure containing the Paired PSCBS results.}
#   \item{...}{Not used.}
# }
#
# \section{Fields and Methods}{
#  @allmethods "public"
# }
#
# @author "HB"
#
# \seealso{
#   The @see "segmentByPairedPSCBS" method returns an object of this class.
# }
#*/###########################################################################
setConstructorS3("PairedPSCBS", function(fit=list(), ...) {
  # Argument 'fit':
  if (!is.list(fit)) {
    stop("Argument 'fit' is not a list: ", class(fit)[1])
  }

  extend(PSCBS(fit=fit, ...), "PairedPSCBS")
})

setMethodS3("getLocusData", "PairedPSCBS", function(fit, ..., fields=c("asis", "full")) {
  # Argument 'fields':
  fields <- match.arg(fields)


  data <- NextMethod("getLocusData", fields="asis")


  if (fields == "full") {
    names <- colnames(data)

    # Genotype calls
    if (!is.element("muN", names)) {
      if (is.element("rho", names)) {
        data$muN <- rep(NA_real_, times=length(data$rho))
        data$muN[is.finite(data$rho)] <- 1/2
      } else if (is.element("betaN", names)) {
        data$muN <- callNaiveGenotypes(data$betaN)
      } else {
        stop("Cannot identify heterozygous SNPs or genotypes")
      }
    }

    data$isHet <- (data$muN == 1/2)

    # BACKWARD COMPATIBILITY: If 'rho' does not exists, calculate
    # it on the fly from 'betaT'.
    # NOTE: This should give an error in the future. /HB 2013-10-25
    if (is.null(data$rho)) {
      data$rho <- 2*abs(data$betaT-1/2)
      data$rho[!data$isHet] <- NA_real_
      warning("Locus-level DH signals ('rho') did not exist and were calculated from tumor BAFs ('betaT')")
    }
    data$c1 <- 1/2*(1-data$rho)*data$CT
    data$c2 <- data$CT - data$c1

    # TumorBoost BAFs
    if (!is.element("rhoN", names)) {
      if (!is.element("betaTN", names) && is.element("betaN", names)) {
        data$betaTN <- normalizeTumorBoost(betaN=data$betaN, betaT=data$betaT, muN=data$muN)
      }

      if (is.element("betaTN", names)) {
        data$rhoN <- 2*abs(data$betaTN-1/2)
        data$rhoN[!data$isHet] <- NA_real_
        data$c1N <- 1/2*(1-data$rhoN)*data$CT
        data$c2N <- data$CT - data$c1N
      }

      if (all(is.element(c("betaN", "betaT"), names))) {
        data$isSNP <- (!is.na(data$betaT) | !is.na(data$betaN))
        data$type <- ifelse(data$isSNP, "SNP", "non-polymorphic locus")
      }
    }

    # Labels
    data$muNx <- c("AA", "AB", "BB")[2*data$muN + 1L]
    data$isHetx <- c("AA|BB", "AB")[data$isHet + 1L]
  }

  data
}, protected=TRUE) # getLocusData()



setMethodS3("resegment", "PairedPSCBS", function(fit, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Resegmenting a ", class(fit)[1], " object")

  # Use the locus-level data of the PairedPSCBS object
  data <- getLocusData(fit)
  class(data) <- "data.frame"
  drop <- c("rho", "betaTN", "index")
  keep <- !is.element(colnames(data), drop)
  data <- data[,keep]
  verbose && str(verbose, data)

  verbose && cat(verbose, "Number of loci: ", nrow(data))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup arguments to be passed
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Overriding default arguments")
  segFcnName <- "segmentByPairedPSCBS"
  segFcn <- getMethodS3(segFcnName, "default")

  # (a) The default arguments
  formals <- formals(segFcn)

  formals <- formals[!sapply(formals, FUN=is.language)]
  formals <- formals[!sapply(formals, FUN=is.name)]
  drop <- c("chromosome", "x", "w", "CT", "thetaT", "thetaN", "betaT", "betaN", "muN", "rho", "preserveScale", "...")
  keep <- !is.element(names(formals), drop)
  formals <- formals[keep]

  # (b) The arguments used in previous fit
  params <- fit$params
  keep <- is.element(names(params), names(formals))
  params <- params[keep]
  # Don't trust 'tbn'!  TODO. /HB 20111117
  params$tbn <- NULL

  # (c) The arguments in '...'
  userArgs <- list(..., verbose=verbose)

  # (d) Merge
  args <- formals
  args2 <- c(params, userArgs)
  for (kk in seq_along(args2)) {
    value <- args2[[kk]]
    if (!is.null(value)) {
      key <- names(args2)[kk]
      if (!is.null(key)) {
        args[[key]] <- value
      } else {
        args <- c(args, list(value))
      }
    }
  } # for (key ...)
  verbose && str(verbose, args[names(args) != "verbose"])

  verbose && enter(verbose, sprintf("Calling %s()", segFcnName))
  args <- c(list(data), args)
  verbose && cat(verbose, "Arguments:")
  verbose && str(verbose, args[names(args) != "verbose"])
  verbose && exit(verbose)

  fit <- do.call(segFcnName, args)
  verbose && exit(verbose)

  verbose && exit(verbose)

  fit
}, protected=TRUE) # resegment()


setMethodS3("adjustPloidyScale", "PairedPSCBS", function(fit, scale, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # (a) Update locus-level data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  names <- c("CT")
  for (ff in names) {
    data[[ff]] <- scale * data[[ff]]
  }
  fit$data <- data ##  fit <- setLocusData(fit, data)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # (b) Update segment-level data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  segs <- getSegments(fit)

  # Adjust segment levels
  names <- grep("^(tcn|c1|c2)(Mean|_.*%)$", names(segs), value=TRUE)
  for (ff in names) {
    segs[[ff]] <- scale * segs[[ff]]
  }

  # Clear segment calls
  names <- c("lohCall", "ntcnCall")
  for (ff in names) {
    segs[[ff]] <- NULL
  }
  fit$output <- segs ## fit <- setSegments(fit, sets)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # (c) Update parameter estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  params <- fit$params
  fields <- c("copyNeutralStats", "deltaCN", "ntcnRange", "deltaLowC1")
  params[fields] <- NULL
  fit$params <- params

  fit
}, protected=TRUE) # adjustPloidyScale()


##############################################################################
# HISTORY
# 2014-03-30
# o Update resegment() for PairedPSCBS to handle 'thetaT' and 'thetaN'.
# 2013-10-25
# o BUG FIX: The 'rho' signals returned by getLocusData(..., fields="full")
#   for PairedPSCBS would have values also for homozygote SNPs.
# 2013-03-08
# o Added getLocusData() for PairedPSCBS.
# 2012-04-21
# o CLEANUP: Moved getSegmentSizes() from PairedPSCBS to PSCBS.
# 2011-11-21
# o BUG FIX: resegment() was trying to call segmentByCBS() instead
#   of segmentByPairedPSCBS().
# 2011-11-17
# o Added resegment() for PairedPSCBS for easy resegmentation.
# 2011-10-02
# o CLEANUP: Moved print() and as.data.frame() to PSCBS.
# o Added Rdoc help.
# o Now the constructor of PairedPSCBS calls that of PSCBS.
# 2011-06-28
# o DOCUMENTATION: Added Rd help for as.data.frame() of PairedPSCBS.
# 2011-04-08
# o Added formal constructor for the PairedPSCBS class.
# o Created.
##############################################################################

###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod callAB
# @aliasmethod callAllelicBalance
#
# @title "Calls segments that are in allelic balance"
#
# \description{
#  @get "title", i.e. that have equal minor and major copy numbers.
# }
#
# @synopsis
#
# \arguments{
#   \item{flavor}{A @character string specifying which type of
#    call to use.}
#   \item{...}{Additional arguments passed to the caller.}
#   \item{minSize}{An optional @integer specifying the minimum number
#    of data points in order to call a segments.  If fewer data points,
#    then the call is set to @NA regardless.}
#   \item{xorCalls}{If @TRUE, a region already called LOH, will
#    for consistency never be called AB, resulting in either an AB
#    call set to @FALSE or @NA (as explained below).}
#   \item{force}{If @FALSE, and allelic-balance calls already exits,
#    then nothing is done, otherwise the calls are done.}
# }
#
# \value{
#   Returns a @see "PairedPSCBS" object with allelic-balance calls.
# }
#
# \section{AB and LOH consistency}{
#   Biologically, a segment can not be both in allelic balance (AB) and
#   in loss-of-heterozygosity (LOH) at the same time.
#   To avoid reporting such inconsistencies, the LOH caller will,
#   if argument \code{xorCalls=TRUE}, never report a segment to be in
#   LOH if it is already called to be in AB.
#   However, regardless of of the AB call, a segment is still always
#   tested for LOH, to check weather the LOH caller is consistent with the
#   AB caller or not.  Thus, in order to distinguish the case where
#   the AB caller and LOH caller agree from when they disagree,
#   we report either (AB,LOH)=(TRUE,FALSE) or (TRUE,NA).  The former is
#   reported when they are consistent, and the latter when they are not,
#   or when the AB caller could not call it.
# }
#
# @author "HB"
#
# \seealso{
#   Internally, one of the following methods are used:
#   @seemethod "callAllelicBalanceByDH".
# }
#
#*/###########################################################################
setMethodS3("callAB", "PairedPSCBS", function(fit, flavor=c("DeltaAB*"), ..., minSize=1, xorCalls=TRUE, force=FALSE) {
  # Argument 'flavor':
  flavor <- match.arg(flavor)

  # Argument 'minSize':
  minSize <- Arguments$getDouble(minSize, range=c(1,Inf))

  # Argument 'xorCalls':
  xorCalls <- Arguments$getLogical(xorCalls)


  # Already done?
  segs <- as.data.frame(fit)
  calls <- segs$abCall
  if (!force && !is.null(calls)) {
    return(invisible(fit))
  }

  if (flavor == "DeltaAB*") {
    fit <- callAllelicBalanceByDH(fit, ...)
  } else {
    stop("Cannot call allelic balance. Unsupported flavor: ", flavor)
  }

  # Don't call segments with too few data points?
  if (minSize > 1) {
    segs <- as.data.frame(fit)
    ns <- segs$dhNbrOfLoci
    calls <- segs$abCall
    calls[ns < minSize] <- NA
    segs$abCall <- calls
    fit$output <- segs
    # Not needed anymore
    segs <- calls <- NULL
  }

  # Don't call a segment AB if it already called LOH?
  if (xorCalls) {
    segs <- as.data.frame(fit)
    if (is.element("lohCall", names(segs))) {
      calls <- segs$abCall
      otherCalls <- segs$lohCall
      # If called (TRUE) and already called (TRUE)
      # by the other caller, call it as NA.
      calls[calls & otherCalls] <- NA
      segs$abCall <- calls
      fit$output <- segs
    }
  }

  return(invisible(fit))
})

setMethodS3("callAllelicBalance", "default", function(...) {
  callAB(...)
})



###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod callAllelicBalanceByDH
#
# @title "Calls segments that are in allelic balance"
#
# \description{
#  @get "title" by thresholding on DH using a predetermined threshold.
#  The variability of the DH mean levels is taken into account via a
#  bootstrap estimator.
# }
#
# @synopsis
#
# \arguments{
#   \item{flavor}{A @character string specifying which type of
#    call to use.}
#   \item{delta}{(Tuning parameter) A non-negative @numeric threshold.}
#   \item{alpha}{A @numeric in [0,1] specifying the upper and lower
#     quantiles calculated by the bootstrap estimator.}
#   \item{...}{Additional arguments passed to the bootstrap estimator
#     @seemethod "bootstrapTCNandDHByRegion".}
# }
#
# \value{
#   Returns a @see "PairedPSCBS" object with allelic-balance calls.
# }
#
# @author "HB"
#
# \section{Algorithm}{
#  \itemize{
#    \item Foo
#    \item Bar
#  }
# }
#
# \seealso{
#   Instead of calling this method explicitly, it is recommended
#   to use the @seemethod "callAllelicBalance" method.
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("callAllelicBalanceByDH", "PairedPSCBS", function(fit, delta=estimateDeltaAB(fit, flavor="qq(DH)"), alpha=0.05, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'delta':
  delta <- Arguments$getDouble(delta, range=c(0,Inf))

  # Argument 'alpha':
  alpha <- Arguments$getDouble(alpha, range=c(0,1))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Calling segments of allelic balance from one-sided DH bootstrap confidence intervals")
  verbose && cat(verbose, "delta (offset adjusting for bias in DH): ", delta)
  verbose && cat(verbose, "alpha (CI quantile; significance level): ", alpha)

  # Calculate DH confidence intervals, if not already done
  probs <- c(alpha, 1-alpha)
  fit <- bootstrapTCNandDHByRegion(fit, probs=probs, ..., verbose=less(verbose, 50))

  segs <- as.data.frame(fit)

  # Extract confidence interval
  alphaTag <- sprintf("%g%%", 100*alpha)
  column <- sprintf("dh_%s", alphaTag)
  # Sanity checks
  .stop_if_not(is.element(column, colnames(segs)))

  # One-sided test
  verbose && enter(verbose, "Calling segments")
  value <- segs[,column, drop=TRUE]
  call <- (value < delta)
  nbrOfCalls <- sum(call, na.rm=TRUE)
  verbose && printf(verbose, "Number of segments called allelic balance (AB): %d (%.2f%%) of %d\n", nbrOfCalls, 100*nbrOfCalls/nrow(segs), nrow(segs))
  verbose && exit(verbose)

  segs$abCall <- call
  fit$output <- segs

  # Append 'delta' and 'alpha' to parameters
  params <- fit$params
  params$deltaAB <- delta
  params$alphaAB <- alpha
  fit$params <- params

  verbose && exit(verbose)

  fit
}, protected=TRUE) # callAllelicBalanceByDH()






##############################################################################
# HISTORY
# 2012-01-15
# o DOCUMENTATION: Added details to the help of callLOH() and callAB() on
#   the difference between (AB,LOH)=(TRUE,FALSE) and (AB,LOH)=(TRUE,NA).
# 2011-07-07
# o BUG FIX: Consecutive calls to callAB(..., force=TRUE) would append
#   additional 'abCall' columns to the segmentation table instead of
#   replacing existing calls.
# 2011-06-14
# o Updated code to recognize new column names.
# 2011-05-29
# o Renamed all arguments, variables, function named 'tau' to 'delta'.
# 2011-04-14
# o BUG FIX: Argument 'minSize' of callAB() and callLOH() had no effect.
# 2011-04-12
# o Added argument 'minSize' to callAB() for PairedPSCBS.
# o Added argument 'xorCalls' to callAB() for PairedPSCBS.
# 2011-04-10
# o callAllelicBalance() calls callAB().
# 2011-04-09
# o Now callAllelicBalance(..., force=FALSE) skips the caller if allelic-
#   balance calls already exist.
# 2011-04-08
# o Added Rdoc for callAllelicBalance() and callAllelicBalanceByDH().
# o Extracted from PairedPSCBS.CALL.R.
# 2011-02-03
# o Updated default for 'tauAB' of callABandHighAI() and callABandLowC1()
#   to be estimated from data using estimateTauAB().
# 2010-12-07
# o Added callLowC1ByC1() and callABandLowC1().
# 2010-11-27
# o Corrected verbose output to call results.
# 2010-11-26 [HB]
# o Now all call functions estimate symmetric bootstrap quantiles for
#   convenince of plotting confidence intervals.
# o BUG FIX: callABandHighAI() for PairedPSCBS used the old DH-only
#   bootstrap method.
# o BUG FIX: The call functions, for instance callABandHighAI(), would throw
#   'Error in quantile.default(x, probs = alpha) : missing values and NaN's
#   not allowed if 'na.rm' is FALSE' unless bootstrapTCNandDHByRegion() was
#   run before.
# 2010-11-22 [HB]
# o Added more verbose output to callABandHighAI().
# o Updated callAllelicBalanceByDH() and callExtremeAllelicImbalanceByDH()
#   to utilize bootstrapTCNandDHByRegion().
# 2010-10-25 [HB]
# o Relaced argument 'ciRange' with 'alpha' for callAllelicBalanceByDH() and
#   callExtremeAllelicImbalanceByDH().
# o Renamed callAllelicBalance() to callAllelicBalanceByDH() and
#   callExtremeAllelicImbalanceByDH() to callExtremeAllelicImbalance().
# o Added arguments 'alphaAB' and 'alphaHighAI' to callABandHighAI().
# o Added sanity checks to the call methods.
# o Now arguments '...' to callABandHighAI() are passed down.
# o Now also arguments '...' to callAllelicBalance() and
#   callExtremeAllelicImbalance() are passed to bootstrapDHByRegion().
# o Added argument 'ciRange' to callAllelicBalance() and
#   callExtremeAllelicImbalance().
# 2010-09-16 [HB]
# o Added callABandHighAI().
# o Added callAllelicBalance() and callExtremeAllelicImbalance().
# o Created.
##############################################################################

library("PSCBS")
library("stats")

message("weightedQuantile() ...")

if (requireNamespace("Hmisc")) {
  message(" - assert identical results to Hmisc::wtd.quantile()")
  wtd.quantile <- Hmisc::wtd.quantile
  for (kk in 1:100) {
    n <- 5L + sample.int(995, size = 1L)
    x <- rnorm(n, mean = 0.0, sd = 1.0)
    w <- runif(n, min = 0.5, max = 2.0) ## Non-normalized weights
    probs <- c(0.0, 0.25, 0.50, 0.75, 1.0)
    q0 <- wtd.quantile(x, weights = w, probs = probs, normwt = TRUE)
    q <- weightedQuantile(x, w = w, probs = probs)
    if (!isTRUE(all.equal(q, q0))) {
      print(q0)
      print(q)
      stopifnot(all.equal(q, q0))
    }
  }
}

message("weightedQuantile() ... DONE")

###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod estimateKappa
#
# @title "Estimate global background in segmented copy numbers"
#
# \description{
#  @get "title".
#  The global background, here called \eqn{\kappa},
#  may have multiple origins where normal contamination is one,
#  but not necessarily the only one.
# }
#
# @synopsis
#
# \arguments{
#   \item{flavor}{A @character string specifying which type of
#    estimator to use.}
#   \item{...}{Additional arguments passed to the estimator.}
# }
#
# \value{
#   Returns the background estimate as a @numeric scalar.
# }
#
# @author "HB"
#
# \seealso{
#   Internally, one of the following methods are used:
#   @seemethod "estimateKappaByC1Density".
# }
#
#*/###########################################################################
setMethodS3("estimateKappa", "PairedPSCBS", function(this, flavor=c("density(C1)"), ...) {
  # Argument 'flavor':
  flavor <- match.arg(flavor)

  if (flavor == "density(C1)") {
    estimateKappaByC1Density(this, ...)
  } else {
    stop("Cannot estimate background. Unsupported flavor: ", flavor)
  }
})



###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod estimateKappaByC1Density
#
# @title "Estimate global background in segmented copy numbers"
#
# \description{
#  @get "title" based on the location of peaks in a weighted
#  density estimator of the minor copy number mean levels.
#
#  The global background, here called \eqn{\kappa},
#  may have multiple origins where normal contamination is one,
#  but not necessarily the only one.
#
#  \emph{Assumptions:}  This estimator assumes that there are segments
#  with C1=0 and C1=1, i.e. some deletions and, typically, some normal
#  segements.
# }
#
# @synopsis
#
# \arguments{
#   \item{typeOfWeights}{A @character string specifying how weights
#    are calculated.}
#   \item{adjust}{A @numeric scale factor specifying the size of
#    the bandwidth parameter used by the density estimator.}
#   \item{from}{A @numeric scalar specifying the lower bound for the
#    support of the estimated density.}
#   \item{minDensity}{A non-negative @numeric threshold specifying
#    the minimum density a peak should have in order to consider
#    it a peak.}
#   \item{...}{Not used.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns the background estimate as a @numeric scalar.
# }
#
# \section{Algorithm}{
#  \itemize{
#  \item Retrieve segment-level minor copy numbers and corresponding weights:
#   \enumerate{
#    \item Grabs the segment-level C1 estimates.
#    \item Calculate segment weights.
#          The default (\code{typeOfWeights="dhNbrOfLoci"}) is to use
#          weights proportional to the number of heterozygous SNPs.
#          An alternative (\code{typeOfWeights="sqrt(dhNbrOfLoci)"}) is
#          to use the square root of those counts.
#   }
#
#  \item Identify subset of regions with C1=0:
#   \enumerate{
#    \item Estimates the weighted empirical density function
#          (truncated at zero below).  Tuning parameter 'adjust'.
#    \item Find the first two peaks
#          (with a density greater than tuning parameter 'minDensity').
#    \item Assumes that the two peaks corresponds to C1=0 and C1=1.
#    \item Defines threshold Delta0.5 as the center location between
#          these two peaks.
#   }
#
#  \item Estimate the global background signal:
#   \enumerate{
#    \item For all segments with C1 < Delta0.5, calculate the weighted
#          median of their C1:s.
#    \item Let kappa be the above weighted median.
#          This is the estimated background.
#   }
#  }
# }
#
# @author "HB"
#
# \seealso{
#   Instead of calling this method explicitly, it is recommended
#   to use the @seemethod "estimateKappa" method.
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("estimateKappaByC1Density", "PairedPSCBS", function(this, typeOfWeights=c("dhNbrOfLoci", "sqrt(dhNbrOfLoci)"), adjust=1, from=0, minDensity=0.2, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'typeOfWeights':
  typeOfWeights <- match.arg(typeOfWeights)

  # Argument 'adjust':
  adjust <- Arguments$getDouble(adjust, range=c(0,Inf))

  # Argument 'minDensity':
  minDensity <- Arguments$getDouble(minDensity, range=c(0,Inf))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Estimate global background (including normal contamination and more)")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the region-level estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  segs <- this$output
  c1 <- segs$c1Mean
  .stop_if_not(!is.null(c1))
  n <- segs$dhNbrOfLoci

  # Drop missing values
  keep <- (!is.na(c1) & !is.na(n))
  c1 <- c1[keep]
  n <- n[keep]

  verbose && cat(verbose, "Number of segments: ", length(c1))

  # Calculate region weights
  if (typeOfWeights == "dhNbrOfLoci") {
    w <- n
  } else if (typeOfWeights == "sqrt(dhNbrOfLoci)") {
    w <- sqrt(n)
  }

  # Standardize weights to sum to one
  weights <- w / sum(w)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Identify subset of regions with C1=0 and C1=1
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Estimating threshold Delta0.5 from the empirical density of C1:s")
  verbose && cat(verbose, "adjust: ", adjust)
  verbose && cat(verbose, "minDensity: ", minDensity)
  ploidy <- ploidy(this)
  verbose && cat(verbose, "ploidy: ", ploidy)
  if (ploidy != 2) {
    minDensity <- (2/ploidy)*minDensity
    verbose && cat(verbose, "minDensity (adjusted for ploidy): ", minDensity)
  }

  d <- density(c1, weights=weights, adjust=adjust, from=from, na.rm=FALSE)
  fit <- findPeaksAndValleys(d)

  type <- NULL; rm(list="type") # To please R CMD check
  fit <- subset(fit, type == "peak")
  if (nrow(fit) < 2L) {
    stop(sprintf("Less than two modes were found in the empirical density of C1: %d", nrow(fit)))
  }
  nModes <- nrow(fit)

  fit <- subset(fit, density >= minDensity)
  if (nrow(fit) < 2L) {
    stop(sprintf("Less than two modes were found in the empirical density of C1 after removing %d modes that are too weak (density < %g): %d", nModes - nrow(fit), minDensity, nrow(fit)))
  }
  nModes <- nrow(fit)
  verbose && cat(verbose, "All peaks:")
  verbose && print(verbose, fit)

  # Keep the first two peaks
  fit <- fit[1:2,,drop=FALSE]
  verbose && cat(verbose, "C1=0 and C1=1 peaks:")
  verbose && print(verbose, fit)

  peaks <- fit$x
  Delta0.5 <- mean(peaks)
  verbose && cat(verbose, "Estimate of Delta0.5: ", Delta0.5)

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Estimate kappa
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  keep <- which(c1 < Delta0.5)
  verbose && cat(verbose, "Number of segments with C1 < Delta0.5: ", length(keep))
  kappa <- weightedMedian(c1[keep], w=weights[keep])

  # Adjust for ploidy
  kappa <- (2/ploidy)*kappa
  verbose && cat(verbose, "Estimate of kappa: ", kappa)

  verbose && exit(verbose)

  kappa
}, protected=TRUE) # estimateKappaByC1Density()

###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod estimateDeltaAB
#
# @title "Estimate a threshold for calling allelic balance from DH"
#
# \description{
#  @get "title" to be used by the @seemethod "callAB" method.
# }
#
# @synopsis
#
# \arguments{
#   \item{scale}{An optional @numeric scale factor.}
#   \item{flavor}{A @character string specifying which type of
#    estimator to use.}
#   \item{...}{Additional arguments passed to the estimator.}
#   \item{max}{(Optional) The maximum estimate allowed. If greater than 
#    this value, the estimate will be truncated.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns the threshold estimate as a @numeric scalar.
# }
#
# @author "HB"
#
# \seealso{
#   Internally, one of the following methods are used:
#   @seemethod "estimateDeltaABBySmallDH",
#   @seemethod "estimateStdDevForHeterozygousBAF",
#   @seemethod "estimateMeanForDH", and
#   @seemethod "estimateHighDHQuantileAtAB".
# }
#
#*/###########################################################################  
setMethodS3("estimateDeltaAB", "PairedPSCBS", function(this, scale=NULL, flavor=c("qq(DH)", "q(DH)", "mad(hBAF)", "median(DH)"), ..., max=Inf, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  # Argument 'flavor':
  flavor <- match.arg(flavor)

  # Argument 'max':
  max <- Arguments$getDouble(max, range=c(0,Inf))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Estimating DH threshold for calling allelic imbalances")
  verbose && cat(verbose, "flavor: ", flavor)

  if (flavor == "mad(hBAF)") {
    if (is.null(scale)) scale <- 3
    verbose && cat(verbose, "scale: ", scale)
    # sigma = mad(hBAF) = 1.4826*median(|hBAF-m|),
    # where m = median(hBAF) ~= 1/2
    sd <- estimateStdDevForHeterozygousBAF(this, ..., verbose=verbose)
    verbose && printf(verbose, "sd: %.3g\n", sd)
    delta <- scale * sd
  } else if (flavor == "median(DH)") {
    if (is.null(scale)) scale <- 3
    verbose && cat(verbose, "scale: ", scale)
    # sigma = 1/2*1.4826*median(|hBAF-1/2|), 
    # because DH = 2*|hBAF-1/2|
    mu <- estimateMeanForDH(this, ..., verbose=verbose)
    verbose && printf(verbose, "mu: %.3g\n", mu)
    sd <- 1/2 * 1.4826 * mu
    verbose && printf(verbose, "sd: %.3g\n", sd)
    delta <- scale * sd
  } else if (flavor == "q(DH)") {
    if (is.null(scale)) scale <- 1
    verbose && cat(verbose, "scale: ", scale)
    delta <- estimateHighDHQuantileAtAB(this, scale=scale, ..., verbose=verbose)
  } else if (flavor == "qq(DH)") {
    if (is.null(scale)) scale <- 1
    verbose && cat(verbose, "scale: ", scale)
    delta <- estimateDeltaABBySmallDH(this, ..., verbose=verbose)
    delta <- scale * delta
  } else {
    stop("Unkown flavor: ", flavor)
  }

##   } else if (flavor == "DHskew") {
##     fit <- this
##     if (is.null(fit$output$dhSkew)) {
##       verbose && enter(verbose, "Estimating DH skewness for each segment")
##       fit <- applyByRegion(fit, FUN=.addTcnDhStatitics, verbose=less(verbose, 5))
##       verbose && exit(verbose)
##     }
##     mu <- fit$output$dhMean
##     skew <- fit$output$dhSkew
## 
##     deltaSkew <- -0.55
##     keep <- which(skew < deltaSkew)
##     verbose && printf(verbose, "Number of segments heavily skewed (< %.3f): %d\n", deltaSkew, length(keep))
##     # Sanity check
##     if (length(keep) == 0) {
##       stop("Cannot estimate DH threshold for AB. No segments with strong skewness exists.")
##     }
##     deltaDH <- median(mu[keep], na.rm=TRUE)
##     verbose && printf(verbose, "deltaDH: %.3g\n", deltaDH)
##     deltaDH <- 1.10*deltaDH
##     verbose && printf(verbose, "Adjusted +10%% deltaDH: %.3g\n", deltaDH)
## 
##     # sigma = 1/2*1.4826*median(|hBAF-1/2|), 
##     # because DH = 2*|hBAF-1/2|
##     mu <- estimateMeanForDH(this, delta=deltaDH, ...)
##     verbose && printf(verbose, "mu: %.3g\n", mu)
##     sd <- 1/2 * 1.4826 * mu
##     verbose && printf(verbose, "sd: %.3g\n", sd)
##  }

  verbose && printf(verbose, "Estimated delta: %.3g\n", delta)

  # Truncate estimate?
  if (delta > max) {
    warning("Estimated delta (%.3g) was greater than the maximum allowed value (%.3g).  The latter will be used instead.", delta, max)
    delta <- max
    verbose && printf(verbose, "Max delta: %.3g\n", max)
    verbose && printf(verbose, "Truncated delta: %.3g\n", delta)
  }

  verbose && exit(verbose)

  delta
}) # estimateDeltaAB()



setMethodS3("estimateStdDevForHeterozygousBAF", "PairedPSCBS", function(this, deltaDH=0.20, deltaTCN=5, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  # Argument 'deltaDH':
  deltaDH <- Arguments$getDouble(deltaDH, range=c(0,1))

  # Argument 'deltaTCN':
  deltaTCN <- Arguments$getDouble(deltaTCN, range=c(0,Inf))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Estimating standard deviation of tumor BAFs for heterozygous SNPs")
  verbose && cat(verbose, "DH threshold: ", deltaDH)
  verbose && cat(verbose, "TCN threshold: ", deltaTCN)

  segs <- as.data.frame(this)

  verbose && cat(verbose, "Number of segments: ", nrow(segs))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Find segments to be used for the estimation
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Find segments that have low DHs
  idxsDH <- which(segs$dhMean <= deltaDH)
  verbose && cat(verbose, "Identified segments with small DH levels: ", length(idxsDH))
  verbose && str(verbose, idxsDH)

  # Sanity check
  if (length(idxsDH) == 0) {
    stop("Cannot estimate standard deviation.  There exist no segments with DH less or equal to the given threshold: ", deltaDH)
  }

  # Find segments that have low TCNs
  idxsTCN <- which(segs$tcnMean <= deltaTCN)
  verbose && cat(verbose, "Identified segments with small TCN levels: ", length(idxsTCN))
  verbose && str(verbose, idxsTCN)

  # Sanity check
  if (length(idxsTCN) == 0) {
    stop("Cannot estimate standard deviation.  There exist no segments with TCN less or equal to the given threshold: ", deltaTCN)
  }

  # Segments with small DH and small TCN
  idxs <- intersect(idxsDH, idxsTCN)
  verbose && cat(verbose, "Identified segments with small DH and small TCN levels: ", length(idxs))
  verbose && str(verbose, idxs)

  # Sanity check
  if (length(idxs) == 0) {
    stop("Cannot estimate standard deviation.  There exist no segments with small DH and small TCN.")
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and estimate parameters
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract those segments
  verbose && enter(verbose, "Extracting identified segments")
  fitT <- extractRegions(this, idxs)
  verbose && exit(verbose)

  # Get the tumor BAFs for the heterozygous SNPs
  verbose && enter(verbose, "Extracting BAFs for the heterozygous SNPs")
  beta <- with(fitT$data, betaTN[muN == 1/2])
  verbose && str(verbose, beta)
  verbose && exit(verbose)

  # Estimate the standard deviation for those
  sd <- mad(beta, na.rm=TRUE)
  verbose && cat(verbose, "Estimated standard deviation: ", sd)


  verbose && exit(verbose)

  sd
}, private=TRUE) # estimateStdDevForHeterozygousBAF()




setMethodS3("estimateMeanForDH", "PairedPSCBS", function(this, deltaDH=0.20, deltaTCN=5, robust=TRUE, trim=0.05, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  # Argument 'deltaDH':
  deltaDH <- Arguments$getDouble(deltaDH, range=c(0,1))

  # Argument 'deltaTCN':
  deltaTCN <- Arguments$getDouble(deltaTCN, range=c(0,Inf))

  # Argument 'robust':
  robust <- Arguments$getLogical(robust)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Estimating mean of tumor DHs for heterozygous SNPs")
  verbose && cat(verbose, "DH threshold: ", deltaDH)
  verbose && cat(verbose, "TCN threshold: ", deltaTCN)
  verbose && cat(verbose, "Robust estimator: ", robust)
  verbose && cat(verbose, "Trim: ", trim)

  segs <- as.data.frame(this)

  verbose && cat(verbose, "Number of segments: ", nrow(segs))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Find segments to be used for the estimation
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Find segments that have low DHs
  idxsDH <- which(segs$dhMean <= deltaDH)
  verbose && cat(verbose, "Identified segments with small DH levels: ", length(idxsDH))
  verbose && str(verbose, idxsDH)

  # Sanity check
  if (length(idxsDH) == 0) {
    stop("Cannot estimate standard deviation.  There exist no segments with DH less or equal to the given threshold: ", deltaDH)
  }

  # Find segments that have low TCNs
  idxsTCN <- which(segs$tcnMean <= deltaTCN)
  verbose && cat(verbose, "Identified segments with small TCN levels: ", length(idxsTCN))
  verbose && str(verbose, idxsTCN)

  # Sanity check
  if (length(idxsTCN) == 0) {
    stop("Cannot estimate standard deviation.  There exist no segments with TCN less or equal to the given threshold: ", deltaTCN)
  }

  # Segments with small DH and small TCN
  idxs <- intersect(idxsDH, idxsTCN)
  verbose && cat(verbose, "Identified segments with small DH and small TCN levels: ", length(idxs))
  verbose && str(verbose, idxs)

  # Sanity check
  if (length(idxs) == 0) {
    stop("Cannot estimate standard deviation.  There exist no segments with small DH and small TCN.")
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and estimate parameters
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract those segments
  verbose && enter(verbose, "Extracting identified segments")
  fitT <- extractRegions(this, idxs)
  verbose && exit(verbose)

  # Get the tumor DHs for the heterozygous SNPs
  verbose && enter(verbose, "Extracting DHs for the heterozygous SNPs")
  rho <- with(fitT$data, rho[muN == 1/2])
  verbose && str(verbose, rho)
  verbose && exit(verbose)

  # Estimate the average for those
  rho <- rho[is.finite(rho)]
  if (robust) {
    mu <- median(rho, na.rm=FALSE)
    qlow <- quantile(rho, probs=0.05, na.rm=FALSE)
    delta <- mu-qlow
    print(list(qlow=qlow, mu=mu, delta=delta, "mu+delta"=mu+delta))
  } else {
    mu <- mean(rho, trim=trim, na.rm=FALSE)
  }
  verbose && cat(verbose, "Estimated mean: ", mu)


  verbose && exit(verbose)

  mu
}, private=TRUE) # estimateMeanForDH()



setMethodS3("estimateHighDHQuantileAtAB", "PairedPSCBS", function(this, quantile=0.99, scale=1, deltaDH=0.20, deltaTCN=5, robust=TRUE, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  # Argument 'quantile':
  quantile <- Arguments$getDouble(quantile, range=c(0.5,1))

  # Argument 'scale':
  scale <- Arguments$getDouble(scale, range=c(0,Inf))

  # Argument 'deltaDH':
  deltaDH <- Arguments$getDouble(deltaDH, range=c(0,1))

  # Argument 'deltaTCN':
  deltaTCN <- Arguments$getDouble(deltaTCN, range=c(0,Inf))

  # Argument 'robust':
  robust <- Arguments$getLogical(robust)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Estimating DH quantile of tumor DHs for heterozygous SNPs")
  verbose && cat(verbose, "DH threshold: ", deltaDH)
  verbose && cat(verbose, "TCN threshold: ", deltaTCN)
  verbose && cat(verbose, "Robust estimator: ", robust)
  verbose && cat(verbose, "Scale factor: ", scale)

  segs <- as.data.frame(this)

  verbose && cat(verbose, "Number of segments: ", nrow(segs))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Find segments to be used for the estimation
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Finding some segments that are likely to in allelic balance (AB)")

  # Find some segments that have low DHs
  idxsDH <- which(segs$dhMean <= deltaDH)
  verbose && cat(verbose, "Identified segments with small DH levels: ", length(idxsDH))
  verbose && str(verbose, idxsDH)

  # Sanity check
  if (length(idxsDH) == 0) {
    stop("Cannot estimate standard deviation.  There exist no segments with DH less or equal to the given threshold: ", deltaDH)
  }

  # Find segments that have low TCNs
  idxsTCN <- which(segs$tcnMean <= deltaTCN)
  verbose && cat(verbose, "Identified segments with small TCN levels: ", length(idxsTCN))
  verbose && str(verbose, idxsTCN)

  # Sanity check
  if (length(idxsTCN) == 0) {
    stop("Cannot estimate standard deviation.  There exist no segments with TCN less or equal to the given threshold: ", deltaTCN)
  }

  # Segments with small DH and small TCN
  idxs <- intersect(idxsDH, idxsTCN)
  verbose && cat(verbose, "Identified segments with small DH and small TCN levels: ", length(idxs))
  verbose && str(verbose, idxs)

  # Sanity check
  if (length(idxs) == 0) {
    stop("Cannot estimate standard deviation.  There exist no segments with small DH and small TCN.")
  }

  # Extract those segments
  verbose && enter(verbose, "Extracting identified segments")
  fitT <- extractRegions(this, idxs)
  verbose && exit(verbose)

  verbose && exit(verbose)



  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and estimate parameters
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Get the tumor DHs for the heterozygous SNPs
  verbose && enter(verbose, "Extracting DHs for the heterozygous SNPs")
  rho <- with(fitT$data, rho[muN == 1/2])
  verbose && str(verbose, rho)
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Estimating the DH quantile
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Estimating the quantile of interest")
  verbose && cat(verbose, "Quantile: ", quantile)

  # Drop missing values
  rho <- rho[is.finite(rho)]

  if (robust) {
    lq <- quantile(rho, probs=1-quantile, na.rm=FALSE)
    verbose && printf(verbose, "Estimated lower quantile (%.3f): %f\n", 1-quantile, lq)
    mu <- median(rho, na.rm=FALSE)
    verbose && cat(verbose, "Estimated median: ", mu)
    delta <- mu-lq
    verbose && printf(verbose, "Estimated \"spread\": %f\n", delta)
    uq <- mu + scale*delta
    verbose && printf(verbose, "Scale parameter: %f\n", scale)
    qs <- c(lq, mu, mu+delta, uq)
    names(qs) <- sprintf("%.1f%%", 100*c(1-quantile, 0.5, quantile, 0.5+scale*(quantile-0.5)))
    names(qs)[3:4] <- sprintf("%s*", names(qs)[3:4])
    attr(uq, "quantiles") <- qs
  } else {
    uq <- quantile(rho, probs=quantile, na.rm=FALSE)
  }

  names(uq) <- uq
  verbose && printf(verbose, "Estimated upper quantile (%.3f): %f\n", quantile, uq)

  verbose && exit(verbose)

  verbose && exit(verbose)

  uq
}, private=TRUE) # estimateHighDHQuantileAtAB()




###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod estimateDeltaABBySmallDH
#
# @title "Estimate a threshold for calling allelic balance from DH"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{q1}{A @numeric value specifying the weighted quantile of the
#    segment-level DHs used to identify segments with small DH means.}
#   \item{q2}{A @numeric value specifying the quantile of the locus-level
#    DH signals for those segments with small DH mean levels.}
#   \item{...}{Not used.}
#   \item{verbose}{See @see "R.utils::Verbose".} 
# }
#
# \value{
#   Returns the threshold estimate as a @numeric scalar.
# }
#
# \section{Algorithm}{
#  \itemize{
#   \item Grabs the segment-level DH estimates.
#   \item Calculate segment weights proportional to the number 
#         of heterozygous SNPs.
#   \item Calculate \eqn{\Delta} as the 5\% quantile of the weighted DH means.
#   \item Choose the segments with means less than \eqn{\Delta}.
#   \item Calculate threshold \eqn{\Delta_{AB}} as the 90\% "symmetric" quantile 
#         of the observed locus-level DHs from the selected segments 
#         in Step 4.
#         The q:th "symmetric" quantile is estimated by estimating 
#         the ((1-q), 50\%) quantiles, calculating their distance as
#         "50\%-(1-q)" and add to the median (50\%), i.e.
#         "median + (median-(1-q))" = "2*median-1 + q", which should
#         equal q if the distribution is symmetric.
#  }
# }
#
# @author "HB"
#
# \seealso{
#   Instead of calling this method explicitly, it is recommended
#   to use the @seemethod "estimateDeltaAB" method.
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("estimateDeltaABBySmallDH", "PairedPSCBS", function(fit, q1=0.05, q2=0.90, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
  # Argument 'q1' & 'q2':
  q1 <- Arguments$getDouble(q1, range=c(0,1))
  q2 <- Arguments$getDouble(q2, range=c(0,1))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Estimating DH threshold for AB caller")
  verbose && cat(verbose, "quantile #1: ", q1)
  verbose && cat(verbose, "Symmetric quantile #2: ", q2)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  # Extract the region-level estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  segs <- getSegments(fit)
  dh <- segs$dhMean
  .stop_if_not(!is.null(dh))
  n <- segs$dhNbrOfLoci

  # Drop missing values
  keep <- (!is.na(dh) & !is.na(n))
  idxs <- which(keep)
  dh <- dh[idxs]
  n <- n[idxs]
  verbose && cat(verbose, "Number of segments: ", length(idxs))
  # Sanity check
  .stop_if_not(length(idxs) > 0)

  # Calculated weighted quantile
  weights <- n / sum(n)
  deltaDH <- weightedQuantile(dh, w=weights, probs=q1)
  verbose && printf(verbose, "Weighted %g%% quantile of DH: %f\n", 100*q1, deltaDH)

  # Identify segments with DH this small
  keep <- (dh <= deltaDH)
  idxs <- idxs[keep]
  verbose && cat(verbose, "Number of segments with small DH: ", length(idxs))
  # Sanity check
  .stop_if_not(length(idxs) > 0)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  # Extract the locus-level estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
  # Extract the regions of interest
  fitT <- extractRegions(fit, idxs)

  # Extract the data
  data <- fitT$data
  rho <- data$rho
  .stop_if_not(!is.null(rho))

  verbose && cat(verbose, "Number of data points: ", length(rho))

  # Drop missing values
  rho <- rho[is.finite(rho)]
  verbose && cat(verbose, "Number of finite data points: ", length(rho))

  qs <- quantile(rho, probs=c(1-q2, 1/2), na.rm=FALSE, names=FALSE)
  verbose && printf(verbose, "Estimate of (1-%.3g):th and 50%% quantiles: (%g,%g)\n", q2, qs[1], qs[2])
  deltaAB <- qs[2] + (qs[2]-qs[1])
  verbose && printf(verbose, "Estimate of %.3g:th \"symmetric\" quantile: %g\n", q2, deltaAB)
  

  # Sanity check
  deltaAB <- Arguments$getDouble(deltaAB)

  deltaAB
}, protected=TRUE) # estimateDeltaABBySmallDH()

###########################################################################/**
# @RdocClass NonPairedPSCBS
#
# @title "The NonPairedPSCBS class"
#
# \description{
#  @classhierarchy
#
#  A NonPairedPSCBS is an object containing the results from the
#  Non-paired PSCBS method.
# }
#
# \usage{NonPairedPSCBS(fit=list(), ...)}
#
# \arguments{
#   \item{fit}{A @list structure containing the Non-paired PSCBS results.}
#   \item{...}{Not used.}
# }
#
# \section{Fields and Methods}{
#  @allmethods "public"
# }
#
# @author "HB"
#
# \seealso{
#   The @see "segmentByNonPairedPSCBS" method returns an object of this class.
# }
#*/###########################################################################
setConstructorS3("NonPairedPSCBS", function(fit=list(), ...) {
  # Argument 'fit':
  if (!is.list(fit)) {
    stop("Argument 'fit' is not a list: ", class(fit)[1])
  }

  extend(PSCBS(fit=fit, ...), "NonPairedPSCBS")
})


setMethodS3("getLocusData", "NonPairedPSCBS", function(fit, ..., fields=c("asis", "full")) {
  # Argument 'fields':
  fields <- match.arg(fields)


  data <- NextMethod("getLocusData", fields="asis")


  if (fields == "full") {
    names <- colnames(data)

    data$isHet <- (data$muN == 1/2)

    # BACKWARD COMPATIBILITY: If 'rho' does not exists, calculate
    # it on the fly from 'betaT'.
    # NOTE: This should give an error in the future. /HB 2013-10-25
    if (is.null(data$rho)) {
      data$rho <- 2*abs(data$betaT-1/2)
      data$rho[!data$isHet] <- NA_real_
      warning("Locus-level DH signals ('rho') did not exist and were calculated from tumor BAFs ('betaT')")
    }

    data$c1 <- 1/2*(1-data$rho)*data$CT
    data$c2 <- data$CT - data$c1

    data$isSNP <- (!is.na(data$betaT) | !is.na(data$muN))
    data$type <- ifelse(data$isSNP, "SNP", "non-polymorphic locus")

    # Labels
    data$muNx <- c("AA", "AB", "BB")[2*data$muN + 1L]
    data$isHetx <- c("AA|BB", "AB")[data$isHet + 1L]
  }

  data
}, protected=TRUE) # getLocusData()


setMethodS3("callROH", "NonPairedPSCBS", function(fit, ...) {
  stop(sprintf("Cannot call ROH from '%s' data.", class(fit)[1L]))
}, private=TRUE) # callROH()


setMethodS3("updateMeans", "NonPairedPSCBS", function(fit, from=c("loci", "segments"), adjustFor=NULL, ..., avgTCN=c("asis", "mean", "median"), avgDH=c("asis", "mean", "median"), verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'from':
  from <- match.arg(from)

  # Argument 'adjustFor':
  if (!is.null(adjustFor)) {
    adjustFor <- Arguments$getCharacters(adjustFor)
    adjustFor <- tolower(adjustFor)
    knownValues <- c("ab", "loh", "roh")
    adjustFor <- match.arg(adjustFor, choices=knownValues, several.ok=TRUE)
  }

  # Argument 'avgTCN' & 'avgDH':
  avgTCN <- match.arg(avgTCN)
  avgDH <- match.arg(avgDH)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Updating mean level estimates")
  verbose && cat(verbose, "Adjusting for:")
  verbose && print(verbose, adjustFor)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setting up averaging functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (avgTCN == "asis" || avgDH == "asis") {
    est <- fit$params$meanEstimators
    if (avgTCN == "asis") {
      avgTCN <- est$tcn
      if (is.null(avgTCN)) avgTCN <- "mean"
      avgTCN <- match.arg(avgTCN)
    }
    if (avgDH == "asis") {
      avgDH <- est$dh
      if (is.null(avgDH)) avgDH <- "mean"
      avgDH <- match.arg(avgDH)
    }
  }

  avgList <- list(
    tcn = get(avgTCN, mode="function"),
    dh = get(avgDH, mode="function")
  )


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the segmentation results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  segs <- getSegments(fit, splitters=TRUE)
  segRows <- list(tcn=fit$tcnSegRows, dh=fit$dhSegRows)
  nbrOfSegments <- nrow(segs)
  verbose && cat(verbose, "Number of segments: ", nbrOfSegments)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Assert that adjustments can be made
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.element("ab", adjustFor)) {
    if (!is.element("abCall", names(segs))) {
      adjustFor <- setdiff(adjustFor, "ab")
      stop("Cannot adjust for AB, because they haven't been called.")
    }
  }

  if (is.element("loh", adjustFor)) {
    if (!is.element("lohCall", names(segs))) {
      adjustFor <- setdiff(adjustFor, "loh")
      stop("Cannot adjust for LOH, because they haven't been called.")
    }
  }

  if (is.element("roh", adjustFor)) {
    if (!is.element("rohCall", names(segs))) {
      adjustFor <- setdiff(adjustFor, "roh")
      stop("Cannot adjust for ROH, because they haven't been called.")
    }
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update the (TCN,DH) mean levels from locus-level data?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (from == "loci") {
    data <- getLocusData(fit)
    chromosome <- data$chromosome
    x <- data$x
    CT <- data$CT
    rho <- data$rho

    isSplitter <- isSegmentSplitter(fit)
    for (ss in seq_len(nbrOfSegments)[!isSplitter]) {
      verbose && enter(verbose, sprintf("Segment %d of %d", ss, nbrOfSegments))
      seg <- segs[ss,]
      verbose && print(verbose, seg)

      chr <- seg[["chromosome"]]
      chrTag <- sprintf("chr%02d", chr)

      for (what in c("tcn", "dh")) {
        segRow <- segRows[[what]][ss,]

        # (a) A splitter - nothing todo?
        if (!is.finite(segRow[[1]]) || !is.finite(segRow[[2]])) {
          next
        }

        # (b) Identify units (loci)
        units <- segRow[[1]]:segRow[[2]]

        # (c) Adjust for missing values
        if (what == "tcn") {
          value <- CT
        } else if (what == "dh") {
          value <- rho
        }
        keep <- which(!is.na(value[units]))
        units <- units[keep]

        # (d) Update mean
        avgFUN <- avgList[[what]]
        gamma <- avgFUN(value[units])

        # Sanity check
        .stop_if_not(length(units) == 0 || !is.na(gamma))

        # Update the segment boundaries, estimates and counts
        key <- paste(what, "Mean", sep="")
        seg[[key]] <- gamma
      }

      verbose && print(verbose, seg)

      segs[ss,] <- seg

      verbose && exit(verbose)
    } # for (ss ...)
  } # if (from ...)



  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Adjust segment means from various types of calls
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (length(adjustFor) > 0) {
    verbose && enter(verbose, "Adjusting segment means")
    verbose && cat(verbose, "Adjusting for:")
    verbose && print(verbose, adjustFor)

    if (is.element("ab", adjustFor)) {
      verbose && enter(verbose, "Adjusting for AB")
      calls <- segs$abCall
      segs$dhMean[calls] <- 1/2
      verbose && exit(verbose)
    }

    if (is.element("loh", adjustFor)) {
      verbose && enter(verbose, "Adjusting for LOH")
      calls <- segs$lohCall
      segs$dhMean[calls] <- 0
      verbose && exit(verbose)
    }

    if (is.element("roh", adjustFor)) {
      verbose && enter(verbose, "Adjusting for ROH")
      calls <- segs$rohCall
      segs$dhMean[calls] <- NA_real_
      verbose && exit(verbose)
    }

    verbose && exit(verbose)
  } # if (length(adjustFor) > 0)



  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update (C1,C2) mean levels
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Update (C1,C2) per segment")
  # Append (C1,C2) estimates
  tcn <- segs$tcnMean
  dh <- segs$dhMean
  C1 <- 1/2*(1-dh)*tcn
  C2 <- tcn - C1
  segs$c1Mean <- C1
  segs$c2Mean <- C2
  verbose && exit(verbose)


  # Return results
  res <- fit
  res$output <- segs
  res <- setMeanEstimators(res, tcn=avgTCN, dh=avgDH)

  verbose && exit(verbose)

  res
}, private=TRUE) # updateMeans()



setMethodS3("resegment", "NonPairedPSCBS", function(fit, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Resegmenting a ", class(fit)[1], " object")

  # Use the locus-level data of the PairedPSCBS object
  data <- getLocusData(fit)
  class(data) <- "data.frame"
  drop <- c("rho", "betaTN", "index")
  keep <- !is.element(colnames(data), drop)
  data <- data[,keep]
  verbose && str(verbose, data)

  verbose && cat(verbose, "Number of loci: ", nrow(data))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup arguments to be passed
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Overriding default arguments")
  segFcnName <- "segmentByPairedNonPSCBS"
  segFcn <- getMethodS3(segFcnName, "default")

  # (a) The default arguments
  formals <- formals(segFcn)

  formals <- formals[!sapply(formals, FUN=is.language)]
  formals <- formals[!sapply(formals, FUN=is.name)]
  drop <- c("chromosome", "x", "w", "CT", "betaT", "betaN", "muN", "...")
  keep <- !is.element(names(formals), drop)
  formals <- formals[keep]

  # (b) The arguments used in previous fit
  params <- fit$params
  keep <- is.element(names(params), names(formals))
  params <- params[keep]
  # Don't trust 'tbn'!  TODO. /HB 20111117
  params$tbn <- NULL

  # (c) The arguments in '...'
  userArgs <- list(..., verbose=verbose)

  # (d) Merge
  args <- formals
  args2 <- c(params, userArgs)
  for (kk in seq_along(args2)) {
    value <- args2[[kk]]
    if (!is.null(value)) {
      key <- names(args2)[kk]
      if (!is.null(key)) {
        args[[key]] <- value
      } else {
        args <- c(args, list(value))
      }
    }
  } # for (key ...)
  verbose && str(verbose, args[names(args) != "verbose"])

  verbose && enter(verbose, sprintf("Calling %s()", segFcnName))
  args <- c(list(data), args)
  verbose && cat(verbose, "Arguments:")
  verbose && str(verbose, args[names(args) != "verbose"])
  verbose && exit(verbose)

  fit <- do.call(segFcnName, args)
  verbose && exit(verbose)

  verbose && exit(verbose)

  fit
}, protected=TRUE) # resegment()



##############################################################################
# HISTORY
# 2013-04-23
# o BUG FIX: updateMeans() for PairedPSCBS and NonPairedPSCBS could
#   include a signal from a neighboring segment when averaging, iff
#   that signal was located at the exact locus of the change point.
# 2013-04-09
# o Added callROH() for NonPairedPSCBS that throws an exception.
# 2013-03-08
# o Added getLocusData() for NonPairedPSCBS.
# 2013-01-15
# o regsegment() was defined for PairedPSCBS instead of NonPairedPSCBS.
# 2012-04-21
# o Created from PairedPSCBS.R.
##############################################################################

###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod callCopyNeutral
# @aliasmethod callNTCN
#
# @title "Calls segments that have a neutral total copy number"
#
# \description{
#  @get "title" (NTCN),
#  i.e. that have a TCN that corresponds to the ploidy of the genome.
# }
#
# @synopsis
#
# \arguments{
#   \item{flavor}{A @character string specifying which type of
#    call to use.}
#   \item{...}{Additional arguments passed to the caller.}
#   \item{minSize}{An optional @integer specifying the minimum number
#    of data points in order to call a segments.  If fewer data points,
#    then the call is set to @NA regardless.}
#   \item{force}{If @FALSE, and copy-neutral calls already exits,
#    then nothing is done, otherwise the calls are done.}
# }
#
# \value{
#   Returns a @see "PairedPSCBS" object with copy-neutral calls.
# }
#
# @author "HB"
#
# \seealso{
#   Internally, one of the following methods are used:
#   @seemethod "callCopyNeutralByTCNofAB".
# }
#
#*/###########################################################################
setMethodS3("callCopyNeutral", "PairedPSCBS", function(fit, flavor=c("TCN|AB"), ..., minSize=1, force=FALSE) {
  # Argument 'flavor':
  flavor <- match.arg(flavor)

  # Argument 'minSize':
  minSize <- Arguments$getDouble(minSize, range=c(1,Inf))


  # Already done?
  segs <- as.data.frame(fit)
  calls <- segs$ntcnCall
  if (!force && !is.null(calls)) {
    return(invisible(fit))
  }

  if (flavor == "TCN|AB") {
    fit <- callCopyNeutralByTCNofAB(fit, ..., force=force)
  } else {
    stop("Cannot call copy-neutral states. Unsupported flavor: ", flavor)
  }

  # Don't call segments with too few data points?
  if (minSize > 1) {
    segs <- as.data.frame(fit)
    ns <- segs$dhNbrOfLoci
    calls <- segs$ntcnCall
    calls[ns < minSize] <- NA
    segs$ntcnCall <- calls
    fit$output <- segs
    # Not needed anymore
    segs <- calls <- NULL
  }

  return(invisible(fit))
})

setMethodS3("callNTCN", "PairedPSCBS", function(...) {
  callCopyNeutral(...)
})




setMethodS3("calcStatsForCopyNeutralABs", "PairedPSCBS", function(fit, ..., force=FALSE, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'force':
  force <- Arguments$getLogical(force)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "calcStatsForCopyNeutralABs")

  segsNTCN <- fit$params$copyNeutralStats
  if (!force && !is.null(segsNTCN)) {
    verbose && exit(verbose)
    return(fit)
  }

  verbose && enter(verbose, "Identifying copy neutral AB segments")

  # Getting AB calls
  segs <- getSegments(fit, splitters=TRUE)
  isAB <- segs$abCall
  if (is.null(isAB)) {
    stop("Cannot call copy-neutral states, because allelic-balance calls have not been made yet.")
  }

  nABs <- sum(isAB, na.rm=TRUE)
  verbose && cat(verbose, "Number of AB segments: ", nABs)
  if (nABs == 0L) {
    stop("Cannot call copy-neutral states, because none of the segments are in allelic balance.")
  }

  C <- segs[,"tcnMean", drop=TRUE]
  isAB <- segs[,"abCall", drop=TRUE]
  n <- segs[,"tcnNbrOfSNPs", drop=TRUE] # "tcnNbrOfLoci"? /HB 2010-09-09

  # Give more weight to longer regions
  weights <- n

  # Identify copy neutral AB segments
  isNeutralAB <- findNeutralCopyNumberState(C=C, isAI=!isAB, weights=weights,
                                     ..., flavor="maxPeak", verbose=verbose)
  nAB <- sum(isNeutralAB, na.rm=TRUE)
  verbose && cat(verbose, "Number of copy-neutral AB segments: ", nAB)
  if (nAB == 0L) {
    stop("Cannot call copy-neutral states, because none of the segments in allelic-balance are copy neutral.")
  }

  verbose && enter(verbose, "Extracting all copy neutral AB segments across all chromosomes into one big segment")

  # (a) Extract those
  fitNTCN <- extractSegments(fit, isNeutralAB)
  verbose && print(verbose, fitNTCN)
  verbose && exit(verbose)

  # (b) Turn into a single-chromosome data set
  fitNTCN <- extractSegments(fitNTCN, !isSegmentSplitter(fitNTCN))
  isSplitter <- is.na(fitNTCN$output$chromosome)
  fitNTCN$data$chromosome <- 0L
  fitNTCN$output$chromosome <- 0L
  fitNTCN$output$chromosome[isSplitter] <- NA


  # (c) Turn into one big segment by dropping all change points
##  nCPs <- nbrOfChangePoints(fitNTCN, ignoreGaps=TRUE)
  nCPs <- nbrOfSegments(fitNTCN, splitters=TRUE) - 1L
  if (nCPs >= 1L) {
    verbose && enter(verbose, "Dropping all change points")
    fitNTCN <- dropChangePoints(fitNTCN, idxs=nCPs:1, ignoreGaps=TRUE, update=TRUE, verbose=less(verbose, 5))
    verbose && exit(verbose)
  }
  # Sanity check
  .stop_if_not(nbrOfSegments(fitNTCN) == 1L)
  verbose && exit(verbose)

  verbose && enter(verbose, "Bootstrap the identified copy-neutral states")
  fitNTCN <- bootstrapTCNandDHByRegion(fitNTCN, what="segment", force=TRUE,
                                           ..., verbose=less(verbose, 50))
  segsNTCN <- getSegments(fitNTCN, simplified=FALSE)
  names <- colnames(segsNTCN)
  excl <- grep("(^chromosome|Id|Start|End|Call)$", names)
  segsNTCN <- segsNTCN[,-excl,drop=FALSE]
  # Sanity check
  .stop_if_not(ncol(segsNTCN) > 0L)
  verbose && exit(verbose)

  verbose && print(verbose, segsNTCN)
  verbose && exit(verbose)

  fit$params$copyNeutralStats <- segsNTCN

  invisible(fit)
}, protected=TRUE) # calcStatsForCopyNeutralABs()



###########################################################################/**
# @RdocMethod estimateDeltaCN
# @alias estimateDeltaCN
# @alias estimateDeltaCN.CBS
#
# @title "Estimates the length of one total copy-number (TCN) unit"
#
# \description{
#  @get "title"
# }
#
# @synopsis
#
# \arguments{
#  \item{scale}{A @numeric scale factor in (0,Inf) used for rescaling
#   (multiplying) the final estimate with.}
#  \item{flavor}{Specifies which type of estimator should be used.}
#  \item{kappa}{Estimate of background signal (used by the \code{"1-kappa"} method).}
#  \item{adjust, quantile}{Tuning parameters (used by the \code{"delta(mode)"} method).}
#  \item{...}{Not used.}
# }
#
# \value{
#  Returns a positive scalar @numeric.
# }
#
# \details{
#   For parent-specific copy-number (PSCN) data, the TCN unit length is
#   estimated as \eqn{(1-kappa)/2}, where \eqn{kappa} is estimated from
#   data (by @see "PSCBS::estimateKappa").
#
#   For total copy-number (TCN) data (only),
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("estimateDeltaCN", "PairedPSCBS", function(fit, scale=1, flavor=c("1-kappa", "delta(mode)"), kappa=estimateKappa(fit), adjust=0.2, quantile=0.95, ...) {
  # Argument 'scale':
  disallow <- c("NA", "NaN", "Inf")
  scale <- Arguments$getDouble(scale, range=c(0,Inf), disallow=disallow)

  # Argument 'flavor':
  flavor <- match.arg(flavor)


  if (flavor == "1-kappa") {
    # Argument 'kappa':
    disallow <- c("NA", "NaN", "Inf")
    kappa <- Arguments$getDouble(kappa, range=c(0,1), disallow=disallow)
    
    # Half a TCN unit length
    delta <- (1-kappa)/2
  } else if (flavor == "delta(mode)") {
    # To please R CMD check
    rohCall <- abCall <- type <- NULL
    rm(list=c("rohCall", "abCall", "type"))

    segs <- getSegments(fit)
    segs <- subset(segs, !rohCall)
    segs <- subset(segs, !abCall)
    sigmas <- list()
    for (name in c("c1", "c2", "tcn")) {
      # FIXME/AD HOC: Here we assume certain fields
      fields <- sprintf("%s_%s%%", name, c(5,95))
      if (all(is.element(fields, names(segs)))) {
        sigma <- segs[,fields[2]] - segs[,fields[1]]
      } else {
        if (name == "tcn") {
          n <- segs[,"tcnNbrOfLoci"]
        } else {
          n <- segs[,"dhNbrOfLoci"]
          n <- segs[,"tcnNbrOfLoci"]
        }
        n <- segs[,"tcnEnd"] - segs[,"tcnStart"]
        sigma <- 1/sqrt(n)
      }
      sigmas[[name]] <- sigma
    }
    segs <- segs[,c("c1Mean", "c2Mean", "tcnMean")]
    x <- unlist(segs, use.names=FALSE)
    w <- 1/unlist(sigmas, use.names=FALSE)
    keep <- is.finite(x) & is.finite(w)
    x <- x[keep]; w <- w[keep]
    w <- w / sum(w)
    d <- density(x, weights=w, adjust=adjust)
##    plotDensity(d)
    tolMax <- max(d$y, na.rm=TRUE)
    tols <- seq(from=tolMax, to=0, length.out=100)
    stats <- data.frame(tolerance=tols, delta=NA_real_, count=NA_integer_)
    for (kk in seq_along(tols)) {
      tol <- tols[kk]
      px <- subset(findPeaksAndValleys(d, tol=tol), type == "peak")$x
      nx <- length(px)
      dx <- mean(diff(px))
      stats[kk,"delta"] <- dx
      stats[kk,"count"] <- nx
    }
    stats <- subset(stats, is.finite(delta))
##    print(stats)
    delta <- median(stats[,"delta"])
  }

  # Rescale
  delta <- scale * delta

  delta
}, protected=TRUE) # estimateDeltaCN()



###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod callCopyNeutralByTCNofAB
#
# @title "Calls regions that are copy neutral"
#
# \description{
#  @get "title" from the total copy numbers (TCNs) of segments
#  in allelic balance (AB).
# }
#
# @synopsis
#
# \arguments{
#   \item{fit}{A PairedPSCBS fit object as returned by
#     @see "PSCBS::segmentByPairedPSCBS".}
#   \item{delta}{A non-negative @double specifying the width of the
#     "acceptance" region.
#     Defaults to half of the distance between two integer TCN states,
#     i.e. 1/2.  This argument should be shrunken as a function of
#     the amount of the normal contamination and other background signals.}
#   \item{alpha}{A @double in [0,0.5] specifying the significance level
#     of the confidence intervals used.}
#   \item{...}{Additional arguments passed to
#              @seemethod "calcStatsForCopyNeutralABs".}
#   \item{force}{If @TRUE, an already called object is skipped, otherwise not.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns a @see "PairedPSCBS" fit object where a column
#   with the copy-neutral call.
# }
#
# \details{
#   ...
# }
#
# %% examples "../incl/callCopyNeutralByTCNofAB.PairedPSCBS.Rex"
#
# @author "HB"
#
# @keyword internal
#*/###########################################################################
setMethodS3("callCopyNeutralByTCNofAB", "PairedPSCBS", function(fit, delta=estimateDeltaCN(fit), alpha=0.05, ..., force=FALSE, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'delta':
  disallow <- c("NA", "NaN", "Inf")
  delta <- Arguments$getDouble(delta, range=c(0,Inf), disallow=disallow)

  # Argument 'alpha':
  disallow <- c("NA", "NaN", "Inf")
  alpha <- Arguments$getDouble(alpha, range=c(0,0.5), disallow=disallow)

  # Argument 'force':
  force <- Arguments$getLogical(force)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "callCopyNeutralByTCNofAB")
  verbose && cat(verbose, "Alpha: ", alpha)
  verbose && cat(verbose, "Delta CN: ", delta)

  segs <- getSegments(fit, splitters=TRUE, simplify=FALSE)

  # Nothing to do?
  if (!force && !is.null(segs$ntcnCall)) {
    # Copy neutral segments are already called
    verbose && cat(verbose, "Already called. Skipping.")
    verbose && exit(verbose)
    return(fit)
  }

  verbose && enter(verbose, "Calling copy-neutral segments")

  verbose && enter(verbose, "Retrieve TCN confidence intervals for all segments")

  # Calculate TCN bootstrap estimates, if missing
  probs <- c(alpha/2, 1-alpha/2)

  verbose && printf(verbose, "Interval: [%g,%g]\n", probs[1], probs[2])

  keys <- sprintf("tcn_%g%%", 100*c(probs[1], probs[2]))
  missing <- keys[!is.element(keys, colnames(segs))]
  if (length(missing) > 0) {
    fit <- bootstrapTCNandDHByRegion(fit, probs=probs, ..., verbose=less(verbose, 50))
    segs <- getSegments(fit, splitters=TRUE, simplify=FALSE)

    # Assert that they exists
    missing <- keys[!is.element(keys, colnames(segs))]
    if (length(missing) > 0) {
      stop("INTERNAL ERROR: No such statistics: ", hpaste(missing))
    }
  }

  verbose && exit(verbose)


  verbose && enter(verbose, "Estimating TCN confidence interval of copy-neutral AB segments")

  fit <- calcStatsForCopyNeutralABs(fit, ..., verbose=less(verbose, 5))
  stats <- fit$params$copyNeutralStats
  verbose && cat(verbose, "Bootstrap statistics for copy-neutral AB segments:")
  verbose && print(verbose, stats)

  # Extract TCN stats
  cols <- grep("^(tcn_|tcnMean)", colnames(stats))
  tcnStats <- stats[,cols,drop=FALSE]
  tcnStats <- unlist(tcnStats, use.names=TRUE)
  verbose && print(verbose, "TCN statistics:")
  verbose && print(verbose, tcnStats)

  # Assert confidence interval of interest
  missing <- keys[!is.element(keys, names(tcnStats))]
  if (length(missing) > 0) {
    stop("INTERNAL ERROR: No such statistics: ", hpaste(missing))
  }
  mean <- tcnStats["tcnMean"]
  ci <- tcnStats[keys]
  verbose && printf(verbose, "%g%%-confidence interval of TCN mean for the copy-neutral state: [%g,%g] (mean=%g)\n", 100*(1-alpha), ci[1], ci[2], mean)

  verbose && exit(verbose)


  verbose && enter(verbose, "Identify all copy-neutral segments")
  verbose && printf(verbose, "DeltaCN: +/-%g\n", delta)
  range <- ci + delta*c(-1,+1)
  verbose && printf(verbose, "Call (\"acceptance\") region: [%g,%g]\n", range[1], range[2])

  # Get TCN confidence intervals for all segments
  ci <- segs[,keys]
  ci <- as.matrix(ci)

  ## WAS: If a confidence interval is completely within the
  ##      calling region, call it
  ## isNTCN <- (range[1] <= ci[,1] & ci[,2] <= range[2])

  # If a segments confidence interval is completely outside the
  # copy-neutral region ("H_0"), that is, it is completely within
  # the rejection region ("H_1"), then the H_0 hypothesis that the
  # segment is copy-neutral in TCN is rejected.
  isLoss <- (ci[,2] < range[1]) # (a) completely below, or
  isGain <- (ci[,1] > range[2]) # (b) completely above.
  isNTCN <- (!isLoss & !isGain) #  => completely inside => not rejected.

  nbrOfSegs <- nrow(segs)
  nbrOfABs <- sum(segs$abCall, na.rm=TRUE)
  nbrOfCNs <- sum(isNTCN, na.rm=TRUE)
  verbose && cat(verbose, "Total number of segments: ", nbrOfSegs)
  verbose && cat(verbose, "Number of segments called allelic balance: ", nbrOfABs)
  verbose && cat(verbose, "Number of segments called copy neutral: ", nbrOfCNs)

  nbrOfCNABs <- sum(isNTCN & segs$abCall, na.rm=TRUE)
  verbose && cat(verbose, "Number of AB segments called copy neutral: ", nbrOfCNABs)
  nbrOfCNNonABs <- sum(isNTCN & !segs$abCall, na.rm=TRUE)
  verbose && cat(verbose, "Number of non-AB segments called copy neutral: ", nbrOfCNNonABs)

  verbose && exit(verbose)


  # Sanity check
#  # All previously called AB regions should remain called here as well
#  .stop_if_not(all(isNTCN[isNeutralAB], na.rm=TRUE))

  segs$ntcnCall <- isNTCN

  params <- fit$params
  params$deltaCN <- delta
  params$ntcnRange <- range

  fitC <- fit
  fitC$output <- segs
  fitC$params <- params

  verbose && exit(verbose)

  fitC
}, protected=TRUE) # callCopyNeutralByTCNofAB()



##############################################################################
# HISTORY
# 2013-10-21 [HB]
# o ROBUSTNESS: Now calcStatsForCopyNeutralABs() only bootstraps the
#   segments of the subsetted copy-neutral segments.
# 2013-04-17 [HB]
# o BUG FIX: Internal calcStatsForCopyNeutralABs() would give an error
#   if there was exactly two AH segments.
# 2013-03-19 [HB]
# o CALLING: Defined a formal hypthesis test for how segments are called
#   copy-neutral in TCN (NTCN), with the null hypothesis being that a
#   segment is NTCN.  In order for a segment to not be NTCN, its confidence
#   interval has to be completely outside the null region.  This changed
#   how callCopyNeutralByTCNofAB() for PairedPSCBS calls segments; it is
#   now a bit more conservative in rejecting NTCN.
# o ROBUSTNESS: Now calcStatsForCopyNeutralABs() for PairedPSCBS does
#   a better job in identifying the TCN mode of the AB segments.
# o Now callCopyNeutralByTCNofAB() records parameters 'deltaCN' and
#   'ntcnRange'.
# 2012-09-21 [HB]
# o BUG FIX: Recent updates in how nbrOfChangePoints() is calculated,
#   caused callGNL() to throw an exception.  Added argument 'ignoreGaps'
#   to nbrOfChangePoints().
# 2012-07-02 [HB]
# o Renamed callTCNN() to callNTCN().
# 2012-06-24 [HB]
# o Renamed callCN() to callTCNN() in order not to confuse it with
#   copy numbers in general.
# 2012-06-03 [HB]
# o Added estimateDeltaCN() for PairedPSCBS, which is calculated as a
#   function of the amount of normal contamination as currently estimated
#   by estimateKappa().
# o Now callCopyNeutralByTCNofAB() runs bootstrapping if quantiles are
#   missing.
# 2012-02-25 [HB]
# o Added internal calcStatsForCopyNeutralABs() for PairedPSCBS.
# 2012-02-24 [HB]
# o Now callCopyNeutralByTCNofAB() calls all segements, not just those in AB.
# o Now the copy-neutral calls are named 'cnCall' (not 'neutralCall').
# o Added callCN()/callCopyNeutral().
# o Added callCopyNeutralByTCNofAB() for PairedPSCBS.  The method was
#   adopted from callCopyNeutralRegions() in aroma.cn, whose history has
#   been incorporated below.
# o Created.
# 2010-09-15* [HB]
# o Added Rdocs for callCopyNeutralRegions().
# 2010-09-09* [HB]
# o Added callCopyNeutralRegions() for PairedPSCBS.
##############################################################################

###########################################################################/**
# @set "class=numeric"
# @RdocMethod testROH
#
# @title "Tests if a segment is in Run-of-Homozygosity (ROH)"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{muN}{An @numeric @vector of J genotype calls in
#        \{0,1/2,1\} for AA, AB, and BB, respectively,
#        and @NA for non-polymorphic loci.}
#   \item{csN}{(optional) A @numeric @vector of J genotype confidence scores.
#        If @NULL, ad hoc scores calculated from \code{betaN} are used.}
#   \item{betaN}{(optional) A @numeric @vector of J matched normal BAFs
#        in [0,1] (due to noise, values may be slightly outside as well)
#        or @NA for non-polymorphic loci.}
#   \item{minNbrOfSnps}{Minimum number of SNPs required to test segment.
#        If not tested, @NA is returned.}
#   \item{delta}{A @double scalar specifying the maximum (weighted)
#        proportion of heterozygous SNPs allowed in an ROH region.}
#   \item{...}{Not used.}
#  \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#  Returns a @logical.
# }
#
# @author "PN, HB"
#
# @keyword internal
#*/###########################################################################
setMethodS3("testROH", "numeric", function(muN, csN=NULL, betaN=NULL, minNbrOfSnps=1, delta=1/12, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'muN':
  muN <- Arguments$getDoubles(muN, range=c(0,1))
  nbrOfSnps <- length(muN)
  length2 <- rep(nbrOfSnps, times=2)

  # Argument 'csN' & 'betaN':
  if (!is.null(csN)) {
    csN <- Arguments$getDoubles(csN, range=c(0,1), length=length2)
  } else {
    if (!is.null(betaN)) {
      betaN <- Arguments$getDoubles(betaN, length=length2)
    }
  }

  # Argument 'minNbrOfSnps':
  minNbrOfSnps <- Arguments$getInteger(minNbrOfSnps, range=c(1,Inf))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Testing for ROH")

  # Default ROH call
  call <- NA

  verbose && cat(verbose, "Number of SNPs: ", nbrOfSnps)

  # Nothing todo?
  if (nbrOfSnps < minNbrOfSnps) {
    verbose && exit(verbose)
    return(call)
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Calculate genotype confidence scores (from betaN)?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.null(csN)) {
    if (!is.null(betaN)) {
      verbose && enter(verbose, "Calculating confidence scores")
      # Assuming naive genotyping a'la aroma.light::callNaiveGenotypes()
      # was used to call genotypes 'muN' from 'betaN'.

      # AD HOC: We also have to assume that the thresholds were 1/3 and 2/3.
      a <- 1/3 # was fit$x[1]
      b <- 2/3 # was fit$x[2]

      # AD HOC: We have to make some assumption about which SNPs are diploid.
      # Assume all for now
      isDiploid <- rep(TRUE, times=nbrOfSnps)

      # KNOWN ISSUE: Scores for homozygotes are in [0,1/3], whereas
      # heterzygotes are in [0,1/6]. /PN 2011-11-11
      csN[isDiploid] <- rowMins(abs(cbind(betaN[isDiploid]-a, betaN[isDiploid]-b)), useNames=FALSE)
      verbose && exit(verbose)
    }
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Call ROH
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Identify heterozygous SNPs
  isHet <- (muN == 1/2)
  verbose && print(verbose, summary(isHet))

  # With or without genotype confidence scores?
  if (!is.null(csN)) {
    # 0-1 weights (just to make sure)
    # Weights summing to one
    w <- csN / sum(csN, na.rm=TRUE)

    wnHets <- sum(isHet*w, na.rm=TRUE)
    wnSnps <- sum(w, na.rm=TRUE) # == 1 /HB

    # Sanity check
    .stop_if_not(isZero(wnSnps - 1.0, eps=sqrt(.Machine$double.eps)))
  } else {
    wnHets <- sum(isHet, na.rm=TRUE)
    wnSnps <- 1
  }

  propHets <- wnHets/wnSnps
  verbose && print(verbose, propHets)

  call <- (propHets < delta)
  verbose && print(verbose, call)

  # Record parameter settings
  attr(call, "minNbrOfSnps") <- minNbrOfSnps
  attr(call, "delta") <- delta

  verbose && exit(verbose)

  call
}) # testROH()


##############################################################################
# HISTORY
# 2014-03-30 [HB]
# o GENERALIZATION: Now testROH() default to equal confidence scores
#   whenever neither 'csN' not 'betaN' is given.  This means that
#   callROH() can also be done if only 'muN' was provided.
# o Updated the ordering and the defaults of testROH() arguments to make
#   it clear that 'betaN' is optional and only used if 'csN' is not given.
# 2013-03-08 [HB]
# o Added Rdoc help.
# 2012-05-30 [HB]
# o Now testROH() return parameter settings as attributes.
# 2011-11-21 [HB]
# o BUG FIX: The internal sanity check on weights was slightly too
#   conservative.
# 2011-11-12 [HB]
# o Renamed argument 'tauROH' to 'delta', cf. how we do for AB and LOH.
# o Added argument 'minNbrOfSnps' to testROH().
# o Added verbose output.
# 2011-11-12 [PN]
# o Implemented a naive caller based on the weighted proportion of hets
#   in the segment.
# 2011-11-04 [HB]
# o Added skeleton for testROH().
# o Created.
##############################################################################

###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod callGNL
# @aliasmethod callGainNeutralLoss
# @alias callGNLByTCNofAB
# @aliasmethod callGNLByTCNofAB
# @alias callGNLByTCNofABv1
# @aliasmethod callGNLByTCNofABv1
#
# @title "Calls segments that are gained, copy neutral, or lost"
#
# \description{
#  @get "title", where copy neutral means having a total copy number
#  that corresponds to the ploidy of the genome.
# }
#
# @synopsis
#
# \arguments{
#   \item{flavor}{A @character string specifying which type of
#    call to use.}
#   \item{...}{Additional arguments passed to the caller.}
#   \item{minSize}{An optional @integer specifying the minimum number
#    of data points in order to call a segments.  If fewer data points,
#    then the call is set to @NA regardless.}
#   \item{force}{If @FALSE, and copy-neutral calls already exits,
#    then nothing is done, otherwise the calls are done.}
# }
#
# \value{
#   Returns a @see "PairedPSCBS" object with added calls.
# }
#
# @author "HB"
#
# \seealso{
#   Internally, one of the following methods are used:
#   \code{callGNLByTCNofAB()}.
# }
#
#*/###########################################################################
setMethodS3("callGNL", "PairedPSCBS", function(fit, flavor=c("TCN|AB"), ..., minSize=1, force=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'flavor':
  flavor <- match.arg(flavor)

  # Argument 'minSize':
  minSize <- Arguments$getDouble(minSize, range=c(1,Inf))


  # Already done?
  segs <- as.data.frame(fit)
  if (!force && all(is.element(c("gainCall", "ntcnCall", "lossCall"), names(segs)))) {
    # Segments are already called
    return(invisible(fit))
  }

  if (flavor == "TCN|AB") {
    fit <- callGNLByTCNofAB(fit, ..., force=force)
  } else {
    stop("Cannot call allelic balance. Unsupported flavor: ", flavor)
  }

  # Don't call segments with too few data points?
  if (minSize > 1) {
    segs <- as.data.frame(fit)
    ns <- segs$dhNbrOfLoci
    calls <- segs$ntcnCall
    calls[ns < minSize] <- NA
    segs$ntcnCall <- calls
    fit$output <- segs
    # Not needed anymore
    segs <- calls <- NULL
  }

  return(invisible(fit))
}) # callGNL()

setMethodS3("callGainNeutralLoss", "PairedPSCBS", function(...) {
  callGNL(...)
})


setMethodS3("callGNLByTCNofAB", "PairedPSCBS", function(fit, ..., minSize=1L, force=FALSE, verbose=FALSE) {
  # Argument 'minSize':
  minSize <- Arguments$getDouble(minSize, range=c(1,Inf))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Calling gain, neutral, and loss based TCNs of AB segments")

  # Already done?
  segs <- as.data.frame(fit)
  called <- all(is.element(c("gainCall", "ntcnCall", "lossCall"), names(segs)))
  if (!force && called) {
    return(invisible(fit))
  }

  verbose && enter(verbose, "Calling neutral TCNs")
  fit <- callCopyNeutralByTCNofAB(fit, ..., verbose=verbose)
  verbose && exit(verbose)

  # The segment data
  segs <- as.data.frame(fit)
  tcnMean <- segs$tcnMean
  nbrOfSegs <- nrow(segs)

  # The call thresholds and the NTCN calls
  ntcnCall <- call <- segs$ntcnCall
  verbose && printf(verbose, "Number of NTCN calls: %d (%.2f%%) of %d\n", sum(call, na.rm=TRUE), 100*sum(call, na.rm=TRUE)/nbrOfSegs, nbrOfSegs)

  params <- fit$params

  deltaCN <- params$deltaCN
  .stop_if_not(!is.null(deltaCN))
  ntcnRange <- params$ntcnRange
  .stop_if_not(!is.null(ntcnRange))

  # Confidence interval of the TCN|AB segments
  range <- ntcnRange + c(+1,-1)*deltaCN

  # Mean of the TCN|AB segments
  mu <- mean(range, na.rm=TRUE)

  verbose && printf(verbose, "Mean TCN of AB segments: %g\n", mu)

  verbose && enter(verbose, "Calling loss")
  call <- !ntcnCall & (tcnMean < mu)
  segs$lossCall <- call
  verbose && printf(verbose, "Number of loss calls: %d (%.2f%%) of %d\n", sum(call, na.rm=TRUE), 100*sum(call, na.rm=TRUE)/nbrOfSegs, nbrOfSegs)
  verbose && exit(verbose)

  verbose && enter(verbose, "Calling gain")
  call <- !ntcnCall & (tcnMean > mu)
  segs$gainCall <- call
  verbose && printf(verbose, "Number of loss calls: %d (%.2f%%) of %d\n", sum(call, na.rm=TRUE), 100*sum(call, na.rm=TRUE)/nbrOfSegs, nbrOfSegs)
  verbose && exit(verbose)

  # Recording
  fit$output <- segs

  verbose && exit(verbose)

  fit
}) # callGNLByTCNofAB()



setMethodS3("callGNLByTCNofABv1", "PairedPSCBS", function(fit, deltaLoss=-0.5, deltaGain=+0.5, alpha=0.05, ..., force=FALSE, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'alpha':
  disallow <- c("NA", "NaN", "Inf")
  alpha <- Arguments$getDouble(alpha, range=c(0,0.5), disallow=disallow)

  # Argument 'deltaLoss' & 'deltaGain':
  disallow <- c("NA", "NaN", "Inf")
  deltaLoss <- Arguments$getDouble(deltaLoss, range=c(-Inf,0), disallow=disallow)
  deltaGain <- Arguments$getDouble(deltaGain, range=c(0,+Inf), disallow=disallow)

  # Argument 'force':
  force <- Arguments$getLogical(force)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "callGNLByTCNofAB")
  verbose && cat(verbose, "Alpha: ", alpha)
  verbose && cat(verbose, "Delta loss: ", deltaLoss)
  verbose && cat(verbose, "Delta gain: ", deltaGain)

  segs <- getSegments(fit, splitters=TRUE, simplify=FALSE)

  # Already done?
  if (!force && all(is.element(c("gainCall", "ntcnCall", "lossCall"), names(segs)))) {
    # Segments are already called
    verbose && cat(verbose, "Already called. Skipping.")
    verbose && exit(verbose)
    return(invisible(fit))
  }

  # Check that bootstrap estimates exists
  keys <- sprintf("tcn_%g%%", 100*c(alpha/2, 1-alpha/2))
  missing <- keys[!is.element(keys, colnames(segs))]
  if (length(missing) > 0) {
    stop("No such statistics: ", hpaste(missing))
  }

  verbose && enter(verbose, "Calling segments")


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Confidence interval of copy-neutral AB segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Estimating TCN confidence interval of copy-neutral AB segments")

  fit <- calcStatsForCopyNeutralABs(fit, ..., verbose=less(verbose, 5))
  stats <- fit$params$copyNeutralStats
  verbose && cat(verbose, "Bootstrap statistics for copy-neutral AB segments:")
  verbose && print(verbose, stats)

  # Extract TCN stats
  cols <- grep("^(tcn_|tcnMean)", colnames(stats))
  tcnStats <- stats[,cols,drop=FALSE]
  tcnStats <- unlist(tcnStats, use.names=TRUE)
  verbose && print(verbose, "TCN statistics:")
  verbose && print(verbose, tcnStats)

  # Extract confidence interval of interest
  keys <- sprintf("tcn_%g%%", 100*c(alpha/2, 1-alpha/2))
  missing <- keys[!is.element(keys, names(tcnStats))]
  if (length(missing) > 0) {
    stop("No such statistics: ", hpaste(missing))
  }
  mean <- tcnStats["tcnMean"]
  ci <- tcnStats[keys]
  verbose && printf(verbose, "%g%%-confidence interval of TCN mean for the copy-neutral state: [%g,%g] (mean=%g)\n", 100*(1-alpha), ci[1], ci[2], mean)

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Get call regions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  naValue <- NA_real_
  callRegions <- matrix(c(
     Inf,    1,
       1,    1,
       1,  Inf
  ), nrow=3, ncol=2, byrow=TRUE)
  rownames(callRegions) <- c("loss", "ntcn", "gain")
  colnames(callRegions) <- c("lower", "upper")
  callRegions["loss",] <- ci[1]+callRegions["loss",]*deltaLoss
  callRegions["ntcn",] <- ci   +callRegions["ntcn",]*c(deltaLoss, deltaGain)
  callRegions["gain",] <- ci[2]+callRegions["gain",]*deltaGain

  verbose && cat(verbose, "Call (\"acceptance\") regions:")
  verbose && print(verbose, callRegions)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Get statistics for all segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegs <- nrow(segs)
  verbose && cat(verbose, "Number of segments: ", nbrOfSegs)
  nbrOfABs <- sum(segs$abCall, na.rm=TRUE)
  verbose && cat(verbose, "Number of AB segments: ", nbrOfABs)
  verbose && cat(verbose, "Number of non-AB segments: ", nbrOfSegs-nbrOfABs)

  # Get TCN confidence intervals for all segments
  keys <- sprintf("tcn_%g%%", 100*c(alpha/2, 1-alpha/2))
  ci <- segs[,keys]

  # Call states
  for (rr in seq_len(nrow(callRegions))) {
    state <- rownames(callRegions)[rr]
    verbose && enter(verbose, "Identify all '", state, "' segments")
    range <- callRegions[rr,]
    verbose && printf(verbose, "Call (\"acceptance\") region: [%g,%g]\n", range[1], range[2])

    # If a confidence interval is completely within the
    # calling region, call it
    isCalled <- (range[1] <= ci[,1] & ci[,2] < range[2])

    nbrOfCalled <- sum(isCalled, na.rm=TRUE)
    verbose && cat(verbose, "Number of segments called '", state, "': ", nbrOfCalled)
##    verbose && cat(verbose, "Number of non-AB segments called '", state, "': ", (nbrOfSegs-nbrOfABs)-nbrOfCalled)

    key <- sprintf("%sCall", state)
    segs[[key]] <- isCalled
    verbose && exit(verbose)
  } # for (rr ...)

  fitC <- fit
  fitC$output <- segs

  verbose && exit(verbose)

  fitC
}, protected=TRUE) # callGNLByTCNofABv1()



##############################################################################
# HISTORY
# 2013-09-20 [HB]
# o BUG FIX: callGNL() for PairedPSCBS used non-defined 'verbose' object.
# 2012-03-22 [HB]
# o Renamed 'cnCall' to 'ntcnCall' for callGNLByTCNofAB().
# 2012-02-26 [HB]
# o Added internal callGNLByTCNofAB().
# o Added callGNL().
##############################################################################

#!/usr/bin/env Rscript
library("revdepcheck")
options(warn = 1L)

available_cores <- function() {
  getenv <- function(name) {
    as.integer(Sys.getenv(name, NA_character_))
  }
  getopt <- function(name) {
    as.integer(getOption(name, NA_integer_))
  }
  if (is.finite(n <- getopt("mc.cores") + 1L)) return(n)
  if (is.finite(n <- getopt("Ncpus") + 1L)) return(n)
  if (is.finite(n <- getenv("PBS_NUM_PPN"))) return(n)
  if (is.finite(n <- getenv("SLURM_CPUS_PER_TASK"))) return(n)
  if (is.finite(n <- getenv("NSLOTS"))) return(n)
  1L
}

precheck <- function() {
  ## WORKAROUND: Remove checked pkgs that use file links, which otherwise
  ## produce warnings which are promoted to errors by revdepcheck.
  unlink("revdep/checks/aroma.affymetrix", recursive = TRUE)
}

check <- function() {
  if (file_test("-f", p <- Sys.getenv("R_CHECK_ENVIRON", "~/.R/check.Renviron"))) {
    cat(sprintf("R CMD check will use env vars from %s\n", sQuote(p)))
    cat(sprintf("To disable, set 'R_CHECK_ENVIRON=false' (a fake pathname)\n"))
  }
  
  envs <- grep("^_R_CHECK_", names(Sys.getenv()), value = TRUE)
  if (length(envs) > 0L) {
    cat(sprintf("Detected _R_CHECK_* env vars that will affect R CMD check: %s\n",
                paste(sQuote(envs), collapse = ", ")))
  }

  precheck()
  revdep_check(bioc = TRUE, num_workers = available_cores(),
               timeout = as.difftime(20, units = "mins"), quiet = FALSE)
}


todo <- function() {
  pkgs <- tryCatch(revdep_todo(), error = function(ex) NA)
  if (identical(pkgs, NA)) {
    cat("Revdepcheck has not been initiated\n")
    return()
  }
  pkgs <- subset(pkgs, status == "todo")
  if (nrow(pkgs) == 0) {
    cat("There are no packages on the revdepcheck todo list\n")
  } else {
    cat(sprintf("%d. %s\n", seq_len(nrow(pkgs)), pkgs$package))
  }
}

parse_pkgs <- function(pkgs) {
  pkgs <- unlist(strsplit(pkgs, split = ",", fixed = TRUE))
  pkgs <- gsub("[ \t'\"‘’]", "", pkgs)
  sort(unique(pkgs))
}

revdep_init <- function() {
  if (!revdepcheck:::db_exists(".")) revdepcheck:::db_setup(".")
}

revdep_todo_reset <- function() {
  revdep_init()
  db <- revdepcheck:::db(".")
  df <- data.frame(package = character(0L), stringsAsFactors = FALSE)
  DBI::dbWriteTable(db, "todo", df, overwrite = TRUE, append = FALSE)
}

revdep_children <- local({
  cache <- list()
  function(pkg = NULL) {
    if (is.null(pkg)) pkg <- desc::desc(file = "DESCRIPTION")$get("Package")
    pkgs <- cache[[pkg]]
    if (is.null(pkgs)) {
      pkgs <- revdepcheck:::cran_revdeps(pkg)
      pkgs <- setdiff(pkgs, pkg) ## WORKAROUND
      cache[[pkg]] <- pkgs
    }
    pkgs
  }
})

args <- base::commandArgs()
if ("--reset" %in% args) {
  revdep_reset()
} else if ("--todo-reset" %in% args) {
  revdep_todo_reset()
  todo()
} else if ("--todo" %in% args) {
  todo()
} else if ("--add" %in% args) {
  pos <- which("--add" == args)
  pkgs <- parse_pkgs(args[seq(from = pos + 1L, to = length(args))])
  revdep_add(packages = pkgs)
  todo()
} else if ("--rm" %in% args) {
  pos <- which("--rm" == args)
  pkgs <- parse_pkgs(args[seq(from = pos + 1L, to = length(args))])
  revdep_rm(packages = pkgs)
  todo()
} else if ("--add-broken" %in% args) {
  revdep_add_broken()
  todo()
} else if ("--add-all" %in% args) {
  revdep_init()
  pkgs <- revdep_children()
  for (pkg in pkgs) {
    pkgs <- c(pkgs, revdepcheck:::cran_revdeps(pkg))
  }
  pkgs <- unique(pkgs)
  revdep_add(packages = pkgs)
  todo()
} else if ("--add-grandchildren" %in% args) {
  revdep_init()
  pkgs <- NULL
  for (pkg in revdep_children()) {
    pkgs <- c(pkgs, revdepcheck:::cran_revdeps(pkg))
  }
  pkgs <- unique(pkgs)
  revdep_add(packages = pkgs)
  todo()
} else if ("--install" %in% args) {
  pos <- which("--install" == args)
  pkgs <- parse_pkgs(args[seq(from = pos + 1L, to = length(args))])
  crancache::install_packages(pkgs)
} else {
  check()
  revdep_report(all = TRUE)
}

###########################################################################/**
# @RdocDefault segmentByCBS
# @alias segmentByCBS.data.frame
# @alias segmentByCBS.CBS
# @alias segmentByCBS.CNA
# @alias segmentByCBS
#
# @title "Segment genomic signals using the CBS method"
#
# \description{
#  @get "title" of the \pkg{DNAcopy} package.
#  This is a convenient low-level wrapper for the \code{DNAcopy::segment()}
#  method.  It is intended to be applied to a sample at the time.
#  For more details on the Circular Binary Segmentation (CBS) method
#  see [1,2].
# }
#
# @synopsis
#
# \arguments{
#   \item{y}{A @numeric @vector of J genomic signals to be segmented.}
#   \item{chromosome}{Optional @numeric @vector of length J, specifying
#       the chromosome of each loci.  If a scalar, it is expanded to
#       a vector of length J.}
#   \item{x}{Optional @numeric @vector of J genomic locations.
#            If @NULL, index locations \code{1:J} are used.}
#   \item{index}{An optional @integer @vector of length J specifying
#     the genomewide indices of the loci.}
#   \item{w}{Optional @numeric @vector in [0,1] of J weights.}
#   \item{undo}{A non-negative @numeric.  If greater than zero, then
#       arguments \code{undo.splits="sdundo"} and \code{undo.SD=undo}
#       are passed to \code{DNAcopy::segment()}.
#       In the special case when \code{undo} is +@Inf, the segmentation
#       result will not contain any changepoints (in addition to what
#       is specified by argument \code{knownSegments}).}
#   \item{avg}{A @character string specifying how to calculating
#         segment mean levels \emph{after} change points have been
#         identified.}
#   \item{...}{Additional arguments passed to the \code{DNAcopy::segment()}
#       segmentation function.}
#   \item{joinSegments}{If @TRUE, there are no gaps between neighboring
#     segments.
#     If @FALSE, the boundaries of a segment are defined by the support
#     that the loci in the segments provides, i.e. there exist a locus
#     at each end point of each segment.  This also means that there
#     is a gap between any neighboring segments, unless the change point
#     is in the middle of multiple loci with the same position.
#     The latter is what \code{DNAcopy::segment()} returns.
#   }
#   \item{knownSegments}{Optional @data.frame specifying
#     \emph{non-overlapping} known segments.  These segments must
#     not share loci.  See @see "findLargeGaps" and @see "gapsToSegments".}
#   \item{seed}{An (optional) @integer specifying the random seed to be
#     set before calling the segmentation method.  The random seed is
#     set to its original state when exiting.  If @NULL, it is not set.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns a @see "CBS" object.
# }
#
# \details{
#   Internally @see "DNAcopy::segment" of \pkg{DNAcopy} is used to
#   segment the signals.
#   This segmentation method support weighted segmentation.
# }
#
# \section{Reproducibility}{
#   The \code{DNAcopy::segment()} implementation of CBS uses approximation
#   through random sampling for some estimates.  Because of this,
#   repeated calls using the same signals may result in slightly
#   different results, unless the random seed is set/fixed.
# }
#
# \section{Missing and non-finite values}{
#   Signals may contain missing values (@NA or @NaN), but not
#   infinite values (+/-@Inf).  Loci with missing-value signals
#   are preserved and keep in the result.
#
#   Likewise, genomic positions may contain missing values.
#   However, if they do, such loci are silently excluded before
#   performing the segmentation, and are not kept in the results.
#   The mapping between the input locus-level data and ditto of
#   the result can be inferred from the \code{index} column of
#   the locus-level data of the result.
#
#   None of the input data may have infinite values,
#   i.e. -@Inf or +@Inf. If so, an informative error is thrown.
# }
#
# \examples{
#   @include "../incl/segmentByCBS.Rex"
#   @include "../incl/segmentByCBS,plot.Rex"
#   @include "../incl/segmentByCBS,tests.Rex"
# }
#
# @author "HB"
#
# \references{
#  [1] @include "../incl/OlshenVenkatraman_2004.Rd" \cr
#  [2] @include "../incl/VenkatramanOlshen_2007.Rd" \cr
# }
#
# \seealso{
#   To segment allele-specific tumor copy-number signals from a tumor
#   \emph{with} a matched normal, see @see "segmentByPairedPSCBS".
#   For the same \emph{without} a matched normal,
#   see @see "segmentByNonPairedPSCBS".
#
#   It is also possible to prune change points after segmentation (with
#   identical results) using
#   \code{\link[PSCBS:pruneBySdUndo.CBS]{pruneBySdUndo}()}.
# }
# @keyword IO
#*/###########################################################################
setMethodS3("segmentByCBS", "default", function(y, chromosome=0L, x=NULL, index=seq_along(y), w=NULL, undo=0, avg=c("mean", "median"), ..., joinSegments=TRUE, knownSegments=NULL, seed=NULL, verbose=FALSE) {
  R_SANITY_CHECK <- TRUE

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Local functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # DNAcopy::getbdry() is slow for now default settings.  Below we
  # implement a memoized version of this function.
  getbdry2 <- function(eta, nperm, alpha, tol=0.01, verbose=FALSE) {
    # Explictly setup cache root here, since it's only done by 'R.cache'
    # if that package is attached.  Here we only load it. /HB 2013-09-27
    .setupCacheRootPath()

    key <- list(method="segmentByCBS",
                eta=eta, nperm=as.integer(nperm), alpha=alpha, tol=tol,
                version="0.16.1")
    dirs <- c("PSCBS", "segmentByCBS", "sbdry")
    bdry <- loadCache(key=key, dirs=dirs)
    if (!is.null(bdry)) return(bdry)

    max.ones <- floor(nperm * alpha) + 1L
    bdry <- getbdry(eta=eta, nperm=nperm, max.ones=max.ones, tol=tol)

    saveCache(bdry, key=key, dirs=dirs)

    bdry
  } # getbdry2()


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'y':
  disallow <- c("Inf")
  y <- Arguments$getDoubles(y, disallow=disallow)
  nbrOfLoci <- length(y)

  length2 <- rep(nbrOfLoci, times=2)

  # Argument 'chromosome':
  if (is.null(chromosome)) {
    chromosome <- 0L
  } else {
    disallow <- c("Inf")
    chromosome <- Arguments$getIntegers(chromosome, range=c(0,Inf), disallow=disallow)
    if (length(chromosome) > 1) {
      chromosome <- Arguments$getIntegers(chromosome, length=length2, disallow=disallow)
  ##    # If 'chromosome' is a vector of length J, then it must contain
  ##    # a unique chromosome.
  ##    chromosomes <- sort(unique(chromosome))
  ##    if (length(chromosomes) > 1) {
  ##      stop("Argument 'chromosome' specifies more than one unique chromosome: ", paste(seqToHumanReadable(chromosomes), collapse=", "))
  ##    }
  ##    chromosome <- chromosomes
    }
  }

  # For future usage
  chrom <- rep(chromosome, length.out=nbrOfLoci)

  # Argument 'x':
  if (is.null(x)) {
    x <- seq_len(nbrOfLoci)
  } else {
    disallow <- c("Inf")
    x <- Arguments$getDoubles(x, length=length2, disallow=disallow)
  }

  # Argument 'index':
  if (is.null(index)) {
    index <- seq_along(y)
  } else {
    index <- Arguments$getIndices(index)
  }

  # Argument 'w':
  hasWeights <- !is.null(w)
  if (hasWeights) {
    disallow <- c("NA", "NaN", "Inf")
    w <- Arguments$getDoubles(w, range=c(0,1), length=length2, disallow=disallow)
  }

  # Argument 'undo':
  undo <- Arguments$getDouble(undo, range=c(0,Inf))

  # Argument 'avg':
  avg <- match.arg(avg)

  # Argument 'cpFlavor':
  joinSegments <- Arguments$getLogical(joinSegments)

  # Argument 'knownSegments':
  if (is.null(knownSegments)) {
    knownSegments <- data.frame(chromosome=integer(0), start=integer(0), end=integer(0))
  } else {
#    if (!joinSegments) {
#      stop("Argument 'knownSegments' should only be specified if argument 'joinSegments' is TRUE.")
#    }
  }

  if (!is.data.frame(knownSegments)) {
    stop("Argument 'knownSegments' is not a data.frame: ", class(knownSegments)[1])
  }

  if (!all(is.element(c("chromosome", "start", "end"), colnames(knownSegments)))) {
    stop("Argument 'knownSegments' does not have the required column names: ", hpaste(colnames(knownSegments)))
  }

  # Detailed validation of 'knownSegments'.
  for (chr in sort(unique(knownSegments$chromosome))) {
    dd <- subset(knownSegments, chromosome == chr)

    # Order segments by 'start'.
    o <- order(dd$start)
    dd <- dd[o,]

    # Known segments must not share 'start' or 'end' loci
    for (field in c("start", "end")) {
      xs <- dd[[field]]
      xs <- xs[!is.na(xs)]
      if (anyDuplicated(xs) > 0) {
        print(knownSegments)
        stop(sprintf("Detected segments on chromosome %s with non-unique '%s' positions in argument 'knownSegments'", chr, field))
      }
    } # for (field ...)

    # Known segments must not overlap
    if (!all(dd$start[-1] >= dd$end[-nrow(dd)], na.rm=TRUE)) {
      print(knownSegments)
      stop("Detected overlapping segments on chromosome ", chr, " in argument 'knownSegments'.")
    }
  }

  # Argument 'seed':
  if (!is.null(seed)) {
    seed <- Arguments$getIntegers(seed)
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Segmenting by CBS")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Setup up data", level=-10)
  data <- data.frame(chrom=chrom, x=x, y=y, index=index)
  if (hasWeights) {
    verbose && cat(verbose, "Adding locus-specific weights", level=-10)
    data$w <- w
  }
  verbose && str(verbose, data, level=-10)
  # Not needed anymore
  chrom <- x <- index <- y <- w <- NULL
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Drop data points without known genomic positions, because that
  # is what DNAcopy::CNA() will do otherwise.
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  ok <- (!is.na(data$chrom) & !is.na(data$x))
  if (any(!ok)) {
    verbose && enter(verbose, "Dropping loci with unknown locations", level=-10)
    verbose && cat(verbose, "Number of loci dropped: ", sum(!ok), level=-10)
    data <- data[ok,,drop=FALSE]
    verbose && exit(verbose)
  }
  ok <- NULL # Not needed anymore


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Reorder data points along the genome, because that is what
  # DNAcopy::segment() will return.  At the end, we will undo
  # the sort such that the returned 'data' object is always in
  # the same order and number of loci as the input data.
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Ordering data along genome", level=-50)
  o <- order(data$chrom, data$x, decreasing=FALSE, na.last=TRUE)
  # Any change?
  if (any(o != seq_along(o))) {
    data <- data[o,,drop=FALSE]
  }
  o <- NULL # Not needed anymore
  verbose && str(verbose, data, level=-50)
  verbose && exit(verbose)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Multiple chromosomes?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Identify all chromosomes, excluding missing values
  chromosomes <- sort(unique(data$chrom), na.last=NA)
  nbrOfChromosomes <- length(chromosomes)
  if (nbrOfChromosomes > 1) {
    verbose && enter(verbose, "Segmenting multiple chromosomes")
    verbose && cat(verbose, "Number of chromosomes: ", nbrOfChromosomes)

    # Generate random seeds?
    seeds <- NULL
    if (!is.null(seed)) {
      randomSeed("set", seed=seed, kind="L'Ecuyer-CMRG")
      on.exit(randomSeed("reset"), add=TRUE)
      verbose && printf(verbose, "Random seed temporarily set (seed=c(%s), kind=\"L'Ecuyer-CMRG\")\n", paste(seed, collapse=", "))
      seeds <- randomSeed("advance", n=nbrOfChromosomes)
      verbose && printf(verbose, "Produced %d seeds from this stream for future usage\n", length(seeds))
    }

    fitList <- list()
    for (kk in seq_len(nbrOfChromosomes)) {
      chromosomeKK <- chromosomes[kk]
      chrTag <- sprintf("Chr%02d", chromosomeKK)
      verbose && enter(verbose, sprintf("Chromosome #%d ('%s') of %d", kk, chrTag, nbrOfChromosomes))

      seedKK <- seeds[[kk]]

      # Extract subset of data and parameters for this chromosome
      dataKK <- subset(data, chrom == chromosomeKK)
      verbose && str(verbose, dataKK, level=-10)
      chrom <- x <- index <- y <- w <- NULL
      fields <- attachLocally(dataKK, fields=c("chrom", "x", "index", "y", "w"))
      dataKK <- NULL # Not needed anymore

      knownSegmentsKK <- NULL
      if (!is.null(knownSegments)) {
        knownSegmentsKK <- subset(knownSegments, chromosome == chromosomeKK)
        if (nrow(knownSegmentsKK) == 0L) {
          knownSegmentsKK <- data.frame(chromosome=chromosomeKK, start=-Inf, end=+Inf)
        }
        verbose && cat(verbose, "Known segments:", level=-5)
        verbose && print(verbose, knownSegmentsKK, level=-5)
      }

      fitList[[chrTag]] <- future({
        fit <- segmentByCBS(y=y,
                  chromosome=chrom, x=x,
                  w=w,
                  index=index,
                  undo=undo,
                  avg=avg,
                  joinSegments=joinSegments,
                  knownSegments=knownSegmentsKK,
                  ...,
                  seed=seedKK,
                  verbose=verbose)

        # Sanity checks
        if (R_SANITY_CHECK) {
          if (nrow(knownSegmentsKK) == 0) {
            # Since all missing data have been dropped...
            .stop_if_not(nrow(fit$data) == length(y))
            # ...and ordered along the genome already.
            .stop_if_not(all.equal(fit$data$y, y))
          }

          # Assert weights were used
          .stop_if_not(!hasWeights || !is.null(fit$data$w))
        } # if (R_SANITY_CHECK)

        verbose && print(verbose, head(as.data.frame(fit)), level=-10)
        verbose && print(verbose, tail(as.data.frame(fit)), level=-10)

        fit
      }, seed = TRUE, label = sprintf("segmentByCBS-%s", chrTag))

      rm(list=fields) # Not needed anymore
      verbose && exit(verbose)
    } # for (kk ...)

    verbose && enter(verbose, "Merging (independently) segmented chromosome", level=-50)
    fitList <- value(fitList)
    ## former Reduce() w/ append(..., addSplit = TRUE)
    fit <- do.call(c, args = c(fitList, addSplit = TRUE))
    # Not needed anymore
    fitList <- NULL

    # Update parameters that otherwise may be incorrect
    fit$params$seed <- seed

    verbose && str(verbose, fit, level=-10)
    verbose && exit(verbose)

    segs <- as.data.frame(fit)
    if (nrow(segs) < 6) {
      verbose && print(verbose, segs, level=-10)
    } else {
      verbose && print(verbose, head(segs), level=-10)
      verbose && print(verbose, tail(segs), level=-10)
    }

    verbose && exit(verbose)

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Return results
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    return(fit)
  } # if (nbrOfChromosomes > 1)

  verbose && cat(verbose, "Chromosome: ", data$chrom[1L])

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Subset 'knownSegments'
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Keeping only current chromosome for 'knownSegments'", level=-10)

  # Assume no missing values
  currChromosome <- data$chrom[1]
  verbose && cat(verbose, "Chromosome: ", currChromosome, level=-10)

  knownSegments <- subset(knownSegments, chromosome == currChromosome)
  if (nrow(knownSegments) == 0L) {
    knownSegments <- data.frame(chromosome=currChromosome, start=-Inf, end=+Inf)
  }
  nbrOfSegments <- nrow(knownSegments)

  verbose && cat(verbose, "Known segments for this chromosome:", level=-10)
  verbose && print(verbose, knownSegments, level=-10)

  verbose && exit(verbose)


  # Sanity checks
  if (R_SANITY_CHECK) {
    # Here 'knownSegments' should specify at most a single chromosome
    uChromosomes <- sort(unique(knownSegments$chromosome))
    if (length(uChromosomes) > 1) {
      stop("INTERNAL ERROR: Argument 'knownSegments' specifies more than one chromosome: ", hpaste(uChromosomes))
    }
  } # if (R_SANITY_CHECK)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Multiple segments?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Sanity check of limitation  /HB 2011-10-19
  if (nbrOfSegments > 1) {
    verbose && enter(verbose, "Segmenting multiple segments on current chromosome", level=-5)
    verbose && cat(verbose, "Number of segments: ", nbrOfSegments, level=-5)

    # Create a splitter-only CBS object
    dataS <- data.frame(y=c(0,0), chromosome=c(1,2), x=c(0,0))
    if (hasWeights) dataS$w <- 1
    splitter <- segmentByCBS(dataS)
    dataS <- NULL
    suppressWarnings({
      splitter <- extractSegment(splitter, 2)
      # Sanity check
      if (R_SANITY_CHECK) {
        .stop_if_not(nbrOfSegments(splitter, splitters=TRUE) == 1)
      } # if (R_SANITY_CHECK)
    })


    # Generate random seeds?
    seeds <- NULL
    if (!is.null(seed)) {
      randomSeed("set", seed=seed, kind="L'Ecuyer-CMRG")
      on.exit(randomSeed("reset"), add=TRUE)
      verbose && printf(verbose, "Random seed temporarily set (seed=c(%s), kind=\"L'Ecuyer-CMRG\")\n", paste(seed, collapse=", "))
      seeds <- randomSeed("advance", n=nbrOfSegments)
      verbose && printf(verbose, "Produced %d seeds from this stream for future usage\n", length(seeds))
    }

    fitList <- list()
    for (jj in seq_len(nbrOfSegments)) {
      seg <- knownSegments[jj,]
      chromosomeJJ <- seg$chromosome
      xStart <- seg$start
      xEnd <- seg$end
      segTag <- sprintf("chr%s:(%s,%s)", chromosomeJJ, xStart, xEnd)
      verbose && enter(verbose, sprintf("Segment #%d ('%s') of %d", jj, segTag, nbrOfSegments), level=-10)

      ## Nothing to do?
      isSplitter <- (is.na(xStart) && is.na(xEnd))
      if (isSplitter) {
        fit <- splitter
        verbose && cat(verbose, "Nothing to segment. Inserting an explicit splitter.", level=-10)
        fitList[[segTag]] <- fit
        fit <- NULL
        verbose && exit(verbose)
        next
      }

      # Extract subset of data and parameters for this segment
      dataJJ <- subset(data, chrom == chromosomeJJ & xStart <= x & x <= xEnd)
      verbose && str(verbose, dataJJ, level=-50)
      chrom <- x <- index <- y <- w <- NULL
      fields <- attachLocally(dataJJ, fields=c("chrom", "x", "index", "y", "w"))
      dataJJ <- NULL # Not needed anymore
      nbrOfLoci <- length(y)

      # Empty segment?
      # [AD HOC. Should be done by segmentCBS(). /HB 2011-10-21]
      if(nbrOfLoci == 0) {
        fit <- splitter
        fit$output$chromosome <- chromosomeJJ
        fit$output$start <- xStart
        fit$output$end <- xEnd
        fit$output$nbrOfLoci <- nbrOfLoci
        fitList[[segTag]] <- fit
        fit <- NULL
        verbose && exit(verbose)
        next
      }

      seedJJ <- seeds[[jj]]

      fitList[[segTag]] <- future({
        fit <- segmentByCBS(y=y,
                  chromosome=chrom, x=x,
                  w=w,
                  index=index,
                  undo=undo,
                  avg=avg,
                  joinSegments=joinSegments,
                  knownSegments=seg,
                  ...,
                  seed=seedJJ,
                  verbose=less(verbose,1))

        # Sanity checks
        if (R_SANITY_CHECK) {
          .stop_if_not(nrow(fit$data) == nbrOfLoci)
          .stop_if_not(all.equal(fit$data$y, y))

          # Assert weights were used
          .stop_if_not(!hasWeights || !is.null(fit$data$w))
        } # if (R_SANITY_CHECK)

        segs <- as.data.frame(fit)
        if (nrow(segs) < 6) {
          verbose && print(verbose, segs, level=-10)
        } else {
          verbose && print(verbose, head(segs), level=-10)
          verbose && print(verbose, tail(segs), level=-10)
        }

        # Sanity check
        if (R_SANITY_CHECK) {
          ## NOTE: Need to use PSCBS::nbrOfSegments() for this to work
          ## when 'PSCBS' is not attached. The reason is that the future
          ## picks up the local integer variable 'nbrOfSegments' instead
          ## of the nbrOfSegments() function of 'PSCBS' as a global
          ## variable.
          ## https://github.com/HenrikBengtsson/PSCBS/issues/67
          .stop_if_not(TRUE && PSCBS::nbrOfSegments(fit, splitters=TRUE) > 0)
        } # if (R_SANITY_CHECK)

        fit
      }, seed = TRUE, label = sprintf("segmentByCBS-%s", segTag))

      rm(list=fields) # Not needed anymore

      verbose && exit(verbose)
    } # for (jj ...)


    verbose && enter(verbose, "Merging (independently) segmented known segments", level=-10)
    verbose && cat(verbose, "Number of segments: ", length(fitList), level=-10)
    fitList <- value(fitList)
    verbose && str(verbose, fitList, level=-50)
    ## former Reduce() w/ append(..., addSplit = FALSE)
    fit <- do.call(c, args = c(fitList, addSplit = FALSE))
    # Not needed anymore
    fitList <- NULL

    # Update parameters that otherwise may be incorrect
    fit$params$seed <- seed

    verbose && str(verbose, fit, level=-10)
    verbose && exit(verbose)

    segs <- getSegments(fit)
    if (nrow(segs) > 6) {
      verbose && print(verbose, head(segs), level=-10)
      verbose && print(verbose, tail(segs), level=-10)
    } else {
      verbose && print(verbose, segs, level=-10)
    }

    # Sanity checks
    if (R_SANITY_CHECK) {
      segs <- getSegments(fit)
      .stop_if_not(all(segs$start[-1] >= segs$end[-nrow(segs)], na.rm=TRUE))
      .stop_if_not(all(diff(segs$start) >= 0, na.rm=TRUE)) ## FIXME: > 0
      .stop_if_not(all(diff(segs$end) >= 0, na.rm=TRUE)) ## FIXME: > 0

  #    if (nrow(fit$data) != length(y)) {
  #      print(c(nrow(fit$data), nrow(data)))
  #    }
  #    .stop_if_not(nrow(fit$data) == nrow(data))
  #    .stop_if_not(all(fit$data$chromosome == data$chromosome))
  #    .stop_if_not(all(fit$data$x == data$x))
  #    .stop_if_not(all(fit$data$index == data$index))
  #    .stop_if_not(all.equal(fit$data$y, data$y))
    } # if (R_SANITY_CHECK)

    verbose && exit(verbose)

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Return results
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    return(fit)
  } # if (nbrOfSegments > 1)

  nbrOfSegments <- nrow(knownSegments)

  # Sanity check
  if (R_SANITY_CHECK) {
    .stop_if_not(nbrOfSegments <= 1)
  } # if (R_SANITY_CHECK)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Specific segment?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (nbrOfSegments > 0) {
    knownSegments <- subset(knownSegments, chromosome == chromosome)
    nbrOfSegments <- nrow(knownSegments)
    # Sanity check
    if (R_SANITY_CHECK) {
      .stop_if_not(nbrOfSegments <= 1)
    } # if (R_SANITY_CHECK)
  }

  if (nbrOfSegments == 1) {
    seg <- knownSegments[1,]
    chromosomeJJ <- seg$chromosome
    xStart <- seg$start
    xEnd <- seg$end
    segTag <- sprintf("chr%s:(%s,%s)", chromosomeJJ, xStart, xEnd)
    verbose && printf(verbose, "Extracting segment '%s'", segTag, level=-50)

    # Extract subset of data and parameters for this segment
    data <- subset(data, chrom == chromosomeJJ & xStart <= x & x <= xEnd)
    verbose && str(verbose, data, level=-50)
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Retrieving segmentation function
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Retrieving the fit function", level=-50)
  # We need to attach the 'DNAcopy' package
  pkgName <- "DNAcopy"
  use(pkgName)
  pkg <- packageDescription(pkgName)
  pkgVer <- pkg$Version
  pkgDetails <- sprintf("%s v%s", pkgName, pkgVer)

  methodName <- "segment"
  verbose && cat(verbose, "Method: ", methodName, level=-50)
  verbose && cat(verbose, "Package: ", pkgDetails, level=-50)

  # Get the fit function for the segmentation method
#  fitFcn <- getExportedValue(pkgName, methodName)
  fitFcn <- getFromNamespace(methodName, pkgName)
  verbose && str(verbose, "Function: ", fitFcn, level=-50)
  formals <- formals(fitFcn)
  verbose && cat(verbose, "Formals:", level=-50)
  verbose && str(verbose, formals, level=-50)
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setting up arguments to pass to segmentation function
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Setting up method arguments", level=-50)

  verbose && enter(verbose, "Setting up ", pkgName, " data structure", level=-50)

  sampleName <- "y" # This is going to be the name of the data field

  # Supress all warnings, in order to avoid warnings by DNAcopy::CNA()
  # on "array has repeated maploc positions".  Ideally we should filter
  # just those out. /HB 2013-10-22
  suppressWarnings({
    cnData <- CNA(
      genomdat  = data$y,
      chrom     = data$chrom,
      data.type = "logratio",
      maploc    = data$x,
      sampleid  = sampleName,
      presorted = TRUE
    )
  })
  verbose && str(verbose, cnData, level=-50)
  names(cnData)[3] <- sampleName
  verbose && str(verbose, cnData, level=-50)
  verbose && exit(verbose)

  # Sanity check
  if (R_SANITY_CHECK) {
    # (because all loci with unknown locations have already been dropped)
    .stop_if_not(nrow(cnData) == nrow(data))
  } # if (R_SANITY_CHECK)


  userArgs <- list(...)
  if (length(userArgs) > 0) {
    verbose && cat(verbose, "User arguments:", level=-50)
    verbose && str(verbose, userArgs, level=-50)
  }

  # Check if 'sbdry' can/should be precalculated.  This uses memoization
  # so that next time you segment with same 'nperm', 'alpha' and 'eta'
  # parameters, there will be much less startup overhead.
  if (length(userArgs) > 0 && !is.element("sbdry", names(userArgs))) {
    keys <- c("nperm", "alpha", "eta")
    keep <- is.element(keys, names(userArgs))
    if (any(keep)) {
      verbose && enter(verbose, "Precalculating argument 'sbdry' (with memoization)", level=-50)
      # Precalculate boundaries
      argsT <- formals[keys]
      keys <- keys[keep]
      argsT[keys] <- userArgs[keys]
      argsT$verbose <- less(verbose, 5)
      sbdry <- do.call(getbdry2, args=argsT)
      userArgs$sbdry <- sbdry
      verbose && exit(verbose)
    }
  }

  params <- list()

  if (hasWeights) {
    params$weights <- data$w
  }

  if (undo > 0) {
    params$undo.splits <- "sdundo"
    params$undo.SD <- undo
  }

  verbose && cat(verbose, "Segmentation parameters:", level=-50)
  verbose && str(verbose, params, level=-50)

  # Assign/overwrite by user arguments
  if (length(userArgs) > 0) {
    for (ff in names(userArgs)) {
      params[[ff]] <- userArgs[[ff]]
    }
  }

  verbose && cat(verbose, "Segmentation and user parameters:", level=-50)
  verbose && str(verbose, params, level=-50)

  # Cleaning out unknown parameters
  keep <- (names(params) %in% names(formals))
  params <- params[keep]

  args <- c(list(cnData), params, verbose=as.logical(verbose))
  verbose && cat(verbose, "Final arguments:", level=-50)
  verbose && str(verbose, args, level=-50)

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Calling segmentation function
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, sprintf("Calling %s() of %s", methodName, pkgName), level=-50)

  # There are a few cases where we can/need to do a dummy segmentation
  # based on a single data points:
  # (a) WORKAROUND for the case when there are no data points.
  # (b) SPEEDUP: When undo=+Inf we don't really have to segment.
  nbrOfNonMissingLoci <- sum(!is.na(cnData$y))
  if (nbrOfNonMissingLoci == 0) {
    args[[1]] <- CNA(genomdat=0, chrom=0, maploc=0)
    if (hasWeights) args$weights <- 1.0
  } else if (undo == +Inf) {
    args[[1]] <- CNA(genomdat=0, chrom=0, maploc=0)
    if (hasWeights) args$weights <- 1.0
    verbose && cat(verbose, "Skipping identification of new change points (undo=+Inf)", level=-50)
  }


  ## Set random seed?
  if (!is.null(seed)) {
    randomSeed("set", seed=seed, kind="L'Ecuyer-CMRG")
    on.exit(randomSeed("reset"), add=TRUE)
    verbose && printf(verbose, "Random seed temporarily set (seed=c(%s), kind=\"L'Ecuyer-CMRG\")\n", paste(seed, collapse=", "))
  }

  # In case the method writes to stdout, we capture it
  # Note: DNAcopy::segment() *does* this.
  stdout <- capture.output({
    # Does not work, because some internal function of the fit function
    # may only be accessible from within the namespace
    # How to do this for DNAcopy::segment()? /HB
##    fit <- do.call(fitFcn, args)
    # This works, but requires that one loads the package and that the
    # function is not masked in the search() path.
    t <- system.time({
      fit <- do.call(methodName, args)
    }, gcFirst = FALSE)
    # Drop the 'call' (because it will be huge due to the do.call() call)
    fit$call <- NULL
  })
  attr(fit, "processingTime") <- t
  attr(fit, "pkgDetails") <- pkgDetails
  attr(fit, "randomSeed") <- seed

  # WORKAROUND for the case when there are no data points.
  if (nbrOfNonMissingLoci == 0) {
    # Drop dummy data point...
    fit$data <- cnData ## fit$data[-1,,drop=FALSE]
    # ...dummy region found
    output <- fit$output
    segRows <- fit$segRows

    # Sanity check
    if (R_SANITY_CHECK) {
      .stop_if_not(nrow(output) == 1)
    } # if (R_SANITY_CHECK)

    # Was a region specified?
    if (nbrOfSegments == 1) {
      seg <- knownSegments[1,]
      output$ID <- sampleName
      output$chrom <- seg$chromosome
      if (is.finite(seg$start)) {
        output$loc.start <- seg$start
      }
      if (is.finite(seg$end)) {
        output$loc.end <- seg$end
      }
      output$num.mark <- 0L
      output$seg.mean <- NA_real_
      segRows[1,] <- NA_integer_
    } else {
      output <- output[-1,,drop=FALSE]
      segRows <- segRows[-1,,drop=FALSE]
    }
    fit$output <- output
    fit$segRows <- segRows
  } else if (undo == +Inf) {
    # Drop dummy data point...
    fit$data <- cnData ## fit$data[-1,,drop=FALSE]
    # ...dummy region found
    output <- fit$output
    segRows <- fit$segRows

    # Sanity check
    if (R_SANITY_CHECK) {
      .stop_if_not(nrow(output) == 1)
    } # if (R_SANITY_CHECK)

    # Was a region specified?
    if (nbrOfSegments == 1) {
      seg <- knownSegments[1,]
      output$ID <- sampleName
      output$chrom <- seg$chromosome
      if (is.finite(seg$start)) {
        output$loc.start <- seg$start
      } else {
        output$loc.start <- min(cnData$maploc, na.rm=TRUE)
      }
      if (is.finite(seg$end)) {
        output$loc.end <- seg$end
      } else {
        output$loc.end <- max(cnData$maploc, na.rm=TRUE)
      }
    }
    output$num.mark <- nrow(fit$data)
    output$seg.mean <- mean(fit$data$y, na.rm=TRUE)
    segRows$endRow <- nrow(fit$data)

    fit$output <- output
    fit$segRows <- segRows
  } # if (undo == +Inf)

  verbose && cat(verbose, "Captured output that was sent to stdout:", level=-50)
  stdout <- paste(stdout, collapse="\n")
  verbose && cat(verbose, stdout, level=-50)

  verbose && cat(verbose, "Fitting time (in seconds):", level=-50)
  verbose && print(verbose, t, level=-50)

  verbose && cat(verbose, "Fitting time per 1000 loci (in seconds):", level=-50)
  verbose && print(verbose, 1000*t/nbrOfLoci, level=-50)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Restructure
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Restructuring results", level=-50)

  # Coerce
  fit$output$num.mark <- as.integer(fit$output$num.mark)

  # Coerce 'chrom' to a plain integer
  fit$data$chrom <- unclass(fit$data$chrom)

  # Store genomewide index
  fit$data$index <- data$index

  # Store weights
  fit$data$w <- data$w

  # Not needed anymore
  data <- NULL

  verbose && exit(verbose)


  # Store also interesting parameters to DNAcopy::segment()
  keys <- setdiff(names(formals), c("x", "weights", "sbdry", "verbose"))
  keys <- c(keys, "undo", "seed")
  keep <- is.element(names(params), keys)
  keep <- names(params)[keep]
  params <- params[keep]
  params$undo <- undo
  params$joinSegments <- joinSegments
  params$knownSegments <- knownSegments
  params$seed <- seed
  fit$params <- params

#  class(fit) <- c("CBS", class(fit))
  class(fit) <- c("CBS", "AbstractCBS")

  # Sanity checks
  if (R_SANITY_CHECK) {
    segRows <- fit$segRows
    .stop_if_not(all(segRows[,1] <= segRows[,2], na.rm=TRUE))
    .stop_if_not(all(segRows[-nrow(segRows),2] < segRows[-1,1], na.rm=TRUE))
  } # if (R_SANITY_CHECK)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Renaming column names
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  names <- colnames(data)
  names <- gsub("chrom", "chromosome", names, fixed=TRUE)
  names <- gsub("maploc", "x", names, fixed=TRUE)
  colnames(data) <- names

  # Drop 'CNA' class and DNAcopy attributes
  class(data) <- c("data.frame")
  attr(data, "data.type") <- NULL

  fit$data <- data

  segs <- fit$output

  names <- colnames(segs)
  names <- gsub("ID", "sampleName", names, fixed=TRUE)
  names <- gsub("seg.mean", "mean", names, fixed=TRUE)
  names <- gsub("chrom", "chromosome", names, fixed=TRUE)
  names <- gsub("num.mark", "nbrOfLoci", names, fixed=TRUE)
  names <- gsub("loc.", "", names, fixed=TRUE) # loc.start, loc.end
  colnames(segs) <- names
  fit$output <- segs


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Join segments?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (joinSegments) {
    if (nbrOfSegments == 1) {
      starts <- knownSegments$start
      ends <- knownSegments$end
      if (is.infinite(starts)) starts <- segs$start
      if (is.infinite(ends)) ends <- segs$end
      range <- range(c(starts, ends), na.rm=TRUE)
    } else {
      range <- NULL
    }

    fit <- joinSegments(fit, range=range, verbose=less(verbose, 10))

    # Sanity checks
    if (R_SANITY_CHECK) {
      segRows <- fit$segRows
      .stop_if_not(all(segRows[,1] <= segRows[,2], na.rm=TRUE))
      .stop_if_not(all(segRows[-nrow(segRows),2] < segRows[-1,1], na.rm=TRUE))
    } # if (R_SANITY_CHECK)
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (avg != "mean") {
    verbose && enter(verbose, "Updating mean level using different estimator")
    verbose && cat(verbose, "Estimator: ", avg)
    fit <- updateMeans(fit, avg=avg, verbose=less(verbose, 20))
    verbose && exit(verbose)
  }


  verbose && cat(verbose, "Results object:", level=-10)
  verbose && str(verbose, fit, level=-10)

  verbose && exit(verbose)


  verbose && exit(verbose)

  fit
}) # segmentByCBS()


setMethodS3("segmentByCBS", "data.frame", function(y, ...) {
  # To please R CMD check
  data <- y

  y <- data$y
  if (is.null(y)) {
    y <- data$cn
    if (is.null(y)) {
      y <- data$CT
    }
  }

  segmentByCBS(y=y, chromosome=data$chromosome, x=data$x, index=data$index, w=data$w, ...)
})


setMethodS3("segmentByCBS", "CBS", function(...) {
  resegment(...)
}) # segmentByCBS()

#########################################################################/**
# @RdocPackage "PSCBS"
# @eval "rd <- gsub('\\alias{PSCBS}', '', rd, fixed=TRUE); ''"
#
# \description{
#   @eval "packageDescription('PSCBS')$Description".
#
#   This package should be considered to be in an alpha or beta phase.
#   You should expect the API to be changing over time.
# }
#
# \section{Installation and updates}{
#   To install this package, use \code{install.packages("PSCBS")}.
# }
#
# \section{To get started}{
#   To get started, see:
#   \enumerate{
#     \item Vignettes '\href{../doc/index.html}{Parent-specific copy-number segmentation using Paired PSCBS}' and '\href{../doc/index.html}{Total copy-number segmentation using CBS}'.
#     \item @see "segmentByCBS" - segments total copy-numbers, or any
#           other unimodal genomic signals, using the CBS method [3,4].
#     \item @see "segmentByPairedPSCBS" - segments allele-specific
#           tumor signal from a tumor \emph{with} a matched normal
#           using the Paired PSCBS method [1,2].
#     \item @see "segmentByNonPairedPSCBS" - segments allele-specific
#           tumor signal from a tumor \emph{without} a matched normal
#           using the Non-Paired PSCBS method adopted from [1,2].
#   }
# }
#
# \section{How to cite}{
#   Please use [1] and [2] to cite when using Paired PSCBS,
#   and [3] and [4] when using CBS.
#   When using Non-Paired PSCBS, please cite [1] and [2] as well.
# }
#
# @author
#
# \section{License}{
#  @eval "packageDescription('PSCBS')$License".
# }
#
# \references{
#  [1] @include "../incl/OlshenA_etal_2011.Rd" \cr
#  [2] @include "../incl/BengtssonH_etal_2010.Rd" \cr
#  [3] @include "../incl/OlshenVenkatraman_2004.Rd" \cr
#  [4] @include "../incl/VenkatramanOlshen_2007.Rd" \cr
# }
#*/#########################################################################

# @title "Re-calculates the segmented profile using non-TumorBoost BAFs"
setMethodS3("unTumorBoost", "PairedPSCBS", function(fit, ..., verbose=FALSE) {
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enterf(verbose, "Relcalculating %s profile without TumorBoost", class(fit)[1L])

  # Nothing to do?
  if (!fit$params$tbn) {
    verbose && cat(verbose, "Profile is not from TumorBoost signals. Skipping.")
    verbose && exit(verbose)
    return(fit)
  }

  verbose && enter(verbose, "Updating locus-level data")
  data <- getLocusData(fit)
  data$betaTN <- data$betaT
  isHet <- !is.na(data$rho)
  data$rho[isHet] <- 2*abs(data$betaTN[isHet]-1/2)
  fit$data <- data
  verbose && exit(verbose)

  verbose && enter(verbose, "Updating segments")
  segs <- getSegments(fit)
  segs$abCall <- NULL
  segs$lohCall <- NULL
  fit$output <- segs
  verbose && exit(verbose)

  verbose && enter(verbose, "Updating parameters")
  params <- fit$params
  params$tbn <- FALSE
  params$deltaAB <- params$alphaAB <- NULL
  params$deltaLowC1 <- params$alphaLowC1 <- NULL
  fit$params <- params
  verbose && exit(verbose)

  verbose && enter(verbose, "Resetting miscellaneous parameters and estimates")
  fit$changepoints <- NULL
  fit$deshearC1C2 <- NULL
  fit$cScaled <- NULL
  fit$kappa <- NULL
  fit$scale <- NULL
  fit <- clearBootstrapSummaries(fit, verbose=less(verbose, 50))
  verbose && exit(verbose)

  verbose && enter(verbose, "Update segment levels")
  fit <- updateMeans(fit, verbose=less(verbose, 50))
  verbose && exit(verbose)

  verbose && exit(verbose)

  fit
}, protected=TRUE) # unTumorBoost()


##############################################################################
# HISTORY
# 2014-03-28
# o Added unTumorBoost() for PairedPSCBS.
##############################################################################

###########################################################################/**
# @RdocGeneric callSegmentationOutliers
# @alias callSegmentationOutliers.default
# @alias callSegmentationOutliers.data.frame
# @alias dropSegmentationOutliers
# @alias dropSegmentationOutliers.default
# @alias dropSegmentationOutliers.data.frame
#
# @title "Calls/drops single-locus outliers along the genome"
#
# \description{
#  @get "title" that have a signal that differ significantly from the
#  neighboring loci.
# }
#
# \usage{
#  @usage callSegmentationOutliers,default
#  @usage callSegmentationOutliers,data.frame
#  @usage dropSegmentationOutliers,default
#  @usage dropSegmentationOutliers,data.frame
# }
#
# \arguments{
#   \item{y}{A @numeric @vector of J genomic signals to be segmented.}
#   \item{chromosome}{(Optional) An @integer scalar
#       (or a @vector of length J contain a unique value).
#       Only used for annotation purposes.}
#   \item{x}{Optional @numeric @vector of J genomic locations.
#            If @NULL, index locations \code{1:J} are used.}
#   \item{method}{A @character string specifying the method
#        used for calling outliers.}
#   \item{...}{Additional arguments passed to internal outlier
#        detection method.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   \code{callSegmentationOutliers()} returns a @logical @vector of length J.
#   \code{dropSegmentationOutliers()} returns an object of the same type
#   as argument \code{y}, where the signals for which outliers were called
#   have been set to @NA.
# }
#
# \section{Missing and non-finite values}{
#   Signals as well as genomic positions may contain missing
#   values, i.e. @NAs or @NaNs.  By definition, these cannot
#   be outliers.
# }
#
# @author "HB"
#
# \seealso{
#   Internally @see "DNAcopy::smooth.CNA" is utilized to identify
#   the outliers.
# }
#
# @keyword IO
#*/###########################################################################
setMethodS3("callSegmentationOutliers", "default", function(y, chromosome=0, x=NULL, method="DNAcopy::smooth.CNA", ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'y':
  disallow <- c("Inf")
  y <- Arguments$getDoubles(y, disallow=disallow)
  nbrOfLoci <- length(y)

  length2 <- rep(nbrOfLoci, times=2L)

  # Argument 'chromosome':
  disallow <- c("NaN", "Inf")
  chromosome <- Arguments$getIntegers(chromosome, range=c(0,Inf), disallow=disallow)
  if (length(chromosome) == 1L) {
    chromosome <- rep(chromosome, times=nbrOfLoci)
  } else {
    chromosome <- Arguments$getVector(chromosome, length=length2)
  }

  # Argument 'x':
  if (!is.null(x)) {
    disallow <- c("Inf")
    x <- Arguments$getDoubles(x, length=length2, disallow=disallow)
  }

  # Argument 'method':
  method <- match.arg(method)

  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }




  verbose && enter(verbose, "Identifying outliers")
  uChromosomes <- sort(unique(chromosome))
  nbrOfChromosomes <- length(uChromosomes)
  verbose && cat(verbose, "Number of chromosomes: ", nbrOfChromosomes)
  verbose && cat(verbose, "Number of loci: ", nbrOfLoci)
  verbose && cat(verbose, "Detection method: ", method)

  # Allocate result vector
  isOutlier <- logical(nbrOfLoci)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Filter missing data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Identifying loci with non-missing data")
  keep <- (!is.na(x) & !is.na(y))
  if (!is.null(chromosome)) {
    keep <- (keep & !is.na(chromosome))
  }
  keep <- which(keep)
  chromosome <- chromosome[keep]
  x <- x[keep]
  y <- y[keep]
  nbrOfLoci <- length(x)
  verbose && cat(verbose, "Number of loci with non-missing data: ", nbrOfLoci)
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # For each chromosome
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  isOutlierT <- logical(nbrOfLoci)
  for (kk in seq_along(uChromosomes)) {
    chr <- uChromosomes[kk]
    verbose && enter(verbose, sprintf("Chromosome #%d ('Chr%02d') of %d", kk, chr, length(uChromosomes)))
    keepKK <- which(chromosome == chr)
    nbrOfLociKK <- length(keepKK)
    verbose && cat(verbose, "Number of loci on chromosome: ", nbrOfLociKK)

    # Extract data
    yKK <- y[keepKK]
    xKK <- x[keepKK]
    chromosomeKK <- chromosome[keepKK]

    # Order loci along chromosome
    o <- order(xKK)
    xKK <- xKK[o]
    yKK <- yKK[o]
    chromosomeKK <- chromosomeKK[o]
    keepKK <- keepKK[o]
    o <- NULL # Not needed anymore

    # Supress all warnings, in order to avoid warnings by DNAcopy::CNA()
    # on "array has repeated maploc positions".  Ideally we should filter
    # just those out. /HB 2013-10-22
    suppressWarnings({
      dataKK <- CNA(genomdat=yKK, chrom=chromosomeKK, maploc=xKK, sampleid="y", presorted=TRUE)
    })
    chromosomeKK <- xKK <- NULL # Not needed anymore

    yKKs <- smooth.CNA(dataKK, ...)$y
    dataKK <- NULL # Not needed anymore

    # Sanity check
    .stop_if_not(length(yKKs) == nbrOfLociKK)
    outliersKK <- which(yKKs != yKK)
    yKKs <- yKK <- NULL # Not needed anymore

    nbrOfOutliers <- length(outliersKK)
    verbose && cat(verbose, "Number of outliers: ", nbrOfOutliers)

    outliers <- keepKK[outliersKK]
    keepKK <- outliersKK <- NULL # Not needed anymore

    isOutlierT[outliers] <- TRUE
    outliers <- NULL # Not needed anymore

    verbose && exit(verbose)
  } # for (kk ...)
  chromosome <- x <- y <- NULL # Not needed anymore

  isOutlier[keep] <- isOutlierT
  isOutlierT <- keep <- NULL # Not needed anymore

  nbrOfOutliers <- sum(isOutlier, na.rm=TRUE)
  verbose && cat(verbose, "Total number of outliers: ", nbrOfOutliers)

  verbose && exit(verbose)

  isOutlier
}) # callSegmentationOutliers()


setMethodS3("callSegmentationOutliers", "data.frame", function(y, ...) {
  data <- y

  # Get either CBS or PSCBS total CN signals.
  y <- data$y
  if (is.null(y)) {
    y <- data$CT
  }

  callSegmentationOutliers(y=y, chromosome=data$chromosome, x=data$x, ...)
}) # callSegmentationOutliers()


setMethodS3("dropSegmentationOutliers", "default", function(y, ...) {
  isOutlier <- callSegmentationOutliers(y, ...)
  y[isOutlier] <- NA_real_
  isOutlier <- NULL # Not needed anymore
  y
})


setMethodS3("dropSegmentationOutliers", "data.frame", function(y, ...) {
  data <- y

  isOutlier <- callSegmentationOutliers(data, ...)

  # Update either CBS or PSCBS total CN signals.
  key <- "CT"
  if (!is.element(key, colnames(data))) {
    key <- "y"
  }

  data[[key]][isOutlier] <- NA_real_

  isOutlier <- NULL # Not needed anymore

  data
})

setMethodS3("shiftTCN", "CBS", function(fit, shift, update=TRUE, ...) {
  # Argument 'shift':
  shift <- Arguments$getDouble(shift, disallow=c("NA", "NaN", "Inf"))

  data <- getLocusData(fit)
  data$y <- data$y + shift
  fit$data <- data
  # Not needed anymore
  data <- NULL

  if (update) {
    fit <- updateMeans(fit, ...)
  }

  fit
}, protected=TRUE)


###########################################################################/**
# @set "class=CBS"
# @RdocMethod c
# @alias c.PSCBS
#
# @title "Concatenates segmentation results"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{\dots}{One or more @see "AbstractCBS" objects to be combined.}
#  \item{addSplit}{If @TRUE, a "divider" is added between chromosomes.}
# }
#
# \value{
#   Returns an @see "AbstractCBS" object of the same class in \dots.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#*/###########################################################################
setMethodS3("c", "CBS", function(..., addSplit = TRUE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  args <- list(...)

  ## Nothing todo?
  nargs <- length(args)
  if (nargs == 1) return(args[[1]])

  isNA <- function(x) is.logical(x) && length(x) == 1L && is.na(x)

  res <- args[[1]]
  fields <- c("output", "segRows")
  
  for (ii in 2:nargs) {
    arg <- args[[ii]]

    if (isNA(arg)) {
      if (addSplit) {
        warning(sprintf("Detected explicit NA in call to c(<%s>, ..., addSplit = TRUE). Ignoring", class(args[[1]])[1]))
        next
      }
      ## Add "splitter"
      for (field in fields) {
        res[[field]] <- rbind(res[[field]], NA)
      }
    } else {
      ## Locus-level data
      data <- getLocusData(res)
      data_arg <- getLocusData(arg)
      if (!all(colnames(data_arg) == colnames(data))) {
        stop(sprintf("Cannot concatenate %s and %s objects, because they have different sets of columns in field %s: {%s} [n=%d] != {%s} [n=%d]", sQuote(class(res)[1]), sQuote(class(arg)[1]), sQuote(field), paste(sQuote(colnames(data)), collapse=", "), ncol(data), paste(sQuote(colnames(data_arg)), collapse=", "), ncol(data_arg)))
      }

      indexOffset <- nrow(data)
      
      data <- rbind(data, getLocusData(arg))
      res[["data"]] <- data
      
      # Segmentation data
      for (field in fields[-1]) {
        arg[[field]] <- arg[[field]] + indexOffset
      }
      splitter <- if (addSplit) NA else NULL
      for (field in fields) {
        res[[field]] <- rbind(res[[field]], splitter, arg[[field]])
      }

      # Known segments
      ksT <- res$params$knownSegments
      ksT$length <- NULL  # In case it's been added
      ksO <- arg$params$knownSegments
      ksO$length <- NULL  # In case it's been added
      res$params$knownSegments <- rbind(ksT, ksO)
    }
  } ## for (ii ...)

  ## Drop row names, iff they've been added
  for (field in fields) rownames(res[[field]]) <- NULL
  
  # Sanity check
  ns <- sapply(res[fields], FUN = nrow)
  .stop_if_not(all(ns == ns[1]))

  res
}) # c()



setMethodS3("extractSegments", "CBS", function(this, idxs, ..., verbose=FALSE) {
  fit <- this

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Local functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  updateSegRows <- function(segRows, idxs=NULL) {
    verbose && str(verbose, segRows)
    if (!is.null(idxs)) {
      segRows <- segRows[idxs,,drop=FALSE]
    }
#    verbose && cat(verbose, "Number of segments: ", nrow(segRows))
#    verbose && str(verbose, segRows)

    # Treat splitters separately
    isSplitter <- (is.na(segRows[,1]) & is.na(segRows[,2]))

    ns <- segRows[,2] - segRows[,1] + 1L
#    verbose && cat(verbose, "Number of loci per segment:")
#    verbose && str(verbose, ns)

    ns <- ns[!isSplitter]
    from <- c(1L, cumsum(ns)[-length(ns)]+1L)
    to <- from + (ns - 1L)
    segRows[!isSplitter,1] <- from
    segRows[!isSplitter,2] <- to
    verbose && str(verbose, segRows)

    # Sanity check
    ns2 <- segRows[,2] - segRows[,1] + 1L
    ns2 <- ns2[!isSplitter]
    .stop_if_not(all(ns2 == ns))

    segRows
  } # updateSegRows()

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'idxs':
  idxs <- Arguments$getIndices(idxs, max=nbrOfSegments(fit, splitters=TRUE))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Extracting subset of segments")

  verbose && cat(verbose, "Number of segments: ", length(idxs))
  verbose && str(verbose, idxs)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  segRows <- fit$segRows
  segs <- getSegments(fit)
  params <- fit$params

  # Sanity checks
  .stop_if_not(all(!is.na(data$chromosome) & !is.na(data$x)))

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Subset segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Update table of segments")
  segsT <- segs[idxs,,drop=FALSE]
  verbose && str(verbose, segsT)
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Subset data accordingly
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Update locus data")

  segRowsT <- segRows[idxs,,drop=FALSE]
  from <- segRowsT[[1]]
  to <- segRowsT[[2]]
  ok <- (!is.na(from) & !is.na(to))
  from <- from[ok]
  to <- to[ok]
  keep <- logical(nrow(data))
  for (rr in seq_along(from)) {
    keep[from[rr]:to[rr]] <- TRUE
  }
  keep <- which(keep)
  verbose && printf(verbose, "Identified %d (%.2f%%) of %d data rows:\n", length(keep), 100*length(keep)/nrow(data), nrow(data))
  verbose && str(verbose, keep)

  dataT <- data[keep,,drop=FALSE]
  verbose && str(verbose, dataT)

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update 'segRows'
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Update 'segRows'")
  segRowsT <- updateSegRows(segRowsT)
  d <- segRows[idxs,] - segRowsT

  # Sanity check
  .stop_if_not(identical(d[,1], d[,2]))
  d <- d[,1]
  verbose && cat(verbose, "Row deltas:")
  verbose && str(verbose, d)

  segRows <- segRows[idxs,,drop=FALSE] - d
  verbose && str(verbose, segRows)
  # Sanity checks
  .stop_if_not(suppressWarnings(max(segRows, na.rm=TRUE)) <= nrow(dataT))
  drow <- segRows[-1,1] - segRows[-nrow(segRows),2]
  .stop_if_not(all(is.na(drow) | (drow > 0)))
  if (!all(is.na(drow) | (drow > 0))) {
    print(segRows)
    stop("INTERNAL ERROR: Generated 'segRows' is invalid, because it contains overlapping data chunks.")
  }

  verbose && exit(verbose)


  # Create new object
  res <- fit
  res$data <- dataT
  res$output <- segsT
  res$segRows <- segRows

  verbose && exit(verbose)

  res
}, protected=TRUE) # extractSegments()



setMethodS3("mergeTwoSegments", "CBS", function(this, left, update=TRUE, verbose=FALSE, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegments <- nbrOfSegments(this, splitters=TRUE)
  # Argument 'left':
  left <- Arguments$getIndex(left, max=nbrOfSegments-1L)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Merging two segments")
  verbose && printf(verbose, "Segments to be merged: %s & %s\n", left, left+1)
  verbose && cat(verbose, "Number of segments before merging: ", nbrOfSegments)
  verbose && cat(verbose, "Number of segments after merging: ", nbrOfSegments-1L)

  segs <- getSegments(this)
  segRows <- this$segRows

  rows <- c(left,left+1)
  segsT <- segs[rows,,drop=FALSE]

  # Sanity check
  chrs <- segsT[["chromosome"]]
  if (chrs[1] != chrs[2]) {
    stop("Cannot merge segments that are on different chromosomes: ", chrs[1], " != ", chrs[2])
  }

  # Merge segments
  segT <- segsT[1,]
  fields <- colnames(segsT)
  idxsUsed <- c()

  # (id) [as in label]
  idxs <- grep("(I|i)d$", fields)
  idxsUsed <- c(idxsUsed, idxs)

  # (chromosome)
  idxs <- grep("chromosome$", fields)
  idxsUsed <- c(idxsUsed, idxs)

  # Starts
  idxs <- grep("(S|s)tart$", fields)
  T <- as.matrix(segsT[,idxs,drop=FALSE])
  segT[,idxs] <- colMins(T, na.rm=TRUE, useNames=FALSE)
  idxsUsed <- c(idxsUsed, idxs)

  # Ends
  idxs <- grep("(E|e)nd$", fields)
  T <- as.matrix(segsT[,idxs,drop=FALSE])
  segT[,idxs] <- colMaxs(T, na.rm=TRUE, useNames=FALSE)
  idxsUsed <- c(idxsUsed, idxs)

  # Counts
  idxs <- grep("(N|n)brOf", fields)
  segT[,idxs] <- colSums(segsT[,idxs,drop=FALSE])
  idxsUsed <- c(idxsUsed, idxs)

  # "Invalidate" remaining entries
  idxsTodo <- setdiff(seq_along(fields), idxsUsed)
  segT[,idxsTodo] <- NA

  # Update segment table
  segs[rows[1],] <- segT
  segs <- segs[-rows[2],]

  # Update 'segRows' tables
  segRows[rows[1],2] <- segRows[rows[2],2]
  segRows <- segRows[-rows[2],]

  # Create results object
  res <- this
  res$output <- segs
  res$segRows <- segRows

  # Update the segment statistics?
  if (update) {
    res <- updateMeans(res)
  }

  verbose && exit(verbose)

  res
}, protected=TRUE) # mergeTwoSegments()

###########################################################################/**
# @set "class=AbstractCBS"
# @RdocMethod updateMeansTogether
# @alias updateMeansTogether.CBS
# @alias updateMeansTogether.PairedPSCBS
#
# @title "Updates the CN mean levels jointly in sets of segments"
#
# \description{
#  @get "title" as if they were one large segment.
#  The locus-level data is not updated/modified.
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Not used.}
# }
#
# \value{
#   Returns an object of the same class.
# }
#
# @author "HB"
#
# \seealso{
#   This method is utilized by @seemethod "pruneByHClust".
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("updateMeansTogether", "AbstractCBS", abstract=TRUE, private=TRUE)


###########################################################################/**
# @set "class=AbstractCBS"
# @RdocMethod hclustCNs
#
# @title "Performs a hierarchical clustering of the CN mean levels"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{size}{Argument passed to @seemethod "sampleCNs".}
#  \item{distMethod, hclustMethod}{Argument \code{method} for
#    @see "stats::dist" and "stats::hclust", respectively.}
#  \item{...}{Not used.}
#  \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns a \code{hclust} object as returned by @see "stats::hclust".
# }
#
# @author
#
# \seealso{
#   This method is utilized by @seemethod "pruneByHClust".
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("hclustCNs", "AbstractCBS", function(fit, size=NULL, distMethod="euclidean", hclustMethod="ward.D", ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Hierarchical clustering of segmented copy numbers")
  verbose && enter(verbose, "Extracting/sampling CNs")
  C <- sampleCNs(fit, size=size, splitters=FALSE)
  verbose && str(verbose, C)

  # Drop also segments with no data points
  ok <- !is.na(C)
  ok <- rowAlls(ok, useNames=FALSE)
  C <- C[ok,,drop=FALSE]
  verbose && str(verbose, C)
  verbose && exit(verbose)

  verbose && enter(verbose, "Calculating distance matrix")
  D <- stats::dist(C, method=distMethod)
  verbose && str(verbose, D)
  verbose && exit(verbose)

  verbose && enter(verbose, "Clustering")

  # TODO: Do *weighted* hierarchical clustering
  tree <- stats::hclust(D, method=hclustMethod)
  verbose && str(verbose, tree)
  verbose && exit(verbose)

  verbose && exit(verbose)

  tree
}, private=TRUE) # hclustCNs()



###########################################################################/**
# @RdocMethod pruneByHClust
#
# @title "Prunes the CN profile by pruning and merging through hierarchical clustering"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Arguments passed to @see "stats::cutree",
#    particularly either of thresholds \code{h} or \code{k}.}
#  \item{size, distMethod, hclustMethod}{Arguments (as well as
#    some of \code{...}) passed to @seemethod "hclustCNs".}
#  \item{merge}{If @TRUE, consecutive segments that belong to the
#    same PSCN cluster will be merged into one large segment.}
#  \item{update}{If @TRUE, segment means are updated afterwards, otherwise not.}
#  \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns a pruned object of the same class.
# }
#
# \examples{\dontrun{
#  fitP <- pruneByHClust(fit, h=0.25)
# }}
#
# @author
#
# @keyword internal
#*/###########################################################################
setMethodS3("pruneByHClust", "AbstractCBS", function(fit, ..., size=NULL, distMethod="euclidean", hclustMethod="ward.D", merge=TRUE, update=TRUE, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Prune segments by hierarchical clustering")
  verbose && cat(verbose, "Clustering arguments:")
  verbose && str(verbose, c(list(size=size, distMethod=distMethod, hclustMethod=hclustMethod), list(...)))

  verbose && enter(verbose, "Clustering")
  tree <- hclustCNs(fit, size=size, distMethod=distMethod,
                    hclustMethod=hclustMethod, ..., verbose=less(verbose,5))
  verbose && print(verbose, tree)
  verbose && exit(verbose)

  verbose && enter(verbose, "Cutting tree")
  verbose && cat(verbose, "Cutting arguments:")
  verbose && str(verbose, c(list(tree=tree), list(...)))
  p <- cutree(tree, ...)
  verbose && str(verbose, p)

  # Group segments
  idxList <- by(names(p), p, FUN=function(x) {
    idxs <- as.integer(as.character(x))
    idxs <- sort(unique(idxs))
    list(idxs)
  })
  verbose && str(verbose, idxList)

  verbose && exit(verbose)


  # Dropping previous segment calls and quantile mean-level estimates.
  fit <- resetSegments(fit)

  verbose && enter(verbose, "Merging mean levels of clustered segments")
  fit <- updateMeansTogether(fit, idxList=idxList, verbose=less(verbose, 10))
  verbose && exit(verbose)

  if (merge) {
    verbose && enter(verbose, "Merging neighboring segments within each cluster")
    lefts <- c()
    for (ii in seq_along(idxList)) {
      verbose && enter(verbose, sprintf("Cluster #%d of %d", ii, length(idxList)))
      idxs <- idxList[[ii]]
      verbose && cat(verbose, "Segments in cluster:")
      verbose && str(verbose, idxs)

      # Indices to segments to merge
      leftsII <- idxs[which(diff(idxs) == 1L)]
      verbose && cat(verbose, "Left indices of neighboring segments:")
      verbose && str(verbose, leftsII)

      lefts <- c(lefts, leftsII)
      verbose && exit(verbose)
    } # for (ii ...)

    lefts <- sort(unique(lefts))
    verbose && cat(verbose, "Left indices of segments to be merged:")
    verbose && str(verbose, lefts)
    verbose && exit(verbose)

    verbose && enter(verbose, "Merging segments")
    lefts <- rev(lefts)
    for (ii in seq_along(lefts)) {
      fit <- mergeTwoSegments(fit, left=lefts[ii], update=FALSE)
    } # for (ii ...)
    verbose && exit(verbose)
  } # if (merge)

  if (update) {
    verbose && enter(verbose, "Updating segment means")
##  fit <- updateBoundaries(fit, verbose=less(verbose, 50))
    fit <- updateMeans(fit, verbose=less(verbose, 50))
    verbose && exit(verbose)
  }

  verbose && exit(verbose)

  fit
}, protected=TRUE) # pruneByHClust()

setMethodS3("updateMeansTogether", "CBS", function(fit, idxList, ..., avg=c("mean", "median"), verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegments <- nbrOfSegments(fit, splitters=TRUE)

  # Argument 'idxList':
  if (!is.list(idxList)) {
    idxList <- list(idxList)
  }
  idxList <- lapply(idxList, FUN=function(idxs) {
    idxs <- Arguments$getIndices(idxs, max=nbrOfSegments)
    sort(unique(idxs))
  })

  # Argument 'avg':
  avg <- match.arg(avg)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Updating mean level estimates of multiple segments")

  verbose && cat(verbose, "Segments:")
  verbose && str(verbose, idxList)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setting up averaging functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  avgFUN <- get(avg, mode="function")


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the data and segmentation results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)

  segs <- getSegments(fit, splitters=TRUE)

  nbrOfSegments <- nrow(segs)
  verbose && cat(verbose, "Total number of segments: ", nbrOfSegments)

  for (ss in seq_along(idxList)) {
    idxs <- idxList[[ss]]

    fitT <- extractSegments(fit, idxs)
    verbose && cat(verbose, "Number of segments: ", nbrOfSegments(fitT))

    dataT <- getLocusData(fitT)
    segsT <- getSegments(fitT)

    y <- dataT$y

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Update the TCN segments
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    verbose && enter(verbose, "Recalculate TCN means")

    # (c) Adjust for missing values
    keep <- which(!is.na(y))

    # (d) Update mean
    gamma <- avgFUN(y[keep])

    # Sanity check
    .stop_if_not(length(gamma) == 0 || !is.na(gamma))

    mus <- c(mean=gamma)

    verbose && print(verbose, mus)
    verbose && exit(verbose)

    for (key in names(mus)) {
      segs[idxs,key] <- mus[key]
    }
  } # for (ss ...)

  # Return results
  res <- fit
  res$output <- segs
  res <- setMeanEstimators(res, y=avg)

  verbose && exit(verbose)

  res
}, private=TRUE) # updateMeansTogether()

setMethodS3("extractSegments", "PairedPSCBS", function(this, idxs, ..., verbose=FALSE) {
  fit <- this

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Local functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  updateSegRows <- function(segRows, idxs=NULL) {
    verbose && str(verbose, segRows)
    if (!is.null(idxs)) {
      segRows <- segRows[idxs,,drop=FALSE]
    }
#    verbose && cat(verbose, "Number of segments: ", nrow(segRows))
#    verbose && str(verbose, segRows)

    # Treat splitters separately
    isSplitter <- (is.na(segRows[,1]) & is.na(segRows[,2]))

    ns <- segRows[,2] - segRows[,1] + 1L
#    verbose && cat(verbose, "Number of loci per segment:")
#    verbose && str(verbose, ns)

    ns <- ns[!isSplitter]
    from <- c(1L, cumsum(ns)[-length(ns)]+1L)
    to <- from + (ns - 1L)
    segRows[!isSplitter,1] <- from
    segRows[!isSplitter,2] <- to
    verbose && str(verbose, segRows)

    # Sanity check
    ns2 <- segRows[,2] - segRows[,1] + 1L
    ns2 <- ns2[!isSplitter]
    .stop_if_not(all(ns2 == ns))

    segRows
  } # updateSegRows()


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'idxs':
  idxs <- Arguments$getIndices(idxs, max=nbrOfSegments(fit, splitters=TRUE))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Extracting subset of segments")

  verbose && cat(verbose, "Number of segments: ", length(idxs))
  verbose && str(verbose, idxs)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  tcnSegRows <- fit$tcnSegRows
  dhSegRows <- fit$dhSegRows
  segs <- getSegments(fit)
  params <- fit$params

  # Sanity checks
  .stop_if_not(all(!is.na(data$chromosome) & !is.na(data$x)))
  .stop_if_not(length(tcnSegRows) == length(dhSegRows))

  # Sanity checks
  if (!params$joinSegments) {
    stop("Cannot extract subset of segments unless CNs are segmented using joinSegments=TRUE.")
  }

  if (params$flavor == "tcn,dh") {
    stop("NOT IMPLEMENTED: Extracting a subset of segments is not supported for flavor '", params$flavor, "'.")
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Subset segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Update table of segments")
  segsT <- segs[idxs,,drop=FALSE]
  verbose && str(verbose, segsT)
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Subset data accordingly
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Update locus data")

  segRows <- tcnSegRows
  segRows <- segRows[idxs,,drop=FALSE]
  from <- segRows[[1]]
  to <- segRows[[2]]
  ok <- (!is.na(from) & !is.na(to))
  from <- from[ok]
  to <- to[ok]
  keep <- logical(nrow(data))
  for (rr in seq_along(from)) {
    keep[from[rr]:to[rr]] <- TRUE
  }
  keep <- which(keep)
  verbose && printf(verbose, "Identified %d (%.2f%%) of %d data rows:\n", length(keep), 100*length(keep)/nrow(data), nrow(data))
  verbose && str(verbose, keep)

  dataT <- data[keep,,drop=FALSE]
  verbose && str(verbose, dataT)

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update 'segRows'
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Update 'segRows'")

  segRows <- updateSegRows(tcnSegRows, idxs=idxs)
  d <- tcnSegRows[idxs,] - segRows
  # Sanity check
  .stop_if_not(identical(d[,1], d[,2]))
  d <- d[,1]
  verbose && cat(verbose, "Row deltas:")
  verbose && str(verbose, d)

  tcnSegRows <- tcnSegRows[idxs,,drop=FALSE] - d
  verbose && str(verbose, tcnSegRows)
  # Sanity checks
  segRows <- tcnSegRows
  .stop_if_not(suppressWarnings(max(segRows, na.rm=TRUE)) <= nrow(dataT))
  drow <- segRows[-1,1] - segRows[-nrow(segRows),2]
  if (!all(is.na(drow) | (drow > 0))) {
    print(segRows)
    stop("INTERNAL ERROR: Generated 'tcnSegRows' is invalid, because it contains overlapping data chunks.")
  }

  dhSegRows <- dhSegRows[idxs,,drop=FALSE] - d
  verbose && str(verbose, dhSegRows)
  # Sanity checks
  segRows <- dhSegRows
  .stop_if_not(suppressWarnings(max(segRows, na.rm=TRUE)) <= nrow(dataT))
  drow <- segRows[-1,1] - segRows[-nrow(segRows),2]
  .stop_if_not(all(is.na(drow) | (drow > 0)))
  if (!all(is.na(drow) | (drow > 0))) {
    print(segRows)
    stop("INTERNAL ERROR: Generated 'dhSegRows' is invalid, because it contains overlapping data chunks.")
  }

  verbose && exit(verbose)


  # Create new object
  res <- fit
  res$data <- dataT
  res$output <- segsT
  res$tcnSegRows <- tcnSegRows
  res$dhSegRows <- dhSegRows

  verbose && exit(verbose)

  res
}, protected=TRUE) # extractSegments()



###########################################################################/**
# @set "class=PairedPSCBS"
# @RdocMethod mergeTwoSegments
#
# @title "Merge two neighboring segments"
#
# \description{
#   @get "title" by recalculating segment statistics.
# }
#
# @synopsis
#
# \arguments{
#  \item{left}{An @integer specifying the segments (left, left+1)
#    to be merged.}
#  \item{update}{If @TRUE, segment statistics are updated.}
#  \item{verbose}{A @logical or a @see "R.utils::Verbose" object.}
#  \item{...}{Not used.}
# }
#
# \value{
#   Returns a @see "PairedPSCBS" with one less segment.
# }
#
# @author "HB"
#
# \seealso{
#   To drop regions (a connected set of segments) see \code{dropRegions()}.
#   @seeclass
# }
#*/###########################################################################
setMethodS3("mergeTwoSegments", "PairedPSCBS", function(this, left, update=TRUE, verbose=FALSE, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegments <- nbrOfSegments(this, splitters=TRUE)
  # Argument 'left':
  left <- Arguments$getIndex(left, max=nbrOfSegments-1L)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Merging two segments")
  verbose && printf(verbose, "Segments to be merged: %s & %s\n", left, left+1)
  verbose && cat(verbose, "Number of segments before merging: ", nbrOfSegments)
  verbose && cat(verbose, "Number of segments after merging: ", nbrOfSegments-1L)

  segs <- getSegments(this, splitters=TRUE)
  tcnSegRows <- this$tcnSegRows
  dhSegRows <- this$dhSegRows

  rows <- c(left,left+1)
  segsT <- segs[rows,,drop=FALSE]

  # Sanity check
  chrs <- segsT[["chromosome"]]
  if (chrs[1] != chrs[2]) {
    stop("Cannot merge segments that are on different chromosomes: ", chrs[1], " != ", chrs[2])
  }

  # Merge segments
  segT <- segsT[1,]
  fields <- colnames(segsT)

  # (chromosome, tcnId, dhId)
  idxsUsed <- 1:3

  # Starts
  idxs <- grep("Start$", fields)
  T <- as.matrix(segsT[,idxs,drop=FALSE])
  segT[,idxs] <- colMins(T, na.rm=TRUE, useNames=FALSE)
  idxsUsed <- c(idxsUsed, idxs)

  # Ends
  idxs <- grep("End$", fields)
  T <- as.matrix(segsT[,idxs,drop=FALSE])
  segT[,idxs] <- colMaxs(T, na.rm=TRUE, useNames=FALSE)
  idxsUsed <- c(idxsUsed, idxs)

  # Counts
  idxs <- grep("NbrOf", fields)
  segT[,idxs] <- colSums(segsT[,idxs,drop=FALSE])
  idxsUsed <- c(idxsUsed, idxs)

  # "Invalidate" remaining entries
  if (update) {
    idxsTodo <- setdiff(seq_along(fields), idxsUsed)
    segT[,idxsTodo] <- NA
  }

  # Update segment table
  segs[rows[1],] <- segT
  segs <- segs[-rows[2],]

  # Update 'segRows' tables
  segRows <- tcnSegRows
  segRows[rows[1],2] <- segRows[rows[2],2]
  segRows <- segRows[-rows[2],]
  tcnSegRows <- segRows

  segRows <- dhSegRows
  segRows[rows[1],2] <- segRows[rows[2],2]
  segRows <- segRows[-rows[2],]
  dhSegRows <- segRows

  # Create results object
  res <- this
  res$output <- segs
  res$tcnSegRows <- tcnSegRows
  res$dhSegRows <- dhSegRows

  # Update the segment statistics?
  if (update) {
    res <- updateMeans(res)
  }

  verbose && exit(verbose)

  res
}, private=TRUE)

setMethodS3("seqOfSegmentsByDP", "AbstractCBS", function(fit, by, shift=+100, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Local functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'by':
  by <- Arguments$getCharacters(by)
  data <- getLocusData(fit)
  fields <- colnames(data)
  missing <- fields[!is.element(by, fields)]
  if (length(missing) > 0) {
    stop("Argument 'by' specifies one or more non-existing locus data fields: ", paste(missing, collapse=", "))
  }

  # Argument 'shift':
  shift <- Arguments$getNumeric(shift)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Identifying optimal sets of segments via dynamic programming")

  # Assert that known segments was used
  knownSegments <- fit$params$knownSegments
  if (nrow(knownSegments) == 0L) {
    chromosome <- getChromosomes(fit)
    knownSegments <- data.frame(chromosome=chromosome, start=-Inf, end=+Inf)
  }

  chrOffsets <- getChromosomeOffsets(fit)
  # Sanity check
  .stop_if_not(all(is.finite(chrOffsets)))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Shift every other non-empty region
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Shifting TCN levels for every second segment")

  segPrefix <- getSegmentTrackPrefixes(fit)[1L]
  segKeys <- toCamelCase(paste(segPrefix, c("start", "end")))
  segRowsKey <- toCamelCase(paste(segPrefix, "seg rows"))

  verbose && enter(verbose, "Split up into non-empty independent regions")
  chromosomes <- getChromosomes(fit)

  fitList <- list()
  for (jj in seq_along(chromosomes)) {
    chr <- chromosomes[jj]
    verbose && enter(verbose, sprintf("Chromosome #%d ('%s') of %d", jj, chr, length(chromosomes)))

    # Subset segmentation results on this chromosome
    fitJJ <- extractChromosome(fit, chr)
    verbose && cat(verbose, "Number of loci on chromosome: ", nbrOfLoci(fitJJ))

    # Nothing to do and nothing to add?
    if (nbrOfLoci(fitJJ) == 0L) {
      verbose && exit(verbose)
      next
    }

    # Find known segments on this chromosome
    knownSegmentsJJ <- subset(knownSegments, chromosome == chr)
    verbose && cat(verbose, "Known segments on chromosome:")
    verbose && print(verbose, knownSegmentsJJ)

    # Nothing to do?
    if (nrow(knownSegmentsJJ) == 0L) {
      fitList <- append(fitList, list(fitJJ))
      verbose && exit(verbose)
      next
    }

    # Get the segments on this chromosome
    segsJJ <- getSegments(fitJJ)

    # Extract the individual known segments on this chromosome
    fitListJJ <- list()
    for (kk in seq_len(nrow(knownSegmentsJJ))) {
      verbose && enter(verbose, sprintf("Known segment #%d of %d", kk, nrow(knownSegmentsJJ)))
      seg <- knownSegmentsJJ[kk,]
      verbose && print(verbose, seg)

      start <- seg$start
      end <- seg$end
      idxStart <- min(which(segsJJ[[segKeys[1]]] >= start))
      idxEnd <- max(which(segsJJ[[segKeys[2]]] <= end))
      idxs <- idxStart:idxEnd

      # Extract the particular known segment
      fitKK <- extractSegments(fitJJ, idxs)

      # Only add if it has loci
      if (nbrOfLoci(fitKK) > 0L) {
        fitListJJ <- append(fitListJJ, list(fitKK))
      }

      fitKK <- NULL # Not needed anymore
      verbose && exit(verbose)
    } # for (kk ...)

    # Append
    fitList <- append(fitList, fitListJJ)
    fitListJJ <- NULL # Not needed anymore

    verbose && exit(verbose)
  } # for (jj ...)

  nbrOfRegions <- length(fitList)
  verbose && cat(verbose, "Number of independent non-empty regions: ", nbrOfRegions)
  verbose && exit(verbose)

  verbose && enter(verbose, "Shift every other region")
  for (jj in seq(from=1L, to=nbrOfRegions, by=2L)) {
    fitJJ <- fitList[[jj]]
    fitJJ <- shiftTCN(fitJJ, shift=shift)
    fitList[[jj]] <- fitJJ
  } # for (jj ...)
  verbose && exit(verbose)

  verbose && enter(verbose, "Merge")
  ## former Reduce() w/ append(a, b, addSplit = FALSE)
  fitT <- do.call(c, args = c(fitList, addSplit = FALSE))
  # Sanity check
##  .stop_if_not(nbrOfSegments(fitT) == nbrOfSegments(fit)) # Not true anymore
  verbose && exit(verbose)
  fitList <- NULL # Not needed anymore

  segsT <- getSegments(fitT)
  verbose && print(verbose, tail(segsT))
  verbose && exit(verbose)

  fit <- fitT

  # Not needed anymore
  fitT <- knownSegments <- NULL


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract signals for DP
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Extracting signals for dynamic programming")

  fit <- tileChromosomes(fit)

  # Locus-level signals
  data <- getLocusData(fit)
  Y <- as.matrix(data[,by,drop=FALSE])
  verbose && print(verbose, summary(Y))

  # "DP" change-point indices (excluding the two outer/boundary ones)
  segRows <- fit[[segRowsKey]]
  segIdxs <- seq_len(nrow(segRows)-1L)
  cpIdxs <- segRows$endRow[segIdxs]

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Dynamic-programming segmention pruning
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Dynamic programming")

  verbose && cat(verbose, "Number of \"DP\" change points: ", length(cpIdxs))
  verbose && str(verbose, cpIdxs)

  res <- seqOfSegmentsByDP(Y, candidatechangepoints=cpIdxs, ...)
  verbose && str(verbose, res)

  # Sanity checks
  jumpList <- res$jump
  lastJump <- jumpList[[length(jumpList)]]
  .stop_if_not(identical(cpIdxs, as.integer(lastJump)))

  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Adjustments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose && enter(verbose, "Excluding cases where known segments no longer correct")

  verbose && cat(verbose, "Number of independent non-empty regions: ", nbrOfRegions)

  # Drop the K first
  nbrOfCPs <- nbrOfRegions - 1L
  if (nbrOfCPs > 0L) {
    K <- nbrOfCPs - 1L # Don't count the flat segmentation
    jumpList <- jumpList[-(1:K)]
  }

  verbose && str(verbose, jumpList)
  verbose && exit(verbose)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract the possible sets of segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  verbose <- less(verbose, 20)
  verbose && enter(verbose, "Converting to physical segments")

  segs <- getSegments(fit, splitters=TRUE, addGaps=FALSE)
  segs <- segs[,c("chromosome", segKeys)]
  jumpIdxList <- lapply(jumpList, FUN=function(idxs) {
    match(idxs, table=cpIdxs)
  })
  # Sanity check
  .stop_if_not(identical(seq_along(cpIdxs), jumpIdxList[[length(jumpIdxList)]]))

  chrs <- segs$chromosome
  starts <- segs[[segKeys[1]]]
  ends <- segs[[segKeys[2]]]
  nsegs <- nrow(segs)
  segList <- vector("list", length=length(jumpIdxList))
  for (kk in seq_along(segList)) {
    verbose && enter(verbose, sprintf("Sequence #%d of %d", kk, length(segList)))
    idxs <- jumpIdxList[[kk]]
    verbose && cat(verbose, "Change point indices:")
    verbose && str(verbose, idxs)

    chrsKK <- chrs[idxs]
    chr <- chrsKK[1]
#    .stop_if_not(all(chrsKK == chr))
    chrsKK <- c(chrsKK, chrsKK[length(chrsKK)])
    startsKK <- starts[c(1L, idxs+1L)]
    endsKK <- ends[c(idxs, nsegs)]
    verbose && cat(verbose, "Chromosomes:")
    verbose && str(verbose, chrsKK)
    verbose && cat(verbose, "Starts:")
    verbose && str(verbose, startsKK)
    verbose && cat(verbose, "Ends:")
    verbose && str(verbose, endsKK)


    offsetsKK <- chrOffsets[chrsKK]
    startsKK <- startsKK - offsetsKK
    endsKK <- endsKK - offsetsKK
    segsKK <- data.frame(chromosome=chrsKK, start=startsKK, end=endsKK)
    verbose && print(verbose, tail(segsKK))
    segList[[kk]] <- segsKK

    verbose && exit(verbose)
  } # for (kk ...)

  verbose && exit(verbose)
  verbose <- more(verbose, 20)


  # Sanity check
  lastSegs <- segList[[length(segList)]]
#  .stop_if_not(identical(lastSegs, segs))
  verbose && str(verbose, segList)

  nbrOfCPsSeq <- sapply(jumpList, FUN=length)
  verbose && cat(verbose, "Sequence of number of \"DP\" change points:")
  verbose && print(verbose, nbrOfCPsSeq)

  nbrOfSegsSeq <- sapply(segList, FUN=nrow)
  verbose && cat(verbose, "Sequence of number of segments:")
  verbose && print(verbose, nbrOfSegsSeq)

  nbrOfChangePointsSeq <- nbrOfSegsSeq - nbrOfRegions
  verbose && cat(verbose, "Sequence of number of \"discovered\" change points:")
  verbose && print(verbose, nbrOfChangePointsSeq)

  .stop_if_not(all(nbrOfSegsSeq == nbrOfCPsSeq + 1L))
  .stop_if_not(nbrOfSegsSeq[1L] == nbrOfRegions)

  segList <- lapply(segList, FUN=function(seg) {
    attr(seg, "nbrOfChangePoints") <- nrow(seg) - nbrOfRegions
    seg
  })

  K <- (nbrOfRegions-1L)
  modelFit <- list(
    nbrOfSegments=nbrOfSegsSeq,
    nbrOfChangePoints=nbrOfSegsSeq - nbrOfRegions,
    nbrOfRegions=nbrOfRegions,
    idxBest=res$kbest - K + 1L,
    rse=res$rse[-(1:K)],
    V=res$V[-(1:K),-(1:K),drop=FALSE],
    seqOfSegmentsByDP=res
  )
  attr(segList, "modelFit") <- modelFit

  verbose && exit(verbose)

  segList
}, protected=TRUE) # seqOfSegmentsByDP()



setMethodS3("seqOfSegmentsByDP", "matrix", function(
### Segmentation of a multi-dimensional signal with dynamic programming.
Y,
### A n*p signal to be segmented
candidatechangepoints = c(1:(n-1)),
### A vector of candidate positions for change-points (default=[1:n-1])
kmax = n-1,
### Maximum number of change-points to test (default : n-1)
threshold = 0.5,
### Stopping criteria. Typically chosen to be in the interval
### (0 0.5]. The smaller the threshold, the higher the tendency to keep more
### changepoints. The criteria is based on the method found in 'Picard et al
### (2005)', "A statistical approach for array CGH data analysis" (BMC
### Bioinformatics). Default=0.5
...
){
  n <- dim(Y)[1]
  p <- dim(Y)[2]
  kmaxmin <- floor(n/4)

  if (kmax == 0 || kmax > length(candidatechangepoints)) {
    kmax <- min(length(candidatechangepoints), kmaxmin)
  }

  if (kmax > kmaxmin) {
    sprintf('warning : not enough points to optimize the number of the change-points up to %s\n', kmax)
    kmax <- kmaxmin
    sprintf('Set the maximum number of change-points to %s\n', kmax)
  }

  # Compute boundaries of the smallest intervals considered
  b <- sort(union(0, union(n, candidatechangepoints)))
  k <- length(b) - 1 # k is the number of such intervals
  # Compute the k*k matrix J such that J[i,j] for i<=j is the RSE when intervales i to j are merged
  J <- matrix(numeric(k*k), ncol=k)

  # How should NAs be handled?!?
  Yz <- Y
  Yz[is.na(Yz)] <- 0
  s <- rbind(rep(0, times=p), colCumsums(Yz, useNames=FALSE))
  v <- c(0, cumsum(rowSums(Y^2, na.rm=TRUE)))
  for (i in 1:k) {
    for (j in i:k) {
      Istart <- b[i] + 1
      Iend <- b[j+1]
      J[i,j] <- v[Iend+1] - v[Istart] - sum((s[Iend+1,]-s[Istart,])^2, na.rm=TRUE)/(Iend-Istart+1)
    } # for (j ...)
  } # for (i ...)

  # Dynamic programming
  V <- matrix(numeric((kmax+1)*k), ncol=k) # V[i,j] is the best RSE for segmenting intervals 1 to j with at most i-1 change points
  jump <- matrix(numeric(kmax*k), ncol=k)
  # With no change points, V[i,j] is juste the precomputed RSE for intervals 1 to j
  V[1,] <- J[1,]
  # Then we apply the recursive formula
  for (ki in 1:kmax) {
    for (j in (ki+1):k) {
      val <- min(V[ki,ki:(j-1)] + t(J[(ki+1):j, j]))
      ind <- which.min(V[ki,ki:(j-1)] + t(J[(ki+1):j, j]))
      V[ki+1,j] <- val
      jump[ki,j] <- ind + ki-1
    } # for (j ...)
  } # for (ki ...)

  # Optimal segmentation
  res.jump <- list()
  for (ki in 1:kmax) {
    res.jump[[ki]] <- numeric(ki)
    res.jump[[ki]][ki] <- jump[ki,k]
    if (ki != 1) {
      for (i in seq(from=(ki-1), to=1, by=-1)) {
        res.jump[[ki]][i] <- jump[i, res.jump[[ki]][i+1]]
      }
    }
  } # for (ki ...)

  # Convert back the index of the interval to the last position before the jump
  rightlimit <- b[2:length(b)]
  for (ki in 1:kmax) {
    res.jump[[ki]] <- rightlimit[res.jump[[ki]]]
  } # for (ki ...)

  # RSE as a function of number of change-points
  res.rse <- V[,k]
  # Optimal number of change points
  options(warn=-1)
  J <- log(res.rse)
  Km <- length(J)
  Jtild <- (J[Km]-J)/(J[Km]-J[1])*(Km-1)+1 # Normalize
  res.kbest <- max(which(diff(diff(Jtild)) > threshold)) + 1
  #if((res.kbest) == -Inf) { res.kbest <- 1 }
  return(list(jump=res.jump, rse=res.rse, kbest=res.kbest, V=V))
### \item{res.jump{i}}{a i*1 vector of change-point positions for the i-th lambda value (i depends on lambda). i varies between 1 and kmax}
### \item{res.rse}{a (kmax+1)-dimensional vector of residual squared error}
### \item{res.kbest}{the number of selected change-points}
}) # seqOfSegmentsByDP()



###########################################################################/**
# @set class=AbstractCBS
# @RdocMethod pruneByDP
#
# @title "Prunes the CN profile using dynamical programming"
#
# \description{
#  @get "title" by specifying the target number of segments or alternative
#  how of many change points to drop.
# }
#
# @synopsis
#
# \arguments{
#  \item{nbrOfSegments}{An @integer specifying the number of segments after
#     pruning. If negative, the it specifies the number of change points
#     to drop.}
#  \item{...}{Optional arguments passed to @seemethod "seqOfSegmentsByDP".}
#  \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns a pruned object of the same class.
# }
#
# \examples{\dontrun{
#  # Drop two segments
#  fitP <- pruneByDP(fit, nbrOfSegments=-2)
# }}
#
# @author "HB, PN"
#
# \references{
#   [1] ... \cr
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("pruneByDP", "AbstractCBS", function(fit, nbrOfSegments, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Some pre-extraction
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  knownSegments <- fit$params$knownSegments
  if (nrow(knownSegments) == 0L) {
    chromosome <- getChromosomes(fit)
    knownSegments <- data.frame(chromosome=chromosome, start=-Inf, end=+Inf)
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'nbrOfSegments':
  nbrOfSegments <- Arguments$getInteger(nbrOfSegments)
  # Specifying number of change points *to drop*?
  if (nbrOfSegments < 0L) {
    nbrOfCPsToDrop <- -nbrOfSegments
    nbrOfSegments <- nbrOfSegments(fit, splitters=FALSE) - nbrOfCPsToDrop
  }

  if (nbrOfSegments < nrow(knownSegments)) {
    stop("Argument 'nbrOfSegments' is less than number of \"known\" segments: ", nbrOfSegments, " < ", nrow(knownSegments))
  }
  if (nbrOfSegments > nbrOfSegments(fit, splitters=FALSE)) {
    stop("Argument 'nbrOfSegments' is greater than the number of \"found\" segments: ", nbrOfSegments, " > ", nbrOfSegments(fit, splitters=FALSE))
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Prune segments by dynamical programming")

  # Nothing to do?
  if (nbrOfSegments == nbrOfSegments(fit, splitters=FALSE)) {
    verbose && cat(verbose, "No need for pruning, because the number of \"target\" segments is the same as the number of \"found\" segments: ", nbrOfSegments, " == ", nbrOfSegments(fit, splitters=FALSE))
    return(fit)
    verbose && exit(verbose)
  }

  verbose && cat(verbose, "Target number of segments: ", nbrOfSegments)

  verbose && enter(verbose, "Dynamic programming")
  segList <- seqOfSegmentsByDP(fit, ...)

  # Select the one with expected number of segments
  nbrOfCPs <- sapply(segList, FUN=nrow)
  verbose && printf(verbose, "Range of number of CPs among solutions: [%d,%d]\n", min(nbrOfCPs), max(nbrOfCPs))

  keep <- which(nbrOfCPs == nbrOfSegments)
  .stop_if_not(length(keep) == 1L)

  knownSegments <- segList[[keep]]
  verbose && printf(verbose, "Solution with %d segments:\n", nbrOfSegments)
  verbose && print(verbose, knownSegments)
  verbose && exit(verbose)

  verbose && enter(verbose, "Rebuilding segmentation results")
  fitDP <- resegment(fit, knownSegments=knownSegments, undoTCN=+Inf, undoDH=+Inf, verbose=less(verbose, 10))
  verbose && print(verbose, fitDP)
  verbose && exit(verbose)

  verbose && exit(verbose)

  fitDP
}, protected=TRUE) # pruneByDP()

###########################################################################/**
# @set "class=PairedPSCBS"
# @RdocMethod plotTracks1
# @aliasmethod plotTracks
# @aliasmethod plotTracks2
# @aliasmethod plotTracksManyChromosomes
# @alias plot
#
# @title "Plots parental specific copy numbers along the genome"
#
# \description{
#  @get "title" for one or more chromosomes.
#  It is possible to specify what type of tracks to plot.
#  Each type of track is plotted in its own panel.
# }
#
# @synopsis
#
# \arguments{
#   \item{x}{A result object returned by @see "segmentByPairedPSCBS".}
#   \item{tracks}{A @character @vector specifying what types of tracks to plot.}
#   \item{scatter}{A @character @vector specifying which of the tracks should
#     have scatter plot.}
#   \item{calls}{A @character @vector of regular expression identifying
#     call labels to be highlighted in the panels.}
#   \item{pch}{The type of the scatter points, if any.}
#   \item{col}{The color of the scatter points, if any.}
#   \item{cex}{The size of the scatter points, if any.}
#   \item{changepoints}{If @TRUE, changepoints are drawn as vertical lines.}
#   \item{grid}{If @TRUE, horizontal lines are displayed.}
#   \item{quantiles}{A @numeric @vector in [0,1] specifying the quantiles
#      of the confidence bands to be drawn, if any.}
#   \item{xlim}{(Optional) The genomic range to plot.}
#   \item{Clim}{The range of copy numbers.}
#   \item{Blim}{The range of allele B fractions (BAFs) and
#     decrease of heterozygosity (DHs).}
#   \item{xScale}{The scale factor used for genomic positions.}
#   \item{...}{Not used.}
#   \item{add}{If @TRUE, the panels plotted are added to the existing plot,
#     otherwise a new plot is created.}
#   \item{subplots}{If @TRUE, then subplots are automatically setup.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns nothing.
# }
#
# @author "HB"
#
# @keyword IO
# @keyword internal
#*/###########################################################################
setMethodS3("plotTracks1", "PairedPSCBS", function(x, tracks=c("tcn", "dh", "tcn,c1,c2", "tcn,c1", "tcn,c2", "c1,c2", "betaN", "betaT", "betaTN")[1:3], scatter="*", calls=".*", pch=".", col=NULL, cex=1, changepoints=FALSE, grid=FALSE, quantiles=c(0.05,0.95), xlim=NULL, Clim=c(0,3*ploidy(x)), Blim=c(0,1), xScale=1e-6, ..., add=FALSE, subplots=!add && (length(tracks) > 1), verbose=FALSE) {

  # To please R CMD check
  fit <- x

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'add':
  add <- Arguments$getLogical(add)

  # Argument 'Clim' & 'Blim':
  if (!add) {
    Clim <- Arguments$getNumerics(Clim, length=c(2L,2L),
                                        disallow=c("Inf", "NA", "NaN"))
    Blim <- Arguments$getNumerics(Blim, length=c(2L,2L),
                                        disallow=c("Inf", "NA", "NaN"))
  }

  # Argument 'fit':
  if (nbrOfChromosomes(fit) >= 1L) {
    return(plotTracksManyChromosomes(fit, tracks=tracks, scatter=scatter, calls=calls, pch=pch, quantiles=quantiles, Clim=Clim, Blim=Blim, xScale=xScale, ..., add=add, subplots=subplots, verbose=verbose))
  }

  # Argument 'tracks':
  knownTracks <- c("tcn", "dh", "tcn,c1,c2", "tcn,c1", "tcn,c2", "c1,c2", "betaN", "betaT", "betaTN")
  tracks <- match.arg(tracks, choices=knownTracks, several.ok=TRUE)
  tracks <- unique(tracks)

  # Argument 'scatter':
  if (!is.null(scatter)) {
    scatter <- Arguments$getCharacter(scatter)
    if (scatter == "*") {
      scatter <- tracks
    } else {
      scatterT <- strsplit(scatter, split=",", fixed=TRUE)
      tracksT <- strsplit(tracks, split=",", fixed=TRUE)
      .stop_if_not(all(is.element(scatterT, tracksT)))
      # Not needed anymore
      scatterT <- tracksT <- NULL
    }
  }

  # Argument 'calls':
  if (!is.null(calls)) {
    calls <- sapply(calls, FUN=Arguments$getRegularExpression)
  }

  # Argument 'changepoints':
  changepoints <- Arguments$getLogical(changepoints)

  # Argument 'grid':
  grid <- Arguments$getLogical(grid)

  # Argument 'xlim':
  if (!is.null(xlim)) {
    xlim <- Arguments$getNumerics(xlim, length=c(2,2))
  }

  # Argument 'xScale':
  xScale <- Arguments$getNumeric(xScale, range=c(0,Inf))

  # Argument 'subplots':
  subplots <- Arguments$getLogical(subplots)

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Plotting PSCN tracks")

  # Extract the input data
  data <- getLocusData(fit)
  if (is.null(data)) {
    stop("Cannot plot segmentation results. No input data available.")
  }

  chromosomes <- getChromosomes(fit)
  chromosome <- chromosomes[1]
  x <- data$x
  CT <- data$CT
  rho <- data$rho
  betaT <- data$betaT
  betaN <- data$betaN
  betaTN <- data$betaTN
  muN <- data$muN
  rho <- data$rho
  hasDH <- !is.null(rho)
  if (hasDH) {
    isHet <- !is.na(rho)
    isSnp <- isHet
  } else {
    isSnp <- (!is.na(betaTN) & !is.na(muN))
    isHet <- isSnp & (muN == 1/2)
  }
  nbrOfLoci <- length(x)

  # BACKWARD COMPATIBILITY:
  # If 'rho' is not available, recalculate it from tumor BAFs.
  # NOTE: This should throw an error in the future. /HB 2013-10-25
  if (!hasDH) {
    rho <- rep(NA_real_, times=nbrOfLoci)
    rho[isHet] <- 2*abs(betaTN[isHet]-1/2)
    warning(sprintf("Locus-level DH signals ('rho') were not available in the %s object and therefore recalculated from the TumorBoost-normalized tumor BAFs ('betaTN').", class(fit)[1L]))
  }

  # Extract the segmentation
  segs <- as.data.frame(fit)

  # Identify available calls
  if (!is.null(calls)) {
    verbose && enter(verbose, "Identifying calls")

    pattern <- "Call$"
    callColumns <- grep(pattern, colnames(segs), value=TRUE)
    if (length(callColumns) > 0) {
      keep <- sapply(calls, FUN=function(pattern) {
        (regexpr(pattern, callColumns) != -1)
      })
      if (is.matrix(keep)) {
        keep <- rowAnys(keep, useNames=FALSE)
      }
      callColumns <- callColumns[keep]
      callLabels <- gsub(pattern, "", callColumns)
      callLabels <- toupper(callLabels)
    }
    verbose && cat(verbose, "Call columns:")
    verbose && print(verbose, callColumns)

    verbose && exit(verbose)
  } else {
    callColumns <- NULL
  }

  if (chromosome != 0) {
    chrTag <- sprintf("Chr%02d", chromosome)
  } else {
    chrTag <- ""
  }

  if (xScale != 1) {
    x <- xScale * x
    if (!is.null(xlim)) {
      xlim <- xScale * xlim
    }
  }

  if (subplots) {
    subplots(length(tracks), ncol=1)
    par(mar=c(1,4,1,2)+1)
  }

  # Color loci by heterozygous vs homozygous
  if (hasDH) {
    colMu <- c("gray", "black")[!is.na(rho) + 1]
  } else {
    colMu <- c("gray", "black")[(muN == 1/2) + 1]
  }

  for (tt in seq_along(tracks)) {
    track <- tracks[tt]
    verbose && enter(verbose, sprintf("Track #%d ('%s') of %d",
                                             tt, track, length(tracks)))

    if (!is.null(scatter)) {
      pchT <- pch
      colT <- col
    } else {
      pchT <- NA
      colT <- NA
    }

    if (track == "tcn") {
      colT <- ifelse(is.null(colT), "black", colT)
      if (add) {
        points(x, CT, pch=pchT, col=colT, cex=cex)
      } else {
        plot(x, CT, pch=pchT, col=colT, cex=cex, xlim=xlim, ylim=Clim, ylab="TCN")
        stext(side=3, pos=1, chrTag)
        if (grid) {
          abline(h=seq(from=0, to=Clim[2], by=2), lty=3, col="gray")
          abline(h=0, lty=1, col="black")
        }
        drawConfidenceBands(fit, what="tcn", quantiles=quantiles, col="purple", xScale=xScale)
        drawLevels(fit, what="tcn", col="purple", xScale=xScale)
      }
    }

    if (is.element(track, c("tcn,c1,c2", "tcn,c1", "tcn,c2", "c1,c2"))) {
      colT <- ifelse(is.null(colT), "black", colT)
      subtracks <- strsplit(track, split=",", fixed=TRUE)[[1]]
      ylab <- paste(toupper(subtracks), collapse=", ")
      if (add) {
        points(x, CT, pch=pchT, cex=cex, col=colT)
      } else {
        plot(x, CT, pch=pchT, cex=cex, col=colT, xlim=xlim, ylim=Clim, ylab=ylab)
        stext(side=3, pos=1, chrTag)
        if (grid) {
          abline(h=seq(from=0, to=Clim[2], by=2), lty=3, col="gray")
          abline(h=0, lty=1, col="black")
        }
        if (is.element("tcn", subtracks)) {
          drawConfidenceBands(fit, what="tcn", quantiles=quantiles, col="purple", xScale=xScale)
        }
        if (is.element("c2", subtracks)) {
          drawConfidenceBands(fit, what="c2", quantiles=quantiles, col="red", xScale=xScale)
        }
        if (is.element("c1", subtracks)) {
          drawConfidenceBands(fit, what="c1", quantiles=quantiles, col="blue", xScale=xScale)
        }
        if (is.element("tcn", subtracks)) {
          drawLevels(fit, what="tcn", col="purple", xScale=xScale)
        }
        if (is.element("c2", subtracks)) {
          drawLevels(fit, what="c2", col="red", xScale=xScale)
          # In case C2 overlaps with TCN
          if (is.element("tcn", subtracks)) {
            drawLevels(fit, what="tcn", col="purple", lty="22", xScale=xScale)
          }
        }
        if (is.element("c1", subtracks)) {
          drawLevels(fit, what="c1", col="blue", xScale=xScale)
          # In case C1 overlaps with C1
          if (is.element("c2", subtracks)) {
            drawLevels(fit, what="c2", col="red", lty="22", xScale=xScale)
            if (is.element("tcn", subtracks)) {
              drawLevels(fit, what="tcn", col="purple", lty="22", xScale=xScale)
            }
          }
        }
      }
    }

    if (track == "betaN") {
      colT <- ifelse(is.null(colT), colMu, colT)
      if (add) {
        points(x, betaN, pch=pchT, cex=cex, col="black")
      } else {
        plot(x, betaN, pch=pchT, cex=cex, col=colT, xlim=xlim, ylim=Blim, ylab=expression(BAF[N]))
        stext(side=3, pos=1, chrTag)
      }
    }

    if (track == "betaT") {
      colT <- ifelse(is.null(colT), colMu, colT)
      if (add) {
        points(x, betaT, pch=pchT, cex=cex, col="black")
      } else {
        plot(x, betaT, pch=pchT, cex=cex, col=colT, xlim=xlim, ylim=Blim, ylab=expression(BAF[T]))
        stext(side=3, pos=1, chrTag)
      }
    }

    if (track == "betaTN") {
      colT <- ifelse(is.null(colT), colMu, colT)
      if (add) {
        points(x, betaTN, pch=pchT, cex=cex, col="black")
      } else {
        plot(x, betaTN, pch=pchT, cex=cex, col=colT, xlim=xlim, ylim=Blim, ylab=expression(BAF[T]^"*"))
        stext(side=3, pos=1, chrTag)
      }
    }

    if (track == "dh") {
      colT <- ifelse(is.null(colT), colMu[isHet], colT)
      if (add) {
        points(x, rho, pch=pchT, cex=cex, col="black")
      } else {
        plot(x, rho, pch=pchT, cex=cex, col=colT, xlim=xlim, ylim=Blim, ylab="DH")
        stext(side=3, pos=1, chrTag)
        drawConfidenceBands(fit, what="dh", quantiles=quantiles, col="orange", xScale=xScale)
        drawLevels(fit, what="dh", col="orange", xScale=xScale)
      }
    }

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Draw change points?
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    if (changepoints) {
      drawChangePoints(fit, col="#666666", xScale=xScale)
    }


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # For each panel of tracks, annotate with calls?
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    if (length(callColumns) > 0) {
      for (cc in seq_along(callColumns)) {
        callColumn <- callColumns[cc]
        callLabel <- callLabels[cc]
        verbose && enter(verbose, sprintf("Call #%d ('%s') of %d",
                                      cc, callLabel, length(callColumns)))

        verbose && cat(verbose, "Column: ", callColumn)

        segsT <- segs[,c("dhStart", "dhEnd", callColumn)]
        isCalled <- which(segsT[[callColumn]])
        segsT <- segsT[isCalled,1:2,drop=FALSE]
        verbose && printf(verbose, "Number of segments called %s: %d\n",
                                                  callLabel, nrow(segsT))
        segsT <- xScale * segsT

        verbose && str(verbose, segsT)

        side <- 2*((cc+1) %% 2) + 1
        # For each segment called...
        for (ss in seq_len(nrow(segsT))) {
          x0 <- segsT[ss,1,drop=TRUE]
          x1 <- segsT[ss,2,drop=TRUE]
          abline(v=c(x0,x1), lty=3, col="gray")
          xMid <- (x0+x1)/2
          mtext(side=side, at=xMid, line=-1, cex=0.7, col="#666666", callLabel)
        } # for (ss in ...)
        verbose && exit(verbose)
      } # for (cc in ...)

      # Add call parameter estimates, e.g. deltaAB
      for (cc in seq_along(callColumns)) {
        callColumn <- callColumns[cc]
        callLabel <- callLabels[cc]
        h <- NULL
        if (callLabel == "AB") {
          if (track == "dh") {
            h <- fit$params$deltaAB
            label <- expression(Delta[AB])
            colT <- "orange"
          }
        } else if (callLabel == "LOH") {
          if (regexpr("c1", track) != -1L) {
            h <- fit$params$deltaLowC1
            label <- expression(Delta[LOH])
            colT <- "blue"
          }
        } else if (callLabel == "NTCN") {
          if (track == "tcn") {
            h <- fit$params$ntcnRange
            label <- c(expression(Delta[-NTCN]), expression(Delta[+NTCN]))
            colT <- "purple"
          }
        }

        if (!is.null(h)) {
          abline(h=h, lty=4, lwd=2, col=colT)
          for (ss in 1:2) {
            side <- c(2,4)[ss]
            adj <- c(1.2,-0.2)[ss]
            mtext(side=side, at=h, label, adj=adj, las=2, xpd=TRUE)
          }
        }
      } # for (cc in ...)
    } # if (length(callColumns) > 0)

    verbose && exit(verbose)
  } # for (tt ...)

  verbose && exit(verbose)

  invisible()
}, private=TRUE) # plotTracks1()


setMethodS3("plotTracks", "PairedPSCBS", function(fit, ...) {
  plotTracksManyChromosomes(fit, ...)
})

setMethodS3("plot", "PairedPSCBS", function(x, ...) {
  plotTracks(x, ...)
}, private=TRUE)


setMethodS3("drawLevels", "PairedPSCBS", function(fit, what=c("tcn", "betaTN", "dh", "c1", "c2"), lend=1L, xScale=1e-6, ...) {
  # WORKAROUND: If Hmisc is loaded after R.utils, it provides a buggy
  # capitalize() that overrides the one we want to use. Until PSCBS
  # gets a namespace, we do the following workaround. /HB 2011-07-14
  capitalize <- R.utils::capitalize

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'what':
  what <- match.arg(what)

  # Argument 'xScale':
  xScale <- Arguments$getNumeric(xScale, range=c(0,Inf))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- tileChromosomes(fit)

  # Get segmentation results
  segs <- as.data.frame(fitT)

  if (what == "betaTN") {
    whatT <- "dh"
  } else {
    whatT <- what
  }

  # Extract subset of segments
  fields <- c("start", "end")
  fields <- sprintf("%s%s", ifelse(what == "tcn", what, "dh"), capitalize(fields))
  fields <- c(fields, sprintf("%sMean", whatT))
  segsT <- segs[,fields, drop=FALSE]
  segsT <- unique(segsT)

  if (what == "betaTN") {
    dh <- segsT[,"dhMean"]
    bafU <- (1 + dh)/2
    bafL <- (1 - dh)/2
    segsT[,3] <- bafU
    segsT[,4] <- bafL
  }

  # Reuse drawLevels() for the DNAcopy class
  for (cc in seq(from=3, to=ncol(segsT))) {
    segsTT <- segsT[,c(1:2,cc)]
    colnames(segsTT) <- c("loc.start", "loc.end", "seg.mean")
    dummy <- list(output=segsTT)
    class(dummy) <- "DNAcopy"
    drawLevels(dummy, lend=lend, xScale=xScale, ...)
  } # for (cc ...)
}, private=TRUE)


setMethodS3("drawConfidenceBands", "PairedPSCBS", function(fit, what=c("tcn", "dh", "c1", "c2"), quantiles=c(0.05,0.95), col=col, alpha=0.4, xScale=1e-6, ...) {
  # WORKAROUND: If Hmisc is loaded after R.utils, it provides a buggy
  # capitalize() that overrides the one we want to use. Until PSCBS
  # gets a namespace, we do the following workaround. /HB 2011-07-14
  capitalize <- R.utils::capitalize

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'what':
  what <- match.arg(what)

  # Argument 'quantiles':
  if (!is.null(quantiles)) {
    quantiles <- Arguments$getNumerics(quantiles, range=c(0,1), length=c(2,2))
  }

  # Argument 'xScale':
  xScale <- Arguments$getNumeric(xScale, range=c(0,Inf))


  # Nothing todo?
  if (is.null(quantiles)) {
    return()
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- tileChromosomes(fit)

  # Get segmentation results
  segs <- as.data.frame(fitT)

  # Extract subset of segments
  fields <- c("start", "end")
  fields <- sprintf("%s%s", ifelse(what == "tcn", what, "dh"), capitalize(fields))

  tags <- sprintf("%g%%", 100*quantiles)
  qFields <- sprintf("%s_%s", what, tags)

  # Nothing todo?
  if (!all(is.element(qFields, colnames(segs)))) {
    return()
  }

  fields <- c(fields, qFields)

  segsT <- segs[,fields, drop=FALSE]
  segsT <- unique(segsT)

  # Rescale x-axis
  segsT[,1:2] <- xScale * segsT[,1:2]

  colQ <- col2rgb(col, alpha=TRUE)
  colQ["alpha",] <- alpha*colQ["alpha",]
  colQ <- rgb(red=colQ["red",], green=colQ["green",], blue=colQ["blue",], alpha=colQ["alpha",], maxColorValue=255)

  for (kk in seq_len(nrow(segsT))) {
    rect(xleft=segsT[kk,1], xright=segsT[kk,2], ybottom=segsT[kk,3], ytop=segsT[kk,4], col=colQ, border=FALSE)
  }
}, private=TRUE)



setMethodS3("plotC1C2", "PairedPSCBS", function(fit, ..., xlab=expression(C[1]), ylab=expression(C[2]), Clim=c(0,2*ploidy(fit))) {
  # Argument 'Clim':
  Clim <- Arguments$getNumerics(Clim, length=c(2L,2L),
                                        disallow=c("Inf", "NA", "NaN"))

  plot(NA, xlim=Clim, ylim=Clim, xlab=xlab, ylab=ylab)
  abline(a=0, b=1, lty=3)
  pointsC1C2(fit, ...)
}, private=TRUE)


setMethodS3("pointsC1C2", "PairedPSCBS", function(fit, cex=NULL, col="#00000033", ...) {
  data <- extractC1C2(fit)
  X <- data[,1:2,drop=FALSE]
  n <- data[,4,drop=TRUE]
  n <- sqrt(n)
  w <- n / sum(n, na.rm=TRUE)

  if (is.null(cex)) {
    cex <- w
    cex <- cex / mean(cex, na.rm=TRUE)
    cex <- cex + 1/2
  }

  points(X, cex=cex, col=col, ...)
}, private=TRUE)


setMethodS3("linesC1C2", "PairedPSCBS", function(fit, ...) {
  drawChangePointsC1C2(fit, ...)
}, private=TRUE)


setMethodS3("drawChangePointsC1C2", "PairedPSCBS", function(fit, col="#00000033", labels=FALSE, lcol="#333333", cex=0.7, adj=c(+1.5,+0.5), ...) {
  xy <- extractMinorMajorCNs(fit, splitters=TRUE, addGaps=TRUE)
  xy <- xy[,1:2,drop=FALSE]
  res <- lines(xy, col=col, ...)

  if (labels) {
    n <- nrow(xy)
    dxy <- (xy[-1,] - xy[-n,]) / 2
    xyMids <- xy[-n,] + dxy
    labels <- rownames(xy)
    labels <- sprintf("%s-%s", labels[-n], labels[-1])
    text(xyMids, labels, cex=cex, col=lcol, adj=adj, ...)
  }

  invisible(res)
}, private=TRUE)




setMethodS3("plotDeltaC1C2", "PairedPSCBS", function(fit, ..., xlab=expression(Delta*C[1]), ylab=expression(Delta*C[2]), Clim=c(-1,1)*ploidy(fit)) {
  # Argument 'Clim':
  Clim <- Arguments$getNumerics(Clim, length=c(2L,2L),
                                        disallow=c("Inf", "NA", "NaN"))

  plot(NA, xlim=Clim, ylim=Clim, xlab=xlab, ylab=ylab)
  abline(h=0, lty=3)
  abline(v=0, lty=3)
  pointsDeltaC1C2(fit, ...)
}, private=TRUE)


setMethodS3("pointsDeltaC1C2", "PairedPSCBS", function(fit, ...) {
  data <- extractDeltaC1C2(fit)
  X <- data[,1:2,drop=FALSE]
  points(X, ...)
}, private=TRUE)


setMethodS3("linesDeltaC1C2", "PairedPSCBS", function(fit, ...) {
  xy <- extractDeltaC1C2(fit)
  xy <- xy[,1:2,drop=FALSE]
  lines(xy, ...)
}, private=TRUE)



setMethodS3("arrowsC1C2", "PairedPSCBS", function(fit, length=0.05, ...) {
  xy <- extractMinorMajorCNs(fit, splitters=TRUE, addGaps=TRUE)
  xy <- xy[,1:2,drop=FALSE]
  x <- xy[,1,drop=TRUE]
  y <- xy[,2,drop=TRUE]
  s <- seq_len(length(x)-1)
  arrows(x0=x[s],y0=y[s], x1=x[s+1],y1=y[s+1], code=2, length=length, ...)
}, private=TRUE)


setMethodS3("arrowsDeltaC1C2", "PairedPSCBS", function(fit, length=0.05, ...) {
  xy <- extractDeltaC1C2(fit)
  xy <- xy[,1:2,drop=FALSE]
  x <- xy[,1,drop=TRUE]
  y <- xy[,2,drop=TRUE]
  s <- seq_len(length(x)-1)
  arrows(x0=x[s],y0=y[s], x1=x[s+1],y1=y[s+1], code=2, length=length, ...)
}, private=TRUE)




setMethodS3("tileChromosomes", "PairedPSCBS", function(fit, chrStarts=NULL, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'chrStarts':
  if (!is.null(chrStarts)) {
    chrStarts <- Arguments$getDoubles(chrStarts)
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  # Nothing to do, i.e. already tiled?
  if (isTRUE(attr(fit, "tiledChromosomes"))) {
    return(fit)
  }


  verbose && enter(verbose, "Tile chromosomes")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and segments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  segs <- getSegments(fit)
  knownSegments <- fit$params$knownSegments

  # Identify all chromosome
  chromosomes <- getChromosomes(fit)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Additional chromosome annotations
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (is.null(chrStarts)) {
    xRange <- matrix(0, nrow=length(chromosomes), ncol=2)
    for (kk in seq_along(chromosomes)) {
      chromosome <- chromosomes[kk]
      idxs <- which(data$chromosome == chromosome)
      x <- data$x[idxs]
      r <- range(x, na.rm=TRUE)
      r <- r / 1e6
      r[1] <- floor(r[1])
      r[2] <- ceiling(r[2])
      r <- 1e6 * r
      xRange[kk,] <- r
    } # for (kk ...)

    chrLength <- xRange[,2]
    chrStarts <- c(0, cumsum(chrLength)[-length(chrLength)])
    chrEnds <- chrStarts + chrLength

    # Not needed anymore
    x <- idxs <- NULL
  } # if (is.null(chrStarts))

  verbose && cat(verbose, "Chromosome starts:")
  chromosomeStats <- cbind(start=chrStarts, end=chrEnds, length=chrEnds-chrStarts)
  verbose && print(chromosomeStats)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Offset...
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  segFields <- grep("(Start|End)$", colnames(segs), value=TRUE)
  # Sanity check
  .stop_if_not(length(segFields) > 0)

  for (kk in seq_along(chromosomes)) {
    chromosome <- chromosomes[kk]
    chrTag <- sprintf("Chr%02d", chromosome)
    verbose && enter(verbose, sprintf("Chromosome #%d ('%s') of %d",
                                         kk, chrTag, length(chromosomes)))

    # Get offset for this chromosome
    offset <- chrStarts[kk]
    verbose && cat(verbose, "Offset: ", offset)

    # Offset data
    idxs <- which(data$chromosome == chromosome)
    if (length(idxs) > 0L) {
      data$x[idxs] <- offset + data$x[idxs]
    }

    # Offset segmentation
    idxs <- which(segs$chromosome == chromosome)
    if (length(idxs) > 0L) {
      segs[idxs,segFields] <- offset + segs[idxs,segFields]
    }

    # Offset known segments
    idxs <- which(knownSegments$chromosome == chromosome)
    if (length(idxs) > 0L) {
      knownSegments[idxs,c("start", "end")] <- offset + knownSegments[idxs,c("start", "end")]
    }

    verbose && exit(verbose)
  } # for (kk ...)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Update results
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fit$data <- data
  fit$output <- segs
  fit$chromosomeStats <- chromosomeStats
  fit$params$knownSegments <- knownSegments
#  fitT$params$chrOffsets <- chrOffsets

  # Flag object
  attr(fit, "tiledChromosomes") <- TRUE

  verbose && exit(verbose)

  fit
}, private=TRUE) # tileChromosomes()



setMethodS3("drawChangePoints", "PSCBS", function(fit, labels=FALSE, col="#666666", cex=0.5, xScale=1e-6, side=3, line=-1, xpd=TRUE, ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- tileChromosomes(fit)
  verbose && str(verbose, fitT)

  segs <- getSegments(fitT, splitters=FALSE)
  xStarts <- segs[,"tcnStart"]
  xEnds <- segs[,"tcnEnd"]

  xs <- sort(unique(c(xStarts, xEnds)))
  abline(v=xScale*xs, lty=1, col=col)

  if (labels) {
    xMids <- xScale * (xEnds + xStarts) / 2
    labels <- rownames(segs)
    mtext(side=side, at=xMids, labels, line=line, cex=cex, col=col, xpd=xpd, ...)
  }
}, protected=TRUE)



setMethodS3("getChromosomeRanges", "PairedPSCBS", function(fit, ...) {
  # To please R CMD check, cf. subset()
  chromosome <- NULL; rm(list="chromosome")

  segs <- getSegments(fit, splitters=FALSE)
  chromosomes <- sort(unique(segs$chromosome))

  # Allocate
  naValue <- NA_real_
  res <- matrix(naValue, nrow=length(chromosomes), ncol=3)
  rownames(res) <- chromosomes
  colnames(res) <- c("start", "end", "length")

  # Get start and end of each chromosome.
  for (ii in seq_len(nrow(res))) {
    chr <- chromosomes[ii]
    segsII <- subset(segs, chromosome == chr)
    res[ii,"start"] <- min(segsII$tcnStart, na.rm=TRUE)
    res[ii,"end"] <- max(segsII$tcnEnd, na.rm=TRUE)
  } # for (ii ...)

  res[,"length"] <- res[,"end"] - res[,"start"] + 1L

  # Sanity check
  .stop_if_not(nrow(res) == length(chromosomes))

  res <- as.data.frame(res)
  res <- cbind(chromosome=chromosomes, res)

  res
}, protected=TRUE) # getChromosomeRanges()


setMethodS3("getChromosomeOffsets", "PairedPSCBS", function(fit, resolution=1e6, ...) {
  # Argument 'resolution':
  if (!is.null(resolution)) {
    resolution <- Arguments$getDouble(resolution, range=c(1,Inf))
  }

  data <- getChromosomeRanges(fit, ...)
  splits <- data[,"start"] + data[,"length"]

  if (!is.null(resolution)) {
    splits <- ceiling(splits / resolution)
    splits <- resolution * splits
  }

  offsets <- c(0L, cumsum(splits))
  names(offsets) <- c(rownames(data), NA)

  offsets
}, protected=TRUE) # getChromosomeOffsets()

###########################################################################/**
# @set class=DNAcopy
# @RdocMethod as.CBS
#
# @title "Coerces a DNAcopy object to a CBS object"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{fit}{A \code{\link[DNAcopy:DNAcopy]{DNAcopy}}. object
#     (of the \pkg{DNAcopy} package.)}
#   \item{sample}{An index specifying which sample to extract,
#     if more than one exists.}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns a @see "CBS" object.
# }
#
# @author "HB"
#
# \seealso{
#   \code{\link[PSCBS:as.DNAcopy.CBS]{as.DNAcopy()}}.
#   For more information see \code{\link[DNAcopy:DNAcopy]{DNAcopy}}.
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("as.CBS", "DNAcopy", function(fit, sample=1L, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- fit$data
  sample <- Arguments$getIndex(sample, max=ncol(data)-2L)

  sampleName <- colnames(data)[sample+2L]


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup the 'data' field
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- fit$data
  rownames <- rownames(data)

  data <- data.frame(
    chromosome = data$chrom,
    x          = data$maploc,
    y          = data[,sample+2L,drop=TRUE],
    stringsAsFactors=FALSE
  )
  rownames(data) <- rownames


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup the 'output' field
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  output <- fit$output
  ID <- NULL; rm(list="ID") # To please R CMD check
  output <- subset(output, ID == sampleName)
  rownames <- rownames(output)

  output <- data.frame(
    chromosome = output$chrom,
    start      = output$loc.start,
    end        = output$loc.end,
    nbrOfLoci  = as.integer(output$num.mark),
    mean       = output$seg.mean,
    stringsAsFactors=FALSE
  )
  rownames(output) <- rownames

  # Add chromosome splitter
  ats <- which(diff(output$chromosome) != 0) + 1L
  if (length(ats) > 0) {
    idxs <- seq_len(nrow(output))
    values <- rep(NA_integer_, times=length(ats))
    expand <- insert(idxs, ats=ats, values=values) # R.utils::insert()
    output <- output[expand,]
    rownames(output) <- NULL
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Setup up 'CBS' object
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (sampleName == "<NA>") sampleName <- NA_character_
  res <- list()
  res$sampleName <- sampleName
  res$data <- data
  res$output <- output
  res$params <- list()
  class(res) <- class(CBS())

  res
}) # as.CBS()


setMethodS3("extractTotalCNs", "CBS", function(fit, ...) {
  data <- getSegments(fit, ...)
  data[,c("mean", "nbrOfLoci"), drop=FALSE]
}, protected=TRUE)


setMethodS3("extractCNs", "CBS", function(fit, ...) {
  data <- extractTotalCNs(fit, ...)
  data <- data[,c("mean"), drop=FALSE]
  data <- as.matrix(data)
  data
}, protected=TRUE)



setMethodS3("extractChromosomes", "CBS", function(x, chromosomes, ...) {
  # To please R CMD check
  this <- x

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'chromosomes':
  disallow <- c("NaN", "Inf")
  chromosomes <- Arguments$getIntegers(chromosomes, range=c(0,Inf), disallow=disallow)
  .stop_if_not(all(is.element(chromosomes, getChromosomes(this))))

  # Always extract in order
  chromosomes <- unique(chromosomes)
  chromosomes <- sort(chromosomes)

  # Allocate results
  res <- this

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Locus data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  chromosome <- NULL; rm(list="chromosome") # To please R CMD check
  data <- getLocusData(this)
  class <- class(data)
  class(data) <- "data.frame"
  data <- subset(data, chromosome %in% chromosomes)
  class(data) <- class
  res$data <- data


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Segmentation data
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Identify rows to subset
  rows <- which(is.element(res$output$chromosome, chromosomes))
  for (field in c("output", "segRows")) {
    res[[field]] <- res[[field]][rows,,drop=FALSE]
  }

  # Identify chromosome offsets
  data <- getLocusData(this)
  chrStarts <- match(getChromosomes(this), data$chromosome)
  chrEnds <- c(chrStarts[-1]-1L, nrow(data))
  chrLengths <- chrEnds - chrStarts + 1L

  chrLengthsExcl <- chrLengths

  keep <- match(chromosomes, getChromosomes(this))
  chrLengthsExcl[keep] <- 0L
  cumChrLengthsExcl <- cumsum(chrLengthsExcl)

  shifts <- cumChrLengthsExcl[keep]
  .stop_if_not(all(is.finite(shifts)))

  # Adjust indices
  for (cc in seq_along(chromosomes)) {
    chromosome <- chromosomes[cc]
    shift <- shifts[cc]
    # Nothing to do?
    if (shift == 0) next
    for (field in c("segRows")) {
      segRows <- res[[field]]
      rows <- which(res$output$chromosome == chromosome)
      segRows[rows,] <- segRows[rows,] - shift
      res[[field]] <- segRows
    }
  }

  res
}, protected=TRUE)


setMethodS3("subset", "CBS", function(x, chromlist=NULL, ...) {
  extractChromosomes(x, chromosomes=chromlist, ...)
}, private=TRUE)



###########################################################################/**
# @set "class=CBS"
# @RdocMethod extractSegmentMeansByLocus
#
# @title "Extracts segments means at each locus"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Arguments passed to @seemethod "getLocusData".}
# }
#
# \value{
#  Returns a @numeric @vector of length \code{nbrOfLoci()}.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("extractSegmentMeansByLocus", "CBS", function(fit, ...) {
  data <- getLocusData(fit, ...)
  chromosome <- data$chromosome
  x <- data$x
  y <- data[,3]

  segs <- getSegments(fit)
  nbrOfSegments <- nrow(segs)
  nbrOfLoci <- nrow(data)

  # Get mean estimators
  estList <- getMeanEstimators(fit, "y")
  avgY <- estList$y

  yS <- y
  for (ss in seq_len(nbrOfSegments)) {
    seg <- segs[ss,]
    idxs <- which(seg$chromosome == chromosome &
                  seg$start <= x & x <= seg$end)
    idxs <- Arguments$getIndices(idxs, max=nbrOfLoci)

    ySS <- y[idxs]
    ok <- is.finite(ySS)

    # Sanity check
    ## .stop_if_not(sum(ok) == seg$nbrOfLoci) # Not dealing with ties

    mu <- avgY(ySS[ok])
    yS[idxs] <- mu
  } # for (ss ...)

  yS
}, private=TRUE) # extractSegmentMeansByLocus()



###########################################################################/**
# @set "class=CBS"
# @RdocMethod estimateStandardDeviation
#
# @title "Estimates the whole-genome standard deviation of the signals"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{chromosomes}{An optional @vector specifying the subset of
#    chromosomes used for the estimate.  If @NULL, all chromosomes are used.}
#  \item{method}{A @character string specifying the method used.}
#  \item{estimator}{A @character string or a @function specifying the
#    internal estimator.}
#  \item{na.rm}{If @TRUE, missing values are dropped, otherwise not.}
#  \item{weights}{An optional @double @vector of \code{nbrOfLoci()}
#    non-negative weights.}
#  \item{...}{Not used.}
# }
#
# \value{
#  Returns a non-negative @numeric scale.
# }
#
# @author "HB"
#
# \seealso{
#   @seeclass
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("estimateStandardDeviation", "CBS", function(fit, chromosomes=NULL, method=c("diff", "res", "abs", "DNAcopy"), estimator=c("mad", "sd"), na.rm=TRUE, weights=NULL, ...) {
  # Local copies of DNAcopy functions
  DNAcopy_trimmed.variance <- .use("trimmed.variance", package="DNAcopy")


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'chromosomes':
  if (!is.null(chromosomes)) {
  }

  # Argument 'method':
  method <- match.arg(method)

  # Argument 'estimator':
  estimator <- match.arg(estimator)


  # Argument 'weights':
  if (!is.null(weights)) {
    nbrOfLoci <- nbrOfLoci(fit)
    weights <- Arguments$getNumerics(weights, range=c(0,Inf),
                                     length=rep(nbrOfLoci, times=2))
  }


  # Get the estimator function
  if (!is.null(weights)) {
    estimator <- sprintf("weighted %s", estimator)
    estimator <- R.utils::toCamelCase(estimator)
  }

  if (method == "DNAcopy") {
    estimatorFcn <- function(y, trim=0.025, ...) {
      sigma2 <- DNAcopy_trimmed.variance(y, trim=trim)
      sqrt(sigma2)
    }
  } else {
    estimatorFcn <- get(estimator, mode="function")
  }


  # Subset by chromosomes?
  if (!is.null(chromosomes)) {
    fit <- extractChromosomes(fit, chromosomes=chromosomes)
  }

  nbrOfLoci <- nbrOfLoci(fit)
  # Nothing to do?
  if (nbrOfLoci <= 1) {
    sigma <- NA_real_
    attr(sigma, "nbrOfLoci") <- nbrOfLoci
    attr(sigma, "df") <- NA_integer_
    return(sigma)
  }

  data <- getLocusData(fit)
  y <- data[,3]

  if (method == "diff") {
    dy <- diff(y)
    # Weighted estimator?
    if (!is.null(weights)) {
      # Calculate weights per pair
      weights <- (weights[1:(nbrOfLoci-1)]+weights[2:nbrOfLoci])/2
      sigma <- estimatorFcn(dy, w=weights, na.rm=na.rm)/sqrt(2)
    } else {
      sigma <- estimatorFcn(dy, na.rm=na.rm)/sqrt(2)
    }
    df <- length(dy)
  } else if (method == "res") {
    yS <- extractSegmentMeansByLocus(fit)
    dy <- y - yS
    if (!is.null(weights)) {
      sigma <- estimatorFcn(dy, w=weights, na.rm=na.rm)
    } else {
      sigma <- estimatorFcn(dy, na.rm=na.rm)
    }
    df <- length(dy)
  } else if (method == "abs") {
    if (!is.null(weights)) {
      sigma <- estimatorFcn(y, w=weights, na.rm=na.rm)
    } else {
      sigma <- estimatorFcn(y, na.rm=na.rm)
    }
    df <- length(y)
  } else if (method == "DNAcopy") {
    if (na.rm) {
      y <- y[!is.na(y)]
    }
    sigma <- estimatorFcn(y, ...)
    df <- length(y)
  } else {
    stop("Method no implemented: ", method)
  }

  attr(sigma, "nbrOfLoci") <- nbrOfLoci
  attr(sigma, "df") <- df

  sigma
}) # estimateStandardDeviation()



setMethodS3("getChromosomeRanges", "CBS", function(fit, ...) {
  # To please R CMD check, cf. subset()
  chromosome <- NULL; rm(list="chromosome")

  segs <- getSegments(fit, splitters=FALSE)
  chromosomes <- sort(unique(segs$chromosome))

  # Allocate
  naValue <- NA_real_
  res <- matrix(naValue, nrow=length(chromosomes), ncol=3)
  rownames(res) <- chromosomes
  colnames(res) <- c("start", "end", "length")

  # Get start and end of each chromosome.
  for (ii in seq_len(nrow(res))) {
    chr <- chromosomes[ii]
    segsII <- subset(segs, chromosome == chr)
    res[ii,"start"] <- min(segsII$start, na.rm=TRUE)
    res[ii,"end"] <- max(segsII$end, na.rm=TRUE)
  } # for (ii ...)

  res[,"length"] <- res[,"end"] - res[,"start"] + 1L

  # Sanity check
  .stop_if_not(nrow(res) == length(chromosomes))

  res <- as.data.frame(res)
  res <- cbind(chromosome=chromosomes, res)

  res
}, protected=TRUE) # getChromosomeRanges()

###########################################################################/**
# @set "class=CBS"
# @RdocMethod pruneBySdUndo
#
# @title "Prune the CBS profile by dropping change points that are too small"
#
# \description{
#  @get "title", where "too small" means that the amplitude of the
#  change points is less than a multiple of the overall standard deviation
#  of the copy-number signals.
# }
#
# @synopsis
#
# \arguments{
#   \item{fit}{A @see "CBS" object.}
#   \item{rho}{A positive @double scalar specifying the number of standard
#     deviations (\code{rho*sigma}) required in order to keep a change point.
#     More change points are dropped the greater this value is.}
#   \item{sigma}{The whole-genome standard deviation of the locus-level
#     copy number signals.  The default is to calculate it from the data
#     and as done in the \pkg{DNAcopy} package.}
#   \item{...}{(Optional) Additional arguments passed to the standard
#     deviation estimator function.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns a @see "CBS" object (of the same class as \code{fit}).
# }
#
# \details{
#  This method corresponds to using the \code{undo} argument when calling
#  @see "segmentByCBS", which in turn corresponds to using the
#  \code{undo.splits="sdundo"} and \code{undo.SD} of the underlying
#  @see "DNAcopy::segment" method.
# }
#
# @examples "../incl/segmentByCBS,pruneBySdUndo.Rex"
#
# @author "HB, PN"
#
# @keyword internal
#*/###########################################################################
setMethodS3("pruneBySdUndo", "CBS", function(fit, rho=3, sigma="DNAcopy", ..., verbose=FALSE) {
  # Local copies of DNAcopy functions
  DNAcopy_changepoints.sdundo <- .use("changepoints.sdundo", package="DNAcopy")


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'rho':
  rho <- Arguments$getDouble(rho, range=c(0,Inf))

  # Argument 'sigma':
  if (is.character(sigma)) {
    sigma <- estimateStandardDeviation(fit, method=sigma, ...)
  }
  sigma <- Arguments$getDouble(sigma, range=c(0,Inf), disallow=c("NA", "NaN", "Inf"))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Pruning segments by standard deviation")

  # Check if locus weights are available
  data <- getLocusData(fit)
  hasWeights <- !is.null(data$w)
  # Not needed anymore
  data <- NULL

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Prune chromosome by chromosome
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  chromosomes <- getChromosomes(fit)
  nbrOfChromosomes <- length(chromosomes)

  fitList <- vector("list", length=nbrOfChromosomes)
  for (cc in seq_len(nbrOfChromosomes)) {
    chr <- chromosomes[cc]
    verbose && enter(verbose, sprintf("Chromosome #%d ('Chr%s') of %d",
                                            cc, chr, length(chromosomes)))

    # Extract this chromosome
    fitT <- extractChromosome(fit, chromosome=chr)

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Get segmentation data
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    data <- getLocusData(fitT)
    segs <- getSegments(fitT)
    segRows <- fitT$segRows
    nbrOfSegs <- nrow(segRows)
    verbose && cat(verbose, "Number of segments (before): ", nbrOfSegs)

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Drop missing values
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    y <- data$y

    # Label data points by their segment index
    segId <- rep(NA_integer_, times=max(segRows[,2], na.rm=TRUE))
    for (rr in 1:nbrOfSegs) {
      segRow <- unlist(segRows[rr,], use.names=FALSE)
      idxs <- segRow[1]:segRow[2]
      segId[idxs] <- rr
    }

    # Drop missing value
    keep <- !is.na(y)
    if (hasWeights) {
      w <- data$w
      keep <- keep & !is.na(w)
    }
    units <- which(keep)
    y <- y[units]
    segId <- segId[units]
    if (hasWeights) {
      w <- w[units]
    }

    # Update 'segRows' accordingly
    for (rr in 1:nbrOfSegs) {
      startStop <- range(which(segId == rr))
      segRows[rr,1] <- startStop[1]
      segRows[rr,2] <- startStop[2]
    }
    # Not needed anymore
    segId <- startStop <- NULL

    # Sanity check
    .stop_if_not(max(segRows[,2]) <= length(y))

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Prune change points
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    segLengths <- segRows[,2] - segRows[,1] + 1L
    segLengthsP <- DNAcopy_changepoints.sdundo(genomdat=y,
                         lseg=segLengths, trimmed.SD=sigma, change.SD=rho)
    segLengthsP <- as.integer(segLengthsP)
    nbrOfSegsP <- length(segLengthsP)
    verbose && cat(verbose, "Number of segments (after): ", nbrOfSegsP)

    nbrOfPrunedSegs <- nbrOfSegs-nbrOfSegsP
    verbose && cat(verbose, "Number of segments dropped: ", nbrOfPrunedSegs)

    # No segments pruned?
    if (nbrOfPrunedSegs == 0) {
      # Sanity check
      .stop_if_not(identical(segLengthsP, segLengths))

      fitList[[cc]] <- fitT
      verbose && cat(verbose, "Nothing to changed. Skipping.")
#      verbose && exit(verbose)
#      next
    }

    # Setup new 'segRows'
    endRow <- cumsum(segLengthsP)
    n <- length(endRow)
    segRowsP <- data.frame(startRow=c(1L, endRow[-n]+1L), endRow=endRow)


    # Expand to units with also missing values
    segRowsP[,1] <- units[segRowsP[,1]]
    segRowsP[,2] <- units[segRowsP[,2]]

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # Create stub for a segment table
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    idxs <- seq_len(nbrOfSegsP)
    segsP <- segs[idxs,]

    # Sanity checks
    if (nbrOfPrunedSegs == 0) {
      segRows <- fitT$segRows
      .stop_if_not(all.equal(segRowsP, segRows, check.attributes=FALSE))
      .stop_if_not(all.equal(segsP, segs, check.attributes=FALSE))
    }

    fitT$output <- segsP
    fitT$segRows <- segRowsP

    fitList[[cc]] <- fitT

    verbose && exit(verbose)
  } # for (cc ...)

  ## formerly Reduce() w/ append(..., addSplit = TRUE)
  fitP <- do.call(c, args = c(fitList, addSplit = TRUE))

  verbose && enter(verbose, "Updating segment means and boundaries")
  fitP <- updateBoundaries(fitP, verbose=less(verbose, 50))
  fitP <- updateMeans(fitP, verbose=less(verbose, 50))
  verbose && exit(verbose)

  nbrOfSegs <- nbrOfSegments(fit)
  nbrOfSegsP <- nbrOfSegments(fitP)
  nbrOfPrunedSegs <- nbrOfSegs-nbrOfSegsP
  verbose && cat(verbose, "Number of segments (before): ", nbrOfSegs)
  verbose && cat(verbose, "Number of segments (after): ", nbrOfSegsP)
  verbose && cat(verbose, "Number of segments dropped: ", nbrOfPrunedSegs)

  verbose && exit(verbose)

  fitP
}) # pruneBySdUndo()


setMethodS3("seqOfSegmentsByDP", "CBS", function(fit, by=c("y"), ...) {
  NextMethod("seqOfSegmentsByDP", by=by)
})

###########################################################################/**
# @RdocClass AbstractCBS
#
# @title "The AbstractCBS class"
#
# \description{
#  @classhierarchy
#
#  All CBS-style segmentation results extend this class, e.g.
#  @see "CBS" and @see "PairedPSCBS".
# }
#
# @synopsis
#
# \arguments{
#   \item{fit}{A @list structure containing the segmentation results.}
#   \item{sampleName}{A @character string.}
#   \item{...}{Not used.}
# }
#
# \section{Fields and Methods}{
#  @allmethods "public"
# }
#
# @author "HB"
#
# @keyword internal
#*/###########################################################################
setConstructorS3("AbstractCBS", function(fit=list(), sampleName=fit$sampleName, ...) {
  # Argument 'sampleName':
  if (!is.null(sampleName)) {
    sampleName <- Arguments$getCharacter(sampleName)
  }

  fit$sampleName <- sampleName
  extend(fit, "AbstractCBS")
})


setMethodS3("print", "AbstractCBS", function(x, ...) {
  # To please R CMD check
  fit <- x

  segs <- getSegments(fit, simplify=TRUE, ...)
  print(segs)
}, protected=TRUE)




setMethodS3("all.equal", "AbstractCBS", function(target, current, check.attributes=FALSE, ...) {
  # NOTE: Here we cannot trust argument '...', because it may contain
  # copies of 'target' and 'current'
  args <- list(...)
  drop <- integer(0L)
  for (kk in seq_along(args)) {
    if (identical(args[[kk]], target)) drop <- c(drop, kk)
    if (identical(args[[kk]], current)) drop <- c(drop, kk)
  }
  if (length(drop) > 0L) {
    args <- args[-drop]
    str(args)
#    assign("...", args, inherits=FALSE)
  }
  args <- list(...)

  # Compare class attributes
  res <- all.equal(class(target), class(current))
  if (!isTRUE(res)) {
    return(res)
  }

  # Compare locus-level data
  dataT <- getLocusData(target)
  dataC <- getLocusData(current)
  res <- all.equal(dataT, dataC, check.attributes=check.attributes)
  if (!isTRUE(res)) {
    attr(res, "what") <- "getLocusData()"
    return(res)
  }

  # Compare segments
  dataT <- getSegments(target)
  dataC <- getSegments(current)
  res <- all.equal(dataT, dataC, check.attributes=check.attributes)
  if (!isTRUE(res)) {
    attr(res, "what") <- "getSegments()"
    return(res)
  }

  # Compare field names
  fieldsT <- names(target)
  fieldsC <- names(current)
  res <- all.equal(fieldsT, fieldsC, check.attributes=check.attributes)
  if (!isTRUE(res)) {
      attr(res, "what") <- "names"
    return(res)
  }

  # Compare other fields
  for (key in fieldsT) {
    dataT <- target[[key]]
    dataC <- current[[key]]
    res <- all.equal(dataT, dataC, check.attributes=check.attributes)
    if (!isTRUE(res)) {
      attr(res, "what") <- sprintf("[[\"%s\"]]", key)
      return(res)
    }
  } # for (key ...)

  return(TRUE)
}, protected=TRUE)



###########################################################################/**
# @RdocMethod getSampleName
# @aliasmethod sampleName
#
# @title "Gets the name of the sample segmented"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns a @character string.
# }
#
# @author
#
# \seealso{
#   @seemethod "setSampleName".
#   @seeclass.
# }
#*/###########################################################################
setMethodS3("getSampleName", "AbstractCBS", function(fit, ...) {
  name <- fit$sampleName
  if (is.null(name)) {
    name <- NA_character_
  }
  name
}, protected=TRUE)

setMethodS3("sampleName", "AbstractCBS", function(fit, ...) {
  getSampleName(fit)
}, protected=TRUE)


###########################################################################/**
# @RdocMethod setSampleName
# @aliasmethod sampleName<-
#
# @title "Sets the name of the sample segmented"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{name}{A @character string.}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns (invisibly) an updated object.
# }
#
# @author
#
# \seealso{
#   @seeclass.
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("setSampleName", "AbstractCBS", function(fit, name, ...) {
  # Argument 'value':
  name <- Arguments$getCharacter(name)

  fit$sampleName <- name

  invisible(fit)
}, protected=TRUE)


setMethodS3("sampleName<-", "AbstractCBS", function(x, value) {
  setSampleName(x, value)
}, protected=TRUE, addVarArgs=FALSE)

"sampleName<-" <- function(x, value) {
  UseMethod("sampleName<-")
}



###########################################################################/**
# @RdocMethod getLocusData
# @aliasmethod setLocusData
# @alias setLocusData.AbstractCBS
#
# @title "Gets the locus-level data"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Not used.}
# }
#
# \value{
#   Returns a JxL @data.frame, where J in the number of loci,
#   and L is the number of locus-specific fields.
# }
#
# @author
#
# \seealso{
#   @seeclass
# }
#*/###########################################################################
setMethodS3("getLocusData", "AbstractCBS", abstract=TRUE)

setMethodS3("setLocusData", "AbstractCBS", function(fit, loci, ...) {
  # Argument 'loci':
  loci <- Arguments$getInstanceOf(loci, "data.frame")
  nbrOfLoci <- nbrOfLoci(fit)
  if (nrow(loci) != nbrOfLoci) {
    stop("Cannot set locus-level data. The number of loci to be set differ from the existing number of loci: ", nrow(loci), " != ", nbrOfLoci)
  }

  fit$data <- loci

  invisible(fit)
}, protected=TRUE)


setMethodS3("getLocusSignalNames", "AbstractCBS", abstract=TRUE, protected=TRUE)

setMethodS3("getSegmentTrackPrefixes", "AbstractCBS", abstract=TRUE, protected=TRUE)


###########################################################################/**
# @RdocMethod nbrOfLoci
#
# @title "Gets the number of loci"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{splitters, ...}{Arguments passed to @seemethod "getLocusData".}
# }
#
# \value{
#   Returns an @integer.
# }
#
# @author
#
# \seealso{
#   @seeclass
# }
#*/###########################################################################
setMethodS3("nbrOfLoci", "AbstractCBS", function(fit, splitters=FALSE, ...) {
  data <- getLocusData(fit, splitters=splitters, ...)
  nrow(data)
})



###########################################################################/**
# @RdocMethod getSegments
# @aliasmethod setSegments
# @alias setSegments.AbstractCBS
#
# @title "Gets the segments"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Not used.}
# }
#
# \value{
#   Returns a SxK @data.frame, where S in the number of segments,
#   and K is the number of segment-specific fields.
# }
#
# @author
#
# \seealso{
#   @seeclass
# }
#*/###########################################################################
setMethodS3("getSegments", "AbstractCBS", abstract=TRUE)


setMethodS3("setSegments", "AbstractCBS", function(fit, segments, splitters=TRUE, ...) {
  # Argument 'segments':
  segments <- Arguments$getInstanceOf(segments, "data.frame")
  nbrOfSegs <- nbrOfSegments(fit, splitters=splitters, ...)
  if (nrow(segments) != nbrOfSegs) {
    stop("Cannot set segments. The number of segments to be set differ from the existing number of segments: ", nrow(segments), " != ", nbrOfSegs)
  }

  fit$output <- segments

  invisible(fit)
}, protected=TRUE)


setMethodS3("getChangePoints", "AbstractCBS", abstract=TRUE)



###########################################################################/**
# @RdocMethod resetSegments
#
# @title "Reset the segments"
#
# \description{
#   @get "title".  More precisely, it removes columns in the segmentation
#   result table that have been added by methods after the actual
#   segmentation method, e.g. bootstrap estimated mean level quantiles
#   and various calls.
#   It leave the basic segmentation results untouched,
#   i.e. the partitioning and the segment means.
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Not used.}
# }
#
# \value{
#   Returns an object if the same class as the input result.
# }
#
# @author
#
# \seealso{
#   @seeclass
# }
#*/###########################################################################
setMethodS3("resetSegments", "AbstractCBS", function(fit, ...) {
  segs <- getSegments(fit, splitters=TRUE)
  names <- colnames(segs)

  excl <- NULL

  # Drop all quantile mean level estimates (from bootstrapping)
  idxs <- grep("_[0-9.]*[%]$", names)
  excl <- c(excl, idxs)

  # Drop all calls
  idxs <- grep("Call$", names)
  excl <- c(excl, idxs)

  excl <- unique(excl)
  if (length(excl) > 0L) {
    segs <- segs[,-excl]
  }

  fit <- setSegments(fit, segs, splitters=TRUE)
  invisible(fit)
}, protected=TRUE)



###########################################################################/**
# @RdocMethod nbrOfSegments
#
# @title "Gets the number of segments"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{splitters, ...}{Arguments passed to @seemethod "getSegments".}
# }
#
# \value{
#   Returns an @integer.
# }
#
# @author
#
# \seealso{
#   @seemethod "nbrOfChangePoints"
#   @seemethod "nbrOfChromosomes"
#   @seeclass
# }
#*/###########################################################################
setMethodS3("nbrOfSegments", "AbstractCBS", function(this, splitters=FALSE, ...) {
  nrow(getSegments(this, splitters=splitters, ...))
})



###########################################################################/**
# @RdocMethod nbrOfChangePoints
#
# @title "Gets the number of change points"
#
# \description{
#   @get "title", which is defined as the number of segments minus
#   the number of chromosomes.
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Not used.}
# }
#
# \value{
#   Returns an @integer.
# }
#
# @author
#
# \seealso{
#   @seemethod "nbrOfSegments"
#   @seemethod "nbrOfChromosomes"
#   @seeclass
# }
#*/###########################################################################
setMethodS3("nbrOfChangePoints", "AbstractCBS", function(fit, ignoreGaps=FALSE, dropEmptySegments=TRUE, ...) {
  segs <- getSegments(fit, splitters=TRUE, addGaps=!ignoreGaps)
  if (dropEmptySegments) {
    prefix <- getSegmentTrackPrefixes(fit)
    keys <- sapply(prefix, FUN=function(x) {
      toCamelCase(paste(c(x, "nbr of loci"), collapse=" "))
    })
    counts <- as.matrix(segs[,keys])
    counts <- rowSums(counts, na.rm=TRUE)
    segs$chromosome[counts == 0L] <- NA
  }
  sum(!is.na(diff(segs$chromosome)))
})



###########################################################################/**
# @RdocMethod as.data.frame
#
# @title "Gets the table of segments"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns a @data.frame, where each row corresponds to
#   a unique segment.
# }
#
# @author
#
# \seealso{
#   Utilizes @seemethod "getSegments".
#   @seeclass.
# }
#*/###########################################################################
setMethodS3("as.data.frame", "AbstractCBS", function(x, ...) {
  getSegments(x, ...)
}, protected=TRUE)




###########################################################################/**
# @RdocMethod getChromosomes
#
# @title "Gets the set of chromosomes"
#
# \description{
#   @get "title" in the segmentation result.
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Arguments passed to @seemethod "getSegments".}
# }
#
# \value{
#   Returns a unique and sorted @vector of chromosomes segmented.
# }
#
# @author
#
# \seealso{
#   @seemethod "nbrOfChromosomes".
#   @seeclass
# }
#*/###########################################################################
setMethodS3("getChromosomes", "AbstractCBS", function(this, ...) {
  segs <- getSegments(this, ...)
  chromosomes <- sort(unique(segs$chromosome), na.last=TRUE)

  # Drop NA dividers
  if (length(chromosomes) > 1) {
    chromosomes <- chromosomes[!is.na(chromosomes)]
  }

  chromosomes
})


###########################################################################/**
# @RdocMethod nbrOfChromosomes
#
# @title "Gets the number of chromosomes"
#
# \description{
#   @get "title".
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Arguments passed to @seemethod "getChromosomes".}
# }
#
# \value{
#   Returns an @integer.
# }
#
# @author
#
# \seealso{
#   @seemethod "getChromosomes".
#   @seeclass
# }
#*/###########################################################################
setMethodS3("nbrOfChromosomes", "AbstractCBS", function(this, ...) {
  length(getChromosomes(this, ...))
})


setMethodS3("getSegmentSizes", "AbstractCBS", function(fit, by=c("length", "count"), ...) {
  by <- match.arg(by)

  if (by == "length") {
    prefix <- getSegmentTrackPrefixes(fit)[1]
    keys <- toCamelCase(paste(prefix, " ", c("start", "end")))
  } else if (by == "count") {
    keys <- "nbrOfLoci"
  }
  data <- getSegments(fit, ...)[,keys]

  if (by == "length") {
    res <- data[[2L]]-data[[1L]]+1L
  } else if (by == "count") {
    res <- data[[1L]]
  }
  res
})


setMethodS3("extractCNs", "AbstractCBS", abstract=TRUE)

setMethodS3("sampleCNs", "AbstractCBS", function(fit, size=NULL, ...) {
  data <- extractCNs(fit, ...)

  if (!is.null(size)) {
    sizes <- getSegmentSizes(fit, ...)
    # Sanity check
    .stop_if_not(length(sizes) == nrow(data))
    idxs <- sample(nrow(data), size=size, replace=TRUE, prob=sizes)
    data <- data[idxs,,drop=FALSE]
  }

  data
})

###########################################################################/**
# @RdocMethod updateMeans
# @alias updateMeans.CBS
# @alias updateMeans.NonPairedPSCBS
# @alias updateMeans.PairedPSCBS
#
# @title "Updates the CN mean levels for each segment independently"
#
# \description{
#  @get "title" as if they were one large segment.
#  The locus-level data is not updated/modified.
# }
#
# @synopsis
#
# \arguments{
#  \item{...}{Arguments specific to the class.}
# }
#
# \value{
#   Returns an object of the same class.
# }
#
# @author
#
# @keyword internal
#*/###########################################################################
setMethodS3("updateMeans", "AbstractCBS", abstract=TRUE, protected=TRUE)


setMethodS3("getMeanEstimators", "AbstractCBS", function(fit, which=NULL, default=mean, ...) {
  estList <- fit$params$meanEstimators
  if (is.null(estList)) {
    estList <- list()
  }

  if (is.null(which)) which <- names(estList)

  for (key in which) {
    fcn <- estList[[key]]
    if (is.null(fcn)) {
      fcn <- default
    } else if (is.character(fcn)) {
      fcn <- get(fcn, mode="function")
    }
    estList[[key]] <- fcn
  }

  estList
}, protected=TRUE)


setMethodS3("setMeanEstimators", "AbstractCBS", function(fit, ...) {
  estList <- fit$params$meanEstimators
  if (is.null(estList)) {
    estList <- list()
  }

  args <- list(...)

  # Nothing todo?
  if (length(args) == 0L) {
    return(invisible(fit))
  }

  keys <- names(args)
  if (is.null(keys)) {
    stop("Estimators arguments must be named.")
  }

  for (key in keys) {
    fcn <- args[[key]]
    if (is.function(fcn)) {
    } else if (is.character(fcn)) {
      if (!exists(fcn, mode="function")) {
        stop(sprintf("No such '%s' estimator function: %s", key, fcn))
      }
    } else {
      stop(sprintf("Estimator argument '%s' must be a function or character string: %s", key, mode(fcn)))
    }
    estList[[key]] <- fcn
  }

  fit$params$meanEstimators <- estList

  invisible(fit)
}, protected=TRUE)


setMethodS3("resegment", "AbstractCBS", abstract=TRUE, protected=TRUE)


setMethodS3("getChromosomeRanges", "AbstractCBS", abstract=TRUE, protected=TRUE)

setMethodS3("getChromosomeOffsets", "AbstractCBS", function(fit, resolution=1e6, ...) {
  # Argument 'resolution':
  if (!is.null(resolution)) {
    resolution <- Arguments$getDouble(resolution, range=c(1,Inf))
  }

  data <- getChromosomeRanges(fit, ...)
  splits <- data[,"start"] + data[,"length"]

  if (!is.null(resolution)) {
    splits <- ceiling(splits / resolution)
    splits <- resolution * splits
  }

  offsets <- c(0L, cumsum(splits))
  names(offsets) <- c(rownames(data), NA)

  offsets
}, protected=TRUE) # getChromosomeOffsets()



###########################################################################/**
# @RdocMethod ploidy
# @aliasmethod ploidy<-
# @aliasmethod setPloidy
# @aliasmethod adjustPloidyScale
# @alias adjustPloidyScale.PairedPSCBS
# @alias adjustPloidyScale
# @alias ploidy
# @alias ploidy<-
# @alias setPloidy
#
# @title "Gets and sets ploidy"
#
# \description{
#  @get "title".
# }
#
# \usage{
#   \method{ploidy}{AbstractCBS}(fit, ...)
#   \method{ploidy}{AbstractCBS}(fit) <- value
# }
#
# \arguments{
#   \item{fit}{An @see "AbstractCBS" object.}
#   \item{value}{An @integer (in \eqn{1,2,\ldots}) specifying the genome ploidy .}
#   \item{...}{Not used.}
# }
#
# \value{
#   Returns (invisibly) an updated object.
# }
#
# @author
#
# \seealso{
#   @seeclass.
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("ploidy", "AbstractCBS", function(fit, ...) {
  ploidy <- fit$params$ploidy
  if (is.null(ploidy)) ploidy <- 2L
  ploidy
})

setMethodS3("ploidy<-", "AbstractCBS", function(fit, value) {
  fit <- setPloidy(fit, ploidy=value, update=TRUE)
  invisible(fit)
})

"ploidy<-" <- function(fit, value) {
  UseMethod("ploidy<-")
}

setMethodS3("setPloidy", "AbstractCBS", function(fit, ploidy=2L, update=TRUE, ...) {
  # Argument 'ploidy':
  ploidy <- Arguments$getInteger(ploidy, range=c(1,Inf))

  if (update) {
    # Calculate rescaling factor
    oldPloidy <- ploidy(fit)
    scale <- ploidy / oldPloidy

    # Nothing todo?
    if (scale != 1) {
      fit <- adjustPloidyScale(fit, scale=scale, ...)
    }
  }

  fit$params$ploidy <- ploidy
  invisible(fit)
}, protected=TRUE)


setMethodS3("adjustPloidyScale", "AbstractCBS", abstract=TRUE)


###########################################################################/**
# @RdocMethod normalizeTotalCNs
# @alias normalizeTotalCNs
# @alias normalizeTotalCNs.PSCBS
#
# @title "Normalizes copy numbers such that the whole-genome average total copy number is two"
#
# \description{
#  @get "title".
# }
#
# @synopsis
#
# \arguments{
#   \item{...}{Additional arguments passed to the normalization method.}
# }
#
# \value{
#   Returns a normalized AbstractCBS object of the same class as \code{fit}.
# }
#
# @author
#
# \seealso{
#   @seeclass.
# }
#*/###########################################################################
setMethodS3("normalizeTotalCNs", "AbstractCBS", abstract=TRUE)

.setupCacheRootPath <- function(...) {
  # Setup the cache root path, possibly by prompting the user.
  ns <- getNamespace("R.cache")
  setupCacheRootPath <- get("setupCacheRootPath", mode="function", envir=ns)
  setupCacheRootPath()
} # .setupCacheRootPath()

# CRAN POLICY: Add precalculated memoization files to the R.cache
# directory, unless running interactively.  The reason for doing this
# is solely to make segmentBy[Non]PairedPSCBS examples to run faster
# on R CMD check but not having to create these memoized files.
# /HB 2012-11-05
# UPDATE: Now it will also gain first-time users. /HB 2013-09-27
.prememoize <- function(verbose=FALSE) {
  # Explictly setup cache root here, since it's only done by 'R.cache'
  # if that package is attached.  Here we only load it. /HB 2013-09-27
  .setupCacheRootPath()

  # This will make sure that the pre-generated calculations available
  # in the 'PSCBS' package are copied to the R.cache cache directory.
  # This regardless of whether a 'PSCBS' cache subdirectory exists
  # or not. /HB 2013-09-27
  path <- "PSCBS/segmentByCBS/sbdry"
  pathS <- system.file("misc/_Rcache", path, package="PSCBS")
  pathD <- getCachePath(path)
  copyDirectory(pathS, pathD, copy.mode=FALSE, recursive=FALSE, overwrite=TRUE)
  if (verbose) {
    message("Added pre-memoized calculations: ", getAbsolutePath(pathD))
  }
} # .prememoize()

setMethodS3("extractSegmentDataByLocus", "PairedPSCBS", function(fit, fields=NULL, ..., verbose=FALSE) {
  # Extract data
  segs <- getSegments(fit, splitters=TRUE)
  data <- getLocusData(fit, ...)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'fields':
  if (!is.null(fields)) {
    fields <- Arguments$getCharacters(fields)
    unknown <- fields[!is.element(fields, colnames(segs))]
    if (length(unknown) > 0L) {
      stop("Unknown segment fields: ", paste(sQuote(unknown), collapse=", "))
    }
  } else {
    fields <- colnames(segs)
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Extracting segment data by locus")

  # Extract segment fields
  chromosome <- data$chromosome
  x <- data$x
  y <- data[,3L]
  segs <- segs[,fields]
  nbrOfLoci <- nrow(data)

  verbose && printf(verbose, "Segment fields: [%d] %s\n", length(fields), paste(sQuote(fields), collapse=", "))
  verbose && cat(verbose, "Number of loci: ", nbrOfLoci)

  # Allocate segment fields at the locus level
  dataL <- matrix(NA, nrow=nbrOfLoci, ncol=length(fields))
  colnames(dataL) <- fields
  dataL <- as.data.frame(dataL)

  verbose && cat(verbose, "Allocated results:")
  verbose && str(verbose, dataL)

  verbose && enter(verbose, "Extracting segment by segment")

  # For each segment...
  for (ss in seq_len(nrow(segs))) {
    verbose && enter(verbose, sprintf("Segment %d of %d", ss, nrow(segs)))
    seg <- segs[ss,]
    idxs <- which(chromosome == seg$chromosome &
                  seg$tcnStart <= x & x <= seg$tcnEnd)
    idxs <- Arguments$getIndices(idxs, max=nbrOfLoci)
    verbose && cat(verbose, "Number of loci in segment: ", length(idxs))
    # Sanity check
##    .stop_if_not(length(idxs) == seg$tcnNbrOfLoci)

    segsSS <- seg[fields]
    verbose && cat(verbose, "Segment data extracted:")
    verbose && print(verbose, segsSS)

    for (field in fields) {
      dataL[idxs,field] <- segsSS[[field]]
    }
    verbose && exit(verbose)
  } # for (ss ...)
  verbose && exit(verbose)

  # The calls for loci that have missing annotations or observations,
  # should also be missing, i.e. NA.
  nok <- (is.na(chromosome) | is.na(x) | is.na(y))
  dataL[nok,] <- NA

  # Sanity check
  .stop_if_not(nrow(dataL) == nbrOfLoci)
  .stop_if_not(ncol(dataL) == length(fields))

  verbose && exit(verbose)

  dataL
}, protected=TRUE) # extractSegmentDataByLocus()



##############################################################################
# HISTORY
# 2013-10-27
# o Added extractSegmentDataByLocus() for PairedPSCBS adopted from
#   extractCallsByLocus() of 'PSCBS'.
##############################################################################

setMethodS3("drawLevels", "DNAcopy", function(fit, field=c("seg.mean", "tcn.mean", "dh.mean"), xScale=1, col="red", lwd=3, ...) {
  field <- match.arg(field)
  segments <- fit$output[,c("loc.start", "loc.end", field)]
  apply(segments, MARGIN=1, FUN=function(seg) {
    x <- c(seg[["loc.start"]], seg[["loc.end"]])
    y <- rep(seg[[field]], times=2)
    lines(x=xScale*x, y=y, col=col, lwd=lwd, ...)
  })
})

###########################################################################/**
# @RdocDocumentation "Non-documented objects"
#
# % Other missing docs
# @eval "t <- readLines('../incl/999.missingdocs.txt'); t <- trim(unlist(strsplit(t, split=' '))); t <- t[nchar(t) > 0]; t2 <- gsub('\\[', '\\\\[', t); t <- unique(t); t <- sprintf('\\alias{%s}', t); paste(t, collapse='\n')"
#
# \description{
#   This page contains aliases for all "non-documented" objects that 
#   \code{R CMD check} detects in this package. 
#
#   Almost all of them are \emph{generic} functions that have specific 
#   document for the corresponding method coupled to a specific class. 
#   Other functions are re-defined by \code{setMethodS3()} to 
#   \emph{default} methods. Neither of these two classes are non-documented
#   in reality.
#   The rest are deprecated methods.
# }
#
# @author
#
# @keyword internal
#*/###########################################################################

###########################################################################/**
# @set "class=CBS"
# @RdocMethod plotTracks
#
# @title "Plots copy numbers along the genome"
#
# \description{
#  @get "title" for one or more chromosomes.
#  Each type of track is plotted in its own panel.
# }
#
# @synopsis
#
# \arguments{
#   \item{x}{A result object returned by @see "segmentByCBS".}
#   \item{pch}{The type of points to use.}
#   \item{Clim}{The range of copy numbers.}
#   \item{xScale}{The scale factor used for genomic positions.}
#   \item{...}{Not used.}
#   \item{add}{If @TRUE, the panels plotted are added to the existing plot,
#     otherwise a new plot is created.}
# }
#
# \value{
#   Returns nothing.
# }
#
# @author "HB"
#
# @keyword IO
# @keyword internal
#*/###########################################################################
setMethodS3("plotTracks", "CBS", function(x, scatter=TRUE, pch=20, col="gray", meanCol="purple", cex=1, grid=FALSE, Clim="auto", xScale=1e-6, Clab="auto", ..., byIndex=FALSE, mar=NULL, add=FALSE) {
  # To please R CMD check
  fit <- x


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'add':
  add <- Arguments$getLogical(add)

  # Argument 'Clim':
  if (identical(Clim, "auto")) {
    signalType <- getSignalType(fit)
    ploidy <- ploidy(fit)
    Clim <- switch(signalType,
      "log2ratio" = c(-2,2) + c(-1,1)*ploidy/2,
      "ratio"     = c(0,3*ploidy),
      {
        x_name <- as.character(substitute(x))
        warning(sprintf("Setting default 'Clim' assuming the signal type is %s because signalType(%s) is unknown (%s). Use signalType(%s) <- %s to avoid this warning.", sQuote("ratio"), x_name, sQuote(signalType), x_name, sQuote("ratio")))
        c(0, 3 * ploidy)
      }
    )
##  NOTE: Don't understand why, but with this 'R CMD build' gives:
##    "Error: processing vignette 'CBS.tex.rsp' failed with diagnostics:
##     Failed to infer argument 'Clim' due to an unknown signalType(): NA"
##  /HB 2013-10-14
##  if (!add && is.null(Clim)) {
##    stop("Failed to infer argument 'Clim' due to an unknown signalType(): ", signalType)
##  }
  } else if (!add) {
    Clim <- Arguments$getNumerics(Clim, length=c(2L,2L),
                                        disallow=c("Inf", "NA", "NaN"))
  }

  if (identical(Clab, "auto")) {
    signalType <- getSignalType(fit)
    Clab <- switch(signalType,
      "log2ratio" = "log2 CN ratio",
      "ratio"     = "CN ratio",
      NULL
    )
  }

  # Argument 'fit':
  if (nbrOfChromosomes(fit) > 1L) {
    res <- plotTracksManyChromosomes(fit, scatter=scatter, pch=pch, col=col, cex=cex, meanCol=meanCol, Clim=Clim, xScale=xScale, Clab=Clab, ..., byIndex=byIndex, mar=mar, add=add)
    return(invisible(res))
  }

  # Argument 'xScale':
  xScale <- Arguments$getNumeric(xScale, range=c(0,Inf))

  # Extract the input data
  data <- getLocusData(fit)
  if (is.null(data)) {
    stop("Cannot plot segmentation results. No input data available.")
  }

  chromosomes <- getChromosomes(fit)
  chromosome <- chromosomes[1]
  x <- data$x
  CT <- data[,3]
  nbrOfLoci <- length(x)

  # Extract the segmentation
  segs <- getSegments(fit)


  if (chromosome != 0) {
    chrTag <- sprintf("Chr%02d", chromosome)
  } else {
    chrTag <- ""
  }

  if (xScale != 1) {
    x <- xScale * x
  }

  if (!add && !is.null(mar)) {
    par(mar=mar)
  }


  pchT <- if (scatter) { pch } else { NA }

  plot(x, CT, pch=pchT, cex=cex, col=col, ..., ylim=Clim, ylab=Clab)
  stext(side=3, pos=1, chrTag)
  if (grid) {
    yrange <- par("usr")[3:4]
    yrange[1] <- floor(yrange[1])
    yrange[2] <- ceiling(yrange[2])
    abline(h=seq(from=yrange[1], to=yrange[2], by=2), lty=3, col="gray")
    abline(h=0, lty=1, col="black")
  }
  drawLevels(fit, col=meanCol, xScale=xScale)

  invisible()
}) # plotTracks()


setMethodS3("plot", "CBS", function(x, ...) {
  plotTracks(x, ...)
}, protected=TRUE)


setMethodS3("drawLevels", "CBS", function(fit, col="purple", xScale=1e-6, byIndex=FALSE, ...) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- tileChromosomes(fit)

  # Get segmentation results
  segs <- as.data.frame(fitT)

  # Extract subset of segments
  fields <- c("start", "end", "mean")
  segs <- segs[,fields, drop=FALSE]
  segs <- unique(segs)

  # Reuse drawLevels() for the DNAcopy class
  colnames(segs) <- c("loc.start", "loc.end", "seg.mean")
  dummy <- list(output=segs)
  class(dummy) <- "DNAcopy"
  drawLevels(dummy, col=col, xScale=xScale, ...)
}, protected=TRUE)


setMethodS3("highlightCalls", "CBS", function(fit, pch=20, callCols=c(loss="red", gain="green", "amplification"="blue"), lwd=3, meanCol="purple", ..., xScale=1e-6, byIndex=FALSE, verbose=FALSE) {
  segs <- getSegments(fit, splitter=FALSE)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Identify segment calls
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  callFields <- grep("Call$", colnames(segs))
  callTypes <- gsub("Call$", "", colnames(segs)[callFields])
  nbrOfCalls <- length(callFields)

  # Nothing todo?
  if (nbrOfCalls == 0L) {
    return()
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- tileChromosomes(fit)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Highlight threshold levels
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  params <- fit$params$callGainsAndLosses
  abline(h=params$muR, col="gray", lty=3)
  abline(h=params$tauLoss, col=callCols["loss"], lty=3)
  abline(h=params$tauGain, col=callCols["gain"], lty=3)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Highlight gains and losses
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  dataT <- getLocusData(fitT)
  segsT <- getSegments(fitT, splitter=FALSE)
  chr <- dataT[,"chromosome"]
  x <- dataT[,"x"]
  y <- dataT[,3]
  nbrOfLoci <- nbrOfLoci(fitT)
  nbrOfSegments <- nbrOfSegments(fitT)
  # Not needed anymore
  dataT <- NULL

  # For each non-neutral segment
  for (ss in seq_len(nbrOfSegments)) {
    seg <- segsT[ss,]

    for (tt in seq_along(callTypes)) {
      field <- callFields[tt]
      type <- callTypes[tt]

      # Called?
      call <- seg[[field]]
      if (isTRUE(call)) {
        col <- callCols[type]
        idxs <- which(chr == seg$chromosome & seg$start <= x & x <= seg$end)
        idxs <- Arguments$getIndices(idxs, max=nbrOfLoci)

        if (byIndex) {
          xs <- idxs
        } else {
          xs <- x[idxs] * xScale
        }
        ys <- y[idxs]
        points(xs, ys, pch=pch, col=col, ...)
        xx <- range(xs, na.rm=TRUE)
        yy <- rep(seg$mean, times=2)
        lines(xx, yy, lwd=lwd, col=meanCol)
      }
    } # for (tt ...)
  } # for (ss ...)
}, protected=TRUE) # highlightCalls()



setMethodS3("highlightLocusCalls", "CBS", function(fit, callPchs=c(negOutlier=25, posOutlier=24), callCols=c(negOutlier="blue", posOutlier="blue"), ..., xScale=1e-6, byIndex=FALSE, verbose=FALSE) {
  data <- getLocusData(fit)

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Identify segment calls
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  callFields <- grep("Call$", colnames(data))
  callTypes <- gsub("Call$", "", colnames(data)[callFields])
  nbrOfCalls <- length(callFields)

  # Nothing todo?
  if (nbrOfCalls == 0) {
    return()
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- tileChromosomes(fit)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Highlight gains and losses
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  dataT <- getLocusData(fitT)
  chr <- dataT[,"chromosome"]
  x <- dataT[,"x"]
  y <- dataT[,3]
  nbrOfLoci <- nbrOfLoci(fitT)

  # For each non-neutral segment
  for (tt in seq_along(callTypes)) {
    field <- callFields[tt]
    type <- callTypes[tt]

    isCalled <- dataT[[field]]
    idxs <- which(isCalled)

    if (length(idxs) == 0L) {
      next
    }

    if (byIndex) {
      xs <- idxs
    } else {
      xs <- x[idxs] * xScale
    }
    ys <- y[idxs]
    pch <- callPchs[type]
    col <- callCols[type]
    points(xs, ys, pch=pch, col=col, ...)
  } # for (tt ...)
}, protected=TRUE) # highlightLocusCalls()




setMethodS3("drawChromosomes", "CBS", function(x, lty=3, xScale=1e-6, ..., byIndex=FALSE, verbose=FALSE) {
  # To please R CMD check
  fit <- x

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'fit':

  # Argument 'xScale':
  xScale <- Arguments$getNumeric(xScale, range=c(0,Inf))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- tileChromosomes(fit)
  # Sanity check
  .stop_if_not(!is.null(fitT$chromosomeStats))

  chrStats <- fitT$chromosomeStats
  chrStats <- chrStats[-nrow(chrStats),,drop=FALSE]
  chrRanges <- as.matrix(chrStats[,c("start","end")])
  vs <- xScale * chrRanges
  mids <- (vs[,1]+vs[,2])/2
  chromosomes <- getChromosomes(fitT)
  chrLabels <- sprintf("%02d", chromosomes)
  side <- rep(c(1,3), length.out=length(chrLabels))
  mtext(text=chrLabels, side=side, at=mids, line=0.1, cex=0.7*par("cex"))
  abline(v=vs, lty=lty)
}, protected=TRUE) # drawChromosomes()



setMethodS3("drawCentromeres", "CBS", function(fit, genomeData, what=c("start", "end"), xScale=1e-6, col="gray", lty=3, ..., byIndex=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'genomeData':
  .stop_if_not(inherits(genomeData, "data.frame"))
  .stop_if_not(is.element("chromosome", colnames(genomeData)))
  .stop_if_not(is.element("centroStart", colnames(genomeData)))
  .stop_if_not(is.element("centroEnd", colnames(genomeData)))

  # Calculate the midpoints of the centromeres
  colnames(genomeData) <- tolower(gsub("centro", "", colnames(genomeData)))
  genomeData$mid <- (genomeData$start + genomeData$end) / 2

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fitT <- tileChromosomes(fit)
  # Sanity check
  .stop_if_not(!is.null(fitT$chromosomeStats))

  chrStats <- fitT$chromosomeStats
  offsets <- chrStats[,"start"] - chrStats[1,"start"]

  # Centroid locations in the tiled space
  offsetsT <- offsets[seq_len(nrow(genomeData))]

  xx <- genomeData[,what,drop=FALSE]
  xx <- as.matrix(xx)
  xx <- offsetsT + xx

  ats <- xScale * xx
  for (cc in seq_len(ncol(xx))) {
    abline(v=ats[,cc], col=col, lty=lty, ...)
  }

  invisible(ats)
}, protected=TRUE) # drawCentromeres()


setMethodS3("highlightArmCalls", "CBS", function(fit, genomeData, minFraction=0.95, callCols=c("loss"="red", "gain"="green"),   xScale=1e-6, ...) {
  # To please/trick R CMD check
  chromosome <- x <- NULL; rm(list=c("chromosome", "x"))

  callStats <- callArms(fit, genomeData=genomeData, minFraction=minFraction)

  callTypes <- grep("Fraction", colnames(callStats), value=TRUE)
  callTypes <- gsub("Fraction", "", callTypes)

  callTypes <- intersect(callTypes, c("loss", "gain"))

  # Adjust (start, end)
  offsets <- getChromosomeOffsets(fit)
  offsets <- offsets[callStats[,"chromosome"]]
  callStats[,c("start","end")] <- offsets + callStats[,c("start","end")]

  nbrOfRegions <- nrow(callStats)

  # Nothing todo?
  if (nbrOfRegions == 0) {
    return(invisible(callStats))
  }


  usr <- par("usr")
  dy <- diff(usr[3:4])
  yy <- usr[3]+c(0,0.05*dy)
  abline(h=usr[3]+0.95*0.05*dy, lty=1, col="gray")

  xx <- callStats[,c("start", "end")]
  xx <- as.matrix(xx)
  xx <- xx * xScale

  for (type in callTypes) {
    col <- callCols[type]
    keyA <- sprintf("%sFraction", type)
    keyB <- sprintf("%sCall", type)
    for (kk in seq_len(nbrOfRegions)) {
      xs <- xx[kk,]
      score <- callStats[kk, keyA]
      if (is.finite(score) && score > 0) {
        ys <- rep(yy[1]+callStats[kk, keyA]*0.05*dy, times=2)
        lines(x=xs, y=ys, col=col)
        call <- callStats[kk, keyB]
        if (call) {
          rect(xs[1], yy[1], xs[2], yy[2], col=col, border=NA)
        }
      }
    }
  } # for (type ...)

  invisible(callStats)
}, protected=TRUE) # highlightArmCalls()

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## DEPRECATED
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## DEFUNCT
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -



##############################################################################
# HISTORY
# 2015-02-22
# o CLEANUP: bootstrapDHByRegion() is defunct (was deprecated since 2013).
# 2013-04-20
# o CLEANUP: Formally deprecated bootstrapDHByRegion().
# 2013-01-15
# o Now bootstrapDHByRegion() uses the params$avgDH estimator, iff given.
# 2012-02-24
# o Added argument 'force' to bootstrapDHByRegion().
# 2011-06-14
# o Updated code to recognize new column names.
# 2010-11-22
# o DEPRECATED: bootstrapDHByRegion() should no longer be used.
# 2010-11-03 [HB]
# o ROBUSTNESS: Now bootstrapDHByRegion() uses resample() of R.utils.
# 2010-11-01 [HB]
# o Now bootstrapDHByRegion() estimates more quantiles.
# o BUG FIX: bootstrapDHByRegion() would give an error if only a single
#   quantile was requested.
# o BUG FIX: bootstrapDHByRegion() would give "Error in if (nbrOfUnits >
#   segJJ[, "dh.num.mark"]) { : missing value where TRUE/FALSE needed" when
#   'dh.num.mark' was NA.
# 2010-10-25 [HB]
# o BUG FIX: Now bootstrapDHByRegion() for PairedPSCBS handles the rare case
#   when markers with the same positions are split in two different segments.
# o BUG FIX: bootstrapDHByRegion() for PairedPSCBS would bootstrap from the
#   incorrect set of loci when the DH region contained only one locus.
# o BUG FIX: bootstrapDHByRegion() for PairedPSCBS would bootstrap from the
#   incorrect set of loci if more than one chromosome was available.
# 2010-09-16 [HB]
# o Added bootstrapDHByRegion(), which is what is used by paired PSCBS.
# o Created.
##############################################################################

#   \item{chromosomes}{An optional @numeric @vector specifying which
#     chromosomes to plot.}
#
#   \item{seed}{An (optional) @integer specifying the random seed to be
#     set before subsampling.  The random seed is
#     set to its original state when exiting.  If @NULL, it is not set.}
#
#   \item{verbose}{See @see "R.utils::Verbose".}
#
setMethodS3("plotTracksManyChromosomes", "PairedPSCBS", function(fit, chromosomes=getChromosomes(fit), tracks=NULL, scatter="*", calls=if (callLoci || length(chromosomes) == 1L) ".*" else NULL, callLoci=FALSE, callThresholds=TRUE, boundaries=TRUE, knownSegments=FALSE, quantiles=c(0.05,0.95), seed=0xBEEF, pch=".", Clim=c(0,3*ploidy(fit)), Blim=c(0,1), xScale=1e-6, xlabTicks=if (length(chromosomes) == 1L) "[pos]" else "[chr]", ..., subset=if (length(chromosomes) > 1L) 0.1 else NULL, add=FALSE, subplots=!add && (length(tracks) > 1L), oma=c(0,0,2,0), mar=c(2,5,1,3)+0.1, onBegin=NULL, onEnd=NULL, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Local functions
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  attachGH <- function(gh, envir=parent.frame()) {
    if (!is.list(gh)) return()
    if (is.null(gh$track)) return()
    if (!is.null(value <- gh$track)) assign("track", value, envir=envir)
    if (!is.null(value <- gh$subtracks)) assign("trackT", value, envir=envir)
    if (!is.null(value <- gh$scatter$col)) assign("colS", value, envir=envir)
    if (!is.null(value <- gh$scatter$pch)) assign("pchT", value, envir=envir)
    if (!is.null(value <- gh$level$col)) assign("colL", value, envir=envir)
    if (!is.null(value <- gh$cis$col)) assign("colC", value, envir=envir)
  } # attachGH()


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Graphical styles
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  opts <- list(
    scatter = list(pch=".", col=c("#aaaaaa")),
    callScatter = list(col=c("#aaaaaa", LOSS="blue", GAIN="red", LOH="purple")),
    smoothScatter = list(pch=".", col=c("#666666")),
    level = list(lty=1L, col=c("black", tcn="purple", c1="blue", c2="red", dh="orange")),
    callLevel = list(lty=1L, col=c("#666666")),
    knownSegment = list(lty=1L, col=c("#aaaaaa"))
  )

  getOptionValue <- function(option, what, track, ...) {
    values <- opts[[option]][[what]]
    value <- values[track]
    if (is.na(value)) value <- values[1L]
    unname(value)
  } # getOptionValue()

  getScatterColor <- function(track, ...) {
    getOptionValue("scatter", "col", track, ...)
  } # getScatterColor()

  getLevelColor <- function(track, ...) {
    getOptionValue("level", "col", track, ...)
  } # getLevelColor()

  getCallScatterColor <- function(track, ...) {
    getOptionValue("callScatter", "col", track, ...)
  } # getCallScatterColor()

  getCallLevelColor <- function(track, ...) {
    getOptionValue("callLevel", "col", track, ...)
  } # getCallLevelColor()

  getCallLevelLty <- function(track, ...) {
    getOptionValue("callLevel", "lty", track, ...)
  } # getCallLevelColor()

  getCIColor <- function(track, ...) {
    getLevelColor(track, ...)
  } # getLevelColor()

  getKnownSegmentColor <- function(track, ...) {
    getOptionValue("knownSegment", "col", track, ...)
  } # getKnownSegmentColor()

  getKnownSegmentLty <- function(track, ...) {
    getOptionValue("knownSegment", "lty", track, ...)
  } # getKnownSegmentColor()

  drawXLabelTicks <- function() {
    if (identical(xlabTicks, "[chr]")) {
      mtext(text=chrTags, side=rep(c(1,3), length.out=length(chrTags)), at=mids, line=0.1, cex=0.7)
    } else if (identical(xlabTicks, "[pos]")) {
      axis(side=1L)
    }
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'fit':

  # Argument 'chromosomes':
  if (!is.null(chromosomes)) {
    disallow <- c("NaN", "Inf")
    chromosomes <- Arguments$getIntegers(chromosomes, range=c(0,Inf), disallow=disallow)
    .stop_if_not(all(is.element(chromosomes, getChromosomes(fit))))
  }

  # Argument 'tracks':
  knownTracks <- c("tcn", "dh", "tcn,c1,c2", "c1,c2", "c1", "c2",
                   "betaN", "betaT", "betaTN")
  defaultTracks <- knownTracks[1:3]
  if (is.null(tracks)) {
    tracks <- defaultTracks
  } else {
    tracks <- match.arg(tracks, choices=knownTracks, several.ok=TRUE)
    tracks <- unique(tracks)
  }

  # Argument 'scatter':
  if (!is.null(scatter)) {
    scatter <- Arguments$getCharacter(scatter)
    if (scatter == "*") {
      scatter <- tracks
    } else {
      scatterT <- strsplit(scatter, split=",", fixed=TRUE)
      tracksT <- strsplit(tracks, split=",", fixed=TRUE)
      .stop_if_not(all(is.element(scatterT, tracksT)))
      # Not needed anymore
      scatterT <- tracksT <- NULL
    }
  }

  # Argument 'calls':
  if (!is.null(calls)) {
    calls <- sapply(calls, FUN=Arguments$getRegularExpression)
  }

  # Argument 'callLoci':
  callLoci <- Arguments$getLogical(callLoci)

  # Argument 'callThresholds':
  callThresholds <- Arguments$getLogical(callThresholds)

  # Argument 'boundaries':
  boundaries <- Arguments$getLogical(boundaries)

  # Argument 'knownSegments':
  knownSegments <- Arguments$getLogical(knownSegments)

  # Argument 'add':
  add <- Arguments$getLogical(add)

  # Argument 'Clim' & 'Blim':
  if (!add) {
    Clim <- Arguments$getNumerics(Clim, length=c(2L,2L),
                                        disallow=c("Inf", "NA", "NaN"))
    Blim <- Arguments$getNumerics(Blim, length=c(2L,2L),
                                        disallow=c("Inf", "NA", "NaN"))
  }

  # Argument 'xScale':
  xScale <- Arguments$getNumeric(xScale, range=c(0,Inf))

  # Argument 'xlabTicks':
  if (!is.null(xlabTicks)) {
    xlabTicks <- Arguments$getCharacter(xlabTicks)
  }

  # Argument 'subset':
  if (!is.null(subset)) {
    subset <- Arguments$getDouble(subset)
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Plotting PSCN tracks")

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Subset by chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (!is.null(chromosomes)) {
    verbose && enter(verbose, "Plotting a subset of the chromosomes")
    fit <- extractChromosomes(fit, chromosomes=chromosomes, verbose=verbose)
    verbose && exit(verbose)
  }

  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Tile chromosomes
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  fit <- tileChromosomes(fit, verbose=verbose)
  verbose && str(verbose, fit)

  # Extract the input data
  data <- getLocusData(fit)
  if (is.null(data)) {
    stop("Cannot plot segmentation results. No input data available.")
  }

  # Extract the segmentation
  segs <- as.data.frame(fit)

  # Identify available calls
  callData <- NULL
  if (!is.null(calls) || callThresholds) {
    verbose && enter(verbose, "Identifying calls")

    pattern <- "Call$"
    allCallColumns <- grep(pattern, colnames(segs), value=TRUE)
    allCallLabels <- toupper(gsub(pattern, "", allCallColumns))
    verbose && cat(verbose, "Call columns:")
    verbose && print(verbose, allCallColumns)

    if (!is.null(calls)) {
      callColumns <- allCallColumns
      if (length(callColumns) > 0L) {
        keep <- sapply(calls, FUN=function(pattern) {
          (regexpr(pattern, callColumns) != -1L)
        })
        if (is.matrix(keep)) {
          keep <- rowAnys(keep, useNames=FALSE)
        }
        callColumns <- callColumns[keep]
        callLabels <- allCallLabels[keep]

        # Annotate individual loci by calls?
        if (callLoci) {
          callData <- extractCallsByLocus(fit, verbose=less(verbose,5))
        }
      }
      verbose && cat(verbose, "Call to be annotated:")
      verbose && print(verbose, callColumns)
    }

    verbose && exit(verbose)
  }


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Subset of the loci?
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  if (!is.null(subset)) {
    # (a) Set and unset the random seed
    if (!is.null(seed)) {
      randomSeed("set", seed=seed, kind="L'Ecuyer-CMRG")
      on.exit(randomSeed("reset"), add=TRUE)
      verbose && printf(verbose, "Random seed temporarily set (seed=%d)\n", seed)
    }

    # (b) Subset
    n <- nrow(data)
    keep <- sample(n, size=subset*n)
    data <- data[keep,]
    if (!is.null(callData)) {
      callData <- callData[keep,]
    }
  }

  # To please R CMD check
  CT <- rho <- muN <- betaT <- betaN <- betaTN <- rho <- NULL
  rm(list=c("CT", "rho", "muN", "betaT", "betaN", "betaTN"))
  attachLocally(data)
  # Calculate (C1,C2)
  C1 <- 1/2*(1-rho)*CT
  C2 <- CT - C1

  # BACKWARD COMPATIBILITY:
  # If 'rho' is not available, recalculate it from tumor BAFs.
  # NOTE: This should throw an error in the future. /HB 2013-10-25
  if (is.null(data$rho)) {
    isSnp <- (!is.na(betaTN) & !is.na(muN))
    isHet <- isSnp & (muN == 1/2)
    rho <- rep(NA_real_, times=nbrOfLoci)
    rho[isHet] <- 2*abs(betaTN[isHet]-1/2)
    warning(sprintf("Locus-level DH signals ('rho') were not available in the %s object and therefore recalculated from the TumorBoost-normalized tumor BAFs ('betaTN').", class(fit)[1L]))
  }

  x <- xScale * x
  vs <- xScale * fit$chromosomeStats[,1:2,drop=FALSE]
  mids <- (vs[,1]+vs[,2])/2

  nbrOfLoci <- length(x)
  chrTags <- sprintf("Chr%02d", chromosomes)

  if (subplots) {
    subplots(length(tracks), ncol=1L)
    par(oma=oma, mar=mar)
  }

  pchT <- if (!is.null(scatter)) { pch } else { NA }
  xlim <- range(x, na.rm=TRUE)
  xlab <- "Genomic position"

  # Graphical handle
  gh <- list(fit=fit)
  gh$xScale <- xScale
  gh$xlim <- xlim
  gh$xlab <- xlab
  if (!is.null(callData)) {
    gh$callsByLocus <- callData
  }

  for (tt in seq_along(tracks)) {
    track <- tracks[tt]
    verbose && enter(verbose, sprintf("Track #%d ('%s') of %d",
                                             tt, track, length(tracks)))

    # Get graphical style parameters.
    tracksT <- unlist(strsplit(track, split=",", fixed=TRUE))
    colS <- sapply(tracksT, FUN=getScatterColor)
    colL <- sapply(tracksT, FUN=getLevelColor)
    colC <- sapply(tracksT, FUN=getCIColor)

    # Color scatter plot according to calls?
    if (!is.null(calls) && callLoci && length(callColumns) > 0L) {
      colsT <- rep(colS[1L], times=nrow(callData))
      for (cc in seq_along(callColumns)) {
        callColumn <- callColumns[cc]
        callLabel <- callLabels[cc]
        verbose && enter(verbose, sprintf("Call #%d ('%s') of %d",
                                      cc, callLabel, length(callColumns)))

        verbose && cat(verbose, "Column: ", callColumn)

        skip <- TRUE
        if (regexpr("tcn", track) != -1L) {
          skip <- !is.element(callLabel, c("LOSS", "NTCN", "GAIN", "LOH"))
        } else if (track == "dh") {
          skip <- !is.element(callLabel, c("AB", "LOH"))
        }
        if (skip) {
          verbose && exit(verbose)
          next
        }

        callsCC <- callData[[callColumn]]
        idxs <- which(callsCC)
        # Nothing to do?
        if (length(idxs) == 0L) {
          verbose && exit(verbose)
          next
        }

        callCol <- getCallScatterColor(callLabel)

        colsT[idxs] <- callCol
      } # for (cc in ...)

      colS <- colsT
    } # if (!is.null(calls))


    # Assign graphical-handle parameters
    gh$track <- track
    gh$subtracks <- tracksT
    gh$scatter <- list(col=colS, pch=pchT)
    gh$level <- list(col=colL)
    gh$cis <- list(col=colC)


    if (track == "tcn") {
      plot(NA, xlim=xlim, ylim=Clim, xlab=xlab, ylab="TCN", axes=FALSE)
      if (!is.null(onBegin)) attachGH(onBegin(gh=gh))
      if (!is.na(pchT)) {
        points(x, CT, pch=pchT, col=colS)
      }
      drawConfidenceBands(fit, what="tcn", quantiles=quantiles, col=colC["tcn"], xScale=xScale)
      drawLevels(fit, what="tcn", col=colL, xScale=xScale)
    }

    if (is.element(track, c("tcn,c1,c2", "c1,c2", "c1", "c2"))) {
      tracksT <- unlist(strsplit(track, split=",", fixed=TRUE))
      plot(NA, xlim=xlim, ylim=Clim, xlab=xlab, ylab="C1, C2, TCN", axes=FALSE)
      if (!is.null(onBegin)) attachGH(onBegin(gh=gh))

      # Draw scatter for TCN or C1 and C2.
      if (!is.na(pchT)) {
        if (is.element("tcn", tracksT)) {
          points(x, CT, pch=pchT, col=colS)
        } else {
          if (is.element("c1", tracksT)) {
            points(x, C1, pch=pchT, col=colS)
          }
          if (is.element("c2", tracksT)) {
            points(x, C2, pch=pchT, col=colS)
          }
        }
      }

      # Draw confidence bands for TCN, C1, C2.
      if (is.element("tcn", tracksT)) {
        drawConfidenceBands(fit, what="tcn", quantiles=quantiles, col=colC["tcn"], xScale=xScale)
      }
      if (is.element("c2", tracksT)) {
        drawConfidenceBands(fit, what="c2", quantiles=quantiles, col=colC["c2"], xScale=xScale)
      }
      if (is.element("c1", tracksT)) {
        drawConfidenceBands(fit, what="c1", quantiles=quantiles, col=colC["c1"], xScale=xScale)
      }

      # Draw segment means for TCN, C1, C2.
      if (is.element("tcn", tracksT)) {
        drawLevels(fit, what="tcn", col=colL["tcn"], xScale=xScale)
      }
      if (is.element("c2", tracksT)) {
        drawLevels(fit, what="c2", col=colL["c2"], xScale=xScale)
      }
      if (is.element("tcn", tracksT)) {
        # In case C2 overlaps with TCN
        drawLevels(fit, what="tcn", col=colL["tcn"], lty="22", xScale=xScale)
      }
      # In case C1 overlaps with C2
      if (is.element("c1", tracksT)) {
        drawLevels(fit, what="c1", col=colL["c1"], xScale=xScale)
        if (is.element("c2", tracksT)) {
          drawLevels(fit, what="c2", col=colL["c2"], lty="22", xScale=xScale)
        }
        if (is.element("tcn", tracksT)) {
          drawLevels(fit, what="tcn", col=colL["tcn"], lty="22", xScale=xScale)
        }
      }
    }

    if (track == "betaN") {
      plot(NA, xlim=xlim, ylim=Blim, xlab=xlab, ylab="BAF_N", axes=FALSE)
      if (!is.null(onBegin)) attachGH(onBegin(gh=gh))
      if (!is.na(pchT)) {
        points(x, betaN, pch=pchT, col=colS)
      }
    }

    if (track == "betaT") {
      plot(NA, xlim=xlim, ylim=Blim, xlab=xlab, ylab="BAF_T", axes=FALSE)
      if (!is.null(onBegin)) attachGH(onBegin(gh=gh))
      if (!is.na(pchT)) {
        points(x, betaT, pch=pchT, col=colS)
      }
    }

    if (track == "betaTN") {
      plot(NA, xlim=xlim, ylim=Blim, xlab=xlab, ylab="BAF_TN", axes=FALSE)
      if (!is.null(onBegin)) attachGH(onBegin(gh=gh))
      if (!is.na(pchT)) {
        points(x, betaTN, pch=pchT, col=colS)
      }
    }

    if (track == "dh") {
      plot(NA, xlim=xlim, ylim=Blim, xlab=xlab, ylab="DH", axes=FALSE)
      if (!is.null(onBegin)) attachGH(onBegin(gh=gh))
      if (!is.na(pchT)) {
        points(x, rho, pch=pchT, col=colS)
      }
      drawConfidenceBands(fit, what="dh", quantiles=quantiles, col=colC["dh"], xScale=xScale)
      drawLevels(fit, what="dh", col=colL["dh"], xScale=xScale)
    }

    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # For each panel of tracks, annotate segments with calls?
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    if (!is.null(calls) && !callLoci && length(callColumns) > 0L) {
      for (cc in seq_along(callColumns)) {
        callColumn <- callColumns[cc]
        callLabel <- callLabels[cc]
        verbose && enter(verbose, sprintf("Call #%d ('%s') of %d",
                                      cc, callLabel, length(callColumns)))

        verbose && cat(verbose, "Column: ", callColumn)

        segsT <- segs[,c("dhStart", "dhEnd", callColumn)]
        isCalled <- which(segsT[[callColumn]])
        segsT <- segsT[isCalled,1:2,drop=FALSE]
        verbose && printf(verbose, "Number of segments called %s: %d\n",
                                                  callLabel, nrow(segsT))
        segsT <- xScale * segsT

        verbose && str(verbose, segsT)

        side <- 2*((cc+1) %% 2) + 1
        # For each segment called...
        for (ss in seq_len(nrow(segsT))) {
          x0 <- segsT[ss,1,drop=TRUE]
          x1 <- segsT[ss,2,drop=TRUE]
          abline(v=c(x0,x1), lty=3, col="gray")
          xMid <- (x0+x1)/2
          mtext(side=side, at=xMid, line=-1, cex=0.7, col="#666666", callLabel)
        } # for (ss in ...)
        verbose && exit(verbose)
      } # for (cc in ...)
    } # if (!is.null(calls))


    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    # For each panel of tracks, annotate with call thresholds?
    # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    if (callThresholds) {
      # Add call parameter estimates, e.g. deltaAB
      colCL <- sapply(tracksT, FUN=getCallLevelColor)
      ltyCL <- sapply(tracksT, FUN=getCallLevelLty)

      trackT <- track
      for (cc in seq_along(allCallColumns)) {
        callColumn <- allCallColumns[cc]
        callLabel <- allCallLabels[cc]

        h <- NULL
        if (callLabel == "AB") {
          if (track == "dh") {
            h <- fit$params$deltaAB
            label <- expression(Delta[AB])
          }
        } else if (callLabel == "LOH") {
          if (regexpr("c1", track) != -1L) {
            h <- fit$params$deltaLowC1
            label <- expression(Delta[LOH])
            trackT <- "c1"
          }
        } else if (callLabel == "NTCN") {
          if (track == "tcn") {
            h <- fit$params$ntcnRange
            label <- c(expression(Delta[-NTCN]), expression(Delta[+NTCN]))
          }
        }

        if (!is.null(h)) {
          abline(h=h, lty=ltyCL[trackT], lwd=2, col=colCL[trackT])
          for (ss in 1:2) {
            side <- c(2,4)[ss]
            adj <- c(1.2,-0.2)[ss]
            mtext(side=side, at=h, label, adj=adj, las=2, xpd=TRUE)
          }
        }
      } # for (cc in ...)
    } # if (callThresholds)

    drawXLabelTicks()
    if (boundaries) {
      abline(v=vs, lty=1, lwd=2)
    }
    if (knownSegments) {
      colT <- getKnownSegmentColor()
      ltyT <- getKnownSegmentLty()
      drawKnownSegments(fit, col=colT, lty=ltyT)
    }
    axis(side=2); box()
    if (!is.null(onEnd)) onEnd(gh=gh)

    verbose && exit(verbose)
  } # for (tt ...)

  verbose && exit(verbose)

  invisible(gh)
}, private=TRUE) # plotTracksManyChromosomes()

# This test script calls a report generator which requires
# the 'ggplot2' package, which in turn will require packages
# 'colorspace', 'dichromat', 'munsell', 'reshape2' and 'scales'.

# Only run this test in full testing mode
if (Sys.getenv("_R_CHECK_FULL_") != "") {
library("PSCBS")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Load SNP microarray data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
data <- PSCBS::exampleData("paired.chr01")
str(data)

data <- data.frame(chromosome=data$chromosome, x=data$x, y=data$CT)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CBS segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Drop single-locus outliers
dataS <- dropSegmentationOutliers(data)

# Speed up example by segmenting fewer loci
dataS <- dataS[seq(from=1, to=nrow(data), by=5),]

str(dataS)

gaps <- findLargeGaps(dataS, minLength=2e6)
knownSegments <- gapsToSegments(gaps)

# CBS segmentation
fit <- segmentByCBS(dataS, knownSegments=knownSegments,
                            seed=0xBEEF, verbose=-10)
signalType(fit) <- "ratio"

# Fake a multi-chromosome segmentation
fit1 <- fit
fit2 <- renameChromosomes(fit, from=1, to=2)
fit <- c(fit1, fit2)

report(fit, sampleName="CBS", studyName="CBS-Ex", verbose=-10)

} # if (Sys.getenv("_R_CHECK_FULL_"))

setMethodS3("applyByRegion", "PairedPSCBS", function(fit, FUN, ..., subset=NULL, append=FALSE, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'FUN':
  .stop_if_not(is.function(FUN))

  # Argument 'subset':
  if (!is.null(subset)) {
    subset <- Arguments$getIndices(subset, range=c(1, nbrOfSegments(fit)))
  }

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Apply function region by region")
  verbose && cat(verbose, "Segments:")
  verbose && str(verbose, subset)


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Extract data and estimates
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  data <- getLocusData(fit)
  segs <- getSegments(fit)
  tcnSegRows <- fit$tcnSegRows
  dhSegRows <- fit$dhSegRows
  params <- fit$params

  # Sanity checks
  if (!params$joinSegments) {
    stop("Cannot applyByRegion() unless PSCNs are segmented using joinSegments=TRUE.")
  }
  dataRows <- tcnSegRows

  # Sanity checks
  .stop_if_not(all(!is.na(data$chromosome) & !is.na(data$x)))
  .stop_if_not(length(tcnSegRows) == length(dhSegRows))


  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # For each segment...
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  nbrOfSegments <- nrow(segs)
  verbose && cat(verbose, "Number of segments: ", nbrOfSegments)

  # Allocate result objects?
  if (append) {
    dataN <- outputN <- dataRowsN <- NULL
  }

  if (is.null(subset)) {
    subset <- seq_len(nbrOfSegments)
  }

  for (rr in subset) {
    verbose && enter(verbose, sprintf("Segment #%d of %d", rr, nbrOfSegments))

    # Extract segment
    segRR <- segs[rr,,drop=FALSE]

    # Nothing todo?
    if (is.na(segRR[["tcnId"]]) && is.na(segRR[["dhId"]])) {
      verbose && cat(verbose, "A divider. Nothing to do.")
      outputN <- rbind(outputN, NA)
      dataRowsN <- rbind(dataRowsN, NA)
      verbose && exit(verbose)
      next
    }

    verbose && str(verbose, segRR, level=-20)

    # Extract data
    dataRowsRR <- dataRows[rr,,drop=FALSE]
    from <- dataRowsRR[[1]]
    to <- dataRowsRR[[2]]
    ok <- (!is.na(from) & !is.na(to))
    from <- from[ok]
    to <- to[ok]
    keep <- logical(nrow(data))
    for (kk in seq_along(from)) {
      keep[from[kk]:to[kk]] <- TRUE
    }
    dataRowsRR <- which(keep)
    verbose && printf(verbose, "Identified %d (%.2f%%) of %d data rows:\n", length(dataRowsRR), 100*length(dataRowsRR)/nrow(data), nrow(data))
    verbose && str(verbose, dataRowsRR)
    dataRR <- data[dataRowsRR,,drop=FALSE]
    verbose && str(verbose, dataRR, level=-20)

    verbose && enter(verbose, "Applying function 'FUN' to segment")
    resRR <- FUN(rr, segRR, dataRR, ...)
    verbose && cat(verbose, "Returned result:")
    verbose && str(verbose, resRR, level=-20)
    verbose && exit(verbose)

    # Nothing to update/store?
    if (!is.list(resRR)) {
      verbose && cat(verbose, "Nothing more to do for this segment since nothing was returned: ", rr)
      verbose && exit(verbose)
      next
    }

    # Extract return data
    dataRRN <- resRR$data
    segRRN <- resRR$output
    # Sanity check
    .stop_if_not(!is.null(dataRRN))
    .stop_if_not(is.data.frame(dataRRN))
    .stop_if_not(!is.null(segRRN))
    .stop_if_not(is.data.frame(segRRN))

    if (append) {
      # Modified locus-level data
      dataRowsRRN <- c(1L, nrow(dataRRN))
      if (!is.null(dataN)) {
        dataRowsRRN <- dataRowsRRN + nrow(dataN)
      }
      dataN <- rbind(dataN, dataRRN)
      # Sanity checks
      .stop_if_not(nrow(dataN) == max(dataRowsN, na.rm=TRUE))

      # Update segment table?
      outputN <- rbind(outputN, segRRN)
      dataRowsN <- rbind(dataRowsN, dataRowsRRN)
      # Sanity check
      .stop_if_not(nrow(outputN) == nrow(dataRowsN))
      # Sanity checks
      .stop_if_not(nrow(dataN) == max(dataRowsN, na.rm=TRUE))
    } else {
      # Modified locus-level data
      verbose && enter(verbose, "Updating locus-level data")
      # Sanity check
      .stop_if_not(dim(dataRRN) == dim(dataRR))
      .stop_if_not(length(dataRowsRR) == nrow(dataRRN))
      data[dataRowsRR,] <- dataRRN
      str(data[dataRowsRR,])
      verbose && exit(verbose)

      # Modified segment data
      verbose && enter(verbose, "Updating segment data")
      # Sanity check
      .stop_if_not(dim(segRRN) == dim(segRR))
      segs[rr,] <- segRRN
      verbose && exit(verbose)
    }

    # Not needed anymore
    dataRRN <- segRRN <- NULL
    dataRR <- segRR <- NULL
    resRR <- NULL

    verbose && exit(verbose)
  } # for (rr ...)

  if (append) {
    if (!is.null(dataRowsN)) {
      rownames(dataRowsN) <- NULL
      colnames(dataRowsN) <- colnames(dataRows)
      dataRowsN <- as.data.frame(dataRowsN)
      # Sanity checks
      .stop_if_not(!is.null(dataN))
      .stop_if_not(!is.null(outputN))
      .stop_if_not(!is.null(dataRowsN))

      data <- dataN
      segs <- outputN

      # Not needed anymore
      dataN <- outputN <- NULL
    }
  }

  # Return result
  res <- fit # "clone"
  res$data <- data
  res$output <- segs

  # Not needed anymore
  data <- segs <- NULL

  # Update segment-to-locus index tables
  if (append && !is.null(dataRowsN)) {
    res$tcnSegRows <- dataRowsN
    res$dhSegRows <- dataRowsN # Is this really the case? /HB 2011-01-17
  }

  verbose && exit(verbose)

  res
}, private=TRUE)


.addC1C2WithStatitics <- function(rr, output, data, robust=TRUE, ...) {
  # Calculate locus-level (C1,C2)
  C <- data$CT
  rho <- data$rho
  C1 <- 1/2 * (1 - rho) * C
  C2 <- C - C1
  CC <- data.frame(C1=C1, C2=C2)

  if (robust) {
    meanFcn <- function(x, ...) median(x, na.rm=TRUE)
    sdFcn <- function(x, ...) mad(x, na.rm=TRUE)
  } else {
    meanFcn <- function(x, ...) mean(x, na.rm=TRUE)
    sdFcn <- function(x, ...) sd(x, na.rm=TRUE)
  }

  # Calculate region-level (C1,C2) means and std devs.
  muCC <- apply(CC, MARGIN=2, FUN=meanFcn)
  sigmaCC <- apply(CC, MARGIN=2, FUN=sdFcn)
  rhoCC <- cor(CC[,1], CC[,2], use="pairwise.complete.obs")

  names(muCC) <- c("c1Avg", "c2Avg")
  names(sigmaCC) <- c("c1Sd", "c2Sd")

  # Update data
  data <- cbind(data, CC)


  # Update segment table
  outputT <- c(muCC, sigmaCC, c1c2.cor=rhoCC)
  outputT <- as.list(outputT)
  outputT <- as.data.frame(outputT)

  output <- cbind(output, outputT)

  list(data=data, output=output)
} # .addC1C2WithStatitics()


.addCACBWithStatitics <- function(rr, output, data, beta=c("betaTN", "betaT"), stratifyBy=c("all", "hets", "homs"), robust=TRUE, ...) {
  # Argument 'beta':
  beta <- match.arg(beta)

  # Argument 'stratifyBy':
  stratifyBy <- match.arg(stratifyBy)

  # Calculate locus-level (CA,CB)
  C <- data$CT
  beta <- data[[beta]]
  CB <- beta * C
  CA <- C - CB
  CC <- data.frame(CA=CA, CB=CB)

  # Update data
  data <- cbind(data, CC)


  if (robust) {
    meanFcn <- function(x, ...) median(x, na.rm=TRUE)
    sdFcn <- function(x, ...) mad(x, na.rm=TRUE)
  } else {
    meanFcn <- function(x, ...) mean(x, na.rm=TRUE)
    sdFcn <- function(x, ...) sd(x, na.rm=TRUE)
  }

  if (stratifyBy == "hets") {
    muN <- data$muN
    keep <- (muN == 1/2)
    CC <- CC[keep,,drop=FALSE]
  } else if (stratifyBy == "homs") {
    muN <- data$muN
    keep <- (muN == 0 | muN == 1)
    CC <- CC[keep,,drop=FALSE]
  }

  # Calculate region-level (CA,CB) means and std devs.
  muCC <- apply(CC, MARGIN=2, FUN=meanFcn)
  sigmaCC <- apply(CC, MARGIN=2, FUN=sdFcn)
  if (nrow(CC) < 3) {
    rhoCC <- NA_real_
  } else {
    rhoCC <- cor(CC[,1], CC[,2], use="pairwise.complete.obs")
  }
  names(muCC) <- c("caAvg", "cbAvg")
  names(sigmaCC) <- c("caSd", "cbSd")

  # Update segment table
  outputT <- c(muCC, sigmaCC, cacbCor=rhoCC)
  outputT <- as.list(outputT)
  outputT <- as.data.frame(outputT)

  output <- cbind(output, outputT)

  list(data=data, output=output)
} # .addCACBWithStatitics()

###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod estimateDeltaLOH
#
# @title "Estimate a threshold for calling LOH from DH"
#
# \description{
#  @get "title" to be used by the @seemethod "callLOH" method.
# }
#
# @synopsis
#
# \arguments{
#   \item{flavor}{A @character string specifying which type of
#    estimator to use.}
#   \item{...}{Additional arguments passed to the estimator.}
#   \item{max}{(Optional) The maximum estimate allowed. If greater than
#    this value, the estimate will be truncated.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns the threshold estimate as a @numeric scalar or -@Inf.
#   In case it is not possible to estimate the LOH threshold, then
#   -@Inf is returned.
# }
#
# @author "HB"
#
# \seealso{
#   Internally, one of the following methods are used:
#   @seemethod "estimateDeltaLOHByMinC1ForNonAB".
# }
#
#*/###########################################################################
setMethodS3("estimateDeltaLOH", "PairedPSCBS", function(this, flavor=c("minC1|nonAB"), ..., max=Inf, verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'flavor':
  flavor <- match.arg(flavor)

  # Argument 'max':
  max <- Arguments$getDouble(max, range=c(0,Inf))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }

  verbose && enter(verbose, "Estimating DH threshold for calling LOH")
  verbose && cat(verbose, "flavor: ", flavor)

  if (flavor == "minC1|nonAB") {
    delta <- estimateDeltaLOHByMinC1ForNonAB(this, ..., verbose=verbose)
  } else {
    stop("Unkown flavor: ", flavor)
  }

  verbose && printf(verbose, "delta: %.3g\n", delta)

  # Truncate estimate?
  if (delta > max) {
    warning("Estimated delta (%.3g) was greater than the maximum allowed value (%.3g).  The latter will be used instead.", delta, max)
    delta <- max
    verbose && printf(verbose, "Max delta: %.3g\n", max)
    verbose && printf(verbose, "Truncated delta: %.3g\n", delta)
  }

  verbose && exit(verbose)

  delta
}) # estimateDeltaLOH()



###########################################################################/**
# @set class=PairedPSCBS
# @RdocMethod estimateDeltaLOHByMinC1ForNonAB
#
# @title "Estimate a threshold for calling LOH from DH"
#
# \description{
#  @get "title" based on the location of guessed C1=0 and C1=1 peaks.
# }
#
# @synopsis
#
# \arguments{
#   \item{midpoint}{A @numeric scalar in [0,1] specifying the relative
#    position of the midpoint between the estimated locations of
#    C1=0 and C1=1 mean parameters.}
#   \item{maxC}{Maximum total copy number of a segment in order to
#    be included in the initial set of segments.}
#   \item{...}{Not used.}
#   \item{verbose}{See @see "R.utils::Verbose".}
# }
#
# \value{
#   Returns the estimated LOH threshold as a @numeric scalar or -@Inf.
#   In case it is not possible to estimate the LOH threshold, then
#   -@Inf is returned.
# }
#
# \details{
#   This method requires that calls for allelic balances already have
#   been me made, cf. @seemethod "callAllelicBalance".
# }
#
# \section{Algorithm}{
#  \itemize{
#   \item Grabs the segment-level C1 estimates.
#   \item Calculate segment weights proportional to the number of heterozygous SNPs.
#   \item Estimate the C1=1 location as the weighted median C1 for segments that have been called to be in allelic balance.
#   \item Estimate the C1=0 location as the smallest C1 among segments that are not in allelic balance.
#   \item Let the LOH threshold be the midpoint of the estimates C1=0 and C1=1 locations.
#  }
# }
#
# @author "HB"
#
# \seealso{
#   Instead of calling this method explicitly, it is recommended
#   to use the @seemethod "estimateDeltaLOH" method.
# }
#
# @keyword internal
#*/###########################################################################
setMethodS3("estimateDeltaLOHByMinC1ForNonAB", "PairedPSCBS", function(this, midpoint=1/2, maxC=3*(ploidy(this)/2), ..., verbose=FALSE) {
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Validate arguments
  # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  # Argument 'midpoint':
  midpoint <- Arguments$getDouble(midpoint, range=c(0,1))

  # Argument 'maxC':
  maxC <- Arguments$getDouble(maxC, range=c(0,Inf))

  # Argument 'verbose':
  verbose <- Arguments$getVerbose(verbose)
  if (verbose) {
    pushState(verbose)
    on.exit(popState(verbose))
  }


  verbose && enter(verbose, "Estimating DH threshold for calling LOH as the midpoint between guessed C1=0 and C1=1")
  segs <- getSegments(this, splitters=FALSE)
  nbrOfSegments <- nrow(segs)

  verbose && printf(verbose, "Argument 'midpoint': %.3g\n", midpoint)
  verbose && cat(verbose, "Number of segments: ", nbrOfSegments)

  # Getting AB calls
  isAB <- segs$abCall
  if (is.null(isAB)) {
    stop("Cannot estimate delta_LOH because allelic-balance calls have not been made yet.")
  }

  nbrOfAB <- sum(isAB, na.rm=TRUE)
  verbose && printf(verbose, "Number of segments in allelic balance: %d (%.1f%%) of %d\n", nbrOfAB, 100*nbrOfAB/nbrOfSegments, nbrOfSegments)

  # Sanity check
  if (nbrOfAB == 0) {
    stop("There are no segments in allelic balance.")
  }

  nbrOfNonAB <- sum(!isAB, na.rm=TRUE)
  verbose && printf(verbose, "Number of segments not in allelic balance: %d (%.1f%%) of %d\n", nbrOfNonAB, 100*nbrOfNonAB/nbrOfSegments, nbrOfSegments)
  segsNonAB <- segs[which(!isAB),,drop=FALSE]

  # Sanity check
  if (nbrOfNonAB == 0) {
    msg <- sprintf("All %d segments are in allelic balance. Cannot estimate DeltaLOH, which requires that at least one segment must be in allelic imbalance.  Returning -Inf instead.", nbrOfSegments)
    warning(msg)
    return(-Inf)
  }


  # Identify segments in AB and with small enough TCNs
  C <- segs$tcnMean
  keep <- which(isAB & C <= maxC)
  verbose && printf(verbose, "Number of segments in allelic balance and TCN <= %.2f: %d (%.1f%%) of %d\n", maxC, length(keep), 100*length(keep)/nbrOfSegments, nbrOfSegments)

  # Sanity check
  if (length(keep) == 0) {
    stop("There are no segments in allelic balance with small enough total CN.")
  }

  # (a) Estimate mean C1 level of AB segments
  segsT <- segs[keep,,drop=FALSE]
  C <- segsT$tcnMean
  n <- segsT$dhNbrOfLoci
  w <- n/sum(n)
  C1 <- C/2 # Called AB!
  verbose && printf(verbose, "C: %s\n", hpaste(sprintf("%.3g", C)))
  verbose && printf(verbose, "Corrected C1 (=C/2): %s\n", hpaste(sprintf("%.3g", C1)))
  verbose && printf(verbose, "Number of DHs: %s\n", hpaste(n))
  verbose && printf(verbose, "Weights: %s\n", hpaste(sprintf("%.3g", w)))
  muC1atAB  <- weightedMedian(C1, w=w, na.rm=TRUE)
  verbose && printf(verbose, "Weighted median of (corrected) C1 in allelic balance: %.3f\n", muC1atAB)


  # (b) Estimate mean C1 level of non-AB segments
  C1 <- segsNonAB$c1Mean
  muC1atNonAB <- min(C1, na.rm=TRUE)
  idxs <- which(C1 <= muC1atNonAB)
  n <- segsNonAB$dhNbrOfLoci[idxs]
  verbose && printf(verbose, "Smallest C1 among segments not in allelic balance: %.3g\n", muC1atNonAB)
  verbose && printf(verbose, "There are %d segments with in total %d heterozygous SNPs with this level.\n", length(idxs), n)

  # Sanity check
  .stop_if_not(muC1atNonAB < muC1atAB)

  delta <- midpoint * (muC1atAB + muC1atNonAB)
  verbose && printf(verbose, "Midpoint between the two: %.3g\n", delta)

  verbose && exit(verbose)

  delta
}, private=TRUE) # estimateDeltaLOHByMinC1AtNonAB()

library("PSCBS")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Load SNP microarray data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
data <- PSCBS::exampleData("paired.chr01")


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Paired PSCBS segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Drop single-locus outliers
dataS <- dropSegmentationOutliers(data)

# Run light-weight tests by default
if (Sys.getenv("_R_CHECK_FULL_") == "") {
  # Use only every 5th data point
  dataS <- dataS[seq(from=1, to=nrow(data), by=5),]
  # Number of segments (for assertion)
  nSegs <- 4L
} else {
  # Full tests
  nSegs <- 11L
}

str(dataS)


## Create multiple chromosomes
data <- list()
for (cc in 1:3) {
  dataS$chromosome <- cc
  data[[cc]] <- dataS
}
data <- Reduce(rbind, data)
str(data)


message("*** segmentByPairedPSCBS() via futures ...")

library("future")
oplan <- plan()

strategies <- c("sequential", "multiprocess")

## Test 'future.BatchJobs' futures?
pkg <- "future.BatchJobs"
if (require(pkg, character.only=TRUE)) {
  strategies <- c(strategies, "batchjobs_local")
}

message("Future strategies to test: ", paste(sQuote(strategies), collapse=", "))

fits <- list()
for (strategy in strategies) {
  message(sprintf("- segmentByPairedPSCBS() using '%s' futures ...", strategy))
  plan(strategy)
  fit <- segmentByPairedPSCBS(data, seed=0xBEEF, verbose=TRUE)
  fits[[strategy]] <- fit
  stopifnot(all.equal(fit, fits[[1]]))
}

message("*** segmentByPairedPSCBS() via futures ... DONE")


message("*** segmentByPairedPSCBS() via futures with known segments ...")
fits <- list()
dataT <- subset(data, chromosome == 1)
gaps <- findLargeGaps(dataT, minLength=2e6)
knownSegments <- gapsToSegments(gaps)

for (strategy in strategies) {
  message(sprintf("- segmentByCBS() w/ known segments using '%s' futures ...", strategy))
  plan(strategy)
  fit <- segmentByPairedPSCBS(dataT, knownSegments=knownSegments, seed=0xBEEF, verbose=TRUE)
  fits[[strategy]] <- fit
  stopifnot(all.equal(fit, fits[[1]]))
}

message("*** segmentByPairedPSCBS() via futures ... DONE")


## Cleanup
plan(oplan)
rm(list=c("fits", "data", "fit"))

# aroma.cn

<details>

* Version: 1.6.1
* Source code: https://github.com/cran/aroma.cn
* URL: http://www.aroma-project.org/, https://github.com/HenrikBengtsson/aroma.cn
* BugReports: https://github.com/HenrikBengtsson/aroma.cn/issues
* Date/Publication: 2015-10-28 00:08:16
* Number of recursive dependencies: 23

Run `revdep_details(,"aroma.cn")` for more info

</details>

## In both

*   checking whether package ‘aroma.cn’ can be installed ... NOTE
    ```
    Found the following notes/warnings:
      Non-staged installation was used
    See ‘/home/hb/repositories/PSCBS/revdep/checks/aroma.cn/new/aroma.cn.Rcheck/00install.out’ for details.
    ```

# aroma.core

<details>

* Version: 3.1.3
* Source code: https://github.com/cran/aroma.core
* URL: https://github.com/HenrikBengtsson/aroma.core, http://www.aroma-project.org/
* BugReports: https://github.com/HenrikBengtsson/aroma.core/issues
* Date/Publication: 2018-05-03 13:41:54 UTC
* Number of recursive dependencies: 45

Run `revdep_details(,"aroma.core")` for more info

</details>

## In both

*   checking package dependencies ... NOTE
    ```
    Packages suggested but not available for checking:
      'EBImage', 'sfit', 'expectile', 'HaarSeg', 'mpcbs'
    ```

*   checking whether package ‘aroma.core’ can be installed ... NOTE
    ```
    Found the following notes/warnings:
      Non-staged installation was used
    See ‘/home/hb/repositories/PSCBS/revdep/checks/aroma.core/new/aroma.core.Rcheck/00install.out’ for details.
    ```

# EstMix

<details>

* Version: 1.0.1
* Source code: https://github.com/cran/EstMix
* Date/Publication: 2018-09-13 04:20:02 UTC
* Number of recursive dependencies: 15

Run `revdep_details(,"EstMix")` for more info

</details>

## Newly fixed

*   checking examples ... ERROR
    ```
    ...
    > ## short example
    > ##
    > #########################################################
    > ## first load the data
    > BAF <- example_data$BAF
    > LRR <- example_data$LRR ## In practice, the orignal LRR should be devided by 0.55
    > chr <- example_data$chr
    > loc <- example_data$x
    > GT <- example_data$GT
    > gt = (GT=='BB')*2+(GT=='AB')*1.5+(GT=='AA')-1;gt[gt==(-1)]=NA
    > 
    > ## then perform segmentation
    > gaps = PSCBS::findLargeGaps(x=loc,minLength=5e6,chromosome=chr)
    > if(!is.null(gaps)) knownSegments = PSCBS::gapsToSegments(gaps)
    > p <- 0.0001
    > fit <- PSCBS::segmentByPairedPSCBS(CT=2*2^LRR,betaT=BAF,muN=gt,chrom=chr,
    + knownSegments=knownSegments,tbn=FALSE,x=loc,seed=1, alphaTCN=p*.9,alphaDH=p*.1)
    Error in is.na(tcnSegRowsKK[, 1]) || is.na(dhSegRowsKK[, 1]) : 
      'length(x) = 3 > 1' in coercion to 'logical(1)'
    Calls: <Anonymous> -> segmentByPairedPSCBS.default -> .stop_if_not
    Execution halted
    ```

## In both

*   checking whether package ‘EstMix’ can be installed ... NOTE
    ```
    Found the following notes/warnings:
      Non-staged installation was used
    See ‘/home/hb/repositories/PSCBS/revdep/checks/EstMix/new/EstMix.Rcheck/00install.out’ for details.
    ```

# jointseg

<details>

* Version: 1.0.2
* Source code: https://github.com/cran/jointseg
* URL: https://github.com/mpierrejean/jointseg
* BugReports: https://github.com/mpierrejean/jointseg/issues
* Date/Publication: 2019-01-11 12:30:03 UTC
* Number of recursive dependencies: 42

Run `revdep_details(,"jointseg")` for more info

</details>

## In both

*   checking whether package ‘jointseg’ can be installed ... NOTE
    ```
    Found the following notes/warnings:
      Non-staged installation was used
    See ‘/home/hb/repositories/PSCBS/revdep/checks/jointseg/new/jointseg.Rcheck/00install.out’ for details.
    ```

# PureCN

<details>

* Version: 1.14.0
* Source code: https://github.com/cran/PureCN
* URL: https://github.com/lima1/PureCN
* Date/Publication: 2019-05-02
* Number of recursive dependencies: 120

Run `revdep_details(,"PureCN")` for more info

</details>

## In both

*   checking whether package ‘PureCN’ can be installed ... NOTE
    ```
    Found the following notes/warnings:
      Non-staged installation was used
    See ‘/home/hb/repositories/PSCBS/revdep/checks/PureCN/new/PureCN.Rcheck/00install.out’ for details.
    ```

*   checking installed package size ... NOTE
    ```
      installed size is  8.2Mb
      sub-directories of 1Mb or more:
        data      1.1Mb
        doc       2.7Mb
        extdata   3.8Mb
    ```

<% if (git_branch() == "develop") { %>
## Parallel processing
The package supports segmentation of the chromosomes in parallel
(asynchronously) via [futures](https://cran.r-project.org/package=future)
by adding the following
```r
future::plan("multiprocess")
```
to the beginning of the PSCBS script.  Everything else will work the
same.  To reset to non-parallel processing, use `future::plan("sequential")`.

To configure this automatically whenever the package is loaded, see
future vignette '[A Future for R: Controlling Default Future Strategy](https://cran.r-project.org/web/packages/future/vignettes/future-5-startup.html)'.
<% } %>


## Installation
R package <%=pkg()%> is available on [CRAN](https://cran.r-project.org/package=<%=pkg()%>) and can be installed in R as:
```r
install.packages('<%=pkg()%>')
```

<% if (git_branch() != "master" && !grepl("^release/", git_branch())) { %>
### Pre-release version

To install the pre-release version that is available in branch `<%=git_branch()%>`, use:
```r
source('http://callr.org/install#<%=github_repos()%>@<%=git_branch()%>')
```
This will install the package from source.  <% if (file.exists("src")) { %><%-%>
Because of this and because this package also compiles native code,
Windows users need to have
[Rtools](https://cran.r-project.org/bin/windows/Rtools/) installed and
OS X users need to have [Xcode](https://developer.apple.com/xcode/)
installed.
<% } # if (file.exists("src")) %>

<% } # if (git_branch() != "master") %>

# CRAN submission PSCBS 0.65.0

on 2019-05-04

Notably, this submission fixes a _R_CHECK_LENGTH_1_LOGIC2_=true bug.

I've verified that this submission causes no issues for any of the 5 reverse package dependencies available on CRAN and Bioconductor.

Thanks in advance


## Notes not sent to CRAN

### R CMD check --as-cran validation

The package has been verified using `R CMD check --as-cran` on:

* Platform x86_64-apple-darwin15.6.0 (64-bit) [Travis CI]:
  - R version 3.5.3 (2019-03-11)
  - R version 3.6.0 (2019-04-26)

* Platform x86_64-unknown-linux-gnu (64-bit) [Travis CI]:
  - R version 3.5.3 (2017-01-27) [sic!]
  - R version 3.6.0 (2019-04-26)
  - R Under development (unstable) (2019-05-04 r76458)

* Platform x86_64-pc-linux-gnu (64-bit):
  - R version 3.2.0 (2015-04-16)
  - R version 3.3.0 (2016-05-03)
  - R version 3.4.0 (2017-04-21)
  - R version 3.6.0 (2019-04-26)

* Platform x86_64-pc-linux-gnu (64-bit) [r-hub]:
  - R version 3.6.0 (2019-04-26)
  - R Under development (unstable) (2019-05-02 r76453)

* Platform i686-pc-linux-gnu (32-bit):
  - R version 3.4.4 (2018-03-15)

* Platform x86_64-w64-mingw32/x64 (64-bit) [win-builder]:
  - R version 3.6.0 (2019-04-26)
  - R Under development (unstable) (2019-05-02 r76454)


The following setups were skipped due to non-availability:

* Platform x86_64-w64-mingw32 (64-bit) [r-hub]:
  - R Under development (unstable) (2019-04-26 r76431)
  - REASON: Dependency 'DNAcopy' not available

* Platform i386-w64-mingw32 (32-bit) [Appveyor CI]:
  - R version 3.6.0 (2019-04-26)
  - REASON: Weird BiocManager error ("Bioconductor version not changed")
    possibly due to today's release of Bioconductor 3.9.

* Platform x86_64-w64-mingw32/x64 (64-bit) [Appveyor CI]:
  - R version 3.6.0 (2019-04-26)
  - REASON: Weird BiocManager error ("Bioconductor version not changed")
    possibly due to today's release of Bioconductor 3.9.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  findLargeGaps.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{findLargeGaps}
\alias{findLargeGaps.default}
\alias{findLargeGaps}
\alias{findLargeGaps.data.frame}

\title{Identifies gaps of a genome where there exist no observations}

\description{
 Identifies gaps of a genome where there exist no observations.
}

\usage{
\method{findLargeGaps}{default}(chromosome=NULL, x, minLength, resolution=1L, ...)
}

\arguments{
  \item{chromosome}{(Optional) An \code{\link[base]{integer}} \code{\link[base]{vector}} of length J of
    chromosome indices.}
  \item{x}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J of genomic locations.}
  \item{minLength}{A positive \code{\link[base]{numeric}} scalar specifying the minimum
    length of a gap.}
  \item{resolution}{A non-negative \code{\link[base]{numeric}} specifying the minimum
    length unit, which by default equals one nucleotide/base pair.}
  \item{...}{Not used.}
}

\value{
  Returns \code{\link[base]{data.frame}} zero or more rows and with columns
  \code{chromosome} (if given), \code{start}, \code{stop},
  and \code{length}.
}

\author{Henrik Bengtsson}

\seealso{
  Use \code{\link{gapsToSegments}}() to turn the set of identified gaps into
  the complementary set of segments such that they can be passed
  to \code{\link{segmentByCBS}}(), \code{\link{segmentByPairedPSCBS}}() and
  \code{\link{segmentByNonPairedPSCBS}}() via argument \code{knownSegments}.
}


\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.EXTS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{extractTCNAndDHs.PairedPSCBS}
\alias{extractTCNAndDHs.PairedPSCBS}
\alias{PairedPSCBS.extractTCNAndDHs}
\alias{extractTCNAndDHs,PairedPSCBS-method}

\title{Extract TCN and DH mean levels per segment}

\description{
  Extract TCN and DH mean levels per segment.
}

\usage{
\method{extractTCNAndDHs}{PairedPSCBS}(fit, ...)
}

\arguments{
 \item{...}{Arguments passed to \code{getSegments()}.}
}

\value{
  Returns a \code{\link[base]{data.frame}}.
}

\author{Henrik Bengtsson}

\seealso{
  \code{\link[PSCBS:extractMinorMajorCNs.PairedPSCBS]{*extractMinorMajorCNs}()}.
  For more information see \code{\link{PairedPSCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.CALL.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getCallStatistics.CBS}
\alias{getCallStatistics.CBS}
\alias{CBS.getCallStatistics}
\alias{getCallStatistics,CBS-method}

\title{Calculates various call statistics per chromosome}

\description{
 Calculates various call statistics per chromosome.
}

\usage{
\method{getCallStatistics}{CBS}(fit, regions=NULL, shrinkRegions=TRUE, ..., verbose=FALSE)
}

\arguments{
 \item{regions}{An optional \code{\link[base]{data.frame}} with columns "chromosome",
    "start", and "end" specifying the regions of interest to calculate
    statistics for.  If \code{\link[base]{NULL}}, all of the genome is used.}
 \item{shrinkRegions}{If \code{\link[base:logical]{TRUE}}, regions are shrunk to the support of
    the data.}
 \item{...}{Not used.}
 \item{verbose}{\code{\link[R.utils]{Verbose}}.}
}

\value{
 Returns a CxK \code{\link[base]{data.frame}}, where C is the number of regions that
 meet the criteria setup by argument \code{regions}
 and (K-4)/2 is the number of call types.
 The first column is the chromosome index, the second and the third
 are the first and last position, and the fourth the length
 (=last-first+1) of the chromosome.
 The following columns contains call summaries per chromosome.
 For each chromosome and call type, the total length of such calls
 on that chromosome is reported together how large of a fraction
 of the chromosome such calls occupy.
}

\details{
  The estimators implemented here are based solely on the
  segmentation results, which is very fast.
  In the original proposal by Fridlyand et al. [1], the authors
  estimates the parameters by converting segment-level calls back
  to locus-level calls and there do the calculations.
  The difference between the two approaches should be minor,
  particularly for large density arrays.
}

\author{Henrik Bengtsson}

\references{
  [1] Fridlyand et al. \emph{Breast tumor copy number aberration
      phenotypes and genomic instability}, BMC Cancer, 2006. \cr
}

\seealso{
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.CALL.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{callGainsAndLosses.CBS}
\alias{callGainsAndLosses.CBS}
\alias{CBS.callGainsAndLosses}
\alias{callGainsAndLosses,CBS-method}

\title{Calls gains and losses}

\description{
 Calls gains and losses.
}

\usage{
\method{callGainsAndLosses}{CBS}(fit, adjust=1, method=c("ucsf-mad", "ucsf-dmad"), ..., verbose=FALSE)
}

\arguments{
 \item{adjust}{A positive scale factor adjusting the sensitivity of the
   caller, where a value less (greater) than 1.0 makes the caller
   less (more) sensitive.}
 \item{method}{A \code{\link[base]{character}} string specifying the calling algorithm to use.}
 \item{...}{Additional/optional arguments used to override the default
   parameters used by the caller.}
}

\value{
 Returns a \code{\link[PSCBS]{CBS}} object where \code{\link[base]{logical}} columns
 'lossCall' and 'gainCall' have been appended to the segmentation table.
}

\section{The UCSF caller}{
  If \code{method == "ucsf-mad"}, then segments are called using [1], i.e.
  a segment is called gained or lost if its segment level is
  at least two standard deviations away from the median segment level
  on Chr1-22, where standard deviation is estimated using MAD.
  Then same is done for \code{method == "ucsf-dmad"} with the difference
  that the standard deviation is estimated using a robust first order
  variance estimator.
}

\examples{
 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Simulating copy-number data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
set.seed(0xBEEF)

# Number of loci
J <- 1000

mu <- double(J)
mu[200:300] <- mu[200:300] + 1
mu[350:400] <- NA # centromere
mu[650:800] <- mu[650:800] - 1
eps <- rnorm(J, sd=1/2)
y <- mu + eps
x <- sort(runif(length(y), max=length(y))) * 1e5
w <- runif(J)
w[650:800] <- 0.001


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fit <- segmentByCBS(y, x=x)
print(fit)
plotTracks(fit)


 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# CALLS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Call gains and losses by segments
fitC <- callGainsAndLosses(fit)

# Call amplifications by segments
fitC <- callAmplifications(fitC)

# Call outliers by loci
fitC <- callOutliers(fitC)

}

\author{Henrik Bengtsson}

\references{
  [1] Fridlyand et al. \emph{Breast tumor copy number aberration
      phenotypes and genomic instability}, BMC Cancer, 2006. \cr
}

\seealso{
  \code{\link[PSCBS:callAmplifications.CBS]{*callAmplifications}()}.
  \code{\link[PSCBS:callOutliers.CBS]{*callOutliers}()}.
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.CALL.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{mergeNonCalledSegments.CBS}
\alias{mergeNonCalledSegments.CBS}
\alias{CBS.mergeNonCalledSegments}
\alias{mergeNonCalledSegments,CBS-method}

\title{Merge neighboring segments that are not called}

\description{
  Merge neighboring segments that are not called
}

\usage{
\method{mergeNonCalledSegments}{CBS}(fit, ..., verbose=FALSE)
}

\arguments{
 \item{...}{Not used.}
 \item{verbose}{\code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns an object of the same class
  with the same of fewer number of segments.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{setSampleName.AbstractCBS}
\alias{setSampleName.AbstractCBS}
\alias{AbstractCBS.setSampleName}
\alias{setSampleName,AbstractCBS-method}
\alias{AbstractCBS.sampleName<-}
\alias{sampleName<-.AbstractCBS}
\alias{sampleName<-,AbstractCBS-method}


\title{Sets the name of the sample segmented}

\description{
 Sets the name of the sample segmented.
}

\usage{
\method{setSampleName}{AbstractCBS}(fit, name, ...)
}

\arguments{
  \item{name}{A \code{\link[base]{character}} string.}
  \item{...}{Not used.}
}

\value{
  Returns (invisibly) an updated object.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}..
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.callGNL.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{callGNL.PairedPSCBS}
\alias{callGNL.PairedPSCBS}
\alias{PairedPSCBS.callGNL}
\alias{callGNL,PairedPSCBS-method}
\alias{PairedPSCBS.callGainNeutralLoss}
\alias{callGainNeutralLoss.PairedPSCBS}
\alias{callGainNeutralLoss,PairedPSCBS-method}

\alias{callGNLByTCNofAB}
\alias{PairedPSCBS.callGNLByTCNofAB}
\alias{callGNLByTCNofAB.PairedPSCBS}
\alias{callGNLByTCNofAB,PairedPSCBS-method}

\alias{callGNLByTCNofABv1}
\alias{PairedPSCBS.callGNLByTCNofABv1}
\alias{callGNLByTCNofABv1.PairedPSCBS}
\alias{callGNLByTCNofABv1,PairedPSCBS-method}


\title{Calls segments that are gained, copy neutral, or lost}

\description{
 Calls segments that are gained, copy neutral, or lost, where copy neutral means having a total copy number
 that corresponds to the ploidy of the genome.
}

\usage{
\method{callGNL}{PairedPSCBS}(fit, flavor=c("TCN|AB"), ..., minSize=1, force=FALSE)
}

\arguments{
  \item{flavor}{A \code{\link[base]{character}} string specifying which type of
   call to use.}
  \item{...}{Additional arguments passed to the caller.}
  \item{minSize}{An optional \code{\link[base]{integer}} specifying the minimum number
   of data points in order to call a segments.  If fewer data points,
   then the call is set to \code{\link[base]{NA}} regardless.}
  \item{force}{If \code{\link[base:logical]{FALSE}}, and copy-neutral calls already exits,
   then nothing is done, otherwise the calls are done.}
}

\value{
  Returns a \code{\link{PairedPSCBS}} object with added calls.
}

\author{Henrik Bengtsson}

\seealso{
  Internally, one of the following methods are used:
  \code{callGNLByTCNofAB()}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.callCopyNeutral.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{estimateDeltaCN.PairedPSCBS}
\alias{estimateDeltaCN.PairedPSCBS}
\alias{PairedPSCBS.estimateDeltaCN}
\alias{estimateDeltaCN,PairedPSCBS-method}
\alias{estimateDeltaCN}
\alias{estimateDeltaCN.CBS}

\title{Estimates the length of one total copy-number (TCN) unit}

\description{
 Estimates the length of one total copy-number (TCN) unit
}

\usage{
\method{estimateDeltaCN}{PairedPSCBS}(fit, scale=1, flavor=c("1-kappa", "delta(mode)"),
  kappa=estimateKappa(fit), adjust=0.2, quantile=0.95, ...)
}

\arguments{
 \item{scale}{A \code{\link[base]{numeric}} scale factor in (0,Inf) used for rescaling
  (multiplying) the final estimate with.}
 \item{flavor}{Specifies which type of estimator should be used.}
 \item{kappa}{Estimate of background signal (used by the \code{"1-kappa"} method).}
 \item{adjust, quantile}{Tuning parameters (used by the \code{"delta(mode)"} method).}
 \item{...}{Not used.}
}

\value{
 Returns a positive scalar \code{\link[base]{numeric}}.
}

\details{
  For parent-specific copy-number (PSCN) data, the TCN unit length is
  estimated as \eqn{(1-kappa)/2}, where \eqn{kappa} is estimated from
  data (by \code{\link[PSCBS]{estimateKappa}}).

  For total copy-number (TCN) data (only),
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{PairedPSCBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  gapsToSegments.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{gapsToSegments.data.frame}
\alias{gapsToSegments.data.frame}
\alias{gapsToSegments}

\title{Gets the genomic segments that are complementary to the gaps}

\description{
 Gets the genomic segments that are complementary to the gaps, with default chromosome boundaries being \code{-Inf}
 and \code{+Inf}.
}

\usage{
\method{gapsToSegments}{data.frame}(gaps, resolution=1L, minLength=0L, dropGaps=FALSE, ...)
}

\arguments{
  \item{gaps}{A \code{\link[base]{data.frame}} with columns \code{chromosome}, \code{start},
    and \code{stop}. Any overlapping gaps will throw an error.}
  \item{resolution}{A non-negative \code{\link[base]{numeric}} specifying the minimum
    length unit, which by default equals one nucleotide/base pair.}
  \item{minLength}{Minimum length of segments to be kept.}
  \item{dropGaps}{If \code{\link[base:logical]{TRUE}}, the gaps themselves are not part of the output.}
  \item{...}{Not used.}
}

\value{
  Returns \code{\link[base]{data.frame}} of least one row with columns \code{chromosome}
  if that argument is given), \code{start}, \code{stop} and \code{length}.
  The segments are ordered along the genome.
}

\author{Henrik Bengtsson}

\seealso{
  \code{\link{findLargeGaps}}().
}


\keyword{methods}
\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{AbstractCBS$load}
\alias{AbstractCBS$load}
\alias{load.AbstractCBS}
\alias{AbstractCBS.load}
\alias{load,AbstractCBS-method}
\alias{load}

\title{Loads an AbstractCBS object from file}

\description{
 Loads an AbstractCBS object from file and assert that it is of the requested class.
}

\usage{
## Static method (use this):
## AbstractCBS$load(...)

## Don't use the below:
\method{load}{AbstractCBS}(static, ...)
}

\arguments{
  \item{...}{Additional arguments passed to \code{\link[R.utils]{loadObject}}.}
}

\value{
  Returns the loaded AbstractCBS object.
}

\author{Henrik Bengtsson}

\seealso{
  Internally \code{\link[R.utils]{loadObject}} is used.
  To save an object, see \code{\link[PSCBS:save.AbstractCBS]{*save}()}.
  For more information see \code{\link{AbstractCBS}}..
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.estimateDeltaAB.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{estimateDeltaABBySmallDH.PairedPSCBS}
\alias{estimateDeltaABBySmallDH.PairedPSCBS}
\alias{PairedPSCBS.estimateDeltaABBySmallDH}
\alias{estimateDeltaABBySmallDH,PairedPSCBS-method}

\title{Estimate a threshold for calling allelic balance from DH}

\description{
 Estimate a threshold for calling allelic balance from DH.
}

\usage{
\method{estimateDeltaABBySmallDH}{PairedPSCBS}(fit, q1=0.05, q2=0.9, ..., verbose=FALSE)
}

\arguments{
  \item{q1}{A \code{\link[base]{numeric}} value specifying the weighted quantile of the
   segment-level DHs used to identify segments with small DH means.}
  \item{q2}{A \code{\link[base]{numeric}} value specifying the quantile of the locus-level
   DH signals for those segments with small DH mean levels.}
  \item{...}{Not used.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns the threshold estimate as a \code{\link[base]{numeric}} scalar.
}

\section{Algorithm}{
 \itemize{
  \item Grabs the segment-level DH estimates.
  \item Calculate segment weights proportional to the number
        of heterozygous SNPs.
  \item Calculate \eqn{\Delta} as the 5\% quantile of the weighted DH means.
  \item Choose the segments with means less than \eqn{\Delta}.
  \item Calculate threshold \eqn{\Delta_{AB}} as the 90\% "symmetric" quantile
        of the observed locus-level DHs from the selected segments
        in Step 4.
        The q:th "symmetric" quantile is estimated by estimating
        the ((1-q), 50\%) quantiles, calculating their distance as
        "50\%-(1-q)" and add to the median (50\%), i.e.
        "median + (median-(1-q))" = "2*median-1 + q", which should
        equal q if the distribution is symmetric.
 }
}

\author{Henrik Bengtsson}

\seealso{
  Instead of calling this method explicitly, it is recommended
  to use the \code{\link[PSCBS:estimateDeltaAB.PairedPSCBS]{*estimateDeltaAB}()} method.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.RESTRUCT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{mergeTwoSegments.PairedPSCBS}
\alias{mergeTwoSegments.PairedPSCBS}
\alias{PairedPSCBS.mergeTwoSegments}
\alias{mergeTwoSegments,PairedPSCBS-method}

\title{Merge two neighboring segments}

\description{
  Merge two neighboring segments by recalculating segment statistics.
}

\usage{
\method{mergeTwoSegments}{PairedPSCBS}(this, left, update=TRUE, verbose=FALSE, ...)
}

\arguments{
 \item{left}{An \code{\link[base]{integer}} specifying the segments (left, left+1)
   to be merged.}
 \item{update}{If \code{\link[base:logical]{TRUE}}, segment statistics are updated.}
 \item{verbose}{A \code{\link[base]{logical}} or a \code{\link[R.utils]{Verbose}} object.}
 \item{...}{Not used.}
}

\value{
  Returns a \code{\link{PairedPSCBS}} with one less segment.
}

\author{Henrik Bengtsson}

\seealso{
  To drop regions (a connected set of segments) see \code{dropRegions()}.
  For more information see \code{\link{PairedPSCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  callSegmentationOutliers.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{callSegmentationOutliers}
\alias{callSegmentationOutliers}

\alias{callSegmentationOutliers.default}
\alias{callSegmentationOutliers.data.frame}
\alias{dropSegmentationOutliers}
\alias{dropSegmentationOutliers.default}
\alias{dropSegmentationOutliers.data.frame}

\title{Calls/drops single-locus outliers along the genome}

\description{
 Calls/drops single-locus outliers along the genome that have a signal that differ significantly from the
 neighboring loci.
}

\usage{
 \method{callSegmentationOutliers}{default}(y, chromosome=0, x=NULL, method="DNAcopy::smooth.CNA", ...,
  verbose=FALSE)
 \method{callSegmentationOutliers}{data.frame}(y, ...)
 \method{dropSegmentationOutliers}{default}(y, ...)
 \method{dropSegmentationOutliers}{data.frame}(y, ...)
}

\arguments{
  \item{y}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J genomic signals to be segmented.}
  \item{chromosome}{(Optional) An \code{\link[base]{integer}} scalar
      (or a \code{\link[base]{vector}} of length J contain a unique value).
      Only used for annotation purposes.}
  \item{x}{Optional \code{\link[base]{numeric}} \code{\link[base]{vector}} of J genomic locations.
           If \code{\link[base]{NULL}}, index locations \code{1:J} are used.}
  \item{method}{A \code{\link[base]{character}} string specifying the method
       used for calling outliers.}
  \item{...}{Additional arguments passed to internal outlier
       detection method.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  \code{callSegmentationOutliers()} returns a \code{\link[base]{logical}} \code{\link[base]{vector}} of length J.
  \code{dropSegmentationOutliers()} returns an object of the same type
  as argument \code{y}, where the signals for which outliers were called
  have been set to \code{\link[base]{NA}}.
}

\section{Missing and non-finite values}{
  Signals as well as genomic positions may contain missing
  values, i.e. \code{\link[base]{NA}}s or \code{\link[base:is.finite]{NaN}}s.  By definition, these cannot
  be outliers.
}

\author{Henrik Bengtsson}

\seealso{
  Internally \code{\link[DNAcopy]{smooth.CNA}} is utilized to identify
  the outliers.
}


\keyword{methods}
\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.REPORT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{report.AbstractCBS}
\alias{report.AbstractCBS}
\alias{AbstractCBS.report}
\alias{report,AbstractCBS-method}

\title{Generates a report of the segmentation results}

\description{
 Generates a report of the segmentation results.
 Currently reports can be generated for segmentation results of class
 \code{\link{CBS}} and \code{\link{PairedPSCBS}}.
}

\usage{
\method{report}{AbstractCBS}(fit, sampleName=getSampleName(fit), studyName, ..., rspTags=NULL,
  rootPath="reports/", .filename="*", skip=TRUE, envir=new.env(), verbose=FALSE)
}

\arguments{
  \item{fit}{An \code{\link{AbstractCBS}} object.}
  \item{sampleName}{A \code{\link[base]{character}} string specifying the name of the
     sample segmented.}
  \item{studyName}{A \code{\link[base]{character}} string specifying the name of study/project.}
  \item{...}{Optional arguments passed to the RSP template.}
  \item{rspTags}{Optional \code{\link[base]{character}} \code{\link[base]{vector}} of tags for further specifying
     which RSP report to generate.}
  \item{rootPath}{The root directory where to write the report.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns the pathname of the generated PDF.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.RESTRUCT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{Restructuring AbstractCBS objects}
\alias{Restructuring AbstractCBS objects}
\title{Restructuring AbstractCBS objects}

\alias{RestructPSCBS}

\description{
  This page describes available methods for restructuring an
  \code{\link{AbstractCBS}} object.

  \itemize{
    \item \code{\link[PSCBS:extractChromosomes.AbstractCBS]{*extractChromosomes}()} /
          \code{\link[PSCBS:extractChromosome.AbstractCBS]{*extractChromosome}()}
          - Extracts an \code{\link{AbstractCBS}} with the specified chromosomes.

    \item \code{\link[PSCBS:extractSegments.AbstractCBS]{*extractSegments}()} /
          \code{\link[PSCBS:extractSegment.AbstractCBS]{*extractSegment}()}
          - Extracts an \code{\link{AbstractCBS}} with the specified segments.

    \item \code{\link[PSCBS:extractRegions.AbstractCBS]{*extractRegions}()} /
          \code{\link[PSCBS:extractRegion.AbstractCBS]{*extractRegion}()}
          - Extracts an \code{\link{AbstractCBS}} with the specified regions
            each of a certain size, where a region is defined as a
            connected set of segments.

    \item \code{\link[PSCBS:dropRegions.AbstractCBS]{*dropRegions}()} /
          \code{\link[PSCBS:dropRegion.AbstractCBS]{*dropRegion}()}
          - Drops specified regions and returns an \code{\link{AbstractCBS}}
            without them.

    \item \code{\link[PSCBS:dropChangePoint.AbstractCBS]{*dropChangePoint}()} /
          \code{\link[PSCBS:mergeTwoSegments.AbstractCBS]{*mergeTwoSegments}()}
          - Drops a change point by merging two neighboring segments
            and recalculates the statistics for the merged segment
            before returning an \code{\link{AbstractCBS}}.

    \item \code{\link[PSCBS:dropChangePoints.AbstractCBS]{*dropChangePoints}()}
          - Drops zero or more change points
            and recalculates the segment statistics
            before returning an \code{\link{AbstractCBS}}.

    \item \code{\link[PSCBS:mergeThreeSegments.AbstractCBS]{*mergeThreeSegments}()}
          - Merges a segment with its two flanking segments
            and recalculates the statistics for the merged segment
            before returning an \code{\link{AbstractCBS}}.
  }

  All of the above methods are implemented for \code{\link{CBS}} and
  \code{\link{PairedPSCBS}} objects.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}.
}


\keyword{documentation}
\keyword{internal}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  segmentByNonPairedPSCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{segmentByNonPairedPSCBS}
\alias{segmentByNonPairedPSCBS.default}
\alias{segmentByNonPairedPSCBS}
\alias{segmentByNonPairedPSCBS.data.frame}
\alias{segmentByNonPairedPSCBS.PairedPSCBS}
\alias{segmentByNonPairedPSCBS}

\title{Segment total copy numbers and allele B fractions using the Non-paired PSCBS method}

\description{
 Segment total copy numbers and allele B fractions using the Non-paired PSCBS method [1].
 This method does not requires matched normals.
 This is a low-level segmentation method.
 It is intended to be applied to one tumor sample at the time.
}

\usage{
\method{segmentByNonPairedPSCBS}{default}(CT, betaT, ..., flavor=c("tcn", "tcn&dh", "tcn,dh",
  "sqrt(tcn),dh", "sqrt(tcn)&dh"), tauA=NA, tauB=1 - tauA, verbose=FALSE)
}

\arguments{
  \item{CT}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J tumor total copy number (TCN)
       ratios in [0,+\code{\link[base:is.finite]{Inf}}) (due to noise, small negative values are
       also allowed).  The TCN ratios are typically scaled such that
       copy-neutral diploid loci have a mean of two.}
  \item{betaT}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J tumor allele B fractions (BAFs)
       in [0,1] (due to noise, values may be slightly outside as well)
       or \code{\link[base]{NA}} for non-polymorphic loci.}
  \item{...}{Additional arguments passed to \code{\link{segmentByPairedPSCBS}}().}
  \item{flavor}{A \code{\link[base]{character}} specifying what type of segmentation and
    calling algorithm to be used.}
  \item{tauA, tauB}{Lower and upper thresholds (\code{tauA < tauB} for
    calling SNPs  heterozygous based on the tumor allele B fractions
    (\code{betaT}).  If \code{\link[base]{NA}}, then they are estimates from data.
  }
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns the segmentation results as a \code{\link{NonPairedPSCBS}} object.
}

\details{
  Internally \code{\link{segmentByPairedPSCBS}}() is used for segmentation.
  This segmentation method does \emph{not} support weights.
}

\section{Reproducibility}{
  The "DNAcopy::segment" implementation of CBS uses approximation
  through random sampling for some estimates.  Because of this,
  repeated calls using the same signals may result in slightly
  different results, unless the random seed is set/fixed.
}

\section{Whole-genome segmentation is preferred}{
  Although it is possible to segment each chromosome independently
  using Paired PSCBS, we strongly recommend to segment whole-genome
  (TCN,BAF) data at once.  The reason for this is that downstream
  CN-state calling methods, such as the AB and the LOH callers,
  performs much better on whole-genome data.  In fact, they may
  fail to provide valid calls if done chromosome by chromosome.
}

\section{Missing and non-finite values}{
  The total copy number signals as well as any optional positions
  must not contain missing values, i.e. \code{\link[base]{NA}}s or \code{\link[base:is.finite]{NaN}}s.
  If there are any, an informative error is thrown.
  Allele B fractions may contain missing values, because such are
  interpreted as representing non-polymorphic loci.

  None of the input signals may have infinite values, i.e. -\code{\link[base:is.finite]{Inf}} or +\code{\link[base:is.finite]{Inf}}.
  If so, an informative error is thrown.
}

\section{Non-Paired PSCBS with known genotypes}{
  If allele B fractions for the matched normal (\code{betaN}) are
  not available, but genotypes (\code{muN}) are, then it is possible
  to run Paired PSCBS.   See \code{\link{segmentByPairedPSCBS}}() for details.
}

\examples{
verbose <- R.utils::Arguments$getVerbose(-10*interactive(), timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Load SNP microarray data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
data <- PSCBS::exampleData("paired.chr01")
str(data)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Paired PSCBS segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Drop single-locus outliers
dataS <- dropSegmentationOutliers(data)

# Speed up example by segmenting fewer loci
dataS <- dataS[seq(from=1, to=nrow(data), by=20),]

str(dataS)

R.oo::attachLocally(dataS)

# Non-Paired PSCBS segmentation
fit <- segmentByNonPairedPSCBS(CT, betaT=betaT,
                            chromosome=chromosome, x=x,
                            seed=0xBEEF, verbose=verbose)
print(fit)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Bootstrap segment level estimates
# (used by the AB caller, which, if skipped here,
#  will do it automatically)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fit <- bootstrapTCNandDHByRegion(fit, B=100, verbose=verbose)
print(fit)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calling segments in allelic balance (AB)
# NOTE: Ideally, this should be done on whole-genome data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Explicitly estimate the threshold in DH for calling AB
# (which be done by default by the caller, if skipped here)
deltaAB <- estimateDeltaAB(fit, flavor="qq(DH)", verbose=verbose)
print(deltaAB)

fit <- callAB(fit, delta=deltaAB, verbose=verbose)
print(fit)


# Even if not explicitly specified, the estimated
# threshold parameter is returned by the caller
stopifnot(fit$params$deltaAB == deltaAB)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calling segments in loss-of-heterozygosity (LOH)
# NOTE: Ideally, this should be done on whole-genome data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Explicitly estimate the threshold in C1 for calling LOH
# (which be done by default by the caller, if skipped here)
deltaLOH <- estimateDeltaLOH(fit, flavor="minC1|nonAB", verbose=verbose)
print(deltaLOH)

fit <- callLOH(fit, delta=deltaLOH, verbose=verbose)
print(fit)
plotTracks(fit)

# Even if not explicitly specified, the estimated
# threshold parameter is returned by the caller
stopifnot(fit$params$deltaLOH == deltaLOH)
}

\author{Henrik Bengtsson}

\references{
 [1] A.B. Olshen, H. Bengtsson, P. Neuvial, P.T. Spellman, R.A. Olshen, V.E. Seshan, \emph{Parent-specific copy number in paired tumor-normal studies using circular binary segmentation}, Bioinformatics, 2011
 \cr
 [2] H. Bengtsson, P. Neuvial and T.P. Speed, \emph{TumorBoost: Normalization of allele-specific tumor copy numbers from a single pair of tumor-normal genotyping microarrays}, BMC Bioinformatics, 2010
 \cr
}

\seealso{
  To segment paired tumor-normal total copy numbers and allele B fractions,
  see \code{\link{segmentByPairedPSCBS}}().

  To segment total copy numbers, or any other unimodal signals,
  see \code{\link{segmentByCBS}}().
}


\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{normalizeTotalCNs.AbstractCBS}
\alias{normalizeTotalCNs.AbstractCBS}
\alias{AbstractCBS.normalizeTotalCNs}
\alias{normalizeTotalCNs,AbstractCBS-method}
\alias{normalizeTotalCNs}
\alias{normalizeTotalCNs.PSCBS}

\title{Normalizes copy numbers such that the whole-genome average total copy number is two}

\description{
 Normalizes copy numbers such that the whole-genome average total copy number is two.
}

\usage{
\method{normalizeTotalCNs}{AbstractCBS}(...)
}

\arguments{
  \item{...}{Additional arguments passed to the normalization method.}
}

\value{
  Returns a normalized AbstractCBS object of the same class as \code{fit}.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}..
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.HCLUST.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{hclustCNs.AbstractCBS}
\alias{hclustCNs.AbstractCBS}
\alias{AbstractCBS.hclustCNs}
\alias{hclustCNs,AbstractCBS-method}

\title{Performs a hierarchical clustering of the CN mean levels}

\description{
 Performs a hierarchical clustering of the CN mean levels.
}

\usage{
\method{hclustCNs}{AbstractCBS}(fit, size=NULL, distMethod="euclidean", hclustMethod="ward.D", ...,
  verbose=FALSE)
}

\arguments{
 \item{size}{Argument passed to \code{\link[PSCBS:sampleCNs.AbstractCBS]{*sampleCNs}()}.}
 \item{distMethod, hclustMethod}{Argument \code{method} for
   \code{\link[stats]{dist}} and "stats::hclust", respectively.}
 \item{...}{Not used.}
 \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns a \code{hclust} object as returned by \code{\link[stats]{hclust}}.
}

\author{Henrik Bengtsson}

\seealso{
  This method is utilized by \code{\link[PSCBS:pruneByHClust.AbstractCBS]{*pruneByHClust}()}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.IO.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{writeSegments.CBS}
\alias{writeSegments.CBS}
\alias{CBS.writeSegments}
\alias{writeSegments,CBS-method}
\alias{writeWIG}
\alias{writeWIG.AbstractCBS}

\title{Writes the table of segments to file}

\description{
 Writes the table of segments to file.
}

\usage{
\method{writeSegments}{CBS}(fit, name=getSampleName(fit), tags=NULL, ext="tsv", path=NULL,
  addHeader=TRUE, createdBy=NULL, sep="\t", nbrOfDecimals=4L, splitters=FALSE,
  overwrite=FALSE, skip=FALSE, ...)
}

\arguments{
  \item{name, tags}{Name and optional tags part of the filename}.
  \item{path}{The directory where the file will be written.}
  \item{addHeader}{If \code{\link[base:logical]{TRUE}}, header comments are written.}
  \item{createdBy}{A header comment of whom created the file.}
  \item{splitters}{If \code{\link[base:logical]{TRUE}}, each chromosome is separated by a row
    of missing values.}
  \item{overwrite, skip}{If an output file already exists, these
    arguments specifies what should happen.}
  \item{...}{Additional arguments pass to \code{getSegments()}.}
}

\value{
  Returns the pathname of the the file written.
}

\author{Henrik Bengtsson}

\seealso{
  Utilizes \code{\link[PSCBS:getSegments.CBS]{*getSegments}()}.
  For more information see \code{\link{CBS}}..
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.joinSegments.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{joinSegments.CBS}
\alias{joinSegments.CBS}
\alias{CBS.joinSegments}
\alias{joinSegments,CBS-method}

\title{Joins neighboring segments such that there is no gap in between them}

\description{
 Joins neighboring segments such that there is no gap in between them.
 For instance, consider two neighboring segments [x1,x2] and [x3,x4]
 with x1 < x2 < x3 < x4.  After join the segments, they are
 [x1,x23] and [x23,x4] where x23 = (x2 + x3)/2.
}

\usage{
\method{joinSegments}{CBS}(fit, range=NULL, verbose=FALSE, ...)
}

\arguments{
  \item{range}{(optional) A \code{\link[base]{numeric}} \code{\link[base]{vector}} of length two.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
  \item{...}{Not used.}
}

\value{
  Returns an updated \code{\link{CBS}} object.
}

\details{
  This function assumes only chromosome exists.
  If more, an error will be thrown.
}

\author{Henrik Bengtsson}



\keyword{internal}
\keyword{methods}
\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{resetSegments.AbstractCBS}
\alias{resetSegments.AbstractCBS}
\alias{AbstractCBS.resetSegments}
\alias{resetSegments,AbstractCBS-method}

\title{Reset the segments}

\description{
  Reset the segments.  More precisely, it removes columns in the segmentation
  result table that have been added by methods after the actual
  segmentation method, e.g. bootstrap estimated mean level quantiles
  and various calls.
  It leave the basic segmentation results untouched,
  i.e. the partitioning and the segment means.
}

\usage{
\method{resetSegments}{AbstractCBS}(fit, ...)
}

\arguments{
 \item{...}{Not used.}
}

\value{
  Returns an object if the same class as the input result.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  randomSeed.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{randomSeed}
\alias{randomSeed}


\title{Sets and resets the .Random.seed in the global environment}

\description{
 Sets and resets the .Random.seed in the global environment.
}

\usage{
 randomSeed(action=c("set", "advance", "reset", "get"), seed=NULL, kind=NULL, n=1L,
  backup=TRUE)
}

\arguments{
  \item{action}{A \code{\link[base]{character}} string specifying the action.}
  \item{seed}{Random seed to be set; only for \code{action="set"}.
    If \code{length(seed) == 1}, then \code{set.seed(seed)} is
    used, otherwise \code{.Random.seed} is assigned the value.}
  \item{kind}{(optional) A \code{\link[base]{character}} string specifying type of
    random number generator to use, cf. \code{\link[base]{RNGkind}}().}
  \item{n}{Number of random seeds to generate by \code{action}.}
  \item{backup}{If \code{\link[base:logical]{TRUE}}, the previous (seed, kind) state is recorded
    such that it can be reset later.}
}

\value{
  Returns a \code{.Random.seed}.
  If more than one is returned, the they are returned as a \code{\link[base]{list}}.
}

\author{Henrik Bengtsson}


\keyword{internal}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{updateMeans.AbstractCBS}
\alias{updateMeans.AbstractCBS}
\alias{AbstractCBS.updateMeans}
\alias{updateMeans,AbstractCBS-method}
\alias{updateMeans.CBS}
\alias{updateMeans.NonPairedPSCBS}
\alias{updateMeans.PairedPSCBS}

\title{Updates the CN mean levels for each segment independently}

\description{
 Updates the CN mean levels for each segment independently as if they were one large segment.
 The locus-level data is not updated/modified.
}

\usage{
\method{updateMeans}{AbstractCBS}(...)
}

\arguments{
 \item{...}{Arguments specific to the class.}
}

\value{
  Returns an object of the same class.
}

\author{Henrik Bengtsson}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  weightedQuantile.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{weightedQuantile}
\alias{weightedQuantile.default}
\alias{weightedQuantile}

\title{Weighted Quantile Value}

\usage{
\method{weightedQuantile}{default}(x, w, probs=c(0, 0.25, 0.5, 0.75, 1), na.rm=TRUE,
  method=c("wtd.quantile"), ...)
}

\description{
  Computes a weighted quantile of a numeric vector.
}

\arguments{
  \item{x}{a \code{\link[base]{numeric}} \code{\link[base]{vector}} containing the values whose weighted
           quantile is to be computed.}
  \item{w}{a numeric \code{\link[base]{vector}} of weights the same length as
           \code{x} giving the weights to use for each element of \code{x}.
           Negative weights are treated as zero weights.
           Default value is equal weight to all values.}
  \item{probs}{a \code{\link[base]{numeric}} \code{\link[base]{vector}} of quantiles in [0,1] to be retrieved.}
  \item{na.rm}{a \code{\link[base]{logical}} value indicating whether \code{\link[base]{NA}} values in
           \code{x} should be stripped before the computation proceeds,
           or not.}
  \item{method}{If \code{"wtd.quantile"}, then an internal copy of
           \code{Hmisc::wtd.quantile()} is used.
           No other methods are currently supported.}
  \item{...}{Additional arguments passed to the estimator.}
}

\value{
  Returns the weighted quantile.
}

\author{Henrik Bengtsson}

\seealso{
  Internally the following functions may be used:
  \code{\link[stats]{quantile}} (if no weights are specified), or an internal
  copy of \code{Hmisc::wtd.quantile()}.
  For a weighted median estimator, \code{\link[matrixStats]{weightedMedian}}
  of the \pkg{matrixStats} package.
}




\keyword{univar}
\keyword{robust}
\keyword{internal}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  installDNAcopy.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{installDNAcopy}
\alias{installDNAcopy.default}
\alias{installDNAcopy}

\title{Install the DNAcopy package}

\usage{
\method{installDNAcopy}{default}(..., force=FALSE)
}

\description{
  Install the DNAcopy package, if missing.
}

\arguments{
  \item{...}{Arguments passed to the install function.}
  \item{force}{If \code{\link[base:logical]{FALSE}} and the \pkg{DNAcopy} package is already
    installed, then it will not be re-install.
    If \code{\link[base:logical]{TRUE}}, it will be installed.}
}

\value{
  Returns nothing.
}

\details{
  This function is will download and call the \code{biocLite()}
  installation function from the Bioconductor Project website.
  This function will also make sure that \pkg{DNAcopy} is loaded so
  that it is reported by \code{\link[utils]{sessionInfo}}.
}

\author{Henrik Bengtsson}


\keyword{internal}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  999.package.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{PSCBS-package}
\alias{PSCBS-package}

\docType{package}

\title{Package PSCBS}



\description{
  Segmentation of allele-specific DNA copy number data and detection of regions with abnormal copy number within each parental chromosome.  Both tumor-normal paired and tumor-only analyses are supported..

  This package should be considered to be in an alpha or beta phase.
  You should expect the API to be changing over time.
}

\section{Installation and updates}{
  To install this package, use \code{install.packages("PSCBS")}.
}

\section{To get started}{
  To get started, see:
  \enumerate{
    \item Vignettes '\href{../doc/index.html}{Parent-specific copy-number segmentation using Paired PSCBS}' and '\href{../doc/index.html}{Total copy-number segmentation using CBS}'.
    \item \code{\link{segmentByCBS}}() - segments total copy-numbers, or any
          other unimodal genomic signals, using the CBS method [3,4].
    \item \code{\link{segmentByPairedPSCBS}}() - segments allele-specific
          tumor signal from a tumor \emph{with} a matched normal
          using the Paired PSCBS method [1,2].
    \item \code{\link{segmentByNonPairedPSCBS}}() - segments allele-specific
          tumor signal from a tumor \emph{without} a matched normal
          using the Non-Paired PSCBS method adopted from [1,2].
  }
}

\section{How to cite}{
  Please use [1] and [2] to cite when using Paired PSCBS,
  and [3] and [4] when using CBS.
  When using Non-Paired PSCBS, please cite [1] and [2] as well.
}

\author{Henrik Bengtsson}

\section{License}{
 GPL (>= 2).
}

\references{
 [1] A.B. Olshen, H. Bengtsson, P. Neuvial, P.T. Spellman, R.A. Olshen, V.E. Seshan, \emph{Parent-specific copy number in paired tumor-normal studies using circular binary segmentation}, Bioinformatics, 2011
 \cr
 [2] H. Bengtsson, P. Neuvial and T.P. Speed, \emph{TumorBoost: Normalization of allele-specific tumor copy numbers from a single pair of tumor-normal genotyping microarrays}, BMC Bioinformatics, 2010
 \cr
 [3] A.B. Olshen, E.S. Venkatraman (aka Venkatraman E. Seshan), R. Lucito and M. Wigler, \emph{Circular binary segmentation for the analysis of array-based DNA copy number data}, Biostatistics, 2004
 \cr
 [4] E.S. Venkatraman and A.B. Olshen, \emph{A faster circular binary segmentation algorithm for the analysis of array CGH data}, Bioinformatics, 2007
 \cr
}
\keyword{package}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.estimateDeltaLOH.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{estimateDeltaLOH.PairedPSCBS}
\alias{estimateDeltaLOH.PairedPSCBS}
\alias{PairedPSCBS.estimateDeltaLOH}
\alias{estimateDeltaLOH,PairedPSCBS-method}

\title{Estimate a threshold for calling LOH from DH}

\description{
 Estimate a threshold for calling LOH from DH to be used by the \code{\link[PSCBS:callLOH.PairedPSCBS]{*callLOH}()} method.
}

\usage{
\method{estimateDeltaLOH}{PairedPSCBS}(this, flavor=c("minC1|nonAB"), ..., max=Inf, verbose=FALSE)
}

\arguments{
  \item{flavor}{A \code{\link[base]{character}} string specifying which type of
   estimator to use.}
  \item{...}{Additional arguments passed to the estimator.}
  \item{max}{(Optional) The maximum estimate allowed. If greater than
   this value, the estimate will be truncated.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns the threshold estimate as a \code{\link[base]{numeric}} scalar or -\code{\link[base:is.finite]{Inf}}.
  In case it is not possible to estimate the LOH threshold, then
  -\code{\link[base:is.finite]{Inf}} is returned.
}

\author{Henrik Bengtsson}

\seealso{
  Internally, one of the following methods are used:
  \code{\link[PSCBS:estimateDeltaLOHByMinC1ForNonAB.PairedPSCBS]{*estimateDeltaLOHByMinC1ForNonAB}()}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getLocusData.AbstractCBS}
\alias{getLocusData.AbstractCBS}
\alias{AbstractCBS.getLocusData}
\alias{getLocusData,AbstractCBS-method}
\alias{AbstractCBS.setLocusData}
\alias{setLocusData.AbstractCBS}
\alias{setLocusData,AbstractCBS-method}

\alias{setLocusData.AbstractCBS}

\title{Gets the locus-level data}

\description{
  Gets the locus-level data.
}

\usage{
\method{getLocusData}{AbstractCBS}(...)
}

\arguments{
 \item{...}{Not used.}
}

\value{
  Returns a JxL \code{\link[base]{data.frame}}, where J in the number of loci,
  and L is the number of locus-specific fields.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.RESTRUCT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{dropChangePoints.AbstractCBS}
\alias{dropChangePoints.AbstractCBS}
\alias{AbstractCBS.dropChangePoints}
\alias{dropChangePoints,AbstractCBS-method}

\title{Drops zero or more change points}

\description{
  Drops zero or more change points, which is done by dropping one change point at the
  time using \code{\link[PSCBS:dropChangePoint.AbstractCBS]{*dropChangePoint}()}
  and recalculating the segment statistics at the end.

  \emph{NOTE: This method only works if there is only one chromosome.}
}

\usage{
\method{dropChangePoints}{AbstractCBS}(fit, idxs, update=TRUE, ...)
}

\arguments{
 \item{idxs}{An \code{\link[base]{integer}} \code{\link[base]{vector}} specifying the change points to be dropped.}
 \item{update}{If \code{\link[base:logical]{TRUE}}, segment statistics are updated.}
 \item{...}{Other arguments passed to \code{\link[PSCBS:dropChangePoint.AbstractCBS]{*dropChangePoint}()}
            and \code{\link[PSCBS:updateMeans.AbstractCBS]{*updateMeans}()}.}
}

\value{
  Returns an \code{\link{AbstractCBS}} of the same class with
  \code{length(idxs)} segments.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{PairedPSCBS}
\docType{class}
\alias{PairedPSCBS}


\title{The PairedPSCBS class}

\description{
 Package:  PSCBS \cr
\bold{Class PairedPSCBS}\cr

\code{list}\cr
\code{~~|}\cr
\code{~~+--}\code{\link[PSCBS]{AbstractCBS}}\cr
\code{~~~~~~~|}\cr
\code{~~~~~~~+--}\code{\link[PSCBS]{PSCBS}}\cr
\code{~~~~~~~~~~~~|}\cr
\code{~~~~~~~~~~~~+--}\emph{\code{PairedPSCBS}}\cr

\bold{Directly known subclasses:}\cr
\cr

public abstract class \bold{PairedPSCBS}\cr
extends \emph{\link[PSCBS]{PSCBS}}\cr



 A PairedPSCBS is an object containing the results from the
 Paired PSCBS method.
}

\usage{PairedPSCBS(fit=list(), ...)}

\arguments{
  \item{fit}{A \code{\link[base]{list}} structure containing the Paired PSCBS results.}
  \item{...}{Not used.}
}

\section{Fields and Methods}{
 \bold{Methods:}\cr
\tabular{rll}{
 \tab \code{\link[PSCBS:callAB.PairedPSCBS]{callAB}} \tab Calls segments that are in allelic balance.\cr
 \tab \code{\link[PSCBS:callCopyNeutral.PairedPSCBS]{callCopyNeutral}} \tab Calls segments that have a neutral total copy number.\cr
 \tab \code{\link[PSCBS:callGNL.PairedPSCBS]{callGNL}} \tab Calls segments that are gained, copy neutral, or lost.\cr
 \tab \code{callGNLByTCNofAB} \tab  -\cr
 \tab \code{callGainNeutralLoss} \tab  -\cr
 \tab \code{\link[PSCBS:callLOH.PairedPSCBS]{callLOH}} \tab Calls segments that are in LOH.\cr
 \tab \code{callNTCN} \tab  -\cr
 \tab \code{\link[PSCBS:callROH.PairedPSCBS]{callROH}} \tab Calls segments that are in ROH.\cr
 \tab \code{\link[PSCBS:estimateDeltaAB.PairedPSCBS]{estimateDeltaAB}} \tab Estimate a threshold for calling allelic balance from DH.\cr
 \tab \code{\link[PSCBS:estimateDeltaLOH.PairedPSCBS]{estimateDeltaLOH}} \tab Estimate a threshold for calling LOH from DH.\cr
 \tab \code{\link[PSCBS:estimateKappa.PairedPSCBS]{estimateKappa}} \tab Estimate global background in segmented copy numbers.\cr
 \tab \code{extractCNs} \tab  -\cr
 \tab \code{hasBootstrapSummaries} \tab  -\cr
 \tab \code{plotTracks} \tab  -\cr
 \tab \code{segmentByNonPairedPSCBS} \tab  -\cr
 \tab \code{segmentByPairedPSCBS} \tab  -\cr
 \tab \code{seqOfSegmentsByDP} \tab  -\cr
}


 \bold{Methods inherited from PSCBS}:\cr
as.data.frame, c, drawChangePoints, extractChromosomes, extractWIG, getLocusData, getLocusSignalNames, getSegmentTrackPrefixes, isLocallyPhased, isSegmentSplitter, normalizeTotalCNs, writeSegments

 \bold{Methods inherited from AbstractCBS}:\cr
adjustPloidyScale, all.equal, as.data.frame, clearCalls, drawChangePoints, drawKnownSegments, dropChangePoint, dropChangePoints, dropRegion, dropRegions, extractCNs, extractChromosome, extractChromosomes, extractRegions, extractSegments, extractWIG, getChangePoints, getChromosomeOffsets, getChromosomeRanges, getChromosomes, getLocusData, getLocusSignalNames, getMeanEstimators, getSampleName, getSegmentSizes, getSegmentTrackPrefixes, getSegments, mergeThreeSegments, mergeTwoSegments, nbrOfChangePoints, nbrOfChromosomes, nbrOfLoci, nbrOfSegments, normalizeTotalCNs, ploidy, ploidy<-, plotTracks, print, pruneByDP, pruneByHClust, renameChromosomes, report, resegment, resetSegments, sampleCNs, sampleName, sampleName<-, seqOfSegmentsByDP, setLocusData, setMeanEstimators, setPloidy, setSampleName, setSegments, shiftTCN, tileChromosomes, updateMeans, writeWIG

 \bold{Methods inherited from list}:\cr
Ops,nonStructure,vector-method, Ops,structure,vector-method, Ops,vector,nonStructure-method, Ops,vector,structure-method, all.equal, as.data.frame, attachLocally, averageQuantile, callHooks, coerce,ANY,list-method, normalizeAverage, normalizeDifferencesToAverage, normalizeQuantileRank, normalizeQuantileSpline, plotDensity, relist, reset, type.convert, within


}

\author{Henrik Bengtsson}

\seealso{
  The \code{\link{segmentByPairedPSCBS}}() method returns an object of this class.
}
\keyword{classes}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{as.data.frame.CBS}
\alias{as.data.frame.CBS}
\alias{CBS.as.data.frame}
\alias{as.data.frame,CBS-method}

\title{Gets the table of segments}

\description{
 Gets the table of segments.
}

\usage{
\method{as.data.frame}{CBS}(x, ...)
}

\arguments{
  \item{...}{Not used.}
}

\value{
  Returns a \code{\link[base]{data.frame}}, where each row corresponds to
  a unique segment.
}

\author{Henrik Bengtsson}

\seealso{
  Utilizes \code{\link[PSCBS:getSegments.CBS]{*getSegments}()}.
  For more information see \code{\link{CBS}}..
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  testROH.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{testROH.numeric}
\alias{testROH.numeric}

\title{Tests if a segment is in Run-of-Homozygosity (ROH)}

\description{
 Tests if a segment is in Run-of-Homozygosity (ROH).
}

\usage{
\method{testROH}{numeric}(muN, csN=NULL, betaN=NULL, minNbrOfSnps=1, delta=1/12, ..., verbose=FALSE)
}

\arguments{
  \item{muN}{An \code{\link[base]{numeric}} \code{\link[base]{vector}} of J genotype calls in
       \{0,1/2,1\} for AA, AB, and BB, respectively,
       and \code{\link[base]{NA}} for non-polymorphic loci.}
  \item{csN}{(optional) A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J genotype confidence scores.
       If \code{\link[base]{NULL}}, ad hoc scores calculated from \code{betaN} are used.}
  \item{betaN}{(optional) A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J matched normal BAFs
       in [0,1] (due to noise, values may be slightly outside as well)
       or \code{\link[base]{NA}} for non-polymorphic loci.}
  \item{minNbrOfSnps}{Minimum number of SNPs required to test segment.
       If not tested, \code{\link[base]{NA}} is returned.}
  \item{delta}{A \code{\link[base]{double}} scalar specifying the maximum (weighted)
       proportion of heterozygous SNPs allowed in an ROH region.}
  \item{...}{Not used.}
 \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
 Returns a \code{\link[base]{logical}}.
}

\author{Pierre Neuvial, Henrik Bengtsson}


\keyword{methods}
\keyword{internal}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  segmentByPairedPSCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{segmentByPairedPSCBS}
\alias{segmentByPairedPSCBS.default}
\alias{segmentByPairedPSCBS}
\alias{segmentByPairedPSCBS.data.frame}
\alias{segmentByPairedPSCBS.PairedPSCBS}
\alias{segmentByPairedPSCBS}

\title{Segment total copy numbers and allele B fractions using the Paired PSCBS method}

\description{
 Segment total copy numbers and allele B fractions using the Paired PSCBS method [1].
 This method requires matched normals.
 This is a low-level segmentation method.
 It is intended to be applied to one tumor-normal sample at the time.
}

\usage{
\method{segmentByPairedPSCBS}{default}(CT, thetaT=NULL, thetaN=NULL, betaT=NULL, betaN=NULL, muN=NULL,
  rho=NULL, chromosome=0, x=NULL, alphaTCN=0.009, alphaDH=0.001, undoTCN=0, undoDH=0,
  ..., avgTCN=c("mean", "median"), avgDH=c("mean", "median"),
  flavor=c("tcn&dh", "tcn,dh", "sqrt(tcn),dh", "sqrt(tcn)&dh", "tcn"), tbn=is.null(rho),
  joinSegments=TRUE, knownSegments=NULL, dropMissingCT=TRUE, seed=NULL, verbose=FALSE,
  preserveScale=FALSE)
}

\arguments{
  \item{CT}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J tumor total copy number (TCN)
       ratios in [0,+\code{\link[base:is.finite]{Inf}}) (due to noise, small negative values are
       also allowed).  The TCN ratios are typically scaled such that
       copy-neutral diploid loci have a mean of two.}
  \item{thetaT, thetaN}{(alternative) As an alternative to specifying
       tumor TCN \emph{ratios} relative to the match normal by
       argument \code{CT}, on may specify total tumor and normal
       signals seperately, in which case the TCN ratios \code{CT} are
       calculated as \eqn{CT = 2*thetaT/thetaN}.}
  \item{betaT}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J tumor allele B fractions (BAFs)
       in [0,1] (due to noise, values may be slightly outside as well)
       or \code{\link[base]{NA}} for non-polymorphic loci.}
  \item{betaN}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J matched normal BAFs in [0,1]
       (due to noise, values may be slightly outside as well) or \code{\link[base]{NA}}
       for non-polymorphic loci.}
  \item{muN}{An optional \code{\link[base]{numeric}} \code{\link[base]{vector}} of J genotype calls in
       \{0,1/2,1\} for AA, AB, and BB, respectively,
       and \code{\link[base]{NA}} for non-polymorphic loci.
       If not given, they are estimated from the normal BAFs using
       \code{\link[aroma.light]{callNaiveGenotypes}} as described in [2].}
  \item{rho}{(alternative to \code{betaT} and \code{betaN}/\code{muN})
       A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J decrease-of-heterozygosity signals (DHs)
       in [0,1] (due to noise, values may be slightly larger than one
       as well).  By definition, DH should be \code{\link[base]{NA}} for homozygous loci
       and for non-polymorphic loci.}
  \item{chromosome}{(Optional) An \code{\link[base]{integer}} scalar (or a \code{\link[base]{vector}} of length J),
       which can be used to specify which chromosome each locus belongs to
       in case multiple chromosomes are segments.
       This argument is also used for annotation purposes.}
  \item{x}{Optional \code{\link[base]{numeric}} \code{\link[base]{vector}} of J genomic locations.
           If \code{\link[base]{NULL}}, index locations \code{1:J} are used.}
  \item{alphaTCN, alphaDH}{The significance levels for segmenting total
       copy numbers (TCNs) and decrease-in-heterozygosity signals (DHs),
       respectively.}
  \item{undoTCN, undoDH}{Non-negative \code{\link[base]{numeric}}s.  If greater than 0,
       then a cleanup of segmentions post segmentation is done.
       See argument \code{undo} of \code{\link{segmentByCBS}}() for more
       details.}
  \item{avgTCN, avgDH}{A \code{\link[base]{character}} string specifying how to calculating
        segment mean levels \emph{after} change points have been
        identified.}
  \item{...}{Additional arguments passed to \code{\link{segmentByCBS}}().}
  \item{flavor}{A \code{\link[base]{character}} specifying what type of segmentation and
    calling algorithm to be used.}
  \item{tbn}{If \code{\link[base:logical]{TRUE}}, \code{betaT} is normalized before segmentation
    using the TumorBoost method [2], otherwise not.}
  \item{joinSegments}{If \code{\link[base:logical]{TRUE}}, there are no gaps between neighboring
    segments.
    If \code{\link[base:logical]{FALSE}}, the boundaries of a segment are defined by the support
    that the loci in the segments provides, i.e. there exist a locus
    at each end point of each segment.  This also means that there
    is a gap between any neighboring segments, unless the change point
    is in the middle of multiple loci with the same position.
    The latter is what \code{DNAcopy::segment()} returns.
  }
  \item{knownSegments}{Optional \code{\link[base]{data.frame}} specifying
    \emph{non-overlapping} known segments.  These segments must
    not share loci.  See \code{\link{findLargeGaps}}() and \code{\link{gapsToSegments}}().}
  \item{dropMissingCT}{If \code{\link[base:logical]{TRUE}}, loci for which 'CT' is missing
    are dropped, otherwise not.}
  \item{seed}{An (optional) \code{\link[base]{integer}} specifying the random seed to be
    set before calling the segmentation method.  The random seed is
    set to its original state when exiting.  If \code{\link[base]{NULL}}, it is not set.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
  \item{preserveScale}{\emph{Defunct - gives an error is specified.}}
}

\value{
  Returns the segmentation results as a \code{\link{PairedPSCBS}} object.
}

\details{
  Internally \code{\link{segmentByCBS}}() is used for segmentation.
  The Paired PSCBS segmentation method does \emph{not} support weights.
}

\section{Reproducibility}{
  The "DNAcopy::segment" implementation of CBS uses approximation
  through random sampling for some estimates.  Because of this,
  repeated calls using the same signals may result in slightly
  different results, unless the random seed is set/fixed.
}

\section{Whole-genome segmentation is preferred}{
  Although it is possible to segment each chromosome independently
  using Paired PSCBS, we strongly recommend to segment whole-genome
  (TCN,BAF) data at once.  The reason for this is that downstream
  CN-state calling methods, such as the AB and the LOH callers,
  performs much better on whole-genome data.  In fact, they may
  fail to provide valid calls if done chromosome by chromosome.
}

\section{Missing and non-finite values}{
  The total copy number signals as well as any optional positions
  must not contain missing values, i.e. \code{\link[base]{NA}}s or \code{\link[base:is.finite]{NaN}}s.
  If there are any, an informative error is thrown.
  Allele B fractions may contain missing values, because such are
  interpreted as representing non-polymorphic loci.

  None of the input signals may have infinite values, i.e. -\code{\link[base:is.finite]{Inf}} or +\code{\link[base:is.finite]{Inf}}.
  If so, an informative error is thrown.
}

\section{Paired PSCBS with only genotypes}{
  If allele B fractions for the matched normal (\code{betaN}) are
  not available, but genotypes (\code{muN}) are, then it is possible
  to run a version of Paired PSCBS where TumorBoost normalization
  of the tumor allele B fractions is skipped.  In order for this
  to work, argument \code{tbn} must be set to \code{\link[base:logical]{FALSE}}.
}

\examples{
verbose <- R.utils::Arguments$getVerbose(-10*interactive(), timestamp=TRUE)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Load SNP microarray data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
data <- PSCBS::exampleData("paired.chr01")
str(data)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Paired PSCBS segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Drop single-locus outliers
dataS <- dropSegmentationOutliers(data)

# Speed up example by segmenting fewer loci
dataS <- dataS[seq(from=1, to=nrow(data), by=10),]

str(dataS)

R.oo::attachLocally(dataS)

# Paired PSCBS segmentation
fit <- segmentByPairedPSCBS(CT, betaT=betaT, betaN=betaN,
                            chromosome=chromosome, x=x,
                            seed=0xBEEF, verbose=verbose)
print(fit)

# Plot results
plotTracks(fit)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Bootstrap segment level estimates
# (used by the AB caller, which, if skipped here,
#  will do it automatically)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fit <- bootstrapTCNandDHByRegion(fit, B=100, verbose=verbose)
print(fit)
plotTracks(fit)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calling segments in allelic balance (AB)
# NOTE: Ideally, this should be done on whole-genome data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Explicitly estimate the threshold in DH for calling AB
# (which be done by default by the caller, if skipped here)
deltaAB <- estimateDeltaAB(fit, flavor="qq(DH)", verbose=verbose)
print(deltaAB)
## [1] 0.1657131

fit <- callAB(fit, delta=deltaAB, verbose=verbose)
print(fit)
plotTracks(fit)

# Even if not explicitly specified, the estimated
# threshold parameter is returned by the caller
stopifnot(fit$params$deltaAB == deltaAB)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Calling segments in loss-of-heterozygosity (LOH)
# NOTE: Ideally, this should be done on whole-genome data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Explicitly estimate the threshold in C1 for calling LOH
# (which be done by default by the caller, if skipped here)
deltaLOH <- estimateDeltaLOH(fit, flavor="minC1|nonAB", verbose=verbose)
print(deltaLOH)
## [1] 0.625175

fit <- callLOH(fit, delta=deltaLOH, verbose=verbose)
print(fit)
plotTracks(fit)

# Even if not explicitly specified, the estimated
# threshold parameter is returned by the caller
stopifnot(fit$params$deltaLOH == deltaLOH)
}

\author{Henrik Bengtsson}

\references{
 [1] A.B. Olshen, H. Bengtsson, P. Neuvial, P.T. Spellman, R.A. Olshen, V.E. Seshan, \emph{Parent-specific copy number in paired tumor-normal studies using circular binary segmentation}, Bioinformatics, 2011
 \cr
 [2] H. Bengtsson, P. Neuvial and T.P. Speed, \emph{TumorBoost: Normalization of allele-specific tumor copy numbers from a single pair of tumor-normal genotyping microarrays}, BMC Bioinformatics, 2010
 \cr
}

\seealso{
  Internally, \code{\link[aroma.light]{callNaiveGenotypes}} is used to
  call naive genotypes, \code{\link[aroma.light]{normalizeTumorBoost}} is
  used for TumorBoost normalization, and \code{\link{segmentByCBS}}() is used
  to segment TCN and DH separately.

  To segment tumor total copy numbers and allele B fractions
  \emph{without} a matched normal, see \code{\link{segmentByNonPairedPSCBS}}().

  To segment total copy-numbers, or any other unimodal signals,
  see \code{\link{segmentByCBS}}().
}


\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.estimateDeltaLOH.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{estimateDeltaLOHByMinC1ForNonAB.PairedPSCBS}
\alias{estimateDeltaLOHByMinC1ForNonAB.PairedPSCBS}
\alias{PairedPSCBS.estimateDeltaLOHByMinC1ForNonAB}
\alias{estimateDeltaLOHByMinC1ForNonAB,PairedPSCBS-method}

\title{Estimate a threshold for calling LOH from DH}

\description{
 Estimate a threshold for calling LOH from DH based on the location of guessed C1=0 and C1=1 peaks.
}

\usage{
\method{estimateDeltaLOHByMinC1ForNonAB}{PairedPSCBS}(this, midpoint=1/2, maxC=3 * (ploidy(this)/2), ...,
  verbose=FALSE)
}

\arguments{
  \item{midpoint}{A \code{\link[base]{numeric}} scalar in [0,1] specifying the relative
   position of the midpoint between the estimated locations of
   C1=0 and C1=1 mean parameters.}
  \item{maxC}{Maximum total copy number of a segment in order to
   be included in the initial set of segments.}
  \item{...}{Not used.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns the estimated LOH threshold as a \code{\link[base]{numeric}} scalar or -\code{\link[base:is.finite]{Inf}}.
  In case it is not possible to estimate the LOH threshold, then
  -\code{\link[base:is.finite]{Inf}} is returned.
}

\details{
  This method requires that calls for allelic balances already have
  been me made, cf. \code{\link[PSCBS:callAllelicBalance.PairedPSCBS]{*callAllelicBalance}()}.
}

\section{Algorithm}{
 \itemize{
  \item Grabs the segment-level C1 estimates.
  \item Calculate segment weights proportional to the number of heterozygous SNPs.
  \item Estimate the C1=1 location as the weighted median C1 for segments that have been called to be in allelic balance.
  \item Estimate the C1=0 location as the smallest C1 among segments that are not in allelic balance.
  \item Let the LOH threshold be the midpoint of the estimates C1=0 and C1=1 locations.
 }
}

\author{Henrik Bengtsson}

\seealso{
  Instead of calling this method explicitly, it is recommended
  to use the \code{\link[PSCBS:estimateDeltaLOH.PairedPSCBS]{*estimateDeltaLOH}()} method.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.PRUNE.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{pruneByDP.AbstractCBS}
\alias{pruneByDP.AbstractCBS}
\alias{AbstractCBS.pruneByDP}
\alias{pruneByDP,AbstractCBS-method}

\title{Prunes the CN profile using dynamical programming}

\description{
 Prunes the CN profile using dynamical programming by specifying the target number of segments or alternative
 how of many change points to drop.
}

\usage{
\method{pruneByDP}{AbstractCBS}(fit, nbrOfSegments, ..., verbose=FALSE)
}

\arguments{
 \item{nbrOfSegments}{An \code{\link[base]{integer}} specifying the number of segments after
    pruning. If negative, the it specifies the number of change points
    to drop.}
 \item{...}{Optional arguments passed to \code{\link[PSCBS:seqOfSegmentsByDP.AbstractCBS]{*seqOfSegmentsByDP}()}.}
 \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns a pruned object of the same class.
}

\examples{\dontrun{
 # Drop two segments
 fitP <- pruneByDP(fit, nbrOfSegments=-2)
}}

\author{Henrik Bengtsson, Pierre Neuvial}

\references{
  [1] ... \cr
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.EXTS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{estimateStandardDeviation.CBS}
\alias{estimateStandardDeviation.CBS}
\alias{CBS.estimateStandardDeviation}
\alias{estimateStandardDeviation,CBS-method}

\title{Estimates the whole-genome standard deviation of the signals}

\description{
 Estimates the whole-genome standard deviation of the signals.
}

\usage{
\method{estimateStandardDeviation}{CBS}(fit, chromosomes=NULL, method=c("diff", "res", "abs",
  "DNAcopy"), estimator=c("mad", "sd"), na.rm=TRUE, weights=NULL, ...)
}

\arguments{
 \item{chromosomes}{An optional \code{\link[base]{vector}} specifying the subset of
   chromosomes used for the estimate.  If \code{\link[base]{NULL}}, all chromosomes are used.}
 \item{method}{A \code{\link[base]{character}} string specifying the method used.}
 \item{estimator}{A \code{\link[base]{character}} string or a \code{\link[base]{function}} specifying the
   internal estimator.}
 \item{na.rm}{If \code{\link[base:logical]{TRUE}}, missing values are dropped, otherwise not.}
 \item{weights}{An optional \code{\link[base]{double}} \code{\link[base]{vector}} of \code{nbrOfLoci()}
   non-negative weights.}
 \item{...}{Not used.}
}

\value{
 Returns a non-negative \code{\link[base]{numeric}} scale.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.SMOOTH.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{getSmoothLocusData.CBS}
\alias{getSmoothLocusData.CBS}
\alias{CBS.getSmoothLocusData}
\alias{getSmoothLocusData,CBS-method}

\title{Gets smoothed locus-level data}

\description{
 Gets smoothed locus-level data.
}

\usage{
\method{getSmoothLocusData}{CBS}(fit, by, ...)
}

\arguments{
  \item{fit}{An \code{\link{CBS}} object.}
  \item{by}{A \code{\link[base]{numeric}} scalar specifying the bin size.}
  \item{...}{Not used.}
}

\value{
  Returns a \code{\link[base]{data.frame}} where the
  first three columns are 'chromosome', 'x' (position),
  and 'count' (number of loci average over for the given bin),
  and the remaining ones are the smoothed locus-level data.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.PLOT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{plotTracks.PairedPSCBS}
\alias{plotTracks.PairedPSCBS}
\alias{PairedPSCBS.plotTracks}
\alias{plotTracks,PairedPSCBS-method}
\alias{PairedPSCBS.plotTracks1}
\alias{plotTracks1.PairedPSCBS}
\alias{plotTracks1,PairedPSCBS-method}

\alias{PairedPSCBS.plotTracks2}
\alias{plotTracks2.PairedPSCBS}
\alias{plotTracks2,PairedPSCBS-method}

\alias{PairedPSCBS.plotTracksManyChromosomes}
\alias{plotTracksManyChromosomes.PairedPSCBS}
\alias{plotTracksManyChromosomes,PairedPSCBS-method}

\alias{plot}

\title{Plots parental specific copy numbers along the genome}

\description{
 Plots parental specific copy numbers along the genome for one or more chromosomes.
 It is possible to specify what type of tracks to plot.
 Each type of track is plotted in its own panel.
}

\usage{
\method{plotTracks}{PairedPSCBS}(fit, ...)
}

\arguments{
  \item{x}{A result object returned by \code{\link{segmentByPairedPSCBS}}().}
  \item{tracks}{A \code{\link[base]{character}} \code{\link[base]{vector}} specifying what types of tracks to plot.}
  \item{scatter}{A \code{\link[base]{character}} \code{\link[base]{vector}} specifying which of the tracks should
    have scatter plot.}
  \item{calls}{A \code{\link[base]{character}} \code{\link[base]{vector}} of regular expression identifying
    call labels to be highlighted in the panels.}
  \item{pch}{The type of the scatter points, if any.}
  \item{col}{The color of the scatter points, if any.}
  \item{cex}{The size of the scatter points, if any.}
  \item{changepoints}{If \code{\link[base:logical]{TRUE}}, changepoints are drawn as vertical lines.}
  \item{grid}{If \code{\link[base:logical]{TRUE}}, horizontal lines are displayed.}
  \item{quantiles}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} in [0,1] specifying the quantiles
     of the confidence bands to be drawn, if any.}
  \item{xlim}{(Optional) The genomic range to plot.}
  \item{Clim}{The range of copy numbers.}
  \item{Blim}{The range of allele B fractions (BAFs) and
    decrease of heterozygosity (DHs).}
  \item{xScale}{The scale factor used for genomic positions.}
  \item{...}{Not used.}
  \item{add}{If \code{\link[base:logical]{TRUE}}, the panels plotted are added to the existing plot,
    otherwise a new plot is created.}
  \item{subplots}{If \code{\link[base:logical]{TRUE}}, then subplots are automatically setup.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns nothing.
}

\author{Henrik Bengtsson}



\keyword{internal}
\keyword{methods}
\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{nbrOfChromosomes.AbstractCBS}
\alias{nbrOfChromosomes.AbstractCBS}
\alias{AbstractCBS.nbrOfChromosomes}
\alias{nbrOfChromosomes,AbstractCBS-method}

\title{Gets the number of chromosomes}

\description{
  Gets the number of chromosomes.
}

\usage{
\method{nbrOfChromosomes}{AbstractCBS}(this, ...)
}

\arguments{
 \item{...}{Arguments passed to \code{\link[PSCBS:getChromosomes.AbstractCBS]{*getChromosomes}()}.}
}

\value{
  Returns an \code{\link[base]{integer}}.
}

\author{Henrik Bengtsson}

\seealso{
  \code{\link[PSCBS:getChromosomes.AbstractCBS]{*getChromosomes}()}.
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.EXTS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{as.CBS.DNAcopy}
\alias{as.CBS.DNAcopy}
\alias{DNAcopy.as.CBS}
\alias{as.CBS,DNAcopy-method}

\title{Coerces a DNAcopy object to a CBS object}

\description{
 Coerces a DNAcopy object to a CBS object.
}

\usage{
\method{as.CBS}{DNAcopy}(fit, sample=1L, ...)
}

\arguments{
  \item{fit}{A \code{\link[DNAcopy:DNAcopy]{DNAcopy}}. object
    (of the \pkg{DNAcopy} package.)}
  \item{sample}{An index specifying which sample to extract,
    if more than one exists.}
  \item{...}{Not used.}
}

\value{
  Returns a \code{\link{CBS}} object.
}

\author{Henrik Bengtsson}

\seealso{
  \code{\link[PSCBS:as.DNAcopy.CBS]{as.DNAcopy()}}.
  For more information see \code{\link[DNAcopy:DNAcopy]{DNAcopy}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.BOOT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{bootstrapTCNandDHByRegion.PairedPSCBS}
\alias{bootstrapTCNandDHByRegion.PairedPSCBS}
\alias{PairedPSCBS.bootstrapTCNandDHByRegion}
\alias{bootstrapTCNandDHByRegion,PairedPSCBS-method}

\title{Estimate confidence intervals of TCN and DH segment levels}

\description{
 Estimate confidence intervals of TCN and DH segment levels using bootstrap.
}

\usage{
\method{bootstrapTCNandDHByRegion}{PairedPSCBS}(fit, B=1000L, boot=NULL, ..., probs=c(0.025, 0.05, 0.95,
  0.975), statsFcn=NULL, what=c("segment", "changepoint"), force=FALSE, verbose=FALSE,
  .debug=FALSE)
}

\arguments{
  \item{B}{A positive \code{\link[base]{integer}} specifying the number of bootstrap samples.}
  \item{boot}{Alternatively, to generating \code{B} bootstrap samples,
     this specifies a pre-generated set of bootstrap samples as
     returned by \code{bootstrapSegmentsAndChangepoints()}.}
  \item{...}{Additional arguments passed to \code{bootstrapSegmentsAndChangepoints()}.}
  \item{probs}{The default quantiles to be estimated.}
  \item{statsFcn}{A (optional) \code{\link[base]{function}} that estimates confidence
     intervals given locus-level data.
     If \code{\link[base]{NULL}}, the \code{\link[stats]{quantile}} function is used.}
  \item{what}{A \code{\link[base]{character}} \code{\link[base]{vector}} specifying what to bootstrap.}
  \item{force}{If \code{\link[base:logical]{TRUE}}, already existing estimates are ignored,
     otherwise not.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
  \item{.debug}{(internal) If \code{\link[base:logical]{TRUE}}, additional sanity checks are
     performed internally.}
}

\value{
  Returns a \code{\link{PairedPSCBS}} object.
}

\author{Henrik Bengtsson}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{save.AbstractCBS}
\alias{save.AbstractCBS}
\alias{AbstractCBS.save}
\alias{save,AbstractCBS-method}

\title{Saves an AbstractCBS object to file}

\description{
 Saves an AbstractCBS object to file.
}

\usage{
\method{save}{AbstractCBS}(this, ...)
}

\arguments{
  \item{...}{Additional arguments passed to \code{\link[R.utils]{saveObject}}.}
}

\value{
  Returns what \code{\link[R.utils]{saveObject}} returns.
}

\author{Henrik Bengtsson}

\seealso{
  Internally \code{\link[R.utils]{saveObject}} is used.
  To load an object, see \code{\link[PSCBS:load.AbstractCBS]{*load}()}.
  For more information see \code{\link{AbstractCBS}}..
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.RESTRUCT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{mergeTwoSegments.AbstractCBS}
\alias{mergeTwoSegments.AbstractCBS}
\alias{AbstractCBS.mergeTwoSegments}
\alias{mergeTwoSegments,AbstractCBS-method}
\alias{AbstractCBS.dropChangePoint}
\alias{dropChangePoint.AbstractCBS}
\alias{dropChangePoint,AbstractCBS-method}


\title{Merge two neighboring segments}

\description{
  Merge two neighboring segments into one segment, which is done by dropping their
  common change point and recalculating the segment statistics.
}

\usage{
\method{mergeTwoSegments}{AbstractCBS}(...)
}

\arguments{
 \item{...}{Not used.}
}

\value{
  Returns an \code{\link{AbstractCBS}} of the same class with one less segment.
}

\author{Henrik Bengtsson}

\seealso{
  To merge a segment and its two flanking segments, see
  \code{\link[PSCBS:mergeThreeSegments.AbstractCBS]{*mergeThreeSegments}()}.
  To drop regions (a connected set of segments)
  see \code{\link[PSCBS:dropRegions.AbstractCBS]{*dropRegions}()}.
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.RESTRUCT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{mergeThreeSegments.AbstractCBS}
\alias{mergeThreeSegments.AbstractCBS}
\alias{AbstractCBS.mergeThreeSegments}
\alias{mergeThreeSegments,AbstractCBS-method}

\title{Merge a segment and its two flanking segments}

\description{
  Merge a segment and its two flanking segments into one segment, and recalculating the segment statistics.
}

\usage{
\method{mergeThreeSegments}{AbstractCBS}(fit, middle, ...)
}

\arguments{
 \item{middle}{An \code{\link[base]{integer}} specifying the three segments
   (middle-1, middle, middle+1) to be merged.}
 \item{...}{Additional arguments passed to \code{\link[PSCBS:mergeTwoSegments.AbstractCBS]{*mergeTwoSegments}()}.}
}

\value{
  Returns an \code{\link{AbstractCBS}} of the same class with two less segment.
}

\author{Henrik Bengtsson}

\seealso{
  Internally \code{\link[PSCBS:mergeTwoSegments.AbstractCBS]{*mergeTwoSegments}()} is used.
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.HCLUST.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{updateMeansTogether.AbstractCBS}
\alias{updateMeansTogether.AbstractCBS}
\alias{AbstractCBS.updateMeansTogether}
\alias{updateMeansTogether,AbstractCBS-method}
\alias{updateMeansTogether.CBS}
\alias{updateMeansTogether.PairedPSCBS}

\title{Updates the CN mean levels jointly in sets of segments}

\description{
 Updates the CN mean levels jointly in sets of segments as if they were one large segment.
 The locus-level data is not updated/modified.
}

\usage{
\method{updateMeansTogether}{AbstractCBS}(...)
}

\arguments{
 \item{...}{Not used.}
}

\value{
  Returns an object of the same class.
}

\author{Henrik Bengtsson}

\seealso{
  This method is utilized by \code{\link[PSCBS:pruneByHClust.AbstractCBS]{*pruneByHClust}()}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PSCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{PSCBS}
\docType{class}
\alias{PSCBS}


\title{The PSCBS class}

\description{
 Package:  PSCBS \cr
\bold{Class PSCBS}\cr

\code{list}\cr
\code{~~|}\cr
\code{~~+--}\code{\link[PSCBS]{AbstractCBS}}\cr
\code{~~~~~~~|}\cr
\code{~~~~~~~+--}\emph{\code{PSCBS}}\cr

\bold{Directly known subclasses:}\cr
\emph{\link[PSCBS]{NonPairedPSCBS}}, \emph{\link[PSCBS]{PairedPSCBS}}\cr

public abstract class \bold{PSCBS}\cr
extends \emph{\link[PSCBS]{AbstractCBS}}\cr



 A PSCBS is an object containing results from parent-specific copy-number
 (PSCN) segmentation.
}

\usage{PSCBS(fit=list(), ...)}

\arguments{
  \item{fit}{A \code{\link[base]{list}} structure containing the PSCN segmentation results.}
  \item{...}{Not used.}
}

\section{Fields and Methods}{
 \bold{Methods:}\cr
\tabular{rll}{
 \tab \code{c} \tab  -\cr
 \tab \code{isLocallyPhased} \tab  -\cr
 \tab \code{normalizeTotalCNs} \tab  -\cr
 \tab \code{\link[PSCBS:writeSegments.PSCBS]{writeSegments}} \tab Writes the table of segments to file.\cr
}


 \bold{Methods inherited from AbstractCBS}:\cr
adjustPloidyScale, all.equal, as.data.frame, clearCalls, drawChangePoints, drawKnownSegments, dropChangePoint, dropChangePoints, dropRegion, dropRegions, extractCNs, extractChromosome, extractChromosomes, extractRegions, extractSegments, extractWIG, getChangePoints, getChromosomeOffsets, getChromosomeRanges, getChromosomes, getLocusData, getLocusSignalNames, getMeanEstimators, getSampleName, getSegmentSizes, getSegmentTrackPrefixes, getSegments, mergeThreeSegments, mergeTwoSegments, nbrOfChangePoints, nbrOfChromosomes, nbrOfLoci, nbrOfSegments, normalizeTotalCNs, ploidy, ploidy<-, plotTracks, print, pruneByDP, pruneByHClust, renameChromosomes, report, resegment, resetSegments, sampleCNs, sampleName, sampleName<-, seqOfSegmentsByDP, setLocusData, setMeanEstimators, setPloidy, setSampleName, setSegments, shiftTCN, tileChromosomes, updateMeans, writeWIG

 \bold{Methods inherited from list}:\cr
Ops,nonStructure,vector-method, Ops,structure,vector-method, Ops,vector,nonStructure-method, Ops,vector,structure-method, all.equal, as.data.frame, attachLocally, averageQuantile, callHooks, coerce,ANY,list-method, normalizeAverage, normalizeDifferencesToAverage, normalizeQuantileRank, normalizeQuantileSpline, plotDensity, relist, reset, type.convert, within


}

\author{Henrik Bengtsson}

\seealso{
  \code{\link{PairedPSCBS}}.
}
\keyword{classes}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.callROH.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{callROH.PairedPSCBS}
\alias{callROH.PairedPSCBS}
\alias{PairedPSCBS.callROH}
\alias{callROH,PairedPSCBS-method}
\alias{callROH.NonPairedPSCBS}

\title{Calls segments that are in ROH}

\description{
 Calls segments that are in ROH, i.e. that have no (true) heterozygous genotypes.
 Run of homozygosity (ROH) is a property of the normal (germline) sample.
}

\usage{
\method{callROH}{PairedPSCBS}(fit, ..., updateMeans=TRUE, force=FALSE, verbose=FALSE)
}

\arguments{
  \item{...}{Additional arguments passed to \code{\link{testROH}}().}
  \item{updateMeans}{If \code{\link[base:logical]{TRUE}}, DH and (C1,C2) mean levels are set
   to \code{\link[base]{NA}} for segments called ROH, otherwise not.}
  \item{force}{If \code{\link[base:logical]{FALSE}}, and ROH calls already exits,
   then nothing is done, otherwise the calls are done.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns a \code{\link{PairedPSCBS}} object with ROH calls.
}

\author{Pierre Neuvial, Henrik Bengtsson}

\seealso{
  Internally, \code{\link{testROH}}() is used.
  To call allelic balance (AB) see \code{\link[PSCBS:callAB.PairedPSCBS]{*callAB}()}.
  To call loss of heterozygosity (LOH) see \code{\link[PSCBS:callLOH.PairedPSCBS]{*callLOH}()}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.callCopyNeutral.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{callCopyNeutralByTCNofAB.PairedPSCBS}
\alias{callCopyNeutralByTCNofAB.PairedPSCBS}
\alias{PairedPSCBS.callCopyNeutralByTCNofAB}
\alias{callCopyNeutralByTCNofAB,PairedPSCBS-method}

\title{Calls regions that are copy neutral}

\description{
 Calls regions that are copy neutral from the total copy numbers (TCNs) of segments
 in allelic balance (AB).
}

\usage{
\method{callCopyNeutralByTCNofAB}{PairedPSCBS}(fit, delta=estimateDeltaCN(fit), alpha=0.05, ..., force=FALSE,
  verbose=FALSE)
}

\arguments{
  \item{fit}{A PairedPSCBS fit object as returned by
    \code{\link[PSCBS]{segmentByPairedPSCBS}}.}
  \item{delta}{A non-negative \code{\link[base]{double}} specifying the width of the
    "acceptance" region.
    Defaults to half of the distance between two integer TCN states,
    i.e. 1/2.  This argument should be shrunken as a function of
    the amount of the normal contamination and other background signals.}
  \item{alpha}{A \code{\link[base]{double}} in [0,0.5] specifying the significance level
    of the confidence intervals used.}
  \item{...}{Additional arguments passed to
             \code{\link[PSCBS:calcStatsForCopyNeutralABs.PairedPSCBS]{*calcStatsForCopyNeutralABs}()}.}
  \item{force}{If \code{\link[base:logical]{TRUE}}, an already called object is skipped, otherwise not.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns a \code{\link{PairedPSCBS}} fit object where a column
  with the copy-neutral call.
}

\details{
  ...
}

%% examples "../incl/callCopyNeutralByTCNofAB.PairedPSCBS.Rex"

\author{Henrik Bengtsson}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  findNeutralCopyNumberState.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{findNeutralCopyNumberState}
\alias{findNeutralCopyNumberState.default}
\alias{findNeutralCopyNumberState}

\title{Call segments to be copy neutral based on allelic imbalance calls and total copy number estimates}

\description{
 Call segments to be copy neutral based on allelic imbalance calls and total copy number estimates.
}

\usage{
\method{findNeutralCopyNumberState}{default}(C, isAI, weights=NULL, ..., minDensity=1e-10,
  flavor=c("firstPeak", "maxPeak"), verbose=FALSE)
}

\arguments{
  \item{C}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} of region-level total copy number estimates.}
  \item{isAI}{A \code{\link[base]{logical}} \code{\link[base]{vector}} of "allelic imbalance" calls.}
  \item{weights}{An optional \code{\link[base]{numeric}} \code{\link[base]{vector}} of non-negative weights.}
  \item{...}{Further arguments to be passed to the density estimation
    function.}
  \item{minDensity}{A \code{\link[base]{numeric}} value, below which density peaks are
    discarded.}
  \item{flavor}{A \code{\link[base]{character}} string specifying how to identify the
    mode of the AB segments.}
  \item{verbose}{If \code{\link[base:logical]{TRUE}}, extra information is output.}
}

\value{
  A \code{\link[base]{logical}} \code{\link[base]{vector}} of "neutral copy number state" calls.
}

\author{Pierre Neuvial, Henrik Bengtsson}


\keyword{internal}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{nbrOfChangePoints.AbstractCBS}
\alias{nbrOfChangePoints.AbstractCBS}
\alias{AbstractCBS.nbrOfChangePoints}
\alias{nbrOfChangePoints,AbstractCBS-method}

\title{Gets the number of change points}

\description{
  Gets the number of change points, which is defined as the number of segments minus
  the number of chromosomes.
}

\usage{
\method{nbrOfChangePoints}{AbstractCBS}(fit, ignoreGaps=FALSE, dropEmptySegments=TRUE, ...)
}

\arguments{
 \item{...}{Not used.}
}

\value{
  Returns an \code{\link[base]{integer}}.
}

\author{Henrik Bengtsson}

\seealso{
  \code{\link[PSCBS:nbrOfSegments.AbstractCBS]{*nbrOfSegments}()}
  \code{\link[PSCBS:nbrOfChromosomes.AbstractCBS]{*nbrOfChromosomes}()}
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.PLOT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{plotTracks.AbstractCBS}
\alias{plotTracks.AbstractCBS}
\alias{AbstractCBS.plotTracks}
\alias{plotTracks,AbstractCBS-method}

\title{Plots the segmentation result along the genome}

\description{
  Plots the segmentation result along the genome.
}

\usage{
\method{plotTracks}{AbstractCBS}(...)
}

\arguments{
 \item{...}{...}
}

\value{
  Returns nothing.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{nbrOfLoci.AbstractCBS}
\alias{nbrOfLoci.AbstractCBS}
\alias{AbstractCBS.nbrOfLoci}
\alias{nbrOfLoci,AbstractCBS-method}

\title{Gets the number of loci}

\description{
  Gets the number of loci.
}

\usage{
\method{nbrOfLoci}{AbstractCBS}(fit, splitters=FALSE, ...)
}

\arguments{
 \item{splitters, ...}{Arguments passed to \code{\link[PSCBS:getLocusData.AbstractCBS]{*getLocusData}()}.}
}

\value{
  Returns an \code{\link[base]{integer}}.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.CALL.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{callAmplifications.CBS}
\alias{callAmplifications.CBS}
\alias{CBS.callAmplifications}
\alias{callAmplifications,CBS-method}

\title{Calls (focal) amplifications}

\description{
 Calls (focal) amplifications.
}

\usage{
\method{callAmplifications}{CBS}(fit, adjust=1, maxLength=2e+07, method=c("ucsf-exp"), ...,
  verbose=FALSE)
}

\arguments{
 \item{adjust}{A positive scale factor adjusting the sensitivity of the
   caller, where a value less (greater) than 1.0 makes the caller
   less (more) sensitive.}
 \item{maxLength}{A \code{\link[base]{double}} scalar specifying the maximum length of a segment
   in order for it to be considered a focal amplification.}
 \item{method}{A \code{\link[base]{character}} string specifying the calling algorithm to use.}
 \item{...}{Additional/optional arguments used to override the default
   parameters used by the caller.}
 \item{verbose}{\code{\link[R.utils]{Verbose}}.}
}

\value{
 Returns a \code{\link[PSCBS]{CBS}} object where \code{\link[base]{logical}} column
 'amplificationCall' has been appended to the segmentation table.
}

\section{The UCSF caller}{
  If \code{method == "ucsf-exp"}, then segments are called using [1], i.e.
  a segment is called an amplification if ...
}

\author{Henrik Bengtsson}

\references{
  [1] Fridlyand et al. \emph{Breast tumor copy number aberration
      phenotypes and genomic instability}, BMC Cancer, 2006. \cr
}

\seealso{
  \code{\link[PSCBS:callGainsAndLosses.CBS]{*callGainsAndLosses}()}.
  \code{\link[PSCBS:callOutliers.CBS]{*callOutliers}()}.
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.CALL.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getFractionOfGenomeLost.CBS}
\alias{getFractionOfGenomeLost.CBS}
\alias{CBS.getFractionOfGenomeLost}
\alias{getFractionOfGenomeLost,CBS-method}
\alias{CBS.getFractionOfGenomeGained}
\alias{getFractionOfGenomeGained.CBS}
\alias{getFractionOfGenomeGained,CBS-method}

\alias{CBS.getFractionOfGenomeAltered}
\alias{getFractionOfGenomeAltered.CBS}
\alias{getFractionOfGenomeAltered,CBS-method}

\alias{CBS.getFGL}
\alias{getFGL.CBS}
\alias{getFGL,CBS-method}

\alias{CBS.getFGG}
\alias{getFGG.CBS}
\alias{getFGG,CBS-method}

\alias{CBS.getFGA}
\alias{getFGA.CBS}
\alias{getFGA,CBS-method}


\title{Calculates the fraction of the genome lost, gained, or aberrant either way}

\description{
 Calculates the fraction of the genome lost, gained, or aberrant either way (in sense of total copy numbers),
 using definitions closely related to those presented in [1].
}

\usage{
\method{getFractionOfGenomeLost}{CBS}(fit, ...)
}

\arguments{
 \item{...}{Not used.}
}

\value{
 Returns a \code{\link[base]{double}} in [0,1].
}

\author{Henrik Bengtsson}

\references{
  [1] Fridlyand et al. \emph{Breast tumor copy number aberration
      phenotypes and genomic instability}, BMC Cancer, 2006. \cr
}

\seealso{
  Internally, \code{\link[PSCBS:getCallStatistics.CBS]{*getCallStatistics}()} is used.
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  999.NonDocumentedObjects.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{Non-documented objects}
\alias{Non-documented objects}
\title{Non-documented objects}


% Other missing docs
\alias{extractWIG}
\alias{extractWIG.AbstractCBS}
\alias{extractWIG.CBS}
\alias{extractWIG.PSCBS}
\alias{all.equal.AbstractCBS}
\alias{all.equal.CBS}
\alias{applyByRegion}
\alias{applyByRegion.PairedPSCBS}
\alias{arrowsC1C2}
\alias{arrowsC1C2.PairedPSCBS}
\alias{arrowsDeltaC1C2}
\alias{arrowsDeltaC1C2.PairedPSCBS}
\alias{as.CBS}
\alias{as.DNAcopy}
\alias{as.character.CBS}
\alias{as.data.frame.PSCBS}
\alias{bootstrapCIs}
\alias{bootstrapCIs.PairedPSCBS}
\alias{bootstrapDHByRegion}
\alias{bootstrapDHByRegion.PairedPSCBS}
\alias{bootstrapTCNandDHByRegion}
\alias{callAB}
\alias{callABandHighAI}
\alias{callABandHighAI.PairedPSCBS}
\alias{callABandLowC1}
\alias{callABandLowC1.PairedPSCBS}
\alias{callAllelicBalance}
\alias{callAllelicBalance.default}
\alias{callAllelicBalanceByDH}
\alias{callAmplifications}
\alias{callArms}
\alias{callArms.CBS}
\alias{callExtremeAllelicImbalanceByDH}
\alias{callExtremeAllelicImbalanceByDH.PairedPSCBS}
\alias{callGainsAndLosses}
\alias{callLOH}
\alias{callLowC1ByC1}
\alias{callLowC1ByC1.PairedPSCBS}
\alias{callOutliers}
\alias{drawCentromeres}
\alias{drawCentromeres.CBS}
\alias{drawChromosomes}
\alias{drawChromosomes.CBS}
\alias{drawConfidenceBands}
\alias{drawConfidenceBands.PairedPSCBS}
\alias{drawLevels}
\alias{drawLevels.CBS}
\alias{drawLevels.DNAcopy}
\alias{drawLevels.PairedPSCBS}
\alias{dropChangePoint}
\alias{dropRegion}
\alias{dropRegions}
\alias{estimateDeltaAB}
\alias{estimateDeltaABBySmallDH}
\alias{estimateDeltaLOH}
\alias{estimateDeltaLOHByMinC1ForNonAB}
\alias{estimateHighDHQuantileAtAB}
\alias{estimateHighDHQuantileAtAB.PairedPSCBS}
\alias{estimateKappa}
\alias{estimateKappaByC1Density}
\alias{estimateMeanForDH}
\alias{estimateMeanForDH.PairedPSCBS}
\alias{estimateStandardDeviation}
\alias{estimateStandardDeviation.DNAcopy}
\alias{estimateStdDevForHeterozygousBAF}
\alias{estimateStdDevForHeterozygousBAF.PairedPSCBS}
\alias{extractC1C2}
\alias{extractCallsByLocus}
\alias{extractCallsByLocus.PairedPSCBS}
\alias{extractCallsByLocus.CBS}
\alias{extractChromosome}
\alias{extractChromosome.AbstractCBS}
\alias{extractChromosomes}
\alias{extractChromosomes.AbstractCBS}
\alias{extractChromosomes.CBS}
\alias{extractChromosomes.PSCBS}
\alias{extractDeltaC1C2}
\alias{extractDeltaC1C2.PairedPSCBS}
\alias{extractLocusLevelC1C2}
\alias{extractLocusLevelC1C2.PairedPSCBS}
\alias{extractLocusLevelTCN}
\alias{extractLocusLevelTCN.PairedPSCBS}
\alias{extractMinorMajorCNs}
\alias{extractRegion}
\alias{extractRegion.AbstractCBS}
\alias{extractRegions}
\alias{extractRegions.AbstractCBS}
\alias{extractSegmentMeansByLocus}
\alias{extractSegmentMeansByLocus.DNAcopy}
\alias{extractTCNAndDHs}
\alias{getCallStatistics}
\alias{getCallStatisticsByArms}
\alias{getCallStatisticsByArms.CBS}
\alias{getChromosomeOffsets}
\alias{getChromosomeRanges}
\alias{getChromosomeRanges.CBS}
\alias{getChromosomes}
\alias{getChromosomes.DNAcopy}
\alias{getFGA}
\alias{getFGG}
\alias{getFGL}
\alias{getFractionOfGenomeAltered}
\alias{getFractionOfGenomeGained}
\alias{getFractionOfGenomeLost}
\alias{getLocusData}
\alias{getLocusData.CBS}
\alias{getLocusData.PSCBS}
\alias{getSampleName}
\alias{getSampleNames}
\alias{getSampleNames.DNAcopy}
\alias{getSegments}
\alias{getSegments.CBS}
\alias{getSignalType}
\alias{getSignalType.CBS}
\alias{highlightArmCalls}
\alias{highlightArmCalls.CBS}
\alias{highlightCalls}
\alias{highlightCalls.CBS}
\alias{highlightLocusCalls}
\alias{highlightLocusCalls.CBS}
\alias{isWholeChromosomeGained}
\alias{isWholeChromosomeGained.CBS}
\alias{isWholeChromosomeLost}
\alias{isWholeChromosomeLost.CBS}
\alias{joinSegments}
\alias{linesC1C2}
\alias{linesC1C2.PairedPSCBS}
\alias{linesDeltaC1C2}
\alias{linesDeltaC1C2.PairedPSCBS}
\alias{mergeNonCalledSegments}
\alias{mergeTwoSegments}
\alias{mergeTwoSegments.CBS}
\alias{nbrOfAmplifications}
\alias{nbrOfAmplifications.CBS}
\alias{nbrOfChangePoints}
\alias{nbrOfChromosomes}
\alias{nbrOfGains}
\alias{nbrOfGains.CBS}
\alias{nbrOfLoci}
\alias{nbrOfLoci.DNAcopy}
\alias{nbrOfLosses}
\alias{nbrOfLosses.CBS}
\alias{nbrOfSamples}
\alias{nbrOfSamples.DNAcopy}
\alias{nbrOfSegments}
\alias{nbrOfSegments.DNAcopy}
\alias{plot.CBS}
\alias{plot.PairedPSCBS}
\alias{plotC1C2}
\alias{plotC1C2.PairedPSCBS}
\alias{plotDeltaC1C2}
\alias{plotDeltaC1C2.PairedPSCBS}
\alias{plotTracksManyChromosomes.CBS}
\alias{pointsC1C2}
\alias{pointsC1C2.PairedPSCBS}
\alias{pointsDeltaC1C2}
\alias{pointsDeltaC1C2.PairedPSCBS}
\alias{postsegmentTCN}
\alias{postsegmentTCN.PairedPSCBS}
\alias{print.AbstractCBS}
\alias{sampleName}
\alias{sampleName<-}
\alias{setLocusData}
\alias{setSampleName}
\alias{setSegments}
\alias{signalType}
\alias{signalType.CBS}
\alias{signalType<-}
\alias{signalType<-.CBS}
\alias{subset.CBS}
\alias{tileChromosomes}
\alias{tileChromosomes.AbstractCBS}
\alias{tileChromosomes.CBS}
\alias{tileChromosomes.PairedPSCBS}
\alias{writeLocusData}
\alias{writeLocusData.CBS}
\alias{writeSegments}
\alias{extractSegments.AbstractCBS}
\alias{extractSegment.AbstractCBS}
\alias{extractSegment}
\alias{extractSegments}
\alias{extractSegments.CBS}
\alias{extractSegments.PairedPSCBS}
\alias{isSegmentSplitter}
\alias{isSegmentSplitter.CBS}
\alias{isSegmentSplitter.PSCBS}
\alias{extractCNs}
\alias{extractCNs.AbstractCBS}
\alias{extractCNs.CBS}
\alias{extractCNs.PairedPSCBS}
\alias{extractTotalCNs}
\alias{extractTotalCNs.CBS}
\alias{getSegmentSizes}
\alias{getSegmentSizes.AbstractCBS}
\alias{getSegmentSizes.CBS}
\alias{getSegmentSizes.PSCBS}
\alias{sampleCNs}
\alias{sampleCNs.AbstractCBS}
\alias{mergeThreeSegments}
\alias{callROH}
\alias{callROHOneSegment}
\alias{callROHOneSegment.PairedPSCBS}
\alias{testROH}
\alias{pruneBySdUndo}
\alias{updateBoundaries}
\alias{updateBoundaries.CBS}
\alias{resegment}
\alias{resegment.AbstractCBS}
\alias{resegment.CBS}
\alias{resegment.PairedPSCBS}
\alias{hclustCNs}
\alias{pruneByHClust}
\alias{updateMeansTogether}
\alias{updateMeans}
\alias{drawChangePoints}
\alias{drawChangePoints.AbstractCBS}
\alias{drawKnownSegments}
\alias{drawKnownSegments.AbstractCBS}
\alias{drawChangePoints.CBS}
\alias{drawChangePoints.PSCBS}
\alias{drawChangePointsC1C2}
\alias{drawChangePointsC1C2.PairedPSCBS}
\alias{extractDhSegment}
\alias{extractDhSegment.PairedPSCBS}
\alias{callNTCN}
\alias{callCopyNeutral}
\alias{callCopyNeutralByTCNofAB}
\alias{dropChangePoints}
\alias{calcStatsForCopyNeutralABs}
\alias{calcStatsForCopyNeutralABs.PairedPSCBS}
\alias{callGainNeutralLoss}
\alias{callGNL}
\alias{renameChromosomes}
\alias{renameChromosomes.AbstractCBS}
\alias{report}
\alias{writeSegments.DNAcopy}
\alias{shiftTCN}
\alias{shiftTCN.AbstractCBS}
\alias{shiftTCN.CBS}
\alias{shiftTCN.PairedPSCBS}
\alias{getChromosomeOffsets.AbstractCBS}
\alias{getChromosomeRanges.PairedPSCBS}
\alias{getChromosomeRanges.AbstractCBS}
\alias{seqOfSegmentsByDP}
\alias{seqOfSegmentsByDP.AbstractCBS}
\alias{seqOfSegmentsByDP.CBS}
\alias{seqOfSegmentsByDP.PairedPSCBS}
\alias{seqOfSegmentsByDP.matrix}
\alias{getChromosomeOffsets.PairedPSCBS}
\alias{getLocusSignalNames}
\alias{getLocusSignalNames.AbstractCBS}
\alias{getLocusSignalNames.CBS}
\alias{getLocusSignalNames.PSCBS}
\alias{getSegmentTrackPrefixes}
\alias{getSegmentTrackPrefixes.AbstractCBS}
\alias{getSegmentTrackPrefixes.CBS}
\alias{getSegmentTrackPrefixes.PSCBS}
\alias{pruneByDP}
\alias{getMeanEstimators}
\alias{getMeanEstimators.AbstractCBS}
\alias{resegment.NonPairedPSCBS}
\alias{setMeanEstimators}
\alias{setMeanEstimators.AbstractCBS}
\alias{resetSegments}
\alias{getLocusData.NonPairedPSCBS}
\alias{getLocusData.PairedPSCBS}
\alias{plotTracks}
\alias{plotTracks1}
\alias{plotTracks2}
\alias{plotTracksManyChromosomes}
\alias{getSmoothLocusData}
\alias{bootstrapSegmentsAndChangepoints}
\alias{bootstrapSegmentsAndChangepoints.PairedPSCBS}
\alias{getChangePoints}
\alias{getChangePoints.AbstractCBS}
\alias{getChangePoints.CBS}
\alias{getChangePoints.PSCBS}
\alias{clearBootstrapSummaries}
\alias{clearBootstrapSummaries.PairedPSCBS}
\alias{findBootstrapSummaries}
\alias{findBootstrapSummaries.PairedPSCBS}
\alias{hasBootstrapSummaries}
\alias{hasBootstrapSummaries.PairedPSCBS}
\alias{clearCalls}
\alias{clearCalls.AbstractCBS}
\alias{extractSegmentDataByLocus}
\alias{extractSegmentDataByLocus.PairedPSCBS}
\alias{updateMeansC1C2}
\alias{updateMeansC1C2.PairedPSCBS}
\alias{encodeCalls}
\alias{encodeCalls.data.frame}
\alias{callGLAO}
\alias{callGLAO.CBS}
\alias{unTumorBoost}
\alias{unTumorBoost.PairedPSCBS}
\alias{isLocallyPhased}
\alias{isLocallyPhased.PSCBS}

\description{
  This page contains aliases for all "non-documented" objects that
  \code{R CMD check} detects in this package.

  Almost all of them are \emph{generic} functions that have specific
  document for the corresponding method coupled to a specific class.
  Other functions are re-defined by \code{setMethodS3()} to
  \emph{default} methods. Neither of these two classes are non-documented
  in reality.
  The rest are deprecated methods.
}

\author{Henrik Bengtsson}


\keyword{documentation}
\keyword{internal}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.callLOH.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{callLOH.PairedPSCBS}
\alias{callLOH.PairedPSCBS}
\alias{PairedPSCBS.callLOH}
\alias{callLOH,PairedPSCBS-method}

\title{Calls segments that are in LOH}

\description{
 Calls segments that are in LOH, i.e. that have "zero" minor copy number.
}

\usage{
\method{callLOH}{PairedPSCBS}(fit, flavor=c("SmallC1", "LargeDH"), ..., minSize=1, xorCalls=TRUE, force=FALSE)
}

\arguments{
  \item{flavor}{A \code{\link[base]{character}} string specifying which type of
   call to use.}
  \item{...}{Additional arguments passed to the caller.}
  \item{minSize}{An optional \code{\link[base]{integer}} specifying the minimum number
   of data points in order to call a segments.  If fewer data points,
   then the call is set to \code{\link[base]{NA}} regardless.}
  \item{xorCalls}{If \code{\link[base:logical]{TRUE}}, a region already called AB, will
   for consistency never be called LOH, resulting in either an LOH
   call set to \code{\link[base:logical]{FALSE}} or \code{\link[base]{NA}} (as explained below).}
  \item{force}{If \code{\link[base:logical]{FALSE}}, and allelic-balance calls already exits,
   then nothing is done, otherwise the calls are done.}
}

\value{
  Returns a \code{\link{PairedPSCBS}} object with LOH calls.
}

\section{AB and LOH consistency}{
  Biologically, a segment can not be both in allelic balance (AB) and
  in loss-of-heterozygosity (LOH) at the same time.
  To avoid reporting such inconsistencies, the LOH caller will,
  if argument \code{xorCalls=TRUE}, never report a segment to be in
  LOH if it is already called to be in AB.
  However, regardless of of the AB call, a segment is still always
  tested for LOH, to check weather the LOH caller is consistent with the
  AB caller or not.  Thus, in order to distinguish the case where
  the AB caller and LOH caller agree from when they disagree,
  we report either (AB,LOH)=(TRUE,FALSE) or (TRUE,NA).  The former is
  reported when they are consistent, and the latter when they are not,
  or when the LOH caller could not call it.
}

\author{Henrik Bengtsson}

\seealso{
  Internally, one of the following methods are used:
  \code{\link[PSCBS:callLowC1ByC1.PairedPSCBS]{*callLowC1ByC1}()},
  \code{\link[PSCBS:callExtremeAllelicImbalanceByDH.PairedPSCBS]{*callExtremeAllelicImbalanceByDH}()}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  NonPairedPSCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{NonPairedPSCBS}
\docType{class}
\alias{NonPairedPSCBS}


\title{The NonPairedPSCBS class}

\description{
 Package:  PSCBS \cr
\bold{Class NonPairedPSCBS}\cr

\code{list}\cr
\code{~~|}\cr
\code{~~+--}\code{\link[PSCBS]{AbstractCBS}}\cr
\code{~~~~~~~|}\cr
\code{~~~~~~~+--}\code{\link[PSCBS]{PSCBS}}\cr
\code{~~~~~~~~~~~~|}\cr
\code{~~~~~~~~~~~~+--}\emph{\code{NonPairedPSCBS}}\cr

\bold{Directly known subclasses:}\cr
\cr

public abstract class \bold{NonPairedPSCBS}\cr
extends \emph{\link[PSCBS]{PSCBS}}\cr



 A NonPairedPSCBS is an object containing the results from the
 Non-paired PSCBS method.
}

\usage{NonPairedPSCBS(fit=list(), ...)}

\arguments{
  \item{fit}{A \code{\link[base]{list}} structure containing the Non-paired PSCBS results.}
  \item{...}{Not used.}
}

\section{Fields and Methods}{
 \bold{Methods:}\cr
\emph{No methods defined}.


 \bold{Methods inherited from PSCBS}:\cr
as.data.frame, c, drawChangePoints, extractChromosomes, extractWIG, getLocusData, getLocusSignalNames, getSegmentTrackPrefixes, isLocallyPhased, isSegmentSplitter, normalizeTotalCNs, writeSegments

 \bold{Methods inherited from AbstractCBS}:\cr
adjustPloidyScale, all.equal, as.data.frame, clearCalls, drawChangePoints, drawKnownSegments, dropChangePoint, dropChangePoints, dropRegion, dropRegions, extractCNs, extractChromosome, extractChromosomes, extractRegions, extractSegments, extractWIG, getChangePoints, getChromosomeOffsets, getChromosomeRanges, getChromosomes, getLocusData, getLocusSignalNames, getMeanEstimators, getSampleName, getSegmentSizes, getSegmentTrackPrefixes, getSegments, mergeThreeSegments, mergeTwoSegments, nbrOfChangePoints, nbrOfChromosomes, nbrOfLoci, nbrOfSegments, normalizeTotalCNs, ploidy, ploidy<-, plotTracks, print, pruneByDP, pruneByHClust, renameChromosomes, report, resegment, resetSegments, sampleCNs, sampleName, sampleName<-, seqOfSegmentsByDP, setLocusData, setMeanEstimators, setPloidy, setSampleName, setSegments, shiftTCN, tileChromosomes, updateMeans, writeWIG

 \bold{Methods inherited from list}:\cr
Ops,nonStructure,vector-method, Ops,structure,vector-method, Ops,vector,nonStructure-method, Ops,vector,structure-method, all.equal, as.data.frame, attachLocally, averageQuantile, callHooks, coerce,ANY,list-method, normalizeAverage, normalizeDifferencesToAverage, normalizeQuantileRank, normalizeQuantileSpline, plotDensity, relist, reset, type.convert, within


}

\author{Henrik Bengtsson}

\seealso{
  The \code{\link{segmentByNonPairedPSCBS}}() method returns an object of this class.
}
\keyword{classes}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.EXTS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{extractSegmentMeansByLocus.CBS}
\alias{extractSegmentMeansByLocus.CBS}
\alias{CBS.extractSegmentMeansByLocus}
\alias{extractSegmentMeansByLocus,CBS-method}

\title{Extracts segments means at each locus}

\description{
 Extracts segments means at each locus.
}

\usage{
\method{extractSegmentMeansByLocus}{CBS}(fit, ...)
}

\arguments{
 \item{...}{Arguments passed to \code{\link[PSCBS:getLocusData.CBS]{*getLocusData}()}.}
}

\value{
 Returns a \code{\link[base]{numeric}} \code{\link[base]{vector}} of length \code{nbrOfLoci()}.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.PLOT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{plotTracks1.PairedPSCBS}
\alias{plotTracks1.PairedPSCBS}
\alias{PairedPSCBS.plotTracks1}
\alias{plotTracks1,PairedPSCBS-method}
\alias{PairedPSCBS.plotTracks}
\alias{plotTracks.PairedPSCBS}
\alias{plotTracks,PairedPSCBS-method}

\alias{PairedPSCBS.plotTracks2}
\alias{plotTracks2.PairedPSCBS}
\alias{plotTracks2,PairedPSCBS-method}

\alias{PairedPSCBS.plotTracksManyChromosomes}
\alias{plotTracksManyChromosomes.PairedPSCBS}
\alias{plotTracksManyChromosomes,PairedPSCBS-method}

\alias{plot}

\title{Plots parental specific copy numbers along the genome}

\description{
 Plots parental specific copy numbers along the genome for one or more chromosomes.
 It is possible to specify what type of tracks to plot.
 Each type of track is plotted in its own panel.
}

\usage{
\method{plotTracks1}{PairedPSCBS}(x, tracks=c("tcn", "dh", "tcn,c1,c2", "tcn,c1", "tcn,c2", "c1,c2", "betaN",
  "betaT", "betaTN")[1:3], scatter="*", calls=".*", pch=".", col=NULL, cex=1,
  changepoints=FALSE, grid=FALSE, quantiles=c(0.05, 0.95), xlim=NULL,
  Clim=c(0, 3 * ploidy(x)), Blim=c(0, 1), xScale=1e-06, ..., add=FALSE,
  subplots=!add && (length(tracks) > 1), verbose=FALSE)
}

\arguments{
  \item{x}{A result object returned by \code{\link{segmentByPairedPSCBS}}().}
  \item{tracks}{A \code{\link[base]{character}} \code{\link[base]{vector}} specifying what types of tracks to plot.}
  \item{scatter}{A \code{\link[base]{character}} \code{\link[base]{vector}} specifying which of the tracks should
    have scatter plot.}
  \item{calls}{A \code{\link[base]{character}} \code{\link[base]{vector}} of regular expression identifying
    call labels to be highlighted in the panels.}
  \item{pch}{The type of the scatter points, if any.}
  \item{col}{The color of the scatter points, if any.}
  \item{cex}{The size of the scatter points, if any.}
  \item{changepoints}{If \code{\link[base:logical]{TRUE}}, changepoints are drawn as vertical lines.}
  \item{grid}{If \code{\link[base:logical]{TRUE}}, horizontal lines are displayed.}
  \item{quantiles}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} in [0,1] specifying the quantiles
     of the confidence bands to be drawn, if any.}
  \item{xlim}{(Optional) The genomic range to plot.}
  \item{Clim}{The range of copy numbers.}
  \item{Blim}{The range of allele B fractions (BAFs) and
    decrease of heterozygosity (DHs).}
  \item{xScale}{The scale factor used for genomic positions.}
  \item{...}{Not used.}
  \item{add}{If \code{\link[base:logical]{TRUE}}, the panels plotted are added to the existing plot,
    otherwise a new plot is created.}
  \item{subplots}{If \code{\link[base:logical]{TRUE}}, then subplots are automatically setup.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns nothing.
}

\author{Henrik Bengtsson}



\keyword{internal}
\keyword{methods}
\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.PRUNE.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{pruneBySdUndo.CBS}
\alias{pruneBySdUndo.CBS}
\alias{CBS.pruneBySdUndo}
\alias{pruneBySdUndo,CBS-method}

\title{Prune the CBS profile by dropping change points that are too small}

\description{
 Prune the CBS profile by dropping change points that are too small, where "too small" means that the amplitude of the
 change points is less than a multiple of the overall standard deviation
 of the copy-number signals.
}

\usage{
\method{pruneBySdUndo}{CBS}(fit, rho=3, sigma="DNAcopy", ..., verbose=FALSE)
}

\arguments{
  \item{fit}{A \code{\link{CBS}} object.}
  \item{rho}{A positive \code{\link[base]{double}} scalar specifying the number of standard
    deviations (\code{rho*sigma}) required in order to keep a change point.
    More change points are dropped the greater this value is.}
  \item{sigma}{The whole-genome standard deviation of the locus-level
    copy number signals.  The default is to calculate it from the data
    and as done in the \pkg{DNAcopy} package.}
  \item{...}{(Optional) Additional arguments passed to the standard
    deviation estimator function.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns a \code{\link{CBS}} object (of the same class as \code{fit}).
}

\details{
 This method corresponds to using the \code{undo} argument when calling
 \code{\link{segmentByCBS}}(), which in turn corresponds to using the
 \code{undo.splits="sdundo"} and \code{undo.SD} of the underlying
 \code{\link[DNAcopy]{segment}} method.
}

\examples{

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Simulating copy-number data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
set.seed(0xBEEF)

# Number of loci
J <- 1000

mu <- double(J)
mu[1:100] <- mu[1:100] + 0.3
mu[200:300] <- mu[200:300] + 1
mu[350:400] <- NA # centromere
mu[650:800] <- mu[650:800] - 1
eps <- rnorm(J, sd=1/2)
y <- mu + eps
x <- sort(runif(length(y), max=length(y))) * 1e5
w <- runif(J)
w[650:800] <- 0.001


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fit <- segmentByCBS(y, x=x)
print(fit)
plotTracks(fit)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Post-segmentation pruning
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fitP <- pruneBySdUndo(fit, rho=1)
drawLevels(fitP, col="red")
}

\author{Henrik Bengtsson, Pierre Neuvial}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{AbstractCBS}
\docType{class}
\alias{AbstractCBS}


\title{The AbstractCBS class}

\description{
 Package:  PSCBS \cr
\bold{Class AbstractCBS}\cr

\code{list}\cr
\code{~~|}\cr
\code{~~+--}\emph{\code{AbstractCBS}}\cr

\bold{Directly known subclasses:}\cr
\emph{\link[PSCBS]{CBS}}, \emph{\link[PSCBS]{NonPairedPSCBS}}, \emph{\link[PSCBS]{PSCBS}}, \emph{\link[PSCBS]{PairedPSCBS}}\cr

public abstract class \bold{AbstractCBS}\cr
extends list\cr



 All CBS-style segmentation results extend this class, e.g.
 \code{\link{CBS}} and \code{\link{PairedPSCBS}}.
}

\usage{
AbstractCBS(fit=list(), sampleName=fit$sampleName, ...)
}

\arguments{
  \item{fit}{A \code{\link[base]{list}} structure containing the segmentation results.}
  \item{sampleName}{A \code{\link[base]{character}} string.}
  \item{...}{Not used.}
}

\section{Fields and Methods}{
 \bold{Methods:}\cr
\tabular{rll}{
 \tab \code{adjustPloidyScale} \tab  -\cr
 \tab \code{extractCNs} \tab  -\cr
 \tab \code{getChangePoints} \tab  -\cr
 \tab \code{\link[PSCBS:getChromosomes.AbstractCBS]{getChromosomes}} \tab Gets the set of chromosomes.\cr
 \tab \code{\link[PSCBS:getLocusData.AbstractCBS]{getLocusData}} \tab Gets the locus-level data.\cr
 \tab \code{getSegmentSizes} \tab  -\cr
 \tab \code{\link[PSCBS:getSegments.AbstractCBS]{getSegments}} \tab Gets the segments.\cr
 \tab \code{\link[PSCBS:mergeThreeSegments.AbstractCBS]{mergeThreeSegments}} \tab Merge a segment and its two flanking segments.\cr
 \tab \code{\link[PSCBS:nbrOfChangePoints.AbstractCBS]{nbrOfChangePoints}} \tab Gets the number of change points.\cr
 \tab \code{\link[PSCBS:nbrOfChromosomes.AbstractCBS]{nbrOfChromosomes}} \tab Gets the number of chromosomes.\cr
 \tab \code{\link[PSCBS:nbrOfLoci.AbstractCBS]{nbrOfLoci}} \tab Gets the number of loci.\cr
 \tab \code{\link[PSCBS:nbrOfSegments.AbstractCBS]{nbrOfSegments}} \tab Gets the number of segments.\cr
 \tab \code{\link[PSCBS:normalizeTotalCNs.AbstractCBS]{normalizeTotalCNs}} \tab Normalizes copy numbers such that the whole-genome average total copy number is two.\cr
 \tab \code{\link[PSCBS:ploidy.AbstractCBS]{ploidy}} \tab Gets and sets ploidy.\cr
 \tab \code{ploidy<-} \tab  -\cr
 \tab \code{\link[PSCBS:plotTracks.AbstractCBS]{plotTracks}} \tab Plots the segmentation result along the genome.\cr
 \tab \code{sampleCNs} \tab  -\cr
 \tab \code{writeWIG} \tab  -\cr
}


 \bold{Methods inherited from list}:\cr
Ops,nonStructure,vector-method, Ops,structure,vector-method, Ops,vector,nonStructure-method, Ops,vector,structure-method, all.equal, as.data.frame, attachLocally, averageQuantile, callHooks, coerce,ANY,list-method, normalizeAverage, normalizeDifferencesToAverage, normalizeQuantileRank, normalizeQuantileSpline, plotDensity, relist, reset, type.convert, within


}

\author{Henrik Bengtsson}


\keyword{classes}
\keyword{internal}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{ploidy.AbstractCBS}
\alias{ploidy.AbstractCBS}
\alias{AbstractCBS.ploidy}
\alias{ploidy,AbstractCBS-method}
\alias{AbstractCBS.ploidy<-}
\alias{ploidy<-.AbstractCBS}
\alias{ploidy<-,AbstractCBS-method}

\alias{AbstractCBS.setPloidy}
\alias{setPloidy.AbstractCBS}
\alias{setPloidy,AbstractCBS-method}

\alias{AbstractCBS.adjustPloidyScale}
\alias{adjustPloidyScale.AbstractCBS}
\alias{adjustPloidyScale,AbstractCBS-method}

\alias{adjustPloidyScale.PairedPSCBS}
\alias{adjustPloidyScale}
\alias{ploidy}
\alias{ploidy<-}
\alias{setPloidy}

\title{Gets and sets ploidy}

\description{
 Gets and sets ploidy.
}

\usage{
  \method{ploidy}{AbstractCBS}(fit, ...)
  \method{ploidy}{AbstractCBS}(fit) <- value
}

\arguments{
  \item{fit}{An \code{\link{AbstractCBS}} object.}
  \item{value}{An \code{\link[base]{integer}} (in \eqn{1,2,\ldots}) specifying the genome ploidy .}
  \item{...}{Not used.}
}

\value{
  Returns (invisibly) an updated object.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}..
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.BOOT.sets.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{getBootstrapLocusSets.PairedPSCBS}
\alias{getBootstrapLocusSets.PairedPSCBS}
\alias{PairedPSCBS.getBootstrapLocusSets}
\alias{getBootstrapLocusSets,PairedPSCBS-method}
\alias{getBootstrapLocusSets}

\title{Generates original and bootstrapped segment-specific index sets}

\description{
 Generates original and bootstrapped segment-specific index sets, which can be used to calculate various bootstrap summaries,
 e.g. segment mean levels.
}

\usage{
\method{getBootstrapLocusSets}{PairedPSCBS}(fit, B=1000L, by=c("betaTN", "betaT"), seed=NULL, verbose=FALSE,
  .validate=FALSE, ...)
}

\arguments{
  \item{B}{A non-negative \code{\link[base]{integer}} specifying the number of bootstrap samples.}
  \item{by}{Should \code{betaTN} or \code{betaT} be used?}
  \item{seed}{An (optional) \code{\link[base]{integer}} specifying the random seed to be
    set before sampling indices.  The random seed is set to its original
    state when exiting.  If \code{\link[base]{NULL}}, it is not set.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
  \item{.validate}{If \code{\link[base:logical]{TRUE}}, additional sanity checks are performed
    to validate the correctness.  This is only needed for troubleshooting
    if it is suspected there is a bug.}
  \item{...}{Not used.}
}

\value{
  Returns a \code{\link[base]{list}}.
}

\author{Henrik Bengtsson}

\seealso{
  This is used internally by various bootstrap methods.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getSegments.AbstractCBS}
\alias{getSegments.AbstractCBS}
\alias{AbstractCBS.getSegments}
\alias{getSegments,AbstractCBS-method}
\alias{AbstractCBS.setSegments}
\alias{setSegments.AbstractCBS}
\alias{setSegments,AbstractCBS-method}

\alias{setSegments.AbstractCBS}

\title{Gets the segments}

\description{
  Gets the segments.
}

\usage{
\method{getSegments}{AbstractCBS}(...)
}

\arguments{
 \item{...}{Not used.}
}

\value{
  Returns a SxK \code{\link[base]{data.frame}}, where S in the number of segments,
  and K is the number of segment-specific fields.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getChromosomes.AbstractCBS}
\alias{getChromosomes.AbstractCBS}
\alias{AbstractCBS.getChromosomes}
\alias{getChromosomes,AbstractCBS-method}

\title{Gets the set of chromosomes}

\description{
  Gets the set of chromosomes in the segmentation result.
}

\usage{
\method{getChromosomes}{AbstractCBS}(this, ...)
}

\arguments{
 \item{...}{Arguments passed to \code{\link[PSCBS:getSegments.AbstractCBS]{*getSegments}()}.}
}

\value{
  Returns a unique and sorted \code{\link[base]{vector}} of chromosomes segmented.
}

\author{Henrik Bengtsson}

\seealso{
  \code{\link[PSCBS:nbrOfChromosomes.AbstractCBS]{*nbrOfChromosomes}()}.
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PSCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getSegments.PSCBS}
\alias{getSegments.PSCBS}
\alias{PSCBS.getSegments}
\alias{getSegments,PSCBS-method}

\title{Gets the segments}

\description{
  Gets the segments.
}

\usage{
\method{getSegments}{PSCBS}(fit, simplify=FALSE, splitters=TRUE, addGaps=FALSE, ...)
}

\arguments{
 \item{simplify}{If \code{\link[base:logical]{TRUE}}, redundant and intermediate information is dropped.}#  \item{splitters}{If \code{\link[base:logical]{TRUE}}, "splitters" between chromosomes are
    preserved, otherwise dropped.}
 \item{...}{Not used.}
}

\value{
  Returns a SxK \code{\link[base]{data.frame}}, where S in the number of segments,
  and K is the number of segment-specific fields.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{PSCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.RESTRUCT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{append.AbstractCBS}
\alias{append.AbstractCBS}
\alias{AbstractCBS.append}
\alias{append,AbstractCBS-method}

\title{Appends one segmentation result to another}

\description{
  Appends one segmentation result to another,
  where both holds segmentation results \emph{of the same sample}.
}

\usage{
\method{append}{AbstractCBS}(x, other, addSplit=TRUE, ...)
}

\arguments{
 \item{x, other}{The two \code{\link{AbstractCBS}} objects to be combined.}
 \item{addSplit}{If \code{\link[base:logical]{TRUE}}, a "divider" is added between chromosomes.}
 \item{...}{Not used.}
}

\value{
  Returns a object of the same class as argument \code{x}.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{AbstractCBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.HCLUST.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{pruneByHClust.AbstractCBS}
\alias{pruneByHClust.AbstractCBS}
\alias{AbstractCBS.pruneByHClust}
\alias{pruneByHClust,AbstractCBS-method}

\title{Prunes the CN profile by pruning and merging through hierarchical clustering}

\description{
 Prunes the CN profile by pruning and merging through hierarchical clustering.
}

\usage{
\method{pruneByHClust}{AbstractCBS}(fit, ..., size=NULL, distMethod="euclidean", hclustMethod="ward.D",
  merge=TRUE, update=TRUE, verbose=FALSE)
}

\arguments{
 \item{...}{Arguments passed to \code{\link[stats]{cutree}},
   particularly either of thresholds \code{h} or \code{k}.}
 \item{size, distMethod, hclustMethod}{Arguments (as well as
   some of \code{...}) passed to \code{\link[PSCBS:hclustCNs.AbstractCBS]{*hclustCNs}()}.}
 \item{merge}{If \code{\link[base:logical]{TRUE}}, consecutive segments that belong to the
   same PSCN cluster will be merged into one large segment.}
 \item{update}{If \code{\link[base:logical]{TRUE}}, segment means are updated afterwards, otherwise not.}
 \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns a pruned object of the same class.
}

\examples{\dontrun{
 fitP <- pruneByHClust(fit, h=0.25)
}}

\author{Henrik Bengtsson}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.estimateDeltaAB.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{estimateDeltaAB.PairedPSCBS}
\alias{estimateDeltaAB.PairedPSCBS}
\alias{PairedPSCBS.estimateDeltaAB}
\alias{estimateDeltaAB,PairedPSCBS-method}

\title{Estimate a threshold for calling allelic balance from DH}

\description{
 Estimate a threshold for calling allelic balance from DH to be used by the \code{\link[PSCBS:callAB.PairedPSCBS]{*callAB}()} method.
}

\usage{
\method{estimateDeltaAB}{PairedPSCBS}(this, scale=NULL, flavor=c("qq(DH)", "q(DH)", "mad(hBAF)", "median(DH)"),
  ..., max=Inf, verbose=FALSE)
}

\arguments{
  \item{scale}{An optional \code{\link[base]{numeric}} scale factor.}
  \item{flavor}{A \code{\link[base]{character}} string specifying which type of
   estimator to use.}
  \item{...}{Additional arguments passed to the estimator.}
  \item{max}{(Optional) The maximum estimate allowed. If greater than
   this value, the estimate will be truncated.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns the threshold estimate as a \code{\link[base]{numeric}} scalar.
}

\author{Henrik Bengtsson}

\seealso{
  Internally, one of the following methods are used:
  \code{\link[PSCBS:estimateDeltaABBySmallDH.PairedPSCBS]{*estimateDeltaABBySmallDH}()},
  \code{\link[PSCBS:estimateStdDevForHeterozygousBAF.PairedPSCBS]{*estimateStdDevForHeterozygousBAF}()},
  \code{\link[PSCBS:estimateMeanForDH.PairedPSCBS]{*estimateMeanForDH}()}, and
  \code{\link[PSCBS:estimateHighDHQuantileAtAB.PairedPSCBS]{*estimateHighDHQuantileAtAB}()}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  exampleData.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{exampleData}
\alias{exampleData.default}
\alias{exampleData}

\title{Gets an example data set}

\description{
 Gets an example data set.
}

\usage{
\method{exampleData}{default}(name=c("paired.chr01"), ...)
}

\arguments{
  \item{name}{A \code{\link[base]{character}} string specifying the name of the data set.}
  \item{...}{Not used.}
}

\value{
  Returns \code{\link[base]{data.frame}}.
}

\author{Henrik Bengtsson}




\keyword{IO}
\keyword{data}
\keyword{internal}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.RESTRUCT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{dropRegions.AbstractCBS}
\alias{dropRegions.AbstractCBS}
\alias{AbstractCBS.dropRegions}
\alias{dropRegions,AbstractCBS-method}
\alias{AbstractCBS.dropRegion}
\alias{dropRegion.AbstractCBS}
\alias{dropRegion,AbstractCBS-method}


\title{Drops chromosomal regions (a connected set of segments)}

\description{
  Drops chromosomal regions (a connected set of segments) each of a certain size (number of segments).
  \emph{None of the statistics are recalculated}.
}

\usage{
\method{dropRegions}{AbstractCBS}(this, regions, H=1, ..., asMissing=FALSE, verbose=FALSE)
}

\arguments{
 \item{regions}{An \code{\link[base]{integer}} \code{\link[base]{vector}} of length R specifying the indices
   of the left most segment in each of the R regions to be dropped.}
 \item{H}{A non-negative \code{\link[base]{integer}} specifying the size of each region,
   i.e. the number of segments per region.}
 \item{...}{Additional arguments passed to \code{\link[PSCBS:extractRegions.AbstractCBS]{*extractRegions}()}.}
 \item{asMissing}{If \code{\link[base:logical]{TRUE}}, dropped segments are replaced by missing values,
   otherwise they are truly dropped.}
 \item{verbose}{A \code{\link[base]{logical}} or a \code{\link[R.utils]{Verbose}} object.}
}

\value{
  Returns an \code{\link{AbstractCBS}} object of the same class with (at most)
  R*H segments dropped.
  If some regions overlap (share segments), then fewer than R*H segments
  are dropped.
}

\author{Henrik Bengtsson}

\seealso{
  Internally \code{\link[PSCBS:extractRegions.AbstractCBS]{*extractRegions}()} is used.
  See also \code{\link[PSCBS:dropChangePoint.AbstractCBS]{*dropChangePoint}()} and \code{\link[PSCBS:mergeTwoSegments.AbstractCBS]{*mergeTwoSegments}()}.
  For more information see \code{\link{AbstractCBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{CBS}
\docType{class}
\alias{CBS}


\title{The CBS class}

\description{
  A CBS object holds results from the
  Circular Binary Segmentation (CBS) method
  for \emph{one} sample for one or more chromosomes.

 Package:  PSCBS \cr
\bold{Class CBS}\cr

\code{list}\cr
\code{~~|}\cr
\code{~~+--}\code{\link[PSCBS]{AbstractCBS}}\cr
\code{~~~~~~~|}\cr
\code{~~~~~~~+--}\emph{\code{CBS}}\cr

\bold{Directly known subclasses:}\cr
\cr

public abstract class \bold{CBS}\cr
extends \emph{\link[PSCBS]{AbstractCBS}}\cr


}

\usage{
CBS(...)
}

\arguments{
 \item{...}{Arguments passed to the constructor of \code{\link{AbstractCBS}}.}
}

\section{Fields and Methods}{
 \bold{Methods:}\cr
\tabular{rll}{
 \tab \code{as} \tab  -\cr
 \tab \code{\link[PSCBS:c.CBS]{c}} \tab Concatenates segmentation results.\cr
 \tab \code{\link[PSCBS:estimateStandardDeviation.CBS]{estimateStandardDeviation}} \tab Estimates the whole-genome standard deviation of the signals.\cr
 \tab \code{\link[PSCBS:plotTracks.CBS]{plotTracks}} \tab Plots copy numbers along the genome.\cr
 \tab \code{\link[PSCBS:pruneBySdUndo.CBS]{pruneBySdUndo}} \tab Prune the CBS profile by dropping change points that are too small.\cr
 \tab \code{segmentByCBS} \tab  -\cr
 \tab \code{seqOfSegmentsByDP} \tab  -\cr
 \tab \code{\link[PSCBS:writeSegments.CBS]{writeSegments}} \tab Writes the table of segments to file.\cr
}


 \bold{Methods inherited from AbstractCBS}:\cr
adjustPloidyScale, all.equal, as.data.frame, clearCalls, drawChangePoints, drawKnownSegments, dropChangePoint, dropChangePoints, dropRegion, dropRegions, extractCNs, extractChromosome, extractChromosomes, extractRegions, extractSegments, extractWIG, getChangePoints, getChromosomeOffsets, getChromosomeRanges, getChromosomes, getLocusData, getLocusSignalNames, getMeanEstimators, getSampleName, getSegmentSizes, getSegmentTrackPrefixes, getSegments, mergeThreeSegments, mergeTwoSegments, nbrOfChangePoints, nbrOfChromosomes, nbrOfLoci, nbrOfSegments, normalizeTotalCNs, ploidy, ploidy<-, plotTracks, print, pruneByDP, pruneByHClust, renameChromosomes, report, resegment, resetSegments, sampleCNs, sampleName, sampleName<-, seqOfSegmentsByDP, setLocusData, setMeanEstimators, setPloidy, setSampleName, setSegments, shiftTCN, tileChromosomes, updateMeans, writeWIG

 \bold{Methods inherited from list}:\cr
Ops,nonStructure,vector-method, Ops,structure,vector-method, Ops,vector,nonStructure-method, Ops,vector,structure-method, all.equal, as.data.frame, attachLocally, averageQuantile, callHooks, coerce,ANY,list-method, normalizeAverage, normalizeDifferencesToAverage, normalizeQuantileRank, normalizeQuantileSpline, plotDensity, relist, reset, type.convert, within


}

\section{Difference to DNAcopy object}{
  A CBS object is similar to DNAcopy objects with the major
  difference that a CBS object holds only one sample, whereas
  a DNAcopy object can hold more than one sample.
}

\section{See also}{
 The \code{\link{segmentByCBS}}() method returns an object of this class.
}

\author{Henrik Bengtsson}
\keyword{classes}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.CALL.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{callOutliers.CBS}
\alias{callOutliers.CBS}
\alias{CBS.callOutliers}
\alias{callOutliers,CBS-method}

\title{Calls outliers}

\description{
 Calls outliers.
}

\usage{
\method{callOutliers}{CBS}(fit, adjust=1, method=c("ucsf-mad"), ...)
}

\arguments{
 \item{adjust}{A positive scale factor adjusting the sensitivity of the
   caller, where a value less (greater) than 1.0 makes the caller
   less (more) sensitive.}
 \item{method}{A \code{\link[base]{character}} string specifying the calling algorithm to use.}
 \item{...}{Additional/optional arguments used to override the default
   parameters used by the caller.}
}

\value{
 Returns a \code{\link[PSCBS]{CBS}} object where \code{\link[base]{logical}} columns
 'negOutlierCall' and 'posOutlierCall' have been appended
 to the segmentation table.
}

\section{The UCSF caller}{
  If \code{method == "ucsf-mad"}, then loci are called using [1]
 "Finally, to identify single technical or biological outliers such
  as high level amplifications, the presence of the outliers within
  a segment was allowed by assigning the original observed log2ratio
  to the clones for which the observed values were more than four
  tumor-specific MAD away from the smoothed values." [1; Suppl. Mat.]
}

\author{Henrik Bengtsson}

\references{
  [1] Fridlyand et al. \emph{Breast tumor copy number aberration
      phenotypes and genomic instability}, BMC Cancer, 2006. \cr
}

\seealso{
  \code{\link[PSCBS:callGainsAndLosses.CBS]{*callGainsAndLosses}()}.
  \code{\link[PSCBS:callAmplifications.CBS]{*callAmplifications}()}.
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.PLOT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{plotTracks.CBS}
\alias{plotTracks.CBS}
\alias{CBS.plotTracks}
\alias{plotTracks,CBS-method}

\title{Plots copy numbers along the genome}

\description{
 Plots copy numbers along the genome for one or more chromosomes.
 Each type of track is plotted in its own panel.
}

\usage{
\method{plotTracks}{CBS}(x, scatter=TRUE, pch=20, col="gray", meanCol="purple", cex=1, grid=FALSE,
  Clim="auto", xScale=1e-06, Clab="auto", ..., byIndex=FALSE, mar=NULL, add=FALSE)
}

\arguments{
  \item{x}{A result object returned by \code{\link{segmentByCBS}}().}
  \item{pch}{The type of points to use.}
  \item{Clim}{The range of copy numbers.}
  \item{xScale}{The scale factor used for genomic positions.}
  \item{...}{Not used.}
  \item{add}{If \code{\link[base:logical]{TRUE}}, the panels plotted are added to the existing plot,
    otherwise a new plot is created.}
}

\value{
  Returns nothing.
}

\author{Henrik Bengtsson}



\keyword{internal}
\keyword{methods}
\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  segmentByCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{segmentByCBS}
\alias{segmentByCBS.default}
\alias{segmentByCBS}
\alias{segmentByCBS.data.frame}
\alias{segmentByCBS.CBS}
\alias{segmentByCBS.CNA}
\alias{segmentByCBS}

\title{Segment genomic signals using the CBS method}

\description{
 Segment genomic signals using the CBS method of the \pkg{DNAcopy} package.
 This is a convenient low-level wrapper for the \code{DNAcopy::segment()}
 method.  It is intended to be applied to a sample at the time.
 For more details on the Circular Binary Segmentation (CBS) method
 see [1,2].
}

\usage{
\method{segmentByCBS}{default}(y, chromosome=0L, x=NULL, index=seq_along(y), w=NULL, undo=0,
  avg=c("mean", "median"), ..., joinSegments=TRUE, knownSegments=NULL, seed=NULL,
  verbose=FALSE)
}

\arguments{
  \item{y}{A \code{\link[base]{numeric}} \code{\link[base]{vector}} of J genomic signals to be segmented.}
  \item{chromosome}{Optional \code{\link[base]{numeric}} \code{\link[base]{vector}} of length J, specifying
      the chromosome of each loci.  If a scalar, it is expanded to
      a vector of length J.}
  \item{x}{Optional \code{\link[base]{numeric}} \code{\link[base]{vector}} of J genomic locations.
           If \code{\link[base]{NULL}}, index locations \code{1:J} are used.}
  \item{index}{An optional \code{\link[base]{integer}} \code{\link[base]{vector}} of length J specifying
    the genomewide indices of the loci.}
  \item{w}{Optional \code{\link[base]{numeric}} \code{\link[base]{vector}} in [0,1] of J weights.}
  \item{undo}{A non-negative \code{\link[base]{numeric}}.  If greater than zero, then
      arguments \code{undo.splits="sdundo"} and \code{undo.SD=undo}
      are passed to \code{DNAcopy::segment()}.
      In the special case when \code{undo} is +\code{\link[base:is.finite]{Inf}}, the segmentation
      result will not contain any changepoints (in addition to what
      is specified by argument \code{knownSegments}).}
  \item{avg}{A \code{\link[base]{character}} string specifying how to calculating
        segment mean levels \emph{after} change points have been
        identified.}
  \item{...}{Additional arguments passed to the \code{DNAcopy::segment()}
      segmentation function.}
  \item{joinSegments}{If \code{\link[base:logical]{TRUE}}, there are no gaps between neighboring
    segments.
    If \code{\link[base:logical]{FALSE}}, the boundaries of a segment are defined by the support
    that the loci in the segments provides, i.e. there exist a locus
    at each end point of each segment.  This also means that there
    is a gap between any neighboring segments, unless the change point
    is in the middle of multiple loci with the same position.
    The latter is what \code{DNAcopy::segment()} returns.
  }
  \item{knownSegments}{Optional \code{\link[base]{data.frame}} specifying
    \emph{non-overlapping} known segments.  These segments must
    not share loci.  See \code{\link{findLargeGaps}}() and \code{\link{gapsToSegments}}().}
  \item{seed}{An (optional) \code{\link[base]{integer}} specifying the random seed to be
    set before calling the segmentation method.  The random seed is
    set to its original state when exiting.  If \code{\link[base]{NULL}}, it is not set.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns a \code{\link{CBS}} object.
}

\details{
  Internally \code{\link[DNAcopy]{segment}} of \pkg{DNAcopy} is used to
  segment the signals.
  This segmentation method support weighted segmentation.
}

\section{Reproducibility}{
  The \code{DNAcopy::segment()} implementation of CBS uses approximation
  through random sampling for some estimates.  Because of this,
  repeated calls using the same signals may result in slightly
  different results, unless the random seed is set/fixed.
}

\section{Missing and non-finite values}{
  Signals may contain missing values (\code{\link[base]{NA}} or \code{\link[base:is.finite]{NaN}}), but not
  infinite values (+/-\code{\link[base:is.finite]{Inf}}).  Loci with missing-value signals
  are preserved and keep in the result.

  Likewise, genomic positions may contain missing values.
  However, if they do, such loci are silently excluded before
  performing the segmentation, and are not kept in the results.
  The mapping between the input locus-level data and ditto of
  the result can be inferred from the \code{index} column of
  the locus-level data of the result.

  None of the input data may have infinite values,
  i.e. -\code{\link[base:is.finite]{Inf}} or +\code{\link[base:is.finite]{Inf}}. If so, an informative error is thrown.
}

\examples{
 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Simulating copy-number data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
set.seed(0xBEEF)

# Number of loci
J <- 1000

mu <- double(J)
mu[200:300] <- mu[200:300] + 1
mu[350:400] <- NA # centromere
mu[650:800] <- mu[650:800] - 1
eps <- rnorm(J, sd=1/2)
y <- mu + eps
x <- sort(runif(length(y), max=length(y))) * 1e5
w <- runif(J)
w[650:800] <- 0.001


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fit <- segmentByCBS(y, x=x)
print(fit)
plotTracks(fit)


     
xlab <- "Position (Mb)"
ylim <- c(-3,3)
xMb <- x/1e6
plot(xMb,y, pch=20, col="#aaaaaa", xlab=xlab, ylim=ylim)
drawLevels(fit, col="red", lwd=2, xScale=1e-6)

 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# TESTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fit <- segmentByCBS(y, x=x, seed=0xBEEF)
print(fit)
##   id chromosome       start      end nbrOfLoci    mean
## 1  y          0    55167.82 20774251       201  0.0164
## 2  y          0 20774250.85 29320105        99  1.0474
## 3  y          0 29320104.86 65874675       349 -0.0227
## 4  y          0 65874675.06 81348129       151 -1.0813
## 5  y          0 81348129.20 99910827       200 -0.0612


# Test #1: Reverse the ordering and segment
fitR <- segmentByCBS(rev(y), x=rev(x), seed=0xBEEF)
# Sanity check
stopifnot(all.equal(getSegments(fitR), getSegments(fit)))
# Sanity check
stopifnot(all.equal(rev(getLocusData(fitR)$index), getLocusData(fit)$index))

# Test #2: Reverse, but preserve ordering of 'data' object
fitRP <- segmentByCBS(rev(y), x=rev(x), preserveOrder=TRUE)
stopifnot(all.equal(getSegments(fitRP), getSegments(fit)))


# (Test #3: Change points inbetween data points at the same locus)
x[650:654] <- x[649]
fitC <- segmentByCBS(rev(y), x=rev(x), preserveOrder=TRUE, seed=0xBEEF)

# Test #4: Allow for some missing values in signals
y[450] <- NA
fitD <- segmentByCBS(y, x=x, seed=0xBEEF)


# Test #5: Allow for some missing genomic annotations
x[495] <- NA
fitE <- segmentByCBS(y, x=x, seed=0xBEEF)


# Test #6: Undo all change points found
fitF <- segmentByCBS(y, x=x, undo=Inf, seed=0xBEEF)
print(fitF)
stopifnot(nbrOfSegments(fitF) == 1L)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# MISC.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Emulate a centromere
x[650:699] <- NA
fit <- segmentByCBS(y, x=x, seed=0xBEEF)
xMb <- x/1e6
plot(xMb,y, pch=20, col="#aaaaaa", xlab=xlab, ylim=ylim)
drawLevels(fit, col="red", lwd=2, xScale=1e-6)

fitC <- segmentByCBS(y, x=x, joinSegments=FALSE, seed=0xBEEF)
drawLevels(fitC, col="blue", lwd=2, xScale=1e-6)



# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Multiple chromosomes
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Appending CBS results
fit1 <- segmentByCBS(y, chromosome=1, x=x)
fit2 <- segmentByCBS(y, chromosome=2, x=x)
fit <- c(fit1, fit2)
print(fit)
plotTracks(fit, subset=NULL, lwd=2, Clim=c(-3,3))


# Segmenting multiple chromosomes at once
chromosomeWG <- rep(1:2, each=J)
xWG <- rep(x, times=2)
yWG <- rep(y, times=2)
fitWG <- segmentByCBS(yWG, chromosome=chromosomeWG, x=xWG)
print(fitWG)
plotTracks(fitWG, subset=NULL, lwd=2, Clim=c(-3,3))

# Assert same results
fit$data[,"index"] <- getLocusData(fitWG)[,"index"] # Ignore 'index'
stopifnot(all.equal(getLocusData(fitWG), getLocusData(fit)))
stopifnot(all.equal(getSegments(fitWG), getSegments(fit)))

}

\author{Henrik Bengtsson}

\references{
 [1] A.B. Olshen, E.S. Venkatraman (aka Venkatraman E. Seshan), R. Lucito and M. Wigler, \emph{Circular binary segmentation for the analysis of array-based DNA copy number data}, Biostatistics, 2004
 \cr
 [2] E.S. Venkatraman and A.B. Olshen, \emph{A faster circular binary segmentation algorithm for the analysis of array CGH data}, Bioinformatics, 2007
 \cr
}

\seealso{
  To segment allele-specific tumor copy-number signals from a tumor
  \emph{with} a matched normal, see \code{\link{segmentByPairedPSCBS}}().
  For the same \emph{without} a matched normal,
  see \code{\link{segmentByNonPairedPSCBS}}().

  It is also possible to prune change points after segmentation (with
  identical results) using
  \code{\link[PSCBS:pruneBySdUndo.CBS]{pruneBySdUndo}()}.
}

\keyword{IO}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.estimateKappa.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{estimateKappa.PairedPSCBS}
\alias{estimateKappa.PairedPSCBS}
\alias{PairedPSCBS.estimateKappa}
\alias{estimateKappa,PairedPSCBS-method}

\title{Estimate global background in segmented copy numbers}

\description{
 Estimate global background in segmented copy numbers.
 The global background, here called \eqn{\kappa},
 may have multiple origins where normal contamination is one,
 but not necessarily the only one.
}

\usage{
\method{estimateKappa}{PairedPSCBS}(this, flavor=c("density(C1)"), ...)
}

\arguments{
  \item{flavor}{A \code{\link[base]{character}} string specifying which type of
   estimator to use.}
  \item{...}{Additional arguments passed to the estimator.}
}

\value{
  Returns the background estimate as a \code{\link[base]{numeric}} scalar.
}

\author{Henrik Bengtsson}

\seealso{
  Internally, one of the following methods are used:
  \code{\link[PSCBS:estimateKappaByC1Density.PairedPSCBS]{*estimateKappaByC1Density}()}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  DNAcopy.EXTS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{as.DNAcopy.CBS}
\alias{as.DNAcopy.CBS}
\alias{CBS.as.DNAcopy}
\alias{as.DNAcopy,CBS-method}

\title{Coerces a CBS object to a DNAcopy object}

\description{
 Coerces a CBS object to a DNAcopy object.
}

\usage{
\method{as.DNAcopy}{CBS}(fit, ...)
}

\arguments{
  \item{fit}{A \code{\link{CBS}} object."}
  \item{...}{Not used.}
}

\value{
  Returns a \code{\link[DNAcopy:DNAcopy]{DNAcopy}} object
  (of the \pkg{DNAcopy} package).
}

\examples{
 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Simulating copy-number data
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
set.seed(0xBEEF)

# Number of loci
J <- 1000

mu <- double(J)
mu[200:300] <- mu[200:300] + 1
mu[350:400] <- NA # centromere
mu[650:800] <- mu[650:800] - 1
eps <- rnorm(J, sd=1/2)
y <- mu + eps
x <- sort(runif(length(y), max=length(y))) * 1e5
w <- runif(J)
w[650:800] <- 0.001


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Segmentation
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
fit <- segmentByCBS(y, x=x)
print(fit)
plotTracks(fit)


 
# Coerce an CBS object to a DNAcopy object
fitD <- as.DNAcopy(fit)

# Coerce an DNAcopy object to a CBS object
fitC <- as.CBS(fitD)

# Sanity check
fitD2 <- as.DNAcopy(fit)
stopifnot(all.equal(fitD2, fitD))

fitC2 <- as.CBS(fitD2)
stopifnot(all.equal(fitC2, fitC))

}

\author{Henrik Bengtsson}

\seealso{
  \code{\link[PSCBS:as.CBS.DNAcopy]{as.CBS()}}.
  For more information see \code{\link{CBS}}.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.estimateKappa.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{estimateKappaByC1Density.PairedPSCBS}
\alias{estimateKappaByC1Density.PairedPSCBS}
\alias{PairedPSCBS.estimateKappaByC1Density}
\alias{estimateKappaByC1Density,PairedPSCBS-method}

\title{Estimate global background in segmented copy numbers}

\description{
 Estimate global background in segmented copy numbers based on the location of peaks in a weighted
 density estimator of the minor copy number mean levels.

 The global background, here called \eqn{\kappa},
 may have multiple origins where normal contamination is one,
 but not necessarily the only one.

 \emph{Assumptions:}  This estimator assumes that there are segments
 with C1=0 and C1=1, i.e. some deletions and, typically, some normal
 segements.
}

\usage{
\method{estimateKappaByC1Density}{PairedPSCBS}(this, typeOfWeights=c("dhNbrOfLoci", "sqrt(dhNbrOfLoci)"),
  adjust=1, from=0, minDensity=0.2, ..., verbose=FALSE)
}

\arguments{
  \item{typeOfWeights}{A \code{\link[base]{character}} string specifying how weights
   are calculated.}
  \item{adjust}{A \code{\link[base]{numeric}} scale factor specifying the size of
   the bandwidth parameter used by the density estimator.}
  \item{from}{A \code{\link[base]{numeric}} scalar specifying the lower bound for the
   support of the estimated density.}
  \item{minDensity}{A non-negative \code{\link[base]{numeric}} threshold specifying
   the minimum density a peak should have in order to consider
   it a peak.}
  \item{...}{Not used.}
  \item{verbose}{See \code{\link[R.utils]{Verbose}}.}
}

\value{
  Returns the background estimate as a \code{\link[base]{numeric}} scalar.
}

\section{Algorithm}{
 \itemize{
 \item Retrieve segment-level minor copy numbers and corresponding weights:
  \enumerate{
   \item Grabs the segment-level C1 estimates.
   \item Calculate segment weights.
         The default (\code{typeOfWeights="dhNbrOfLoci"}) is to use
         weights proportional to the number of heterozygous SNPs.
         An alternative (\code{typeOfWeights="sqrt(dhNbrOfLoci)"}) is
         to use the square root of those counts.
  }

 \item Identify subset of regions with C1=0:
  \enumerate{
   \item Estimates the weighted empirical density function
         (truncated at zero below).  Tuning parameter 'adjust'.
   \item Find the first two peaks
         (with a density greater than tuning parameter 'minDensity').
   \item Assumes that the two peaks corresponds to C1=0 and C1=1.
   \item Defines threshold Delta0.5 as the center location between
         these two peaks.
  }

 \item Estimate the global background signal:
  \enumerate{
   \item For all segments with C1 < Delta0.5, calculate the weighted
         median of their C1:s.
   \item Let kappa be the above weighted median.
         This is the estimated background.
  }
 }
}

\author{Henrik Bengtsson}

\seealso{
  Instead of calling this method explicitly, it is recommended
  to use the \code{\link[PSCBS:estimateKappa.PairedPSCBS]{*estimateKappa}()} method.
}


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  AbstractCBS.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{getSampleName.AbstractCBS}
\alias{getSampleName.AbstractCBS}
\alias{AbstractCBS.getSampleName}
\alias{getSampleName,AbstractCBS-method}
\alias{AbstractCBS.sampleName}
\alias{sampleName.AbstractCBS}
\alias{sampleName,AbstractCBS-method}


\title{Gets the name of the sample segmented}

\description{
 Gets the name of the sample segmented.
}

\usage{
\method{getSampleName}{AbstractCBS}(fit, ...)
}

\arguments{
  \item{...}{Not used.}
}

\value{
  Returns a \code{\link[base]{character}} string.
}

\author{Henrik Bengtsson}

\seealso{
  \code{\link[PSCBS:setSampleName.AbstractCBS]{*setSampleName}()}.
  For more information see \code{\link{AbstractCBS}}..
}
\keyword{internal}
\keyword{methods}

A.B. Olshen, H. Bengtsson, P. Neuvial, P.T. Spellman, R.A. Olshen, V.E. Seshan, \emph{Parent-specific copy number in paired tumor-normal studies using circular binary segmentation}, Bioinformatics, 2011

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PSCBS.IO.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


 \name{writeSegments.PSCBS}
\alias{writeSegments.PSCBS}
\alias{PSCBS.writeSegments}
\alias{writeSegments,PSCBS-method}

 \title{Writes the table of segments to file}

 \description{
  Writes the table of segments to file.
 }

 \usage{
\method{writeSegments}{PSCBS}(fit, name=getSampleName(fit), tags=NULL, ext="tsv", path=NULL,
  addHeader=TRUE, createdBy=NULL, sep="\t", nbrOfDecimals=4L, splitters=FALSE,
  overwrite=FALSE, skip=FALSE, ...)
}

 \arguments{
   \item{name, tags}{Name and optional tags part of the filename}.
   \item{path}{The directory where the file will be written.}
   \item{addHeader}{If \code{\link[base:logical]{TRUE}}, header comments are written.}
   \item{createdBy}{A header comment of whom created the file.}
   \item{splitters}{If \code{\link[base:logical]{TRUE}}, each chromosome is separated by a row
     of missing values.}
   \item{overwrite, skip}{If an output file already exists, these
     arguments specifies what should happen.}
   \item{...}{Additional arguments pass to \code{getSegments()}.}
 }

 \value{
   Returns the pathname of the the file written.
 }

 \author{Henrik Bengtsson}

 \seealso{
   Utilizes \code{\link[PSCBS:getSegments.PSCBS]{*getSegments}()}.
   For more information see \code{\link{PSCBS}}..
 }


\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.callCopyNeutral.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{callCopyNeutral.PairedPSCBS}
\alias{callCopyNeutral.PairedPSCBS}
\alias{PairedPSCBS.callCopyNeutral}
\alias{callCopyNeutral,PairedPSCBS-method}
\alias{PairedPSCBS.callNTCN}
\alias{callNTCN.PairedPSCBS}
\alias{callNTCN,PairedPSCBS-method}


\title{Calls segments that have a neutral total copy number}

\description{
 Calls segments that have a neutral total copy number (NTCN),
 i.e. that have a TCN that corresponds to the ploidy of the genome.
}

\usage{
\method{callCopyNeutral}{PairedPSCBS}(fit, flavor=c("TCN|AB"), ..., minSize=1, force=FALSE)
}

\arguments{
  \item{flavor}{A \code{\link[base]{character}} string specifying which type of
   call to use.}
  \item{...}{Additional arguments passed to the caller.}
  \item{minSize}{An optional \code{\link[base]{integer}} specifying the minimum number
   of data points in order to call a segments.  If fewer data points,
   then the call is set to \code{\link[base]{NA}} regardless.}
  \item{force}{If \code{\link[base:logical]{FALSE}}, and copy-neutral calls already exits,
   then nothing is done, otherwise the calls are done.}
}

\value{
  Returns a \code{\link{PairedPSCBS}} object with copy-neutral calls.
}

\author{Henrik Bengtsson}

\seealso{
  Internally, one of the following methods are used:
  \code{\link[PSCBS:callCopyNeutralByTCNofAB.PairedPSCBS]{*callCopyNeutralByTCNofAB}()}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  CBS.RESTRUCT.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{c.CBS}
\alias{c.CBS}
\alias{CBS.c}
\alias{c,CBS-method}
\alias{c.PSCBS}

\title{Concatenates segmentation results}

\description{
  Concatenates segmentation results.
}

\usage{
\method{c}{CBS}(..., addSplit=TRUE)
}

\arguments{
 \item{\dots}{One or more \code{\link{AbstractCBS}} objects to be combined.}
 \item{addSplit}{If \code{\link[base:logical]{TRUE}}, a "divider" is added between chromosomes.}
}

\value{
  Returns an \code{\link{AbstractCBS}} object of the same class in \dots.
}

\author{Henrik Bengtsson}

\seealso{
  For more information see \code{\link{CBS}}.
}
\keyword{internal}
\keyword{methods}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Do not modify this file since it was automatically generated from:
% 
%  PairedPSCBS.callAB.R
% 
% by the Rdoc compiler part of the R.oo package.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\name{callAllelicBalanceByDH.PairedPSCBS}
\alias{callAllelicBalanceByDH.PairedPSCBS}
\alias{PairedPSCBS.callAllelicBalanceByDH}
\alias{callAllelicBalanceByDH,PairedPSCBS-method}

\title{Calls segments that are in allelic balance}

\description{
 Calls segments that are in allelic balance by thresholding on DH using a predetermined threshold.
 The variability of the DH mean levels is taken into account via a
 bootstrap estimator.
}

\usage{
\method{callAllelicBalanceByDH}{PairedPSCBS}(fit, delta=estimateDeltaAB(fit, flavor = "qq(DH)"), alpha=0.05,
  ..., verbose=FALSE)
}

\arguments{
  \item{flavor}{A \code{\link[base]{character}} string specifying which type of
   call to use.}
  \item{delta}{(Tuning parameter) A non-negative \code{\link[base]{numeric}} threshold.}
  \item{alpha}{A \code{\link[base]{numeric}} in [0,1] specifying the upper and lower
    quantiles calculated by the bootstrap estimator.}
  \item{...}{Additional arguments passed to the bootstrap estimator
    \code{\link[PSCBS:bootstrapTCNandDHByRegion.PairedPSCBS]{*bootstrapTCNandDHByRegion}()}.}
}

\value{
  Returns a \code{\link{PairedPSCBS}} object with allelic-balance calls.
}

\author{Henrik Bengtsson}

\section{Algorithm}{
 \itemize{
   \item Foo
   \item Bar
 }
}

\seealso{
  Instead of calling this method explicitly, it is recommended
  to use the \code{\link[PSCBS:callAllelicBalance.PairedPSCBS]{*callAllelicBalance}()} method.
}


\keyword{internal}
\keyword{methods}
